/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(Q){for(var e=[],P=0,A=Q.length;P<A;P++)e[P]=oe[Q[P]];return e};define(oe[135],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function P(b,$,d){const h=A(b,$);if(h!==-1)return b[h]}e.$fb=P;function A(b,$,d=b.length-1){for(let h=d;h>=0;h--){const g=b[h];if($(g))return h}return-1}e.$gb=A;function s(b,$){const d=M(b,$);return d===-1?void 0:b[d]}e.$hb=s;function M(b,$,d=0,h=b.length){let g=d,w=h;for(;g<w;){const c=Math.floor((g+w)/2);$(b[c])?g=c+1:w=c}return g-1}e.$ib=M;function D(b,$){const d=S(b,$);return d===b.length?void 0:b[d]}e.$jb=D;function S(b,$,d=0,h=b.length){let g=d,w=h;for(;g<w;){const c=Math.floor((g+w)/2);$(b[c])?w=c:g=c+1}return g}e.$kb=S;function f(b,$,d=0,h=b.length){const g=S(b,$,d,h);return g===b.length?-1:g}e.$lb=f;class l{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(l.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!$(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const d=M(this.e,$,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$mb=l;function p(b,$){if(b.length===0)return;let d=b[0];for(let h=1;h<b.length;h++){const g=b[h];$(g,d)>0&&(d=g)}return d}e.$nb=p;function k(b,$){if(b.length===0)return;let d=b[0];for(let h=1;h<b.length;h++){const g=b[h];$(g,d)>=0&&(d=g)}return d}e.$ob=k;function v(b,$){return p(b,(d,h)=>-$(d,h))}e.$pb=v;function u(b,$){if(b.length===0)return-1;let d=0;for(let h=1;h<b.length;h++){const g=b[h];$(g,b[d])>0&&(d=h)}return d}e.$qb=u;function y(b,$){for(const d of b){const h=$(d);if(h!==void 0)return h}}e.$rb=y}),define(oe[136],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function P(D,S){const f=Object.create(null);for(const l of D){const p=S(l);let k=f[p];k||(k=f[p]=[]),k.push(l)}return f}e.$K=P;function A(D,S){const f=[],l=[];for(const p of D)S.has(p)||f.push(p);for(const p of S)D.has(p)||l.push(p);return{removed:f,added:l}}e.$L=A;function s(D,S){const f=[],l=[];for(const[p,k]of D)S.has(p)||f.push(k);for(const[p,k]of S)D.has(p)||l.push(k);return{removed:f,added:l}}e.$M=s;function M(D,S){const f=new Set;for(const l of S)D.has(l)&&f.add(l);return f}e.$N=M}),define(oe[137],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.$jt=e.$it=void 0;function P(S,f){const l=Math.pow(10,f);return Math.round(S*l)/l}class A{constructor(f,l,p,k=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.r===l.r&&f.g===l.g&&f.b===l.b&&f.a===l.a}}e.$it=A;class s{constructor(f,l,p,k){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,p),0),3),this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.l===l.l&&f.a===l.a}static fromRGBA(f){const l=f.r/255,p=f.g/255,k=f.b/255,v=f.a,u=Math.max(l,p,k),y=Math.min(l,p,k);let b=0,$=0;const d=(y+u)/2,h=u-y;if(h>0){switch($=Math.min(d<=.5?h/(2*d):h/(2-2*d),1),u){case l:b=(p-k)/h+(p<k?6:0);break;case p:b=(k-l)/h+2;break;case k:b=(l-p)/h+4;break}b*=60,b=Math.round(b)}return new s(b,$,d,v)}static i(f,l,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?f+(l-f)*6*p:p<1/2?l:p<2/3?f+(l-f)*(2/3-p)*6:f}static toRGBA(f){const l=f.h/360,{s:p,l:k,a:v}=f;let u,y,b;if(p===0)u=y=b=k;else{const $=k<.5?k*(1+p):k+p-k*p,d=2*k-$;u=s.i(d,$,l+1/3),y=s.i(d,$,l),b=s.i(d,$,l-1/3)}return new A(Math.round(u*255),Math.round(y*255),Math.round(b*255),v)}}e.$jt=s;class M{constructor(f,l,p,k){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,p),0),3),this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.v===l.v&&f.a===l.a}static fromRGBA(f){const l=f.r/255,p=f.g/255,k=f.b/255,v=Math.max(l,p,k),u=Math.min(l,p,k),y=v-u,b=v===0?0:y/v;let $;return y===0?$=0:v===l?$=((p-k)/y%6+6)%6:v===p?$=(k-l)/y+2:$=(l-p)/y+4,new M(Math.round($*60),b,v,f.a)}static toRGBA(f){const{h:l,s:p,v:k,a:v}=f,u=k*p,y=u*(1-Math.abs(l/60%2-1)),b=k-u;let[$,d,h]=[0,0,0];return l<60?($=u,d=y):l<120?($=y,d=u):l<180?(d=u,h=y):l<240?(d=y,h=u):l<300?($=y,h=u):l<=360&&($=u,h=y),$=Math.round(($+b)*255),d=Math.round((d+b)*255),h=Math.round((h+b)*255),new A($,d,h,v)}}e.$kt=M;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,l){return!f&&!l?!0:!f||!l?!1:f.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof A)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&A.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),l=D.k(this.rgba.g),p=D.k(this.rgba.b),k=.2126*f+.7152*l+.0722*p;return P(k,4)}static k(f){const l=f/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(f){const l=this.getRelativeLuminance(),p=f.getRelativeLuminance();return l>p?(l+.05)/(p+.05):(p+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const l=this.getRelativeLuminance(),p=f.getRelativeLuminance();return l>p}isDarkerThan(f){const l=this.getRelativeLuminance(),p=f.getRelativeLuminance();return l<p}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:l,g:p,b:k,a:v}=this.rgba;return new D(new A(l,p,k,v*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const l=f.rgba,p=this.rgba.a,k=l.a,v=p+k*(1-p);if(v<1e-6)return D.transparent;const u=this.rgba.r*p/v+l.r*k*(1-p)/v,y=this.rgba.g*p/v+l.g*k*(1-p)/v,b=this.rgba.b*p/v+l.b*k*(1-p)/v;return new D(new A(u,y,b,v))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:l,g:p,b:k,a:v}=this.rgba;return new D(new A(f.rgba.r-v*(f.rgba.r-l),f.rgba.g-v*(f.rgba.g-p),f.rgba.b-v*(f.rgba.b-k),1))}flatten(...f){const l=f.reduceRight((p,k)=>D.o(k,p));return D.o(this,l)}static o(f,l){const p=1-f.rgba.a;return new D(new A(p*l.rgba.r+f.rgba.a*f.rgba.r,p*l.rgba.g+f.rgba.a*f.rgba.g,p*l.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,l,p){if(f.isLighterThan(l))return f;p=p||.5;const k=f.getRelativeLuminance(),v=l.getRelativeLuminance();return p=p*(v-k)/v,f.lighten(p)}static getDarkerColor(f,l,p){if(f.isDarkerThan(l))return f;p=p||.5;const k=f.getRelativeLuminance(),v=l.getRelativeLuminance();return p=p*(k-v)/k,f.darken(p)}static{this.white=new D(new A(255,255,255,1))}static{this.black=new D(new A(0,0,0,1))}static{this.red=new D(new A(255,0,0,1))}static{this.blue=new D(new A(0,0,255,1))}static{this.green=new D(new A(0,255,0,1))}static{this.cyan=new D(new A(0,255,255,1))}static{this.lightgrey=new D(new A(211,211,211,1))}static{this.transparent=new D(new A(0,0,0,0))}}e.$lt=D,function(S){let f;(function(l){let p;(function(k){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}k.formatRGB=v;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}k.formatRGBA=u;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}k.formatHSL=y;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}k.formatHSLA=b;function $(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function d(t){return`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}`}k.formatHex=d;function h(t,o=!1){return o&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}${$(Math.round(t.rgba.a*255))}`}k.formatHexA=h;function g(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}k.format=g;function w(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*c(t.charCodeAt(1))+c(t.charCodeAt(2)),i=16*c(t.charCodeAt(3))+c(t.charCodeAt(4)),n=16*c(t.charCodeAt(5))+c(t.charCodeAt(6));return new S(new A(r,i,n,1))}if(o===9){const r=16*c(t.charCodeAt(1))+c(t.charCodeAt(2)),i=16*c(t.charCodeAt(3))+c(t.charCodeAt(4)),n=16*c(t.charCodeAt(5))+c(t.charCodeAt(6)),a=16*c(t.charCodeAt(7))+c(t.charCodeAt(8));return new S(new A(r,i,n,a/255))}if(o===4){const r=c(t.charCodeAt(1)),i=c(t.charCodeAt(2)),n=c(t.charCodeAt(3));return new S(new A(16*r+r,16*i+i,16*n+n))}if(o===5){const r=c(t.charCodeAt(1)),i=c(t.charCodeAt(2)),n=c(t.charCodeAt(3)),a=c(t.charCodeAt(4));return new S(new A(16*r+r,16*i+i,16*n+n,(16*a+a)/255))}return null}k.parseHex=w;function c(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=l.CSS||(l.CSS={}))})(f=S.Format||(S.Format={}))}(D||(e.$lt=D={}))}),define(oe[50],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function P(D){return(S,f,l)=>{let p=null,k=null;if(typeof l.value=="function"?(p="value",k=l.value):typeof l.get=="function"&&(p="get",k=l.get),!k)throw new Error("not supported");l[p]=D(k,f)}}function A(D,S,f){let l=null,p=null;if(typeof f.value=="function"?(l="value",p=f.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",p=f.get),!p)throw new Error("not supported");const k=`$memoize$${S}`;f[l]=function(...v){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,v)}),this[k]}}e.$wh=A;function s(D,S,f){return P((l,p)=>{const k=`$debounce$${p}`,v=`$debounce$result$${p}`;return function(...u){this[v]||(this[v]=f?f():void 0),clearTimeout(this[k]),S&&(this[v]=S(this[v],...u),u=[this[v]]),this[k]=setTimeout(()=>{l.apply(this,u),this[v]=f?f():void 0},D)}})}e.$xh=s;function M(D,S,f){return P((l,p)=>{const k=`$throttle$timer$${p}`,v=`$throttle$result$${p}`,u=`$throttle$lastRun$${p}`,y=`$throttle$pending$${p}`;return function(...b){if(this[v]||(this[v]=f?f():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),S&&(this[v]=S(this[v],...b)),this[y])return;const $=this[u]+D;$<=Date.now()?(this[u]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0):(this[y]=!0,this[k]=setTimeout(()=>{this[y]=!1,this[u]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0},$-Date.now()))}})}e.$yh=M}),define(oe[14],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?g.isErrorNoTelemetry(t)?new g(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=P,e.$X=new P;function A(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=A;function s(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function M(c){l(c)||e.$X.onUnexpectedError(c)}e.$1=M;function D(c){l(c)||e.$X.onUnexpectedExternalError(c)}e.$2=D;function S(c){if(c instanceof Error){const{name:t,message:o}=c,r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:g.isErrorNoTelemetry(c)}}return c}e.$3=S;const f="Canceled";function l(c){return c instanceof p?!0:c instanceof Error&&c.name===f&&c.message===f}e.$4=l;class p extends Error{constructor(){super(f),this.name=this.message}}e.$5=p;function k(){const c=new Error(f);return c.name=c.message,c}e.$6=k;function v(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=v;function u(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=u;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=y;function b(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=b;class $ extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=$;class d extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=d;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=h;class g extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof g)return t;const o=new g;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=g;class w extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$cb=w}),define(oe[22],ae([0,1,14,135]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(z,Y=0){return z[z.length-(1+Y)]}e.$sb=s;function M(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=M;function D(z,Y,N=(B,_)=>B===_){if(z===Y)return!0;if(!z||!Y||z.length!==Y.length)return!1;for(let B=0,_=z.length;B<_;B++)if(!N(z[B],Y[B]))return!1;return!0}e.$ub=D;function S(z,Y){const N=z.length-1;Y<N&&(z[Y]=z[N]),z.pop()}e.$vb=S;function f(z,Y,N){return l(z.length,B=>N(z[B],Y))}e.$wb=f;function l(z,Y){let N=0,B=z-1;for(;N<=B;){const _=(N+B)/2|0,ce=Y(_);if(ce<0)N=_+1;else if(ce>0)B=_-1;else return _}return-(N+1)}e.$xb=l;function p(z,Y,N){if(z=z|0,z>=Y.length)throw new TypeError("invalid index");const B=Y[Math.floor(Y.length*Math.random())],_=[],ce=[],re=[];for(const $e of Y){const me=N($e,B);me<0?_.push($e):me>0?ce.push($e):re.push($e)}return z<_.length?p(z,_,N):z<_.length+re.length?re[0]:p(z-(_.length+re.length),ce,N)}e.$yb=p;function k(z,Y){const N=[];let B;for(const _ of z.slice(0).sort(Y))!B||Y(B[0],_)!==0?(B=[_],N.push(B)):B.push(_);return N}e.$zb=k;function*v(z,Y){let N,B;for(const _ of z)B!==void 0&&Y(B,_)?N.push(_):(N&&(yield N),N=[_]),B=_;N&&(yield N)}e.$Ab=v;function u(z,Y){for(let N=0;N<=z.length;N++)Y(N===0?void 0:z[N-1],N===z.length?void 0:z[N])}e.$Bb=u;function y(z,Y){for(let N=0;N<z.length;N++)Y(N===0?void 0:z[N-1],z[N],N+1===z.length?void 0:z[N+1])}e.$Cb=y;function b(z,Y,N){const B=[];function _($e,me,ye){if(me===0&&ye.length===0)return;const Pe=B[B.length-1];Pe&&Pe.start+Pe.deleteCount===$e?(Pe.deleteCount+=me,Pe.toInsert.push(...ye)):B.push({start:$e,deleteCount:me,toInsert:ye})}let ce=0,re=0;for(;;){if(ce===z.length){_(ce,0,Y.slice(re));break}if(re===Y.length){_(ce,z.length-ce,[]);break}const $e=z[ce],me=Y[re],ye=N($e,me);ye===0?(ce+=1,re+=1):ye<0?(_(ce,1,[]),ce+=1):ye>0&&(_(ce,0,[me]),re+=1)}return B}e.$Db=b;function $(z,Y,N){const B=b(z,Y,N),_=[],ce=[];for(const re of B)_.push(...z.slice(re.start,re.start+re.deleteCount)),ce.push(...re.toInsert);return{removed:_,added:ce}}e.$Eb=$;function d(z,Y,N){if(N===0)return[];const B=z.slice(0,N).sort(Y);return g(z,Y,B,N,z.length),B}e.top=d;function h(z,Y,N,B,_){return N===0?Promise.resolve([]):new Promise((ce,re)=>{(async()=>{const $e=z.length,me=z.slice(0,N).sort(Y);for(let ye=N,Pe=Math.min(N+B,$e);ye<$e;ye=Pe,Pe=Math.min(Pe+B,$e)){if(ye>N&&await new Promise(Le=>setTimeout(Le)),_&&_.isCancellationRequested)throw new P.$5;g(z,Y,me,ye,Pe)}return me})().then(ce,re)})}e.$Gb=h;function g(z,Y,N,B,_){for(const ce=N.length;B<_;B++){const re=z[B];if(Y(re,N[ce-1])<0){N.pop();const $e=(0,A.$kb)(N,me=>Y(re,me)<0);N.splice($e,0,re)}}}function w(z){return z.filter(Y=>!!Y)}e.$Hb=w;function c(z){let Y=0;for(let N=0;N<z.length;N++)z[N]&&(z[Y]=z[N],Y+=1);z.length=Y}e.$Ib=c;function t(z,Y,N){z.splice(N,0,z.splice(Y,1)[0])}e.$Jb=t;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function r(z){return Array.isArray(z)&&z.length>0}e.$Lb=r;function i(z,Y=N=>N){const N=new Set;return z.filter(B=>{const _=Y(B);return N.has(_)?!1:(N.add(_),!0)})}e.$Mb=i;function n(z){const Y=new Set;return N=>{const B=z(N);return Y.has(B)?!1:(Y.add(B),!0)}}e.$Nb=n;function a(z,Y){return z.length>0?z[0]:Y}e.$Ob=a;function m(z,Y){return z.length>0?z[z.length-1]:Y}e.$Pb=m;function O(z,Y,N=(B,_)=>B===_){let B=0;for(let _=0,ce=Math.min(z.length,Y.length);_<ce&&N(z[_],Y[_]);_++)B++;return B}e.$Qb=O;function I(z){return[].concat(...z)}e.$Rb=I;function E(z,Y){let N=typeof Y=="number"?z:0;typeof Y=="number"?N=z:(N=0,Y=z);const B=[];if(N<=Y)for(let _=N;_<Y;_++)B.push(_);else for(let _=N;_>Y;_--)B.push(_);return B}e.$Sb=E;function C(z,Y,N){return z.reduce((B,_)=>(B[Y(_)]=N?N(_):_,B),Object.create(null))}e.$Tb=C;function j(z,Y){return z.push(Y),()=>T(z,Y)}e.$Ub=j;function T(z,Y){const N=z.indexOf(Y);if(N>-1)return z.splice(N,1),Y}e.$Vb=T;function F(z,Y,N){const B=z.slice(0,Y),_=z.slice(Y);return B.concat(N,_)}e.$Wb=F;function G(z,Y){let N;if(typeof Y=="number"){let B=Y;N=()=>{const _=Math.sin(B++)*179426549;return _-Math.floor(_)}}else N=Math.random;for(let B=z.length-1;B>0;B-=1){const _=Math.floor(N()*(B+1)),ce=z[B];z[B]=z[_],z[_]=ce}}e.$Xb=G;function J(z,Y){const N=z.indexOf(Y);N>-1&&(z.splice(N,1),z.unshift(Y))}e.$Yb=J;function le(z,Y){const N=z.indexOf(Y);N>-1&&(z.splice(N,1),z.push(Y))}e.$Zb=le;function se(z,Y){for(const N of Y)z.push(N)}e.$1b=se;function ue(z,Y){return Array.isArray(z)?z.map(Y):Y(z)}e.$2b=ue;function Z(z){return Array.isArray(z)?z:[z]}e.$3b=Z;function X(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=X;function H(z,Y,N){const B=W(z,Y),_=z.length,ce=N.length;z.length=_+ce;for(let re=_-1;re>=B;re--)z[re+ce]=z[re];for(let re=0;re<ce;re++)z[re+B]=N[re]}e.$5b=H;function L(z,Y,N,B){const _=W(z,Y);let ce=z.splice(_,N);return ce===void 0&&(ce=[]),H(z,_,B),ce}e.$6b=L;function W(z,Y){return Y<0?Math.max(Y+z.length,0):Math.min(Y,z.length)}var V;(function(z){function Y(ce){return ce<0}z.isLessThan=Y;function N(ce){return ce<=0}z.isLessThanOrEqual=N;function B(ce){return ce>0}z.isGreaterThan=B;function _(ce){return ce===0}z.isNeitherLessOrGreaterThan=_,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function q(z,Y){return(N,B)=>Y(z(N),z(B))}e.$7b=q;function te(...z){return(Y,N)=>{for(const B of z){const _=B(Y,N);if(!V.isNeitherLessOrGreaterThan(_))return _}return V.neitherLessOrGreaterThan}}e.$8b=te;const he=(z,Y)=>z-Y;e.$9b=he;const K=(z,Y)=>(0,e.$9b)(z?1:0,Y?1:0);e.$0b=K;function R(z){return(Y,N)=>-z(Y,N)}e.$$b=R;class U{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let N=this.c;for(;N<this.g.length&&Y(this.g[N]);)N++;const B=N===this.c?null:this.g.slice(this.c,N);return this.c=N,B}takeFromEndWhile(Y){let N=this.d;for(;N>=0&&Y(this.g[N]);)N--;const B=N===this.d?null:this.g.slice(N+1,this.d+1);return this.d=N,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const N=this.g.slice(this.c,this.c+Y);return this.c+=Y,N}}e.$_b=U;class x{static{this.empty=new x(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(N=>(Y(N),!0))}toArray(){const Y=[];return this.iterate(N=>(Y.push(N),!0)),Y}filter(Y){return new x(N=>this.iterate(B=>Y(B)?N(B):!0))}map(Y){return new x(N=>this.iterate(B=>N(Y(B))))}some(Y){let N=!1;return this.iterate(B=>(N=Y(B),!N)),N}findFirst(Y){let N;return this.iterate(B=>Y(B)?(N=B,!1):!0),N}findLast(Y){let N;return this.iterate(B=>(Y(B)&&(N=B),!0)),N}findLastMaxBy(Y){let N,B=!0;return this.iterate(_=>((B||V.isGreaterThan(Y(_,N)))&&(B=!1,N=_),!0)),N}}e.$ac=x}),define(oe[138],ae([0,1,14]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function A(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=A;function s(f,l="Unreachable"){throw new Error(l)}e.$6c=s;function M(f){if(!f)throw new P.$cb("Assertion Failed")}e.$7c=M;function D(f){if(!f()){debugger;f(),(0,P.$1)(new P.$cb("Assertion Failed"))}}e.$8c=D;function S(f,l){let p=0;for(;p<f.length-1;){const k=f[p],v=f[p+1];if(!l(k,v))return!1;p++}return!0}e.$9c=S}),define(oe[84],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function P(A,s){const M=this;let D=!1,S;return function(){if(D)return S;if(D=!0,s)try{S=A.apply(M,arguments)}finally{s()}else S=A.apply(M,arguments);return S}}e.$db=P}),define(oe[72],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(A){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}A.is=s;const M=Object.freeze([]);function D(){return M}A.empty=D;function*S(t){yield t}A.single=S;function f(t){return s(t)?t:S(t)}A.wrap=f;function l(t){return t||M}A.from=l;function*p(t){for(let o=t.length-1;o>=0;o--)yield t[o]}A.reverse=p;function k(t){return!t||t[Symbol.iterator]().next().done===!0}A.isEmpty=k;function v(t){return t[Symbol.iterator]().next().value}A.first=v;function u(t,o){for(const r of t)if(o(r))return!0;return!1}A.some=u;function y(t,o){for(const r of t)if(o(r))return r}A.find=y;function*b(t,o){for(const r of t)o(r)&&(yield r)}A.filter=b;function*$(t,o){let r=0;for(const i of t)yield o(i,r++)}A.map=$;function*d(...t){for(const o of t)yield*o}A.concat=d;function h(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}A.reduce=h;function*g(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}A.slice=g;function w(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const a=i.next();if(a.done)return[r,A.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return i}}]}A.consume=w;async function c(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}A.asyncToArray=c})(P||(e.Iterable=P={}))}),define(oe[42],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,o=!1){let r=0;const i=t.length;let n="",a=0,m=16,O=0;function I(J){let le=0,se=0;for(;le<J;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)se=se*16+ue-48;else if(ue>=65&&ue<=70)se=se*16+ue-65+10;else if(ue>=97&&ue<=102)se=se*16+ue-97+10;else break;r++,le++}return le<J&&(se=-1),se}function E(J){r=J,n="",a=0,m=16,O=0}function C(){const J=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return O=3,t.substring(J,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;le=r}else O=3;return t.substring(J,le)}function j(){let J="",le=r;for(;;){if(r>=i){J+=t.substring(le,r),O=2;break}const se=t.charCodeAt(r);if(se===34){J+=t.substring(le,r),r++;break}if(se===92){if(J+=t.substring(le,r),r++,r>=i){O=2;break}switch(t.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const Z=I(4);Z>=0?J+=String.fromCharCode(Z):O=4;break}default:O=5}le=r;continue}if(se>=0&&se<=31)if(f(se)){J+=t.substring(le,r),O=2;break}else O=6;r++}return J}function T(){if(n="",O=0,a=r,r>=i)return a=i,m=17;let J=t.charCodeAt(r);if(S(J)){do r++,n+=String.fromCharCode(J),J=t.charCodeAt(r);while(S(J));return m=15}if(f(J))return r++,n+=String.fromCharCode(J),J===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),m=14;switch(J){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,n=j(),m=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(le,r),m=12}if(t.charCodeAt(r+1)===42){r+=2;const se=i-1;let ue=!1;for(;r<se;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,O=1),n=t.substring(le,r),m=13}return n+=String.fromCharCode(J),r++,m=16}case 45:if(n+=String.fromCharCode(J),r++,r===i||!l(t.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),m=11;default:for(;r<i&&F(J);)r++,J=t.charCodeAt(r);if(a!==r){switch(n=t.substring(a,r),n){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return n+=String.fromCharCode(J),r++,m=16}}function F(J){if(S(J)||f(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let J;do J=T();while(J>=12&&J<=15);return J}return{setPosition:E,getPosition:()=>r,scan:o?G:T,getToken:()=>m,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>O}}e.$_m=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function k(t,o){const r=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function O(I,E,C,j){a.value=I,a.offset=E,a.length=C,a.type=j,a.colonOffset=void 0,n=a}try{g(t,{onObjectBegin:(I,E)=>{if(o<=I)throw i;n=void 0,m=o>I,r.push("")},onObjectProperty:(I,E,C)=>{if(o<E||(O(I,E,C,"property"),r[r.length-1]=I,o<=E+C))throw i},onObjectEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw i;n=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onLiteralValue:(I,E,C)=>{if(o<E||(O(I,E,C,c(I)),o<=E+C))throw i},onSeparator:(I,E,C)=>{if(o<=E)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=E,m=!1,n=void 0;else if(I===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(m=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:n,isAtPropertyKey:m,matches:I=>{let E=0;for(let C=0;E<I.length&&C<r.length;C++)if(I[E]===r[C]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$an=k;function v(t,o=[],r=M.DEFAULT){let i=null,n=[];const a=[];function m(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return g(t,{onObjectBegin:()=>{const I={};m(I),a.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const I=[];m(I),a.push(n),n=I,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:m,onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r),n[0]}e.$bn=v;function u(t,o=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function a(I){return i.children.push(I),I}g(t,{onObjectBegin:I=>{i=a({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,E,C)=>{i=a({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:E,length:C,parent:i})},onObjectEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onArrayBegin:(I,E)=>{i=a({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onLiteralValue:(I,E,C)=>{a({type:c(I),offset:E,length:C,parent:i,value:I}),n(E+C)},onSeparator:(I,E,C)=>{i.type==="property"&&(I===":"?i.colonOffset=E:I===","&&n(E))},onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r);const O=i.children[0];return O&&delete O.parent,O}e.$cn=u;function y(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$dn=y;function b(t){if(!t.parent||!t.parent.children)return[];const o=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$en=b;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$fn=$;function d(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$gn=d;function h(t,o,r=!1){if(d(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const a=h(i[n],o,r);if(a)return a}return t}}e.$hn=h;function g(t,o,r=M.DEFAULT){const i=D(t,!1);function n(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(q){return q?te=>q(te,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=n(o.onObjectBegin),O=a(o.onObjectProperty),I=n(o.onObjectEnd),E=n(o.onArrayBegin),C=n(o.onArrayEnd),j=a(o.onLiteralValue),T=a(o.onSeparator),F=n(o.onComment),G=a(o.onError),J=r&&r.disallowComments,le=r&&r.allowTrailingComma;function se(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:J||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:J?ue(10):F();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,te=[],he=[]){if(G(q),te.length+he.length>0){let K=i.getToken();for(;K!==17;){if(te.indexOf(K)!==-1){se();break}else if(he.indexOf(K)!==-1)break;K=se()}}}function Z(q){const te=i.getTokenValue();return q?j(te):O(te),se(),!0}function X(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}j(q);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return se(),!0}function H(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(T(":"),se(),V()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){m(),se();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),se(),i.getToken()===2&&le)break}else q&&ue(6,[],[]);H()||ue(4,[],[2,5]),q=!0}return I(),i.getToken()!==2?ue(7,[2],[]):se(),!0}function W(){E(),se();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),se(),i.getToken()===4&&le)break}else q&&ue(6,[],[]);V()||ue(4,[],[4,5]),q=!0}return C(),i.getToken()!==4?ue(8,[4],[]):se(),!0}function V(){switch(i.getToken()){case 3:return W();case 1:return L();case 10:return Z(!0);default:return X()}}return se(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):V()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$in=g;function w(t,o){const r=D(t),i=[];let n,a=0,m;do switch(m=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:a!==m&&i.push(t.substring(a,m)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),a=r.getPosition();break}while(n!==17);return i.join("")}e.$jn=w;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$kn=c}),define(oe[139],ae([0,1,42]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=void 0;function A(l,p,k){let v,u,y,b,$;if(p){for(b=p.offset,$=b+p.length,y=b;y>0&&!f(l,y-1);)y--;let m=$;for(;m<l.length&&!f(l,m);)m++;u=l.substring(y,m),v=D(u,k)}else u=l,v=0,y=0,b=0,$=l.length;const d=S(k,l);let h=!1,g=0,w;k.insertSpaces?w=M(" ",k.tabSize||4):w="	";const c=(0,P.$_m)(u,!1);let t=!1;function o(){return d+M(w,v+g)}function r(){let m=c.scan();for(h=!1;m===15||m===14;)h=h||m===14,m=c.scan();return t=m===16||c.getTokenError()!==0,m}const i=[];function n(m,O,I){!t&&O<$&&I>b&&l.substring(O,I)!==m&&i.push({offset:O,length:I-O,content:m})}let a=r();if(a!==17){const m=c.getTokenOffset()+y,O=M(w,v);n(O,y,m)}for(;a!==17;){let m=c.getTokenOffset()+c.getTokenLength()+y,O=r(),I="";for(;!h&&(O===12||O===13);){const C=c.getTokenOffset()+y;n(" ",m,C),m=c.getTokenOffset()+c.getTokenLength()+y,I=O===12?o():"",O=r()}if(O===2)a!==1&&(g--,I=o());else if(O===4)a!==3&&(g--,I=o());else{switch(a){case 3:case 1:g++,I=o();break;case 5:case 12:I=o();break;case 13:h?I=o():I=" ";break;case 6:I=" ";break;case 10:if(O===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:O===12||O===13?I=" ":O!==5&&O!==17&&(t=!0);break;case 16:t=!0;break}h&&(O===12||O===13)&&(I=o())}const E=c.getTokenOffset()+y;n(I,m,E),a=O}return i}e.$ln=A;function s(l,p){const k=JSON.stringify(l,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?k.replace(/\r\n|\r|\n/g,p.eol):k}e.$mn=s;function M(l,p){let k="";for(let v=0;v<p;v++)k+=l;return k}function D(l,p){let k=0,v=0;const u=p.tabSize||4;for(;k<l.length;){const y=l.charAt(k);if(y===" ")v++;else if(y==="	")v+=u;else break;k++}return Math.floor(v/u)}function S(l,p){for(let k=0;k<p.length;k++){const v=p.charAt(k);if(v==="\r")return k+1<p.length&&p.charAt(k+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return l&&l.eol||`
`}e.$nn=S;function f(l,p){return`\r
`.indexOf(l.charAt(p))!==-1}e.$on=f}),define(oe[101],ae([0,1,42,139]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function s(l,p,k){return M(l,p,void 0,k)}e.$pn=s;function M(l,p,k,v,u){const y=p.slice(),b=[],$=(0,P.$cn)(l,b);let d,h;for(;y.length>0&&(h=y.pop(),d=(0,P.$dn)($,y),d===void 0&&k!==void 0);)typeof h=="string"?k={[h]:k}:k=[k];if(d)if(d.type==="object"&&typeof h=="string"&&Array.isArray(d.children)){const g=(0,P.$dn)(d,[h]);if(g!==void 0)if(k===void 0){if(!g.parent)throw new Error("Malformed AST");const w=d.children.indexOf(g.parent);let c,t=g.parent.offset+g.parent.length;if(w>0){const o=d.children[w-1];c=o.offset+o.length}else c=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return D(l,{offset:c,length:t-c,content:""},v)}else return D(l,{offset:g.offset,length:g.length,content:JSON.stringify(k)},v);else{if(k===void 0)return[];const w=`${JSON.stringify(h)}: ${JSON.stringify(k)}`,c=u?u(d.children.map(o=>o.children[0].value)):d.children.length;let t;if(c>0){const o=d.children[c-1];t={offset:o.offset+o.length,length:0,content:","+w}}else d.children.length===0?t={offset:d.offset+1,length:0,content:w}:t={offset:d.offset+1,length:0,content:w+","};return D(l,t,v)}}else if(d.type==="array"&&typeof h=="number"&&Array.isArray(d.children))if(k!==void 0){const g=`${JSON.stringify(k)}`;let w;if(d.children.length===0||h===0)w={offset:d.offset+1,length:0,content:d.children.length===0?g:g+","};else{const c=h===-1||h>d.children.length?d.children.length:h,t=d.children[c-1];w={offset:t.offset+t.length,length:0,content:","+g}}return D(l,w,v)}else{const g=h,w=d.children[g];let c;if(d.children.length===1)c={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===g){const t=d.children[g-1],o=t.offset+t.length,r=d.offset+d.length;c={offset:o,length:r-2-o,content:""}}else c={offset:w.offset,length:d.children[g+1].offset-w.offset,content:""};return D(l,c,v)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${d.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return D(l,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(k)},v)}}e.$qn=M;function D(l,p,k){let v=S(l,p),u=p.offset,y=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;u>0&&!(0,A.$on)(v,u-1);)u--;for(;y<v.length&&!(0,A.$on)(v,y);)y++}const b=(0,A.$ln)(v,{offset:u,length:y-u},k);for(let d=b.length-1;d>=0;d--){const h=b[d];v=S(v,h),u=Math.min(u,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const $=l.length-(v.length-y)-u;return[{offset:u,length:$,content:v.substring(u,y)}]}e.$rn=D;function S(l,p){return l.substring(0,p.offset)+p.content+l.substring(p.offset+p.length)}e.$sn=S;function f(l,p){const k=p.slice(0).sort((u,y)=>{const b=u.offset-y.offset;return b===0?u.length-y.length:b});let v=l.length;for(let u=k.length-1;u>=0;u--){const y=k[u];if(y.offset+y.length<=v)l=S(l,y);else throw new Error("Overlapping edit");v=y.offset}return l}e.$tn=f}),define(oe[62],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=P}),define(oe[102],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class A{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const D=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(D){const l=this.b;this.b=S,S.prev=l,l.next=S}else{const l=this.a;this.a=S,S.next=l,l.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$4c=A}),define(oe[31],ae([0,1]),function(Q,e){"use strict";var P,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(g,w,c){let t=g.get(w);return t===void 0&&(t=c,g.set(w,t)),t}e.$xc=M;function D(g){const w=[];return g.forEach((c,t)=>{w.push(`${t} => ${c}`)}),`Map(${g.size}) {${w.join(", ")}}`}e.$yc=D;function S(g){const w=[];return g.forEach(c=>{w.push(c)}),`Set(${g.size}) {${w.join(", ")}}`}e.$zc=S;class f{constructor(w,c){this.uri=w,this.value=c}}function l(g){return Array.isArray(g)}class p{static{this.c=w=>w.toString()}constructor(w,c){if(this[P]="ResourceMap",w instanceof p)this.d=new Map(w.d),this.e=c??p.c;else if(l(w)){this.d=new Map,this.e=c??p.c;for(const[t,o]of w)this.set(t,o)}else this.d=new Map,this.e=w??p.c}set(w,c){return this.d.set(this.e(w),new f(w,c)),this}get(w){return this.d.get(this.e(w))?.value}has(w){return this.d.has(this.e(w))}get size(){return this.d.size}clear(){this.d.clear()}delete(w){return this.d.delete(this.e(w))}forEach(w,c){typeof c<"u"&&(w=w.bind(c));for(const[t,o]of this.d)w(o.value,o.uri,this)}*values(){for(const w of this.d.values())yield w.value}*keys(){for(const w of this.d.values())yield w.uri}*entries(){for(const w of this.d.values())yield[w.uri,w.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,w]of this.d)yield[w.uri,w.value]}}e.$Ac=p;class k{constructor(w,c){this[A]="ResourceSet",!w||typeof w=="function"?this.c=new p(w):(this.c=new p(c),w.forEach(this.add,this))}get size(){return this.c.size}add(w){return this.c.set(w,w),this}clear(){this.c.clear()}delete(w){return this.c.delete(w)}forEach(w,c){this.c.forEach((t,o)=>w.call(c,o,o,this))}has(w){return this.c.has(w)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=k;var v;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class u{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(w){return this.c.has(w)}get(w,c=0){const t=this.c.get(w);if(t)return c!==0&&this.l(t,c),t.value}set(w,c,t=0){let o=this.c.get(w);if(o)o.value=c,t!==0&&this.l(o,t);else{switch(o={key:w,value:c,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(w,o),this.f++}return this}delete(w){return!!this.remove(w)}remove(w){const c=this.c.get(w);if(c)return this.c.delete(w),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const w=this.d;return this.c.delete(w.key),this.k(w),this.f--,w.value}forEach(w,c){const t=this.g;let o=this.d;for(;o;){if(c?w.bind(c)(o.value,o.key,this):w(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const w=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(w.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const w=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(w.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const w=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(w.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(w){if(w>=this.size)return;if(w===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>w;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(w){if(!this.d&&!this.e)this.e=w;else if(this.d)w.next=this.d,this.d.previous=w;else throw new Error("Invalid list");this.d=w,this.g++}j(w){if(!this.d&&!this.e)this.d=w;else if(this.e)w.previous=this.e,this.e.next=w;else throw new Error("Invalid list");this.e=w,this.g++}k(w){if(w===this.d&&w===this.e)this.d=void 0,this.e=void 0;else if(w===this.d){if(!w.next)throw new Error("Invalid list");w.next.previous=void 0,this.d=w.next}else if(w===this.e){if(!w.previous)throw new Error("Invalid list");w.previous.next=void 0,this.e=w.previous}else{const c=w.next,t=w.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}w.next=void 0,w.previous=void 0,this.g++}l(w,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(w===this.d)return;const t=w.next,o=w.previous;w===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),w.previous=void 0,w.next=this.d,this.d.previous=w,this.d=w,this.g++}else if(c===2){if(w===this.e)return;const t=w.next,o=w.previous;w===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),w.next=void 0,w.previous=this.e,this.e.next=w,this.e=w,this.g++}}}toJSON(){const w=[];return this.forEach((c,t)=>{w.push([t,c])}),w}fromJSON(w){this.clear();for(const[c,t]of w)this.set(c,t)}}e.$Cc=u;class y extends u{constructor(w,c=1){super(),this.m=w,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(w){this.m=w,this.o()}get ratio(){return this.n}set ratio(w){this.n=Math.min(Math.max(0,w),1),this.o()}get(w,c=2){return super.get(w,c)}peek(w){return super.get(w,0)}set(w,c){return super.set(w,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=y;class b{constructor(){this.c=new Map}add(w){return this.c.set(w,(this.c.get(w)||0)+1),this}delete(w){let c=this.c.get(w)||0;return c===0?!1:(c--,c===0?this.c.delete(w):this.c.set(w,c),!0)}has(w){return this.c.has(w)}}e.$Ec=b;class ${constructor(w){if(this.c=new Map,this.d=new Map,w)for(const[c,t]of w)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(w,c){this.c.set(w,c),this.d.set(c,w)}get(w){return this.c.get(w)}getKey(w){return this.d.get(w)}delete(w){const c=this.c.get(w);return c===void 0?!1:(this.c.delete(w),this.d.delete(c),!0)}forEach(w,c){this.c.forEach((t,o)=>{w.call(c,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=$;class d{constructor(){this.c=new Map}add(w,c){let t=this.c.get(w);t||(t=new Set,this.c.set(w,t)),t.add(c)}delete(w,c){const t=this.c.get(w);t&&(t.delete(c),t.size===0&&this.c.delete(w))}forEach(w,c){const t=this.c.get(w);t&&t.forEach(c)}get(w){const c=this.c.get(w);return c||new Set}}e.$Gc=d;function h(g,w){if(g===w)return!0;if(g.size!==w.size)return!1;for(const[c,t]of g)if(!w.has(c)||w.get(c)!==t)return!1;for(const[c]of w)if(!g.has(c))return!1;return!0}e.$Hc=h}),define(oe[2],ae([0,1,22,136,31,84,72]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let f=null;class l{constructor(){this.b=new Map}static{this.a=0}c(j){let T=this.b.get(j);return T||(T={parent:null,source:null,isSingleton:!1,value:j,idx:l.a++},this.b.set(j,T)),T}trackDisposable(j){const T=this.c(j);T.source||(T.source=new Error().stack)}setParent(j,T){const F=this.c(j);F.parent=T}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,T){const F=T.get(j);if(F)return F;const G=j.parent?this.f(this.c(j.parent),T):j;return T.set(j,G),G}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,j).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(j=10,T){let F;if(T)F=T;else{const ue=new Map,Z=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,ue).isSingleton);if(Z.length===0)return;const X=new Set(Z.map(H=>H.value));if(F=Z.filter(H=>!(H.parent&&X.has(H.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function G(ue){function Z(H,L){for(;H.length>0&&L.some(W=>typeof W=="string"?W===H[0]:H[0].match(W));)H.shift()}const X=ue.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return Z(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const J=new s.$Gc;for(const ue of F){const Z=G(ue);for(let X=0;X<=Z.length;X++)J.add(Z.slice(0,X).join(`
`),ue)}F.sort((0,P.$7b)(ue=>ue.idx,P.$9b));let le="",se=0;for(const ue of F.slice(0,j)){se++;const Z=G(ue),X=[];for(let H=0;H<Z.length;H++){let L=Z[H];L=`(shared with ${J.get(Z.slice(0,H+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const V=J.get(Z.slice(0,H).join(`
`)),q=(0,A.$K)([...V].map(te=>G(te)[H]),te=>te);delete q[Z[H]];for(const[te,he]of Object.entries(q))X.unshift(`    - stacktraces of ${he.length} other leaks continue with ${te}`);X.unshift(L)}le+=`


==================== Leaking disposable ${se}/${F.length}: ${ue.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>j&&(le+=`


... and ${F.length-j} more leaking disposables

`),{leaks:F,details:le}}}e.$Ic=l;function p(C){f=C}if(e.$Jc=p,S){const C="__is_disposable_tracked__";p(new class{trackDisposable(j){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[C]||console.log(T)},3e3)}setParent(j,T){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsSingleton(j){}})}function k(C){return f?.trackDisposable(C),C}e.$Kc=k;function v(C){f?.markAsDisposed(C)}e.$Lc=v;function u(C,j){f?.setParent(C,j)}function y(C,j){if(f)for(const T of C)f.setParent(T,j)}function b(C){return f?.markAsSingleton(C),C}e.$Mc=b;function $(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$Nc=$;function d(C){if(D.Iterable.is(C)){const j=[];for(const T of C)if(T)try{T.dispose()}catch(F){j.push(F)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$Oc=d;function h(C){for(const j of C)$(j)&&j.dispose();return[]}e.$Pc=h;function g(...C){const j=w(()=>d(C));return y(C,j),j}e.$Qc=g;function w(C){const j=k({dispose:(0,M.$db)(()=>{v(j),C()})});return j}e.$Rc=w;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return u(j,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),u(j,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,k(this),u(this.q,this)}dispose(){v(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Tc=t;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&u(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&u(j,null),j}}e.$Uc=o;class r{constructor(j){this.a=new o,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(j){let T=j;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,v(this))},this}}e.$Xc=n;class a{constructor(){this.a=new Map}acquire(j,...T){let F=this.a.get(j);F||(F={counter:0,object:this.b(j,...T)},this.a.set(j,F));const{object:G}=F,J=(0,M.$db)(()=>{--F.counter===0&&(this.c(j,F.object),this.a.delete(j))});return F.counter++,{object:G,dispose:J}}}e.$Yc=a;class m{constructor(j){this.a=j}async acquire(j,...T){const F=this.a.acquire(j,...T);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(G){throw F.dispose(),G}}}e.$Zc=m;class O{constructor(j){this.object=j}dispose(){}}e.$1c=O;function I(C){const j=new c;try{C(j)}finally{j.dispose()}}e.$2c=I;class E{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,T,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(j)?.dispose(),this.a.set(j,T)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(oe[85],ae([0,1,31]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=e.$Fl=void 0;const A=new P.$Dc(1e4);function s(l){return f(l,"NFC",A)}e.$Fl=s;const M=new P.$Dc(1e4);function D(l){return f(l,"NFD",M)}e.$Gl=D;const S=/[^\u0000-\u0080]/;function f(l,p,k){if(!l)return l;const v=k.get(l);if(v)return v;let u;return S.test(l)?u=l.normalize(p):u=l,k.set(l,u),u}e.$Hl=function(){const l=/[\u0300-\u036f]/g;return function(p){return D(p).replace(l,"")}}()}),define(oe[140],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.rot=e.$6l=void 0;function P(S,f,l){return Math.min(Math.max(S,f),l)}e.$6l=P;function A(S,f){return(f+S%f)%f}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$8l=s;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$9l=M;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const l=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$0l=D}),function(){function Q(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(f){M.push(f,Date.now())}function S(){const f=[];for(let l=0;l<M.length;l+=2)f.push({name:M[l],startTime:M[l+1]});return f}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=P(A))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var A in P)(typeof exports=="object"?exports:Q)[A]=P[A]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function P(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return Q[A].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=Q,P.c=e,P.d=function(A,s,M){P.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:M})},P.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},P.t=function(A,s){if(1&s&&(A=P(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var D in A)P.d(M,D,function(S){return A[S]}.bind(null,D));return M},P.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return P.d(s,"a",s),s},P.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},P.p="",P(P.s=0)}([function(Q,e,P){(function(A){var s;e=Q.exports=he,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],l=0,p=l++;f[p]="0|[1-9]\\d*";var k=l++;f[k]="[0-9]+";var v=l++;f[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=l++;f[u]="("+f[p]+")\\.("+f[p]+")\\.("+f[p]+")";var y=l++;f[y]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var b=l++;f[b]="(?:"+f[p]+"|"+f[v]+")";var $=l++;f[$]="(?:"+f[k]+"|"+f[v]+")";var d=l++;f[d]="(?:-("+f[b]+"(?:\\."+f[b]+")*))";var h=l++;f[h]="(?:-?("+f[$]+"(?:\\."+f[$]+")*))";var g=l++;f[g]="[0-9A-Za-z-]+";var w=l++;f[w]="(?:\\+("+f[g]+"(?:\\."+f[g]+")*))";var c=l++,t="v?"+f[u]+f[d]+"?"+f[w]+"?";f[c]="^"+t+"$";var o="[v=\\s]*"+f[y]+f[h]+"?"+f[w]+"?",r=l++;f[r]="^"+o+"$";var i=l++;f[i]="((?:<|>)?=?)";var n=l++;f[n]=f[k]+"|x|X|\\*";var a=l++;f[a]=f[p]+"|x|X|\\*";var m=l++;f[m]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[d]+")?"+f[w]+"?)?)?";var O=l++;f[O]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[h]+")?"+f[w]+"?)?)?";var I=l++;f[I]="^"+f[i]+"\\s*"+f[m]+"$";var E=l++;f[E]="^"+f[i]+"\\s*"+f[O]+"$";var C=l++;f[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=l++;f[j]="(?:~>?)";var T=l++;f[T]="(\\s*)"+f[j]+"\\s+",S[T]=new RegExp(f[T],"g");var F=l++;f[F]="^"+f[j]+f[m]+"$";var G=l++;f[G]="^"+f[j]+f[O]+"$";var J=l++;f[J]="(?:\\^)";var le=l++;f[le]="(\\s*)"+f[J]+"\\s+",S[le]=new RegExp(f[le],"g");var se=l++;f[se]="^"+f[J]+f[m]+"$";var ue=l++;f[ue]="^"+f[J]+f[O]+"$";var Z=l++;f[Z]="^"+f[i]+"\\s*("+o+")$|^$";var X=l++;f[X]="^"+f[i]+"\\s*("+t+")$|^$";var H=l++;f[H]="(\\s*)"+f[i]+"\\s*("+o+"|"+f[m]+")",S[H]=new RegExp(f[H],"g");var L=l++;f[L]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var W=l++;f[W]="^\\s*("+f[O]+")\\s+-\\s+("+f[O]+")\\s*$";var V=l++;f[V]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,f[q]),S[q]||(S[q]=new RegExp(f[q]));function te(ee,fe){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>M||!(fe?S[r]:S[c]).test(ee))return null;try{return new he(ee,fe)}catch{return null}}function he(ee,fe){if(ee instanceof he){if(ee.loose===fe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(ee,fe);s("SemVer",ee,fe),this.loose=fe;var ge=ee.trim().match(fe?S[r]:S[c]);if(!ge)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Me=+Ie;if(Me>=0&&Me<D)return Me}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ee,fe){var ge=te(ee,fe);return ge?ge.version:null},e.clean=function(ee,fe){var ge=te(ee.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return s("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),R(this.major,ee.major)||R(this.minor,ee.minor)||R(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=ee.prerelease[fe];if(s("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return R(ge,Ie)}while(++fe)},he.prototype.inc=function(ee,fe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new he(ee,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(ee,fe){if(Y(ee,fe))return null;var ge=te(ee),Ie=te(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Me in ge)if((Me==="major"||Me==="minor"||Me==="patch")&&ge[Me]!==Ie[Me])return"pre"+Me;return"prerelease"}for(var Me in ge)if((Me==="major"||Me==="minor"||Me==="patch")&&ge[Me]!==Ie[Me])return Me},e.compareIdentifiers=R;var K=/^[0-9]+$/;function R(ee,fe){var ge=K.test(ee),Ie=K.test(fe);return ge&&Ie&&(ee=+ee,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:ee<fe?-1:ee>fe?1:0}function U(ee,fe,ge){return new he(ee,ge).compare(new he(fe,ge))}function x(ee,fe,ge){return U(ee,fe,ge)>0}function z(ee,fe,ge){return U(ee,fe,ge)<0}function Y(ee,fe,ge){return U(ee,fe,ge)===0}function N(ee,fe,ge){return U(ee,fe,ge)!==0}function B(ee,fe,ge){return U(ee,fe,ge)>=0}function _(ee,fe,ge){return U(ee,fe,ge)<=0}function ce(ee,fe,ge,Ie){var Me;switch(fe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Me=ee===ge;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Me=ee!==ge;break;case"":case"=":case"==":Me=Y(ee,ge,Ie);break;case"!=":Me=N(ee,ge,Ie);break;case">":Me=x(ee,ge,Ie);break;case">=":Me=B(ee,ge,Ie);break;case"<":Me=z(ee,ge,Ie);break;case"<=":Me=_(ee,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Me}function re(ee,fe){if(ee instanceof re){if(ee.loose===fe)return ee;ee=ee.value}if(!(this instanceof re))return new re(ee,fe);s("comparator",ee,fe),this.loose=fe,this.parse(ee),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ee,fe){return R(fe,ee)},e.major=function(ee,fe){return new he(ee,fe).major},e.minor=function(ee,fe){return new he(ee,fe).minor},e.patch=function(ee,fe){return new he(ee,fe).patch},e.compare=U,e.compareLoose=function(ee,fe){return U(ee,fe,!0)},e.rcompare=function(ee,fe,ge){return U(fe,ee,ge)},e.sort=function(ee,fe){return ee.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(ee,fe){return ee.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=x,e.lt=z,e.eq=Y,e.neq=N,e.gte=B,e.lte=_,e.cmp=ce,e.Comparator=re;var $e={};function me(ee,fe){if(ee instanceof me)return ee.loose===fe?ee:new me(ee.raw,fe);if(ee instanceof re)return new me(ee.value,fe);if(!(this instanceof me))return new me(ee,fe);if(this.loose=fe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ye(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Pe(ee,fe,ge,Ie,Me,Te,je,Je,Be,He,Ve,ie,de){return((fe=ye(ge)?"":ye(Ie)?">="+ge+".0.0":ye(Me)?">="+ge+"."+Ie+".0":">="+fe)+" "+(Je=ye(Be)?"":ye(He)?"<"+(+Be+1)+".0.0":ye(Ve)?"<"+Be+"."+(+He+1)+".0":ie?"<="+Be+"."+He+"."+Ve+"-"+ie:"<="+Je)).trim()}function Le(ee,fe){for(var ge=0;ge<ee.length;ge++)if(!ee[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ee.length;ge++)if(s(ee[ge].semver),ee[ge].semver!==$e&&ee[ge].semver.prerelease.length>0){var Ie=ee[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function ke(ee,fe,ge){try{fe=new me(fe,ge)}catch{return!1}return fe.test(ee)}function pe(ee,fe,ge,Ie){var Me,Te,je,Je,Be;switch(ee=new he(ee,Ie),fe=new me(fe,Ie),ge){case">":Me=x,Te=_,je=z,Je=">",Be=">=";break;case"<":Me=z,Te=B,je=x,Je="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(ee,fe,Ie))return!1;for(var He=0;He<fe.set.length;++He){var Ve=fe.set[He],ie=null,de=null;if(Ve.forEach(function(be){be.semver===$e&&(be=new re(">=0.0.0")),ie=ie||be,de=de||be,Me(be.semver,ie.semver,Ie)?ie=be:je(be.semver,de.semver,Ie)&&(de=be)}),ie.operator===Je||ie.operator===Be||(!de.operator||de.operator===Je)&&Te(ee,de.semver)||de.operator===Be&&je(ee,de.semver))return!1}return!0}re.prototype.parse=function(ee){var fe=this.loose?S[Z]:S[X],ge=ee.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ee);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new he(ge[2],this.loose):this.semver=$e},re.prototype.toString=function(){return this.value},re.prototype.test=function(ee){return s("Comparator.test",ee,this.loose),this.semver===$e||(typeof ee=="string"&&(ee=new he(ee,this.loose)),ce(ee,this.operator,this.semver,this.loose))},re.prototype.intersects=function(ee,fe){if(!(ee instanceof re))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(ee.value,fe),ke(this.value,ge,fe);if(ee.operator==="")return ge=new me(this.value,fe),ke(ee.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Te=this.semver.version===ee.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Je=ce(this.semver,"<",ee.semver,fe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Be=ce(this.semver,">",ee.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Ie||Me||Te&&je||Je||Be},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ee){var fe=this.loose;ee=ee.trim(),s("range",ee,fe);var ge=fe?S[W]:S[L];ee=ee.replace(ge,Pe),s("hyphen replace",ee),ee=ee.replace(S[H],"$1$2$3"),s("comparator trim",ee,S[H]),ee=(ee=(ee=ee.replace(S[T],"$1~")).replace(S[le],"$1^")).split(/\s+/).join(" ");var Ie=fe?S[Z]:S[X],Me=ee.split(" ").map(function(Te){return function(je,Je){return s("comp",je),je=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ie,de){s("caret",ie,de);var be=de?S[ue]:S[se];return ie.replace(be,function(Se,ve,Ae,We,qe){var Qe;return s("caret",ie,Se,ve,Ae,We,qe),ye(ve)?Qe="":ye(Ae)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(We)?Qe=ve==="0"?">="+ve+"."+Ae+".0 <"+ve+"."+(+Ae+1)+".0":">="+ve+"."+Ae+".0 <"+(+ve+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=ve==="0"?Ae==="0"?">="+ve+"."+Ae+"."+We+qe+" <"+ve+"."+Ae+"."+(+We+1):">="+ve+"."+Ae+"."+We+qe+" <"+ve+"."+(+Ae+1)+".0":">="+ve+"."+Ae+"."+We+qe+" <"+(+ve+1)+".0.0"):(s("no pr"),Qe=ve==="0"?Ae==="0"?">="+ve+"."+Ae+"."+We+" <"+ve+"."+Ae+"."+(+We+1):">="+ve+"."+Ae+"."+We+" <"+ve+"."+(+Ae+1)+".0":">="+ve+"."+Ae+"."+We+" <"+(+ve+1)+".0.0"),s("caret return",Qe),Qe})}(Ve,He)}).join(" ")}(je,Je),s("caret",je),je=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ie,de){var be=de?S[G]:S[F];return ie.replace(be,function(Se,ve,Ae,We,qe){var Qe;return s("tilde",ie,Se,ve,Ae,We,qe),ye(ve)?Qe="":ye(Ae)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(We)?Qe=">="+ve+"."+Ae+".0 <"+ve+"."+(+Ae+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=">="+ve+"."+Ae+"."+We+qe+" <"+ve+"."+(+Ae+1)+".0"):Qe=">="+ve+"."+Ae+"."+We+" <"+ve+"."+(+Ae+1)+".0",s("tilde return",Qe),Qe})}(Ve,He)}).join(" ")}(je,Je),s("tildes",je),je=function(Be,He){return s("replaceXRanges",Be,He),Be.split(/\s+/).map(function(Ve){return function(ie,de){ie=ie.trim();var be=de?S[E]:S[I];return ie.replace(be,function(Se,ve,Ae,We,qe,Qe){s("xRange",ie,Se,ve,Ae,We,qe,Qe);var xe=ye(Ae),Xe=xe||ye(We),Ye=Xe||ye(qe);return ve==="="&&Ye&&(ve=""),xe?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ye?(Xe&&(We=0),Ye&&(qe=0),ve===">"?(ve=">=",Xe?(Ae=+Ae+1,We=0,qe=0):Ye&&(We=+We+1,qe=0)):ve==="<="&&(ve="<",Xe?Ae=+Ae+1:We=+We+1),Se=ve+Ae+"."+We+"."+qe):Xe?Se=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ye&&(Se=">="+Ae+"."+We+".0 <"+Ae+"."+(+We+1)+".0"),s("xRange return",Se),Se})}(Ve,He)}).join(" ")}(je,Je),s("xrange",je),je=function(Be,He){return s("replaceStars",Be,He),Be.trim().replace(S[V],"")}(je,Je),s("stars",je),je}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Te){return!!Te.match(Ie)})),Me=Me.map(function(Te){return new re(Te,fe)})},me.prototype.intersects=function(ee,fe){if(!(ee instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return ee.set.some(function(Me){return Me.every(function(Te){return Ie.intersects(Te,fe)})})})})},e.toComparators=function(ee,fe){return new me(ee,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],ee))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(ee,fe,ge){var Ie=null,Me=null;try{var Te=new me(fe,ge)}catch{return null}return ee.forEach(function(je){Te.test(je)&&(Ie&&Me.compare(je)!==-1||(Me=new he(Ie=je,ge)))}),Ie},e.minSatisfying=function(ee,fe,ge){var Ie=null,Me=null;try{var Te=new me(fe,ge)}catch{return null}return ee.forEach(function(je){Te.test(je)&&(Ie&&Me.compare(je)!==1||(Me=new he(Ie=je,ge)))}),Ie},e.validRange=function(ee,fe){try{return new me(ee,fe).range||"*"}catch{return null}},e.ltr=function(ee,fe,ge){return pe(ee,fe,"<",ge)},e.gtr=function(ee,fe,ge){return pe(ee,fe,">",ge)},e.outside=pe,e.prerelease=function(ee,fe){var ge=te(ee,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ee,fe,ge){return ee=new me(ee,ge),fe=new me(fe,ge),ee.intersects(fe)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var fe=ee.match(S[C]);return fe==null?null:te((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,P(1))},function(Q,e){var P,A,s=Q.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S($){if(P===setTimeout)return setTimeout($,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout($,0);try{return P($,0)}catch{try{return P.call(null,$,0)}catch{return P.call(this,$,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var f,l=[],p=!1,k=-1;function v(){p&&f&&(p=!1,f.length?l=f.concat(l):k=-1,l.length&&u())}function u(){if(!p){var $=S(v);p=!0;for(var d=l.length;d;){for(f=l,l=[];++k<d;)f&&f[k].run();k=-1,d=l.length}f=null,p=!1,function(h){if(A===clearTimeout)return clearTimeout(h);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(h);try{A(h)}catch{try{return A.call(null,h)}catch{return A.call(this,h)}}}($)}}function y($,d){this.fun=$,this.array=d}function b(){}s.nextTick=function($){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];l.push(new y($,d)),l.length!==1||p||S(u)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function($){return[]},s.binding=function($){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function($){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(oe[141],ae([0,1]),function(Q,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;class A{constructor(S,f,l){this.level=S,this.key=f,this.value=l,this.forward=[]}}const s=void 0;class M{constructor(S,f=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,f){return M.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=M.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let l=this.e.forward[0];for(;l;)S.call(f,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,l){let p=S.e;for(let k=S.d-1;k>=0;k--)for(;p.forward[k]&&l(p.forward[k].key,f)<0;)p=p.forward[k];if(p=p.forward[0],p&&l(p.key,f)===0)return p}static h(S,f,l,p){const k=[];let v=S.e;for(let u=S.d-1;u>=0;u--){for(;v.forward[u]&&p(v.forward[u].key,f)<0;)v=v.forward[u];k[u]=v}if(v=v.forward[0],v&&p(v.key,f)===0)return v.value=l,!1;{const u=M.j(S);if(u>S.d){for(let y=S.d;y<u;y++)k[y]=S.e;S.d=u}v=new A(u,f,l);for(let y=0;y<u;y++)v.forward[y]=k[y].forward[y],k[y].forward[y]=v;return!0}}static j(S,f=.5){let l=1;for(;Math.random()<f&&l<S.c;)l+=1;return l}static k(S,f,l){const p=[];let k=S.e;for(let v=S.d-1;v>=0;v--){for(;k.forward[v]&&l(k.forward[v].key,f)<0;)k=k.forward[v];p[v]=k}if(k=k.forward[0],!k||l(k.key,f)!==0)return!1;for(let v=0;v<S.d&&p[v].forward[v]===k;v++)p[v].forward[v]=k.forward[v];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$Zr=M}),define(oe[73],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qd=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(M){return new A(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Qd=A}),define(oe[3],ae([0,1,14,84,2,102,73]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.Event=void 0;const S=!1,f=!1;var l;(function(I){I.None=()=>s.$Tc.None;function E(ce){if(f){const{onDidAddListener:re}=ce,$e=y.create();let me=0;ce.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),re?.()}}}function C(ce,re){return X(ce,()=>{},0,void 0,!0,void 0,re)}I.defer=C;function j(ce){return(re,$e=null,me)=>{let ye=!1,Pe;return Pe=ce(Le=>{if(!ye)return Pe?Pe.dispose():ye=!0,re.call($e,Le)},null,me),ye&&Pe.dispose(),Pe}}I.once=j;function T(ce,re,$e){return ue((me,ye=null,Pe)=>ce(Le=>me.call(ye,re(Le)),null,Pe),$e)}I.map=T;function F(ce,re,$e){return ue((me,ye=null,Pe)=>ce(Le=>{re(Le),me.call(ye,Le)},null,Pe),$e)}I.forEach=F;function G(ce,re,$e){return ue((me,ye=null,Pe)=>ce(Le=>re(Le)&&me.call(ye,Le),null,Pe),$e)}I.filter=G;function J(ce){return ce}I.signal=J;function le(...ce){return(re,$e=null,me)=>{const ye=(0,s.$Qc)(...ce.map(Pe=>Pe(Le=>re.call($e,Le))));return Z(ye,me)}}I.any=le;function se(ce,re,$e,me){let ye=$e;return T(ce,Pe=>(ye=re(ye,Pe),ye),me)}I.reduce=se;function ue(ce,re){let $e;const me={onWillAddFirstListener(){$e=ce(ye.fire,ye)},onDidRemoveLastListener(){$e?.dispose()}};re||E(me);const ye=new g(me);return re?.add(ye),ye.event}function Z(ce,re){return re instanceof Array?re.push(ce):re&&re.add(ce),ce}function X(ce,re,$e=100,me=!1,ye=!1,Pe,Le){let ke,pe,ee,fe=0,ge;const Ie={leakWarningThreshold:Pe,onWillAddFirstListener(){ke=ce(Te=>{fe++,pe=re(pe,Te),me&&!ee&&(Me.fire(pe),pe=void 0),ge=()=>{const je=pe;pe=void 0,ee=void 0,(!me||fe>1)&&Me.fire(je),fe=0},typeof $e=="number"?(clearTimeout(ee),ee=setTimeout(ge,$e)):ee===void 0&&(ee=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&fe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ke.dispose()}};Le||E(Ie);const Me=new g(Ie);return Le?.add(Me),Me.event}I.debounce=X;function H(ce,re=0,$e){return I.debounce(ce,(me,ye)=>me?(me.push(ye),me):[ye],re,void 0,!0,void 0,$e)}I.accumulate=H;function L(ce,re=(me,ye)=>me===ye,$e){let me=!0,ye;return G(ce,Pe=>{const Le=me||!re(Pe,ye);return me=!1,ye=Pe,Le},$e)}I.latch=L;function W(ce,re,$e){return[I.filter(ce,re,$e),I.filter(ce,me=>!re(me),$e)]}I.split=W;function V(ce,re=!1,$e=[],me){let ye=$e.slice(),Pe=ce(pe=>{ye?ye.push(pe):ke.fire(pe)});me&&me.add(Pe);const Le=()=>{ye?.forEach(pe=>ke.fire(pe)),ye=null},ke=new g({onWillAddFirstListener(){Pe||(Pe=ce(pe=>ke.fire(pe)),me&&me.add(Pe))},onDidAddFirstListener(){ye&&(re?setTimeout(Le):Le())},onDidRemoveLastListener(){Pe&&Pe.dispose(),Pe=null}});return me&&me.add(ke),ke.event}I.buffer=V;function q(ce,re){return(me,ye,Pe)=>{const Le=re(new he);return ce(function(ke){const pe=Le.evaluate(ke);pe!==te&&me.call(ye,pe)},void 0,Pe)}}I.chain=q;const te=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(re){return this.f.push(re),this}forEach(re){return this.f.push($e=>(re($e),$e)),this}filter(re){return this.f.push($e=>re($e)?$e:te),this}reduce(re,$e){let me=$e;return this.f.push(ye=>(me=re(me,ye),me)),this}latch(re=($e,me)=>$e===me){let $e=!0,me;return this.f.push(ye=>{const Pe=$e||!re(ye,me);return $e=!1,me=ye,Pe?ye:te}),this}evaluate(re){for(const $e of this.f)if(re=$e(re),re===te)break;return re}}function K(ce,re,$e=me=>me){const me=(...ke)=>Le.fire($e(...ke)),ye=()=>ce.on(re,me),Pe=()=>ce.removeListener(re,me),Le=new g({onWillAddFirstListener:ye,onDidRemoveLastListener:Pe});return Le.event}I.fromNodeEventEmitter=K;function R(ce,re,$e=me=>me){const me=(...ke)=>Le.fire($e(...ke)),ye=()=>ce.addEventListener(re,me),Pe=()=>ce.removeEventListener(re,me),Le=new g({onWillAddFirstListener:ye,onDidRemoveLastListener:Pe});return Le.event}I.fromDOMEventEmitter=R;function U(ce){return new Promise(re=>j(ce)(re))}I.toPromise=U;function x(ce){const re=new g;return ce.then($e=>{re.fire($e)},()=>{re.fire(void 0)}).finally(()=>{re.dispose()}),re.event}I.fromPromise=x;function z(ce,re,$e){return re($e),ce(me=>re(me))}I.runAndSubscribe=z;function Y(ce,re){let $e=null;function me(Pe){$e?.dispose(),$e=new s.$Sc,re(Pe,$e)}me(void 0);const ye=ce(Pe=>me(Pe));return(0,s.$Rc)(()=>{ye.dispose(),$e?.dispose()})}I.runAndSubscribeWithStore=Y;class N{constructor(re,$e){this._observable=re,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{re.addObserver(this)},onDidRemoveLastListener:()=>{re.removeObserver(this)}};$e||E(me),this.emitter=new g(me),$e&&$e.add(this.emitter)}beginUpdate(re){this.f++}handlePossibleChange(re){}handleChange(re,$e){this.g=!0}endUpdate(re){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function B(ce,re){return new N(ce,re).emitter.event}I.fromObservable=B;function _(ce){return(re,$e,me)=>{let ye=0,Pe=!1;const Le={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ce.reportChanges(),Pe&&(Pe=!1,re.call($e)))},handlePossibleChange(){},handleChange(){Pe=!0}};ce.addObserver(Le),ce.reportChanges();const ke={dispose(){ce.removeObserver(Le)}};return me instanceof s.$Sc?me.add(ke):Array.isArray(me)&&me.push(ke),ke}}I.fromObservableLight=_})(l||(e.Event=l={}));class p{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${p.f++}`,p.all.add(this)}start(E){this.g=new D.$Qd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Sd=p;let k=-1;function v(I){const E=k;return k=I,{dispose(){k=E}}}e.$Td=v;class u{constructor(E,C=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=C,this.g=0}dispose(){this.f?.clear()}check(E,C){const j=this.threshold;if(j<=0||C<j)return;this.f||(this.f=new Map);const T=this.f.get(E.value)||0;if(this.f.set(E.value,T+1),this.g-=1,this.g<=0){this.g=j*.5;let F,G=0;for(const[J,le]of this.f)(!F||G<le)&&(F=J,G=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${G}):`),console.warn(F)}return()=>{const F=this.f.get(E.value)||0;this.f.set(E.value,F-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class ${constructor(E){this.value=E,this.id=b++}}const d=2,h=(I,E)=>{if(I instanceof $)E(I);else for(let C=0;C<I.length;C++){const j=I[C];j&&E(j)}};class g{constructor(E){this.w=0,this.f=E,this.g=k>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const E=this.t;queueMicrotask(()=>{h(E,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,C,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;C&&(E=E.bind(C));const T=new $(E);let F,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=y.create(),F=this.g.check(T.stack,this.w+1)),S&&(T.stack=G??y.create()),this.t?this.t instanceof $?(this.u??=new c,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,s.$Rc)(()=>{F?.(),this.x(T)});return j instanceof s.$Sc?j.add(J):Array.isArray(j)&&j.push(J),J},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,j=C.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[j]=void 0;const T=this.u.current===this;if(this.w*d<=C.length){let F=0;for(let G=0;G<C.length;G++)C[G]?C[F++]=C[G]:T&&(this.u.end--,F<this.u.i&&this.u.i--);C.length=F}}y(E,C){if(!E)return;const j=this.f?.onListenerError||P.$1;if(!j){E.value(C);return}try{E.value(C)}catch(T){j(T)}}z(E){const C=E.current.t;for(;E.i<E.end;)this.y(C[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,E);else{const C=this.u;C.enqueue(this,E,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Ud=g;const w=()=>new c;e.$Vd=w;class c{constructor(){this.i=-1,this.end=0}enqueue(E,C,j){this.i=0,this.end=j,this.current=E,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends g{async fireAsync(E,C,j){if(this.t)for(this.h||(this.h=new M.$4c),h(this.t,T=>this.h.push([T.value,E]));this.h.size>0&&!C.isCancellationRequested;){const[T,F]=this.h.shift(),G=[],J={...F,token:C,waitUntil:le=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");j&&(le=j(le,T)),G.push(le)}};try{T(J)}catch(le){(0,P.$1)(le);continue}Object.freeze(G),await Promise.allSettled(G).then(le=>{for(const se of le)se.status==="rejected"&&(0,P.$1)(se.reason)})}}}e.$Wd=t;class o extends g{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Xd=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Yd=r;class i extends g{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$Zd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new g({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const C={event:E,listener:null};this.h.push(C),this.g&&this.m(C);const j=()=>{this.g&&this.o(C);const T=this.h.indexOf(C);this.h.splice(T,1)};return(0,s.$Rc)((0,A.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(C=>this.f.fire(C))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$1d=n;class a{constructor(E,C,j,T){this.f=new s.$Sc;const F=this.f.add(new n),G=this.f.add(new s.$3c);function J(le){G.set(le,F.add(T(le)))}for(const le of E)J(le);this.f.add(C(le=>{J(le)})),this.f.add(j(le=>{G.deleteAndDispose(le)})),this.event=F.event}dispose(){this.f.dispose()}}e.$2d=a;class m{constructor(){this.f=[]}wrapEvent(E){return(C,j,T)=>E(F=>{const G=this.f[this.f.length-1];G?G.push(()=>C.call(j,F)):C.call(j,F)},void 0,T)}bufferEvents(E){const C=[];this.f.push(C);const j=E();return this.f.pop(),C.forEach(T=>T()),j}}e.$3d=m;class O{constructor(){this.f=!1,this.g=l.None,this.h=s.$Tc.None,this.j=new g({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$4d=O}),define(oe[23],ae([0,1,3]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.CancellationToken=void 0;const A=Object.freeze(function(S,f){const l=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(l)}}});var s;(function(S){function f(l){return l===S.None||l===S.Cancelled||l instanceof M?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new P.$Ud),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$5d=D}),define(oe[142],ae([0,1,23]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.$De=void 0;class A{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$5d,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$De=A;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$Ee=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$Fe=M}),define(oe[63],ae([0,1,14,2]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=void 0;function s(w){const c=w;return c?typeof c.read=="function":!1}e.$6d=s;function M(w){const c=w;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$7d=M;function D(w){const c=w;return c?M(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$8d=D;function S(w,c){return new f(w,c)}e.$9d=S;class f{constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,P.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let o;switch(c){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(w,c){const t=[];let o;for(;(o=w.read())!==null;)t.push(o);return c(t)}e.$0d=l;function p(w,c,t){const o=[];let r;for(;(r=w.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return w.read()}}}e.$$d=p;function k(w,c){return new Promise((t,o)=>{const r=[];v(w,{onData:i=>{c&&r.push(i)},onError:i=>{c?o(i):t(void 0)},onEnd:()=>{t(c?c(r):void 0)}})})}e.$_d=k;function v(w,c,t){w.on("error",o=>{t?.isCancellationRequested||c.onError(o)}),w.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),w.on("data",o=>{t?.isCancellationRequested||c.onData(o)})}e.$ae=v;function u(w,c){return new Promise((t,o)=>{const r=new A.$Sc,i=[],n=O=>{if(i.push(O),i.length>c)return r.dispose(),w.pause(),t({stream:w,buffer:i,ended:!1})},a=O=>(r.dispose(),o(O)),m=()=>(r.dispose(),t({stream:w,buffer:i,ended:!0}));r.add((0,A.$Rc)(()=>w.removeListener("error",a))),w.on("error",a),r.add((0,A.$Rc)(()=>w.removeListener("end",m))),w.on("end",m),r.add((0,A.$Rc)(()=>w.removeListener("data",n))),w.on("data",n)})}e.$be=u;function y(w,c){const t=S(c);return t.end(w),t}e.$ce=y;function b(){const w=S(()=>{throw new Error("not supported")});return w.end(),w}e.$de=b;function $(w){let c=!1;return{read:()=>c?null:(c=!0,w)}}e.$ee=$;function d(w,c,t){const o=S(t);return v(w,{onData:r=>o.write(c.data(r)),onError:r=>o.error(c.error?c.error(r):r),onEnd:()=>o.end()}),o}e.$fe=d;function h(w,c,t){let o=!1;return{read:()=>{const r=c.read();return o?r:(o=!0,r!==null?t([w,r]):w)}}}e.$ge=h;function g(w,c,t){let o=!1;const r=S(t);return v(c,{onData:i=>o?r.write(i):(o=!0,r.write(t([w,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(w)),r.end()}}),r}e.$he=g}),define(oe[17],ae([0,1,62,63]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;const s=typeof Buffer<"u",M=new P.$V(()=>new Uint8Array(256));let D,S;class f{static alloc(C){return s?new f(Buffer.allocUnsafe(C)):new f(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new f(C)}static fromString(C,j){return!(j?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(C)):(D||(D=new TextEncoder),new f(D.encode(C)))}static fromByteArray(C){const j=f.alloc(C.length);for(let T=0,F=C.length;T<F;T++)j.buffer[T]=C[T];return j}static concat(C,j){if(typeof j>"u"){j=0;for(let G=0,J=C.length;G<J;G++)j+=C[G].byteLength}const T=f.alloc(j);let F=0;for(let G=0,J=C.length;G<J;G++){const le=C[G];T.set(le,F),F+=le.byteLength}return T}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=f.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(C,j){return new f(this.buffer.subarray(C,j))}set(C,j){if(C instanceof f)this.buffer.set(C.buffer,j);else if(C instanceof Uint8Array)this.buffer.set(C,j);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),j);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return v(this.buffer,C)}writeUInt32BE(C,j){u(this.buffer,C,j)}readUInt32LE(C){return y(this.buffer,C)}writeUInt32LE(C,j){b(this.buffer,C,j)}readUInt8(C){return $(this.buffer,C)}writeUInt8(C,j){d(this.buffer,C,j)}indexOf(C,j=0){return l(this.buffer,C instanceof f?C.buffer:C,j)}}e.$ie=f;function l(E,C,j=0){const T=C.byteLength,F=E.byteLength;if(T===0)return 0;if(T===1)return E.indexOf(C[0]);if(T>F-j)return-1;const G=M.value;G.fill(C.length);for(let ue=0;ue<C.length;ue++)G[C[ue]]=C.length-ue-1;let J=j+C.length-1,le=J,se=-1;for(;J<F;)if(E[J]===C[le]){if(le===0){se=J;break}J--,le--}else J+=Math.max(C.length-le,G[E[J]]),le=C.length-1;return se}e.$je=l;function p(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0}e.$ke=p;function k(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255}e.$le=k;function v(E,C){return E[C]*2**24+E[C+1]*2**16+E[C+2]*2**8+E[C+3]}e.$me=v;function u(E,C,j){E[j+3]=C,C=C>>>8,E[j+2]=C,C=C>>>8,E[j+1]=C,C=C>>>8,E[j]=C}e.$ne=u;function y(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0|E[C+2]<<16>>>0|E[C+3]<<24>>>0}e.$oe=y;function b(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255,C=C>>>8,E[j+2]=C&255,C=C>>>8,E[j+3]=C&255}e.$pe=b;function $(E,C){return E[C]}e.$qe=$;function d(E,C,j){E[j]=C}e.$re=d;function h(E){return A.$0d(E,C=>f.concat(C))}e.$se=h;function g(E){return A.$ee(E)}e.$te=g;function w(E){return A.$_d(E,C=>f.concat(C))}e.$ue=w;async function c(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await w(E.stream)])}e.$ve=c;function t(E){return A.$ce(E,C=>f.concat(C))}e.$we=t;function o(E){return A.$fe(E,{data:C=>typeof C=="string"?f.fromString(C):f.wrap(C)},C=>f.concat(C))}e.$xe=o;function r(E){return A.$9d(C=>f.concat(C),E)}e.$ye=r;function i(E,C){return A.$ge(E,C,j=>f.concat(j))}e.$ze=i;function n(E,C){return A.$he(E,C,j=>f.concat(j))}e.$Ae=n;function a(E){let C=0,j=0,T=0;const F=new Uint8Array(Math.floor(E.length/4*3)),G=le=>{switch(j){case 3:F[T++]=C|le,j=0;break;case 2:F[T++]=C|le>>>2,C=le<<6,j=3;break;case 1:F[T++]=C|le>>>4,C=le<<4,j=2;break;default:C=le<<2,j=1}};for(let le=0;le<E.length;le++){const se=E.charCodeAt(le);if(se>=65&&se<=90)G(se-65);else if(se>=97&&se<=122)G(se-97+26);else if(se>=48&&se<=57)G(se-48+52);else if(se===43||se===45)G(62);else if(se===47||se===95)G(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const J=T;for(;j>0;)G(0);return f.wrap(F).slice(0,J)}e.$Be=a;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},C=!0,j=!1){const T=j?O:m;let F="";const G=E.byteLength%3;let J=0;for(;J<E.byteLength-G;J+=3){const le=E[J+0],se=E[J+1],ue=E[J+2];F+=T[le>>>2],F+=T[(le<<4|se>>>4)&63],F+=T[(se<<2|ue>>>6)&63],F+=T[ue&63]}if(G===1){const le=E[J+0];F+=T[le>>>2],F+=T[le<<4&63],C&&(F+="==")}else if(G===2){const le=E[J+0],se=E[J+1];F+=T[le>>>2],F+=T[(le<<4|se>>>4)&63],F+=T[se<<2&63],C&&(F+="=")}return F}e.$Ce=I}),define(oe[25],ae([0,1,142,62]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gf=e.$Ff=e.$Ef=e.$Df=e.GraphemeBreakType=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Ie=s;const M=/{(\d+)}/g;function D(ie,...de){return de.length===0?ie:ie.replace(M,function(be,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=de.length?be:de[ve]})}e.$Je=D;const S=/{([^}]+)}/g;function f(ie,de){return Object.keys(de).length===0?ie:ie.replace(S,(be,Se)=>de[Se]??be)}e.$Ke=f;function l(ie){return ie.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}e.$Le=l;function p(ie){return ie.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$Me=p;function k(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ne=k;function v(ie,de){let be=0;const Se=de.charCodeAt(0);for(let ve=ie.length-1;ve>=0;ve--)ie.charCodeAt(ve)===Se&&be++;return be}e.$Oe=v;function u(ie,de,be="\u2026"){return ie.length<=de?ie:`${ie.substr(0,de)}${be}`}e.$Pe=u;function y(ie,de,be="\u2026"){if(ie.length<=de)return ie;const Se=Math.ceil(de/2)-be.length/2,ve=Math.floor(de/2)-be.length/2;return`${ie.substr(0,Se)}${be}${ie.substr(ie.length-ve)}`}e.$Qe=y;function b(ie,de=" "){const be=$(ie,de);return d(be,de)}e.$Re=b;function $(ie,de){if(!ie||!de)return ie;const be=de.length;if(be===0||ie.length===0)return ie;let Se=0;for(;ie.indexOf(de,Se)===Se;)Se=Se+be;return ie.substring(Se)}e.$Se=$;function d(ie,de){if(!ie||!de)return ie;const be=de.length,Se=ie.length;if(be===0||Se===0)return ie;let ve=Se,Ae=-1;for(;Ae=ie.lastIndexOf(de,ve-1),!(Ae===-1||Ae+be!==ve);){if(Ae===0)return"";ve=Ae}return ie.substring(0,ve)}e.$Te=d;function h(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ue=h;function g(ie){return ie.replace(/\*/g,"")}e.$Ve=g;function w(ie,de,be={}){if(!ie)throw new Error("Cannot create regex from empty string");de||(ie=k(ie)),be.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Se="";return be.global&&(Se+="g"),be.matchCase||(Se+="i"),be.multiline&&(Se+="m"),be.unicode&&(Se+="u"),new RegExp(ie,Se)}e.$We=w;function c(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Xe=c;function t(ie){return ie.split(/\r\n|\r|\n/)}e.$Ye=t;function o(ie){for(let de=0,be=ie.length;de<be;de++){const Se=ie.charCodeAt(de);if(Se!==32&&Se!==9)return de}return-1}e.$Ze=o;function r(ie,de=0,be=ie.length){for(let Se=de;Se<be;Se++){const ve=ie.charCodeAt(Se);if(ve!==32&&ve!==9)return ie.substring(de,Se)}return ie.substring(de,be)}e.$1e=r;function i(ie,de=ie.length-1){for(let be=de;be>=0;be--){const Se=ie.charCodeAt(be);if(Se!==32&&Se!==9)return be}return-1}e.$2e=i;function n(ie,de,be){const Se=[];let ve=0;for(const Ae of ie.matchAll(de)){if(Se.push(ie.slice(ve,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");ve=Ae.index+Ae[0].length,Se.push(be(Ae[0],...Ae.slice(1),Ae.index,ie,Ae.groups))}return Se.push(ie.slice(ve)),Promise.all(Se).then(Ae=>Ae.join(""))}e.$3e=n;function a(ie,de){return ie<de?-1:ie>de?1:0}e.$4e=a;function m(ie,de,be=0,Se=ie.length,ve=0,Ae=de.length){for(;be<Se&&ve<Ae;be++,ve++){const Qe=ie.charCodeAt(be),xe=de.charCodeAt(ve);if(Qe<xe)return-1;if(Qe>xe)return 1}const We=Se-be,qe=Ae-ve;return We<qe?-1:We>qe?1:0}e.$5e=m;function O(ie,de){return I(ie,de,0,ie.length,0,de.length)}e.$6e=O;function I(ie,de,be=0,Se=ie.length,ve=0,Ae=de.length){for(;be<Se&&ve<Ae;be++,ve++){let Qe=ie.charCodeAt(be),xe=de.charCodeAt(ve);if(Qe===xe)continue;if(Qe>=128||xe>=128)return m(ie.toLowerCase(),de.toLowerCase(),be,Se,ve,Ae);C(Qe)&&(Qe-=32),C(xe)&&(xe-=32);const Xe=Qe-xe;if(Xe!==0)return Xe}const We=Se-be,qe=Ae-ve;return We<qe?-1:We>qe?1:0}e.$7e=I;function E(ie){return ie>=48&&ie<=57}e.$8e=E;function C(ie){return ie>=97&&ie<=122}e.$9e=C;function j(ie){return ie>=65&&ie<=90}e.$0e=j;function T(ie,de){return ie.length===de.length&&I(ie,de)===0}e.$$e=T;function F(ie,de){const be=de.length;return de.length>ie.length?!1:I(ie,de,0,be)===0}e.$_e=F;function G(ie,de){const be=Math.min(ie.length,de.length);let Se;for(Se=0;Se<be;Se++)if(ie.charCodeAt(Se)!==de.charCodeAt(Se))return Se;return be}e.$af=G;function J(ie,de){const be=Math.min(ie.length,de.length);let Se;const ve=ie.length-1,Ae=de.length-1;for(Se=0;Se<be;Se++)if(ie.charCodeAt(ve-Se)!==de.charCodeAt(Ae-Se))return Se;return be}e.$bf=J;function le(ie){return 55296<=ie&&ie<=56319}e.$cf=le;function se(ie){return 56320<=ie&&ie<=57343}e.$df=se;function ue(ie,de){return(ie-55296<<10)+(de-56320)+65536}e.$ef=ue;function Z(ie,de,be){const Se=ie.charCodeAt(be);if(le(Se)&&be+1<de){const ve=ie.charCodeAt(be+1);if(se(ve))return ue(Se,ve)}return Se}e.$ff=Z;function X(ie,de){const be=ie.charCodeAt(de-1);if(se(be)&&de>1){const Se=ie.charCodeAt(de-2);if(le(Se))return ue(Se,be)}return be}class H{get offset(){return this.e}constructor(de,be=0){this.c=de,this.d=de.length,this.e=be}setOffset(de){this.e=de}prevCodePoint(){const de=X(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=Z(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$gf=H;class L{get offset(){return this.c.offset}constructor(de,be=0){this.c=new H(de,be)}nextGraphemeLength(){const de=Ie.getInstance(),be=this.c,Se=be.offset;let ve=de.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Ae=be.offset,We=de.getGraphemeBreakType(be.nextCodePoint());if(fe(ve,We)){be.setOffset(Ae);break}ve=We}return be.offset-Se}prevGraphemeLength(){const de=Ie.getInstance(),be=this.c,Se=be.offset;let ve=de.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Ae=be.offset,We=de.getGraphemeBreakType(be.prevCodePoint());if(fe(We,ve)){be.setOffset(Ae);break}ve=We}return Se-be.offset}eol(){return this.c.eol()}}e.$hf=L;function W(ie,de){return new L(ie,de).nextGraphemeLength()}e.$if=W;function V(ie,de){return new L(ie,de).prevGraphemeLength()}e.$jf=V;function q(ie,de){de>0&&se(ie.charCodeAt(de))&&de--;const be=de+W(ie,de);return[be-V(ie,be),be]}e.$kf=q;function te(ie){const de=new L(ie);let be=0;for(;!de.eol();)be++,de.nextGraphemeLength();return be}e.$lf=te;let he;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(ie){return he||(he=K()),he.test(ie)}e.$mf=R;const U=/^[\t\n\r\x20-\x7E]*$/;function x(ie){return U.test(ie)}e.$nf=x,e.$of=/[\u2028\u2029]/;function z(ie){return e.$of.test(ie)}e.$pf=z;function Y(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$qf=Y;function N(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$rf=N;function B(ie,de,be=""){const Se=ie.trimStart();if(Se.length<de)return Se;const ve=/\b/g;let Ae=0;for(;ve.test(Se)&&!(Se.length-ve.lastIndex<de);)Ae=ve.lastIndex,ve.lastIndex+=1;return Ae===0?Se:be+Se.substring(Ae).trimStart()}e.$sf=B;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function re(ie){return ie&&(ie=ie.replace(_,"").replace(ce,"")),ie}e.$tf=re,e.$uf=String.fromCharCode(65279);function $e(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$vf=$e;function me(ie){return $e(ie)?ie.substr(1):ie}e.$wf=me;function ye(ie,de){if(!ie||!de||ie.length<de.length)return!1;const be=de.length,Se=ie.toLowerCase();let ve=0,Ae=-1;for(;ve<be;){const We=Se.indexOf(de[ve],Ae+1);if(We<0)return!1;Ae=We,ve++}return!0}e.$xf=ye;function Pe(ie,de=!1){return ie?(de&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$yf=Pe;function Le(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$zf=Le;function ke(ie,de=1){if(de===0)return"";let be=-1;do be=ie.indexOf(`
`,be+1),de--;while(de>0&&be>=0);return be===-1?ie:(ie[be-1]==="\r"&&be--,ie.substr(0,be))}e.$Af=ke;function pe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$Bf=pe;function ee(ie){return Ie.getInstance().getGraphemeBreakType(ie)}e.$Cf=ee;function fe(ie,de){return ie===0?de!==5&&de!==7:ie===2&&de===3?!1:ie===4||ie===2||ie===3||de===4||de===2||de===3?!0:!(ie===8&&(de===8||de===9||de===11||de===12)||(ie===11||ie===9)&&(de===9||de===10)||(ie===12||ie===10)&&de===10||de===5||de===13||de===7||ie===1||ie===13&&de===14||ie===6&&de===6)}var ge;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Me()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const be=this.d,Se=be.length/3;let ve=1;for(;ve<=Se;)if(de<be[3*ve])ve=2*ve;else if(de>be[3*ve+1])ve=2*ve+1;else return be[3*ve+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(ie,de){if(ie===0)return 0;const be=je(ie,de);if(be!==void 0)return be;const Se=new H(de,ie);return Se.prevCodePoint(),Se.offset}e.$Df=Te;function je(ie,de){const be=new H(de,ie);let Se=be.prevCodePoint();for(;Je(Se)||Se===65039||Se===8419;){if(be.offset===0)return;Se=be.prevCodePoint()}if(!N(Se))return;let ve=be.offset;return ve>0&&be.prevCodePoint()===8205&&(ve=be.offset),ve}function Je(ie){return 127995<=ie&&ie<=127999}var Be;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$Ef="\xA0";class He{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$Ee(de=>{function be(Xe){const Ye=new Map;for(let nt=0;nt<Xe.length;nt+=2)Ye.set(Xe[nt],Xe[nt+1]);return Ye}function Se(Xe,Ye){const nt=new Map(Xe);for(const[st,ot]of Ye)nt.set(st,ot);return nt}function ve(Xe,Ye){if(!Xe)return Ye;const nt=new Map;for(const[st,ot]of Xe)Ye.has(st)&&nt.set(st,ot);return nt}const Ae=this.c.value;let We=de.filter(Xe=>!Xe.startsWith("_")&&Xe in Ae);We.length===0&&(We=["_default"]);let qe;for(const Xe of We){const Ye=be(Ae[Xe]);qe=ve(qe,Ye)}const Qe=be(Ae._common),xe=Se(Qe,qe);return new He(xe)})}static getInstance(de){return He.d.get(Array.from(de))}static{this.e=new A.$V(()=>Object.keys(He.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return He.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Ff=He;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(de){return Ve.e().has(de)}static get codePoints(){return Ve.e()}}e.$Gf=Ve}),define(oe[45],ae([0,1,25]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=void 0;function A(d){return s(d,0)}e.$Si=A;function s(d,h){switch(typeof d){case"object":return d===null?M(349,h):Array.isArray(d)?f(d,h):l(d,h);case"string":return S(d,h);case"boolean":return D(d,h);case"number":return M(d,h);case"undefined":return M(937,h);default:return M(617,h)}}e.$Ti=s;function M(d,h){return(h<<5)-h+d|0}e.$Ui=M;function D(d,h){return M(d?433:863,h)}function S(d,h){h=M(149417,h);for(let g=0,w=d.length;g<w;g++)h=M(d.charCodeAt(g),h);return h}e.$Vi=S;function f(d,h){return h=M(104579,h),d.reduce((g,w)=>s(w,g),h)}function l(d,h){return h=M(181387,h),Object.keys(d).sort().reduce((g,w)=>(g=S(w,g),s(d[w],g)),h)}class p{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Wi=p;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function v(d,h,g=32){const w=g-h,c=~((1<<w)-1);return(d<<h|(c&d)>>>w)>>>0}function u(d,h=0,g=d.byteLength,w=0){for(let c=0;c<g;c++)d[h+c]=w}function y(d,h,g="0"){for(;d.length<h;)d=g+d;return d}function b(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(g=>g.toString(16).padStart(2,"0")).join(""):y((d>>>0).toString(16),h/4)}e.$Xi=b;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const g=h.length;if(g===0)return;const w=this.p;let c=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=h.charCodeAt(0),r=0);;){let i=o;if(P.$cf(o))if(r+1<g){const n=h.charCodeAt(r+1);P.$df(n)?(r++,i=P.$ef(o,n)):i=65533}else{t=o;break}else P.$df(o)&&(i=65533);if(c=this.w(w,c,i),r++,r<g)o=h.charCodeAt(r);else break}this.r=c,this.u=t}w(h,g,w){return w<128?h[g++]=w:w<2048?(h[g++]=192|(w&1984)>>>6,h[g++]=128|(w&63)>>>0):w<65536?(h[g++]=224|(w&61440)>>>12,h[g++]=128|(w&4032)>>>6,h[g++]=128|(w&63)>>>0):(h[g++]=240|(w&1835008)>>>18,h[g++]=128|(w&258048)>>>12,h[g++]=128|(w&4032)>>>6,h[g++]=128|(w&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=$.g,g=this.q;for(let m=0;m<64;m+=4)h.setUint32(m,g.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)h.setUint32(m,v(h.getUint32(m-12,!1)^h.getUint32(m-32,!1)^h.getUint32(m-56,!1)^h.getUint32(m-64,!1),1),!1);let w=this.h,c=this.l,t=this.m,o=this.n,r=this.o,i,n,a;for(let m=0;m<80;m++)m<20?(i=c&t|~c&o,n=1518500249):m<40?(i=c^t^o,n=1859775393):m<60?(i=c&t|c&o|t&o,n=2400959708):(i=c^t^o,n=3395469782),a=v(w,5)+i+r+n+h.getUint32(m*4,!1)&4294967295,r=o,o=t,t=v(c,30),c=w,w=a;this.h=this.h+w&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Yi=$}),define(oe[74],ae([0,1,25]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const M="error",D="warning",S="warn",f="info",l="ignore";function p(v){return v?P.$$e(M,v)?s.Error:P.$$e(D,v)||P.$$e(S,v)?s.Warning:P.$$e(f,v)?s.Info:s.Ignore:s.Ignore}s.fromValue=p;function k(v){switch(v){case s.Error:return M;case s.Warning:return D;case s.Info:return f;default:return l}}s.toString=k}(A||(A={})),e.default=A}),define(oe[143],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Rd=Symbol("MicrotaskDelay")}),define(oe[58],ae([0,1,22,25]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class s{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const y=u.charCodeAt(0),b=this.b.charCodeAt(this.c);return y-b}value(){return this.b[this.c]}}e.$7h=s;class M{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,A.$5e)(u,this.b,0,u.length,this.c,this.d):(0,A.$7e)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$8h=M;class D{constructor(u=!0,y=!0){this.f=u,this.g=y}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let y=u.length-1;y>=0;y--,this.c--){const b=this.b.charCodeAt(y);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,A.$5e)(u,this.b,0,u.length,this.d,this.e):(0,A.$7e)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$9h=D;var S;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(u,y){this.f=u,this.g=y,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,A.$6e)(u,this.c.scheme);if(this.d[this.e]===2)return(0,A.$6e)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,A.$4e)(u,this.c.query);if(this.d[this.e]===5)return(0,A.$4e)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$0h=f;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(p||(p={}));class k{static forUris(u=()=>!1,y=()=>!1){return new k(new f(u,y))}static forPaths(u=!1){return new k(new D(void 0,!u))}static forStrings(){return new k(new s)}static forConfigKeys(){return new k(new M)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,y){if(y){const b=y.slice(0);(0,P.$Xb)(b);for(const $ of b)this.set($,u)}else{const b=u.slice(0);(0,P.$Xb)(b);for(const $ of b)this.set($[0],$[1])}}set(u,y){const b=this.b.reset(u);let $;this.c||(this.c=new l,this.c.segment=b.value());const d=[];for($=this.c;;){const g=b.cmp($.segment);if(g>0)$.left||($.left=new l,$.left.segment=b.value()),d.push([-1,$]),$=$.left;else if(g<0)$.right||($.right=new l,$.right.segment=b.value()),d.push([1,$]),$=$.right;else if(b.hasNext())b.next(),$.mid||($.mid=new l,$.mid.segment=b.value()),d.push([0,$]),$=$.mid;else break}const h=$.value;$.value=y,$.key=u;for(let g=d.length-1;g>=0;g--){const w=d[g][1];w.updateHeight();const c=w.balanceFactor();if(c<-1||c>1){const t=d[g][0],o=d[g+1][0];if(t===1&&o===1)d[g][1]=w.rotateLeft();else if(t===-1&&o===-1)d[g][1]=w.rotateRight();else if(t===1&&o===-1)w.right=d[g+1][1]=d[g+1][1].rotateRight(),d[g][1]=w.rotateLeft();else if(t===-1&&o===1)w.left=d[g+1][1]=d[g+1][1].rotateLeft(),d[g][1]=w.rotateRight();else throw new Error;if(g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this.c=d[0][1]}}return h}get(u){return this.d(u)?.value}d(u){const y=this.b.reset(u);let b=this.c;for(;b;){const $=y.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(y.hasNext())y.next(),b=b.mid;else break}return b}has(u){const y=this.d(u);return!(y?.value===void 0&&y?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,y){const b=this.b.reset(u),$=[];let d=this.c;for(;d;){const h=b.cmp(d.segment);if(h>0)$.push([-1,d]),d=d.left;else if(h<0)$.push([1,d]),d=d.right;else if(b.hasNext())b.next(),$.push([0,d]),d=d.mid;else break}if(d){if(y?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this.f(d.right);if(h.key){const{key:g,value:w,segment:c}=h;this.e(h.key,!1),d.key=g,d.value=w,d.segment=c}}else{const h=d.left??d.right;if($.length>0){const[g,w]=$[$.length-1];switch(g){case-1:w.left=h;break;case 0:w.mid=h;break;case 1:w.right=h;break}}else this.c=h}for(let h=$.length-1;h>=0;h--){const g=$[h][1];g.updateHeight();const w=g.balanceFactor();if(w>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),$[h][1]=g.rotateLeft()):w<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),$[h][1]=g.rotateRight()),h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const y=this.b.reset(u);let b=this.c,$;for(;b;){const d=y.cmp(b.segment);if(d>0)b=b.left;else if(d<0)b=b.right;else if(y.hasNext())y.next(),$=b.value||$,b=b.mid;else break}return b&&b.value||$}findSuperstr(u){return this.g(u,!1)}g(u,y){const b=this.b.reset(u);let $=this.c;for(;$;){const d=b.cmp($.segment);if(d>0)$=$.left;else if(d<0)$=$.right;else if(b.hasNext())b.next(),$=$.mid;else return $.mid?this.h($.mid):y?$.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[y,b]of this)u(b,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const y=[];return this.j(u,y),y[Symbol.iterator]()}j(u,y){u&&(u.left&&this.j(u.left,y),u.value&&y.push([u.key,u.value]),u.mid&&this.j(u.mid,y),u.right&&this.j(u.right,y))}_isBalanced(){const u=y=>{if(!y)return!0;const b=y.balanceFactor();return b<-1||b>1?!1:u(y.left)&&u(y.right)};return u(this.c)}}e.$$h=k}),define(oe[12],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=void 0;function P(c){return typeof c=="string"}e.$Hf=P;function A(c){return Array.isArray(c)&&c.every(t=>P(t))}e.$If=A;function s(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Jf=s;function M(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Kf=M;function D(c){return typeof c=="number"&&!isNaN(c)}e.$Lf=D;function S(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Mf=S;function f(c){return c===!0||c===!1}e.$Nf=f;function l(c){return typeof c>"u"}e.$Of=l;function p(c){return!k(c)}e.$Pf=p;function k(c){return l(c)||c===null}e.$Qf=k;function v(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Rf=v;function u(c){if(k(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Sf=u;function y(...c){const t=[];for(let o=0;o<c.length;o++){const r=c[o];if(k(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$Tf=y;const b=Object.prototype.hasOwnProperty;function $(c){if(!s(c))return!1;for(const t in c)if(b.call(c,t))return!1;return!0}e.$Uf=$;function d(c){return typeof c=="function"}e.$Vf=d;function h(...c){return c.length>0&&c.every(d)}e.$Wf=h;function g(c,t){const o=Math.min(c.length,t.length);for(let r=0;r<o;r++)w(c[r],t[r])}e.$Xf=g;function w(c,t){if(P(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(c instanceof t)return}catch{}if(!k(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Yf=w}),define(oe[75],ae([0,1,12]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=void 0;const A=Object.create(null);function s(S,f){if((0,P.$Hf)(f)){const l=A[f];if(l===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=l}return A[S]=f,{id:S}}function M(){return A}e.$9j=M;function D(){return Object.values(e.$$j)}e.$0j=D,e.$$j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(oe[35],ae([0,1,12]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([g,w])=>{h[g]=w&&typeof w=="object"?A(w):w}),h}e.$un=A;function s(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const w in g)if(M.call(g,w)){const c=g[w];typeof c=="object"&&!Object.isFrozen(c)&&!(0,P.$Kf)(c)&&h.push(c)}}return d}e.$vn=s;const M=Object.prototype.hasOwnProperty;function D(d,h){return S(d,h,new Set)}e.$wn=D;function S(d,h,g){if((0,P.$Qf)(d))return d;const w=h(d);if(typeof w<"u")return w;if(Array.isArray(d)){const c=[];for(const t of d)c.push(S(t,h,g));return c}if((0,P.$Jf)(d)){if(g.has(d))throw new Error("Cannot clone recursive data-structure");g.add(d);const c={};for(const t in d)M.call(d,t)&&(c[t]=S(d[t],h,g));return g.delete(d),c}return d}function f(d,h,g=!0){return(0,P.$Jf)(d)?((0,P.$Jf)(h)&&Object.keys(h).forEach(w=>{w in d?g&&((0,P.$Jf)(d[w])&&(0,P.$Jf)(h[w])?f(d[w],h[w],g):d[w]=h[w]):d[w]=h[w]}),d):h}e.$xn=f;function l(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let g,w;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(g=0;g<d.length;g++)if(!l(d[g],h[g]))return!1}else{const c=[];for(w in d)c.push(w);c.sort();const t=[];for(w in h)t.push(w);if(t.sort(),!l(c,t))return!1;for(g=0;g<c.length;g++)if(!l(d[c[g]],h[c[g]]))return!1}return!0}e.$yn=l;function p(d){const h=new Set;return JSON.stringify(d,(g,w)=>{if((0,P.$Jf)(w)||Array.isArray(w)){if(h.has(w))return"[Circular]";h.add(w)}return w})}e.$zn=p;function k(d,h){const g=Object.create(null);return!d||!h||Object.keys(h).forEach(c=>{const t=d[c],o=h[c];l(t,o)||(g[c]=o)}),g}e.$An=k;function v(d,h){const g=h.toLowerCase(),w=Object.keys(d).find(c=>c.toLowerCase()===g);return w?d[w]:d[h]}e.$Bn=v;function u(d,h){const g=Object.create(null);for(const[w,c]of Object.entries(d))h(w,c)&&(g[w]=c);return g}e.$Cn=u;function y(d){let h=[];for(;Object.prototype!==d;)h=h.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return h}e.$Dn=y;function b(d){const h=[];for(const g of y(d))typeof d[g]=="function"&&h.push(g);return h}e.$En=b;function $(d,h){const g=c=>function(){const t=Array.prototype.slice.call(arguments,0);return h(c,t)},w={};for(const c of d)w[c]=g(c);return w}e.$Fn=$}),define(oe[103],ae([0,1,75]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$_j=e.ThemeColor=void 0;var A;(function(D){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=S})(A||(e.ThemeColor=A={}));function s(D){return{id:D}}e.$_j=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(h){const g=S.exec(h.id);if(!g)return f(P.$$j.error);const[,w,c]=g,t=["codicon","codicon-"+w];return c&&t.push("codicon-modifier-"+c.substring(1)),t}D.asClassNameArray=f;function l(h){return f(h).join(" ")}D.asClassName=l;function p(h){return"."+f(h).join(".")}D.asCSSSelector=p;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||A.isThemeColor(h.color))}D.isThemeIcon=k;const v=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function u(h){const g=v.exec(h);if(!g)return;const[,w]=g;return{id:w}}D.fromString=u;function y(h){return{id:h}}D.fromId=y;function b(h,g){let w=h.id;const c=w.lastIndexOf("~");return c!==-1&&(w=w.substring(0,c)),g&&(w=`${w}~${g}`),{id:w}}D.modify=b;function $(h){const g=h.id.lastIndexOf("~");if(g!==-1)return h.id.substring(g+1)}D.getModifier=$;function d(h,g){return h.id===g.id&&h.color?.id===g.color?.id}D.isEqual=d})(M||(e.ThemeIcon=M={}))}),define(oe[32],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return P.test(s)}e.$og=A,e.$pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,l="";return l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l}}()}),define(oe[144],ae([0,1,86,46,84]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lU=void 0;async function M(D,S){if(await new Promise((p,k)=>{const v=A.createReadStream(D),u=P.createHash("sha256");v.pipe(u);const y=(0,s.$db)((b,$)=>{v.removeAllListeners(),u.removeAllListeners(),b?k(b):p($)});v.once("error",y),v.once("end",y),u.once("error",y),u.once("data",b=>y(void 0,b.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$lU=M}),define(oe[145],ae([0,1,26]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!A.has(S)}function M(){const D=(0,P.networkInterfaces)();for(const S in D){const f=D[S];if(f){for(const{mac:l}of f)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$8m=M}),define(oe[104],ae([0,1,87]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tg=e.$sg=e.$rg=void 0;function A(S,f,l,p=1){let k=!1;return new Promise(v=>{const u=setTimeout(()=>{if(!k)return k=!0,v(0)},l);s(S,f,p,y=>{if(!k)return k=!0,clearTimeout(u),v(y)})})}e.$rg=A;function s(S,f,l,p){if(f===0)return p(0);const k=new P.Socket;k.once("connect",()=>(D(k),s(S+l,f-1,l,p))),k.once("data",()=>{}),k.once("error",v=>(D(k),v.code!=="ECONNREFUSED"?s(S+l,f-1,l,p):p(S))),k.connect(S,"127.0.0.1")}e.$sg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,f,l,p="127.0.0.1"){let k=!1,v,u=1;const y=P.createServer({pauseOnConnect:!0});function b($,d){k||(k=!0,y.removeAllListeners(),y.close(),v&&clearTimeout(v),d($))}return new Promise($=>{v=setTimeout(()=>{b(0,$)},l),y.on("listening",()=>{b(S,$)}),y.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&u<f?(S++,u++,y.listen(S,p)):b(0,$)}),y.on("close",()=>{b(0,$)}),y.listen(S,p)})}e.$tg=M;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function P(f){const l=new Set;if(Array.isArray(f))for(const p of f)typeof p=="string"&&l.add(p);return Array.from(l)}function A(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const l=e();if(l)if(typeof f=="string")l.add(f.toLowerCase());else for(const p of P(f))s(p)}function M(f){if(typeof f!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let p;for(const k of l){if(f.indexOf(k)!==0)continue;const u=f.indexOf("\\",k.length);if(u===-1)continue;const y=f.substring(k.length,u);if(y){p=y;break}}return p}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[146],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pU=e.$oU=void 0,e.$oU="vscode:contextmenu",e.$pU="vscode:onCloseContextMenu"}),define(oe[147],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wU=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$wU=P}),define(oe[148],ae([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(oe[149],ae([0,1,148]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0;const A=60,s=A*60,M=s*24,D=M*7,S=M*30,f=M*365;function l(k,v,u,y){typeof k!="number"&&(k=k.getTime());const b=Math.round((new Date().getTime()-k)/1e3);if(b<-30)return(0,P.localize)(0,null,l(new Date().getTime()+b*1e3,!1));if(!y&&b<30)return(0,P.localize)(1,null);let $;return b<A?($=b,v?$===1?u?(0,P.localize)(2,null,$):(0,P.localize)(3,null,$):u?(0,P.localize)(4,null,$):(0,P.localize)(5,null,$):$===1?u?(0,P.localize)(6,null,$):(0,P.localize)(7,null,$):u?(0,P.localize)(8,null,$):(0,P.localize)(9,null,$)):b<s?($=Math.floor(b/A),v?$===1?u?(0,P.localize)(10,null,$):(0,P.localize)(11,null,$):u?(0,P.localize)(12,null,$):(0,P.localize)(13,null,$):$===1?u?(0,P.localize)(14,null,$):(0,P.localize)(15,null,$):u?(0,P.localize)(16,null,$):(0,P.localize)(17,null,$)):b<M?($=Math.floor(b/s),v?$===1?u?(0,P.localize)(18,null,$):(0,P.localize)(19,null,$):u?(0,P.localize)(20,null,$):(0,P.localize)(21,null,$):$===1?u?(0,P.localize)(22,null,$):(0,P.localize)(23,null,$):u?(0,P.localize)(24,null,$):(0,P.localize)(25,null,$)):b<D?($=Math.floor(b/M),v?$===1?(0,P.localize)(26,null,$):(0,P.localize)(27,null,$):$===1?(0,P.localize)(28,null,$):(0,P.localize)(29,null,$)):b<S?($=Math.floor(b/D),v?$===1?u?(0,P.localize)(30,null,$):(0,P.localize)(31,null,$):u?(0,P.localize)(32,null,$):(0,P.localize)(33,null,$):$===1?u?(0,P.localize)(34,null,$):(0,P.localize)(35,null,$):u?(0,P.localize)(36,null,$):(0,P.localize)(37,null,$)):b<f?($=Math.floor(b/S),v?$===1?u?(0,P.localize)(38,null,$):(0,P.localize)(39,null,$):u?(0,P.localize)(40,null,$):(0,P.localize)(41,null,$):$===1?u?(0,P.localize)(42,null,$):(0,P.localize)(43,null,$):u?(0,P.localize)(44,null,$):(0,P.localize)(45,null,$)):($=Math.floor(b/f),v?$===1?u?(0,P.localize)(46,null,$):(0,P.localize)(47,null,$):u?(0,P.localize)(48,null,$):(0,P.localize)(49,null,$):$===1?u?(0,P.localize)(50,null,$):(0,P.localize)(51,null,$):u?(0,P.localize)(52,null,$):(0,P.localize)(53,null,$))}e.$um=l;function p(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$vm=p}),define(oe[150],ae([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(oe[51],ae([0,1,22,12,150]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=void 0;function M(k,v){return v&&(k.stack||k.stacktrace)?s.localize(0,null,S(k),D(k.stack)||D(k.stacktrace)):S(k)}function D(k){return Array.isArray(k)?k.join(`
`):k}function S(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?s.localize(1,null,k.message):k.message||s.localize(2,null)}function f(k=null,v=!1){if(!k)return s.localize(3,null);if(Array.isArray(k)){const u=P.$Hb(k),y=f(u[0],v);return u.length>1?s.localize(4,null,y,u.length):y}if(A.$Hf(k))return k;if(k.detail){const u=k.detail;if(u.error)return M(u.error,v);if(u.exception)return M(u.exception,v)}return k.stack?M(k,v):k.message?k.message:s.localize(5,null)}e.$Pi=f;function l(k){const v=k;return v instanceof Error&&Array.isArray(v.actions)}e.$Qi=l;function p(k,v){let u;return typeof k=="string"?u=new Error(k):u=k,u.actions=v,u}e.$Ri=p}),define(oe[151],ae([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(oe[152],ae([0,1,151]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;function A(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$Wp=A}),define(oe[153],ae([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,153]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,s=!1,M=!1,D=!1,S=!1,f=!1,l=!1,p=!1,k=!1,v=!1,u,y=e.$g,b=e.$g,$,d;const h=globalThis;let g;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?g=h.vscode.process:typeof process<"u"&&(g=process);const w=typeof g?.versions?.electron=="string",c=w&&g?.type==="renderer";if(typeof g=="object"){A=g.platform==="win32",s=g.platform==="darwin",M=g.platform==="linux",D=M&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,l=w,k=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$g,y=e.$g;const E=g.env.VSCODE_NLS_CONFIG;if(E)try{const C=JSON.parse(E),j=C.availableLanguages["*"];u=C.locale,b=C.osLocale,y=j||e.$g,$=C._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!c?(d=navigator.userAgent,A=d.indexOf("Windows")>=0,s=d.indexOf("Macintosh")>=0,p=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,f=!0,u=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,y=u,b=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:A?r=3:M&&(r=2),e.$i=A,e.$j=s,e.$k=M,e.$l=D,e.$m=S,e.$n=l,e.$o=f,e.$p=f&&typeof h.importScripts=="function",e.$q=e.$p?h.origin:void 0,e.$r=p,e.$s=v,e.$t=k,e.$u=r,e.$v=d,e.$w=y;var i;(function(E){function C(){return e.$w}E.value=C;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=j;function T(){return e.$w==="en"}E.isDefault=T})(i||(e.Language=i={})),e.$x=u,e.$y=b,e.$z=$,e.$A=typeof h.postMessage=="function"&&!h.importScripts,e.$B=(()=>{if(e.$A){const E=[];h.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let T=0,F=E.length;T<F;T++){const G=E[T];if(G.id===j.data.vscodeScheduleAsyncWork){E.splice(T,1),G.callback();return}}});let C=0;return j=>{const T=++C;E.push({id:T,callback:j}),h.postMessage({vscodeScheduleAsyncWork:T},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||p?2:A?1:3;let a=!0,m=!1;function O(){if(!m){m=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,a=new Uint16Array(E.buffer)[0]===(2<<8)+1}return a}e.$D=O,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}e.$J=I}),define(oe[36],ae([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;A={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(oe[9],ae([0,1,36]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,s=97,M=90,D=122,S=46,f=47,l=92,p=58,k=63;class v extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const a=o.indexOf(".")!==-1?"property":"argument";let m=`The "${o}" ${a} ${n} of type ${r}`;m+=`. Received type ${typeof i}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,o){if(t===null||typeof t!="object")throw new v(o,"Object",t)}function y(t,o){if(typeof t!="string")throw new v(o,"string",t)}const b=P.$dc==="win32";function $(t){return t===f||t===l}function d(t){return t===f}function h(t){return t>=A&&t<=M||t>=s&&t<=D}function g(t,o,r,i){let n="",a=0,m=-1,O=0,I=0;for(let E=0;E<=t.length;++E){if(E<t.length)I=t.charCodeAt(E);else{if(i(I))break;I=f}if(i(I)){if(!(m===E-1||O===1))if(O===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",a=0):(n=n.slice(0,C),a=n.length-1-n.lastIndexOf(r)),m=E,O=0;continue}else if(n.length!==0){n="",a=0,m=E,O=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",a=2)}else n.length>0?n+=`${r}${t.slice(m+1,E)}`:n=t.slice(m+1,E),a=E-m-1;m=E,O=0}else I===S&&O!==-1?++O:O=-1}return n}function w(t,o){u(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],y(a,"path"),a.length===0)continue}else o.length===0?a=P.cwd():(a=P.env[`=${o}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===l)&&(a=`${o}\\`));const m=a.length;let O=0,I="",E=!1;const C=a.charCodeAt(0);if(m===1)$(C)&&(O=1,E=!0);else if($(C))if(E=!0,$(a.charCodeAt(1))){let j=2,T=j;for(;j<m&&!$(a.charCodeAt(j));)j++;if(j<m&&j!==T){const F=a.slice(T,j);for(T=j;j<m&&$(a.charCodeAt(j));)j++;if(j<m&&j!==T){for(T=j;j<m&&!$(a.charCodeAt(j));)j++;(j===m||j!==T)&&(I=`\\\\${F}\\${a.slice(T,j)}`,O=j)}}}else O=1;else h(C)&&a.charCodeAt(1)===p&&(I=a.slice(0,2),O=2,m>2&&$(a.charCodeAt(2))&&(E=!0,O=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${a.slice(O)}\\${r}`,i=E,E&&o.length>0)break}return r=g(r,!i,"\\",$),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){y(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const a=t.charCodeAt(0);if(o===1)return d(a)?"\\":t;if($(a))if(n=!0,$(t.charCodeAt(1))){let O=2,I=O;for(;O<o&&!$(t.charCodeAt(O));)O++;if(O<o&&O!==I){const E=t.slice(I,O);for(I=O;O<o&&$(t.charCodeAt(O));)O++;if(O<o&&O!==I){for(I=O;O<o&&!$(t.charCodeAt(O));)O++;if(O===o)return`\\\\${E}\\${t.slice(I)}\\`;O!==I&&(i=`\\\\${E}\\${t.slice(I,O)}`,r=O)}}}else r=1;else h(a)&&t.charCodeAt(1)===p&&(i=t.slice(0,2),r=2,o>2&&$(t.charCodeAt(2))&&(n=!0,r=3));let m=r<o?g(t.slice(r),!n,"\\",$):"";return m.length===0&&!n&&(m="."),m.length>0&&$(t.charCodeAt(o-1))&&(m+="\\"),i===void 0?n?`\\${m}`:m:n?`${i}\\${m}`:`${i}${m}`},isAbsolute(t){y(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return $(r)||o>2&&h(r)&&t.charCodeAt(1)===p&&$(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let a=0;a<t.length;++a){const m=t[a];y(m,"path"),m.length>0&&(o===void 0?o=r=m:o+=`\\${m}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&$(r.charCodeAt(0))){++n;const a=r.length;a>1&&$(r.charCodeAt(1))&&(++n,a>2&&($(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&$(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(t,o){if(y(t,"from"),y(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===l;)a--;const m=a-n;let O=0;for(;O<o.length&&o.charCodeAt(O)===l;)O++;let I=o.length;for(;I-1>O&&o.charCodeAt(I-1)===l;)I--;const E=I-O,C=m<E?m:E;let j=-1,T=0;for(;T<C;T++){const G=t.charCodeAt(n+T);if(G!==o.charCodeAt(O+T))break;G===l&&(j=T)}if(T!==C){if(j===-1)return i}else{if(E>C){if(o.charCodeAt(O+T)===l)return i.slice(O+T+1);if(T===2)return i.slice(O+T)}m>C&&(t.charCodeAt(n+T)===l?j=T:T===2&&(j=3)),j===-1&&(j=0)}let F="";for(T=n+j+1;T<=a;++T)(T===a||t.charCodeAt(T)===l)&&(F+=F.length===0?"..":"\\..");return O+=j,F.length>0?`${F}${i.slice(O,I)}`:(i.charCodeAt(O)===l&&++O,i.slice(O,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const r=o.charCodeAt(2);if(r!==k&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===p&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){y(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return $(n)?t:".";if($(n)){if(r=i=1,$(t.charCodeAt(1))){let O=2,I=O;for(;O<o&&!$(t.charCodeAt(O));)O++;if(O<o&&O!==I){for(I=O;O<o&&$(t.charCodeAt(O));)O++;if(O<o&&O!==I){for(I=O;O<o&&!$(t.charCodeAt(O));)O++;if(O===o)return t;O!==I&&(r=i=O+1)}}}}else h(n)&&t.charCodeAt(1)===p&&(r=o>2&&$(t.charCodeAt(2))?3:2,i=r);let a=-1,m=!0;for(let O=o-1;O>=i;--O)if($(t.charCodeAt(O))){if(!m){a=O;break}}else m=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,o){o!==void 0&&y(o,"ext"),y(t,"path");let r=0,i=-1,n=!0,a;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let m=o.length-1,O=-1;for(a=t.length-1;a>=r;--a){const I=t.charCodeAt(a);if($(I)){if(!n){r=a+1;break}}else O===-1&&(n=!1,O=a+1),m>=0&&(I===o.charCodeAt(m)?--m===-1&&(i=a):(m=-1,i=O))}return r===i?i=O:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=r;--a)if($(t.charCodeAt(a))){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let o=0,r=-1,i=0,n=-1,a=!0,m=0;t.length>=2&&t.charCodeAt(1)===p&&h(t.charCodeAt(0))&&(o=i=2);for(let O=t.length-1;O>=o;--O){const I=t.charCodeAt(O);if($(I)){if(!a){i=O+1;break}continue}n===-1&&(a=!1,n=O+1),I===S?r===-1?r=O:m!==1&&(m=1):r!==-1&&(m=-1)}return r===-1||n===-1||m===0||m===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:w.bind(null,"\\"),parse(t){y(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return $(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if($(n)){if(i=1,$(t.charCodeAt(1))){let j=2,T=j;for(;j<r&&!$(t.charCodeAt(j));)j++;if(j<r&&j!==T){for(T=j;j<r&&$(t.charCodeAt(j));)j++;if(j<r&&j!==T){for(T=j;j<r&&!$(t.charCodeAt(j));)j++;j===r?i=j:j!==T&&(i=j+1)}}}}else if(h(n)&&t.charCodeAt(1)===p){if(r<=2)return o.root=o.dir=t,o;if(i=2,$(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let a=-1,m=i,O=-1,I=!0,E=t.length-1,C=0;for(;E>=i;--E){if(n=t.charCodeAt(E),$(n)){if(!I){m=E+1;break}continue}O===-1&&(I=!1,O=E+1),n===S?a===-1?a=E:C!==1&&(C=1):a!==-1&&(C=-1)}return O!==-1&&(a===-1||C===0||C===1&&a===O-1&&a===m+1?o.base=o.name=t.slice(m,O):(o.name=t.slice(m,a),o.base=t.slice(m,O),o.ext=t.slice(a,O))),m>0&&m!==i?o.dir=t.slice(0,m-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(b){const t=/\\/g;return()=>{const o=P.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>P.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:c();y(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===f)}return o=g(o,!r,"/",d),r?`/${o}`:o.length>0?o:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=g(t,!o,"/",d),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(y(t,"from"),y(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,a=1,m=o.length-a,O=n<m?n:m;let I=-1,E=0;for(;E<O;E++){const j=t.charCodeAt(r+E);if(j!==o.charCodeAt(a+E))break;j===f&&(I=E)}if(E===O)if(m>O){if(o.charCodeAt(a+E)===f)return o.slice(a+E+1);if(E===0)return o.slice(a+E)}else n>O&&(t.charCodeAt(r+E)===f?I=E:E===0&&(I=0));let C="";for(E=r+I+1;E<=i;++E)(E===i||t.charCodeAt(E)===f)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(a+I)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&y(o,"ext"),y(t,"path");let r=0,i=-1,n=!0,a;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let m=o.length-1,O=-1;for(a=t.length-1;a>=0;--a){const I=t.charCodeAt(a);if(I===f){if(!n){r=a+1;break}}else O===-1&&(n=!1,O=a+1),m>=0&&(I===o.charCodeAt(m)?--m===-1&&(i=a):(m=-1,i=O))}return r===i?i=O:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===f){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let o=-1,r=0,i=-1,n=!0,a=0;for(let m=t.length-1;m>=0;--m){const O=t.charCodeAt(m);if(O===f){if(!n){r=m+1;break}continue}i===-1&&(n=!1,i=m+1),O===S?o===-1?o=m:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||i===-1||a===0||a===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:w.bind(null,"/"),parse(t){y(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===f;let i;r?(o.root="/",i=1):i=0;let n=-1,a=0,m=-1,O=!0,I=t.length-1,E=0;for(;I>=i;--I){const C=t.charCodeAt(I);if(C===f){if(!O){a=I+1;break}continue}m===-1&&(O=!1,m=I+1),C===S?n===-1?n=I:E!==1&&(E=1):n!==-1&&(E=-1)}if(m!==-1){const C=a===0&&r?1:a;n===-1||E===0||E===1&&n===m-1&&n===a+1?o.base=o.name=t.slice(C,m):(o.name=t.slice(C,n),o.base=t.slice(C,m),o.ext=t.slice(n,m))}return a>0?o.dir=t.slice(0,a-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=b?e.$fc.normalize:e.$gc.normalize,e.$ic=b?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=b?e.$fc.join:e.$gc.join,e.$kc=b?e.$fc.resolve:e.$gc.resolve,e.$lc=b?e.$fc.relative:e.$gc.relative,e.$mc=b?e.$fc.dirname:e.$gc.dirname,e.$nc=b?e.$fc.basename:e.$gc.basename,e.$oc=b?e.$fc.extname:e.$gc.extname,e.$pc=b?e.$fc.format:e.$gc.format,e.$qc=b?e.$fc.parse:e.$gc.parse,e.$rc=b?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=b?e.$fc.sep:e.$gc.sep,e.$tc=b?e.$fc.delimiter:e.$gc.delimiter}),define(oe[33],ae([0,1,9,4,25,12]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=void 0;function D(a){return a===47||a===92}e.$Zf=D;function S(a){return a.replace(/[\\/]/g,P.$gc.sep)}e.$1f=S;function f(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$2f=f;function l(a,m=P.$gc.sep){if(!a)return"";const O=a.length,I=a.charCodeAt(0);if(D(I)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let C=3;const j=C;for(;C<O&&!D(a.charCodeAt(C));C++);if(j!==C&&!D(a.charCodeAt(C+1))){for(C+=1;C<O;C++)if(D(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,m)}}return m}else if(d(I)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+m:a.slice(0,2);let E=a.indexOf("://");if(E!==-1){for(E+=3;E<O;E++)if(D(a.charCodeAt(E)))return a.slice(0,E+1)}return""}e.$3f=l;function p(a){if(!A.$i||!a||a.length<5)return!1;let m=a.charCodeAt(0);if(m!==92||(m=a.charCodeAt(1),m!==92))return!1;let O=2;const I=O;for(;O<a.length&&(m=a.charCodeAt(O),m!==92);O++);return!(I===O||(m=a.charCodeAt(O+1),isNaN(m)||m===92))}e.$4f=p;const k=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(a,m=A.$i){const O=m?k:v;return!(!a||a.length===0||/^\s+$/.test(a)||(O.lastIndex=0,O.test(a))||m&&u.test(a)||a==="."||a===".."||m&&a[a.length-1]==="."||m&&a.length!==a.trim().length||a.length>255)}e.$5f=y;function b(a,m,O){const I=a===m;return!O||I?I:!a||!m?!1:(0,s.$$e)(a,m)}e.$6f=b;function $(a,m,O,I=P.sep){if(a===m)return!0;if(!a||!m||m.length>a.length)return!1;if(O){if(!(0,s.$_e)(a,m))return!1;if(m.length===a.length)return!0;let C=m.length;return m.charAt(m.length-1)===I&&C--,a.charAt(C)===I}return m.charAt(m.length-1)!==I&&(m+=I),a.indexOf(m)===0}e.$7f=$;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.$8f=d;function h(a,m){return A.$i&&a.endsWith(":")&&(a+=P.sep),(0,P.$ic)(a)||(a=(0,P.$jc)(m,a)),a=(0,P.$hc)(a),A.$i?(a=(0,s.$Te)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,s.$Te)(a,P.sep),a||(a=P.sep)),a}e.$9f=h;function g(a){const m=(0,P.$hc)(a);return A.$i?a.length>3?!1:w(m)&&(a.length===2||m.charCodeAt(2)===92):m===P.$gc.sep}e.$0f=g;function w(a,m=A.$i){return m?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$$f=w;function c(a,m=A.$i){return w(a,m)?a[0]:void 0}e.$_f=c;function t(a,m,O){return m.length>a.length?-1:a===m?0:(O&&(a=a.toLowerCase(),m=m.toLowerCase()),a.indexOf(m))}e.$ag=t;function o(a){const m=a.split(":");let O,I,E;for(const C of m){const j=Number(C);(0,M.$Lf)(j)?I===void 0?I=j:E===void 0&&(E=j):O=O?[O,C].join(":"):C}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$bg=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,m,O=8){let I="";for(let C=0;C<O;C++){let j;C===0&&A.$i&&!m&&(O===3||O===4)?j=i:j=r,I+=j.charAt(Math.floor(Math.random()*j.length))}let E;return m?E=`${m}-${I}`:E=I,a?(0,P.$jc)(a,E):E}e.$cg=n}),define(oe[76],ae([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.TerminateResponseCode=e.Source=void 0;var A;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...f){const l=f.reduce((v,u)=>(v[u]=!0,v),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(v=>!l[v]).forEach(v=>{for(let u=0;u<p.length;u++)if(v.search(p[u])!==-1){delete S[v];break}})}e.$Ql=M;function D(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$Rl=D}),define(oe[7],ae([0,1,9,4]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const p="",k="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(n){return n instanceof u?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,m,O,I,E=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=f(n,E),this.authority=a||p,this.path=l(this.scheme,m||p),this.query=O||p,this.fragment=I||p,S(this,E))}get fsPath(){return w(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:m,path:O,query:I,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=p),m===void 0?m=this.authority:m===null&&(m=p),O===void 0?O=this.path:O===null&&(O=p),I===void 0?I=this.query:I===null&&(I=p),E===void 0?E=this.fragment:E===null&&(E=p),a===this.scheme&&m===this.authority&&O===this.path&&I===this.query&&E===this.fragment?this:new $(a,m,O,I,E)}static parse(n,a=!1){const m=v.exec(n);return m?new $(m[2]||p,r(m[4]||p),r(m[5]||p),r(m[7]||p),r(m[9]||p),a):new $(p,p,p,p,p)}static file(n){let a=p;if(A.$i&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const m=n.indexOf(k,2);m===-1?(a=n.substring(2),n=k):(a=n.substring(2,m),n=n.substring(m)||k)}return new $("file",a,n,p,p)}static from(n,a){return new $(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.$i&&n.scheme==="file"?m=u.file(P.$fc.join(w(n,!0),...a)).path:m=P.$gc.join(n.path,...a),n.with({path:m})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof u)return n;{const a=new $(n);return a._formatted=n.external??null,a._fsPath=n._sep===b?n.fsPath??null:null,a}}else return n}}e.URI=u;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=y;const b=A.$i?1:void 0;class $ extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,a){let m,O=-1;for(let I=0;I<i.length;I++){const E=i.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||a&&E===91||a&&E===93||a&&E===58)O!==-1&&(m+=encodeURIComponent(i.substring(O,I)),O=-1),m!==void 0&&(m+=i.charAt(I));else{m===void 0&&(m=i.substr(0,I));const C=d[E];C!==void 0?(O!==-1&&(m+=encodeURIComponent(i.substring(O,I)),O=-1),m+=C):O===-1&&(O=I)}}return O!==-1&&(m+=encodeURIComponent(i.substring(O))),m!==void 0?m:i}function g(i){let n;for(let a=0;a<i.length;a++){const m=i.charCodeAt(a);m===35||m===63?(n===void 0&&(n=i.substr(0,a)),n+=d[m]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function w(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,A.$i&&(a=a.replace(/\//g,"\\")),a}e.$wc=w;function c(i,n){const a=n?g:h;let m="",{scheme:O,authority:I,path:E,query:C,fragment:j}=i;if(O&&(m+=O,m+=":"),(I||O==="file")&&(m+=k,m+=k),I){let T=I.indexOf("@");if(T!==-1){const F=I.substr(0,T);I=I.substr(T+1),T=F.lastIndexOf(":"),T===-1?m+=a(F,!1,!1):(m+=a(F.substr(0,T),!1,!1),m+=":",m+=a(F.substr(T+1),!1,!0)),m+="@"}I=I.toLowerCase(),T=I.lastIndexOf(":"),T===-1?m+=a(I,!1,!0):(m+=a(I.substr(0,T),!1,!0),m+=I.substr(T))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const T=E.charCodeAt(1);T>=65&&T<=90&&(E=`/${String.fromCharCode(T+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const T=E.charCodeAt(0);T>=65&&T<=90&&(E=`${String.fromCharCode(T+32)}:${E.substr(2)}`)}m+=a(E,!0,!1)}return C&&(m+="?",m+=a(C,!1,!1)),j&&(m+="#",m+=n?j:h(j,!1,!1)),m}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(oe[154],ae([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$nq=e.$mq=e.$lq=void 0;function A(l){const p=l;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.$lq=A;function s(l){const p=[];let k;try{const v=JSON.parse(l.arguments),u=v[v.length-1];u&&u.__$stack&&(v.pop(),k=u.__$stack),p.push(...v)}catch{p.push("Unable to log remote console arguments",l.arguments)}return{args:p,stack:k}}e.$mq=s;function M(l){if(typeof l!="string")return M(s(l).stack);const p=l;if(p){const k=D(p),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(v&&v.length===4)return{uri:P.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$nq=M;function D(l){if(!l)return l;const p=l.indexOf(`
`);return p===-1?l:l.substring(0,p)}function S(l,p){const{args:k,stack:v}=s(l),u=typeof k[0]=="string"&&k.length===1;let y=D(v);y&&(y=`(${y.trim()})`);let b=[];if(typeof k[0]=="string"?y&&u?b=[`%c[${p}] %c${k[0]} %c${y}`,f("blue"),f(""),f("grey")]:b=[`%c[${p}] %c${k[0]}`,f("blue"),f(""),...k.slice(1)]:b=[`%c[${p}]%`,f("blue"),...k],y&&!u&&b.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,b)}e.log=S;function f(l){return`color: ${l}`}}),define(oe[77],ae([0,1,17,7]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function s(f){return JSON.stringify(f,D)}e.$zh=s;function M(f){let l=JSON.parse(f);return l=S(l),l}e.$Ah=M;function D(f,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function S(f,l=0){if(!f||l>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return A.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof P.$ie||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let p=0;p<f.length;++p)f[p]=S(f[p],l+1);else for(const p in f)Object.hasOwnProperty.call(f,p)&&(f[p]=S(f[p],l+1))}return f}e.$Bh=S}),define(oe[13],ae([0,1,14,4,25,7]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.Schemas=void 0;var D;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function S(v,u){return M.URI.isUri(v)?(0,s.$$e)(v.scheme,u):(0,s.$_e)(v,u+":")}e.$dg=S;function f(v,...u){return u.some(y=>S(v,y))}e.$eg=f,e.$fg="vscode-tkn",e.$gg="tkn";class l{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u){this.f=`${u}/${D.vscodeRemoteResource}`}set(u,y,b){this.a[u]=y,this.b[u]=b}setConnectionToken(u,y){this.c[u]=y}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(g){return P.$1(g),u}const y=u.authority;let b=this.a[y];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const $=this.b[y],d=this.c[y];let h=`path=${encodeURIComponent(u.path)}`;return typeof d=="string"&&(h+=`&${e.$gg}=${encodeURIComponent(d)}`),M.URI.from({scheme:A.$o?this.d:D.vscodeRemoteResource,authority:`${b}:${$}`,path:this.f,query:h})}}e.$hg=new l,e.$ig="vs/../../extensions",e.$jg="vs/../../node_modules",e.$kg="vs/../../node_modules.asar",e.$lg="vs/../../node_modules.asar.unpacked",e.$mg="vscode-app";class p{static{this.a=e.$mg}asBrowserUri(u){const y=this.b(u,Q);return this.uriToBrowserUri(y)}uriToBrowserUri(u){return u.scheme===D.vscodeRemote?e.$hg.rewrite(u):u.scheme===D.file&&(A.$m||A.$q===`${D.vscodeFileResource}://${p.a}`)?u.with({scheme:D.vscodeFileResource,authority:u.authority||p.a,query:null,fragment:null}):u}asFileUri(u){const y=this.b(u,Q);return this.uriToFileUri(y)}uriToFileUri(u){return u.scheme===D.vscodeFileResource?u.with({scheme:D.file,authority:u.authority!==p.a?u.authority:null,query:null,fragment:null}):u}b(u,y){return M.URI.isUri(u)?u:M.URI.parse(y.toUrl(u))}}e.$ng=new p;var k;(function(v){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(u.get("3"));const y="vscode-coi";function b(d){let h;typeof d=="string"?h=new URL(d).searchParams:d instanceof URL?h=d.searchParams:M.URI.isUri(d)&&(h=new URL(d.toString(!0)).searchParams);const g=h?.get(y);if(g)return u.get(g)}v.getHeadersFromQuery=b;function $(d,h,g){if(!globalThis.crossOriginIsolated)return;const w=h&&g?"3":g?"2":"1";d instanceof URLSearchParams?d.set(y,w):d[y]=w}v.addSearchParam=$})(k||(e.COI=k={}))}),define(oe[19],ae([0,1,33,13,9,4,25,7]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.DataUri=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=void 0;function f(u){return(0,S.$wc)(u,!0)}e.$ug=f;class l{constructor(y){this.a=y}compare(y,b,$=!1){return y===b?0:(0,D.$4e)(this.getComparisonKey(y,$),this.getComparisonKey(b,$))}isEqual(y,b,$=!1){return y===b?!0:!y||!b?!1:this.getComparisonKey(y,$)===this.getComparisonKey(b,$)}getComparisonKey(y,b=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,b,$=!1){if(y.scheme===b.scheme){if(y.scheme===A.Schemas.file)return P.$7f(f(y),f(b),this.a(y))&&y.query===b.query&&($||y.fragment===b.fragment);if((0,e.$Lg)(y.authority,b.authority))return P.$7f(y.path,b.path,this.a(y),"/")&&y.query===b.query&&($||y.fragment===b.fragment)}return!1}joinPath(y,...b){return S.URI.joinPath(y,...b)}basenameOrAuthority(y){return(0,e.$Dg)(y)||y.authority}basename(y){return s.$gc.basename(y.path)}extname(y){return s.$gc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let b;return y.scheme===A.Schemas.file?b=S.URI.file(s.$mc(f(y))).path:(b=s.$gc.dirname(y.path),y.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),b="/")),y.with({path:b})}normalizePath(y){if(!y.path.length)return y;let b;return y.scheme===A.Schemas.file?b=S.URI.file(s.$hc(f(y))).path:b=s.$gc.normalize(y.path),y.with({path:b})}relativePath(y,b){if(y.scheme!==b.scheme||!(0,e.$Lg)(y.authority,b.authority))return;if(y.scheme===A.Schemas.file){const h=s.$lc(f(y),f(b));return M.$i?P.$1f(h):h}let $=y.path||"/";const d=b.path||"/";if(this.a(y)){let h=0;for(const g=Math.min($.length,d.length);h<g&&!($.charCodeAt(h)!==d.charCodeAt(h)&&$.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);$=d.substr(0,h)+$.substr(h)}return s.$gc.relative($,d)}resolvePath(y,b){if(y.scheme===A.Schemas.file){const $=S.URI.file(s.$kc(f(y),b));return y.with({authority:$.authority,path:$.path})}return b=P.$2f(b),y.with({path:s.$gc.resolve(y.path,b)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,b){return y===b||y!==void 0&&b!==void 0&&(0,D.$$e)(y,b)}hasTrailingPathSeparator(y,b=s.sep){if(y.scheme===A.Schemas.file){const $=f(y);return $.length>P.$3f($).length&&$[$.length-1]===b}else{const $=y.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,b=s.sep){return(0,e.$Mg)(y,b)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,b=s.sep){let $=!1;if(y.scheme===A.Schemas.file){const d=f(y);$=d!==void 0&&d.length===P.$3f(d).length&&d[d.length-1]===b}else{b="/";const d=y.path;$=d.length===1&&d.charCodeAt(d.length-1)===47}return!$&&!(0,e.$Mg)(y,b)?y.with({path:y.path+"/"}):y}}e.$vg=l,e.$wg=new l(()=>!1),e.$xg=new l(u=>u.scheme===A.Schemas.file?!M.$k:!0),e.$yg=new l(u=>!0),e.$zg=e.$wg.isEqual.bind(e.$wg),e.$Ag=e.$wg.isEqualOrParent.bind(e.$wg),e.$Bg=e.$wg.getComparisonKey.bind(e.$wg),e.$Cg=e.$wg.basenameOrAuthority.bind(e.$wg),e.$Dg=e.$wg.basename.bind(e.$wg),e.$Eg=e.$wg.extname.bind(e.$wg),e.$Fg=e.$wg.dirname.bind(e.$wg),e.$Gg=e.$wg.joinPath.bind(e.$wg),e.$Hg=e.$wg.normalizePath.bind(e.$wg),e.$Ig=e.$wg.relativePath.bind(e.$wg),e.$Jg=e.$wg.resolvePath.bind(e.$wg),e.$Kg=e.$wg.isAbsolutePath.bind(e.$wg),e.$Lg=e.$wg.isEqualAuthority.bind(e.$wg),e.$Mg=e.$wg.hasTrailingPathSeparator.bind(e.$wg),e.$Ng=e.$wg.removeTrailingPathSeparator.bind(e.$wg),e.$Og=e.$wg.addTrailingPathSeparator.bind(e.$wg);function p(u,y){const b=[];for(let $=0;$<u.length;$++){const d=y(u[$]);u.some((h,g)=>g===$?!1:(0,e.$Ag)(d,y(h)))||b.push(u[$])}return b}e.$Pg=p;var k;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function y(b){const $=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(g=>{const[w,c]=g.split(":");w&&c&&$.set(w,c)});const h=b.path.substring(0,b.path.indexOf(";"));return h&&$.set(u.META_DATA_MIME,h),$}u.parseMetaData=y})(k||(e.DataUri=k={}));function v(u,y,b){if(y){let $=u.path;return $&&$[0]!==s.$gc.sep&&($=s.$gc.sep+$),u.with({scheme:b,authority:y,path:$})}return u.with({scheme:b})}e.$Qg=v}),define(oe[8],ae([0,1,23,14,3,2,19,4,143,62]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.Promises=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=void 0;function p(N){return!!N&&typeof N.then=="function"}e.$Rg=p;function k(N){const B=new P.$5d,_=N(B.token),ce=new Promise((re,$e)=>{const me=B.token.onCancellationRequested(()=>{me.dispose(),$e(new A.$5)});Promise.resolve(_).then(ye=>{me.dispose(),B.dispose(),re(ye)},ye=>{me.dispose(),B.dispose(),$e(ye)})});return new class{cancel(){B.cancel(),B.dispose()}then(re,$e){return ce.then(re,$e)}catch(re){return this.then(void 0,re)}finally(re){return ce.finally(re)}}}e.$Sg=k;function v(N,B,_){return new Promise((ce,re)=>{const $e=B.onCancellationRequested(()=>{$e.dispose(),ce(_)});N.then(ce,re).finally(()=>$e.dispose())})}e.$Tg=v;function u(N,B){return new Promise((_,ce)=>{const re=B.onCancellationRequested(()=>{re.dispose(),ce(new A.$5)});N.then(_,ce).finally(()=>re.dispose())})}e.$Ug=u;async function y(N){let B=-1;const _=N.map((ce,re)=>ce.then($e=>(B=re,$e)));try{return await Promise.race(_)}finally{N.forEach((ce,re)=>{re!==B&&ce.cancel()})}}e.$Vg=y;function b(N,B,_){let ce;const re=setTimeout(()=>{ce?.(void 0),_?.()},B);return Promise.race([N.finally(()=>clearTimeout(re)),new Promise($e=>ce=$e)])}e.$Wg=b;function $(N){return new Promise((B,_)=>{const ce=N();p(ce)?ce.then(B,_):B(ce)})}e.$Xg=$;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const _=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(_,_).then(ce)})}return new Promise((_,ce)=>{this.b.then(_,ce)})}return this.a=B(),new Promise((_,ce)=>{this.a.then(re=>{this.a=null,_(re)},re=>{this.a=null,ce(re)})})}dispose(){this.f=!0}}e.$Yg=d;class h{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$Zg=h;class g{constructor(){this.a=new Map}queue(B,_){const re=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(B)===re&&this.a.delete(B)});return this.a.set(B,re),re}}e.$1g=g;const w=(N,B)=>{let _=!0;const ce=setTimeout(()=>{_=!1,B()},N);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ce),_=!1}}},c=N=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,N())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class t{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,_=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((re,$e)=>{this.d=re,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const re=this.g;return this.g=null,re()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=_===f.$Rd?c(ce):w(_,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$2g=t;class o{constructor(B){this.a=new t(B),this.b=new d}trigger(B,_){return this.a.trigger(()=>this.b.queue(B),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$3g=o;class r{constructor(){this.a=!1,this.b=new Promise((B,_)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$4g=r;class i extends r{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$5g=i;function n(N,B){return B?new Promise((_,ce)=>{const re=setTimeout(()=>{$e.dispose(),_()},N),$e=B.onCancellationRequested(()=>{clearTimeout(re),$e.dispose(),ce(new A.$5)})}):k(_=>n(N,_))}e.$6g=n;function a(N,B=0,_){const ce=setTimeout(()=>{N(),_&&re.dispose()},B),re=(0,M.$Rc)(()=>{clearTimeout(ce),_?.deleteAndLeak(re)});return _?.add(re),re}e.$7g=a;function m(N){const B=[];let _=0;const ce=N.length;function re(){return _<ce?N[_++]():null}function $e(me){me!=null&&B.push(me);const ye=re();return ye?ye.then($e):Promise.resolve(B)}return Promise.resolve(null).then($e)}e.$8g=m;function O(N,B=ce=>!!ce,_=null){let ce=0;const re=N.length,$e=()=>{if(ce>=re)return Promise.resolve(_);const me=N[ce++];return Promise.resolve(me()).then(Pe=>B(Pe)?Promise.resolve(Pe):$e())};return $e()}e.$9g=O;function I(N,B=ce=>!!ce,_=null){if(N.length===0)return Promise.resolve(_);let ce=N.length;const re=()=>{ce=-1;for(const $e of N)$e.cancel?.()};return new Promise(($e,me)=>{for(const ye of N)ye.then(Pe=>{--ce>=0&&B(Pe)?(re(),$e(Pe)):ce===0&&$e(_)}).catch(Pe=>{--ce>=0&&(re(),me(Pe))})})}e.$0g=I;class E{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new s.$Ud}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((_,ce)=>{this.g.push({factory:B,c:_,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const _=B.factory();_.then(B.c,B.e),_.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$$g=E;class C extends E{constructor(){super(1)}}e.$_g=C;class j{constructor(){this.a=new L,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$ah=j;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new q;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,_=D.$wg){const ce=_.getComparisonKey(B);return this.a.get(ce)?.size??0}queueFor(B,_,ce=D.$wg){const re=ce.getComparisonKey(B);let $e=this.a.get(re);if(!$e){$e=new C;const me=this.f++,ye=s.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(re),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(me,ye),this.a.set(re,$e)}return $e.queue(_)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$bh=T;class F{constructor(B,_){this.a=-1,typeof B=="function"&&typeof _=="number"&&this.setIfNotSet(B,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},_)}setIfNotSet(B,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},_))}}e.$ch=F;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,_,ce=globalThis){this.cancel();const re=ce.setInterval(()=>{B()},_);this.d=(0,M.$Rc)(()=>{ce.clearInterval(re),this.d=void 0})}dispose(){this.cancel()}}e.$dh=G;class J{constructor(B,_){this.b=-1,this.a=B,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$eh=J;class le{constructor(B,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=B,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$fh=le;class se extends J{constructor(B,_){super(B,_),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$gh=se;class ue extends M.$Tc{constructor(B,_){super(),this.g=B,this.h=_,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of B)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$hh=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$jh=(N,B)=>{(0,S.$B)(()=>{if(_)return;const ce=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$jh=(N,B,_)=>{const ce=N.requestIdleCallback(B,typeof _=="number"?{timeout:_}:void 0);let re=!1;return{dispose(){re||(re=!0,N.cancelIdleCallback(ce))}}},e.$ih=N=>(0,e.$jh)(globalThis,N)}();class Z{constructor(B,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$jh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$kh=Z;class X extends Z{constructor(B){super(globalThis,B)}}e.$lh=X;async function H(N,B,_){let ce;for(let re=0;re<_;re++)try{return await N()}catch($e){ce=$e,await n(B)}throw ce}e.$mh=H;class L{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,_,ce){return this.a={taskId:B,cancel:()=>ce?.(),promise:_},_.then(()=>this.d(B),()=>this.d(B)),_}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{let _,ce;const re=new Promise(($e,me)=>{_=$e,ce=me});this.b={run:B,promise:re,promiseResolve:_,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$nh=L;class W{constructor(B,_=()=>Date.now()){this.d=B,this.f=_,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$oh=W;var V;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(V||(V={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,_)=>{this.a=B,this.b=_})}complete(B){return new Promise(_=>{this.a(B),this.d={outcome:0,value:B},_()})}error(B){return new Promise(_=>{this.b(B),this.d={outcome:1,value:B},_()})}cancel(){return this.error(new A.$5)}}e.$ph=q;var te;(function(N){async function B(ce){let re;const $e=await Promise.all(ce.map(me=>me.then(ye=>ye,ye=>{re||(re=ye)})));if(typeof re<"u")throw re;return $e}N.settled=B;function _(ce){return new Promise(async(re,$e)=>{try{await ce(re,$e)}catch(me){$e(me)}})}N.withAsyncBody=_})(te||(e.Promises=te={}));class he{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$qh=he;class K{constructor(B){this.b=B,this.a=new l.$V(()=>new he(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$rh=K;var R;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(R||(R={}));class U{static fromArray(B){return new U(_=>{_.emitMany(B)})}static fromPromise(B){return new U(async _=>{_.emitMany(await B)})}static fromPromises(B){return new U(async _=>{await Promise.all(B.map(async ce=>_.emitOne(await ce)))})}static merge(B){return new U(async _=>{await Promise.all(B.map(async ce=>{for await(const re of ce)_.emitOne(re)}))})}static{this.EMPTY=U.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new s.$Ud,queueMicrotask(async()=>{const _={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(B(_)),this.j()}catch(ce){this.k(ce)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(B,_){return new U(async ce=>{for await(const re of B)ce.emitOne(_(re))})}map(B){return U.map(this,B)}static filter(B,_){return new U(async ce=>{for await(const re of B)_(re)&&ce.emitOne(re)})}filter(B){return U.filter(this,B)}static coalesce(B){return U.filter(B,_=>!!_)}coalesce(){return U.coalesce(this)}static async toPromise(B){const _=[];for await(const ce of B)_.push(ce);return _}toPromise(){return U.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$sh=U;class x extends U{constructor(B,_){super(_),this.l=B}cancel(){this.l.cancel()}}e.$th=x;function z(N){const B=new P.$5d,_=N(B.token);return new x(B,async ce=>{const re=B.token.onCancellationRequested(()=>{re.dispose(),B.dispose(),ce.reject(new A.$5)});try{for await(const $e of _){if(B.token.isCancellationRequested)return;ce.emitOne($e)}re.dispose(),B.dispose()}catch($e){re.dispose(),B.dispose(),ce.reject($e)}})}e.$uh=z;class Y{constructor(){this.a=new q,this.b=new U(ce=>{if(B){ce.reject(B);return}return _&&ce.emitMany(_),this.d=re=>ce.reject(re),this.f=re=>ce.emitOne(re),this.a.p});let B,_;this.f=ce=>{_||(_=[]),_.push(ce)},this.d=ce=>{B||(B=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$vh=Y}),define(oe[105],ae([0,1,22,8,33,31,9,4,25]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=void 0;function l(){return Object.create(null)}e.$Gj=l,e.$Hj="**",e.$Ij="/";const p="[/\\\\]",k="[^/\\\\]",v=/\//g;function u(X,H){switch(X){case 0:return"";case 1:return`${k}*?`;default:return`(?:${p}|${k}+${p}${H?`|${p}${k}+`:""})*?`}}function y(X,H){if(!X)return[];const L=[];let W=!1,V=!1,q="";for(const te of X){switch(te){case H:if(!W&&!V){L.push(q),q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":V=!0;break;case"]":V=!1;break}q+=te}return q&&L.push(q),L}e.$Jj=y;function b(X){if(!X)return"";let H="";const L=y(X,e.$Ij);if(L.every(W=>W===e.$Hj))H=".*";else{let W=!1;L.forEach((V,q)=>{if(V===e.$Hj){if(W)return;H+=u(2,q===L.length-1)}else{let te=!1,he="",K=!1,R="";for(const U of V){if(U!=="}"&&te){he+=U;continue}if(K&&(U!=="]"||!R)){let x;U==="-"?x=U:(U==="^"||U==="!")&&!R?x="^":U===e.$Ij?x="":x=(0,f.$Ne)(U),R+=x;continue}switch(U){case"{":te=!0;continue;case"[":K=!0;continue;case"}":{const z=`(?:${y(he,",").map(Y=>b(Y)).join("|")})`;H+=z,te=!1,he="";break}case"]":{H+="["+R+"]",K=!1,R="";break}case"?":H+=k;continue;case"*":H+=u(1);continue;default:H+=(0,f.$Ne)(U)}}q<L.length-1&&(L[q+1]!==e.$Hj||q+2<L.length)&&(H+=p)}W=V===e.$Hj})}return H}const $=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(X,H){if(!X)return r;let L;typeof X!="string"?L=X.pattern:L=X,L=L.trim();const W=`${L}_${!!H.trimForExclusions}`;let V=t.get(W);if(V)return n(V,X);let q;return $.test(L)?V=m(L.substr(4),L):(q=d.exec(a(L,H)))?V=O(q[1],L):(H.trimForExclusions?g:h).test(L)?V=I(L,H):(q=w.exec(a(L,H)))?V=E(q[1].substr(1),L,!0):(q=c.exec(a(L,H)))?V=E(q[1],L,!1):V=C(L),t.set(W,V),n(V,X)}function n(X,H){if(typeof H=="string")return X;const L=function(W,V){return(0,s.$7f)(W,H.base,!S.$k)?X((0,f.$Se)(W.substr(H.base.length),D.sep),V):null};return L.allBasenames=X.allBasenames,L.allPaths=X.allPaths,L.basenames=X.basenames,L.patterns=X.patterns,L}function a(X,H){return H.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function m(X,H){return function(L,W){return typeof L=="string"&&L.endsWith(X)?H:null}}function O(X,H){const L=`/${X}`,W=`\\${X}`,V=function(te,he){return typeof te!="string"?null:he?he===X?H:null:te===X||te.endsWith(L)||te.endsWith(W)?H:null},q=[X];return V.basenames=q,V.patterns=[H],V.allBasenames=q,V}function I(X,H){const L=ue(X.slice(1,-1).split(",").map(he=>i(he,H)).filter(he=>he!==r),X),W=L.length;if(!W)return r;if(W===1)return L[0];const V=function(he,K){for(let R=0,U=L.length;R<U;R++)if(L[R](he,K))return X;return null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function E(X,H,L){const W=D.sep===D.$gc.sep,V=W?X:X.replace(v,D.sep),q=D.sep+V,te=D.$gc.sep+X;let he;return L?he=function(K,R){return typeof K=="string"&&(K===V||K.endsWith(q)||!W&&(K===X||K.endsWith(te)))?H:null}:he=function(K,R){return typeof K=="string"&&(K===V||!W&&K===X)?H:null},he.allPaths=[(L?"*/":"./")+X],he}function C(X){try{const H=new RegExp(`^${b(X)}$`);return function(L){return H.lastIndex=0,typeof L=="string"&&H.test(L)?X:null}}catch{return r}}function j(X,H,L){return!X||typeof H!="string"?!1:T(X)(H,void 0,L)}e.$Kj=j;function T(X,H={}){if(!X)return o;if(typeof X=="string"||F(X)){const L=i(X,H);if(L===r)return o;const W=function(V,q){return!!L(V,q)};return L.allBasenames&&(W.allBasenames=L.allBasenames),L.allPaths&&(W.allPaths=L.allPaths),W}return le(X,H)}e.$Lj=T;function F(X){const H=X;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$Mj=F;function G(X){return X.allBasenames||[]}e.$Nj=G;function J(X){return X.allPaths||[]}e.$Oj=J;function le(X,H){const L=ue(Object.getOwnPropertyNames(X).map(he=>se(he,X[he],H)).filter(he=>he!==r)),W=L.length;if(!W)return r;if(!L.some(he=>!!he.requiresSiblings)){if(W===1)return L[0];const he=function(U,x){let z;for(let Y=0,N=L.length;Y<N;Y++){const B=L[Y](U,x);if(typeof B=="string")return B;(0,A.$Rg)(B)&&(z||(z=[]),z.push(B))}return z?(async()=>{for(const Y of z){const N=await Y;if(typeof N=="string")return N}return null})():null},K=L.find(U=>!!U.allBasenames);K&&(he.allBasenames=K.allBasenames);const R=L.reduce((U,x)=>x.allPaths?U.concat(x.allPaths):U,[]);return R.length&&(he.allPaths=R),he}const V=function(he,K,R){let U,x;for(let z=0,Y=L.length;z<Y;z++){const N=L[z];N.requiresSiblings&&R&&(K||(K=(0,D.$nc)(he)),U||(U=K.substr(0,K.length-(0,D.$oc)(he).length)));const B=N(he,K,U,R);if(typeof B=="string")return B;(0,A.$Rg)(B)&&(x||(x=[]),x.push(B))}return x?(async()=>{for(const z of x){const Y=await z;if(typeof Y=="string")return Y}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function se(X,H,L){if(H===!1)return r;const W=i(X,L);if(W===r)return r;if(typeof H=="boolean")return W;if(H){const V=H.when;if(typeof V=="string"){const q=(te,he,K,R)=>{if(!R||!W(te,he))return null;const U=V.replace("$(basename)",()=>K),x=R(U);return(0,A.$Rg)(x)?x.then(z=>z?X:null):x?X:null};return q.requiresSiblings=!0,q}}return W}function ue(X,H){const L=X.filter(he=>!!he.basenames);if(L.length<2)return X;const W=L.reduce((he,K)=>{const R=K.basenames;return R?he.concat(R):he},[]);let V;if(H){V=[];for(let he=0,K=W.length;he<K;he++)V.push(H)}else V=L.reduce((he,K)=>{const R=K.patterns;return R?he.concat(R):he},[]);const q=function(he,K){if(typeof he!="string")return null;if(!K){let U;for(U=he.length;U>0;U--){const x=he.charCodeAt(U-1);if(x===47||x===92)break}K=he.substr(U)}const R=W.indexOf(K);return R!==-1?V[R]:null};q.basenames=W,q.patterns=V,q.allBasenames=W;const te=X.filter(he=>!he.basenames);return te.push(q),te}function Z(X,H){return(0,P.$ub)(X,H,(L,W)=>typeof L=="string"&&typeof W=="string"?L===W:typeof L!="string"&&typeof W!="string"?L.base===W.base&&L.pattern===W.pattern:!1)}e.$Pj=Z}),define(oe[47],ae([0,1,22,33,9,4,19,25]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=void 0;function f(i,n){const{os:a,tildify:m,relative:O}=n;if(O){const C=l(i,O,a);if(typeof C=="string")return C}let I=i.fsPath;if(a===1&&!M.$i?I=I.replace(/\//g,"\\"):a!==1&&M.$i&&(I=I.replace(/\\/g,"/")),a!==1&&m?.userHome){const C=m.userHome.fsPath;let j;i.scheme!==m.userHome.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep?j=m.userHome.with({path:i.path}).fsPath:j=I,I=v(j,C,a)}return(a===1?s.$fc:s.$gc).normalize(p(I,a===1))}e.$Uv=f;function l(i,n,a){const m=a===1?s.$fc:s.$gc,O=a===3?D.$wg:D.$yg,I=n.getWorkspace(),E=(0,P.$Ob)(I.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep&&(i=E.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let j;if(O.isEqual(C.uri,i)?j="":j=O.relativePath(C.uri,i)??"",j&&(j=m.normalize(j)),I.folders.length>1&&!n.noPrefix){const T=C.name?C.name:O.basenameOrAuthority(C.uri);j=j?`${T} \u2022 ${j}`:T}return j}function p(i,n=M.$i){return(0,A.$$f)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$Vv=p;let k=Object.create(null);function v(i,n,a=M.OS){if(a===1||!i||!n)return i;let m=k.original===n?k.normalized:void 0;m||(m=n,M.$i&&(m=(0,A.$1f)(m)),m=`${(0,S.$Te)(m,s.$gc.sep)}${s.$gc.sep}`,k={original:n,normalized:m});let O=i;return M.$i&&(O=(0,A.$1f)(O)),(a===3?O.startsWith(m):(0,S.$_e)(O,m))?`~/${O.substr(m.length)}`:i}e.$Wv=v;function u(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Xv=u;const y="\u2026",b="\\\\",$="~";function d(i,n=s.sep){const a=new Array(i.length);let m=!1;for(let O=0;O<i.length;O++){const I=i[O];if(I===""){a[O]=`.${n}`;continue}if(!I){a[O]=I;continue}m=!0;let E="",C=I;C.indexOf(b)===0?(E=C.substr(0,C.indexOf(b)+b.length),C=C.substr(C.indexOf(b)+b.length)):C.indexOf(n)===0?(E=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf($)===0&&(E=C.substr(0,C.indexOf($)+$.length),C=C.substr(C.indexOf($)+$.length));const j=C.split(n);for(let T=1;m&&T<=j.length;T++)for(let F=j.length-T;m&&F>=0;F--){m=!1;let G=j.slice(F,F+T).join(n);for(let J=0;!m&&J<i.length;J++)if(J!==O&&i[J]&&i[J].indexOf(G)>-1){const le=F+T===j.length,se=F>0&&i[J].indexOf(n)>-1?n+G:G,ue=i[J].endsWith(se);m=!le||ue}if(!m){let J="";(j[0].endsWith(":")||E!=="")&&(F===1&&(F=0,T++,G=j[0]+n+G),F>0&&(J=j[0]+n),J=E+J),F>0&&(J=J+y+n),J=J+G,F+T<j.length&&(J=J+n+y),a[O]=J}}m&&(a[O]=I)}return a}e.$Yv=d;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function g(i,n=Object.create(null)){const a=[];let m=!1,O="";for(const I of i)if(I==="$"||m&&I==="{")O&&a.push({value:O,type:h.TEXT}),O="",m=!0;else if(I==="}"&&m){const E=n[O];if(typeof E=="string")E.length&&a.push({value:E,type:h.VARIABLE});else if(E){const C=a[a.length-1];(!C||C.type!==h.SEPARATOR)&&a.push({value:E.label,type:h.SEPARATOR})}O="",m=!1}else O+=I;return O&&!m&&a.push({value:O,type:h.TEXT}),a.filter((I,E)=>{if(I.type===h.SEPARATOR){const C=a[E-1],j=a[E+1];return[C,j].every(T=>T&&(T.type===h.VARIABLE||T.type===h.TEXT)&&T.value.length>0)}return!0}).map(I=>I.value).join("")}e.$Zv=g;function w(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$1v=w;function c(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$2v=c;function t(i){return i.replace(/&/g,"&&")}e.$3v=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=r(i.substring(0,n)),m=i.substring(n);return{name:a.name+m,parentPath:a.parentPath}}}return r(i)}e.$4v=o;function r(i){const n=i.indexOf("/")!==-1?s.$gc:s.$fc,a=n.basename(i),m=n.dirname(i);return a.length?{name:a,parentPath:m}:{name:m,parentPath:""}}}),define(oe[155],ae([0,1,17,7]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function s(k){return k.toJSON()}class M{constructor(v){this.a=v}transformIncoming(v){const u=this.a.transformIncoming(v);return u===v?v:s(A.URI.from(u))}transformOutgoing(v){const u=this.a.transformOutgoing(v);return u===v?v:s(A.URI.from(u))}transformOutgoingURI(v){const u=this.a.transformOutgoing(v);return u===v?v:A.URI.from(u)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$3m=M,e.$4m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function D(k,v,u){if(!k||u>200)return null;if(typeof k=="object"){if(k instanceof A.URI)return v.transformOutgoing(k);for(const y in k)if(Object.hasOwnProperty.call(k,y)){const b=D(k[y],v,u+1);b!==null&&(k[y]=b)}}return null}function S(k,v){const u=D(k,v,0);return u===null?k:u}e.$5m=S;function f(k,v,u,y){if(!k||y>200)return null;if(typeof k=="object"){if(k.$mid===1)return u?A.URI.revive(v.transformIncoming(k)):v.transformIncoming(k);if(k instanceof P.$ie)return null;for(const b in k)if(Object.hasOwnProperty.call(k,b)){const $=f(k[b],v,u,y+1);$!==null&&(k[b]=$)}}return null}function l(k,v){const u=f(k,v,!1,0);return u===null?k:u}e.$6m=l;function p(k,v){const u=f(k,v,!0,0);return u===null?k:u}e.$7m=p}),define(oe[88],ae([0,1,26,58,32,145,4]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=void 0,e.$9m=new class{c(v){return this.a||(this.a=A.$$h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,u=0;const y=(0,P.networkInterfaces)();for(const b in y){const $=y[b];if($)for(const{mac:d,internal:h}of $)h||(u+=1,this.c(d.toUpperCase())&&(v+=1))}this.b=u>0?v/u:0}return this.b}};let S;async function f(v){return S||(S=(async()=>await l(v)||s.$pg())()),S}e.$0m=f;async function l(v){try{const u=await new Promise((b,$)=>{Q(["crypto"],b,$)}),y=(0,M.$8m)();return u.createHash("sha256").update(y,"utf8").digest("hex")}catch(u){v(u);return}}const p="Software\\Microsoft\\SQMClient";async function k(v){if(D.$i){const u=await new Promise((y,b)=>{Q(["@vscode/windows-registry"],y,b)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",p,"MachineId")||""}catch(y){return v(y),""}}return""}e.$$m=k}),define(oe[21],ae([0,1,46,26,156,8,33,85,9,4,19,7]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function u(se,ue=v.UNLINK,Z){if((0,D.$0f)(se))throw new Error("rimraf - will refuse to recursively delete root");return ue===v.UNLINK?b(se):y(se,Z)}async function y(se,ue=(0,D.$cg)((0,A.tmpdir)())){try{try{await P.promises.rename(se,ue)}catch(Z){return Z.code==="ENOENT"?void 0:b(se)}b(ue).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function b(se){return(0,s.promisify)(P.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function $(se){if((0,D.$0f)(se))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=$;async function d(se,ue){return w(await(ue?h(se):(0,s.promisify)(P.readdir)(se)))}async function h(se){try{return await(0,s.promisify)(P.readdir)(se,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ue=[],Z=await d(se);for(const X of Z){let H=!1,L=!1,W=!1;try{const V=await e.Promises.lstat((0,f.$jc)(se,X));H=V.isFile(),L=V.isDirectory(),W=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ue.push({name:X,isFile:()=>H,isDirectory:()=>L,isSymbolicLink:()=>W})}return ue}function g(se){return w(P.readdirSync(se))}e.readdirSync=g;function w(se){return se.map(ue=>typeof ue=="string"?l.$j?(0,S.$Fl)(ue):ue:(ue.name=l.$j?(0,S.$Fl)(ue.name):ue.name,ue))}async function c(se){const ue=await d(se),Z=[];for(const X of ue)await o.existsDirectory((0,f.$jc)(se,X))&&Z.push(X);return Z}function t(se,ue=1e3){return new Promise(Z=>{let X=!1;const H=setInterval(()=>{X||(X=!0,P.access(se,L=>{X=!1,L&&(clearInterval(H),Z(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(se){async function ue(H){let L;try{if(L=await e.Promises.lstat(H),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(l.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw V}throw W}}se.stat=ue;async function Z(H){try{const{stat:L,symbolicLink:W}=await se.stat(H);return L.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=Z;async function X(H){try{const{stat:L,symbolicLink:W}=await se.stat(H);return L.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const r=new M.$bh;function i(se,ue,Z){return r.queueFor(k.URI.file(se),()=>{const X=I(Z);return new Promise((H,L)=>m(se,ue,X,W=>W?L(W):H()))},p.$xg)}let n=!0;function a(se){n=se}e.configureFlushOnWrite=a;function m(se,ue,Z,X){if(!n)return P.writeFile(se,ue,{mode:Z.mode,flag:Z.flag},X);P.open(se,Z.flag,Z.mode,(H,L)=>{if(H)return X(H);P.writeFile(L,ue,W=>{if(W)return P.close(L,()=>X(W));P.fdatasync(L,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),a(!1)),P.close(L,q=>X(q))))})})}function O(se,ue,Z){const X=I(Z);if(!n)return P.writeFileSync(se,ue,{mode:X.mode,flag:X.flag});const H=P.openSync(se,X.flag,X.mode);try{P.writeFileSync(H,ue);try{P.fdatasyncSync(H)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),a(!1)}}finally{P.closeSync(H)}}e.writeFileSync=O;function I(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function E(se,ue,Z=6e4){if(se!==ue)try{l.$i&&typeof Z=="number"?await C(se,ue,Date.now(),Z):await(0,s.promisify)(P.rename)(se,ue)}catch(X){if(se.toLowerCase()!==ue.toLowerCase()&&X.code==="EXDEV"||se.endsWith("."))await j(se,ue,{preserveSymlinks:!1}),await u(se,v.MOVE);else throw X}}async function C(se,ue,Z,X,H=0){try{return await(0,s.promisify)(P.rename)(se,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Z>=X)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${L}`),L;if(H===0){let W=!1;try{const{stat:V}=await o.stat(ue);V.isFile()||(W=!0)}catch{}if(W)throw L}return await(0,M.$6g)(Math.min(100,H*10)),C(se,ue,Z,X,H+1)}}async function j(se,ue,Z){return F(se,ue,{root:{source:se,target:ue},options:Z,handledSourcePaths:new Set})}const T=511;async function F(se,ue,Z){if(Z.handledSourcePaths.has(se))return;Z.handledSourcePaths.add(se);const{stat:X,symbolicLink:H}=await o.stat(se);if(H){if(Z.options.preserveSymlinks)try{return await le(se,ue,Z)}catch{}if(H.dangling)return}return X.isDirectory()?G(se,ue,X.mode&T,Z):J(se,ue,X.mode&T)}async function G(se,ue,Z,X){await e.Promises.mkdir(ue,{recursive:!0,mode:Z});const H=await d(se);for(const L of H)await F((0,f.$jc)(se,L),(0,f.$jc)(ue,L),X)}async function J(se,ue,Z){await e.Promises.copyFile(se,ue),await e.Promises.chmod(ue,Z)}async function le(se,ue,Z){let X=await e.Promises.readlink(se);(0,D.$7f)(X,Z.root.source,!l.$k)&&(X=(0,f.$jc)(Z.root.target,X.substr(Z.root.source.length+1))),await e.Promises.symlink(X,ue)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(se,ue,Z,X,H)=>new Promise((L,W)=>{P.read(se,ue,Z,X,H,(V,q,te)=>V?W(V):L({bytesRead:q,buffer:te}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(se,ue,Z,X,H)=>new Promise((L,W)=>{P.write(se,ue,Z,X,H,(V,q,te)=>V?W(V):L({bytesWritten:q,buffer:te}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return u}get rename(){return E}get copy(){return j}}}),define(oe[106],ae([0,1,46,9,4,25,21]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=e.$sq=void 0;function S(v){if(s.$k)return v;const u=(0,A.$mc)(v);if(v===u)return v;const y=((0,A.$nc)(v)||v).toLowerCase();try{const $=(0,D.readdirSync)(u).filter(d=>d.toLowerCase()===y);if($.length===1){const d=S(u);if(d)return(0,A.$jc)(d,$[0])}else if($.length>1){const d=$.indexOf(y);if(d>=0){const h=S(u);if(h)return(0,A.$jc)(h,$[d])}}}catch{}return null}e.$sq=S;async function f(v){if(s.$k)return v;const u=(0,A.$mc)(v);if(v===u)return v;const y=((0,A.$nc)(v)||v).toLowerCase();try{const $=(await D.Promises.readdir(u)).filter(d=>d.toLowerCase()===y);if($.length===1){const d=await f(u);if(d)return(0,A.$jc)(d,$[0])}else if($.length>1){const d=$.indexOf(y);if(d>=0){const h=await f(u);if(h)return(0,A.$jc)(h,$[d])}}}catch{}return null}e.$tq=f;async function l(v){try{return await D.Promises.realpath(v)}catch{const y=k(v);return await D.Promises.access(y,P.constants.R_OK),y}}e.$uq=l;function p(v){try{return P.realpathSync(v)}catch{const y=k(v);return P.accessSync(y,P.constants.R_OK),y}}e.$vq=p;function k(v){return(0,M.$Te)((0,A.$hc)(v),A.sep)}}),define(oe[107],ae([0,1,26,9,21]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class k{constructor(c,t,o){this.exePath=c,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:w=!1}={}){return w?l===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:w=!1,findPreview:c=!1}={}){const t=v({useAlternateBitness:w});if(!t)return null;const o=A.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const m of await s.Promises.readdir(o)){let O=-1;if(c){const E=m.indexOf("-");if(E<0)continue;const C=m.substring(0,E);if(!M.test(C)||m.substring(E+1)!=="preview")continue;O=parseInt(C,10)}else{if(!M.test(m))continue;O=parseInt(m,10)}if(O<=r)continue;const I=A.$jc(o,m,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(i=I,r=O)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=c?" Preview":"";return new k(i,`PowerShell${a}${n}`,!0)}async function y({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const c=A.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=w?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(c))if(t.test(r)){const i=A.$jc(c,r,"pwsh.exe");return new k(i,o)}return null}function b(){const w=A.$jc(P.homedir(),".dotnet","tools","pwsh.exe");return new k(w,".NET Core PowerShell Global Tool")}function $(){const w=A.$jc(process.env.windir,l===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(w,"Windows PowerShell",!0)}async function*d(){let w=await u();w&&(yield w),w=await u({useAlternateBitness:!0}),w&&(yield w),w=await y(),w&&(yield w),w=b(),w&&(yield w),w=await u({findPreview:!0}),w&&(yield w),w=await y({findPreview:!0}),w&&(yield w),w=await u({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=$(),w&&(yield w)}async function*h(){for await(const w of d())await w.exists()&&(yield w)}e.$Ol=h;async function g(){for await(const w of h())return w;return null}e.$Pl=g}),define(oe[89],ae([0,1,9,4,36,76,12,21]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Tl=e.$Sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(k=s.env){return k.comspec||"cmd.exe"}e.$Sl=f;function l(k){let v=[],u=!1;const y=function(b){if(u){v.push(b);return}(!k.send(b,d=>{if(d&&console.error(d),u=!1,v.length>0){const h=v.slice(0);v=[],h.forEach(g=>y(g))}})||A.$i)&&(u=!0)};return{send:y}}e.$Tl=l;var p;(function(k){async function v(u,y,b){if(P.$ic(u))return u;if(y===void 0&&(y=s.cwd()),P.$mc(u)!=="."||(b===void 0&&D.$Hf(s.env.PATH)&&(b=s.env.PATH.split(P.$tc)),b===void 0||b.length===0))return P.$jc(y,u);async function d(h){if(await S.Promises.exists(h)){let g;try{g=await S.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(g=await S.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(const h of b){let g;if(P.$ic(h)?g=P.$jc(h,u):g=P.$jc(y,h,u),await d(g))return g;let w=g+".com";if(await d(w)||(w=g+".exe",await d(w)))return w}return P.$jc(y,u)}k.findExecutable=v})(p||(e.win32=p={}))}),define(oe[108],ae([0,1,48,13]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;function s(D){return new Promise((S,f)=>{let l;const p=new Map;function k(u,y,b,$,d){const h=p.get(y);if(u===D||h){const g={name:v(b),cmd:b,pid:u,ppid:y,load:$,mem:d};p.set(u,g),u===D&&(l=g),h&&(h.children||(h.children=[]),h.children.push(g),h.children.length>1&&(h.children=h.children.sort((w,c)=>w.pid-c.pid)))}}function v(u){const y=/--utility-sub-type=network/i,b=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(b.exec(u))return"electron-crash-reporter";if($.exec(u))return"winpty-agent";if(d.exec(u))return"conpty-agent";let g=h.exec(u);if(g&&g.length===2)return g[1]==="renderer"?"window":g[1]==="utility"?y.exec(u)?"utility-network-service":"utility-process":g[1]==="extensionHost"?"extension-host":g[1];const w=/[a-zA-Z-]+\.js/g;let c="";do g=w.exec(u),g&&(c+=g+" ");while(g);return c&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${c})`:u}if(process.platform==="win32"){const u=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,b)=>{Q(["@vscode/windows-process-tree"],y,b)}).then(y=>{y.getProcessList(D,b=>{if(!b){f(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(b,$=>{const d=new Map;$.forEach(h=>{const g=u(h.commandLine||"");d.set(h.pid,{name:v(g),cmd:g,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),l=d.get(D),l?(d.forEach(h=>{const g=d.get(h.ppid);g&&(g.children||(g.children=[]),g.children.push(h))}),d.forEach(h=>{h.children&&(h.children=h.children.sort((g,w)=>g.pid-w.pid))}),S(l)):f(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let u=function(){let y=[l];const b=[];for(;y.length;){const d=y.shift();d&&(b.push(d.pid),d.children&&(y=y.concat(d.children)))}let $=JSON.stringify(A.$ng.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+b.join(" "),(0,P.exec)($,{},(d,h,g)=>{if(d||g)f(d||new Error(g.toString()));else{const w=h.toString().split(`
`);for(let c=0;c<b.length;c++){const t=p.get(b[c]);t.load=parseFloat(w[c])}if(!l){f(new Error(`Root process ${D} not found`));return}S(l)}})};(0,P.exec)("which ps",{},(y,b,$)=>{if(y||$)if(process.platform!=="linux")f(y||new Error($.toString()));else{const d=JSON.stringify(A.$ng.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(d,{},(h,g,w)=>{h||w?f(h||new Error(w.toString())):(M(g,k),u())})}else{const d=b.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${d} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,w,c)=>{g||c&&!c.includes("screen size is bogus")?f(g||new Error(c.toString())):(M(w,k),process.platform==="linux"?u():l?S(l):f(new Error(`Root process ${D} not found`)))})}})}})}e.$4r=s;function M(D,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=D.toString().split(`
`);for(const p of l){const k=f.exec(p.trim());k&&k.length===6&&S(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(oe[109],ae([0,1,26,4,107,89]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=void 0;async function D(k,v){return k===1?A.$i?p():M.$Sl(v):f(k,v)}e.$Ul=D;let S=null;function f(k,v){if(A.$k&&k===2||A.$j&&k===3)return"/bin/bash";if(!S){let u;if(A.$i)u="/bin/bash";else{if(u=v.SHELL,!u)try{u=(0,P.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}S=u}return S}let l=null;async function p(){return l||(l=(await(0,s.$Pl)()).exePath),l}});var Ee=this&&this.__decorate||function(Q,e,P,A){var s=arguments.length,M=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,P):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Q,e,P,A);else for(var S=Q.length-1;S>=0;S--)(D=Q[S])&&(M=(s<3?D(M):s>3?D(e,P,M):D(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(oe[43],ae([0,1,22,8,17,23,50,14,3,2,77,25,12]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.ProxyChannel=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.RequestInitiator=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;var u;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(u||(u={}));function y(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(b||(b={}));function $(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(d||(d={}));function h(H){let L=0;for(let W=0;;W+=7){const V=H.read(1);if(L|=(V.buffer[0]&127)<<W,!(V.buffer[0]&128))return L}}const g=r(0);function w(H,L){if(L===0){H.write(g);return}let W=0;for(let q=L;q!==0;q=q>>>7)W++;const V=s.$ie.alloc(W);for(let q=0;L!==0;q++)V.buffer[q]=L&127,L=L>>>7,L>0&&(V.buffer[q]|=128);H.write(V)}class c{constructor(L){this.b=L,this.a=0}read(L){const W=this.b.slice(this.a,this.a+L);return this.a+=W.byteLength,W}}e.$Ch=c;class t{constructor(){this.a=[]}get buffer(){return s.$ie.concat(this.a)}write(L){this.a.push(L)}}e.$Dh=t;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function r(H){const L=s.$ie.alloc(1);return L.writeUInt8(H,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function a(H,L){if(typeof L>"u")H.write(i.Undefined);else if(typeof L=="string"){const W=s.$ie.fromString(L);H.write(i.String),w(H,W.byteLength),H.write(W)}else if(n&&Buffer.isBuffer(L)){const W=s.$ie.wrap(L);H.write(i.Buffer),w(H,W.byteLength),H.write(W)}else if(L instanceof s.$ie)H.write(i.VSBuffer),w(H,L.byteLength),H.write(L);else if(Array.isArray(L)){H.write(i.Array),w(H,L.length);for(const W of L)a(H,W)}else if(typeof L=="number"&&(L|0)===L)H.write(i.Uint),w(H,L);else{const W=s.$ie.fromString(JSON.stringify(L));H.write(i.Object),w(H,W.byteLength),H.write(W)}}e.$Eh=a;function m(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(h(H)).toString();case o.Buffer:return H.read(h(H)).buffer;case o.VSBuffer:return H.read(h(H));case o.Array:{const W=h(H),V=[];for(let q=0;q<W;q++)V.push(m(H));return V}case o.Object:return JSON.parse(H.read(h(H)).toString());case o.Int:return h(H)}}e.$Fh=m;class O{constructor(L,W,V=null,q=1e3){this.h=L,this.j=W,this.k=V,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(L,W){this.b.set(L,W),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const W=this.o([L.type]);this.k?.logOutgoing(W,0,1,$(L.type));return}case 201:case 202:case 204:case 203:{const W=this.o([L.type,L.id],L.data);this.k?.logOutgoing(W,L.id,1,$(L.type),L.data);return}}}o(L,W=void 0){const V=new t;return a(V,L),a(V,W),this.p(V.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const W=new c(L),V=m(W),q=m(W),te=V[0];switch(te){case 100:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}: ${V[2]}.${V[3]}`,q),this.s({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}: ${V[2]}.${V[3]}`,q),this.t({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}`),this.u({type:te,id:V[1]});case 103:return this.k?.logIncoming(L.byteLength,V[1],1,`${y(te)}`),this.u({type:te,id:V[1]})}}s(L){const W=this.b.get(L.channelName);if(!W){this.v(L);return}const V=new M.$5d;let q;try{q=W.call(this.j,L.name,L.arg,V.token)}catch(K){q=Promise.reject(K)}const te=L.id;q.then(K=>{this.m({id:te,data:K,type:201})},K=>{K instanceof Error?this.m({id:te,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:te,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,l.$Rc)(()=>V.cancel());this.d.set(L.id,he)}t(L){const W=this.b.get(L.channelName);if(!W){this.v(L);return}const V=L.id,te=W.listen(this.j,L.name,L.arg)(he=>this.m({id:V,data:he,type:204}));this.d.set(L.id,te)}u(L){const W=this.d.get(L.id);W&&(W.dispose(),this.d.delete(L.id))}v(L){let W=this.g.get(L.channelName);W||(W=[],this.g.set(L.channelName,W));const V=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:L,timeoutTimer:V})}w(L){const W=this.g.get(L);if(W){for(const V of W)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Gh=O;var I;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(L,W=null){this.l=L,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Ud,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=W}getChannel(L){const W=this;return{call(V,q,te){return W.a?Promise.reject(new S.$5):W.m(L,V,q,te)},listen(V,q){return W.a?f.Event.None:W.o(L,V,q)}}}m(L,W,V,q=M.CancellationToken.None){const te=this.g++,K={id:te,type:100,channelName:L,name:W,arg:V};if(q.isCancellationRequested)return Promise.reject(new S.$5);let R;return new Promise((x,z)=>{if(q.isCancellationRequested)return z(new S.$5);const Y=()=>{const ce=re=>{switch(re.type){case 201:this.f.delete(te),x(re.data);break;case 202:{this.f.delete(te);const $e=new Error(re.data.message);$e.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,$e.name=re.data.name,z($e);break}case 203:this.f.delete(te),z(re.data);break}};this.f.set(te,ce),this.p(K)};let N=null;this.b===d.Idle?Y():(N=(0,A.$Sg)(ce=>this.u()),N.then(()=>{N=null,Y()}));const B=()=>{N?(N.cancel(),N=null):this.p({id:te,type:101}),z(new S.$5)},_=q.onCancellationRequested(B);R=(0,l.$Qc)((0,l.$Rc)(B),_),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(L,W,V){const q=this.g++,he={id:q,type:102,channelName:L,name:W,arg:V};let K=null;const R=new f.$Ud({onWillAddFirstListener:()=>{K=(0,A.$Sg)(x=>this.u()),K.then(()=>{K=null,this.d.add(R),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(R),this.p({id:q,type:103}))}}),U=x=>R.fire(x.data);return this.f.set(q,U),R.event}p(L){switch(L.type){case 100:case 102:{const W=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(W,L.id,0,`${y(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const W=this.q([L.type,L.id]);this.j?.logOutgoing(W,L.id,0,y(L.type));return}}}q(L,W=void 0){const V=new t;return a(V,L),a(V,W),this.r(V.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const W=new c(L),V=m(W),q=m(W),te=V[0];switch(te){case 200:return this.j?.logIncoming(L.byteLength,0,0,$(te)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,V[1],0,$(te),q),this.t({type:V[0],id:V[1],data:q})}}t(L){if(L.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=E,Ee([D.$wh],E.prototype,"onDidInitializePromise",null);class C{get connections(){const L=[];return this.f.forEach(W=>L.push(W)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new f.$Ud,this.onDidAddConnection=this.g.event,this.h=new f.$Ud,this.onDidRemoveConnection=this.h.event,this.j=new l.$Sc,this.j.add(L(({protocol:W,onDidClientDisconnect:V})=>{const q=f.Event.once(W.onMessage);this.j.add(q(te=>{const he=new c(te),K=m(he),R=new O(W,K),U=new E(W);this.a.forEach((z,Y)=>R.registerChannel(Y,z));const x={channelServer:R,channelClient:U,ctx:K};this.f.add(x),this.g.fire(x),this.j.add(V(()=>{R.dispose(),U.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,W){const V=this;return{call(q,te,he){let K;if((0,v.$Vf)(W)){const U=(0,P.$4b)(V.connections.filter(W));K=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(V.onDidAddConnection,W))}else K=W.routeCall(V,q,te);const R=K.then(U=>U.channelClient.getChannel(L));return T(R).call(q,te,he)},listen(q,te){if((0,v.$Vf)(W))return V.k(L,W,q,te);const he=W.routeEvent(V,q,te).then(K=>K.channelClient.getChannel(L));return T(he).listen(q,te)}}}k(L,W,V,q){const te=this;let he;const K=new f.$Ud({onWillAddFirstListener:()=>{he=new l.$Sc;const R=new f.$1d,U=new Map,x=Y=>{const B=Y.channelClient.getChannel(L).listen(V,q),_=R.add(B);U.set(Y,_)},z=Y=>{const N=U.get(Y);N&&(N.dispose(),U.delete(Y))};te.connections.filter(W).forEach(x),f.Event.filter(te.onDidAddConnection,W)(x,void 0,he),te.onDidRemoveConnection(z,void 0,he),R.event(K.fire,K,he),he.add(R)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(L,W){this.a.set(L,W);for(const V of this.f)V.channelServer.registerChannel(L,W)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Ih=C;class j{constructor(L,W,V=null){const q=new t;a(q,W),L.send(q.buffer),this.a=new E(L,V),this.d=new O(L,W,V)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,W){this.d.registerChannel(L,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Jh=j;function T(H){return{call(L,W,V){return H.then(q=>q.call(L,W,V))},listen(L,W){const V=new f.$4d;return H.then(q=>V.input=q.listen(L,W)),V.event}}}e.$Kh=T;function F(H){let L=!1;return{call(W,V,q){return L?H.call(W,V,q):(0,A.$6g)(0).then(()=>L=!0).then(()=>H.call(W,V,q))},listen(W,V){if(L)return H.listen(W,V);const q=new f.$4d;return(0,A.$6g)(0).then(()=>L=!0).then(()=>q.input=H.listen(W,V)),q.event}}}e.$Lh=F;class G{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const W of L.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await f.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Mh=G;var J;(function(H){function L(te,he,K){const R=te,U=K&&K.disableMarshalling,x=new Map;for(const z in R)V(z)&&x.set(z,f.Event.buffer(R[z],!0,void 0,he));return new class{listen(z,Y,N){const B=x.get(Y);if(B)return B;if(q(Y)){const _=R[Y];if(typeof _=="function")return _.call(R,N)}throw new S.$bb(`Event not found: ${Y}`)}call(z,Y,N){const B=R[Y];if(typeof B=="function"){if(!U&&Array.isArray(N))for(let ce=0;ce<N.length;ce++)N[ce]=(0,p.$Bh)(N[ce]);let _=B.apply(R,N);return _ instanceof Promise||(_=Promise.resolve(_)),_}throw new S.$bb(`Method not found: ${Y}`)}}}H.fromService=L;function W(te,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(R,U){if(typeof U=="string")return he?.properties?.has(U)?he.properties.get(U):q(U)?function(x){return te.listen(U,x)}:V(U)?te.listen(U):async function(...x){let z;he&&!(0,v.$Qf)(he.context)?z=[he.context,...x]:z=x;const Y=await te.call(U,z);return K?Y:(0,p.$Bh)(Y)};throw new S.$bb(`Property not found: ${String(U)}`)}})}H.toService=W;function V(te){return te[0]==="o"&&te[1]==="n"&&k.$0e(te.charCodeAt(2))}function q(te){return/^onDynamic/.test(te)&&k.$0e(te.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const L=H.toString();if(L!=="[object Object]")return L}return H}function ue(H){return Array.isArray(H)?H.map(se):se(H)}function Z(H,L,W,V,q,te,he){he=ue(he);const K=le[q],R=K[V%K.length];let U=[`%c[${H}]%c[${String(L).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(te)?(U=U.concat(he),U.push(")")):U.push(he),console.log.apply(console,U)}class X{constructor(L,W){this.d=L,this.f=W,this.a=0,this.b=0}logOutgoing(L,W,V,q,te){this.b+=L,Z(this.d,this.b,L,W,V,q,te)}logIncoming(L,W,V,q,te){this.a+=L,Z(this.f,this.a,L,W,V,q,te)}}e.$Nh=X}),define(oe[157],ae([0,1,17,3,43]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uU=e.$tU=void 0;class M{constructor(f){this.a=f,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?P.$ie.wrap(l.data):P.$ie.alloc(0)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$tU=M;class D extends s.$Jh{constructor(f,l){const p=new M(f);super(p,l),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}e.$uU=D}),define(oe[110],ae([0,1,17,3,2,43]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.ProtocolConstants=e.$Oh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function m(I,E){if(!n.has(I)){const C=String(++a);n.set(I,C)}return n.get(I)}function O(I,E,C,j){if(!i.enableDiagnostics)return;const T=m(I,E);if(j instanceof P.$ie||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const F=P.$ie.alloc(j.byteLength);F.set(j),i.records.push({timestamp:Date.now(),id:T,label:E,type:C,buff:F})}else i.records.push({timestamp:Date.now(),id:T,label:E,type:C,data:j})}i.traceSocketEvent=O})(S||(e.SocketDiagnostics=S={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let l=null;function p(){return l||(l=P.$ie.alloc(0)),l}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return p();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return a&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const m=P.$ie.alloc(n);let O=0,I=0;for(;n>0;){const E=this.a[I];if(E.byteLength>n){const C=E.slice(0,n);m.set(C,O),O+=n,a&&(this.a[I]=E.slice(n),this.b-=n),n-=n}else m.set(E,O),O+=E.byteLength,a?(this.a.shift(),this.b-=E.byteLength):I++,n-=E.byteLength}return m}}e.$Oh=k;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function u(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class b{constructor(n,a,m,O){this.type=n,this.id=a,this.ack=m,this.data=O,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends s.$Tc{constructor(n){super(),this.f=this.B(new A.$Ud),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new k,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,O=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new b(m,O,I,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=P.$ie.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const m=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,m}h(){const n=P.$ie.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Tc{constructor(n){super(),this.f=new A.$Ud,this.onMessage=this.f.event,this.g=new A.$Ud,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new d(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$Ph=h;class g extends M.$Jh{static fromSocket(n,a){return new g(new h(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,m=null){super(n,a,m),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Qh=g;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Ud({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Rh=w;class c{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,m=this.a;for(;m;)n[a++]=m.data,m=m.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new c(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<o.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+o.a)*1e3;let m=0;for(let O=0;O<o.a;O++)n-this.c[O]<=a&&m++;return 1-m/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new w,this.onControlMessage=this.u.event,this.v=new w,this.onMessage=this.v.event,this.w=new w,this.onDidDispose=this.w.event,this.x=new w,this.onSocketClose=this.x.event,this.y=new w,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=n.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,p());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,p());this.p.write(n)}sendResume(){const n=new b(8,0,0,p());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,p());this.p.write(n);const a=this.b.toArray();for(let m=0,O=a.length;m<O;m++)this.p.write(a[m]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new b(6,0,0,p())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let m=0,O=a.length;m<O;m++)this.p.write(a[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const m=new b(1,a,this.h,n);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(n){const a=new b(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,m=Date.now()-this.q.lastReadTime,O=Date.now()-this.n;if(a>=2e4&&m>=2e4&&O>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:m});return}const I=Math.max(2e4-a,2e4-m,2e4-O,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,p());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,p());this.p.write(n)}}e.$Sh=r}),define(oe[37],ae([0,1,15,14,13]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=void 0;class M{constructor(){this.a=new WeakMap}on(S,f){const l=(p,...k)=>{this.b(S,p)&&f(p,...k)};return this.a.set(f,l),P.ipcMain.on(S,l),this}once(S,f){return P.ipcMain.once(S,(l,...p)=>{this.b(S,l)&&f(l,...p)}),this}handle(S,f){return P.ipcMain.handle(S,(l,...p)=>this.b(S,l)?f(l,...p):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,f){const l=this.a.get(f);return l&&(P.ipcMain.removeListener(S,l),this.a.delete(f)),this}b(S,f){if(!S||!S.startsWith("vscode:"))return(0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const l=f.senderFrame,p=l.url;if(!p||p==="about:blank")return!0;let k="unknown";try{k=new URL(p).host}catch{return(0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${p}'.`),!1}return k!==s.$mg?((0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${k}'.`),!1):l.parent!==null?((0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${k}' is not a main frame.`),!1):!0}}e.$qU=new M}),define(oe[158],ae([0,1,15,37,146]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rU=void 0;function M(){A.$qU.on(s.$oU,(S,f,l,p,k)=>{const v=D(S,p,l);v.popup({x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{v&&S.sender.send(s.$pU,f)}})})}e.$rU=M;function D(S,f,l){const p=new P.Menu;return l.forEach(k=>{let v;k.type==="separator"?v=new P.MenuItem({type:k.type}):Array.isArray(k.submenu)?v=new P.MenuItem({submenu:D(S,f,k.submenu),label:k.label}):v=new P.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(u,y,b)=>S.sender.send(f,k.id,b)}),p.append(v)}),p}}),define(oe[159],ae([0,1,37,17,3,2,43,147]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xU=void 0;function f(p,k){const v=s.Event.fromNodeEventEmitter(P.$qU,k,(y,b)=>({event:y,message:b})),u=s.Event.filter(v,({event:y})=>y.sender.id===p);return s.Event.map(u,({message:y})=>y&&A.$ie.wrap(y))}class l extends D.$Ih{static{this.b=new Map}static d(){const k=s.Event.fromNodeEventEmitter(P.$qU,"vscode:hello",({sender:v})=>v);return s.Event.map(k,v=>{const u=v.id;l.b.get(u)?.dispose();const b=new s.$Ud;l.b.set(u,(0,M.$Rc)(()=>b.fire()));const $=f(u,"vscode:message"),d=s.Event.any(s.Event.signal(f(u,"vscode:disconnect")),b.event);return{protocol:new S.$wU(v,$),onDidClientDisconnect:d}})}constructor(){super(l.d())}}e.$xU=l}),define(oe[111],ae([0,1,37,3,32,157]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zU=e.$yU=void 0;class D extends M.$uU{constructor(l,p){super({addEventListener:(k,v)=>l.addListener(k,v),removeEventListener:(k,v)=>l.removeListener(k,v),postMessage:k=>l.postMessage(k),start:()=>l.start(),close:()=>l.close()},p)}}e.$yU=D;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$pg)();f.webContents.send("vscode:createMessageChannel",l);const p=A.Event.fromNodeEventEmitter(P.$qU,"vscode:createMessageChannelResult",(v,u)=>({nonce:u,port:v.ports[0]})),{port:k}=await A.Event.toPromise(A.Event.once(A.Event.filter(p,v=>v.nonce===l)));return k}e.$zU=S}),define(oe[160],ae([0,1,48,8,17,23,154,14,3,2,35,89,76,43]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class y extends u.$Gh{constructor(d){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>s.$ie.wrap(Buffer.from(h,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$pq=y;class b{constructor(d,h){this.i=d,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.$Ud,this.onDidProcessExit=this.h.event;const g=h&&h.timeout?h.timeout:6e4;this.b=new A.$2g(g),this.d=null,this.f=null}getChannel(d){const h=this;return{call(g,w,c){return h.k(d,g,w,c)},listen(g,w){return h.l(d,g,w)}}}k(d,h,g,w=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const c=this.n(d),t=(0,A.$Sg)(i=>c.call(h,g,i)),o=w.onCancellationRequested(()=>t.cancel()),r=(0,l.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,h,g){if(!this.b)return f.Event.None;this.b.cancel();let w;const c=new f.$Ud({onWillAddFirstListener:()=>{w=this.n(d).listen(h,g)(c.fire,c),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,p.$un)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,v.$Rl)(h.env),this.d=(0,P.fork)(this.i,d,h);const g=new f.$Ud;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$lq)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}g.fire(s.$ie.wrap(Buffer.from(n,"base64")))});const c=this.j.useQueue?(0,k.$Tl)(this.d):this.d,t=n=>this.d&&this.d.connected&&c.send(n.buffer.toString("base64")),o=g.event,r={send:t,onMessage:o};this.f=new u.$Hh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(m=>(0,l.$Oc)(m)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(d){let h=this.g.get(d);return h||(h=this.m.getChannel(d),this.g.set(d,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qq=b}),define(oe[112],ae([0,1,8,3,2,77,12]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.StorageState=e.$op=e.StorageHint=void 0;var S;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(v){const u=v;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$op=f;var l;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(l||(e.StorageState=l={}));class p extends s.$Tc{static{this.a=100}constructor(u,y=Object.create(null)){super(),this.r=u,this.s=y,this.b=this.B(new A.$Xd),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$3g(p.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach((y,b)=>this.w(b,y)),u.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(u,y){if(this.c===l.Closed)return;let b=!1;(0,D.$Qf)(y)?b=this.f.delete(u):this.f.get(u)!==y&&(this.f.set(u,y),b=!0),b&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,y){const b=this.f.get(u);return(0,D.$Qf)(b)?y:b}getBoolean(u,y){const b=this.get(u);return(0,D.$Qf)(b)?y:b==="true"}getNumber(u,y){const b=this.get(u);return(0,D.$Qf)(b)?y:parseInt(b,10)}getObject(u,y){const b=this.get(u);return(0,D.$Qf)(b)?y:(0,M.$Ah)(b)}async set(u,y,b=!1){if(this.c===l.Closed)return;if((0,D.$Qf)(y))return this.delete(u,b);const $=(0,D.$Jf)(y)||Array.isArray(y)?(0,M.$zh)(y):String(y);if(this.f.get(u)!==$)return this.f.set(u,$),this.j.set(u,$),this.h.delete(u),this.b.fire({key:u,external:b}),this.D()}async delete(u,y=!1){if(!(this.c===l.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:y}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$pp=p;class k{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((y,b)=>this.a.set(b,y)),u.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$qp=k}),define(oe[161],ae([0,1,8,3,31,9,21]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VU=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor(p,k=Object.create(null)){this.g=p,this.h=k,this.c=(0,M.$nc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,k=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(u=>k.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${k.size} rows`),k}async updateItems(p){const k=await this.f;return this.j(k,p)}j(p,k){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${k.insert?(0,s.$yc)(k.insert):"0"}), delete(${k.delete?(0,s.$zc)(k.delete):"0"})`),this.t(p,()=>{const v=k.insert,u=k.delete;if(v&&v.size>0){const y=[];y.push([]);let b=0;v.forEach(($,d)=>{let h=y[b];h.length>S.b&&(b++,h=[],y.push(h)),h.push(d,$)}),y.forEach($=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array($.length/2).fill("(?,?)").join(",")}`,d=>d.run($),()=>{const d=[];let h=0;return v.forEach((g,w)=>{d.push(w),h+=g.length}),`Keys: ${d.join(", ")} Length: ${h}`})})}if(u&&u.size){const y=[];y.push([]);let b=0;u.forEach($=>{let d=y[b];d.length>S.b&&(b++,d=[],y.push(d)),d.push($)}),y.forEach($=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array($.length).fill("?").join(",")})`,d=>d.run($),()=>{const d=[];return u.forEach(h=>{d.push(h)}),`Keys: ${d.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const p=await this.f;return this.q(p,"VACUUM")}async close(p){this.d.trace(`[storage ${this.c}] close()`);const k=await this.f;return this.k(k,p)}k(p,k){return new Promise((v,u)=>{p.db.close(y=>(y&&this.o(p,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?v():!p.isErroneous&&!p.isInMemory?this.l().then(v,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),v())):typeof k=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const $=()=>this.k(b,void 0);return this.j(b,{insert:k()}).then(()=>$(),d=>($(),Promise.reject(d)))})).then(v,u):u(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return D.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const k=await this.f,v=await this.r(k,p?"PRAGMA integrity_check":"PRAGMA quick_check"),u=p?v.integrity_check:v.quick_check;return k.isErroneous?`${u} (last error: ${k.lastError})`:k.isInMemory?`${u} (in-memory!)`:u}async n(p,k=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${k})`);try{return await this.p(p)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&k)return await(0,P.$6g)(S.a),this.n(p,!1);try{await D.Promises.unlink(p);try{await D.Promises.rename(this.m(p),p,!1)}catch{}return await this.p(p)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(S.IN_MEMORY_PATH)}}}o(p,k){p.isErroneous=!0,p.lastError=k,this.d.error(k)}p(p){return new Promise((k,v)=>{new Promise((u,y)=>{Q(["@vscode/sqlite3"],u,y)}).then(u=>{const y={db:new(this.d.isTracing?u.verbose().Database:u.Database)(p,b=>b?y.db&&b.code!=="SQLITE_CANTOPEN"?y.db.close(()=>v(b)):v(b):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(y),$=>y.db.close(()=>v($)))),isInMemory:p===S.IN_MEMORY_PATH};y.db.on("error",b=>this.o(y,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&y.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},v)})}q(p,k){return new Promise((v,u)=>{p.db.exec(k,y=>y?(this.o(p,`[storage ${this.c}] exec(): ${y}`),u(y)):v())})}r(p,k){return new Promise((v,u)=>{p.db.get(k,(y,b)=>y?(this.o(p,`[storage ${this.c}] get(): ${y}`),u(y)):v(b))})}s(p,k){return new Promise((v,u)=>{p.db.all(k,(y,b)=>y?(this.o(p,`[storage ${this.c}] all(): ${y}`),u(y)):v(b))})}t(p,k){return new Promise((v,u)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),k(),p.db.run("END TRANSACTION",y=>y?(this.o(p,`[storage ${this.c}] transaction(): ${y}`),u(y)):v())})})}u(p,k,v,u){const y=p.db.prepare(k),b=$=>{this.o(p,`[storage ${this.c}] prepare(): ${$} (${k}). Details: ${u()}`)};y.on("error",b),v(y),y.finalize($=>{$&&b($),y.removeListener("error",b)})}}e.$VU=S;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(p){p&&typeof p.logTrace=="function"&&process.env[f.a]&&(this.b=p.logTrace),p&&typeof p.logError=="function"&&(this.c=p.logError)}get isTracing(){return!!this.b}trace(p){this.b?.(p)}error(p){this.c?.(p)}}}),define(oe[162],ae([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(oe[163],ae([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[164],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[165],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(oe[166],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[167],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[168],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(oe[169],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(oe[170],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[171],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[172],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[173],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[174],ae([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[175],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(oe[176],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(oe[177],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(oe[178],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[179],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[180],ae([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[181],ae([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[182],ae([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[183],ae([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(oe[184],ae([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(oe[185],ae([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[186],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[187],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[188],ae([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[189],ae([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[190],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[191],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[192],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(oe[193],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[194],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[195],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncb=e.$mcb=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$mcb=P;function A(s){return s&&s.hasOwnProperty("workspace")}e.$ncb=A}),define(oe[196],ae([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$29b=e.$19b=e.$Z9b=void 0;function A(D){return typeof D?.backupFolder=="string"}e.$Z9b=A;function s(D){let S=[];try{Array.isArray(D.workspaces)&&(S=D.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$19b=s;function M(D){let S=[];try{Array.isArray(D.folders)&&(S=D.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$29b=M}),define(oe[197],ae([0,1,14,165]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...l){switch(l.length){case 1:return(0,A.localize)(0,null,l[0]);case 2:return(0,A.localize)(1,null,l[0],l[1]);case 3:return(0,A.localize)(2,null,l[0],l[1],l[2]);default:return}}const D=(0,A.localize)(3,null),S=(0,A.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const k=this.d,v=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:v};this.g.push({offset:k,lexeme:v,additionalInfo:p}),this.f.push(u)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const k=this.c.substring(this.d,this.e),v=f.b.get(k);v?this.k(v):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,k=!1,v=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(S);return}const y=this.c.charCodeAt(p);if(k)k=!1;else if(y===47&&!v){p++;break}else y===91?v=!0:y===92?k=!0:y===93&&(v=!1);p++}for(;p<this.c.length&&f.a.has(this.c.charCodeAt(p));)p++;this.e=p;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$Zi=f}),define(oe[198],ae([0,1,3,2]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=void 0;class s{constructor(){this.a=new P.$Ud,this.b=new P.$Ud,this.c=new P.$Ud,this.d=new P.$Ud}static{this.ChannelName="extensionhostdebugservice"}call(S,f,l){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(S,f,l){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$ao=s;class M extends A.$Tc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,l){this.b.call("attach",[S,f,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$bo=M}),define(oe[199],ae([0,1,149,50,13,9,36,19,7]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$wm=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,M.$mc)(s.$ng.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Gg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Gg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,P.$vm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",u)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Gg)(f.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Gg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Gg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Gg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=D.env.VSCODE_PORTABLE;return u?f.URI.file((0,M.$jc)(u,"argv.json")):(0,S.$Gg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,M.$kc)(u):(0,M.$hc)((0,M.$jc)(s.$ng.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?f.URI.file((0,M.$kc)(u)):f.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,M.$kc)(u);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const b=D.env.VSCODE_PORTABLE;return b?(0,M.$jc)(b,"extensions"):(0,S.$Gg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,M.$hc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?f.URI.parse(u):f.URI.file((0,M.$hc)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$wm.test(u))}get extensionLogLevel(){const u=[];for(const y of this.args.log||[]){const b=e.$wm.exec(y);b&&b[1]&&b[2]&&u.push([b[1],b[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,S.$Gg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=D.env.VSCODE_PORTABLE;return u?f.URI.file((0,M.$jc)(u,"policy.json")):(0,S.$Gg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,y,b){this.a=u,this.b=y,this.c=b,this.editSessionId=this.args.editSessionId}}e.$xm=l,Ee([A.$wh],l.prototype,"appRoot",null),Ee([A.$wh],l.prototype,"userHome",null),Ee([A.$wh],l.prototype,"userDataPath",null),Ee([A.$wh],l.prototype,"appSettingsHome",null),Ee([A.$wh],l.prototype,"tmpDir",null),Ee([A.$wh],l.prototype,"cacheHome",null),Ee([A.$wh],l.prototype,"stateResource",null),Ee([A.$wh],l.prototype,"userRoamingDataHome",null),Ee([A.$wh],l.prototype,"userDataSyncHome",null),Ee([A.$wh],l.prototype,"sync",null),Ee([A.$wh],l.prototype,"machineSettingsResource",null),Ee([A.$wh],l.prototype,"workspaceStorageHome",null),Ee([A.$wh],l.prototype,"localHistoryHome",null),Ee([A.$wh],l.prototype,"keyboardLayoutResource",null),Ee([A.$wh],l.prototype,"argvResource",null),Ee([A.$wh],l.prototype,"isExtensionDevelopment",null),Ee([A.$wh],l.prototype,"untitledWorkspacesHome",null),Ee([A.$wh],l.prototype,"builtinExtensionsPath",null),Ee([A.$wh],l.prototype,"extensionsPath",null),Ee([A.$wh],l.prototype,"extensionDevelopmentLocationURI",null),Ee([A.$wh],l.prototype,"extensionDevelopmentKind",null),Ee([A.$wh],l.prototype,"extensionTestsLocationURI",null),Ee([A.$wh],l.prototype,"debugExtensionHost",null),Ee([A.$wh],l.prototype,"logLevel",null),Ee([A.$wh],l.prototype,"extensionLogLevel",null),Ee([A.$wh],l.prototype,"serviceMachineIdResource",null),Ee([A.$wh],l.prototype,"disableTelemetry",null),Ee([A.$wh],l.prototype,"disableWorkspaceTrust",null),Ee([A.$wh],l.prototype,"useInMemorySecretStorage",null),Ee([A.$wh],l.prototype,"policyFile",null);function p(v,u){return k(v["inspect-extensions"],v["inspect-brk-extensions"],5870,u,v.debugId,v.extensionEnvironment)}e.$ym=p;function k(v,u,y,b,$,d){const g=Number(u||v)||(b?null:y),w=g?!!u:!1;let c;if(d)try{c=JSON.parse(d)}catch{}return{port:g,break:w,debugId:$,env:c}}e.$zm=k}),define(oe[113],ae([0,1,309,4,168]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Vl=["tunnel","serve-web"],e.$Wl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(b,$,d=D){const h=b.find(a=>a.length>0&&a[0]!=="-"),g={},w=["_"],c=[],t={};let o;for(const a in $){const m=$[a];m.type==="subcommand"?a===h&&(o=m):(m.alias&&(g[a]=m.alias),m.type==="string"||m.type==="string[]"?(w.push(a),m.deprecates&&w.push(...m.deprecates)):m.type==="boolean"&&(c.push(a),m.deprecates&&c.push(...m.deprecates)),m.global&&(t[a]=m))}if(o&&h){const a=t;for(const E in o.options)a[E]=o.options[E];const m=b.filter(E=>E!==h),O=d.getSubcommandReporter?d.getSubcommandReporter(h):void 0,I=S(m,a,O);return{[h]:I,_:[]}}const r=P(b,{string:w,boolean:c,alias:g}),i={},n=r;i._=r._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in $){const m=$[a];if(m.type==="subcommand")continue;m.alias&&delete n[m.alias];let O=n[a];if(m.deprecates)for(const I of m.deprecates)n.hasOwnProperty(I)&&(O||(O=n[I],O&&d.onDeprecatedOption(I,m.deprecationMessage||(0,s.localize)(38,null,a))),delete n[I]);if(typeof O<"u"){if(m.type==="string[]"){if(Array.isArray(O)||(O=[O]),!m.allowEmptyValue){const I=O.filter(E=>E.length>0);I.length!==O.length&&(d.onEmptyValue(a),O=I.length>0?I:void 0)}}else m.type==="string"&&(Array.isArray(O)?(O=O.pop(),d.onMultipleValues(a,O)):!O&&!m.allowEmptyValue&&(d.onEmptyValue(a),O=void 0));i[a]=O,m.deprecationMessage&&d.onDeprecatedOption(a,m.deprecationMessage)}delete n[a]}for(const a in n)d.onUnknownOption(a);return i}e.$Xl=S;function f(b,$){let d="";return $.args&&(Array.isArray($.args)?d=` <${$.args.join("> <")}>`:d=` <${$.args}>`),$.alias?`-${$.alias} --${b}${d}`:`--${b}${d}`}function l(b,$){const d=[];for(const h in b){const g=b[h],w=f(h,g);d.push([w,g.description])}return p(d,$)}e.$Yl=l;function p(b,$){const h=b.reduce((c,t)=>Math.max(c,t[0].length),12)+2+1;if($-h<25)return b.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const g=$-h-1,w=[];for(const c of b){const t=c[0],o=v(c[1],g),r=k(h-t.length-2);w.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)w.push(k(h)+o[i])}return w}function k(b){return" ".repeat(b)}function v(b,$){const d=[];for(;b.length;){const h=b.length<$?b.length:b.lastIndexOf(" ",$),g=b.slice(0,h).trim();b=b.slice(h),d.push(g)}return d}function u(b,$,d,h,g){const w=process.stdout.isTTY&&process.stdout.columns||80,c=g?.noInputFiles!==!0?`[${(0,s.localize)(39,null)}...]`:"",t=[`${b} ${d}`];t.push(""),t.push(`${(0,s.localize)(40,null)}: ${$} [${(0,s.localize)(41,null)}]${c}`),t.push(""),g?.noPipe!==!0&&(A.$i?t.push((0,s.localize)(42,null,$)):t.push((0,s.localize)(43,null,$)),t.push(""));const o={},r=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let a=o[n.cat];a||(o[n.cat]=a={}),a[i]=n}}for(const i in o){const n=i,a=o[n];a&&(t.push(M[n]),t.push(...l(a,w)),t.push(""))}return r.length&&(t.push((0,s.localize)(44,null)),t.push(...p(r.map(i=>[i.command,i.description]),w)),t.push("")),t.join(`
`)}e.$Zl=u;function y(b,$){return`${b||(0,s.localize)(45,null)}
${$||(0,s.localize)(46,null)}
${process.arch}`}e.$1l=y}),define(oe[200],ae([0,1,87,198,113]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=void 0;class M extends A.$ao{constructor(S){super(),this.f=S}call(S,f,l){return f==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(S,f,l)}async g(S,f){const l=(0,s.$Xl)(S,s.$Wl);l.debugRenderer=f;const p=l.extensionDevelopmentPath;if(!p)return{success:!1};const[k]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!f)return{success:!0};const v=k.win;if(!v)return{success:!0};const u=v.webContents.debugger;let y=u.isAttached()?1/0:0;const b=(0,P.createServer)($=>{y++===0&&u.attach();let d=!1;const h=c=>{d||$.write(JSON.stringify(c)+"\0")},g=(c,t,o,r)=>h({method:t,params:o,sessionId:r});v.on("close",()=>{u.removeListener("message",g),$.end(),d=!0}),u.addListener("message",g);let w=Buffer.alloc(0);$.on("data",c=>{w=Buffer.concat([w,c]);for(let t=w.indexOf(0);t!==-1;t=w.indexOf(0)){let o;try{const r=w.slice(0,t).toString("utf8");w=w.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}u.sendCommand(o.method,o.params,o.sessionId).then(r=>h({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>h({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),$.on("error",c=>{console.error("error on cdp pipe:",c)}),$.on("close",()=>{d=!0,--y===0&&u.detach()})});return await new Promise($=>b.listen(0,$)),v.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$E0b=M}),define(oe[64],ae([0,1,310,169,113]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=void 0;function M(k,v){const u=(g,w)=>{console.warn((0,A.localize)(0,null,g,w))},y=g=>{console.warn((0,A.localize)(1,null,g))},b=(g,w)=>{console.warn((0,A.localize)(2,null,g,w))},$=g=>({onUnknownOption:w=>{s.$Vl.includes(g)||console.warn((0,A.localize)(3,null,w,g))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:s.$Vl.includes(g)?$:void 0}),d={onUnknownOption:g=>{console.warn((0,A.localize)(4,null,g))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:$},h=(0,s.$Xl)(k,s.$Wl,v?d:void 0);return h.goto&&h._.forEach(g=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(g),(0,A.localize)(5,null))),h}function D(k){const v=k.findIndex(u=>!/^-/.test(u));if(v>-1)return[...k.slice(0,v),...k.slice(v+1)]}function S(k){let[,...v]=k;process.env.VSCODE_DEV&&(v=D(v)||[]);const u=!p(process.env);return M(v,u)}e.$2l=S;function f(k){let[,,...v]=k;return process.env.VSCODE_DEV&&(v=D(v)||[]),M(v,!0)}e.$3l=f;function l(k,...v){const u=k.indexOf("--");return u===-1?k.push(...v):k.splice(u,0,...v),k}e.$4l=l;function p(k){return k.VSCODE_CLI==="1"}e.$5l=p}),function(){"use strict";function Q(e,P,A){function s(D,S){const f=M(D,S),l=[f];return e.isAbsolute(f)||l.unshift(A),e.resolve(...l)}function M(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,S);const p=D["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(k,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,S)}return{getUserDataPath:s}}if(typeof define=="function")define(oe[201],ae([114,26,36]),function(e,P,A){return Q(e,P,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Q(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[90],ae([0,1,26,199,201]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0;class M extends A.$xm{constructor(l,p){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,p.nameShort)},p)}}e.$Am=M;function D(f,l){return(0,A.$zm)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.$Bm=D;function S(f,l){return(0,A.$zm)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.$Cm=S}),define(oe[202],ae([0,1,46,26,33]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=void 0;function M(D){const S=(0,s.$cg)((0,A.tmpdir)());try{return(0,P.writeFileSync)(S,""),D&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$W$b=M}),define(oe[203],ae([0,1,12,171]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;function s(D,S,f,l){try{M(D,S,f,l)}catch(p){D.error(p?.message??p)}return S}e.$Xp=s;function M(D,S,f,l){const p=(k,v,u)=>{const y=k[v];if((0,P.$Hf)(y)){const b=y,$=b.length;if($>1&&b[0]==="%"&&b[$-1]==="%"){const d=b.substr(1,$-2);let h=f[d];h===void 0&&l&&(h=l[d]);const g=typeof h=="string"?h:h?.message,w=l?.[d],c=typeof w=="string"?w:w?.message;if(!g){c||D.warn(`[${S.name}]: ${(0,A.localize)(0,null,d)}`);return}if(u&&(v==="title"||v==="category")&&c&&c!==g){const t={value:g,original:c};k[v]=t}else k[v]=g}}else if((0,P.$Jf)(y))for(const b in y)y.hasOwnProperty(b)&&(b==="commands"?p(y,b,!0):p(y,b,u));else if(Array.isArray(y))for(let b=0;b<y.length;b++)p(y,b,u)};for(const k in S)S.hasOwnProperty(k)&&p(S,k)}}),define(oe[204],ae([0,1,19,74,173,205]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f(d){return d=d.trim(),d==="*"||D.test(d)}e.$_o=f;function l(d){if(!f(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(D);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$ap=l;function p(d){if(!d)return null;const h=d.majorBase,g=d.majorMustEqual,w=d.minorBase;let c=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(h===0||(c=!1),o=!1);let r=0;if(d.preRelease){const i=S.exec(d.preRelease);if(i){const[,n,a,m]=i;r=Date.UTC(Number(n),Number(a)-1,Number(m))}}return{majorBase:h,majorMustEqual:g,minorBase:w,minorMustEqual:c,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:r}}e.$bp=p;function k(d,h,g){let w;typeof d=="string"?w=p(l(d)):w=d;let c;h instanceof Date?c=h.getTime():typeof h=="string"&&(c=new Date(h).getTime());let t;if(typeof g=="string"?t=p(l(g)):t=g,!w||!t)return!1;const o=w.majorBase,r=w.minorBase,i=w.patchBase;let n=t.majorBase,a=t.minorBase,m=t.patchBase;const O=t.notBefore;let I=t.majorMustEqual,E=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>a?!0:r<a||c&&c<O?!1:i>=m:(o===1&&n===0&&(!I||!E||!C)&&(n=1,a=0,m=0,I=!0,E=!1,C=!1),o<n?!1:o>n?!I:r<a?!1:r>a?!E:i<m?!1:i>m?!C:!(c&&c<O))}e.$cp=k;function v(d,h,g,w,c){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([A.default.Error,s.localize(0,null)]),t;if(typeof w.name!="string")return t.push([A.default.Error,s.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([A.default.Error,s.localize(2,null,"version")]),t;if(!w.engines)return t.push([A.default.Error,s.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([A.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!$(w.extensionDependencies))return t.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!$(w.activationEvents))return t.push([A.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([A.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$Gg)(g,w.main);(0,P.$Ag)(i,g)||t.push([A.default.Warning,s.localize(10,null,i.path,g.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([A.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$Gg)(g,w.browser);(0,P.$Ag)(i,g)||t.push([A.default.Warning,s.localize(12,null,i.path,g.path)])}}if(!M.valid(w.version))return t.push([A.default.Error,s.localize(13,null)]),t;const o=[];if(!u(d,h,w,c,o))for(const i of o)t.push([A.default.Error,i]);return t}e.$dp=v;function u(d,h,g,w,c){return w||typeof g.main>"u"&&typeof g.browser>"u"?!0:b(d,h,g.engines.vscode,c)}e.$ep=u;function y(d,h,g){return d==="*"||b(h,g,d)}e.$fp=y;function b(d,h,g,w=[]){const c=p(l(g));if(!c)return w.push(s.localize(14,null,g)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return w.push(s.localize(15,null,g)),!1}else if(!c.majorMustEqual)return w.push(s.localize(16,null,g)),!1;return k(d,h,c)?!0:(w.push(s.localize(17,null,d,g)),!1)}function $(d){if(!Array.isArray(d))return!1;for(let h=0,g=d.length;h<g;h++)if(typeof d[h]!="string")return!1;return!0}}),define(oe[206],ae([0,1,17,32]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;async function s(M,D,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const p=(await D.readFile(M.serviceMachineIdResource)).value.toString();f=(0,A.$og)(p)?p:null}catch{f=null}if(!f){f=(0,A.$pg)();try{await D.writeFile(M.serviceMachineIdResource,P.$ie.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$zp=s}),define(oe[78],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class P{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$2h=P}),define(oe[207],ae([0,1,78]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.InstantiationType=void 0;const A=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,f,l){f instanceof P.$2h||(f=new P.$2h(f,[],!!l)),A.push([S,f])}e.$Xr=M;function D(){return A}e.$Yr=D}),define(oe[208],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class P{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Bq=P;class A{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const S=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(D);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let S=this.a.get(D);return S||(S=new P(D,M),this.a.set(D,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,S]of this.a)M.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const S=new Set([M]),f=this.c(D,S);if(f)return f}}c(M,D){for(const[S,f]of M.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const l=this.c(f,D);if(l)return l;D.delete(S)}}}e.$Cq=A}),define(oe[6],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(P||(e._util=P={})),e.$4h=s("instantiationService");function A(D,S,f){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:D,index:f}):(S[P.DI_DEPENDENCIES]=[{id:D,index:f}],S[P.DI_TARGET]=S)}function s(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const S=function(f,l,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(S,f,p)};return S.toString=()=>D,P.serviceIds.set(D,S),S}e.$5h=s;function M(D){return D}e.$6h=M}),define(oe[65],ae([0,1,13,6]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$09b=e.$99b=void 0,e.$99b=(0,A.$5h)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${P.Schemas.vscodeFileResource}://${P.$mg}/`)}e.$09b=s}),define(oe[66],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$39b=void 0,e.$39b=(0,P.$5h)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.ConfigurationTarget=e.$Ai=e.$zi=e.$yi=void 0,e.$yi=(0,s.$5h)("configurationService");function M(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof A.URI)}e.$zi=M;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof A.URI)}e.$Ai=D;var S;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Bi=f;function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$Ci=l;function p(d,h){const g=Object.create(null);for(const w in d)k(g,w,d[w],h);return g}e.$Di=p;function k(d,h,g,w){const c=h.split("."),t=c.pop();let o=d;for(let r=0;r<c.length;r++){const i=c[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:w(`Ignoring ${h} as ${c.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=g}catch{w(`Ignoring ${h} as ${c.join(".")} is ${JSON.stringify(o)}`)}else w(`Ignoring ${h} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.$Ei=k;function v(d,h){const g=h.split(".");u(d,g)}e.$Fi=v;function u(d,h){const g=h.shift();if(h.length===0){delete d[g];return}if(Object.keys(d).indexOf(g)!==-1){const w=d[g];typeof w=="object"&&!Array.isArray(w)&&(u(w,h),Object.keys(w).length===0&&delete d[g])}}function y(d,h,g){function w(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const c=h.split("."),t=w(d,c);return typeof t>"u"?g:t}e.$Gi=y;function b(d,h,g){Object.keys(h).forEach(w=>{w!=="__proto__"&&(w in d?P.$Jf(d[w])&&P.$Jf(h[w])?b(d[w],h[w],g):g&&(d[w]=h[w]):d[w]=h[w])})}e.$Hi=b;function $(d){return d.replace(/[\[\]]/g,"")}e.$Ii=$}),define(oe[115],ae([0,1,4,25,197,6,164,14]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.ContextKeyExprType=e.$1i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",P.$j),f.set("isLinux",P.$k),f.set("isWindows",P.$i),f.set("isWeb",P.$o),f.set("isMacNative",P.$j&&!P.$o),f.set("isEdge",P.$H),f.set("isFirefox",P.$F),f.set("isChrome",P.$E),f.set("isSafari",P.$G);function l(K,R){if(f.get(K)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(K,R)}e.$1i=l;const p=Object.prototype.hasOwnProperty;var k;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const v={regexParsingWithErrorRecovery:!0},u=(0,D.localize)(0,null),y=(0,D.localize)(1,null),b=(0,D.localize)(2,null),$=(0,D.localize)(3,null),d=(0,D.localize)(4,null),h=(0,D.localize)(5,null),g=(0,D.localize)(6,null),w=(0,D.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=v){this.k=R,this.d=new s.$Zi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const x=this.D(),z=x.type===17?h:void 0;throw this.h.push({message:d,offset:x.offset,lexeme:s.$Zi.getLexeme(x),additionalInfo:z}),c.c}return U}catch(U){if(U!==c.c)throw U;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const U=this.o();R.push(U)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const U=this.s();R.push(U)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,$),U?.negate()}case 17:return this.z(),j.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,$),U}case 17:{const U=R.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const Y=z.lexeme,N=Y.lastIndexOf("/"),B=N===Y.length-1?void 0:this.w(Y.substring(N+1));let _;try{_=new RegExp(Y.substring(1,N),B)}catch{throw this.B("REGEX",z)}return se.create(U,_)}switch(z.type){case 10:case 19:{const Y=[z.lexeme];this.z();let N=this.D(),B=0;for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--;for(;!this.E()&&N.type!==15&&N.type!==16;){switch(N.type){case 0:B++;break;case 1:B--;break;case 10:case 18:for(let me=0;me<N.lexeme.length;me++)N.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--}if(B<0)break;Y.push(s.$Zi.getLexeme(N)),this.z(),N=this.D()}const _=Y.join(""),ce=_.lastIndexOf("/"),re=ce===_.length-1?void 0:this.w(_.substring(ce+1));let $e;try{$e=new RegExp(_.substring(1,ce),re)}catch{throw this.B("REGEX",z)}return t.regex(U,$e)}case 18:{const Y=z.lexeme;this.z();let N=null;if(!(0,A.$Ie)(Y)){const B=Y.indexOf("/"),_=Y.lastIndexOf("/");if(B!==_&&B>=0){const ce=Y.slice(B+1,_),re=Y[_+1]==="i"?"i":"";try{N=new RegExp(ce,re)}catch{throw this.B("REGEX",z)}}}if(N===null)throw this.B("REGEX",z);return se.create(U,N)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const z=this.u();return t.notIn(U,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(U,z);switch(z){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(U,z);switch(z){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,z)}}case 5:return this.z(),J.create(U,this.u());case 6:return this.z(),le.create(U,this.u());case 7:return this.z(),F.create(U,this.u());case 8:return this.z(),G.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:g,offset:R.offset,lexeme:"",additionalInfo:w}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,U){if(this.C(R))return this.z();throw this.B(U,this.D())}B(R,U,x){const z=(0,D.localize)(8,null,R,s.$Zi.getLexeme(U)),Y=U.offset,N=s.$Zi.getLexeme(U);return this.h.push({message:z,offset:Y,lexeme:N,additionalInfo:x}),c.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$2i=c;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(R){return m.create(R)}static equals(R,U){return O.create(R,U)}static notEquals(R,U){return C.create(R,U)}static regex(R,U){return se.create(R,U)}static in(R,U){return I.create(R,U)}static notIn(R,U){return E.create(R,U)}static not(R){return j.create(R)}static and(...R){return X.create(R,null,!0)}static or(...R){return H.create(R,null,!0)}static greater(R,U){return F.create(R,U)}static greaterEquals(R,U){return G.create(R,U)}static smaller(R,U){return J.create(R,U)}static smallerEquals(R,U){return le.create(R,U)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$3i=t;function o(K){const R=new c({regexParsingWithErrorRecovery:!1});return K.map(U=>(R.parse(U),R.lexingErrors.length>0?R.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,D.localize)(9,null,x.additionalInfo):(0,D.localize)(10,null),offset:x.offset,length:x.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$4i=o;function r(K,R){const U=K?K.substituteConstants():void 0,x=R?R.substituteConstants():void 0;return!U&&!x?!0:!U||!x?!1:U.equals(x)}e.$5i=r;function i(K,R){return K.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.$6i=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$7i=a;class m{static create(R,U=null){const x=f.get(R);return typeof x=="boolean"?x?a.INSTANCE:n.INSTANCE:new m(R,U)}constructor(R,U){this.key=R,this.c=U,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:W(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=f.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$8i=m;class O{static create(R,U,x=null){if(typeof U=="boolean")return U?m.create(R,x):j.create(R,x);const z=f.get(R);return typeof z=="boolean"?U===(z?"true":"false")?a.INSTANCE:n.INSTANCE:new O(R,U,x)}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=f.get(this.c);if(typeof R=="boolean"){const U=R?"true":"false";return this.d===U?a.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$9i=O;class I{static create(R,U){return new I(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:V(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.f),x=R.getValue(this.d);return Array.isArray(U)?U.includes(x):typeof x=="string"&&typeof U=="object"&&U!==null?p.call(U,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$0i=I;class E{static create(R,U){return new E(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=11,this.c=I.create(R,U)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$$i=E;class C{static create(R,U,x=null){if(typeof U=="boolean")return U?j.create(R,x):m.create(R,x);const z=f.get(R);return typeof z=="boolean"?U===(z?"true":"false")?n.INSTANCE:a.INSTANCE:new C(R,U,x)}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=f.get(this.c);if(typeof R=="boolean"){const U=R?"true":"false";return this.d===U?n.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$_i=C;class j{static create(R,U=null){const x=f.get(R);return typeof x=="boolean"?x?n.INSTANCE:a.INSTANCE:new j(R,U)}constructor(R,U){this.c=R,this.d=U,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:W(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=f.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:a.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$aj=j;function T(K,R){if(typeof K=="string"){const U=parseFloat(K);isNaN(U)||(K=U)}return typeof K=="string"||typeof K=="number"?R(K):n.INSTANCE}class F{static create(R,U,x=null){return T(U,z=>new F(R,z,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$bj=F;class G{static create(R,U,x=null){return T(U,z=>new G(R,z,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$cj=G;class J{static create(R,U,x=null){return T(U,z=>new J(R,z,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$dj=J;class le{static create(R,U,x=null){return T(U,z=>new le(R,z,x))}constructor(R,U,x){this.c=R,this.d=U,this.f=x,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$ej=le;class se{static create(R,U){return new se(R,U)}constructor(R,U){this.d=R,this.f=U,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const U=this.f?this.f.source:"",x=R.f?R.f.source:"";return U<x?-1:U>x?1:0}equals(R){if(R.type===this.type){const U=this.f?this.f.source:"",x=R.f?R.f.source:"";return this.d===R.d&&U===x}return!1}substituteConstants(){return this}evaluate(R){const U=R.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$fj=se;class ue{static create(R){return new ue(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new ue(this.c.map(R))}negate(){return this.c}}e.$gj=ue;function Z(K){let R=null;for(let U=0,x=K.length;U<x;U++){const z=K[U].substituteConstants();if(K[U]!==z&&R===null){R=[];for(let Y=0;Y<U;Y++)R[Y]=K[Y]}R!==null&&(R[U]=z)}return R===null?K:R}class X{static create(R,U,x){return X.d(R,U,x)}constructor(R,U){this.expr=R,this.c=U,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const z=i(this.expr[U],R.expr[U]);if(z!==0)return z}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=Z(this.expr);return R===this.expr?this:X.create(R,this.c,!1)}evaluate(R){for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].evaluate(R))return!1;return!0}static d(R,U,x){const z=[];let Y=!1;for(const N of R)if(N){if(N.type===1){Y=!0;continue}if(N.type===0)return n.INSTANCE;if(N.type===6){z.push(...N.expr);continue}z.push(N)}if(z.length===0&&Y)return a.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];for(;z.length>1;){const N=z[z.length-1];if(N.type!==9)break;z.pop();const B=z.pop(),_=z.length===0,ce=H.create(N.expr.map(re=>X.create([re,B],null,x)),null,_);ce&&(z.push(ce),z.sort(i))}if(z.length===1)return z[0];if(x){for(let N=0;N<z.length;N++)for(let B=N+1;B<z.length;B++)if(z[N].negate().equals(z[B]))return n.INSTANCE;if(z.length===1)return z[0]}return new X(z,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new X(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.c){const R=[];for(const U of this.expr)R.push(U.negate());this.c=H.create(R,this,!0)}return this.c}}e.$hj=X;class H{static create(R,U,x){return H.d(R,U,x)}constructor(R,U){this.expr=R,this.c=U,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let U=0,x=this.expr.length;U<x;U++){const z=i(this.expr[U],R.expr[U]);if(z!==0)return z}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let U=0,x=this.expr.length;U<x;U++)if(!this.expr[U].equals(R.expr[U]))return!1;return!0}return!1}substituteConstants(){const R=Z(this.expr);return R===this.expr?this:H.create(R,this.c,!1)}evaluate(R){for(let U=0,x=this.expr.length;U<x;U++)if(this.expr[U].evaluate(R))return!0;return!1}static d(R,U,x){let z=[],Y=!1;if(R){for(let N=0,B=R.length;N<B;N++){const _=R[N];if(_){if(_.type===0){Y=!0;continue}if(_.type===1)return a.INSTANCE;if(_.type===9){z=z.concat(_.expr);continue}z.push(_)}}if(z.length===0&&Y)return n.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];if(x){for(let N=0;N<z.length;N++)for(let B=N+1;B<z.length;B++)if(z[N].negate().equals(z[B]))return a.INSTANCE;if(z.length===1)return z[0]}return new H(z,U)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const U of this.expr)R.push(...U.keys());return R}map(R){return new H(this.expr.map(U=>U.map(R)),null)}negate(){if(!this.c){const R=[];for(const U of this.expr)R.push(U.negate());for(;R.length>1;){const U=R.shift(),x=R.shift(),z=[];for(const Y of he(U))for(const N of he(x))z.push(X.create([Y,N],null,!1));R.unshift(H.create(z,null,!1))}this.c=H.create(R,this,!0)}return this.c}}e.$ij=H;class L extends m{static{this.d=[]}static all(){return L.d.values()}constructor(R,U,x){super(R,null),this.f=U,typeof x=="object"?L.d.push({...x,key:R}):x!==!0&&L.d.push({key:R,description:x,type:U!=null?typeof U:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return O.create(this.key,R)}notEqualsTo(R){return C.create(this.key,R)}}e.$jj=L,e.$kj=(0,M.$5h)("contextKeyService");function W(K,R){return K<R?-1:K>R?1:0}function V(K,R,U,x){return K<U?-1:K>U?1:R<x?-1:R>x?1:0}function q(K,R){if(K.type===0||R.type===1)return!0;if(K.type===9)return R.type===9?te(K.expr,R.expr):!1;if(R.type===9){for(const U of R.expr)if(q(K,U))return!0;return!1}if(K.type===6){if(R.type===6)return te(R.expr,K.expr);for(const U of K.expr)if(q(U,R))return!0;return!1}return K.equals(R)}e.$lj=q;function te(K,R){let U=0,x=0;for(;U<K.length&&x<R.length;){const z=K[U].cmp(R[x]);if(z<0)return!1;z===0&&U++,x++}return U===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(oe[91],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=e.ID=void 0,e.ID="diagnosticsService",e.$Hm=(0,P.$5h)(e.ID);function A(M){return!!M.hostName&&!!M.errorMessage}e.$Im=A;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Jm=s}),define(oe[116],ae([0,1,19,74,166,6,47,4,35]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.ConfirmResult=e.$7v=e.$6v=e.$5v=void 0,e.$5v=(0,M.$5h)("dialogService");var l;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(l||(l={}));class p{a($){return this.d($,l.Confirmation)}b($){return this.d($,l.Prompt)}c($){return this.d($,l.Input)}d($,d){const h=[];switch(d){case l.Confirmation:{const g=$;g.primaryButton?h.push(g.primaryButton):h.push((0,s.localize)(0,null)),g.cancelButton?h.push(g.cancelButton):h.push((0,s.localize)(1,null));break}case l.Prompt:{const g=$;Array.isArray(g.buttons)&&g.buttons.length>0&&h.push(...g.buttons.map(w=>w.label)),g.cancelButton&&(g.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof g.cancelButton=="string"?h.push(g.cancelButton):g.cancelButton.label?h.push(g.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case l.Input:{const g=$;g.primaryButton?h.push(g.primaryButton):h.push((0,s.localize)(5,null)),g.cancelButton?h.push(g.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===A.default.Info?"info":$===A.default.Error?"error":$===A.default.Warning?"warning":"none"}f($,d,h){const g=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&g.push($.cancelButton);let w=g[d]?.run({checkboxChecked:h});return w instanceof Promise||(w=Promise.resolve(w)),{result:w,checkboxChecked:h}}}e.$6v=p,e.$7v=(0,M.$5h)("fileDialogService");var k;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(k||(e.ConfirmResult=k={}));const v=10;function u(b){const $=[];return $.push(...b.slice(0,v).map(d=>typeof d=="string"?d:(0,P.$Dg)(d))),b.length>v&&(b.length-v===1?$.push((0,s.localize)(7,null)):$.push((0,s.localize)(8,null,b.length-v))),$.push(""),$.join(`
`)}e.$8v=u;function y(b,$){const d=(0,f.$un)(b);let h=(d.buttons??[]).map(t=>(0,D.$2v)(t)),g=(b.buttons||[]).map((t,o)=>o),w=0,c=d.cancelId??h.length-1;if(h.length>1){const t=typeof c=="number"?h[c]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&h.length>1&&c!==1){h.splice(c,1),h.splice(1,0,t);const o=g[c];g.splice(c,1),g.splice(1,0,o),c=1}S.$k&&h.length>1&&(h=h.reverse(),g=g.reverse(),w=h.length-1,typeof t=="string"&&(c=w-1))}else if(S.$i&&typeof t=="string"&&h.length>1&&c!==h.length-1){h.splice(c,1),h.push(t);const o=g[c];g.splice(c,1),g.push(o),c=h.length-1}}return d.buttons=h,d.defaultId=w,d.cancelId=c,d.noLink=!0,d.title=d.title||$.nameLong,{options:d,buttonIndeces:g}}e.$9v=y}),define(oe[117],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bV=e.$aV=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$_U=e.$$U=void 0,e.$$U=(0,P.$5h)("encryptionService"),e.$_U=(0,P.$5h)("encryptionMainService");var A;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$aV=M;function D(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$bV=D}),define(oe[38],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=void 0,e.$_h=(0,P.$5h)("environmentService"),e.$ai=(0,P.$6h)(e.$_h)}),define(oe[118],ae([0,1,170,6]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$xo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=void 0,e.$lo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$mo=new RegExp(e.$lo),e.$no="__web_extension",e.$oo="skipWalkthrough",e.$po="extensionsSync",e.$qo="dependecyOrPackExtensionInstall";function s(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ro=s;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$so=M;function D(d,h){switch(d){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$to=D;function S(d,h){return h==="web"&&!d.includes("web")}e.$uo=S;function f(d,h,g){return S(h,g)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===g}e.$vo=f;function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$wo=l;var p;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var k;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var v;(function(d){d.Install="install",d.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var u;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$xo=(0,A.$5h)("extensionGalleryService");var y;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var b;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class $ extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$yo=$,e.$zo=(0,A.$5h)("extensionManagementService"),e.$Ao="extensionsIdentifiers/disabled",e.$Bo="extensionsIdentifiers/enabled",e.$Co=(0,A.$5h)("IGlobalExtensionEnablementService"),e.$Do=(0,A.$5h)("IExtensionTipsService"),e.$Eo=(0,P.localize)(0,null),e.$Fo={value:e.$Eo,original:"Extensions"},e.$Go=(0,P.localize2)(1,"Preferences")}),define(oe[209],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.$L0b=void 0,e.$L0b=(0,P.$5h)("extensionHostStarter"),e.$M0b="extensionHostStarter"}),define(oe[210],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=e.$R2b=void 0,e.$R2b=(0,P.$5h)("externalTerminal"),e.$S2b="Terminal.app"}),define(oe[211],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O0b=void 0,e.$O0b=(0,P.$5h)("externalTerminal")}),define(oe[212],ae([0,1,48,50,13,9,4,76,21,89,174,210]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=e.$Q0b=e.$P0b=void 0;const v=p.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await $.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends u{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(P,c,l.$Sl(),t)}spawnTerminal(c,t,o,r){const i=t.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=M.$nc(i,".exe").toLowerCase();if(n==="cmder")return c.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),n==="wt"&&a.push("-d ."),new Promise((m,O)=>{const I=d(process),E=c.spawn(o,a,{cwd:r,env:I,detached:!0});E.on("error",O),E.on("exit",()=>m())})}async runInTerminal(c,t,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:y.getDefaultTerminalWindows(),a=await y.f();return new Promise((m,O)=>{const I=`"${t} - ${v}"`,E=`""${o.join('" "')}" & pause"`,C=Object.assign({},d(process),r);Object.keys(C).filter(J=>C[J]===null).forEach(J=>delete C[J]);const j={cwd:t,env:C,windowsVerbatimArguments:!0};let T,F;M.$nc(n,".exe")==="wt"?(T=n,F=["-d",".",y.b,"/c",E]):a?(T=a,F=["-d",t,n,"/c",E]):(T=y.b,F=["/c","start",I,"/wait",n,"/c",E]),P.spawn(T,F,j).on("error",J=>{O(h(J))}),m(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return y.d}static async f(){try{const c=await l.win32.findExecutable("wt");return await f.Promises.exists(c)?c:void 0}catch{return}}}e.$P0b=y,Ee([A.$wh],y,"f",null);class b extends u{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(P,c,t)}runInTerminal(c,t,o,r,i){const n=i.osxExec||k.$S2b;return new Promise((a,m)=>{if(n===k.$S2b||n==="iTerm.app"){const O=n===k.$S2b?"TerminalHelper":"iTermHelper",E=[s.$ng.asFileUri(`vs/workbench/contrib/externalTerminal/node/${O}.scpt`).fsPath,"-t",c||v,"-w",t];for(const T of o)E.push("-a"),E.push(T);if(r){const T=Object.assign({},d(process),r);for(const F in T){const G=T[F];G===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${G}`))}}let C="";const j=P.spawn(b.b,E);j.on("error",T=>{m(h(T))}),j.stderr.on("data",T=>{C+=T.toString()}),j.on("exit",T=>{if(T===0)a(void 0);else if(C){const F=C.split(`
`,1);m(new Error(F[0]))}else m(new Error(p.localize(1,null,O,T)))})}else m(new Error(p.localize(2,null,n)))})}spawnTerminal(c,t,o){const r=t.osxExec||k.$S2b;return new Promise((i,n)=>{const a=["-a",r];o&&a.push(o);const m=d(process),O=c.spawn("/usr/bin/open",a,{cwd:o,env:m});O.on("error",n),O.on("exit",()=>i())})}}e.$Q0b=b;class $ extends u{static{this.b=p.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(P,c,t)}runInTerminal(c,t,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((a,m)=>{const O=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?O.push("-x"):O.push("-e"),O.push("bash"),O.push("-c");const E=`${g(o)}; echo; read -p "${$.b}" -n1;`;O.push(`''${E}''`);const C=Object.assign({},d(process),r);Object.keys(C).filter(G=>C[G]===null).forEach(G=>delete C[G]);const j={cwd:t,env:C};let T="";const F=P.spawn(I,O,j);F.on("error",G=>{m(h(G))}),F.stderr.on("data",G=>{T+=G.toString()}),F.on("exit",G=>{if(G===0)a(void 0);else if(T){const J=T.split(`
`,1);m(new Error(J[0]))}else m(new Error(p.localize(4,null,I,G)))})})})}static async getDefaultTerminalLinuxReady(){if(!$.d)if(!D.$k)$.d=Promise.resolve("xterm");else{const c=await f.Promises.exists("/etc/debian_version");$.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return $.d}spawnTerminal(c,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(a=>{const m=d(process),O=c.spawn(a,[],{cwd:o,env:m});O.on("error",n),O.on("exit",()=>i())})})}}e.$R0b=$;function d(w){const c={...w.env};return(0,S.$Ql)(c),c}function h(w){return"errno"in w&&w.errno==="ENOENT"&&"path"in w&&typeof w.path=="string"?new Error(p.localize(5,null,w.path)):w}function g(w){let c="";for(const t of w)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(oe[16],ae([0,1,58,9,25,12,7,176,6,4,13,62]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileKind=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileOperationResult=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileChangeType=e.$Hk=e.FileOperation=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileSystemProviderErrorCode=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderCapabilities=e.$rk=e.FilePermission=e.FileType=e.$qk=e.$pk=void 0,e.$pk=(0,f.$5h)("fileService");function v(q){return q.create===!0}e.$qk=v;var u;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var y;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function b(q){const te=q;return!!te&&typeof te.onDidChange=="function"}e.$rk=b;var $;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function d(q){return!!(q.capabilities&2)}e.$sk=d;function h(q){return!!(q.capabilities&8)}e.$tk=h;function g(q){return!!(q.capabilities&131072)}e.$uk=g;function w(q){return!!(q.capabilities&4)}e.$vk=w;function c(q){return!!(q.capabilities&16)}e.$wk=c;function t(q){return d(q)?!!(q.capabilities&16384):!1}e.$xk=t;function o(q){return d(q)?!!(q.capabilities&32768):!1}e.$yk=o;function r(q){return!!(q.capabilities&65536)}e.$zk=r;function i(q){return!!(q.capabilities&2048)}e.$Ak=i;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class a extends Error{static create(te,he){const K=new a(te.toString(),he);return I(K,he),K}constructor(te,he){super(te),this.code=he}}e.$Bk=a;function m(q,te){return a.create(q,te)}e.$Ck=m;function O(q){return q||m((0,S.localize)(0,null),n.Unknown)}e.$Dk=O;function I(q,te){return q.name=te?`${te} (FileSystemError)`:"FileSystemError",q}e.$Ek=I;function E(q){if(!q)return n.Unknown;if(q instanceof a)return q.code;const te=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!te)return n.Unknown;switch(te[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Fk=E;function C(q){if(q instanceof le)return q.fileOperationResult;switch(E(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Gk=C;var j;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class T{constructor(te,he,K){this.resource=te,this.operation=he,this.target=K}isOperation(te){return this.operation===te}}e.$Hk=T;var F;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class G{static{this.a=null}constructor(te,he){this.c=he,this.b=void 0,this.d=new k.$V(()=>{const K=P.$$h.forUris(()=>this.c);return K.fill(this.rawAdded.map(R=>[R,!0])),K}),this.f=new k.$V(()=>{const K=P.$$h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(R=>[R,!0])),K}),this.g=new k.$V(()=>{const K=P.$$h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(R=>[R,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of te){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==G.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(te,...he){return this.h(te,{includeChildren:!1},...he)}affects(te,...he){return this.h(te,{includeChildren:!0},...he)}h(te,he,...K){if(!te)return!1;const R=K.length>0;return!!((!R||K.includes(1))&&(this.d.value.get(te)||he.includeChildren&&this.d.value.findSuperstr(te))||(!R||K.includes(0))&&(this.f.value.get(te)||he.includeChildren&&this.f.value.findSuperstr(te))||(!R||K.includes(2))&&(this.g.value.findSubstr(te)||he.includeChildren&&this.g.value.findSuperstr(te)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(te){return this.b===te}hasCorrelation(){return typeof this.b=="number"}}e.$Ik=G;function J(q,te,he){return!q||!te||q===te||te.length>q.length?!1:(te.charAt(te.length-1)!==A.sep&&(te+=A.sep),he?(0,s.$_e)(q,te):q.indexOf(te)===0)}e.$Jk=J;class le extends Error{constructor(te,he,K){super(te),this.fileOperationResult=he,this.options=K}}e.$Kk=le;class se extends le{constructor(te,he,K,R){super(te,he,R),this.fileOperationResult=he,this.size=K}}e.$Lk=se;class ue extends le{constructor(te,he,K){super(te,2,K),this.stat=he}}e.$Mk=ue;var Z;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Nk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ok={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Pk="files.associations",e.$Qk="files.exclude",e.$Rk="files.readonlyInclude",e.$Sk="files.readonlyExclude",e.$Tk="files.readonlyFromPermissions";var X;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$Uk="";function H(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Vk=H;async function L(q,te){if(!te.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise(he=>{const K=te.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===q.scheme&&R.added&&(K.dispose(),he())})})}e.$Wk=L;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(te){return(0,M.$Lf)(te)||(te=0),te<W.KB?(0,S.localize)(1,null,te.toFixed(0)):te<W.MB?(0,S.localize)(2,null,(te/W.KB).toFixed(2)):te<W.GB?(0,S.localize)(3,null,(te/W.MB).toFixed(2)):te<W.TB?(0,S.localize)(4,null,(te/W.GB).toFixed(2)):(0,S.localize)(5,null,(te/W.TB).toFixed(2))}}e.$Xk=W;function V(q){const te=typeof q=="string"||q?.scheme===p.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===p.Schemas.file?1024*W.MB:te?10*W.MB:l.$o?50*W.MB:1024*W.MB}e.$Yk=V}),define(oe[119],ae([0,1,17,14,177,16]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;async function D(p,k,v,u,y,b){let $;try{await S(p,k,v,u,y,b)}catch(d){$=d}finally{$&&y.errorTransformer&&($=y.errorTransformer($)),typeof $<"u"&&v.error($),v.end()}}e.$aq=D;async function S(p,k,v,u,y,b){f(b);const $=await p.open(k,{create:!1});try{f(b);let d=0,h=0,g=y&&typeof y.length=="number"?y.length:void 0,w=P.$ie.alloc(Math.min(y.bufferSize,typeof g=="number"?g:y.bufferSize)),c=y&&typeof y.position=="number"?y.position:0,t=0;do h=await p.read($,c,w.buffer,t,w.byteLength-t),c+=h,t+=h,d+=h,typeof g=="number"&&(g-=h),t===w.byteLength&&(await v.write(u(w)),w=P.$ie.alloc(Math.min(y.bufferSize,typeof g=="number"?g:y.bufferSize)),t=0);while(h>0&&(typeof g!="number"||g>0)&&f(b)&&l(d,y));if(t>0){let o=t;typeof g=="number"&&(o=Math.min(t,g)),v.write(u(w.slice(0,o)))}}catch(d){throw(0,M.$Dk)(d)}finally{await p.close($)}}function f(p){if(p.isCancellationRequested)throw(0,A.$6)();return!0}function l(p,k){if(typeof k?.limits?.size=="number"&&p>k.limits.size)throw(0,M.$Ck)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[67],ae([0,1,105,2,9,4,7,16]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=void 0;function f(d){return d.recursive===!0}e.$cq=f;class l extends A.$Tc{static{this.a=5}constructor(h,g,w,c){super(),this.h=h,this.j=g,this.m=w,this.n=c,this.c=this.B(new A.$Uc),this.f=void 0,this.g=0}s(){const h=new A.$Sc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(g=>this.h(g))),h.add(this.b.onDidLogMessage(g=>this.j(g))),h.add(this.b.onDidError(g=>this.t(g)))}t(h){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$dq=l;class p extends l{constructor(h,g,w){super(h,g,w,{type:"node.js",restartOnError:!1})}}e.$eq=p;class k extends l{constructor(h,g,w){super(h,g,w,{type:"universal",restartOnError:!0})}}e.$fq=k;function v(d){return d.map(h=>({type:h.type,resource:D.URI.revive(h.resource),cId:h.cId}))}e.$gq=v;function u(d){const h=new $;for(const g of d)h.processEvent(g);return h.coalesce()}e.$hq=u;function y(d,h){return typeof h=="string"&&!h.startsWith(P.$Hj)&&!(0,s.$ic)(h)?{base:d,pattern:h}:h}e.$iq=y;function b(d,h){const g=[];for(const w of h)g.push((0,P.$Lj)(y(d,w)));return g}e.$jq=b;class ${constructor(){this.a=new Set,this.b=new Map}c(h){return M.$k?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const g=this.b.get(this.c(h));let w=!1;if(g){const c=g.type,t=h.type;g.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?w=!0:c===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(g)):c===2&&t===1?g.type=0:c===1&&t===0||(g.type=t)}else w=!0;w&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],g=[];return Array.from(this.a).filter(w=>w.type!==2?(h.push(w),!1):!0).sort((w,c)=>w.resource.fsPath.length-c.resource.fsPath.length).filter(w=>g.some(c=>(0,S.$Jk)(w.resource.fsPath,c,!M.$k))?!1:(g.push(w.resource.fsPath),!0)).concat(h)}}}),define(oe[213],ae([0,1,17,51,14,3,2,63,32,16,67]),function(Q,e,P,A,s,M,D,S,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.$bO=void 0,e.$bO="localFilesystem";class k extends D.$Tc{constructor(u,y){super(),this.a=u,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Ud),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Ud),this.onDidWatchError=this.g.event,this.h=(0,f.$pg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,y){const{buffer:b}=await this.a.call("readFile",[u,y]);return b}readFileStream(u,y,b){const $=(0,S.$9d)(h=>P.$ie.concat(h.map(g=>P.$ie.wrap(g))).buffer),d=new D.$Sc;return d.add(this.a.listen("readFileStream",[u,y])(h=>{if(h instanceof P.$ie)$.write(h.buffer);else{if(h==="end")$.end();else{let g;if(h instanceof Error)g=h;else{const w=h;g=(0,l.$Ck)(w.message??(0,A.$Pi)(w),w.code??l.FileSystemProviderErrorCode.Unknown)}$.error(g),$.end()}d.dispose()}})),d.add(b.onCancellationRequested(()=>{$.error((0,s.$6)()),$.end(),d.dispose()})),$}writeFile(u,y,b){return this.a.call("writeFile",[u,P.$ie.wrap(y),b])}open(u,y){return this.a.call("open",[u,y])}close(u){return this.a.call("close",[u])}async read(u,y,b,$,d){const[h,g]=await this.a.call("read",[u,y,d]);return b.set(h.buffer.slice(0,g),$),g}write(u,y,b,$,d){return this.a.call("write",[u,y,P.$ie.wrap(b),$,d])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,y){return this.a.call("delete",[u,y])}rename(u,y,b){return this.a.call("rename",[u,y,b])}copy(u,y,b){return this.a.call("copy",[u,y,b])}cloneFile(u,y){return this.a.call("cloneFile",[u,y])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const y=u;this.f.fire((0,p.$gq)(y))}else{const y=u;this.g.fire(y)}}))}watch(u,y){const b=(0,f.$pg)();return this.a.call("watch",[this.h,b,u,y]),(0,D.$Rc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$cO=k}),define(oe[214],ae([0,1,46,8,23,33,2,85,9,4,19,7,106,21,67]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=void 0;class b extends D.$Tc{static{this.a=100}static{this.b=75}constructor(h,g,w,c){super(),this.m=h,this.n=g,this.r=w,this.s=c,this.c=this.B(new A.$hh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new A.$gh(t=>this.z(t),b.b)),this.g=(0,y.$jq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$jq)(this.m.path,this.m.includes):void 0,this.j=new s.$5d,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const g=await u.Promises.stat(h);this.B(await this.w(h,g.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let g=h.path;try{g=await u.Promises.realpath(h.path),h.path===g&&(g=await(0,v.$tq)(h.path)??h.path),h.path!==g&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${g})`)}catch{}return g}async w(h,g){if(l.$j&&(0,M.$7f)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Tc.None;const w=new s.$5d(this.j.token),c=new D.$Sc;try{const t=k.URI.file(this.m.path),o=(0,f.$nc)(h),r=(0,P.watch)(h);c.add((0,D.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${h}'`);const i=new Set;if(g)try{for(const a of await u.Promises.readdir(h))i.add(a)}catch(a){this.D(a)}const n=new Map;c.add((0,D.$Rc)(()=>{for(const[,a]of n)a.dispose();n.clear()})),r.on("error",(a,m)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${a}, ${m})`),this.dispose()}),r.on("change",(a,m)=>{if(w.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${m}`);let O="";if(m&&(O=m.toString(),l.$j&&(O=(0,S.$Fl)(O))),!(!O||a!=="change"&&a!=="rename"))if(g)if(a==="rename"){n.get(O)?.dispose();const I=setTimeout(async()=>{if(n.delete(O),O===o&&!await u.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,f.$jc)(h,O));if(w.token.isCancellationRequested)return;let C;E?i.has(O)?C=0:(C=1,i.add(O)):(i.delete(O),C=2),this.y({resource:(0,p.$Gg)(t,O),type:C,cId:this.m.correlationId})},b.a);n.set(O,(0,D.$Rc)(()=>clearTimeout(I)))}else{let I;i.has(O)?I=0:(I=1,i.add(O)),this.y({resource:(0,p.$Gg)(t,O),type:I,cId:this.m.correlationId})}else if(a==="rename"||O!==o){const I=setTimeout(async()=>{const E=await u.Promises.exists(h);w.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(h,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},b.a);c.clear(),c.add((0,D.$Rc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await u.Promises.exists(h)&&!w.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${t.toString()})`)}return(0,D.$Rc)(()=>{w.dispose(!0),c.dispose()})}y(h,g=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!g&&this.g.some(w=>w(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!g&&this.h&&this.h.length>0&&!this.h.some(w=>w(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const g=(0,y.$hq)(h);if(g.length>0){if(this.s)for(const c of g)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(g)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(l.$k)return u.Promises.exists(h);try{const g=(0,f.$nc)(h);return(await u.Promises.readdir((0,f.$mc)(h))).some(c=>c===g)}catch(g){return this.G(g),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$wq=b;async function $(d,h,g,w,c=512){const t=await u.Promises.open(d,"r"),o=Buffer.allocUnsafe(c),r=new s.$5d(w);let i,n=!1;const a={path:d,excludes:[],recursive:!1},m=new b(a,O=>{(async()=>{for(const{type:I}of O)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await u.Promises.read(t,o,0,c,null);if(!E||r.token.isCancellationRequested)break;h(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await m.ready,g(),new Promise((O,I)=>{r.token.onCancellationRequested(async()=>{m.dispose();try{await u.Promises.close(t)}catch(E){i=new Error(E)}i?I(i):O()})})}e.$xq=$}),define(oe[215],ae([0,1,3,105,2,4,214]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;class S extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new P.$Ud),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Ud),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(l){const p=this.j(l),k=p.filter(u=>{const y=this.c.get(u.path);return y?!(0,A.$Pj)(y.request.excludes,u.excludes)||!(0,A.$Pj)(y.request.includes,u.includes):!0}),v=Array.from(this.c.values()).filter(({request:u})=>!p.find(y=>y.path===u.path&&(0,A.$Pj)(y.excludes,u.excludes)&&(0,A.$Pj)(y.includes,u.includes))).map(({request:u})=>u.path);k.length&&this.m(`Request to start watching: ${k.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const u of v)this.h(u);for(const u of k)this.g(u)}g(l){const p=new D.$wq(l,v=>this.a.fire(v),v=>this.b.fire(v),this.f),k={request:l,instance:p};this.c.set(l.path,k)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const p=this.c.get(l);p&&(this.c.delete(l),p.instance.dispose())}j(l){const p=new Map;for(const k of l){const v=M.$k?k.path:k.path.toLowerCase();let u=p.get(k.correlationId);u||(u=new Map,p.set(k.correlationId,u)),u.set(v,k)}return Array.from(p.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(l){this.f=l;for(const[,p]of this.c)p.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,p){return p?`[File Watcher (node.js)] ${l} (path: ${p.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$yq=S}),define(oe[216],ae([0,1,67,215]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class s extends P.$eq{constructor(D,S,f){super(D,S,f),this.s()}r(D){return D.add(new A.$yq)}}e.$zq=s}),define(oe[217],ae([0,1,13,43,160,67]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=void 0;class D extends M.$fq{constructor(f,l,p){super(f,l,p),this.s()}r(f){const l=f.add(new s.$qq(P.$ng.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:p,signal:k})=>this.t(`terminated by itself with code ${p}, signal: ${k}`))),A.ProxyChannel.toService((0,A.$Lh)(l.getChannel("watcher")))}}e.$rq=D}),define(oe[92],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class P{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$3h=P}),define(oe[218],ae([0,1,8,14,2,78,208,6,92,102]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;const p=!1;class k extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class v{constructor($=new f.$3h,d=!1,h,g=p){this.f=$,this.g=d,this.h=h,this.i=g,this.o=new Set,this.f.set(S.$4h,this),this._globalGraph=g?h?._globalGraph??new D.$Cq(w=>w):void 0}createChild($){return new v($,this.g,this,this.i)}invokeFunction($,...d){const h=y.traceInvocation(this.i,$);let g=!1;try{return $({get:c=>{if(g)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,h);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...d)}finally{g=!0,h.stop()}}createInstance($,...d){let h,g;return $ instanceof M.$2h?(h=y.traceCreation(this.i,$.ctor),g=this.j($.ctor,$.staticArguments.concat(d),h)):(h=y.traceCreation(this.i,$),g=this.j($,d,h)),h.stop(),g}j($,d=[],h){const g=S._util.getServiceDependencies($).sort((t,o)=>t.index-o.index),w=[];for(const t of g){const o=this.m(t.id,h);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(o)}const c=g.length>0?g[0].index:d.length;if(d.length!==c){console.trace(`[createInstance] First service dependency of ${$.name} at position ${c+1} conflicts with ${d.length} static arguments`);const t=c-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,c)}return Reflect.construct($,d.concat(w))}k($,d){if(this.f.get($)instanceof M.$2h)this.f.set($,d);else if(this.h)this.h.k($,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const d=this.f.get($);return!d&&this.h?this.h.l($):d}m($,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const h=this.l($);return h instanceof M.$2h?this.q($,h,d.branch($,!0)):(d.branch($,!1),h)}q($,d,h){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,d,h)}finally{this.o.delete($)}}r($,d,h){const g=new D.$Cq(t=>t.id.toString());let w=0;const c=[{id:$,desc:d,_trace:h}];for(;c.length;){const t=c.pop();if(g.lookupOrInsertNode(t),w++>1e3)throw new k(g);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.$2h){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};g.insertEdge(t,i),c.push(i)}}}for(;;){const t=g.roots();if(t.length===0){if(!g.isEmpty())throw new k(g);break}for(const{data:o}of t){if(this.l(o.id)instanceof M.$2h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}g.removeNode(o)}}return this.l($)}s($,d,h=[],g,w){if(this.f.get($)instanceof M.$2h)return this.t($,d,h,g,w);if(this.h)return this.h.s($,d,h,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t($,d,h=[],g,w){if(g){const c=new v(void 0,this.g,this,this.i);c.c=String($);const t=new Map,o=new P.$lh(()=>{const r=c.j(d,h,w);for(const[i,n]of t){const a=r[i];if(typeof a=="function")for(const m of n)m.disposable=a.apply(r,m.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let m=t.get(i);return m||(m=new l.$4c,t.set(i,m)),(I,E,C)=>{if(o.isInitialized)return o.value[i](I,E,C);{const j={listener:[I,E,C],disposable:void 0},T=m.push(j);return(0,s.$Rc)(()=>{T(),j.disposable?.dispose()})}}}if(i in r)return r[i];const n=o.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),r[i]=a),a},set(r,i,n){return o.value[i]=n,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,h,w)}u($,d){if(d&&console.warn($),this.g)throw new Error($)}}e.$Dq=v;var u;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(u||(u={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,d){return $?new y(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation($,d){return $?new y(1,d.name):y.c}static{this.f=0}constructor($,d){this.type=$,this.name=d,this.g=Date.now(),this.h=[]}branch($,d){const h=new y(3,$.toString());return this.h.push([$,d,h]),h}stop(){const $=Date.now()-this.g;y.f+=$;let d=!1;function h(w,c){const t=[],o=new Array(w+1).join("	");for(const[r,i,n]of c.h)if(i&&n){d=!0,t.push(`${o}CREATES -> ${r}`);const a=h(w+1,n);a&&t.push(a)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];($>2||d)&&y.all.add(g.join(`
`))}}e.$Eq=y}),define(oe[219],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ozb=e.IssueType=void 0;var A;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.$ozb=(0,P.$5h)("issueService")}),define(oe[5],ae([0,1,51,3,45,2,31,4,19,12,7,115,6]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.log=e.$pj=e.LogLevel=e.$oj=e.$nj=e.$mj=void 0,e.$mj=(0,v.$5h)("logService"),e.$nj=(0,v.$5h)("loggerService");function u(){return new Date().toISOString()}function y(I){return(0,l.$Lf)(I)}e.$oj=y;var b;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$pj=b.Info;function $(I,E,C){switch(E){case b.Trace:I.trace(C);break;case b.Debug:I.debug(C);break;case b.Info:I.info(C);break;case b.Warning:I.warn(C);break;case b.Error:I.error(C);break;case b.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function d(I,E=!1){let C="";for(let j=0;j<I.length;j++){let T=I[j];if(T instanceof Error&&(T=(0,P.$Pi)(T,E)),typeof T=="object")try{T=JSON.stringify(T)}catch{}C+=(j>0?" ":"")+T}return C}class h extends M.$Tc{constructor(){super(...arguments),this.b=e.$pj,this.c=this.B(new A.$Ud),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==b.Off&&this.b<=E}}e.$rj=h;class g extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...C){this.f(b.Trace)&&this.g(b.Trace,d([E,...C],!0))}debug(E,...C){this.f(b.Debug)&&this.g(b.Debug,d([E,...C]))}info(E,...C){this.f(b.Info)&&this.g(b.Info,d([E,...C]))}warn(E,...C){this.f(b.Warning)&&this.g(b.Warning,d([E,...C]))}error(E,...C){if(this.f(b.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(b.Error,d(j))}else this.g(b.Error,d([E,...C]))}flush(){}}e.$sj=g;class w extends h{constructor(E=e.$pj){super(),this.setLevel(E),this.g=!S.$i}trace(E,...C){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...C):console.log(`[main ${u()}]`,E,...C))}debug(E,...C){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...C):console.log(`[main ${u()}]`,E,...C))}info(E,...C){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...C):console.log(`[main ${u()}]`,E,...C))}warn(E,...C){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...C):console.warn(`[main ${u()}]`,E,...C))}error(E,...C){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...C):console.error(`[main ${u()}]`,E,...C))}flush(){}}e.$tj=w;class c extends h{constructor(E=e.$pj,C=!0){super(),this.g=C,this.setLevel(E)}trace(E,...C){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...C):console.log(E,...C))}debug(E,...C){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...C):console.log(E,...C))}info(E,...C){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...C):console.log(E,...C))}warn(E,...C){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...C):console.log(E,...C))}error(E,...C){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...C):console.error(E,...C))}flush(){}}e.$uj=c;class t extends h{constructor(E,C=e.$pj){super(),this.g=E,this.setLevel(C)}trace(E,...C){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(E),...C])}debug(E,...C){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(E),...C])}info(E,...C){this.f(b.Info)&&this.g.log(b.Info,[this.h(E),...C])}warn(E,...C){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(E),...C])}error(E,...C){this.f(b.Error)&&this.g.log(b.Error,[this.h(E),...C])}h(E){return typeof E=="string"?E:(0,P.$Pi)(E,this.f(b.Trace))}flush(){}}e.$vj=t;class o extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const C of this.g)C.setLevel(E);super.setLevel(E)}trace(E,...C){for(const j of this.g)j.trace(E,...C)}debug(E,...C){for(const j of this.g)j.debug(E,...C)}info(E,...C){for(const j of this.g)j.info(E,...C)}warn(E,...C){for(const j of this.g)j.warn(E,...C)}error(E,...C){for(const j of this.g)j.error(E,...C)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$wj=o;class r extends M.$Tc{constructor(E,C,j){if(super(),this.h=E,this.j=C,this.b=new D.$Ac,this.c=this.B(new A.$Ud),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Ud),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Ud),this.onDidChangeVisibility=this.g.event,j)for(const T of j)this.b.set(T.resource,{logger:void 0,info:T})}m(E){return(0,l.$Hf)(E)?[...this.b.values()].find(C=>C.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,C){const j=this.n(E),T=(0,l.$Hf)(E)?E:C?.id??(0,s.$Si)(j.toString()).toString(16);let F=this.b.get(j)?.logger;const G=C?.logLevel==="always"?b.Trace:C?.logLevel;F||(F=this.s(j,G??this.getLogLevel(j)??this.h,{...C,id:T}));const J={logger:F,info:{resource:j,id:T,logLevel:G,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(J.info),this.b.set(j,J),F}n(E){return(0,l.$Hf)(E)?(0,f.$Gg)(this.j,`${E}.log`):E}setLogLevel(E,C){if(p.URI.isUri(E)){const j=E,T=C,F=this.b.get(j);F&&T!==F.info.logLevel&&(F.info.logLevel=T===this.h?void 0:T,F.logger?.setLevel(T),this.b.set(F.info.resource,F),this.f.fire([j,T]))}else{this.h=E;for(const[j,T]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,C){const j=this.m(E);j&&C!==!j.info.hidden&&(j.info.hidden=!C,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,C]))}getLogLevel(E){let C;return E&&(C=this.b.get(E)?.info.logLevel),C??this.h}registerLogger(E){const C=this.b.get(E.resource);C?C.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const C=this.b.get(E);C&&(C.logger&&C.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$xj=r;class i{constructor(){this.onDidChangeLogLevel=new A.$Ud().event}setLevel(E){}getLevel(){return b.Info}trace(E,...C){}debug(E,...C){}info(E,...C){}warn(E,...C){}error(E,...C){}critical(E,...C){}dispose(){}flush(){}}e.$yj=i;class n extends i{}e.$zj=n;function a(I){if(I.verbose)return b.Trace;if(typeof I.logLevel=="string"){const E=O(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$pj}e.$Aj=a;function m(I){switch(I){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$Bj=m;function O(I){switch(I){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$Cj=O,e.$Dj=new k.$jj("logLevel",m(b.Info))});var ne=this&&this.__param||function(Q,e){return function(P,A){e(P,A,Q)}};define(oe[220],ae([0,1,15,4,5]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K0b=void 0;const M=P.safeStorage;let D=class{constructor(f){this.a=f,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(M.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(f){let l;try{if(l=JSON.parse(f),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const p=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const k=M.decryptString(p);return this.a.trace("[EncryptionMainService] Decrypted value."),k}catch(p){throw this.a.error(p),p}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$i)return Promise.resolve("dpapi");if(A.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$K0b=D,e.$K0b=D=Ee([ne(0,s.$mj)],D)}),define(oe[221],ae([0,1,22,8,14,3,2,9,67,5]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class p extends D.$Tc{constructor(v,u){super(),this.a=v,this.b=u,this.c=this.B(new M.$Ud),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Ud),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$3g(0)),this.w=[],this.y=this.B(new A.$3g(0))}watch(v,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(v,u):this.z(v,u)}n(v,u){const y={path:this.H(v),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},b=(0,P.$Ub)(this.j,y);return this.r(),(0,D.$Rc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,s.$1)(v))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,f.$gq)(u)),u=>this.G(u),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const u of this.j)(0,f.$cq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const u of this.j)(0,f.$cq)(u)&&v.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,u){const y={path:this.H(v),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},b=(0,P.$Ub)(this.w,y);return this.C(),(0,D.$Rc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,s.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,f.$gq)(v)),v=>this.G(v),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,S.$hc)(v.fsPath)}}e.$kq=p}),define(oe[222],ae([0,1,22,8,17,23,3,45,72,2,58,13,68,19,63,175,16,119,5,14]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;let c=class extends l.$Tc{static{w=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Ud),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Ud),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Ud),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Ud),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Ud),this.Y=this.B(new D.$Ud),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Ud),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$bh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`);const i=new l.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const a=new $.$Ik(n,!this.S(r));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,l.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,l.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await A.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return f.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,u.$Kg)(o))throw new $.$Kk((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new g.$bb;throw i.message=(0,b.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,$.$vk)(r)||(0,$.$sk)(r)||(0,$.$wk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,$.$vk)(r)||(0,$.$sk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,$.$Fk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$Kk((0,b.localize)(2,null,this.sb(o)),1):(0,$.$Dk)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),a=r?.resolveTo,m=r?.resolveSingleChildDescendants,O=r?.resolveMetadata,I=await i.stat(o);let E;return this.t(i,o,I,void 0,!!O,(C,j)=>(E||(E=p.$$h.forUris(()=>!n),E.set(o,!0),a&&E.fill(!0,a)),E.get(C.resource)||E.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&m?j===1:!1))}async t(o,r,i,n,a,m){const{providerExtUri:O}=this.R(o),I={resource:r,name:O.basename(r),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Vk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&m(I,n)){try{const E=await o.readdir(r),C=await A.Promises.settled(E.map(async([j,T])=>{try{const F=O.joinPath(r,j),G=a?await o.stat(F):{type:T};return await this.t(o,F,G,E.length,a,m)}catch(F){return this.b.trace(F),null}}));I.children=(0,P.$Hb)(C)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return A.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new $.$Kk((0,b.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$ie.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new $.$Hk(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:a}=this.R(n);let m=i;if((0,$.$yk)(n)&&!m?.atomic){const O=n.enforceAtomicWriteFile?.(o);O&&(m={...i,atomic:O})}try{await this.w(n,o,m)||await this.U(n,a.dirname(o));let I;if((0,$.$sk)(n)&&!(r instanceof s.$ie))if((0,y.$7d)(r)){const E=await(0,y.$be)(r,3);E.ended?I=s.$ie.concat(E.buffer):I=E}else I=(0,y.$$d)(r,E=>s.$ie.concat(E),3);else I=r;!(0,$.$vk)(n)||(0,$.$sk)(n)&&I instanceof s.$ie||(0,$.$sk)(n)&&(0,$.$yk)(n)&&m?.atomic?await this.hb(n,o,m,I):await this.db(n,o,m,I instanceof s.$ie?(0,s.$te)(I):I),this.r.fire(new $.$Hk(o,4))}catch(O){throw new $.$Kk((0,b.localize)(4,null,this.sb(o),(0,$.$Dk)(O).toString()),(0,$.$Gk)(O),m)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(r)));if(n)throw new Error((0,b.localize)(8,null,this.sb(r)))}let m;try{m=await o.stat(r)}catch{return}if(m.type&$.FileType.Directory)throw new $.$Kk((0,b.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,m),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Uk&&typeof m.mtime=="number"&&typeof m.size=="number"&&i.mtime<m.mtime&&i.etag!==(0,$.$Vk)({mtime:i.mtime,size:m.size}))throw new $.$Kk((0,b.localize)(10,null),3,i);return m}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((a,m)=>{this.cb.queueFor(r,async()=>{try{const O=await this.C(o,r,i,n);a(O)}catch(O){m(O)}},this.R(o).providerExtUri)})}async C(o,r,i,n){const a=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,s.$ue)(a.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const a=new M.$5d(n);let m=i;(0,$.$xk)(o)&&o.enforceAtomicReadFile?.(r)&&(m={...i,atomic:!0});const O=this.J(r,m).then(E=>E,E=>{throw a.dispose(!0),E});let I;try{return typeof m?.etag=="string"&&m.etag!==$.$Uk&&await O,m?.atomic&&(0,$.$xk)(o)||!((0,$.$vk)(o)||(0,$.$wk)(o))||(0,$.$sk)(o)&&m?.preferUnbuffered?I=this.I(o,r,m):(0,$.$wk)(o)?I=this.G(o,r,a.token,m):I=this.H(o,r,a.token,m),I.on("end",()=>a.dispose()),I.on("error",()=>a.dispose()),{...await O,value:I}}catch(E){throw I&&await(0,y.$_d)(I),this.F(E,r,m)}}F(o,r,i){const n=(0,b.localize)(11,null,this.sb(r),(0,$.$Dk)(o).toString());return o instanceof $.$Mk?new $.$Mk(n,o.stat,i):o instanceof $.$Lk?new $.$Lk(n,o.fileOperationResult,o.size,o.options):new $.$Kk(n,(0,$.$Gk)(o),i)}G(o,r,i,n=Object.create(null)){const a=o.readFileStream(r,n,i);return(0,y.$fe)(a,{data:m=>m instanceof s.$ie?m:s.$ie.wrap(m),error:m=>this.F(m,r,n)},m=>s.$ie.concat(m))}H(o,r,i,n=Object.create(null)){const a=(0,s.$ye)();return(0,d.$aq)(o,r,a,m=>m,{...n,bufferSize:this.a,errorTransformer:m=>this.F(m,r,n)},i),a}I(o,r,i){const n=(0,y.$9d)(a=>s.$ie.concat(a));return(async()=>{try{let a;i?.atomic&&(0,$.$xk)(o)?a=await o.readFile(r,{atomic:!0}):a=await o.readFile(r),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.L(r,a.byteLength,i),n.end(s.$ie.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$Kk((0,b.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==$.$Uk&&r.etag===i.etag)throw new $.$Mk((0,b.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new $.$Lk((0,b.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const a=i==="move"?this.qb(await this.n(o),o):await this.m(o),m=this.qb(await this.n(r),r);await this.Q(a,o,m,r,i,n)}catch(a){return a}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),a=this.qb(await this.n(r),r),m=await this.N(n,o,a,r,"move",!!i),O=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Hk(o,m==="move"?2:3,O)),O}async copy(o,r,i){const n=await this.m(o),a=this.qb(await this.n(r),r),m=await this.N(n,o,a,r,"copy",!!i),O=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Hk(o,m==="copy"?3:2,O)),O}async N(o,r,i,n,a,m){if(r.toString()===n.toString())return a;const{exists:O,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,n,a,m);if(O&&!I&&m&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),a==="copy"){if(o===i&&(0,$.$tk)(o))await o.copy(r,n,{overwrite:m});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,n):await this.O(o,r,i,n)}return a}else return o===i?(await o.rename(r,n,{overwrite:m}),a):(await this.N(o,r,i,n,"copy",m),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,$.$vk)(o)&&(0,$.$vk)(i))return this.jb(o,r,i,n);if((0,$.$vk)(o)&&(0,$.$sk)(i))return this.pb(o,r,i,n);if((0,$.$sk)(o)&&(0,$.$vk)(i))return this.nb(o,r,i,n);if((0,$.$sk)(o)&&(0,$.$sk)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async a=>{const m=this.R(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.P(o,await this.resolve(a.resource),i,m):this.O(o,a.resource,i,m)}))}async Q(o,r,i,n,a,m){let O=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:C}=this.R(o);if(C||(O=E.isEqual(r,n)),O&&a==="copy")throw new Error((0,b.localize)(15,null,this.sb(r),this.sb(n)));if(!O&&E.isEqualOrParent(n,r))throw new Error((0,b.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!O){if(!m)throw new $.$Kk((0,b.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,b.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:O}}R(o){const r=this.S(o);return{providerExtUri:r?u.$wg:u.$yg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$Hk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&$.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(r)));break}catch(a){if((0,$.$Fk)(a)!==$.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(r)),r=n.dirname(r)}for(let a=i.length-1;a>=0;a--){r=n.joinPath(r,i[a]);try{await o.mkdir(r)}catch(m){if((0,$.$Fk)(m)!==$.FileSystemProviderErrorCode.FileExists)throw m}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const a=r?.atomic;if(a&&!(i.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(n&&a)throw new Error((0,b.localize)(22,null,this.sb(o)));let m;try{m=await i.stat(o)}catch{}if(m)this.rb(o,m);else throw new $.$Kk((0,b.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,$.$zk)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const a=!!n?.useTrash,m=!!n?.recursive,O=n?.atomic??!1;await i.delete(o,{recursive:m,useTrash:a,atomic:O}),this.r.fire(new $.$Hk(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(o,r)))return i===n&&(0,$.$uk)(i)?i.cloneFile(o,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,$.$tk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:w.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new l.$Sc;let n=!1,a=()=>{n=!0};i.add((0,l.$Rc)(()=>a())),(async()=>{try{const O=await this.bb(o,r);n?(0,l.$Oc)(O):a=()=>(0,l.$Oc)(O)}catch(O){this.b.error(O)}})();const m=r.correlationId;if(typeof m=="number"){const O=i.add(new D.$Ud);return i.add(this.X.event(E=>{E.correlates(m)&&O.fire(E)})),{onDidChange:O.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,S.$Si)([this.R(i).providerExtUri.getComparisonKey(o),r]);let a=this.$.get(n);return a||(a={count:0,disposable:i.watch(o,r)},this.$.set(n,a)),a.count+=1,(0,l.$Rc)(()=>{a&&(a.count--,a.count===0&&((0,l.$Oc)(a.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,l.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,async()=>{const a=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,y.$7d)(n)||(0,y.$8d)(n)?await this.eb(o,a,n):await this.fb(o,a,n)}catch(m){throw(0,$.$Dk)(m)}finally{await o.close(a)}},this.R(o).providerExtUri)}async eb(o,r,i){let n=0,a;if((0,y.$8d)(i)){if(i.buffer.length>0){const m=s.$ie.concat(i.buffer);await this.gb(o,r,m,m.byteLength,n,0),n+=m.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((m,O)=>{(0,y.$ae)(a,{onData:async I=>{a.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(E){return O(E)}n+=I.byteLength,setTimeout(()=>a.resume())},onError:I=>O(I),onEnd:()=>m()})})}async fb(o,r,i){let n=0,a;for(;(a=i.read())!==null;)await this.gb(o,r,a,a.byteLength,n,0),n+=a.byteLength}async gb(o,r,i,n,a,m){let O=0;for(;O<n;){const I=await o.write(r,a+O,i.buffer,m+O,n-O);O+=I}}async hb(o,r,i,n){return this.cb.queueFor(r,()=>this.ib(o,r,i,n),this.R(o).providerExtUri)}async ib(o,r,i,n){let a;n instanceof s.$ie?a=n:(0,y.$7d)(n)?a=await(0,s.$ue)(n):(0,y.$8d)(n)?a=await(0,s.$ve)(n):a=(0,s.$se)(n),await o.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,()=>this.kb(o,r,i,n),this.R(i).providerExtUri)}async kb(o,r,i,n){let a,m;try{a=await o.open(r,{create:!1}),m=await i.open(n,{create:!0,unlock:!1});const O=s.$ie.alloc(this.a);let I=0,E=0,C=0;do C=await o.read(a,I,O.buffer,E,O.byteLength-E),await this.gb(i,m,O,C,I,E),I+=C,E+=C,E===O.byteLength&&(E=0);while(C>0)}catch(O){throw(0,$.$Dk)(O)}finally{await A.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof m=="number"?i.close(m):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,()=>this.mb(o,r,i,n),this.R(i).providerExtUri)}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,()=>this.ob(o,r,i,n),this.R(i).providerExtUri)}async ob(o,r,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const m=await o.readFile(r);await this.gb(i,a,s.$ie.wrap(m),m.byteLength,0,0)}catch(m){throw(0,$.$Dk)(m)}finally{await i.close(a)}}async pb(o,r,i,n){const a=await(0,s.$ue)(this.H(o,r,M.CancellationToken.None));await this.hb(i,n,void 0,a)}qb(o,r){if(o.capabilities&2048)throw new $.$Kk((0,b.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&$.FilePermission.Readonly)throw new $.$Kk((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$bq=c,e.$bq=c=w=Ee([ne(0,h.$mj)],c)}),define(oe[93],ae([0,1,46,311,8,31,17,3,33,2,9,4,19,63,21,179,16,119,221,51,217,216]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0,(()=>{try{(0,A.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,g.$Pi)(o)}`)}})();class t extends h.$kq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$Ac(n=>v.$xg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let m;a.isSymbolicLink()?m=(await this.stat((0,v.$Gg)(r,a.name))).type:m=this.M(a),n.push([a.name,m])}catch(m){this.a.trace(m)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=$.FileType.Unknown:r.isFile()?n=$.FileType.File:r.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$4g;return this.N.set(r,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const a=this.H(r);return await y.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const a=(0,u.$9d)(m=>D.$ie.concat(m.map(O=>D.$ie.wrap(O))).buffer);return(0,d.$aq)(this,r,a,m=>m.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,v.$Gg)((0,v.$Fg)(r),`${(0,v.$Dg)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await y.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,a){const m=new l.$Sc;try{m.add(await this.O(r)),m.add(await this.O(i)),await this.S(i,n,a,!0);try{await this.rename(i,r,{overwrite:!0})}catch(O){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw O}}finally{m.dispose()}}async S(r,i,n,a){let m;try{const O=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(O)){if(!n.overwrite)throw(0,$.$Ck)((0,b.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$Ck)((0,b.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(r,{create:!0,unlock:n.unlock},a),await this.write(m,0,i,0,i.byteLength)}catch(O){throw await this.gb(r,O)}finally{typeof m=="number"&&await this.close(m)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const a=this.H(r);let m;(0,$.$qk)(i)&&!n&&(m=await this.O(r));let O;try{if((0,$.$qk)(i)&&i.unlock)try{const{stat:E}=await y.SymlinkSupport.stat(a);E.mode&128||await y.Promises.chmod(a,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,$.$qk)(i)){if(k.$i)try{await y.Promises.truncate(a,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";O=await y.Promises.open(a,I)}catch(I){throw m?.dispose(),(0,$.$qk)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(O,0),(0,$.$qk)(i)&&this.X.set(O,r),m){const I=this.W.get(O);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${O} (${a})`),this.W.set(O,m),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${O} (${a})`),I.dispose())}return O}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,a,m){const O=this.Z(r,i);let I=null;try{I=(await y.Promises.read(r,n,a,m,O)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,O,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const a=this.U.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,a+n):this.U.delete(r)))}async write(r,i,n,a,m){return(0,s.$mh)(()=>this.ab(r,i,n,a,m),100,3)}async ab(r,i,n,a,m){const O=this.Z(r,i);let I=null;try{I=(await y.Promises.write(r,n,a,m,O)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,O,I)}return I}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,p.$jc)((0,p.$mc)(n),`${(0,p.$nc)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,a)}else try{await y.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let m=!1;try{const{stat:O,symbolicLink:I}=await y.SymlinkSupport.stat(n);m=O.isDirectory()&&!I}catch{}if(m)await y.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.fb(n)}}async rename(r,i,n){const a=this.H(r),m=this.H(i);if(a!==m)try{await this.bb(r,i,"move",n.overwrite),await y.Promises.rename(a,m)}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,b.localize)(2,null,(0,p.$nc)(a),(0,p.$nc)((0,p.$mc)(m)),O.toString()))),this.fb(O)}}async copy(r,i,n){const a=this.H(r),m=this.H(i);if(a!==m)try{await this.bb(r,i,"copy",n.overwrite),await y.Promises.copy(a,m,{preserveSymlinks:!0})}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,b.localize)(3,null,(0,p.$nc)(a),(0,p.$nc)((0,p.$mc)(m)),O.toString()))),this.fb(O)}}async bb(r,i,n,a){const m=this.H(r),O=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.$6f)(m,O,!0)),I){if(n==="copy")throw(0,$.$Ck)((0,b.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,$.$Ck)((0,b.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!a)throw(0,$.$Ck)((0,b.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);C.type&$.FileType.File&&j.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const a=this.H(r),m=this.H(i),O=!!(this.capabilities&1024);if((0,f.$6f)(a,m,!O))return;const I=new l.$Sc;try{I.add(await this.O(r)),I.add(await this.O(i)),n&&await y.Promises.mkdir((0,p.$mc)(m),{recursive:!0}),await y.Promises.copyFile(a,m)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(E)}finally{I.dispose()}}t(r,i,n){return new w.$rq(a=>r(a),a=>i(a),n)}F(r,i,n){return new c.$zq(a=>r(a),a=>i(a),n)}fb(r){if(r instanceof $.$Bk)return r;let i=r,n;switch(r.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$Ck)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await y.SymlinkSupport.stat(this.H(r));a.mode&128||(n=(0,$.$Ck)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$Aq=t}),define(oe[223],ae([0,1,3,93,2,17,63,23]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=void 0;class f extends s.$Tc{constructor(k,v){super(),this.a=k,this.b=v,this.F=new Map,this.G=new Map}call(k,v,u){const y=this.c(k);switch(v){case"stat":return this.g(y,u[0]);case"readdir":return this.h(y,u[0]);case"open":return this.r(y,u[0],u[1]);case"close":return this.s(u[0]);case"read":return this.t(u[0],u[1],u[2]);case"readFile":return this.j(y,u[0],u[1]);case"write":return this.u(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.n(y,u[0],u[1],u[2]);case"rename":return this.z(y,u[0],u[1],u[2]);case"copy":return this.C(y,u[0],u[1],u[2]);case"cloneFile":return this.D(y,u[0],u[1]);case"mkdir":return this.w(y,u[0]);case"delete":return this.y(y,u[0],u[1]);case"watch":return this.I(y,u[0],u[1],u[2],u[3]);case"unwatch":return this.J(u[0],u[1])}throw new Error(`IPC Command ${v} not found`)}listen(k,v,u){const y=this.c(k);switch(v){case"fileChange":return this.H(y,u[0]);case"readFileStream":return this.m(y,u[0],u[1])}throw new Error(`Unknown event ${v}`)}g(k,v){const u=this.f(k,v,!0);return this.a.stat(u)}h(k,v){const u=this.f(k,v);return this.a.readdir(u)}async j(k,v,u){const y=this.f(k,v,!0),b=await this.a.readFile(y,u);return M.$ie.wrap(b)}m(k,v,u){const y=this.f(k,v,!0),b=new S.$5d,$=new P.$Ud({onDidRemoveLastListener:()=>{b.cancel()}}),d=this.a.readFileStream(y,u,b.token);return(0,D.$ae)(d,{onData:h=>$.fire(M.$ie.wrap(h)),onError:h=>$.fire(h),onEnd:()=>{$.fire("end"),$.dispose(),b.dispose()}}),$.event}n(k,v,u,y){const b=this.f(k,v);return this.a.writeFile(b,u.buffer,y)}r(k,v,u){const y=this.f(k,v,!0);return this.a.open(y,u)}s(k){return this.a.close(k)}async t(k,v,u){const y=M.$ie.alloc(u),b=0,$=await this.a.read(k,v,y.buffer,b,u);return[y,$]}u(k,v,u,y,b){return this.a.write(k,v,u.buffer,y,b)}w(k,v){const u=this.f(k,v);return this.a.mkdir(u)}y(k,v,u){const y=this.f(k,v);return this.a.delete(y,u)}z(k,v,u,y){const b=this.f(k,v),$=this.f(k,u);return this.a.rename(b,$,y)}C(k,v,u,y){const b=this.f(k,v),$=this.f(k,u);return this.a.copy(b,$,y)}D(k,v,u){const y=this.f(k,v),b=this.f(k,u);return this.a.cloneFile(y,b)}H(k,v){const u=new P.$Ud({onWillAddFirstListener:()=>{this.F.set(v,this.L(k,u))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(v)),this.F.delete(v)}});return u.event}async I(k,v,u,y,b){const $=this.F.get(v);if($){const d=this.f(k,y),h=$.watch(u,d,b);this.G.set(v+u,h)}}async J(k,v){const u=k+v,y=this.G.get(u);y&&((0,s.$Oc)(y),this.G.delete(u))}dispose(){super.dispose();for(const[,k]of this.G)k.dispose();this.G.clear();for(const[,k]of this.F)k.dispose();this.F.clear()}}e.$0r=f;class l extends s.$Tc{constructor(k,v,u,y){super(),this.c=k,this.f=u,this.g=y,this.a=new Map,this.b=this.B(new A.$Aq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(k){const v=this.B(new P.$Ud);this.B(v.event(u=>{k.fire(u.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type,cId:y.cId})))})),this.B(this.b.onDidChangeFile(u=>v.fire(u))),this.B(this.b.onDidWatchError(u=>k.fire(u)))}j(k){}m(k){}watch(k,v,u){const y=this.m(this.g);return Array.isArray(y)&&(u.excludes=[...u.excludes,...y]),this.a.set(k,this.b.watch(v,u)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(k)),this.a.delete(k)})}dispose(){for(const[,k]of this.a)k.dispose();this.a.clear(),super.dispose()}}e.$$r=l}),define(oe[224],ae([0,1,15,178,4,7,16,9,223,155]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=void 0;class p extends f.$0r{constructor(u,y,b){super(u,y),this.M=b}c(u){return l.$4m}f(u,y){return M.URI.revive(y)}async y(u,y,b){if(!b.useTrash)return super.y(u,y,b);const $=this.f(u,y),d=(0,S.$hc)($.fsPath);try{await P.shell.trashItem(d)}catch{throw(0,D.$Ck)(s.$i?(0,A.localize)(0,null,(0,S.$nc)(d)):(0,A.localize)(1,null,(0,S.$nc)(d)),D.FileSystemProviderErrorCode.Unknown)}}L(u,y){return new k(u,y,this.b,this.M)}}e.$S0b=p;class k extends f.$$r{watch(u,y,b){if(b.recursive)throw(0,D.$Ck)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,y,b)}}}),define(oe[225],ae([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;class A extends P.$sj{constructor(M=P.$pj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:S}of this.m)(0,P.log)(M,D,S);this.m=[]}g(M,D){this.n?(0,P.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$G7b=A}),define(oe[226],ae([0,1,7,3,5,2]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.$zr=void 0;class D extends s.$xj{constructor(k,v,u,y,b){super(v,u,y),this.r=k,this.t=b,this.B(b.listen("onDidChangeLogLevel",k)($=>{(0,s.$oj)($)?super.setLogLevel($):super.setLogLevel(P.URI.revive($[0]),$[1])})),this.B(b.listen("onDidChangeVisibility",k)(([$,d])=>super.setVisibility(P.URI.revive($),d))),this.B(b.listen("onDidChangeLoggers",k)(({added:$,removed:d})=>{for(const h of $)super.registerLogger({...h,resource:P.URI.revive(h.resource)});for(const h of d)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$vj({log:(k,v)=>{this.t.call("consoleLog",[k,v])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,v){super.setLogLevel(k,v),this.t.call("setLogLevel",[k,v])}setVisibility(k,v){super.setVisibility(k,v),this.t.call("setVisibility",[this.n(k),v])}s(k,v,u){return new S(this.t,k,v,u,this.r)}static setLogLevel(k,v,u){return k.call("setLogLevel",[v,u])}}e.$zr=D;class S extends s.$sj{constructor(k,v,u,y,b){super(y?.logLevel==="always"),this.r=k,this.s=v,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[v,y,b]).then(()=>{this.u(this.n),this.m=!0})}g(k,v){const u=[[k,v]];this.m?this.u(u):this.n.push(...u)}u(k){this.r.call("log",[this.s,k])}}class f{constructor(k,v){this.a=k,this.b=v}listen(k,v){const u=this.b(k);switch(v){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(b=>this.c(b,u)),removed:[...y.removed].map(b=>this.c(b,u))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,y=>[u.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$oj)(y)?y:[u.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${v}`)}async call(k,v,u){const y=this.b(k);switch(v){case"setLogLevel":return(0,s.$oj)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(P.URI.revive(y.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,y)))}throw new Error(`Call not found: ${v}`)}c(k,v){return{...k,resource:v.transformOutgoingURI(k.resource)}}}e.$Ar=f;class l extends M.$Tc{constructor(k,v){super(),v.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(u=>v.call("setLogLevel",[u]))),v.call("getRegisteredLoggers").then(u=>{for(const y of u)k.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this.B(v.listen("onDidChangeVisibility")(([u,y])=>k.setVisibility(P.URI.revive(u),y))),this.B(v.listen("onDidChangeLoggers")(({added:u,removed:y})=>{for(const b of u)k.registerLogger({...b,resource:P.URI.revive(b.resource)});for(const b of y)k.deregisterLogger(b.resource)}))}}e.$Br=l}),define(oe[227],ae([0,1,2,5]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0;class s extends P.$Tc{constructor(D,S=[]){super(),this.a=new A.$wj([D,...S]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$tO=s}),define(oe[228],ae([0,1,31,7,5]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=void 0;class M{constructor(S){this.b=S,this.a=new P.$Ac}listen(S,f,l){switch(f){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,l){switch(f){case"createLogger":this.c(A.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(A.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$oj)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(A.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:A.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(l[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,l){this.a.set(S,this.b.createLogger(S,f,l))}d(S,f){let l=console.log;switch(S){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...f)}e(S,f){const l=this.a.get(S);if(!l)throw new Error("Create the logger before logging");for(const[p,k]of f)(0,s.log)(l,p,k)}}e.$M$b=M}),define(oe[229],ae([0,1,16,5]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function M(l,p,k,v,u){try{const y=await new Promise(($,d)=>{Q(["@vscode/spdlog"],$,d)});y.setFlushOn(s.Trace);const b=await y.createAsyncRotatingLogger(l,p,k,v);return u?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(y){console.error(y)}return null}function D(l,p,k){switch(p){case A.LogLevel.Trace:l.trace(k);break;case A.LogLevel.Debug:l.debug(k);break;case A.LogLevel.Info:l.info(k);break;case A.LogLevel.Warning:l.warn(k);break;case A.LogLevel.Error:l.error(k);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function S(l,p){switch(p){case A.LogLevel.Trace:l.setLevel(s.Trace);break;case A.LogLevel.Debug:l.setLevel(s.Debug);break;case A.LogLevel.Info:l.setLevel(s.Info);break;case A.LogLevel.Warning:l.setLevel(s.Warning);break;case A.LogLevel.Error:l.setLevel(s.Error);break;case A.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class f extends A.$sj{constructor(p,k,v,u,y){super(),this.m=[],this.setLevel(y),this.n=this.s(p,k,v,u),this.B(this.onDidChangeLogLevel(b=>{this.r&&S(this.r,b)}))}async s(p,k,v,u){const y=v?6:1,b=30/y*P.$Xk.MB,$=await M(p,k,b,y,u);if($){this.r=$,S(this.r,this.getLevel());for(const{level:d,message:h}of this.m)D(this.r,d,h);this.m=[]}}g(p,k){this.r?D(this.r,p,k):this.getLevel()<=p&&this.m.push({level:p,message:k})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$iO=f}),define(oe[230],ae([0,1,32,5,229]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;class M extends A.$xj{s(S,f,l){return new s.$iO((0,P.$pg)(),S.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.$jO=M}),define(oe[69],ae([0,1,31,3,6,5,230]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o0b=e.$n0b=void 0,e.$n0b=(0,s.$6h)(M.$nj);class S extends D.$jO{constructor(){super(...arguments),this.u=new P.$Ac}createLogger(l,p,k){k!==void 0&&this.u.set(this.n(l),k);try{return super.createLogger(l,p)}catch(v){throw this.u.delete(this.n(l)),v}}registerLogger(l,p){p!==void 0&&this.u.set(l.resource,p),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const p=[];for(const k of super.getRegisteredLoggers())l===this.u.get(k.resource)&&p.push(k);return p}getOnDidChangeLogLevelEvent(l){return A.Event.filter(this.onDidChangeLogLevel,p=>(0,M.$oj)(p)||this.w(p[0],l))}getOnDidChangeVisibilityEvent(l){return A.Event.filter(this.onDidChangeVisibility,([p])=>this.w(p,l))}getOnDidChangeLoggersEvent(l){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(v=>this.w(v.resource,l)),removed:[...p.removed].filter(v=>this.w(v.resource,l))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(l){for(const[p,k]of this.u)k===l&&this.deregisterLogger(p)}w(l,p){const k=this.u.get(l);return k===void 0||k===p}dispose(){super.dispose(),this.u.clear()}}e.$o0b=S}),define(oe[231],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$80b=e.$70b=e.$60b=e.$50b=void 0;function P(D){return D.submenu!==void 0}e.$50b=P;function A(D){return D.id==="vscode.menubar.separator"}e.$60b=A;function s(D){return D.uri!==void 0}e.$70b=s;function M(D){return!P(D)&&!A(D)&&!s(D)}e.$80b=M}),define(oe[39],ae([0,1,3,72,2,6]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=void 0,e.$In=(0,M.$5h)("policy");class D extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Ud),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const p=Object.keys(this.f).length;return this.f={...l,...this.f},p!==Object.keys(this.f).length&&await this.j(l),A.Iterable.reduce(this.g.entries(),(k,[v,u])=>({...k,[v]:u}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(l,[p,k])=>({...l,[p]:{definition:k,value:this.g.get(p)}}),{})}}e.$Jn=D;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Kn=S}),define(oe[232],ae([0,1,8,3,72,12,16,5,39]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6$b=void 0;function l(k,v){const u=[];for(const y of new Set(s.Iterable.concat(k.keys(),v.keys())))k.get(y)!==v.get(y)&&u.push(y);return u}let p=class extends f.$Jn{constructor(v,u,y){super(),this.m=v,this.n=u,this.s=y,this.c=this.B(new P.$3g(500));const b=A.Event.filter(u.onDidFilesChange,$=>$.affects(v));this.B(u.watch(v)),this.B(b(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const u=await this.n.readFile(this.m),y=JSON.parse(u.value.toString());if(!(0,M.$Jf)(y))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(y))this.f[b]&&v.set(b,y[b])}catch(u){u.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",u)}return v}async w(){const v=await this.u(),u=l(this.g,v);this.g=v,u.length>0&&this.h.fire(u)}};e.$6$b=p,e.$6$b=p=Ee([ne(1,D.$pk),ne(2,S.$mj)],p)}),define(oe[233],ae([0,1,3,2,39]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=void 0;class M{constructor(f){this.b=f,this.a=new A.$Sc}listen(f,l){switch(l){case"onDidChange":return P.Event.map(this.b.onDidChange,p=>p.reduce((k,v)=>({...k,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(f,l,p){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$D$b=M;class D extends s.$Jn{constructor(f,l){super(),this.a=l;for(const p in f){const{definition:k,value:v}=f[p];this.f[p]=k,v!==void 0&&this.g.set(p,v)}this.a.listen("onDidChange")(p=>{for(const k in p){const v=p[k];v===null?this.g.delete(k):this.g.set(k,v)}this.h.fire(Object.keys(p))})}async j(f){const l=await this.a.call("updatePolicyDefinitions",f);for(const p in l)this.g.set(p,l[p])}}e.$E$b=D}),define(oe[234],ae([0,1,39,8,2,5]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=void 0;let D=class extends P.$Jn{constructor(f,l){super(),this.m=f,this.n=l,this.a=new A.$Yg,this.b=this.B(new s.$Uc)}async j(f){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:l}=await new Promise((p,k)=>{Q(["@vscode/policy-watcher"],p,k)});await this.a.queue(()=>new Promise((p,k)=>{try{this.b.value=l(this.n,f,v=>{this.t(v),p()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),k(v)}}))}t(f){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const l in f){const p=f[l];p===void 0?this.g.delete(l):this.g.set(l,p)}this.h.fire(Object.keys(f))}};e.$5$b=D,e.$5$b=D=Ee([ne(0,M.$mj)],D)}),define(oe[79],ae([0,1,36]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)A=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:M.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(oe[27],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=void 0,e.$Ej=(0,P.$5h)("productService"),e.$Fj="vscode://schemas/vscode-product"}),define(oe[235],ae([0,1,8,5]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;let s=class{constructor(D,S,f){this.a=D,this.b=S,this.c=f}async inspect(D){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$6g)(D);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$V0b=s,e.$V0b=s=Ee([ne(2,A.$mj)],s)}),define(oe[80],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=void 0,e.$69b=(0,P.$5h)("protocolMainService")}),define(oe[44],ae([0,1,138,12]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class s{constructor(){this.a=new Map}add(D,S){P.ok(A.$Hf(D)),P.ok(A.$Jf(S)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Gn=new s}),define(oe[236],ae([0,1,3,44]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0,e.$Hn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$Ud,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,l){this.a[s(f)]=l,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;A.$Gn.add(e.$Hn.JSONContribution,D)}),define(oe[52],ae([0,1,22,3,12,163,18,236,44]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ConfigurationScope=e.$Ln=e.EditPresentationTypes=void 0;var l;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Ln={Configuration:"base.contributions.configuration"};var p;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.$Mn={properties:{},patternProperties:{}},e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn="vscode://schemas/settings/resourceLanguage",e.$Tn="vscode://schemas/settings/configurationDefaults";const k=f.$Gn.as(S.$Hn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.$Ud,this.onDidSchemaChange=this.i.event,this.j=new A.$Ud,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Sn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),k.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const a in i)if(o.add(a),e.$Vn.test(a)){const m=this.a.get(a),O=m?.valuesSources??new Map;if(n)for(const j of Object.keys(i[a]))O.set(j,n);const I={...m?.value||{},...i[a]};this.a.set(a,{source:n,value:I,valuesSources:O});const E=(0,D.$Ii)(a),C={type:"object",default:I,description:M.localize(1,null,E),$ref:e.$Sn,defaultDefaultValue:I,source:s.$Hf(n)?void 0:n,defaultValueSource:n};r.push(...b(a)),this.d[a]=C,this.b.properties[a]=C}else{this.a.set(a,{value:i[a],source:n});const m=this.d[a];m&&(this.w(a,m),this.r(a,m))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const a=this.a.get(n),m=s.$Hf(i)?i:i?.id,O=s.$Hf(a?.source)?a?.source:a?.source?.id;if(m===O)if(o.add(n),this.a.delete(n),e.$Vn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,a){n=s.$Qf(t.scope)?n:t.scope;const m=t.properties;if(m)for(const I in m){const E=m[I];if(o&&g(I,E)){delete m[I];continue}if(E.source=r,E.defaultDefaultValue=m[I].default,this.w(I,E),e.$Vn.test(I)?E.scope=void 0:(E.scope=s.$Qf(E.scope)?n:E.scope,E.restricted=s.$Qf(E.restricted)?!!i?.includes(I):E.restricted),m[I].hasOwnProperty("included")&&!m[I].included){this.f[I]=m[I],delete m[I];continue}else this.d[I]=m[I],m[I].policy?.name&&this.e.set(m[I].policy.name,I);!m[I].deprecationMessage&&m[I].markdownDeprecationMessage&&(m[I].deprecationMessage=m[I].markdownDeprecationMessage),a.add(I)}const O=t.allOf;if(O)for(const I of O)this.p(I,o,r,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const a in i)this.r(a,i[a]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Mn.properties[t]=o,o.scope){case 1:e.$Nn.properties[t]=o;break;case 2:e.$On.properties[t]=o;break;case 6:e.$Pn.properties[t]=o;break;case 3:e.$Qn.properties[t]=o;break;case 4:e.$Rn.properties[t]=o;break;case 5:e.$Rn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Mn.properties[t],o.scope){case 1:delete e.$Nn.properties[t];break;case 2:delete e.$On.properties[t];break;case 6:delete e.$Pn.properties[t];break;case 3:delete e.$Qn.properties[t];break;case 4:case 5:delete e.$Rn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Sn};this.w(o,r),e.$Mn.properties[o]=r,e.$Nn.properties[o]=r,e.$On.properties[o]=r,e.$Pn.properties[o]=r,e.$Qn.properties[o]=r,e.$Rn.properties[o]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Sn};e.$Mn.patternProperties[e.$Un]=t,e.$Nn.patternProperties[e.$Un]=t,e.$On.patternProperties[e.$Un]=t,e.$Pn.patternProperties[e.$Un]=t,e.$Qn.patternProperties[e.$Un]=t,e.$Rn.patternProperties[e.$Un]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Of(i)&&(i=o.defaultDefaultValue,n=void 0),s.$Of(i)&&(i=d(o.type)),o.default=i,o.defaultValueSource=n}}const u="\\[([^\\]]+)\\]",y=new RegExp(u,"g");e.$Un=`^(${u})+$`,e.$Vn=new RegExp(e.$Un);function b(c){const t=[];if(e.$Vn.test(c)){let o=y.exec(c);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=y.exec(c)}}return(0,P.$Mb)(t)}e.$Wn=b;function $(c){return c.reduce((t,o)=>`${t}[${o}]`,"")}e.$Xn=$;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Yn=d;const h=new v;f.$Gn.add(e.$Ln.Configuration,h);function g(c,t){return c.trim()?e.$Vn.test(c)?M.localize(7,null,c):h.getConfigurationProperties()[c]!==void 0?M.localize(8,null,c):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,c,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$Zn=g;function w(){const c=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))c.push([o,t[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$1n=w}),define(oe[120],ae([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;function u(o){return Object.isFrozen(o)?o:S.$vn(o)}class y{constructor(r={},i=[],n=[],a){this.b=r,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new b("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,p.$Gi)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),a=i?this.rawConfiguration.getOverrideValue(r,i):void 0,m=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:a,merged:m}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,p.$Gi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$un(this.contents),n=S.$un(this.overrides),a=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const O of r)if(m.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.h(i,O.contents);for(const I of O.overrides){const[E]=n.filter(C=>P.$ub(C.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=P.$Mb(E.keys)):n.push(S.$un(I))}for(const I of O.keys)a.indexOf(I)===-1&&a.push(I)}return new y(i,a,n,m.every(O=>O instanceof y)?void 0:m)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of P.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let m=this.contents[a];const O=i[a];O&&(typeof m=="object"&&typeof O=="object"?(m=S.$un(m),this.h(m,O)):m=O),n[a]=m}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$Jf(r[n])&&f.$Jf(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$un(i[n])}}i(r){let i=null,n=null;const a=m=>{m&&(n?this.h(n,m):n=S.$un(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===r?i=m.contents:m.identifiers.includes(r)&&a(m.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,p.$Fi)(this.contents,r),k.$Vn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$ub(n.identifiers,(0,k.$Wn)(r))),1))}j(r,i,n){(0,p.$Ei)(this.contents,r,i,a=>console.error(a)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),k.$Vn.test(r)&&this.overrides.push({identifiers:(0,k.$Wn)(r),keys:Object.keys(this.contents[r]),contents:(0,p.$Di)(this.contents[r],a=>console.error(a))})}}e.$2n=y;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$Qf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:a,overrides:m,restricted:O,hasExcludedProperties:I}=this.h(r,i);this.b=new y(n,a,m,I?[r]:void 0),this.c=O||[]}g(r){let i={},n=null,a=[];const m=[],O=[];function I(C){Array.isArray(a)?a.push(C):n!==null&&(a[n]=C)}const E={onObjectBegin:()=>{const C={};I(C),m.push(a),a=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const C=[];I(C),m.push(a),a=C,n=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:I,onError:(C,j,T)=>{O.push({error:C,offset:j,length:T})}};if(r)try{s.$in(r,E),i=a[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=v.$Gn.as(k.$Ln.Configuration).getConfigurationProperties(),a=this.i(r,n,!0,i);r=a.raw;const m=(0,p.$Di)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),O=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:m,keys:O,overrides:I,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(r,i,n,a){let m=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:m};const O={},I=[];for(const E in r)if(k.$Vn.test(E)&&n){const C=this.i(r[E],i,!1,a);O[E]=C.raw,m=m||C.hasExcludedProperties,I.push(...C.restricted)}else{const C=i[E],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&I.push(E),!a.exclude?.includes(E)&&(a.include?.includes(E)||(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&!(a.skipRestricted&&C?.restricted))?O[E]=r[E]:m=!0}return{raw:O,restricted:I,hasExcludedProperties:m}}j(r,i){const n=[];for(const a of Object.keys(r))if(k.$Vn.test(a)){const m={};for(const O in r[a])m[O]=r[a][O];n.push({identifiers:(0,k.$Wn)(a),keys:Object.keys(m),contents:(0,p.$Di)(m,i)})}return n}}e.$3n=b;class $ extends M.$Tc{constructor(r,i,n,a){super(),this.c=r,this.f=i,this.g=a,this.b=this.B(new A.$Ud),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&n.isEqual(m.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$4n=$;class d{constructor(r,i,n,a,m,O,I,E,C,j,T,F,G){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=m,this.f=O,this.g=I,this.h=E,this.i=C,this.j=j,this.k=T,this.l=F,this.m=G}get value(){return u(this.c)}n(r,i,n){const a=r.inspect(i,n);return{get value(){return u(a.value)},get override(){return u(a.override)},get merged(){return u(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,i,n,a,m=new y,O=new y,I=new D.$Ac,E=new y,C=new D.$Ac){this.c=r,this.d=i,this.f=n,this.g=a,this.h=m,this.i=O,this.j=I,this.l=E,this.m=C,this.a=null,this.b=new D.$Ac,this.n=null}getValue(r,i,n){return this.p(r,i,n).getValue(r)}updateValue(r,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new y,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(r):a.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const a=this.p(r,i,n),m=this.t(i.resource,n),O=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const E of a.overrides)for(const C of E.identifiers)a.getOverrideValue(r,C)!==void 0&&I.add(C);return new d(r,i,a.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,m||void 0,O)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:a,updated:m,removed:O}=c(this.c,r);i=[...a,...m,...O]}for(const a of i)for(const m of(0,k.$Wn)(a)){const O=this.c.getKeysForOverrideIdentifier(m),I=r.getKeysForOverrideIdentifier(m),E=[...I.filter(C=>O.indexOf(C)===-1),...O.filter(C=>I.indexOf(C)===-1),...O.filter(C=>!S.$yn(this.c.override(m).getValue(C),r.override(m).getValue(C)))];n.push([m,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:a}=c(this.d,r),m=[...i,...n,...a];return m.length&&this.updatePolicyConfiguration(r),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=c(this.applicationConfiguration,r),O=[...i,...n,...a];return O.length&&this.updateApplicationConfiguration(r),{keys:O,overrides:m}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=c(this.localUserConfiguration,r),O=[...i,...n,...a];return O.length&&this.updateLocalUserConfiguration(r),{keys:O,overrides:m}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=c(this.remoteUserConfiguration,r),O=[...i,...n,...a];return O.length&&this.updateRemoteUserConfiguration(r),{keys:O,overrides:m}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:a,overrides:m}=c(this.workspaceConfiguration,r),O=[...i,...n,...a];return O.length&&this.updateWorkspaceConfiguration(r),{keys:O,overrides:m}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:a,updated:m,removed:O,overrides:I}=c(n,i),E=[...a,...m,...O];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:a,removed:m,overrides:O}=c(i,void 0);return{keys:[...n,...a,...m],overrides:O}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,n){let a=this.q(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}q({resource:r},i){let n=this.r();if(i&&r){const a=i.getFolder(r);a&&(n=this.s(a.uri)||n);const m=this.m.get(r);m&&(n=n.merge(m))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const n=this.r(),a=this.j.get(r);a?(i=n.merge(a),this.b.set(r,i)):i=n}return i}t(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:a,keys:m}=this.j.get(i);return r.push([i,{contents:n,overrides:a,keys:m}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.w(r.defaults),n=this.w(r.policy),a=this.w(r.application),m=this.w(r.user),O=this.w(r.workspace),I=r.folders.reduce((E,C)=>(E.set(l.URI.revive(C[0]),this.w(C[1])),E),new D.$Ac);return new h(i,n,a,m,new y,O,I,new y,new D.$Ac)}static w(r){return new y(r.contents,r.keys,r.overrides)}}e.$5n=h;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const a of o)a.keys.forEach(m=>r.add(m)),a.overrides.forEach(([m,O])=>{const I=(0,D.$xc)(i,m,new Set);O.forEach(E=>I.add(E))});const n=[];return i.forEach((a,m)=>n.push([m,[...a.values()]])),{keys:[...r.values()],overrides:n}}e.$6n=g;class w{constructor(r,i,n,a){this.change=r,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const m of r.keys)this.affectedKeys.add(m);for(const[,m]of r.overrides)for(const O of m)this.affectedKeys.add(O);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,a=this.d.indexOf(n);if(a<0)return!1;const m=a+n.length;if(m>=this.d.length)return!1;const O=this.d.charCodeAt(m);if(O!==this.b&&O!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!S.$yn(I,E)}return!0}}e.$7n=w;function c(o,r){const{added:i,removed:n,updated:a}=t(r?.rawConfiguration,o?.rawConfiguration),m=[],O=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(C=>!O.includes(C));for(const C of E)m.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const E=O.filter(C=>!I.includes(C));for(const C of E)m.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const E of O)if(I.includes(E)){const C=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});m.push([E,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:a,overrides:m}}function t(o,r){const i=o?r?o.keys.filter(m=>r.keys.indexOf(m)===-1):[...o.keys]:[],n=r?o?r.keys.filter(m=>o.keys.indexOf(m)===-1):[...r.keys]:[],a=[];if(o&&r){for(const m of r.keys)if(o.keys.indexOf(m)!==-1){const O=(0,p.$Gi)(r.contents,m),I=(0,p.$Gi)(o.contents,m);S.$yn(O,I)||a.push(m)}}return{added:i,removed:n,updated:a}}}),define(oe[237],ae([0,1,22,3,2,35,12,120,52,5,39,44]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=void 0;class v extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new A.$Ud),this.onDidChangeConfiguration=this.a.event,this.b=new S.$2n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$Gn.as(f.$Ln.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:d})=>this.c(Array.from($),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,d){this.h($,k.$Gn.as(f.$Ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new S.$2n;const $=k.$Gn.as(f.$Ln.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,d){const h=this.f();for(const g of $){const w=h[g],c=d[g];w!==void 0?this.b.addValue(g,w):c?this.b.addValue(g,c.default):this.b.removeValue(g)}}}e.$8n=v;class u{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new S.$2n}async initialize(){return this.configurationModel}}e.$9n=u;let y=class extends s.$Tc{get configurationModel(){return this.b}constructor($,d,h){super(),this.c=$,this.f=d,this.g=h,this.a=this.B(new A.$Ud),this.onDidChangeConfiguration=this.a.event,this.b=new S.$2n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const d={},h=[],g=k.$Gn.as(f.$Ln.Configuration).getConfigurationProperties();for(const w of $){const c=g[w];if(!c){h.push(w);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}h.push(w),d[c.policy.name]={type:c.type}}}return(0,D.$Uf)(d)||await this.f.updatePolicyDefinitions(d),h}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const d=k.$Gn.as(f.$Ln.Configuration).getPolicyConfigurations(),h=(0,P.$Hb)($.map(g=>d.get(g)));this.m(h,!0)}m($,d){this.g.trace("PolicyConfiguration#update",$);const h=k.$Gn.as(f.$Ln.Configuration).getConfigurationProperties(),g=[],w=this.b.isEmpty();for(const c of $){const t=h[c]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(w?o!==void 0:!(0,M.$yn)(this.b.getValue(c),o))&&g.push([c,o])}else this.b.getValue(c)!==void 0&&g.push([c,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const c=this.b;this.b=new S.$2n;for(const t of c.keys)this.b.setValue(t,c.getValue(t));for(const[t,o]of g)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);d&&this.a.fire(this.b)}}};e.$0n=y,e.$0n=y=Ee([ne(1,p.$In),ne(2,l.$mj)],y)}),define(oe[238],ae([0,1,22,8,17,3,42,101,2,35,4,19,18,120,52,237,39]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=void 0;class d extends f.$Tc{constructor(w,c,t,o){super(),this.m=w,this.h=this.B(new M.$Ud),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$8n),this.c=t instanceof $.$Kn?new b.$9n:this.B(new b.$0n(this.b,t,o)),this.f=this.B(new u.$4n(this.m,{},k.$xg,c)),this.a=new u.$5n(this.b.configurationModel,this.c.configurationModel,new u.$2n,new u.$2n),this.j=new h(w,c,this),this.g=this.B(new A.$eh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,c,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new u.$5n(w,c,new u.$2n,t)}getConfigurationData(){return this.a.toData()}getValue(w,c){const t=typeof w=="string"?w:void 0,o=(0,v.$zi)(w)?w:(0,v.$zi)(c)?c:{};return this.a.getValue(t,o,void 0)}async updateValue(w,c,t,o,r){const i=(0,v.$Ai)(t)?t:(0,v.$zi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,n=i?o:t;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${w} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,P.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect(w,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${w} because it is configured in system policy.`);if((0,l.$yn)(c,a.defaultValue)&&(c=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const O=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(E=>(0,P.$ub)([...E.identifiers].sort(),O));I&&(i.overrideIdentifiers=I.identifiers)}const m=i?.overrideIdentifiers?.length?[(0,y.$Xn)(i.overrideIdentifiers),w]:[w];await this.j.write(m,c),await this.reloadConfiguration()}inspect(w,c={}){return this.a.inspect(w,c,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.n(w)}n(w){const c=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(w);this.t(t,c,2)}r(w,c){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(w,c);this.t(o,t,7)}s(w){const c=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(w);this.t(t,c,7)}t(w,c,t){const o=new u.$7n(w,{data:c},this.a);o.source=t,o.sourceConfig=this.u(t),this.h.fire(o)}u(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$$n=d;class h{constructor(w,c,t){this.b=w,this.c=c,this.d=t,this.a=new A.$_g}write(w,c){return this.a.queue(()=>this.e(w,c))}async e(w,c){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,D.$bn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,w,c);t=(0,S.$tn)(t,r),await this.c.writeFile(this.b,s.$ie.fromString(t))}f(w,c,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!c.length){const n=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,S.$qn)(w,c,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let w=p.OS===3||p.OS===2?`
`:`\r
`;const c=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});c&&typeof c=="string"&&c!=="auto"&&(w=c),this.g={eol:w,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[239],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=e.$S$b=e.$R$b=void 0,e.$R$b="request",e.$S$b="remoteResourceHandler";class P{async routeCall(s,M,D){if(M!==e.$R$b)throw new Error(`Call not found: ${M}`);const S=D[0];if(S?.authority){const f=s.connections.find(l=>l.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$T$b=P}),define(oe[240],ae([0,1,14,6]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.RemoteAuthorityResolverErrorCode=e.$9k=e.$8k=e.RemoteConnectionType=e.$7k=void 0,e.$7k=(0,A.$5h)("remoteAuthorityResolverService");var s;(function(p){p[p.WebSocket=0]="WebSocket",p[p.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$8k=M;class D{constructor(k,v){this.host=k,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$9k=D;var S;(function(p){p.Unknown="Unknown",p.NotAvailable="NotAvailable",p.TemporarilyNotAvailable="TemporarilyNotAvailable",p.NoResolverFound="NoResolverFound",p.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends P.$bb{static isNotAvailable(k){return k instanceof f&&k._code===S.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===S.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===S.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===S.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,v=S.Unknown,u){super(k),this._message=k,this._code=v,this._detail=u,this.isHandled=v===S.NotAvailable&&u===!0,Object.setPrototypeOf(this,f.prototype)}}e.$0k=f;function l(p){const k=p.indexOf("+");return k===-1?p:p.substring(0,k)}e.$$k=l}),define(oe[59],ae([0,1,13]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0;function A(l){return l.scheme===P.Schemas.vscodeRemote?l.authority:void 0}e.$_k=A;function s(l){if(!l)return;const p=l.indexOf("+");return p<0?l:l.substr(0,p)}e.$al=s;function M(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$bl=M;function D(l){const{host:p,port:k}=f(l);if(typeof k>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:p,port:k}}e.$cl=D;function S(l,p){let{host:k,port:v}=f(l);return typeof v>"u"&&(v=p),{host:k,port:v}}e.$dl=S;function f(l){const p=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const k=l.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(oe[121],ae([0,1,25,6,59]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.TargetPlatform=e.ExtensionType=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em="extensions.user.cache",e.$fm="extensions.builtin.cache",e.$gm="undefined_publisher",e.$hm=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$im=M,e.$jm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,d){if(typeof $>"u"||$===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof $=="string"||typeof d=="string"){const h=typeof $=="string"?$:$.value,g=typeof d=="string"?d:d.value;return P.$$e(h,g)}return $._lower===d._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$km=f;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const d of $)this.add(d)}add($){this.c.add(f.toKey($))}delete($){return this.c.delete(f.toKey($))}has($){return this.c.has(f.toKey($))}}e.$lm=l;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(f.toKey($))}get($){return this.c.get(f.toKey($))}has($){return this.c.has(f.toKey($))}set($,d){this.c.set(f.toKey($),d)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$mm=p;function k(b){return v(b)}e.$nm=k;function v(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$om=v;function u(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$pm=u;function y(b,$){if($){const d=`onResolveRemoteAuthority:${(0,s.$al)($)}`;return!!b.activationEvents?.includes(d)}return!1}e.$qm=y,e.$rm=(0,A.$5h)("IBuiltinExtensionsScannerService")}),define(oe[241],ae([0,1,8,17,23,14,3,2,68,73,32,110,240,59]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.PersistentConnectionEventType=e.$kl=e.$jl=e.$il=e.ConnectionType=void 0;const y=30*1e3;var b;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function $(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(K){const R=new s.$5d;return setTimeout(()=>R.cancel(),K),R.token}function h(K,R){if(K.isCancellationRequested||R.isCancellationRequested)return s.CancellationToken.Cancelled;const U=new s.$5d;return K.onCancellationRequested(()=>U.cancel()),R.onCancellationRequested(()=>U.cancel()),U.token}class g{get didTimeout(){return this.c==="timedout"}constructor(R){this.c="pending",this.d=new S.$Sc,this.promise=new Promise((U,x)=>{this.f=U,this.g=x}),R.isCancellationRequested?this.h():this.d.add(R.onCancellationRequested(()=>this.h()))}registerDisposable(R){this.c==="pending"?this.d.add(R):R.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(R))}reject(R){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(R))}}function w(K,R){const U=new g(R);return U.registerDisposable(K.onControlMessage(x=>{const z=JSON.parse(x.toString()),Y=L(z);Y?U.reject(Y):U.resolve(z)})),U.promise}function c(K,R,U,x,z,Y,N,B){const _=new g(B),ce=l.$Qd.create(!1);return K.info(`Creating a socket (${N})...`),f.mark(`code/willCreateSocket/${Y}`),R.connect(U,x,z,N).then(re=>{_.didTimeout?(f.mark(`code/didCreateSocketError/${Y}`),K.info(`Creating a socket (${N}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),re?.dispose()):(f.mark(`code/didCreateSocketOK/${Y}`),K.info(`Creating a socket (${N}) was successful after ${ce.elapsed()} ms.`),_.resolve(re))},re=>{f.mark(`code/didCreateSocketError/${Y}`),K.info(`Creating a socket (${N}) returned an error after ${ce.elapsed()} ms.`),K.error(re),_.reject(re)}),_.promise}function t(K,R){const U=new g(R);return K.then(x=>{U.didTimeout||U.resolve(x)},x=>{U.didTimeout||U.reject(x)}),U.promise}async function o(K,R,U,x){const z=te(K,R);K.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,u.$bl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,$(R),`renderer-${$(R)}-${K.reconnectionToken}`,x)}catch(re){throw K.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),K.logService.error(re),re}K.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let N,B;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Y,null),N=K.reconnectionProtocol,B=!1):(N=new k.$Sh({socket:Y}),B=!0),K.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const _=await t(K.signService.createNewMessage((0,p.$pg)()),x),ce={type:"auth",auth:K.connectionToken||"00000000000000000000",data:_.data};N.sendControl(A.$ie.fromString(JSON.stringify(ce)));try{const re=await w(N,h(x,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(K.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(K.signService.validate(_,re.signedData),x)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await t(K.signService.sign(re.data),x),ye={type:"connectionType",commit:K.commit,signedData:me,desiredConnectionType:R};return U&&(ye.args=U),K.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(A.$ie.fromString(JSON.stringify(ye))),{protocol:N,ownsProtocol:B}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(K.logService.error(`${z} the handshake timed out. Error:`),K.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${z} received error control message when negotiating connection. Error:`),K.logService.error(re)),B&&H(N),re}}async function r(K,R,U,x){const z=Date.now(),Y=te(K,R),{protocol:N,ownsProtocol:B}=await o(K,R,U,x),_=new g(x);return _.registerDisposable(N.onControlMessage(ce=>{const re=JSON.parse(ce.toString()),$e=L(re);$e?(K.logService.error(`${Y} received error control message when negotiating connection. Error:`),K.logService.error($e),B&&H(N),_.reject($e)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${he(z)}!`),_.resolve({protocol:N,firstMessage:re}))})),_.promise}async function i(K,R){const{protocol:U}=await r(K,1,void 0,R);return{protocol:U}}async function n(K,R,U){const{protocol:x,firstMessage:z}=await r(K,2,R,U),Y=z&&z.debugPort;return{protocol:x,debugPort:Y}}async function a(K,R,U){const x=Date.now(),z=te(K,3),{protocol:Y}=await o(K,3,R,U);return K.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Y}async function m(K,R,U){const{connectTo:x,connectionToken:z}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:x,connectionToken:z,reconnectionToken:R,reconnectionProtocol:U,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function O(K,R,U){return E(K,async x=>{const{protocol:z}=await i(x,s.CancellationToken.None);return new Z(K,R,U,x.reconnectionToken,z)})}e.$il=O;async function I(K,R){return E(K,async U=>{const{protocol:x,debugPort:z}=await n(U,R,s.CancellationToken.None);return new X(K,R,U.reconnectionToken,x,z)})}e.$jl=I;async function E(K,R){for(let x=1;;x++)try{const z=(0,p.$pg)(),Y=await m(K,z,null);return await R(Y)}catch(z){if(x<5)K.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(z);else throw K.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(z),ue.triggerPermanentFailure(0,0,v.$0k.isHandled(z)),z}}async function C(K,R,U){const x=await m(K,(0,p.$pg)(),null);return await a(x,{host:R,port:U},s.CancellationToken.None)}e.$kl=C;function j(K){return(0,P.$Sg)(R=>new Promise((U,x)=>{const z=setTimeout(U,K*1e3);R.onCancellationRequested(()=>{clearTimeout(z),U()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class F{constructor(R,U){this.reconnectionToken=R,this.millisSinceLastIncomingData=U,this.type=0}}e.$ll=F;class G{constructor(R,U,x,z){this.reconnectionToken=R,this.millisSinceLastIncomingData=U,this.durationSeconds=x,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$ml=G;class J{constructor(R,U,x){this.reconnectionToken=R,this.millisSinceLastIncomingData=U,this.attempt=x,this.type=2}}e.$nl=J;class le{constructor(R,U,x){this.reconnectionToken=R,this.millisSinceLastIncomingData=U,this.attempt=x,this.type=4}}e.$ol=le;class se{constructor(R,U,x,z){this.reconnectionToken=R,this.millisSinceLastIncomingData=U,this.attempt=x,this.handled=z,this.type=3}}e.$pl=se;class ue extends S.$Tc{static triggerPermanentFailure(R,U,x){this._permanentFailure=!0,this.f=R,this.g=U,this.h=x,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(R=>R.y())}static debugPauseSocketWriting(){this.j.forEach(R=>R.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(R,U,x,z,Y){super(),this.t=R,this.u=U,this.reconnectionToken=x,this.protocol=z,this.w=Y,this.m=this.B(new D.$Ud),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(z.onSocketClose(N=>{const B=q(this.t,this.reconnectionToken,!0);N?N.type===0?(this.u.logService.info(`${B} received socket close event (hadError: ${N.hadError}).`),N.error&&this.u.logService.error(N.error)):(this.u.logService.info(`${B} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this.u.logService.error(N.event)):this.u.logService.info(`${B} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(N=>{const B=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} received socket timeout event (unacknowledgedMsgCount: ${N.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${N.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${N.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,S.$Rc)(()=>{const N=ue.j.indexOf(this);N>=0&&ue.j.splice(N,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const R=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const z=x<U.length?U[x]:U[U.length-1];try{if(z>0){const N=j(z);this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,N)),this.u.logService.info(`${R} waiting for ${z} seconds before reconnecting...`);try{await N}catch{}}if(this.n){this.u.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${R} resolving connection...`);const Y=await m(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${R} connecting to ${Y.connectTo}...`),await this.G(Y,d(y)),this.u.logService.info(`${R} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(v.$0k.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,M.$4)(Y)){this.u.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof v.$0k){this.u.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,v.$0k.isHandled(Y));break}this.u.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(R,U,x){this.w?ue.triggerPermanentFailure(R,U,x):this.D(R,U,x)}D(R,U,x){this.m.fire(new se(this.reconnectionToken,R,U,x)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ql=ue;class Z extends ue{constructor(R,U,x,z,Y){super(1,R,z,Y,!0),this.client=this.B(new k.$Qh(Y,{remoteAuthority:U,clientId:x},R.ipcLogger))}async G(R,U){await i(R,U)}}e.$rl=Z;class X extends ue{constructor(R,U,x,z,Y){super(2,R,x,z,!1),this.H=U,this.debugPort=Y}async G(R,U){await n(R,this.H,U)}}e.$sl=X;function H(K){try{K.acceptDisconnect();const R=K.getSocket();K.dispose(),R.dispose()}catch(R){(0,M.$1)(R)}}function L(K){if(K&&K.type==="error"){const R=new Error(`Connection error: ${K.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function W(K,R){for(;K.length<R;)K+=" ";return K}function V(K,R){return`[remote-connection][${W($(K),13)}][${R.substr(0,5)}\u2026]`}function q(K,R,U){return`${V(K,R)}[${U?"reconnect":"initial"}]`}function te(K,R){return`${q(R,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(oe[242],ae([0,1,2,6]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=void 0,e.$el=(0,A.$5h)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,S){return this.a[D]??=[],this.a[D].push(S),(0,P.$Rc)(()=>{const f=this.a[D]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,S,f,l){const p=this.b(D);if(!p)throw new Error(`No socket factory found for ${D}`);return p.connect(D,S,f,l)}}e.$fl=s}),define(oe[243],ae([0,1,26,48,21,114]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=void 0;let D;async function S(u=!1){return(D===void 0||u)&&(D=f()),D}e.$U0b=S;async function f(){const u=l();if(u===void 0)return!1;if(u>=22e3){const y=k();if(y)return new Promise(b=>{A.execFile(y,["--status"],$=>b(!$))})}else{const y=v();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(u)return parseInt(u[3])}function p(u){const y=process.env.SystemRoot;if(y){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,b?"Sysnative":"System32",u)}}function k(){return p("wsl.exe")}function v(){return p("lxss\\LxssManager.dll")}}),define(oe[53],ae([0,1,17,14,2,183,52,6,5,44]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$gp=(0,S.$5h)("requestService");class p{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?c[t]="*****":c[t]=this.b[t];this.a=c}return this.a}}class k extends s.$Tc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,M.localize)(0,null),when:f.$Dj.isEqualTo((0,f.$Bj)(f.LogLevel.Trace)).serialize()})}async c(c,t,o){const r=`${c} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new p(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,A.$0)(i)),i}}}e.$hp=k;function v(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.$ip=v;function u(w){return w.res.statusCode===204}e.$jp=u;async function y(w){return u(w)?null:(await(0,P.$ue)(w.stream)).toString()}e.$kp=y;async function b(w){if(!v(w))throw new Error("Server returned "+w.res.statusCode);return y(w)}e.$lp=b;async function $(w){if(!v(w))throw new Error("Server returned "+w.res.statusCode);if(u(w))return null;const t=(await(0,P.$ue)(w.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$mp=$;function d(w){g(w)}e.$np=d;let h;function g(w){const c=l.$Gn.as(D.$Ln.Configuration),t=h;h={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[h],remove:t?[t]:[]})}g(1)}),define(oe[244],ae([0,1,17,23]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=void 0;class s{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,l,p=A.CancellationToken.None){switch(f){case"request":return this.a.request(l[0],p).then(async({res:k,stream:v})=>{const u=await(0,P.$ue)(v);return[{statusCode:k.statusCode,headers:k.headers},u]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$jr=s;class M{constructor(S){this.a=S}async request(S,f){const[l,p]=await this.a.call("request",[S],f);return{res:l,stream:(0,P.$we)(p)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$kr=M}),define(oe[245],ae([0,1,246,12]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(D,S,f={}){const l=(0,P.parse)(D),p=f.proxyUrl||s(l,S);if(!p)return null;const k=(0,P.parse)(p);if(!/^https?:$/.test(k.protocol||""))return null;const v={host:k.hostname||"",port:(k.port?+k.port:0)||(k.protocol==="https"?443:80),auth:k.auth,rejectUnauthorized:(0,A.$Nf)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((u,y)=>{Q(["http-proxy-agent"],u,y)})).HttpProxyAgent(p,v):new(await new Promise((u,y)=>{Q(["https-proxy-agent"],u,y)})).HttpsProxyAgent(p,v)}e.$lr=M}),define(oe[247],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=e.$c$b=e.$b$b=void 0,e.$b$b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$c$b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$d$b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[94],ae([0,1,48,9,184,23,51,14,4,32,109,64,8,140]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=void 0;let y;async function b(d,h,g,w){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.$5l)(w)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.$5l)(w)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=v.Promises.withAsyncBody(async(c,t)=>{const o=new M.$5d;let r=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,u.$6l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{c(await $(h,o.token))}catch(a){!(0,S.$4)(a)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$Pi)(a)))):c({})}finally{clearTimeout(n),o.dispose()}})),y)}e.$$l=b;async function $(d,h){const g=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",g);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",w);const c=(0,l.$pg)().replace(/-/g,"").substr(0,12),t=new RegExp(c+"({.*})"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const r=await(0,p.$Ul)(f.OS,o);return d.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new S.$5);const a=(0,A.$nc)(r);let m,O;const I="";/^pwsh(-preview)?$/.test(a)?(m=`& '${process.execPath}' ${I} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,O=["-Login","-Command"]):a==="nu"?(m=`^'${process.execPath}' ${I} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,O=["-i","-l","-c"]):a==="xonsh"?(m=`import os, json; print("${c}", json.dumps(dict(os.environ)), "${c}")`,O=["-i","-l","-c"]):(m=`'${process.execPath}' ${I} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"||a==="csh"?O=["-ic"]:O=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),m);const E=(0,P.spawn)(r,[...O,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(E.kill(),n(new S.$5))),E.on("error",T=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Pi)(T)),n(T)});const C=[];E.stdout.on("data",T=>C.push(T));const j=[];E.stderr.on("data",T=>j.push(T)),E.on("close",(T,F)=>{const G=Buffer.concat(C).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const J=Buffer.concat(j).toString("utf8");if(J.trim()&&d.trace("getUnixShellEnvironment#stderr",J),T||F)return n(new Error((0,s.localize)(2,null,T,F)));const le=t.exec(G),se=le?le[1]:"{}";try{const ue=JSON.parse(se);g?ue.ELECTRON_RUN_AS_NODE=g:delete ue.ELECTRON_RUN_AS_NODE,w?ue.ELECTRON_NO_ATTACH_CONSOLE=w:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){d.error("getUnixShellEnvironment#errorCaught",(0,D.$Pi)(ue)),n(ue)}})})}}),define(oe[248],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(P.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$96b=P}),define(oe[95],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=void 0,e.$gl="signService",e.$hl=(0,P.$5h)(e.$gl)}),define(oe[249],ae([0,1,248]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=void 0;class A extends P.$96b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>Q(["vsda"],M,D))}}e.$4$b=A}),define(oe[34],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0,e.$kO=(0,P.$5h)("stateReadService"),e.$lO=(0,P.$5h)("stateService")}),define(oe[122],ae([0,1,8,17,2,12,38,16,5]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oO=e.$nO=e.$mO=e.SaveStrategy=void 0;var l;(function(u){u[u.IMMEDIATE=0]="IMMEDIATE",u[u.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class p extends s.$Tc{constructor(y,b,$,d){super(),this.h=y,this.j=b,this.m=$,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new P.$3g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,b){const $=this.a[y];return(0,M.$Qf)($)?b:$}setItem(y,b){this.setItems([{key:y,data:b}])}setItems(y){let b=!1;for(const{key:$,data:d}of y)this.a[$]!==d&&((0,M.$Qf)(d)?(0,M.$Of)(this.a[$])||(this.a[$]=void 0,b=!0):(this.a[$]=d,b=!0));b&&this.s()}removeItem(y){(0,M.$Of)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,A.$ie.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(b){this.m.error(b)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$mO=p;let k=class extends s.$Tc{constructor(y,b,$,d){super(),this.a=this.B(new p(b.stateResource,y,$,d))}async init(){await this.a.init()}getItem(y,b){return this.a.getItem(y,b)}};e.$nO=k,e.$nO=k=Ee([ne(1,D.$_h),ne(2,f.$mj),ne(3,S.$pk)],k);class v extends k{setItem(y,b){this.a.setItem(y,b)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$oO=v}),define(oe[123],ae([0,1,4,36,32]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=void 0;function M(f){if(P.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,l,p,k,v,u,y,b,$){const d=Object.create(null);d["common.machineId"]=u,d["common.sqmId"]=y,d.sessionID=(0,s.$pg)()+Date.now(),d.commitHash=k,d.version=v,d["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,P.$h)(P.$u),d["common.nodePlatform"]=A.$dc,d["common.nodeArch"]=p,d["common.product"]=$||"desktop",b&&(d["common.msftInternal"]=b);let h=0;const g=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),P.$l&&(d["common.snap"]="true");const w=M(l);return w&&(d["common.platformDetail"]=w),d}e.$Ho=D;function S(f){const l=A.env.USERDNSDOMAIN;if(!l)return!1;const p=l.toLowerCase();return f.some(k=>p===k)}e.$Io=S}),define(oe[28],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=void 0,e.$tl=(0,P.$5h)("telemetryService"),e.$ul=(0,P.$5h)("customEndpointTelemetryService"),e.$vl="telemetry.currentSessionDate",e.$wl="telemetry.firstSessionDate",e.$xl="telemetry.lastSessionDate",e.$yl="telemetry.machineId",e.$zl="telemetry.sqmId",e.$Al="telemetry",e.$Bl="telemetry.telemetryLevel",e.$Cl="telemetry.enableCrashReporter",e.$Dl="telemetry.enableTelemetry";var A;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(oe[250],ae([0,1,26,8,42,13,9,4,7,88,21,108,91,16,27,28]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=void 0;const $=new Map;async function d(t,o){const r=`${t}::${o.join(":")}`,i=$.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,m=new Map,O=2e4;function I(C,j,T,F){const G=j.substring(C.length+1);return A.Promises.withAsyncBody(async J=>{let le;try{le=await p.Promises.readdir(j,{withFileTypes:!0})}catch{J();return}if(F.count>=O){F.count+=le.length,F.maxReached=!0,J();return}let se=le.length;if(se===0){J();return}let ue=le;F.count+le.length>O&&(F.maxReached=!0,se=O-F.count,ue=le.slice(0,se)),F.count+=le.length;for(const Z of ue)if(Z.isDirectory()){if(T.includes(Z.name)||await I(C,(0,D.$jc)(j,Z.name),T,F),--se===0){J();return}}else{const X=Z.name.lastIndexOf(".");if(X>=0){const H=Z.name.substring(X+1);H&&a.set(H,(a.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(G)!==!1&&H.filePattern.test(Z.name)&&m.set(H.tag,(m.get(H.tag)??0)+1);if(--se===0){J();return}}})}const E=A.Promises.withAsyncBody(async C=>{const j={count:0,maxReached:!1};await I(t,t,o,j);const T=await w(t);C({configFiles:h(m),fileTypes:h(a),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:T})});return $.set(r,E),E}e.$5r=d;function h(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function g(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/u.$Xk.GB).toFixed(2)}GB (${(P.freemem()/u.$Xk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$9m.value()*100)}%`},o=P.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$6r=g;async function w(t){try{const o=new Map,r=(0,D.$jc)(t,".vscode","launch.json"),i=await p.Promises.readFile(r),n=[],a=(0,s.$bn)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$kn)(a)==="object"&&a.configurations)for(const m of a.configurations){const O=m.type;O&&(o.has(O)?o.set(O,o.get(O)+1):o.set(O,1))}return h(o)}catch{return[]}}e.$7r=w;let c=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/u.$Xk.GB).toFixed(2)}GB (${(P.freemem()/u.$Xk.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$9m.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,k.$4r)(o.mainPID),this.k(o)]).then(async i=>{let[n,a]=i,m=this.m(o,n);return r.forEach(O=>{if((0,v.$Im)(O))m+=`
${O.errorMessage}`,a+=`
${O.errorMessage}`;else if(m+=`

Remote: ${O.hostName}`,O.processes&&(m+=`
${this.m(o,O.processes)}`),O.workspaceMetadata){a+=`
|  Remote: ${O.hostName}`;for(const I of Object.keys(O.workspaceMetadata)){const E=O.workspaceMetadata[I];let C=`${E.fileCount} files`;E.maxFilesReached&&(C=`more than ${C}`),a+=`|    Folder (${I}): ${C}`,a+=this.h(E)}}}),{processInfo:m,workspaceInfo:a}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:a,cpus:m}=g(),O={os:a,memory:i,cpus:m,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(O.load=`${P.loadavg().map(I=>Math.round(I)).join(", ")}`),S.$k&&(O.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(O)}async getDiagnostics(o,r){const i=[];return(0,k.$4r)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(a=>{if((0,v.$Im)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(o,a.processes)),a.workspaceMetadata)for(const m of Object.keys(a.workspaceMetadata)){const O=a.workspaceMetadata[m];let I=`${O.fileCount} files`;O.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${m}): ${I}`),i.push(this.h(O))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const a=(E,C)=>{const j=` ${E}(${C})`;n+j.length>60?(r.push(m),m="|                 ",n=m.length):n+=j.length,m+=j};let m="|      File types:";const O=10,I=o.fileTypes.length>O?O:o.fileTypes.length;for(let E=0;E<I;E++){const C=o.fileTypes[E];a(C.name,C.count)}if(r.push(m),o.configFiles.length>=0&&(m="|      Conf files:",n=0,o.configFiles.forEach(E=>{a(E.name,E.count)}),r.push(m)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const j=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;E+=j}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const m=f.URI.revive(a);if(m.scheme===M.Schemas.file){const O=m.fsPath;i.push(d(O,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,D.$nc)(O)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${O} (${I.toString()})`)}))}else r.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:m})=>i.set(a,m));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,a){const m=a===0;let O;m?O=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?O=r.get(n.pid):O=`${"  ".repeat(a)} ${n.name}`;const I=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/u.$Xk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${O}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,i,E,a+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=f.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const a=n.fsPath;try{(await d(a,["node_modules",".git"])).fileTypes.forEach(O=>r.add(O.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=f.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const a=await d(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),a.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),a.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$8r=c,e.$8r=c=Ee([ne(0,b.$tl),ne(1,y.$Ej)],c)}),define(oe[251],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=e.$g$b=void 0;class P{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:S,data:f}){return this.b.forEach(l=>l.log(S,f)),Promise.resolve(null)}}e.$g$b=P;class A{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$h$b=A}),define(oe[54],ae([0,1,35,12,3,18,59,123,28]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Jo=l;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ko=p,e.$Lo=new p;class k{async publicLog(n,a,m){}async publicLogError(n,a,m){}}e.$Mo=k,e.$No="telemetry",e.$Oo="extensionTelemetryLog",e.$Po={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(m,O)=>{const I=m?new Set([...m.affectedKeys,...O.affectedKeys]):O.affectedKeys;return{...O,affectedKeys:I}},1e3,!0)(m=>{m.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$Bi)(m.source),configurationKeys:Array.from(m.affectedKeys)})})}e.$Qo=v;function u(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Ro=u;function y(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$So=y;function b(i){const n=i.getValue(f.$Bl),a=i.getValue(f.$Cl);if(i.getValue(f.$Dl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$To=b;function $(i){const n={},a={},m={};g(i,m);for(let O in m){O=O.length>150?O.substr(O.length-149):O;const I=m[O];typeof I=="number"?a[O]=I:typeof I=="boolean"?a[O]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${O} has been trimmed to 8192, the original length is ${I.length}`),n[O]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[O]=I)}return{properties:n,measurements:a}}e.$Uo=$;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const n=(0,D.$al)(i);return d.has(n)?n:"other"}e.$Vo=h;function g(i,n,a=0,m){if(i)for(const O of Object.getOwnPropertyNames(i)){const I=i[O],E=m?m+O:O;Array.isArray(I)?n[E]=(0,P.$zn)(I):I instanceof Date?n[E]=I.toISOString():(0,A.$Jf)(I)?a<2?g(I,n,a+1,E+"."):n[E]=(0,P.$zn)(I):n[E]=I}}function w(i,n){const a=i.msftInternalDomains||[],m=n.getValue("telemetry.internalTesting");return(0,S.$Io)(a)||m}e.$Wo=w;function c(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Xo=c;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const m=[];for(const C of n)for(;;){const j=C.exec(i);if(!j)break;m.push([j.index,C.lastIndex])}const O=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(a="";;){const C=I.exec(i);if(!C)break;const j=m.some(([T,F])=>C.index<F&&T<I.lastIndex);!O.test(C[0])&&!j&&(a+=i.substring(E,C.index)+"<REDACTED: user-file-path>",E=I.lastIndex)}return E<i.length&&(a+=i.substr(E)),a}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function r(i,n){return(0,P.$wn)(i,a=>{if(a instanceof l||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let m=a.replaceAll("%20"," ");m=t(m,n);for(const O of n)m=m.replace(O,"");return m=o(m),m}})}e.$Yo=r}),define(oe[124],ae([0,1,25,118,121,4,7,14,36,54]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;function p(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$6e)(r.id,i.id)===0}e.$Zo=p;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,n,a)}static parse(i){const n=k.exec(i);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$1o=v;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=u.exec(r);return i&&i[1]?[$(i[1]),i[2]]:[$(r),void 0]}e.$2o=y;function b(r,i){return`${r}.${i}`}e.$3o=b;function $(r){return r.toLowerCase()}e.$4o=$;function d(r,i){return $(b(r??s.$gm,i))}e.$5o=d;function h(r,i){const n=[],a=m=>{for(const O of n)if(O.some(I=>p(i(I),i(m))))return O;return null};for(const m of r){const O=a(m);O?O.push(m):n.push([m])}return n}e.$6o=h;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$7o=g;function w(r){return{id:new l.$Jo(r.identifier.id),name:new l.$Jo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$8o=w,e.$9o=new s.$km("pprice.better-merge");function c(r,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const m=a.shift();if(m&&n.every(O=>!p(O.identifier,{id:m}))){const O=r.filter(I=>p(I.identifier,{id:m}));O.length===1&&(n.push(O[0]),a.push(...O[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$0o=c;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){i.debug("Error while getting the os-release file.",(0,S.$0)(m))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),a=(0,A.$to)(n?"alpine":M.$u,f.$ec);return i.debug("ComputeTargetPlatform:",a),a}e.$$o=o}),define(oe[252],ae([0,1,206,54]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function s(M,D,S,f,l,p,k){const v={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,A.$Ro)(D,S)&&(0,A.$To)(f)===3){const u=await(0,P.$zp)(S,l,p);v["X-Market-User-Id"]=u,v["VSCode-SessionId"]=k.machineId||u}return v}e.$Ap=s}),define(oe[253],ae([0,1,2,35,4,25,185,18,52,79,27,44,28,54]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,h,g){this.k=h,this.l=g,this.d={},this.i=new P.$Sc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,M.$Ne)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Ne)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(v.$Bl)||w.affectsConfiguration(v.$Dl)||w.affectsConfiguration(v.$Cl))&&this.m()}))}setExperimentProperty(d,h){this.d[d]=h}m(){let d=(0,u.$To)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const g=h.usage?3:h.error?2:0;d=Math.min(d,g)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,h,g){this.g<h||(g=(0,A.$xn)(g,this.d),g=(0,u.$Yo)(g,this.j),g=(0,A.$xn)(g,this.c),this.b.forEach(w=>w.log(d,g)))}publicLog(d,h){this.n(d,3,h)}publicLog2(d,h){this.publicLog(d,h)}publicLogError(d,h){this.h&&this.n(d,2,h)}publicLogError2(d,h){this.publicLogError(d,h)}};e.$or=y,e.$or=y=Ee([ne(1,S.$yi),ne(2,p.$Ej)],y);function b(){const $=(0,D.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$o?"":(0,D.localize)(3,null),g=(0,D.localize)(4,null),w=(0,D.localize)(5,null),c=(0,D.localize)(6,null),t=(0,D.localize)(7,null),o=`
|       | ${g} | ${w} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${$} ${d} ${h}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}k.$Gn.as(f.$Ln.Configuration).registerConfiguration({id:v.$Al,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[v.$Bl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$Gn.as(f.$Ln.Configuration).registerConfiguration({id:v.$Al,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[v.$Dl]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,D.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,D.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${v.$Bl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[254],ae([0,1,4,88,28]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=e.$I$b=void 0;async function M(S,f){let l=S.getItem(s.$yl);return(typeof l!="string"||P.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,A.$0m)(f.error.bind(f))),l}e.$I$b=M;async function D(S,f){let l=S.getItem(s.$zl);return typeof l!="string"&&(l=await(0,A.$$m)(f.error.bind(f))),l}e.$J$b=D}),define(oe[255],ae([0,1,28,254]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=e.$K$b=void 0;async function s(D,S){const f=await(0,A.$I$b)(D,S);return D.setItem(P.$yl,f),f}e.$K$b=s;async function M(D,S){const f=await(0,A.$J$b)(D,S);return D.setItem(P.$zl,f),f}e.$L$b=M}),define(oe[125],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(oe[256],ae([0,1,4,125]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach((k,v)=>{this.d(k,v);const u=k.map.entries();let y=u.next();for(;!y.done;){const b=y.value[1],$=y.value[0];let d=this.a.get($);if(d||(d=[],this.a.set($,d)),d.length>0&&d[0].type===A.EnvironmentVariableMutatorType.Replace){y=u.next();continue}const h={extensionIdentifier:v,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};h.scope||delete h.scope,d.unshift(h),y=u.next()}})}async applyToProcessEnvironment(p,k,v){let u;P.$i&&(u={},Object.keys(p).forEach(y=>u[y.toLowerCase()]=y));for(const[y,b]of this.getVariableMap(k)){const $=P.$i&&u[y.toLowerCase()]||y;for(const d of b){const h=v?await v(d.value):d.value;if(d.options?.applyAtProcessCreation??!0)switch(d.type){case A.EnvironmentVariableMutatorType.Append:p[$]=(p[$]||"")+h;break;case A.EnvironmentVariableMutatorType.Prepend:p[$]=h+(p[$]||"");break;case A.EnvironmentVariableMutatorType.Replace:p[$]=h;break}if(d.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${s.get(d.type)}`;p[g]=(p[g]?p[g]+":":"")+y+"="+this.c(h)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,k){const v=new Map,u=new Map,y=new Map;if(p.getVariableMap(k).forEach((b,$)=>{const d=this.getVariableMap(k).get($),h=S(b,d);h&&v.set($,h)}),this.getVariableMap(k).forEach((b,$)=>{const d=p.getVariableMap(k).get($),h=S(b,d);h&&y.set($,h)}),this.getVariableMap(k).forEach((b,$)=>{const d=p.getVariableMap(k).get($),h=f(b,d);h&&u.set($,h)}),!(v.size===0&&u.size===0&&y.size===0))return{added:v,changed:u,removed:y}}getVariableMap(p){const k=new Map;for(const v of this.a.values()){const u=v.filter(y=>D(y,p));u.length>0&&k.set(u[0].variable,u)}return k}getDescriptionMap(p){const k=new Map;for(const v of this.b.values()){const u=v.filter(y=>D(y,p,!0));for(const y of u)k.set(y.extensionIdentifier,y.description)}return k}d(p,k){if(!p.descriptionMap)return;const v=p.descriptionMap.entries();let u=v.next();for(;!u.done;){const y=u.value[1],b=u.value[0];let $=this.b.get(b);$||($=[],this.b.set(b,$));const d={extensionIdentifier:k,scope:y.scope,description:y.description};d.scope||delete d.scope,$.push(d),u=v.next()}}}e.$Rr=M;function D(l,p,k=!1){return l.scope?!!(l.scope.workspaceFolder&&p?.workspaceFolder&&l.scope.workspaceFolder.index===p.workspaceFolder.index):k?p===l.scope:!0}function S(l,p){if(!p)return l;const k=new Set;p.forEach(u=>k.add(u.extensionIdentifier));const v=[];return l.forEach(u=>{k.has(u.extensionIdentifier)||v.push(u)}),v.length===0?void 0:v}function f(l,p){if(!p)return;const k=new Map;p.forEach(u=>k.set(u.extensionIdentifier,u));const v=[];return l.forEach(u=>{const y=k.get(u.extensionIdentifier);y&&(u.type!==y.type||u.value!==y.value||u.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&v.push(y)}),v.length===0?void 0:v}}),define(oe[257],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0;function P(f){return[...f.entries()]}e.$Lr=P;function A(f){return f?[...f.entries()]:[]}e.$Mr=A;function s(f){return new Map(f)}e.$Nr=s;function M(f){return new Map(f??[])}e.$Or=M;function D(f){return Array.from(f.entries()).map(l=>[l[0],P(l[1].map),A(l[1].descriptionMap)])}e.$Pr=D;function S(f){return new Map(f.map(l=>[l[0],{map:s(l[1]),descriptionMap:M(l[2])}]))}e.$Qr=S}),define(oe[258],ae([0,1,8,23,3,2,5]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;let S=class extends M.$Tc{constructor(l,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Ud),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,M.$Rc)(()=>{for(const k of this.f.values())(0,M.$Oc)(k)}))}createRequest(l){return new Promise((p,k)=>{const v=++this.a;this.c.set(v,p),this.g.fire({requestId:v,...l});const u=new A.$5d;(0,P.$6g)(this.b,u.token).then(()=>k(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,M.$Rc)(()=>u.cancel())])})}acceptReply(l,p){const k=this.c.get(l);k?(this.c.delete(l),(0,M.$Oc)(this.f.get(l)||[]),this.f.delete(l),k(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Cr=S,e.$Cr=S=Ee([ne(1,D.$mj)],S)}),define(oe[126],ae([0,1,6,115,44]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$vr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ur=void 0,e.$ur=new A.$jj("terminalTabFocusMode",!1,!0);var M;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",c.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",c.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",c.MouseWheelZoom="terminal.integrated.mouseWheelZoom",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var l;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var p;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var k;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k||(e.ProcessPropertyType=k={})),e.$vr=(0,P.$5h)("ptyService");var v;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var u;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var y;(function(c){c.TerminalView="view",c.Editor="editor"})(y||(e.TerminalLocationString=y={}));var b;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var $;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var d;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var h;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var g;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.$wr={Backend:"workbench.contributions.terminal.processBackend"};class w{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Gn.add(e.$wr.Backend,new w),e.$xr=(0,P.$5h)("localPtyService"),e.$yr=(0,P.$5h)("terminalLogService")}),define(oe[259],ae([0,1,75,7,187,103]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=e.$Fr=e.$Er=e.$Dr=void 0;function D(v,u){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...v.map(b=>({name:b.profileName,description:S(b)}))),u&&y.push(...u.map(b=>({name:b.title,description:f(b)}))),{values:y.map(b=>b.name),markdownDescriptions:y.map(b=>b.description)}}e.$Dr=D;function S(v){let u=`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:P.$$j.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?u+=`
- args: "${v.args}"`:u+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(u+=`
- overrideName: ${v.overrideName}`),v.color&&(u+=`
- color: ${v.color}`),v.env&&(u+=`
- env: ${JSON.stringify(v.env)}`),u}function f(v){return`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:P.$$j.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function l(v,u){if(!v&&!u)return!0;if(typeof v=="string"&&typeof u=="string")return v===u;if(Array.isArray(v)&&Array.isArray(u)){if(v.length!==u.length)return!1;for(let y=0;y<v.length;y++)if(v[y]!==u[y])return!1;return!0}return!1}e.$Er=l;function p(v,u){if(!v&&!u)return!0;if(!v||!u)return!1;if(M.ThemeIcon.isThemeIcon(v)&&M.ThemeIcon.isThemeIcon(u))return v.id===u.id&&v.color===u.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof u=="object"&&"light"in u&&"dark"in u){const y=v,b=u;if((A.URI.isUri(y.light)||k(y.light))&&(A.URI.isUri(y.dark)||k(y.dark))&&(A.URI.isUri(b.light)||k(b.light))&&(A.URI.isUri(b.dark)||k(b.dark)))return y.light.path===b.light.path&&y.dark.path===b.dark.path}if(A.URI.isUri(v)&&A.URI.isUri(u)||k(v)||k(u)){const y=v,b=u;return y.path===b.path&&y.scheme===b.scheme}return!1}e.$Fr=p;function k(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$Gr=k}),define(oe[260],ae([0,1,75,4,186,52,44,259]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0,e.$Hr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Ir={type:"string",enum:Array.from((0,P.$0j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,P.$0j)(),$=>`$(${$.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$Ir},color:{description:(0,s.localize)(3,null),...e.$Hr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},p={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function k($){const d=$===2?"linux":$===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$h)($),'```json\n"terminal.integrated.profile.'+d+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:k(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:k(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:k(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.$Gn.as(M.$Ln.Configuration).registerConfiguration(v),b()}e.$Jr=u;let y;function b($,d){const h=D.$Gn.as(M.$Ln.Configuration);let g;$&&(g=(0,S.$Dr)($?.profiles,d));const w=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:$?.os===3?g?.values:void 0,markdownEnumDescriptions:$?.os===3?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:$?.os===2?g?.values:void 0,markdownEnumDescriptions:$?.os===2?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:$?.os===1?g?.values:void 0,markdownEnumDescriptions:$?.os===1?g?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:w?[w]:[]})}e.$Kr=b}),define(oe[261],ae([0,1,26,13,35,9,4,36,25,12,21,125,257,256]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$Sr=y;async function b(i,n,a,m=S.env,O=p.Promises.exists){if(M.$ic(i))return await O(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$mc(i)!=="."){const j=M.$jc(n,i);return await O(j)?j:void 0}const E=(0,s.$Bn)(m,"PATH");if(a===void 0&&(0,l.$Hf)(E)&&(a=E.split(M.$tc)),a===void 0||a.length===0){const j=M.$jc(n,i);return await O(j)?j:void 0}for(const j of a){let T;if(M.$ic(j)?T=M.$jc(j,i):T=M.$jc(n,j,i),await O(T))return T;if(D.$i){let F=T+".com";if(await O(F)||(F=T+".exe",await O(F)))return F}}const C=M.$jc(n,i);return await O(C)?C:void 0}e.$Tr=b;function $(i,n,a,m,O){const I=D.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const E=i.args,C=S.$dc==="win32"?M.$nc(i.executable).toLowerCase():M.$nc(i.executable),j=M.$mc(A.$ng.asFileUri("").fsPath);let T;const F={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(F.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!E||o(E)?T=g.get(h.WindowsPwsh):t(E)&&(T=g.get(h.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.$Je)(T[T.length-1],j,""),n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:F}):void 0;m.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!E||E.length===0?T=g.get(h.Bash):r(E)&&(F.VSCODE_SHELL_LOGIN="1",d(n,F),T=g.get(h.Bash)),T?(T=[...T],T[T.length-1]=(0,f.$Je)(T[T.length-1],j),{newArgs:T,envMixin:F}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${G}:${J}`,d(n,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!E||o(E)?T=g.get(h.Pwsh):t(E)&&(T=g.get(h.PwshLogin)),T?(n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,f.$Je)(T[T.length-1],j,""),{newArgs:T,envMixin:F}):void 0;case"zsh":{if(!E||E.length===0?T=g.get(h.Zsh):r(E)?(T=g.get(h.ZshLogin),d(n,F)):(E===g.get(h.Zsh)||E===g.get(h.ZshLogin))&&(T=E),!T)return;T=[...T],T[T.length-1]=(0,f.$Je)(T[T.length-1],j);let G;try{G=P.userInfo().username}catch{G="unknown"}const J=M.$jc(P.tmpdir(),`${G}-${O.applicationName}-zsh`);F.ZDOTDIR=J;const le=a?.ZDOTDIR??P.homedir()??"~";F.USER_ZDOTDIR=le;const se=[];return se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(J,".zshrc")}),se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(J,".zprofile")}),se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(J,".zshenv")}),se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(J,".zlogin")}),{newArgs:T,envMixin:F,filesToCopy:se}}}m.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$Ur=$;function d(i,n){if(D.$j&&i.environmentVariableCollections){const a=(0,v.$Qr)(i.environmentVariableCollections),O=new u.$Rr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(O)for(const E of O)E.type===k.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const g=new Map;g.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(h.Zsh,["-i"]),g.set(h.ZshLogin,["-il"]),g.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],c=["-nol","-nologo"];function t(i){return typeof i=="string"?w.includes(i.toLowerCase()):i.length===1&&w.includes(i[0].toLowerCase())||i.length===2&&(w.includes(i[0].toLowerCase())||w.includes(i[1].toLowerCase()))&&(c.includes(i[0].toLowerCase())||c.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?c.includes(i.toLowerCase()):i.length===0||i?.length===1&&c.includes(i[0].toLowerCase())}function r(i){return i==="string"&&w.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&w.includes(i[0].toLowerCase())}}),define(oe[262],ae([0,1,48,75,9,4,12,21,107,261,114]),function(Q,e,P,A,s,M,D,S,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=void 0;var k;(function(a){a.UnixShellsPath="/etc/shells"})(k||(k={}));let v,u=!0;function y(a,m,O,I,E=process.env,C,j,T,F){return C=C||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?b(O,C,E,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:I.getValue("terminal.integrated.profiles.windows"),typeof m=="string"?m:I.getValue("terminal.integrated.defaultProfile.windows"),F,T):r(C,j,O,a&&typeof a=="object"?{...a}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof m=="string"?m:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,T,E)}e.$Vr=y;async function b(a,m,O,I,E,C,j,T,F){const G=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=`${process.env.windir}\\${G?"Sysnative":"System32"}`;let le=!1;(0,l.$Sr)()>=16299&&(le=!0),await g(T);const se=new Map;if(a){se.set("PowerShell",{source:"PowerShell",icon:A.$$j.terminalPowershell,isAutoDetected:!0}),se.set("Windows PowerShell",{path:`${J}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$$j.terminalPowershell,isAutoDetected:!0}),se.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),se.set("Command Prompt",{path:`${J}\\cmd.exe`,icon:A.$$j.terminalCmd,isAutoDetected:!0}),se.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),se.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$$j.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;se.set("Cmder",{path:`${J}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}i(C,se);const ue=await $(se.entries(),j,m,O,I,F);if(a&&E)try{const Z=await t(`${J}\\${le?"wsl":"bash"}.exe`,j);for(const X of Z)(!C||!(X.profileName in C))&&ue.push(X)}catch{u&&(I?.info("WSL is not installed, so could not detect WSL profiles"),u=!1)}return ue}async function $(a,m,O,I=process.env,E,C){const j=[];for(const[T,F]of a)j.push(d(T,F,m,O,I,E,C));return(await Promise.all(j)).filter(T=>!!T)}async function d(a,m,O,I,E=process.env,C,j){if(m===null)return;let T,F,G;if("source"in m&&!("path"in m)){const ue=v?.get(m.source);if(!ue)return;T=ue.paths,F=m.args||ue.args,m.icon?G=h(m.icon):ue.icon&&(G=ue.icon)}else T=Array.isArray(m.path)?m.path:[m.path],F=M.$i||Array.isArray(m.args)?m.args:void 0,G=h(m.icon);let J;if(j){const ue=T.map(X=>typeof X=="string"?X:X.path),Z=await j(ue);J=new Array(T.length);for(let X=0;X<T.length;X++)typeof T[X]=="string"?J[X]=Z[X]:J[X]={path:Z[X],isUnsafe:!0}}else J=T.slice();let le;if(m.requiresPath){let ue;if((0,D.$Hf)(m.requiresPath)?ue=m.requiresPath:(ue=m.requiresPath.path,m.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const se=await n(a,O,J,I,E,F,m.env,m.overrideName,m.isAutoDetected,le);if(!se){C?.debug("Terminal profile not validated",a,T);return}return se.isAutoDetected=m.isAutoDetected,se.icon=G,se.color=m.color,se}function h(a){return typeof a=="string"?{id:a}:a}async function g(a){if(v&&!a)return;const[m,O]=await Promise.all([w(),a||c()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:m,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:O,icon:A.$$j.terminalPowershell})}async function w(){const a=new Set,m=await(0,l.$Tr)("git.exe");if(m){const E=(0,p.dirname)(m);a.add((0,p.resolve)(E,"../.."))}function O(E,C){C&&E.add(C)}O(a,process.env.ProgramW6432),O(a,process.env.ProgramFiles),O(a,process.env["ProgramFiles(X86)"]),O(a,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of a)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function c(){const a=[];for await(const m of(0,f.$Ol)())a.push(m.exePath);return a}async function t(a,m){const O=[],I=await new Promise((j,T)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,G)=>{if(F)return T("Problem occurred when getting wsl distros");j(G)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),C=I.split(E).filter(j=>j.trim().length>0&&j!=="");for(const j of C){if(j===""||j.startsWith("docker-desktop"))continue;const T=`${j} (WSL)`,F={profileName:T,path:a,args:["-d",`${j}`],isDefault:T===m,icon:o(j),isAutoDetected:!1};O.push(F)}return O}function o(a){return a.includes("Ubuntu")?A.$$j.terminalUbuntu:a.includes("Debian")?A.$$j.terminalDebian:A.$$j.terminalLinux}async function r(a,m,O,I,E,C,j,T){const F=new Map;if(O&&await a.existsFile("/etc/shells")){const G=(await a.readFile("/etc/shells")).toString(),J=(C||G.split(`
`)).map(se=>{const ue=se.indexOf("#");return ue===-1?se:se.substring(0,ue)}).filter(se=>se.trim().length>0),le=new Map;for(const se of J){let ue=(0,s.$nc)(se),Z=le.get(ue)||0;Z++,Z>1&&(ue=`${ue} (${Z})`),le.set(ue,Z),F.set(ue,{path:se,isAutoDetected:!0})}}return i(I,F),await $(F.entries(),E,a,T,m,j)}function i(a,m){if(a)for(const[O,I]of Object.entries(a))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?m.delete(O):(I.icon=I.icon||m.get(O)?.icon,m.set(O,I))}async function n(a,m,O,I,E,C,j,T,F,G){if(O.length===0)return Promise.resolve(void 0);const J=O.shift();if(J==="")return n(a,m,O,I,E,C,j,T,F);const le=typeof J!="string"&&J.isUnsafe,se=typeof J=="string"?J:J.path,ue={profileName:a,path:se,args:C,env:j,overrideName:T,isAutoDetected:F,isDefault:a===m,isUnsafePath:le,requiresUnsafePath:G};if((0,s.$nc)(se)===se){const X=E.PATH?E.PATH.split(s.$tc):void 0,H=await(0,l.$Tr)(se,void 0,X,void 0,I.existsFile);return H?(ue.path=H,ue.isFromPath=!0,ue):n(a,m,O,I,E,C)}return await I.existsFile((0,s.$hc)(se))?ue:n(a,m,O,I,E,C,j,T,F)}}),define(oe[263],ae([0,1,3,2,4,43,18,5,226,94,258,126,260,262,109,73]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0;var $;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})($||($={}));let d=class extends A.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(g,w,c,t){super(),this.M=g,this.N=w,this.O=c,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Ud),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Ud),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Ud),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Ud),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Ud),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Ud),this.onProcessData=this.D.event,this.F=this.B(new P.$Ud),this.onProcessReady=this.F.event,this.G=this.B(new P.$Ud),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Ud),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Ud),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Ud),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Ud),this.onProcessExit=this.L.event,(0,v.$Jr)(),this.B(this.M),this.B((0,A.$Rc)(()=>this.W())),this.j=this.B(new p.$Cr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$$l)(this.N,this.O,{_:[]},process.env)}catch(g){return this.O.error("ptyHost was unable to resolve shell environment",g),{}}}U(){const g=this.M.start(),w=g.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(w.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(g.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=$.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService(w.getChannel(k.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new f.$Br(this.P,w.getChannel(k.TerminalIpcChannels.Logger))),this.a=g,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[g,t]}async createProcess(g,w,c,t,o,r,i,n,a,m,O){const I=setTimeout(()=>this.$(),k.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(g,w,c,t,o,r,i,n,a,m,O);return clearTimeout(I),E}updateTitle(g,w,c){return this.f.updateTitle(g,w,c)}updateIcon(g,w,c,t){return this.f.updateIcon(g,w,c,t)}attachToProcess(g){return this.f.attachToProcess(g)}detachFromProcess(g,w){return this.f.detachFromProcess(g,w)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(g){return this.f.start(g)}shutdown(g,w){return this.f.shutdown(g,w)}input(g,w){return this.f.input(g,w)}processBinary(g,w){return this.f.processBinary(g,w)}resize(g,w,c){return this.f.resize(g,w,c)}clearBuffer(g){return this.f.clearBuffer(g)}acknowledgeDataEvent(g,w){return this.f.acknowledgeDataEvent(g,w)}setUnicodeVersion(g,w){return this.f.setUnicodeVersion(g,w)}getInitialCwd(g){return this.f.getInitialCwd(g)}getCwd(g){return this.f.getCwd(g)}async getLatency(){const g=new b.$Qd,w=await this.f.getLatency();return g.stop(),[{label:"ptyhostservice<->ptyhost",latency:g.elapsed()},...w]}orphanQuestionReply(g){return this.f.orphanQuestionReply(g)}installAutoReply(g,w){return this.f.installAutoReply(g,w)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(g){return this.f.uninstallAutoReply(g)}getDefaultSystemShell(g){return this.g?.getDefaultSystemShell(g)??(0,y.$Ul)(g??s.OS,process.env)}async getProfiles(g,w,c,t=!1){const o=await this.S();return(0,u.$Vr)(w,c,t,this.N,o,void 0,this.O,this.bb.bind(this,g))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(g,w){return this.f.getWslPath(g,w)}getRevivedPtyNewId(g,w){return this.f.getRevivedPtyNewId(g,w)}setTerminalLayoutInfo(g){return this.f.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return this.g?.getTerminalLayoutInfo(g)}async requestDetachInstance(g,w){return this.f.requestDetachInstance(g,w)}async acceptDetachInstanceReply(g,w){return this.f.acceptDetachInstanceReply(g,w)}async freePortKillProcess(g){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(g)}async serializeTerminalState(g){return this.f.serializeTerminalState(g)}async reviveTerminalProcesses(g,w,c){return this.f.reviveTerminalProcesses(g,w,c)}async refreshProperty(g,w){return this.f.refreshProperty(g,w)}async updateProperty(g,w,c){return this.f.updateProperty(g,w,c)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(g){this.ab(),this.s=setTimeout(()=>this.Y(),g?k.HeartbeatConstants.ConnectingBeatInterval:k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(g,w){return this.j.createRequest({workspaceId:g,originalText:w})}async acceptPtyHostResolvedVariables(g,w){this.j.acceptReply(g,w)}};e.$Wr=d,e.$Wr=d=Ee([ne(1,D.$yi),ne(2,S.$mj),ne(3,S.$nj)],d)}),define(oe[70],ae([0,1,15,3,2,4,18,6,34]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=e.$79b=void 0;const l="#FFFFFF",p="#1E1E1E",k="#000000",v="#FFFFFF",u="theme",y="themeBackground",b="windowSplash";e.$79b=(0,S.$5h)("themeMainService");let $=class extends s.$Tc{constructor(h,g){super(),this.b=h,this.c=g,this.a=this.B(new A.$Ud),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(w=>{w.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(A.Event.fromNodeEventEmitter(P.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":P.nativeTheme.themeSource="dark";break;case"light":P.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":P.nativeTheme.themeSource="light";break;case"vs-dark":P.nativeTheme.themeSource="dark";break;default:P.nativeTheme.themeSource="system"}break;default:P.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?k:v;let g=this.b.getItem(y,null);if(!g)switch(this.g()){case"vs":g=l;break;case"hc-black":g=k;break;case"hc-light":g=v;break;default:g=p}return M.$j&&g.toUpperCase()===p&&(g="#171717"),g}g(){switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(h,g){this.b.setItems([{key:u,data:g.baseTheme},{key:y,data:g.colorInfo.background},{key:b,data:g}]),typeof h=="number"&&this.h(h,g),this.f()}h(h,g){for(const w of P.BrowserWindow.getAllWindows())if(w.id===h){w.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$89b=$,e.$89b=$=Ee([ne(0,f.$lO),ne(1,D.$yi)],$)}),define(oe[127],ae([0,1,3,18,6,5]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.ProvidedOnAutoForward=e.$Bv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Av=e.$zv=void 0,e.$zv=(0,s.$5h)("tunnelService"),e.$Av=(0,s.$5h)("sharedTunnelsService");var D;(function($){$.Http="http",$.Https="https"})(D||(e.TunnelProtocol=D={}));var S;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f($){return!!$.forwardPort}e.$Bv=f;var l;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function p($){if($.scheme!=="http"&&$.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(d)return{address:d[1],port:+d[2]}}e.$Cv=p,e.$Dv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k($){return e.$Dv.indexOf($)>=0}e.$Ev=k,e.$Fv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v($){return e.$Fv.indexOf($)>=0}e.$Gv=v;function u($,d,h,g){if(h===1)return!1;if(h===2&&v(d)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(w?.length===4&&parseInt(w[1])>=18)return!1}return $<1024}e.$Hv=u;class y{constructor(d,h,g){this.remoteAddress=d,this.localAddress=h,this.b=g,this.a=new P.$Ud,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Iv=y;let b=class{constructor(d,h){this.k=d,this.l=h,this.a=new P.$Ud,this.onTunnelOpened=this.a.event,this.b=new P.$Ud,this.onTunnelClosed=this.b.event,this.c=new P.$Ud,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const d=this.l.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.f=d,d?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.g=d.elevation,this.i=d.privacyOptions,this.h=d.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const d=[],h=Array.from(this.e.values());for(const g of h){const w=Array.from(g.values());for(const c of w){const t=await c.value;t&&typeof t!="string"&&d.push(t)}}return d}async dispose(){for(const d of this.e.values()){for(const{value:h}of d.values())await h.then(g=>typeof g!="string"?g?.dispose():void 0);d.clear()}this.e.clear()}setEnvironmentTunnel(d,h,g,w,c){this.q(d,h,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:h,localAddress:g,privacy:w,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,h){(v(d)||k(d))&&(d=e.$Dv[0]);const g=this.s(d,h);if(g)return++g.refcount,g.value}openTunnel(d,h,g,w,c,t=!1,o,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${g} on local port ${c}.`);const i=this.f??d;if(!i)return;if(h||(h="localhost"),w||(w=this.m),this.f&&this.j.has(g)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.t(i,h,g,w,c,t,o,r);return n?n.then(a=>{if(a){if(typeof a=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(h,g),a}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(h,g);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(a);return(a.tunnelRemoteHost!==h||a.tunnelRemotePort!==g)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&a.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}o(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this.e.get(d.tunnelRemoteHost);if(h){const g=h.get(d.tunnelRemotePort);g&&(g.refcount--,await this.p(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async p(d,h,g){if(g.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const w=g.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(d)&&this.e.get(d).delete(h),w}}async closeTunnel(d,h){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const g=this.e.get(d);if(g&&g.has(h)){const w=g.get(h);w.refcount=0,await this.p(d,h,w)}}q(d,h,g){this.e.has(d)||this.e.set(d,new Map),this.e.get(d).set(h,{refcount:1,value:g})}async r(d,h){const g=this.e.get(d);if(g){const w=g.get(h),c=w?await w.value:void 0;(!c||typeof c=="string")&&g.delete(h),g.size===0&&this.e.delete(d)}}s(d,h){const g=[d];k(d)?(g.push(...e.$Dv),g.push(...e.$Fv)):v(d)&&g.push(...e.$Fv);const w=g.map(c=>this.e.get(c));for(const c of w){const t=c?.get(h);if(t)return t}}canTunnel(d){return!!p(d)}u(d,h,g,w,c,t,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${g} on local port ${w}.`);const r=g;this.j.add(r);const i=w===void 0?g:w,n={elevationRequired:c?this.isPortPrivileged(i):!1},a={remoteAddress:{host:h,port:g},localAddressPort:w,privacy:t,public:t?t!==S.Private:void 0,protocol:o},m=d.forwardPort(a,n);return m?(this.q(h,g,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),m}};e.$Jv=b,e.$Jv=b=Ee([ne(0,M.$mj),ne(1,A.$yi)],b)}),define(oe[49],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pV=e.$oV=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(A||(e.StateType=A={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$oV={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,S)=>({type:"idle",updateType:D,error:S}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$pV=(0,P.$5h)("updateService")}),define(oe[264],ae([0,1,4,188,52,44]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$Gn.as(s.$Ln.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[265],ae([0,1,3,49]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=e.$i$b=void 0;class s{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,l){switch(f){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${f}`)}}e.$i$b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Ud,this.onStateChange=this.a.event,this.b=A.$oV.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$j$b=M}),define(oe[40],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=void 0,e.$Zk=(0,P.$5h)("IUriIdentityService")}),define(oe[266],ae([0,1,40,207,16,19,141,3,2]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0;class l{static{this._clock=0}constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let p=class{constructor(v){this.g=v,this.c=new f.$Sc,this.f=2**16;const u=new Map,y=b=>{let $=u.get(b.scheme);return $===void 0&&($=v.hasProvider(b)&&!this.g.hasCapability(b,1024),u.set(b.scheme,$)),$};this.c.add(S.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(b=>{u.delete(b.scheme)})),this.extUri=new M.$vg(y),this.d=new D.$Zr((b,$)=>this.extUri.compare(b,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,M.$Hg)(v));const u=this.d.get(v);return u?u.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new l(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((y,b)=>y[1].time<b[1].time?1:y[1].time>b[1].time?-1:0);l._clock=0,this.d.clear();const u=this.f*.5;for(let y=0;y<u;y++)this.d.set(v[y][0],v[y][1].touch())}};e.$1r=p,e.$1r=p=Ee([ne(0,s.$pk)],p),(0,A.$Xr)(P.$Zk,p,1)}),define(oe[128],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fV=void 0,e.$fV=(0,P.$5h)("urlService")}),define(oe[267],ae([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=e.$r$b=e.$q$b=void 0;class A{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,l){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${f}`)}}e.$q$b=A;class s{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$r$b=s;class M{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,l,p){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(l)&&l.length>0){const k=P.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",k.toString(!0)),k.query){const v=/\bwindowId=(\d+)/.exec(k.query);if(v){const u=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,k.toString(!0));const y=new RegExp(`window:${u}`),b=S.connections.find($=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",$.ctx),y.test($.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",k.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",k.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",k.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,l,p)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$s$b=M}),define(oe[268],ae([0,1,8,2,7,27]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hV=e.$gV=void 0;class D extends A.$Tc{constructor(){super(...arguments),this.a=new Set}open(l,p){const k=[...this.a.values()];return(0,P.$9g)(k.map(v=>()=>v.handleURL(l,p)),void 0,!1).then(v=>v||!1)}registerHandler(l){return this.a.add(l),(0,A.$Rc)(()=>this.a.delete(l))}}e.$gV=D;let S=class extends D{constructor(l){super(),this.b=l}create(l){let{authority:p,path:k,query:v,fragment:u}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&k&&k.indexOf("/")!==0&&(k=`/${k}`),s.URI.from({scheme:this.b.urlProtocol,authority:p,path:k,query:v,fragment:u})}};e.$hV=S,e.$hV=S=Ee([ne(0,M.$Ej)],S)}),define(oe[269],ae([0,1,15,8,3,2,4,7]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$b=void 0;class f extends M.$Tc{constructor(p,k,v,u,y,b){if(super(),this.c=k,this.f=b,this.a=[],this.b=0,p&&(b.trace("ElectronURLListener initialUrisToHandle:",p.map(h=>h.originalUrl)),this.a=p),D.$i){const h=u.isBuilt?[]:[`"${u.appRoot}"`];h.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const $=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(h,g)=>({event:h,url:g})),({event:h,url:g})=>(h.preventDefault(),g));this.B($(h=>{const g=this.g(h);g&&this.c.open(g,{originalUrl:h})})),v.getWindows().filter(h=>h.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g(p){try{return S.URI.parse(p)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const k of this.a)await this.c.open(k.uri,{originalUrl:k.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",k.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",k.originalUrl),p.push(k));p.length!==0&&(this.a=p,(0,A.$7g)(()=>this.h(),500,this.q))}}e.$t$b=f}),define(oe[270],ae([0,1,3,2,16,58,31]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=void 0;class S extends A.$Tc{constructor(l,p,k,v,u,y){super(),this.f=l,this.g=p,this.h=k,this.j=v,this.m=u,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Ud),this.onDidChangeFile=this.a.event,this.b=M.$$h.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,p){return this.g.open(this.t(l),p)}close(l){return this.g.close(l)}read(l,p,k,v,u){return this.g.read(l,p,k,v,u)}write(l,p,k,v,u){return this.g.write(l,p,k,v,u)}watch(l,p){this.b.set(l,l);const k=this.g.watch(this.t(l),p);return(0,A.$Rc)(()=>{this.b.delete(l),k.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,p,k){return this.g.rename(this.t(l),this.t(p),k)}readFile(l,p){return this.g.readFile(this.t(l),p)}readFileStream(l,p,k){return this.g.readFileStream(this.t(l),p,k)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,p,k){return this.g.writeFile(this.t(l),p,k)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,p){return this.g.delete(this.t(l),p)}copy(l,p,k){if((0,s.$tk)(this.g))return this.g.copy(this.t(l),this.t(p),k);throw new Error("copy not supported")}cloneFile(l,p){if((0,s.$uk)(this.g))return this.g.cloneFile(this.t(l),this.t(p));throw new Error("clone not supported")}s(l){const p=[];for(const k of l){if(k.resource.scheme!==this.f)continue;const v=this.u(k.resource);this.b.findSubstr(v)&&p.push({resource:v,type:k.type,cId:k.cId})}p.length&&(this.n.debug("User data changed"),this.a.fire(p))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$7$b=S}),define(oe[271],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0,e.$N$b="utilityProcessWorker"}),define(oe[272],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=void 0,e.$u$b=(0,P.$5h)("webviewManagerService")}),define(oe[273],ae([0,1,15,2,13,7]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$b=void 0;class D extends A.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,l){try{const p=M.URI.parse(f.url),k=D.a.get(p.path);if(typeof k=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${k}`,u=s.$ng.asFileUri(v);return l({path:u.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$v$b=D}),define(oe[60],ae([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=e.$OC=e.$NC=e.$MC=void 0,e.$MC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(v){return typeof v.parentId=="number"}e.$NC=A;function s(v){return!!v.workspaceUri}e.$OC=s;function M(v){return!!v.folderUri}e.$PC=M;function D(v){return!!v.fileUri}e.$QC=D;function S(v){const u=f(v),y=v.getValue("window.menuBarVisibility");return y==="default"||u==="native"&&y==="compact"||P.$j&&P.$m?"classic":y}e.$RC=S;function f(v){if(P.$o)return"custom";const u=v.getValue("window");if(u){if(P.$j&&u.nativeTabs===!0||P.$j&&u.nativeFullScreen===!1)return"native";const $=u.titleBarStyle;if($==="native"||$==="custom")return $}return P.$k?"native":"custom"}e.$SC=f;function l(v){return!(!P.$i||P.$o||f(v)==="native")}e.$TC=l;function p(v){const u=v.getValue("window");return!u||typeof u.nativeFullScreen!="boolean"||u.nativeTabs?!0:u.nativeFullScreen!==!1}e.$UC=p;function k(v=0){return Math.pow(1.2,v)}e.$VC=k}),define(oe[129],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$W9b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var A;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$W9b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(oe[274],ae([0,1,8,3,2]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=void 0;class M extends s.$Tc{constructor({onDidOpenMainWindow:S,onDidFocusMainWindow:f,getActiveWindowId:l}){super(),this.a=this.B(new s.$Sc),A.Event.latch(A.Event.any(S,f))(this.f,this,this.a),this.b=(0,P.$Sg)(()=>l()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$B$b=M}),define(oe[30],ae([0,1,192,9,58,19,7,6,13]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.WorkbenchState=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0,e.$bi=(0,S.$5h)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$ci=l;function p(i){return typeof i?.id=="string"&&!l(i)&&!v(i)}e.$di=p,e.$ei={id:"ext-dev"},e.$fi={id:"empty-window"};function k(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.$nc)(i)}:n?e.$ei:e.$fi;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$gi=k;function v(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$hi=v;function u(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$ii=u;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ji=b;function $(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ki=$;class d{constructor(n,a,m,O,I){this.h=n,this.j=m,this.k=O,this.l=I,this.c=s.$$h.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$$h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$li=d;class h{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$Gg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$mi=h;function g(i){return new h({uri:i,index:0,name:(0,M.$Cg)(i)},{uri:i.toString()})}e.$ni=g,e.$oi="code-workspace",e.$pi=`.${e.$oi}`,e.$qi=[{name:(0,P.localize)(0,null),extensions:[e.$oi]}],e.$ri="workspace.json";function w(i,n){return M.$xg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$si=w;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$ti=c,e.$ui="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$ui}e.$vi=t;function o(i,n){return!w(i,n)&&!c(i)}e.$wi=o;function r(i){return(typeof i=="string"?(0,A.$oc)(i):(0,M.$Eg)(i))===e.$pi}e.$xi=r}),define(oe[55],ae([0,1,15,8,45,47,2,85,4,21,167,116,6,5,27,30]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=e.$49b=void 0,e.$49b=(0,v.$5h)("dialogMainService");let $=class{constructor(h,g){this.d=h,this.e=g,this.a=new Map,this.b=new Map,this.c=new A.$_g}pickFileFolder(h,g){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},g)}pickFolder(h,g){return this.f({...h,pickFolders:!0,title:(0,p.localize)(1,null)},g)}pickFile(h,g){return this.f({...h,pickFiles:!0,title:(0,p.localize)(2,null)},g)}pickWorkspace(h,g){const w=(0,p.localize)(3,null),c=(0,M.$2v)((0,p.localize)(4,null)),t=b.$qi;return this.f({...h,pickFiles:!0,title:w,filters:t,buttonLabel:c},g)}async f(h,g){const w={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(w.properties=void 0,h.pickFiles&&h.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&w.properties.push("treatPackageAsDirectory");const c=await this.showOpenDialog(w,(g||P.BrowserWindow.getFocusedWindow())??void 0);if(c&&c.filePaths&&c.filePaths.length>0)return c.filePaths}g(h){if(h){let g=this.b.get(h.id);return g||(g=new A.$_g,this.b.set(h.id,g)),g}else return this.c}showMessageBox(h,g){return this.g(g).queue(async()=>{const{options:w,buttonIndeces:c}=(0,k.$9v)(h,this.e);let t;return g?t=await P.dialog.showMessageBox(g,w):t=await P.dialog.showMessageBox(w),{response:c[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(h,g){const w=this.j(h,g);if(!w)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(g).queue(async()=>{let c;return g?c=await P.dialog.showSaveDialog(g,h):c=await P.dialog.showSaveDialog(h),c.filePath=this.h(c.filePath),c})}finally{(0,D.$Oc)(w)}}h(h){return h&&f.$j&&(h=(0,S.$Fl)(h)),h}i(h){return h.map(g=>this.h(g))}async showOpenDialog(h,g){h.defaultPath&&(await l.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const w=this.j(h,g);if(!w)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(g).queue(async()=>{let c;return g?c=await P.dialog.showOpenDialog(g,h):c=await P.dialog.showOpenDialog(h),c.filePaths=this.i(c.filePaths),c})}finally{(0,D.$Oc)(w)}}j(h,g){if(!g)return D.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let w=this.a.get(g.id);w||(w=new Set,this.a.set(g.id,w));const c=(0,s.$Si)(h);if(!w.has(c))return this.d.trace("[DialogMainService]: new file dialog lock created",h),w.add(c),(0,D.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),w?.delete(c),w?.size===0&&this.a.delete(g.id)})}};e.$59b=$,e.$59b=$=Ee([ne(0,u.$mj),ne(1,y.$Ej)],$)}),define(oe[275],ae([0,1,3,2,77,30]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=void 0;class D extends A.$Tc{static{this.a=100}constructor(f,l){super(),this.f=f,this.g=l,this.b=this.B(new P.$Ud),this.c=new Map,this.h(l.applicationStorage,this.b)}h(f,l){this.B(P.Event.debounce(f.onDidChangeStorage,(p,k)=>(p?p.push(k):p=[k],p),D.a)(p=>{p.length&&l.fire(this.j(p,f))}))}j(f,l){const p=new Map,k=new Set;return f.forEach(v=>{const u=l.get(v.key);typeof u=="string"?p.set(v.key,u):k.add(v.key)}),{changed:Array.from(p.entries()),deleted:Array.from(k.values())}}listen(f,l,p){switch(l){case"onDidChangeStorage":{const k=p.profile?(0,s.$Bh)(p.profile):void 0;if(!k)return this.b.event;let v=this.c.get(k.id);return v||(v=this.B(new P.$Ud),this.h(this.g.profileStorage(k),v),this.c.set(k.id,v)),v.event}}throw new Error(`Event not found: ${l}`)}async call(f,l,p){const k=p.profile?(0,s.$Bh)(p.profile):void 0,v=(0,M.$ii)(p.workspace),u=await this.m(k,v);switch(l){case"getItems":return Array.from(u.items.entries());case"updateItems":{const y=p;if(y.insert)for(const[b,$]of y.insert)u.set(b,$);y.delete?.forEach(b=>u.delete(b));break}case"optimize":return u.optimize();case"isUsed":{const y=p.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async m(f,l){let p;l?p=this.g.workspaceStorage(l):f?p=this.g.profileStorage(f):p=this.g.applicationStorage;try{await p.init()}catch(k){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":f?"profile":"application"} storage due to ${k}`)}return p}}e.$f$b=D}),define(oe[41],ae([0,1,45,3,2,19,7,189,38,16,6,5,30,31,40,8,32,25,12]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.ProfileResourceType=void 0;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(g||(e.ProfileResourceType=g={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$1k=w,e.$2k=(0,p.$5h)("IUserDataProfilesService");function c(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$3k=c;function t(i,n,a,m,O,I){return{id:i,name:n,location:a,isDefault:!1,shortName:O?.shortName,icon:O?.icon,globalStorageHome:I&&O?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Gg)(a,"globalStorage"),settingsResource:I&&O?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Gg)(a,"settings.json"),keybindingsResource:I&&O?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Gg)(a,"keybindings.json"),tasksResource:I&&O?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Gg)(a,"tasks.json"),snippetsHome:I&&O?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Gg)(a,"snippets"),extensionsResource:I&&O?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Gg)(a,"extensions.json"),cacheHome:(0,M.$Gg)(m,i),useDefaultFlags:O?.useDefaultFlags,isTransient:O?.transient}}e.$4k=t;let o=class extends s.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,m,O){super(),this.t=n,this.u=a,this.w=m,this.y=O,this.f=!0,this.h=this.B(new A.$Ud),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Ud),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Ud),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Ud),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$Gg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Gg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,h.$Hf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}a.push(t((0,M.$Dg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const m=new u.$Ac,O=new Map;if(a.length)try{const I=this.Q();if(I.workspaces)for(const[E,C]of Object.entries(I.workspaces)){const j=D.URI.parse(E),T=a.find(F=>F.id===C);T&&m.set(j,T)}if(I.emptyWindows)for(const[E,C]of Object.entries(I.emptyWindows)){const j=a.find(T=>T.id===C);j&&O.set(E,j)}}catch(I){this.y.error(I)}this.z={profiles:a,workspaces:m,emptyWindows:O}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",m=new RegExp(`${(0,d.$Ne)(a)}\\s(\\d+)`);let O=0;for(const E of this.profiles){const C=m.exec(E.name),j=C?parseInt(C[1]):0;O=j>O?j:O}const I=`${a} ${O+1}`;return this.createProfile((0,P.$Si)((0,$.$pg)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,a,m){return this.createProfile((0,P.$Si)((0,$.$pg)()).toString(16),n,a,m)}async createProfile(n,a,m,O){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,a,m);return O&&await this.setProfileForWorkspace(O,I),I}async F(n,a,m){if(!(0,h.$Hf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let O=this.r.get(a);return O||(O=(async()=>{try{const I=this.profiles.find(j=>j.name===a||j.id===n);if(I)return I;const E=t(n,a,(0,M.$Gg)(this.profilesHome,n),this.g,m,this.defaultProfile);await this.u.createFolder(E.location);const C=[];return this.j.fire({profile:E,join(j){C.push(j)}}),await b.Promises.settled(C),this.I([E],[],[]),E}finally{this.r.delete(a)}})(),this.r.set(a,O)),O}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(O=>O.id===n.id);if(!m)throw new Error(`Profile '${n.name}' does not exist`);return m=t(m.id,a.name??m.name,m.location,this.g,{shortName:a.shortName??m.shortName,icon:a.icon===null?void 0:a.icon??m.icon,transient:a.transient??m.isTransient,useDefaultFlags:a.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.I([],[],[m]),m}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(O=>O.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const m=[];this.m.fire({profile:a,join(O){m.push(O)}});try{await Promise.allSettled(m)}catch(O){this.y.error(O)}for(const O of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(O)?.id&&this.C.emptyWindows.delete(O);for(const O of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(O)?.id&&this.C.workspaces.delete(O);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(O){(0,l.$Gk)(O)!==1&&this.y.error(O)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(O=>O.id===a.id);if(!m)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,m)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(m=>!this.w.extUri.isEqual(m.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,v.$ci)(n)?n.uri:(0,v.$hi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,m){const O=[...this.profiles,...n],I=[];this.s.profiles=[];for(let E of O)E.isDefault||a.some(C=>E.id===C.id)||(E=m.find(C=>E.id===C.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,a,m)}J(n,a,m){this.h.fire({added:n,removed:a,updated:m,all:this.profiles})}L(n,a,m){m=a?.isTransient?!0:m,m||this.L(n,void 0,!0);const O=this.G(n),I=m?this.s:this.C;D.URI.isUri(O)?(I.workspaces.delete(O),a&&I.workspaces.set(O,a)):(I.emptyWindows.delete(O),a&&I.emptyWindows.set(O,a)),m||this.M()}M(){const n={};for(const[m,O]of this.C.workspaces.entries())n[m.toString()]=O.id;const a={};for(const[m,O]of this.C.emptyWindows.entries())a[m.toString()]=O.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},m=this.D();if(n.workspaces)for(const[I,E]of Object.entries(n.workspaces)){const C=D.URI.parse(E);a[I]=this.w.extUri.isEqual(C,m.location)?m.id:this.w.extUri.basename(C)}const O={};if(n.emptyWindows)for(const[I,E]of Object.entries(n.emptyWindows)){const C=D.URI.parse(E);O[I]=this.w.extUri.isEqual(C,m.location)?m.id:this.w.extUri.basename(C)}return{workspaces:a,emptyWindows:O}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$5k=o,e.$5k=o=Ee([ne(0,f.$_h),ne(1,l.$pk),ne(2,y.$Zk),ne(3,k.$mj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$6k=r}),define(oe[81],ae([0,1,8,17,2,3,31,7,118,124,16,6,5,41,40,12,14,28]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class g extends Error{constructor(r,i){super(r),this.code=i}}e.$Tp=g,e.$Up=(0,k.$5h)("IExtensionsProfileScannerService");let w=class extends s.$Tc{constructor(r,i,n,a,m,O){super(),this.j=r,this.m=i,this.n=n,this.r=a,this.s=m,this.t=O,this.b=this.B(new M.$Ud),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Ud),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Ud),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Ud),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],a=[];try{return await this.u(i,m=>{const O=[];for(const I of m)r.some(([E])=>(0,l.$Zo)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?n.push(I):O.push(I);for(const[I,E]of r){const C=O.findIndex(T=>(0,l.$Zo)(T.identifier,I.identifier)&&T.version===I.manifest.version),j={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};C===-1?(a.push(j),O.push(j)):O.splice(C,1,j)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),O}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(m){throw a.length&&this.c.fire({extensions:a,error:m,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:m,profileLocation:i}),m}}async updateMetadata(r,i){const n=[];return await this.u(i,a=>{const m=[];for(const O of a){const I=r.find(([E])=>(0,l.$Zo)(E.identifier,O.identifier)&&E.manifest.version===O.version);I&&(O.metadata={...O.metadata,...I[1]},n.push(O)),m.push(O)}return m}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,a=>{const m=[];for(const O of a)(0,l.$Zo)(O.identifier,r.identifier)?n.push(O):m.push(O);return n.length&&this.f.fire({extensions:n,profileLocation:i}),m}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(r,i,n){return this.F(r).queue(async()=>{let a=[],m;try{const O=await this.m.readFile(r);m=JSON.parse(O.value.toString().trim()||"[]")}catch(O){if((0,p.$Gk)(O)!==1)throw O;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(m=await this.D()),!m&&n?.bailOutWhenFileNotFound)throw new g((0,$.$0)(O),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.w(r);let O=!1;for(const I of m){c(I)||this.w(r);let E;if((0,b.$Hf)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,b.$Hf)(I.location))E=this.z(I.location),O=!0,I.relativeLocation=I.location,I.location=E.toJSON();else{E=S.URI.revive(I.location);const C=this.y(E);C&&(O=!0,I.relativeLocation=C)}a.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}O&&await this.m.writeFile(r,A.$ie.fromString(JSON.stringify(m)))}if(i){a=i(a);const O=a.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,A.$ie.fromString(JSON.stringify(O)))}return a})}w(r){const i=new g(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(m){if((0,p.$Gk)(m)===1)return;throw m}this.t.info("Migrating extensions from old default profile location",r.toString());let a;try{const m=JSON.parse(n);Array.isArray(m)&&m.every(O=>c(O))?a=m:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.t.error(m)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ie.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(m){if((0,p.$Gk)(m)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw m}try{await this.m.del(r)}catch(m){(0,p.$Gk)(m)!==1&&this.t.error(m)}try{await this.m.del(i)}catch(m){(0,p.$Gk)(m)!==1&&this.t.error(m)}return a})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$_g,this.h.set(r,i)),i}};e.$Vp=w,e.$Vp=w=Ee([ne(1,p.$pk),ne(2,u.$2k),ne(3,y.$Zk),ne(4,d.$tl),ne(5,v.$mj)],w);function c(o){return(0,b.$Jf)(o)&&(0,f.$wo)(o.identifier)&&(t(o.location)||(0,b.$Hf)(o.location)&&o.location)&&((0,b.$Of)(o.relativeLocation)||(0,b.$Hf)(o.relativeLocation))&&o.version&&(0,b.$Hf)(o.version)}function t(o){return o?(0,b.$Hf)(o.path)&&(0,b.$Hf)(o.scheme):!1}}),define(oe[130],ae([0,1,22,8,35,17,14,42,152,2,13,9,4,19,205,74,12,7,172,38,124,121,204,16,6,5,27,3,77,81,41,40,203]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o,r,i,n,a,m,O,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.Translations=void 0;var j;(function(ue){function Z(X,H){if(X===H)return!0;const L=Object.keys(X),W=new Set;for(const V of Object.keys(H))W.add(V);if(L.length!==W.size)return!1;for(const V of L){if(X[V]!==H[V])return!1;W.delete(V)}return W.size===0}ue.equals=Z})(j||(e.Translations=j={})),e.$Yp=(0,r.$5h)("IExtensionsScannerService");let T=class extends l.$Tc{constructor(Z,X,H,L,W,V,q,te,he,K,R,U){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=X,this.r=H,this.s=L,this.t=W,this.u=V,this.w=q,this.y=te,this.z=he,this.C=K,this.D=R,this.F=U,this.g=this.B(new a.$Ud),this.onDidChangeCache=this.g.event,this.h=(0,u.$Gg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(J,this.s,this.h)),this.m=this.B(this.F.createInstance(J,this.s,this.h)),this.n=this.B(this.F.createInstance(G,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,w.$$o)(this.w,this.y)),this.G}async scanAllExtensions(Z,X,H){const[L,W]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(X)]),V=H?await this.scanExtensionsUnderDevelopment(Z,[...L,...W]):[];return this.L(L,W,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const X=[];X.push(this.M(!!Z.useCache,Z.language)),X.push(this.N(Z.language,!!Z.checkControlFile));const[H,L]=await Promise.all(X);return this.J([...H,...L],0,Z,!1)}async scanUserExtensions(Z){const X=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const H=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(X,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,H),W=Z.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let V;try{V=await W.scanExtensions(L)}catch(q){if(q instanceof O.$Tp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await W.scanExtensions(L);else throw q}return V=await this.J(V,1,Z,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(Z,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===p.Schemas.file).map(async L=>{const W=await this.P(L,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(q=>(q.type=X.find(te=>(0,w.$Zo)(te.identifier,q.identifier))?.type??q.type,this.n.validate(q,W)))}))).flat();return this.J(H,"development",Z,!0)}return[]}async scanExistingExtension(Z,X,H){const L=await this.P(Z,!1,X,!0,H.language,!0,void 0),W=await this.n.scanExtension(L);return!W||!H.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(Z,X,H){const L=await this.P(Z,!1,X,!0,H.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(L);return this.J(W,X,H,!0)}async scanMetadata(Z){const X=(0,u.$Gg)(Z,"package.json"),H=(await this.w.readFile(X)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(Z,X){const H=(0,u.$Gg)(Z,"package.json"),L=(await this.w.readFile(H)).value.toString(),W=JSON.parse(L);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,W.__metadata={...W.__metadata,...X},await this.w.writeFile((0,u.$Gg)(Z,"package.json"),M.$ie.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof O.$Tp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ie.fromString(JSON.stringify([])))}catch(X){(0,o.$Gk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,X,H,L){return H.includeAllVersions||(Z=this.L(X===0?Z:void 0,X===1?Z:void 0,X==="development"?Z:void 0,await this.getTargetPlatform(),L)),H.includeInvalid||(Z=Z.filter(W=>W.isValid)),Z.sort((W,V)=>{const q=k.$nc(W.location.fsPath),te=k.$nc(V.location.fsPath);return q<te?-1:q>te?1:0})}L(Z,X,H,L,W){const V=(te,he,K)=>{if(te.isValid&&!he.isValid)return!1;if(te.isValid===he.isValid){if(W&&y.gt(te.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(y.eq(te.manifest.version,he.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${te.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${he.location.path}.`),!0},q=new c.$mm;return Z?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),X?.forEach(te=>{const he=q.get(te.identifier.id);if(!he&&Z&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),H?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!0))&&q.set(te.identifier.id,te),q.set(te.identifier.id,te)}),[...q.values()]}async M(Z,X){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),W=await(Z&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",W.length),W}async N(Z,X){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const L=X?await this.O():{},W=[],V=d.URI.file(k.$hc(k.$jc(p.$ng.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of H){const he=L[te.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":W.push((0,u.$Gg)(V,te.name));break;default:W.push(d.URI.file(he));break}}const q=await Promise.all(W.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,P.$Hb)(q)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,X,H,L,W,V,q){const te=await this.f(W??v.$w),he=await this.Q(Z),K=X&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=K?await this.Q(K):void 0;return new F(Z,he,K,R,X,q,H,L,V,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,te)}async Q(Z){try{const X=await this.w.stat(Z);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Zp=T,e.$Zp=T=Ee([ne(4,I.$2k),ne(5,O.$Up),ne(6,o.$pk),ne(7,i.$mj),ne(8,g.$_h),ne(9,n.$Ej),ne(10,E.$Zk),ne(11,r.$4h)],T);class F{constructor(Z,X,H,L,W,V,q,te,he,K,R,U,x,z,Y){this.location=Z,this.mtime=X,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=L,this.profile=W,this.profileScanOptions=V,this.type=q,this.excludeObsolete=te,this.validate=he,this.productVersion=K,this.productDate=R,this.productCommit=U,this.devMode=x,this.language=z,this.translations=Y}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,X){return(0,u.$zg)(Z.location,X.location)&&Z.mtime===X.mtime&&(0,u.$zg)(Z.applicationExtensionslocation,X.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&Z.profile===X.profile&&s.$yn(Z.profileScanOptions,X.profileScanOptions)&&Z.type===X.type&&Z.excludeObsolete===X.excludeObsolete&&Z.validate===X.validate&&Z.productVersion===X.productVersion&&Z.productDate===X.productDate&&Z.productCommit===X.productCommit&&Z.devMode===X.devMode&&Z.language===X.language&&j.equals(Z.translations,X.translations)}}e.$1p=F;let G=class extends l.$Tc{constructor(Z,X,H,L,W){super(),this.f=Z,this.g=X,this.h=H,this.j=L,this.m=W}async scanExtensions(Z){const X=Z.profile?await this.r(Z):await this.n(Z);let H={};if(Z.excludeObsolete&&Z.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(L)}catch{}return(0,$.$Uf)(H)?X:X.filter(L=>!H[w.$1o.create(L).toString()])}async n(Z){const X=await this.j.resolve(Z.location);if(!X.children?.length)return[];const H=await Promise.all(X.children.map(async L=>{if(!L.isDirectory||Z.type===1&&(0,u.$Dg)(L.resource).indexOf(".")===0)return null;const W=new F(L.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(W)}));return(0,P.$Hb)(H).sort((L,W)=>L.location.path<W.location.path?-1:1)}async r(Z){let X=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){X=X.filter(L=>!L.metadata?.isApplicationScoped);const H=await this.s(Z.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Z);X.push(...H)}return X}async s(Z,X,H){const L=await this.g.scanProfileExtensions(Z,H.profileScanOptions);if(!L.length)return[];const W=await Promise.all(L.map(async V=>{if(X(V)){const q=new F(V.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(q,V.metadata)}return null}));return(0,P.$Hb)(W)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,u.$Gg)(Z.location,"package.json"))){const X=await this.scanExtension(Z);return X?[X]:[]}else return await this.scanExtensions(Z)}catch(X){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,D.$0)(X)),[]}}async scanExtension(Z,X){try{let H=await this.scanExtensionManifest(Z.location);if(H){H.publisher||(H.publisher=c.$gm),X=X??H.__metadata,delete H.__metadata;const L=(0,w.$5o)(H.publisher,H.name),W=X?.id?{id:L,uuid:X.id}:{id:L},V=X?.isSystem?0:Z.type,q=V===0||!!X?.isBuiltin;H=await this.t(Z.location,H,F.createNlsConfiguration(Z));const te={type:V,identifier:W,manifest:H,location:Z.location,isBuiltin:q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return Z.validate?this.validate(te,Z):te}}catch(H){Z.type!==0&&this.m.error(H)}return null}validate(Z,X){let H=!0;const L=(0,t.$dp)(X.productVersion,X.productDate,X.location,Z.manifest,Z.isBuiltin);for(const[W,V]of L)W===b.default.Error&&(H=!1,this.m.error(this.z(X.location,V)));return Z.isValid=H,Z.validations=L,Z}async scanExtensionManifest(Z){const X=(0,u.$Gg)(Z,"package.json");let H;try{H=(await this.j.readFile(X)).value.toString()}catch(W){return(0,o.$Gk)(W)!==1&&this.m.error(this.z(Z,(0,h.localize)(0,null,X.path,W.message))),null}let L;try{L=JSON.parse(H)}catch{const V=[];(0,S.$bn)(H,V);for(const q of V)this.m.error(this.z(Z,(0,h.localize)(1,null,X.path,q.offset,q.length,(0,f.$Wp)(q.error))));return null}return(0,S.$kn)(L)!=="object"?(this.m.error(this.z(Z,(0,h.localize)(2,null,X.path))),null):L}async t(Z,X,H){const L=await this.u(Z,X,H);if(L)try{const W=[],V=await this.w(L.default,W);if(W.length>0)return W.forEach(te=>{this.m.error(this.z(Z,(0,h.localize)(3,null,L.default?.path,(0,f.$Wp)(te.error))))}),X;if((0,S.$kn)(L)!=="object")return this.m.error(this.z(Z,(0,h.localize)(4,null,L.default?.path))),X;const q=L.values||Object.create(null);return(0,C.$Xp)(this.m,X,q,V)}catch{}return X}async u(Z,X,H){const L=(0,u.$Gg)(Z,"package.nls.json"),W=(he,K)=>{K.forEach(R=>{this.m.error(this.z(Z,(0,h.localize)(5,null,he?.path,(0,f.$Wp)(R.error))))})},V=he=>{this.m.error(this.z(Z,(0,h.localize)(6,null,he?.path)))},q=`${X.publisher}.${X.name}`,te=H.translations[q];if(te)try{const he=d.URI.file(te),K=(await this.j.readFile(he)).value.toString(),R=[],U=(0,S.$bn)(K,R);return R.length>0?(W(he,R),{values:void 0,default:L}):(0,S.$kn)(U)!=="object"?(V(he),{values:void 0,default:L}):{values:U.contents?U.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let K;try{K=await this.y(Z,H)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const R=(await this.j.readFile(K.localized)).value.toString(),U=[],x=(0,S.$bn)(R,U);return U.length>0?(W(K.localized,U),{values:void 0,default:K.original}):(0,S.$kn)(x)!=="object"?(V(K.localized),{values:void 0,default:K.original}):{values:x,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Z,X){if(Z)try{const H=(await this.j.readFile(Z)).value.toString();return(0,S.$bn)(H,X)}catch{}}y(Z,X){return new Promise((H,L)=>{const W=V=>{const q=(0,u.$Gg)(Z,`package.nls.${V}.json`);this.j.exists(q).then(te=>{te&&H({localized:q,original:(0,u.$Gg)(Z,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?H({localized:(0,u.$Gg)(Z,"package.nls.json"),original:null}):(V=V.substring(0,he),W(V))})};if(X.devMode||X.pseudo||!X.language)return H({localized:(0,u.$Gg)(Z,"package.nls.json"),original:null});W(X.language)})}z(Z,X){return`[${Z.path}]: ${X}`}};G=Ee([ne(1,O.$Up),ne(2,E.$Zk),ne(3,o.$pk),ne(4,i.$mj)],G);let J=class extends G{constructor(Z,X,H,L,W,V,q){super(X,L,W,V,q),this.G=Z,this.H=H,this.D=this.B(new A.$3g(3e3)),this.F=this.B(new a.$Ud),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const X=this.M(Z),H=await this.I(X);if(this.C=Z,H&&H.input&&F.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),H.result.map(W=>(W.location=d.URI.revive(W.location),W));const L=await super.scanExtensions(Z);return await this.J(X,{input:Z,result:L}),L}async I(Z){try{const X=await this.j.readFile(Z),H=JSON.parse(X.value.toString());return{result:H.result,input:(0,m.$Bh)(H.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",Z.path,(0,D.$0)(X))}return null}async J(Z,X){try{await this.j.writeFile(Z,M.$ie.fromString(JSON.stringify(X)))}catch(H){this.m.debug("Error while writing the extension cache file:",Z.path,(0,D.$0)(H))}}async L(){if(!this.C)return;const Z=this.M(this.C),X=await this.I(Z);if(!X)return;const H=X.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$yn(L,H))try{this.m.info("Invalidating Cache",H,L),await this.j.del(Z),this.F.fire()}catch(W){this.m.error(W)}}M(Z){const X=this.N(Z);return this.h.extUri.joinPath(X.cacheHome,Z.type===0?c.$fm:c.$em)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(Z.location,X.extensionsResource))??this.G:this.H.defaultProfile}};J=Ee([ne(2,I.$2k),ne(3,O.$Up),ne(4,E.$Zk),ne(5,o.$pk),ne(6,i.$mj)],J);function le(ue,Z){const X=(0,w.$3o)(ue.manifest.publisher,ue.manifest.name);return{id:X,identifier:new c.$km(X),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$2p=le;class se extends T{constructor(Z,X,H,L,W,V,q,te,he,K,R,U){super(Z,X,(0,u.$Gg)(H,".vscode-oss-dev","extensions","control.json"),L,W,V,q,te,he,K,R,U),this.R=(async()=>{if(v.$z)try{const x=await this.w.readFile(d.URI.file(v.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$3p=se}),define(oe[276],ae([0,1,5,41,40,28,81,16,38,7]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=void 0;let p=class extends D.$Vp{constructor(v,u,y,b,$,d){super(l.URI.file(v.extensionsPath),u,y,b,$,d)}};e.$sO=p,e.$sO=p=Ee([ne(0,f.$ai),ne(1,S.$pk),ne(2,A.$2k),ne(3,s.$Zk),ne(4,M.$tl),ne(5,P.$mj)],p)}),define(oe[277],ae([0,1,7,38,81,130,16,6,5,27,40,41]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=void 0;let v=class extends M.$3p{constructor(y,b,$,d,h,g,w,c){super(P.URI.file(h.builtinExtensionsPath),P.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,b,$,d,h,g,w,c)}};e.$F$b=v,e.$F$b=v=Ee([ne(0,k.$2k),ne(1,s.$Up),ne(2,D.$pk),ne(3,f.$mj),ne(4,A.$ai),ne(5,l.$Ej),ne(6,p.$Zk),ne(7,S.$4h)],v)}),define(oe[278],ae([0,1,15,2,13,9,4,58,7,32,37,38,5,41]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=void 0;let y=class extends A.$Tc{constructor($,d,h){super(),this.c=$,this.f=h,this.a=S.$$h.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot($.appRoot),this.addValidFileRoot($.extensionsPath),this.addValidFileRoot(d.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot($.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:$}=P.session;$.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(d,h)=>this.j(d,h)),$.protocol.interceptFileProtocol(s.Schemas.file,(d,h)=>this.h(d,h)),this.B((0,A.$Rc)(()=>{$.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),$.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot($){const d=(0,M.$hc)($);return this.a.get(d)?A.$Tc.None:(this.a.set(d,!0),(0,A.$Rc)(()=>this.a.delete(d)))}h($,d){const h=f.URI.parse($.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${$.url})`),d({error:-3})}j($,d){const h=this.m($);let g;return this.c.crossOriginIsolated&&((0,M.$nc)(h)==="workbench.html"||(0,M.$nc)(h)==="workbench-dev.html"?g=s.COI.CoopAndCoep:g=s.COI.getHeadersFromQuery($.url)),this.a.findSubstr(h)?d({path:h,headers:g}):this.b.has((0,M.$oc)(h).toLowerCase())?d({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${$.url})`),d({error:-3}))}m($){const d=f.URI.parse($.url),h=s.$ng.uriToFileUri(d);return(0,M.$hc)(h.fsPath)}createIPCObjectUrl(){let $;const d=f.URI.from({scheme:"vscode",path:(0,l.$pg)()}),h=d.toString(),g=async()=>$;return p.$qU.handle(h,g),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:d,update:w=>$=w,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),p.$qU.removeHandler(h)}}}};e.$X$b=y,e.$X$b=y=Ee([ne(0,k.$ai),ne(1,u.$2k),ne(2,v.$mj)],y)}),define(oe[96],ae([0,1,8,3,2,68,12,112,6,41]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$tp=e.$sp=e.$rp=void 0,e.$rp="__$__isNewStorageMarker",e.$sp="__$__targetStorageMarker",e.$tp=(0,f.$5h)("storageService");var p;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var k;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var v;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function u(h){const g=h.get(e.$sp);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.$up=u;class y extends s.$Tc{static{this.a=60*1e3}constructor(g={flushInterval:y.a}){super(),this.m=g,this.b=this.B(new A.$Xd),this.c=this.B(new A.$Xd),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Ud),this.onWillSaveState=this.f.event,this.h=this.B(new P.$eh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(g,w,c){return A.Event.filter(this.b.event,t=>t.scope===g&&(w===void 0||t.key===w),c)}n(){this.j.value=(0,P.$ih)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(g,w){const{key:c,external:t}=w;if(c===e.$sp){switch(g){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:c,target:this.J(g)[c],external:t})}w(g){this.f.fire({reason:g})}get(g,w,c){return this.P(w)?.get(g,c)}getBoolean(g,w,c){return this.P(w)?.getBoolean(g,c)}getNumber(g,w,c){return this.P(w)?.getNumber(g,c)}getObject(g,w,c){return this.P(w)?.getObject(g,c)}storeAll(g,w){this.y(()=>{for(const c of g)this.store(c.key,c.value,c.scope,c.target,w)})}store(g,w,c,t,o=!1){if((0,D.$Qf)(w)){this.remove(g,c,o);return}this.y(()=>{this.z(g,c,t),this.P(c)?.set(g,w,o)})}remove(g,w,c=!1){this.y(()=>{this.z(g,w,void 0),this.P(w)?.delete(g,c)})}y(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,w){const c=[],t=this.J(g);for(const o of Object.keys(t))t[o]===w&&c.push(o);return c}z(g,w,c,t=!1){const o=this.J(w);typeof c=="number"?o[g]!==c&&(o[g]=c,this.P(w)?.set(e.$sp,JSON.stringify(o),t)):typeof o[g]=="number"&&(delete o[g],this.P(w)?.set(e.$sp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(g){switch(g){case-1:return this.I;case 0:return this.G;default:return this.D}}L(g){const w=this.P(g);return w?u(w):Object.create(null)}isNew(g){return this.getBoolean(e.$rp,g)===!0}async flush(g=p.NONE){this.f.fire({reason:g});const w=this.P(-1),c=this.P(0),t=this.P(1);switch(g){case p.NONE:await P.Promises.settled([w?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await P.Promises.settled([w?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.P(-1)?.items??new Map,w=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return d(g,w,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(g){return await this.flush(),this.P(g)?.optimize()}async switch(g,w){return this.w(p.NONE),(0,l.$1k)(g)?this.R(g,w):this.S(g,w)}M(g,w){return!(g.id===w.id||b(w)&&b(g))}N(g,w,c){this.y(()=>{const t=new Set;for(const[o,r]of g)t.add(o),w.get(o)!==r&&this.u(c,{key:o,external:!0});for(const[o]of w.items)t.has(o)||this.u(c,{key:o,external:!0})})}}e.$vp=y;function b(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$wp=b;class $ extends y{constructor(){super(),this.U=this.B(new S.$pp(new S.$qp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$pp(new S.$qp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$pp(new S.$qp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(g=>this.u(1,g))),this.B(this.W.onDidChangeStorage(g=>this.u(0,g))),this.B(this.U.onDidChangeStorage(g=>this.u(-1,g)))}P(g){switch(g){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(g){return!1}}e.$xp=$;async function d(h,g,w,c,t,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;h.forEach((j,T)=>{i.set(T,j),n.set(T,r(j))});const a=new Map,m=new Map;g.forEach((j,T)=>{a.set(T,j),m.set(T,r(j))});const O=new Map,I=new Map;w.forEach((j,T)=>{O.set(T,j),I.set(T,r(j))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const E=[];if(i.forEach((j,T)=>{E.push({key:T,value:j})}),console.table(E),console.groupEnd(),console.log(n),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];a.forEach((T,F)=>{j.push({key:F,value:T})}),console.table(j),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${o})`);const C=[];O.forEach((j,T)=>{C.push({key:T,value:j})}),console.table(C),console.groupEnd(),console.log(I)}e.$yp=d}),define(oe[279],ae([0,1,22,8,3,2,9,73,7,21,112,161,5,96,28,30,13]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=e.$w0b=e.$v0b=e.$u0b=void 0;class d extends M.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Ud),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Ud),this.onDidCloseStorage=this.c.event,this.f=this.B(new p.$pp(new p.$qp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$ph,this.whenInit=this.h.p,this.j=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===p.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(u.$rp);i===void 0?r.set(u.$rp,!0):i&&r.set(u.$rp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=p.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$Qd(!1);await this.w(),r.stop(),r.elapsed()>d.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([a,m])=>({key:a,length:m.length})),(a,m)=>m.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=p.StorageState.Closed,await this.f.close()}}class h extends d{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,h.y)}constructor(r,i,n,a){super(n,a),this.z=r,this.C=i}async t(){return new p.$pp(new k.$VU(this.path??k.$VU.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}class g extends h{constructor(r,i,n,a){super(r,i,n,a)}}e.$u0b=g;class w extends h{constructor(r,i,n,a){super(i.defaultProfile,r,n,a)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$wl,void 0)===void 0&&r.set(y.$wl,new Date().toUTCString());const n=r.get(y.$vl,void 0),a=new Date().toUTCString();r.set(y.$xl,typeof n>"u"?null:n),r.set(y.$vl,a)}}e.$v0b=w;class c extends d{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id,c.y)}constructor(r,i,n,a,m){super(n,m),this.C=r,this.D=i,this.F=a}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new p.$pp(new k.$VU(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:k.$VU.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id),i=(0,D.$jc)(r,c.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,b.$ci)(this.C)?i={folder:this.C.uri.toString()}:(0,b.$hi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$jc)(r,c.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$w0b=c;class t extends d{get path(){}async t(){return new p.$pp(new p.$qp,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.$x0b=t}),define(oe[280],ae([0,1,3,2,96]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;class M extends A.$Tc{constructor(S,f,l){super(),this.b=S,this.c=f,this.f=l;const p=this.B(new A.$Uc);this.a=this.B(new P.$Ud({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new A.$Sc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,l)=>(f?f.push(l.key):f=[l.key],f),100)(f=>this.h(f))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,l)=>{f||(f=new Map);let p=f.get(l.profile.id);return p||f.set(l.profile.id,p={profile:l.profile,keys:[],storage:l.storage}),p.keys.push(l.key),f},100)(f=>this.j(f))),S}h(S){const f=S.includes(s.$sp)?[this.c.defaultProfile]:[],l=[];if(S=S.filter(p=>p!==s.$sp),S.length){const p=(0,s.$up)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:S.map(k=>({key:k,scope:0,target:p[k]}))})}this.m(f,l)}j(S){const f=[],l=new Map;for(const[p,k]of S.entries()){k.keys.includes(s.$sp)&&f.push(k.profile);const v=k.keys.filter(u=>u!==s.$sp);if(v.length){const u=(0,s.$up)(k.storage.storage);l.set(p,{profile:k.profile,changes:v.map(y=>({key:y,scope:0,target:u[y]}))})}}this.m(f,[...l.values()])}m(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,l){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$H$b=M}),define(oe[281],ae([0,1,7,38,16,5,34,40,41,12,122]),function(Q,e,P,A,s,M,D,S,f,l,p){"use strict";var k,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=e.$qO=e.$pO=void 0;let u=class extends f.$5k{static{k=this}static{this.a="profileAssociationsMigration"}constructor(d,h,g,w,c){super(g,w,h,c),this.U=d,this.W=g}O(){return this.U.getItem(k.b,[]).map(h=>({...h,location:(0,l.$Hf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):P.URI.revive(h.location)}))}Q(){const d=this.U.getItem(k.c,{});return this.U.getItem(k.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$pO=u,e.$pO=u=k=Ee([ne(0,D.$kO),ne(1,S.$Zk),ne(2,A.$ai),ne(3,s.$pk),ne(4,M.$mj)],u);let y=v=class extends u{constructor(d,h,g,w,c){super(d,h,g,w,c),this.$=d}P(d){d.length?this.$.setItem(v.b,d.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(v.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(v.c,d):this.$.removeItem(v.c)}Q(){const d="workspaceAndProfileInfo",h=this.$.getItem(d,void 0);if(h){this.$.removeItem(d);const w=h.reduce((c,{workspace:t,profile:o})=>(c[P.URI.revive(t).toString()]=P.URI.revive(o).toString(),c),{});this.$.setItem(v.c,{workspaces:w})}const g=super.Q();return this.$.getItem(v.a,!1)||(this.R(g),this.$.setItem(v.a,!0)),g}};e.$qO=y,e.$qO=y=v=Ee([ne(0,D.$lO),ne(1,S.$Zk),ne(2,A.$ai),ne(3,s.$pk),ne(4,M.$mj)],y);let b=class extends y{constructor(d,h,g,w){super(new p.$oO(0,h,w,g),d,h,g,w)}async init(){return await this.$.init(),super.init()}};e.$rO=b,e.$rO=b=Ee([ne(0,S.$Zk),ne(1,A.$ai),ne(2,s.$pk),ne(3,M.$mj)],b)}),define(oe[56],ae([0,1,38,16,6,5,40,41,281,34]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=e.$c0b=void 0,e.$c0b=(0,s.$6h)(S.$2k);let p=class extends f.$qO{constructor(v,u,y,b,$){super(v,u,y,b,$)}getAssociatedEmptyWindows(){const v=[];for(const u of this.C.emptyWindows.keys())v.push({id:u});return v}};e.$d0b=p,e.$d0b=p=Ee([ne(0,l.$lO),ne(1,D.$Zk),ne(2,P.$ai),ne(3,A.$pk),ne(4,M.$mj)],p)}),define(oe[131],ae([0,1,19,7,30]),function(Q,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g0b=e.$f0b=e.$e0b=void 0;async function M(f,l,p){for(const v of f){const u=v.openedWorkspace;if((0,s.$hi)(u)){const y=await p(u);if(y){if(y.folders.some(b=>P.$xg.isEqualOrParent(l,b.uri)))return v}else if(P.$xg.isEqualOrParent(l,u.configPath))return v}}const k=f.filter(v=>(0,s.$ci)(v.openedWorkspace)&&P.$xg.isEqualOrParent(l,v.openedWorkspace.uri));if(k.length)return k.sort((v,u)=>-(v.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.$e0b=M;function D(f,l){for(const p of f)if((0,s.$hi)(p.openedWorkspace)&&P.$xg.isEqual(p.openedWorkspace.configPath,l)||(0,s.$ci)(p.openedWorkspace)&&P.$xg.isEqual(p.openedWorkspace.uri,l))return p}e.$f0b=D;function S(f,l){const p=k=>l.some(v=>P.$xg.isEqual(A.URI.file(v),A.URI.file(k)));for(const k of f)if(k.config?.extensionDevelopmentPath?.some(v=>p(v)))return k}e.$g0b=S}),define(oe[97],ae([0,1,33,42,101,47,13,9,4,19,7,6,59,30]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcb=e.$wcb=e.$vcb=e.$ucb=e.$tcb=e.$scb=e.$rcb=e.$qcb=e.$pcb=e.$ocb=void 0,e.$ocb=(0,k.$5h)("workspacesService");function y(I){return I.hasOwnProperty("workspace")}e.$pcb=y;function b(I){return I.hasOwnProperty("folderUri")}e.$qcb=b;function $(I){return I.hasOwnProperty("fileUri")}e.$rcb=$;function d(I){return h(I)||g(I)}e.$scb=d;function h(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function g(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function w(I,E,C,j,T){if(I.scheme!==j.scheme)return{name:C,uri:I.toString(!0)};let F=E?void 0:T.relativePath(j,I);if(F!==void 0)F.length===0?F=".":f.$i&&(F=c(F));else if(I.scheme===D.Schemas.file)F=I.fsPath,f.$i&&(F=c(F));else if(T.isEqualAuthority(I.authority,j.authority))F=I.path;else return{name:C,uri:I.toString(!0)};return{name:C,path:F}}e.$tcb=w;function c(I){return I=(0,M.$Vv)(I),(0,P.$4f)(I)||(I=(0,P.$1f)(I)),I}function t(I,E,C){const j=[],T=new Set,F=C.dirname(E);for(const G of I){let J;if(h(G))G.path&&(J=C.resolvePath(F,G.path));else if(g(G))try{J=p.URI.parse(G.uri),J.path[0]!==S.$gc.sep&&(J=J.with({path:S.$gc.sep+J.path}))}catch(le){console.warn(le)}if(J){const le=C.getComparisonKey(J);if(!T.has(le)){T.add(le);const se=G.name||C.basenameOrAuthority(J);j.push(new u.$mi({uri:J,name:se,index:j.length},G))}}}return j}e.$ucb=t;function o(I,E,C,j,T){const F=r(E,I),G=T.dirname(E),J=T.dirname(j),le=[];for(const X of F.folders){const H=h(X)?T.resolvePath(G,X.path):p.URI.parse(X.uri);let L;C?L=!1:L=!h(X)||(0,S.$ic)(X.path),le.push(w(H,L,X.name,J,T))}const se={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},ue=s.$qn(I,["folders"],le,se);let Z=s.$tn(I,ue);return(0,l.$Lg)(F.remoteAuthority,(0,v.$_k)(j))&&(Z=s.$tn(Z,s.$pn(Z,["remoteAuthority"],se))),Z}e.$vcb=o;function r(I,E){const C=A.$bn(E);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(j=>d(j));else throw new Error(`${I} looks like an invalid workspace file.`);return C}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function a(I){return typeof I.fileUri=="string"}function m(I,E){const C={workspaces:[],files:[]};if(I){const j=function(F,G){for(let J=0;J<F.length;J++)try{G(F[J],J)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(F[J])}: ${le.toString()}. Skip entry.`)}},T=I;Array.isArray(T.entries)&&j(T.entries,F=>{const G=F.label,J=F.remoteAuthority;i(F)?C.workspaces.push({label:G,remoteAuthority:J,workspace:{id:F.workspace.id,configPath:p.URI.parse(F.workspace.configPath)}}):n(F)?C.workspaces.push({label:G,remoteAuthority:J,folderUri:p.URI.parse(F.folderUri)}):a(F)&&C.files.push({label:G,remoteAuthority:J,fileUri:p.URI.parse(F.fileUri)})})}return C}e.$wcb=m;function O(I){const E={entries:[]};for(const C of I.workspaces)b(C)?E.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):E.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of I.files)E.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return E}e.$xcb=O}),define(oe[98],ae([0,1,86,13,4,19]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0b=e.$j0b=e.$i0b=e.$h0b=void 0,e.$h0b=128/4;function D(l){function p(){let k=l.scheme===A.Schemas.file?(0,M.$ug)(l):l.toString();return s.$k||(k=k.toLowerCase()),(0,P.createHash)("md5").update(k).digest("hex")}return{id:p(),configPath:l}}e.$i0b=D;function S(l,p){function k(){if(l.scheme!==A.Schemas.file)return(0,P.createHash)("md5").update(l.toString()).digest("hex");if(!p)return;let u;return s.$k?u=p.ino:s.$j?u=p.birthtime.getTime():s.$i&&(typeof p.birthtimeMs=="number"?u=Math.floor(p.birthtimeMs):u=p.birthtime.getTime()),(0,P.createHash)("md5").update(l.fsPath).update(u?String(u):"").digest("hex")}const v=k();if(typeof v=="string")return{id:v,uri:l}}e.$j0b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$k0b=f}),define(oe[99],ae([0,1,86,87,26,282,17,14,3,2,9,4,32,43,110]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=void 0;class b{traceSocketEvent(E,C){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,C)}constructor(E,C=""){this.f=!0,this.debugLabel=C,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,S.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const C=j=>{this.traceSocketEvent("read",j),E(D.$ie.wrap(j))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(E){const C=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(E){const C=()=>{E()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,S.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,S.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Th=b;var $;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var d;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(d||(d={}));class h extends l.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,C){this.socket.traceSocketEvent(E,C)}constructor(E,C,j,T){super(),this.f=this.B(new f.$Ud),this.g=this.B(new f.$Ud),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:j?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new g(this,C,j,T,this.f,(F,G)=>this.m(F,G))),this.B(this.a.onError(F=>{console.error(F),(0,S.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new y.$Oh,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let C=0;for(;C<E.byteLength;)this.a.writeMessage(E.slice(C,Math.min(C+262144,E.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(E,{compressed:C,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let T=2;E.byteLength<126?T+=0:E.byteLength<2**16?T+=2:T+=8;const F=D.$ie.alloc(T),G=C?64:0,J=j&15;if(F.writeUInt8(128|G|J,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let le=1;F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}else{F.writeUInt8(127,1);let le=1;F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(E.byteLength>>>24&255,++le),F.writeUInt8(E.byteLength>>>16&255,++le),F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(D.$ie.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),j=C.readUInt8(0),T=(j&128)>>>7,F=(j&64)>>>6,G=j&15,J=C.readUInt8(1),le=(J&128)>>>7,se=J&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),j=C.readUInt8(1),T=(j&128)>>>7;let F=j&127,G=1;F===126?F=C.readUInt8(++G)*2**8+C.readUInt8(++G):F===127&&(F=C.readUInt8(++G)*0+C.readUInt8(++G)*0+C.readUInt8(++G)*0+C.readUInt8(++G)*0+C.readUInt8(++G)*2**24+C.readUInt8(++G)*2**16+C.readUInt8(++G)*2**8+C.readUInt8(++G));let J=0;T&&(J=C.readUInt8(++G)*2**24+C.readUInt8(++G)*2**16+C.readUInt8(++G)*2**8+C.readUInt8(++G)),this.j.state=3,this.j.readLen=F,this.j.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Uh=h;class g extends l.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$ie.alloc(0)}constructor(E,C,j,T,F,G){super(),this.n=E,this.r=F,this.s=G,this.a=this.B(new f.$Ud),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Ud),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Ud),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new w(this.n,T,j,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(E,C){this.g.push({data:E,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:C}=this.g.shift();if(this.f&&C.compressed){const j=await this.w(this.f,E);this.s(j,C)}else this.s(E,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,C){return new Promise((j,T)=>{E.write(C),E.flush(F=>j(F))})}acceptFrame(E,C,j){this.h.push({data:E,isCompressed:C,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const C=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,C,j){return new Promise((T,F)=>{E.write(C),j&&E.write(D.$ie.fromByteArray([0,0,255,255])),E.flush(G=>T(G))})}}class w extends l.$Tc{get recordedInflateBytes(){return this.j?D.$ie.concat(this.f):D.$ie.alloc(0)}constructor(E,C,j,T){super(),this.h=E,this.j=C,this.a=this.B(new f.$Ud),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(T),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(D.$ie.wrap(F))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=D.$ie.concat(this.g);this.g.length=0,E(C)})}}class c extends l.$Tc{constructor(E,C){super(),this.g=E,this.a=this.B(new f.$Ud),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$ie.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=D.$ie.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),E(C)})}}function t(I,E){if(E===0)return;const C=I.byteLength>>>2;for(let le=0;le<C;le++){const se=I.readUInt32BE(le*4);I.writeUInt32BE(se^E,le*4)}const j=C*4,T=I.byteLength-j,F=E>>>24&255,G=E>>>16&255,J=E>>>8&255;T>=1&&I.writeUInt8(I.readUInt8(j)^F,j),T>=2&&I.writeUInt8(I.readUInt8(j+1)^G,j+1),T>=3&&I.writeUInt8(I.readUInt8(j+2)^J,j+2)}e.$Vh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const I=(0,v.$pg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$Vh?e.$Vh:(0,s.tmpdir)(),C=(0,p.$jc)(E,`vscode-ipc-${I}.sock`);return n(C),C}e.$Wh=r;function i(I,E,C){const T=(0,P.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${C}-${E}-sock`;const F=C.substr(0,4),G=E.substr(0,6);let J;return process.platform!=="darwin"&&e.$Vh&&!process.env.VSCODE_PORTABLE?J=(0,p.$jc)(e.$Vh,`vscode-${T}-${F}-${G}.sock`):J=(0,p.$jc)(I,`${F}-${G}.sock`),n(J),J}e.$Xh=i;function n(I){const E=o[k.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class a extends u.$Ih{static b(E){const C=f.Event.fromNodeEventEmitter(E,"connection");return f.Event.map(C,j=>({protocol:new y.$Ph(new b(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(a.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Yh=a;function m(I){return new Promise((E,C)=>{const j=(0,A.createServer)();j.on("error",C),j.listen(I,()=>{j.removeListener("error",C),E(new a(j))})})}e.$Zh=m;function O(I,E){return new Promise((C,j)=>{const T=(0,A.createConnection)(I,()=>{T.removeListener("error",j),C(y.$Qh.fromSocket(new b(T,`ipc-client${E}`),E))});T.once("error",j)})}e.$1h=O}),define(oe[24],ae([0,1,50,9,4,99,38,90,6]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y9b=e.$X9b=void 0,e.$X9b=(0,f.$6h)(D.$_h);class l extends S.$Am{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,A.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Xh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const k in process.env)if(k.endsWith("_VSCODE_SNAP_ORIG")){const v=k.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[k]?process.env[v]=process.env[k]:delete process.env[v]}}}restoreSnapExportedVariables(){if(s.$k)for(const k in this.d)process.env[k]=this.d[k],delete this.d[k]}}e.$Y9b=l,Ee([P.$wh],l.prototype,"cachedLanguagesPath",null),Ee([P.$wh],l.prototype,"backupHome",null),Ee([P.$wh],l.prototype,"mainIPCHandle",null),Ee([P.$wh],l.prototype,"mainLockfile",null),Ee([P.$wh],l.prototype,"disableUpdates",null),Ee([P.$wh],l.prototype,"crossOriginIsolated",null),Ee([P.$wh],l.prototype,"codeCachePath",null),Ee([P.$wh],l.prototype,"useCodeCache",null)}),define(oe[283],ae([0,1,86,33,13,9,4,19,21,196,18,24,34,16,5,195,30,98]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$D0b=void 0;let g=class{static{h=this}static{this.a="backupWorkspaces"}constructor(c,t,o,r){this.j=c,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$xg,this.i={isEqual:(i,n)=>(0,A.$6f)(i,n,!D.$k)}}async initialize(){const c=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(c.emptyWindows),this.d=await this.u((0,l.$19b)(c)),this.e=await this.v((0,l.$29b)(c)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.$Ok.OFF}q(){return this.s()===u.$Ok.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.$Ok.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(c,t){this.d.some(r=>c.workspace.id===r.workspace.id)||(this.d.push(c),this.C());const o=(0,M.$jc)(this.c,c.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(c,t){if(await f.Promises.exists(c)&&await this.z(c),await f.Promises.exists(t))try{await f.Promises.rename(t,c,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(c){return this.e.some(t=>this.h.isEqual(c.folderUri,t.folderUri))||(this.e.push(c),this.C()),(0,M.$jc)(this.c,this.D(c))}registerEmptyWindowBackup(c){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,c.backupFolder))||(this.g.push(c),this.C()),(0,M.$jc)(this.c,c.backupFolder)}async u(c){if(!Array.isArray(c))return[];const t=new Set,o=[];for(const r of c){const i=r.workspace;if(!(0,$.$hi)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$jc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(c){if(!Array.isArray(c))return[];const t=[],o=new Set;for(const r of c){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!o.has(n)){o.add(n);const a=(0,M.$jc)(this.c,this.D(r));await this.B(a)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(a):await this.x(a)}}return t}async w(c){if(!Array.isArray(c))return[];const t=[],o=new Set;for(const r of c){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,M.$jc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(c){try{await f.Promises.rm(c,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let c=(0,d.$k0b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,c.id));)c=(0,d.$k0b)();return{backupFolder:c.id}}async z(c){const t=this.y(),o=(0,M.$jc)(this.c,t.backupFolder);try{await f.Promises.rename(c,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const c=[];for(const t of this.d)await this.A(t)&&c.push(t);for(const t of this.e)await this.A(t)&&c.push(t);return c}A(c){let t;return(0,l.$Z9b)(c)?t=(0,M.$jc)(this.c,c.backupFolder):(0,b.$mcb)(c)?t=(0,M.$jc)(this.c,this.D(c)):t=(0,M.$jc)(this.c,c.workspace.id),this.B(t)}async B(c){try{const t=await f.Promises.readdir(c);for(const o of t)try{if((await f.Promises.readdir((0,M.$jc)(c,o))).length>0)return!0}catch{}}catch{}return!1}C(){const c={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(h.a,c)}D(c){const t=c.folderUri;let o;return t.scheme===s.Schemas.file?o=D.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,P.createHash)("md5").update(o).digest("hex")}};e.$D0b=g,e.$D0b=g=h=Ee([ne(0,k.$X9b),ne(1,p.$yi),ne(2,y.$mj),ne(3,v.$lO)],g)}),define(oe[20],ae([0,1,15,37,8,3,2,4,36,12,6,5,34,24]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$t0b=e.LifecycleMainPhase=e.ShutdownReason=e.$s0b=void 0,e.$s0b=(0,p.$5h)("lifecycleMainService");var b;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var $;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let d=class extends D.$Tc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(g,w,c){super(),this.F=g,this.G=w,this.H=c,this.c=this.B(new M.$Ud),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Ud),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Ud),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Ud),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const g=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",g);const w=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",w),P.app.once("will-quit",c=>{this.S("Lifecycle#app.on(will-quit) - begin"),c.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",g),P.app.removeListener("window-all-closed",w),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(g){if(this.y)return this.y;const w=this.F;this.S("Lifecycle#onWillShutdown.fire()");const c=[];return this.f.fire({reason:g,join(t,o){w.trace(`Lifecycle#onWillShutdown - begin '${t}'`),c.push(o.finally(()=>{w.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(c)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===g)return;this.S(`lifecycle (main): phase changed (value: ${g})`),this.n=g;const w=this.C.get(this.n);w&&(w.open(),this.C.delete(this.n))}async when(g){if(g<=this.n)return;let w=this.C.get(g);w||(w=new s.$4g,this.C.set(g,w)),await w.wait()}registerWindow(g){const w=new D.$Sc;this.t++,w.add(g.onWillLoad(t=>this.g.fire({window:g,workspace:t.workspace,reason:t.reason})));const c=(0,l.$Sf)(g.win);c.on("close",t=>{const o=g.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${g.id}`),t.preventDefault(),this.unload(g,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(g),g.close()})}),c.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.t--,w.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}registerAuxWindow(g){const w=(0,l.$Sf)(g.win);w.on("close",c=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${g.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),c.preventDefault())}),w.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${g.id}`)})}async reload(g,w){await this.unload(g,3)||g.reload(w)}unload(g,w){const c=this.z.get(g.id);if(c)return c;const t=this.M(g,w).finally(()=>{this.z.delete(g.id)});return this.z.set(g.id,t),t}async M(g,w){if(!g.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${g.id}`);const c=this.j?2:w,t=await this.P(g,c);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.N(t)):(await this.Q(g,c),!1)}N(g){return g?(this.O(!0),this.j=!1,!0):!1}O(g){this.w&&(this.w(g),this.w=void 0,this.u=void 0)}P(g,w){return new Promise(c=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;A.$qU.once(o,()=>{c(!1)}),A.$qU.once(r,()=>{c(!0)}),g.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:w})})}Q(g,w){return new Promise(c=>{const o=`vscode:reply${this.s++}`;A.$qU.once(o,()=>c()),g.send("vscode:onWillUnload",{replyChannel:o,reason:w})})}quit(g){return this.R(g).then(w=>{if(!w&&g)try{if(S.$i){const c=(0,f.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.F.error(c)}return w})}R(g){return this.S(`Lifecycle#quit() - begin (willRestart: ${g})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(g&&this.G.setItem(y.b,!0),this.u=new Promise(w=>{this.w=w,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(g){this.H.args["enable-smoke-test-driver"]?this.F.info(g):this.F.trace(g)}setRelaunchHandler(g){this.D=g}async relaunch(g){this.S("Lifecycle#relaunch()");const w=process.argv.slice(1);if(g?.addArgs&&w.push(...g.addArgs),g?.removeArgs)for(const o of g.removeArgs){const r=w.indexOf(o);r>=0&&w.splice(r,1)}const c=()=>{this.D?.handleRelaunch(g)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:w}))};P.app.once("quit",c),await this.quit(!0)&&P.app.removeListener("quit",c)}async kill(g){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$6g)(1e3),(async()=>{for(const w of P.BrowserWindow.getAllWindows())if(w&&!w.isDestroyed()){let c;w.webContents&&!w.webContents.isDestroyed()?c=new Promise(t=>w.once("closed",t)):c=Promise.resolve(),w.destroy(),await c}})()]),P.app.exit(g)}};e.$t0b=d,e.$t0b=d=y=Ee([ne(0,k.$mj),ne(1,v.$lO),ne(2,u.$X9b)],d)}),define(oe[284],ae([0,1,4,3,2,6,20]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10b=e.$Z0b=void 0,e.$Z0b=(0,M.$5h)("keyboardLayoutMainService");let S=class extends s.$Tc{constructor(p){super(),this.a=this.B(new A.$Ud),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((k,v)=>{Q(["native-keymap"],k,v)});this.c=f(p),P.$t||p.onDidChangeKeyboardLayout(()=>{this.c=f(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$10b=S,e.$10b=S=Ee([ne(0,D.$s0b)],S);function f(l){const p=l.getKeyMap(),k=l.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:k}}}),define(oe[285],ae([0,1,246,8,17,14,12,18,38,94,5,53,245,282]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=void 0;let y=class extends k.$hp{constructor(h,g,w,c){super(c),this.m=h,this.n=g,this.r=w,this.s(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,g){const{f:w,g:c}=this;let t;try{t=await(0,l.$$l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(i)))}const o={...process.env,...t},r=h.agent?h.agent:await(0,v.$lr)(h.url||"",o,{proxyUrl:w,strictSSL:c});return h.agent=r,h.strictSSL=c,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>$(h,g))}async resolveProxy(h){}async loadCertificates(){return(await new Promise((g,w)=>{Q(["@vscode/proxy-agent"],g,w)})).loadSystemCertificates({log:this.r})}};e.$mr=y,e.$mr=y=Ee([ne(0,S.$yi),ne(1,f.$ai),ne(2,p.$mj),ne(3,p.$nj)],y);async function b(d){return((0,P.parse)(d.url).protocol==="https:"?await new Promise((w,c)=>{Q(["https"],w,c)}):await new Promise((w,c)=>{Q(["http"],w,c)})).request}async function $(d,h){return A.Promises.withAsyncBody(async(g,w)=>{const c=(0,P.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await b(d),o={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,D.$Nf)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password);const r=t(o,i=>{const n=(0,D.$Lf)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...d,url:i.headers.location,followRedirects:n-1},h).then(g,w);else{let a=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,u.createGunzip)())),g({res:i,stream:(0,s.$xe)(a)})}});r.on("error",w),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),h.onCancellationRequested(()=>{r.abort(),w(new M.$5)})})}e.$nr=$}),define(oe[286],ae([0,1,15,285]),function(Q,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0;function s(D){return P.net.request}class M extends A.$mr{request(S,f){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$3$b=M}),define(oe[82],ae([0,1,7,3,2,38,16,6,20,5,96,279,41,56,40,13]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0b=e.$A0b=e.$z0b=e.$y0b=void 0,e.$y0b=(0,S.$5h)("storageMainService");let $=class extends s.$Tc{constructor(g,w,c,t,o,r){super(),this.c=g,this.f=w,this.g=c,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new A.$Ud),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this.B(this.h.onWillShutdown(g=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=g.reason,g.join("applicationStorage",this.applicationStorage.close());for(const[,w]of this.t)g.join("profileStorage",w.close());for(const[,w]of this.w)g.join("workspaceStorage",w.close())})),this.B(this.g.onWillCreateProfile(g=>{g.join((async()=>{await this.j.exists(g.profile.globalStorageHome)||await this.j.createFolder(g.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(g=>{const w=this.t.get(g.profile.id);w&&g.join(w.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const g=new k.$v0b(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(g.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),g}profileStorage(g){if((0,p.$wp)(g))return this.applicationStorage;let w=this.t.get(g.id);if(!w){this.c.trace(`StorageMainService: creating profile storage (${g.name})`),w=this.B(this.u(g)),this.t.set(g.id,w);const c=this.B(w.onDidChangeStorage(t=>this.b.fire({...t,storage:w,profile:g})));this.B(A.Event.once(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${g.name})`),this.t.delete(g.id),c.dispose()}))}return w}u(g){return this.a===2?new k.$x0b(this.c,this.j):new k.$u0b(g,this.n(),this.c,this.j)}workspaceStorage(g){let w=this.w.get(g.id);return w||(this.c.trace(`StorageMainService: creating workspace storage (${g.id})`),w=this.B(this.y(g)),this.w.set(g.id,w),this.B(A.Event.once(w.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${g.id})`),this.w.delete(g.id)}))),w}y(g){return this.a===2?new k.$x0b(this.c,this.j):new k.$w0b(g,this.n(),this.c,this.f,this.j)}isUsed(g){const w=P.URI.file(g);for(const c of[this.applicationStorage,...this.t.values(),...this.w.values()])if(c.path&&this.m.extUri.isEqualOrParent(P.URI.file(c.path),w))return!0;return!1}};e.$z0b=$,e.$z0b=$=Ee([ne(0,l.$mj),ne(1,M.$_h),ne(2,u.$c0b),ne(3,f.$s0b),ne(4,D.$pk),ne(5,y.$Zk)],$),e.$A0b=(0,S.$5h)("applicationStorageMainService");let d=class extends p.$vp{constructor(g,w){super(),this.s=g,this.U=w,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(g){if(g===-1)return this.U.applicationStorage.storage}Q(g){if(g===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$B0b=d,e.$B0b=d=Ee([ne(0,v.$2k),ne(1,e.$y0b)],d)}),define(oe[287],ae([0,1,87,26,104,99,8,2,4,18,5,27,241,242,95,127,17]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.$1$b=e.$Z$b=e.$Y$b=void 0;async function d(t,o,r,i,n){let a;for(let m=3;m&&(a?.dispose(),a=await new h(t,o,r,i,n).waitForReady(),!(n&&s.$sg[n]||!s.$sg[a.tunnelLocalPort]));m--);return a}class h extends S.$Tc{constructor(o,r,i,n,a){super(),this.m=r,this.n=a,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=P.createServer(),this.c=new D.$4g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.r(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,b.$Gv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$tg)(o,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,b.$Ev)(this.tunnelRemoteHost)||(0,b.$Gv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$kl)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&o.write(a.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Th?n.socket.destroy():n.end()}),n instanceof M.$Th?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write($.$ie.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$Y$b=h;let g=class extends b.$Jv{constructor(o,r,i,n,a){super(r,a),this.v=o,this.w=i,this.y=n}isPortPrivileged(o){return(0,b.$Hv)(o,this.m,f.OS,A.release())}t(o,r,i,n,a,m,O,I){const E=this.s(r,i);if(E)return++E.refcount,E.value;if((0,b.$Bv)(o))return this.u(o,r,i,a,m,O,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${a}.`);const C={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},j=d(C,n,r,i,a);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,j),j}}};e.$Z$b=g,e.$Z$b=g=Ee([ne(0,u.$el),ne(1,p.$mj),ne(2,y.$hl),ne(3,k.$Ej),ne(4,l.$yi)],g);let w=class extends g{constructor(o,r,i,n,a){super(o,r,i,n,a)}};e.$1$b=w,e.$1$b=w=Ee([ne(0,u.$el),ne(1,p.$mj),ne(2,y.$hl),ne(3,k.$Ej),ne(4,l.$yi)],w);let c=class extends S.$Tc{constructor(o,r,i,n,a){super(),this.b=o,this.c=r,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(o,r,i,n,a,m,O,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${m}.`),!this.a.has(o)){const C=new w(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,n,a,m,O,I,E)}};e.$2$b=c,e.$2$b=c=Ee([ne(0,u.$el),ne(1,p.$mj),ne(2,k.$Ej),ne(3,y.$hl),ne(4,l.$yi)],c)}),define(oe[100],ae([0,1,8,23,3,18,24,20,5,27,53,49]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=e.$k$b=void 0;function v(y,b,$){return`${$.updateUrl}/api/update/${y}/${b}/${$.commit}`}e.$k$b=v;let u=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,$,d,h,g,w){this.f=b,this.g=$,this.h=d,this.i=h,this.j=g,this.k=w,this.b=k.$oV.Uninitialized,this.c=new s.$Ud,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(k.$oV.Disabled(0));return}if(this.h.disableUpdates){this.d(k.$oV.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(k.$oV.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),$=this.m(b);if(!$){this.d(k.$oV.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s($),!this.a){this.d(k.$oV.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const d=new URL(this.a);d.searchParams.set("prss","true"),this.a=d.toString()}if(this.d(k.$oV.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,d=>this.j.error(d))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,P.$6g)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch($){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error($);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$l$b=u,e.$l$b=u=Ee([ne(0,S.$s0b),ne(1,M.$yi),ne(2,D.$X9b),ne(3,p.$gp),ne(4,f.$mj),ne(5,l.$Ej)],u)}),define(oe[288],ae([0,1,15,50,3,45,2,18,24,20,5,27,53,28,49,100]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=void 0;let $=class extends b.$l$b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(h,g)=>g)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(h,g,w)=>({url:g,version:w,productVersion:w}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(h,g,w,c)=>({releaseNotes:g,version:w,productVersion:w,date:c}))}constructor(h,g,w,c,t,o,r){super(h,g,c,t,o,r),this.z=w,this.u=new D.$Sc,h.setRelaunchHandler(this)}handleRelaunch(h){return h?.addArgs||h?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(h){this.z.publicLog2("update:error",{messageHash:String((0,M.$Si)(String(h)))}),this.j.error("UpdateService error:",h);const g=this.state.type==="checking for updates"&&this.state.explicit?h:void 0;this.d(y.$oV.Idle(1,g))}s(h){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const w=(0,b.$k$b)(g,h,this.k);try{P.autoUpdater.setFeedURL({url:w})}catch(c){this.j.error("Failed to set update feed URL",c);return}return w}t(h){this.d(y.$oV.CheckingForUpdates(h)),P.autoUpdater.checkForUpdates()}E(h){this.state.type==="checking for updates"&&this.d(y.$oV.Downloading(h))}F(h){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:h.version}),this.d(y.$oV.Ready(h)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(y.$oV.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$m$b=$,Ee([A.$wh],$.prototype,"v",null),Ee([A.$wh],$.prototype,"w",null),Ee([A.$wh],$.prototype,"x",null),Ee([A.$wh],$.prototype,"y",null),e.$m$b=$=Ee([ne(0,l.$s0b),ne(1,S.$yi),ne(2,u.$tl),ne(3,f.$X9b),ne(4,v.$gp),ne(5,p.$mj),ne(6,k.$Ej)],$)}),define(oe[289],ae([0,1,48,46,8,3,9,24,20,5,28,49]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$b=void 0;let v=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,$,d){if(this.f=b,this.g=d,this.a=k.$oV.Uninitialized,this.b=new M.$Ud,this.onStateChange=this.b.event,$.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(k.$oV.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(b=60*60*1e3){return(0,s.$6g)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};v=Ee([ne(0,f.$s0b),ne(1,S.$X9b),ne(2,l.$mj)],v);let u=class extends v{constructor(b,$,d,h,g,w){super(d,h,g),this.o=b,this.p=$,this.q=w;const c=(0,A.watch)(D.$mc(this.o)),t=M.Event.fromNodeEventEmitter(c,"change",(n,a)=>a),o=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(o,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));d.onWillShutdown(()=>{i.dispose(),c.close()})}m(){this.d(k.$oV.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(k.$oV.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.$oV.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.$oV.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((d,h)=>(0,A.realpath)(`${D.$mc(this.o)}/current`,(g,w)=>g?h(g):d(w))),$=D.$nc(b);return this.p!==$}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$o$b=u,e.$o$b=u=Ee([ne(2,f.$s0b),ne(3,S.$X9b),ne(4,l.$mj),ne(5,p.$tl)],u)}),define(oe[29],ae([0,1,4,6,60,70,27,18,24,9,65,137]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=e.$a0b=e.$_9b=e.OpenContext=e.$$9b=void 0,e.$$9b=(0,A.$5h)("windowsMainService");var v;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(v||(e.OpenContext=v={}));function u($,d,h){const g=$.get(M.$79b),w=$.get(D.$Ej),c=$.get(S.$yi),t=$.get(f.$X9b),o=c.getValue("window"),r={backgroundColor:g.getBackgroundColor(),minWidth:s.$MC.WIDTH,minHeight:s.$MC.HEIGHT,title:w.nameLong,...h,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$VC)(d?.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...h?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(d&&(r.x=d.x,r.y=d.y,r.width=d.width,r.height=d.height),P.$k?r.icon=(0,l.$jc)(t.appRoot,"resources/linux/code.png"):P.$i&&!t.isBuilt&&(r.icon=(0,l.$jc)(t.appRoot,"resources/win32/code_150x150.png")),P.$j&&(r.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(r.acceptFirstMouse=!1)),P.$j&&!(0,s.$UC)(c)&&(r.fullscreenable=!1),P.$j&&o?.nativeTabs===!0&&(r.tabbingIdentifier=w.nameShort),(0,s.$SC)(c)==="custom"&&(r.titleBarStyle="hidden",P.$j||(r.frame=!1),(0,s.$TC)(c))){const a=g.getWindowSplash()?.colorInfo.titleBarBackground??g.getBackgroundColor(),m=k.$lt.fromHex(a).isDarker()?"#FFFFFF":"#000000";r.titleBarOverlay={height:29,color:a,symbolColor:m}}return r}e.$_9b=u;function y($){const d=$.get(e.$$9b),h=$.get(p.$99b),g=d.getFocusedWindow()??h.getFocusedWindow();if(g)return g;const w=d.getLastActiveWindow(),c=h.getLastActiveWindow();return w&&c?w.lastFocusTime<c.lastFocusTime?c:w:w??c}e.$a0b=y;function b($){let d,h=Number.MIN_VALUE;for(const g of $)g.lastFocusTime>h&&(h=g.lastFocusTime,d=g);return d}e.$b0b=b}),define(oe[290],ae([0,1,15,23,3,45,2,32,117,5,82,29]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=void 0;var v;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let u=class extends D.$Tc{constructor(b,$,d,h){super(),this.g=b,this.h=$,this.j=d,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const b=s.Event.fromNodeEventEmitter(P.app,"login",($,d,h,g,w)=>({event:$,webContents:d,req:h,authInfo:g,callback:w}));this.B(b(this.r,this))}async r({event:b,authInfo:$,req:d,callback:h}){if(!$.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&d.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let g;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{g=await this.b}finally{this.b=void 0}}h(g?.username,g?.password)}async s(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(b);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const $=String((0,M.$Si)({scheme:b.scheme,host:b.host,port:b.port}));let d,h;try{const t=this.m.get(this.a+$,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));d=o.username,h=o.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof d=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:d,password:h};const g=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!g){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const w={authInfo:b,username:this.f?.username??d,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,S.$pg)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,w),this.c=v.LoginDialogShown;const c=await new Promise(t=>{const o=async(r,i,n)=>{if(i===w.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",o),n){const a={username:n.username,password:n.password};try{if(n.remember){const m=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+$,m,-1,1)}else this.m.remove(this.a+$,-1)}catch(m){this.g.error(m)}t({username:a.username,password:a.password})}else t(void 0)};g.win?.webContents.on("ipc-message",o)});return this.f=c,c}};e.$C0b=u,e.$C0b=u=Ee([ne(0,l.$mj),ne(1,k.$$9b),ne(2,f.$_U),ne(3,p.$A0b)],u)}),define(oe[291],ae([0,1,15,22,4,7,21,18,64,6,5,128,29]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=e.$30b=e.ID=void 0,e.ID="launchMainService",e.$30b=(0,l.$5h)(e.ID);let u=class{constructor(b,$,d,h){this.a=b,this.b=$,this.c=d,this.d=h}async start(b,$){this.a.trace("Received data from other instance: ",b,$),s.$j&&P.app.focus({steal:!0});const d=this.e(b);if(d.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const g=(0,A.$Ob)(await this.b.openEmptyWindow({context:4}));g&&(h=g.ready())}h.then(()=>{for(const{uri:g,originalUrl:w}of d)this.c.open(g,{originalUrl:w})})}else return this.f(b,$)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,A.$Hb)(b._urls.map($=>{try{return{uri:M.URI.parse($),originalUrl:$}}catch{return null}})):[]}async f(b,$){const d=(0,f.$5l)($)?0:4;let h=[];const g=b.wait&&b.waitMarkerFilePath?M.URI.file(b.waitMarkerFilePath):void 0,w=b.remote||void 0,c={context:d,cli:b,userEnv:$,waitMarkerFileURI:g,remoteAuthority:w,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,c);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||c.forceProfile||c.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)h=await this.b.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,c),h=[o]):h=await this.b.open({...c,forceEmpty:!0})}}else h=await this.b.open({...c,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(g&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,D.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$40b=u,e.$40b=u=Ee([ne(0,p.$mj),ne(1,v.$$9b),ne(2,k.$fV),ne(3,S.$yi)],u)}),define(oe[292],ae([0,1,2,20,56,30,8,29]),function(Q,e,P,A,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=void 0;let f=class extends P.$Tc{constructor(p,k,v){super(),this.a=k,this.b=v,this.B(p.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(p.onBeforeCloseWindow(u=>this.c(u))),this.B(new D.$eh(()=>this.g(),30*1e3)).schedule()}async c(p){const k=this.f(p),v=this.a.getProfileForWorkspace(k);v?.isTransient&&(this.a.unsetWorkspace(k,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,M.$gi)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const k=this.b.getWindows().map(v=>this.f(v));for(const v of p)k.some(u=>u.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$G$b=f,e.$G$b=f=Ee([ne(0,A.$s0b),ne(1,s.$c0b),ne(2,S.$$9b)],f)}),define(oe[61],ae([0,1,15,2,3,5,312,8,13,29,74,28,20,76,35,4,132]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$G0b=e.$F0b=void 0;function h(c){return typeof c.responseWindowId=="number"}let g=class extends A.$Tc{static{d=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(d.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++d.a),this.f=this.B(new s.$Ud),this.onStdout=this.f.event,this.g=this.B(new s.$Ud),this.onStderr=this.g.event,this.h=this.B(new s.$Ud),this.onMessage=this.h.event,this.j=this.B(new s.$Ud),this.onSpawn=this.j.event,this.m=this.B(new s.$Ud),this.onExit=this.m.event,this.n=this.B(new s.$Ud),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case p.default.Error:this.u.error(r);break;case p.default.Warning:this.u.warn(r);break;case p.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=f.$ng.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],n=this.t.execArgv??[],a=this.t.allowLoadingUnsignedLibraries,m=this.t.forceAllocationsToV8Sandbox,O="pipe",I=this.F(t);return this.z("creating new...",p.default.Info),this.r=P.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:m,stdio:O}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,y.$un)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,b.$i&&((0,$.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,$.getUNCHostAllowlist)().join("\\")),(0,u.$Rl)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&d.b.set(t.pid,{pid:t.pid,name:h(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",p.default.Info),this.j.fire(t.pid)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,p.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,p.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",p.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",p.default.Info),this.r.kill()?(this.z("successfully killed the process",p.default.Info),this.H()):this.z("unable to kill the process",p.default.Warning)}H(){typeof this.s=="number"&&d.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",p.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$6g)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,p.default.Info),this.kill()))}};e.$F0b=g,e.$F0b=g=d=Ee([ne(0,M.$mj),ne(1,k.$tl),ne(2,v.$s0b)],g);let w=class extends g{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$G0b=w,e.$G0b=w=Ee([ne(0,M.$mj),ne(1,l.$$9b),ne(2,k.$tl),ne(3,v.$s0b)],w)}),define(oe[293],ae([0,1,14,3,5,20,8,61,29,28]),function(Q,e,P,A,s,M,D,S,f,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$N0b=void 0;let k=class{static{p=this}static{this.a=0}constructor(u,y,b,$){this.d=u,this.f=y,this.g=b,this.h=$,this.b=new Map,this.c=!1,this.f.onWillShutdown(d=>{this.c=!0,d.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(u){const y=this.b.get(u);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(u){return this.i(u).onStdout}onDynamicStderr(u){return this.i(u).onStderr}onDynamicMessage(u){return this.i(u).onMessage}onDynamicExit(u){return this.i(u).onExit}async createExtensionHost(){if(this.c)throw(0,P.$6)();const u=String(++p.a),y=new S.$G0b(this.d,this.g,this.h,this.f);return this.b.set(u,y),y.onExit(({pid:b,code:$,signal:d})=>{this.d.info(`Extension host with pid ${b} exited with code: ${$}, signal: ${d}.`),setTimeout(()=>{y.dispose(),this.b.delete(u)}),setTimeout(()=>{try{process.kill(b,0),this.d.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)}),{id:u}}async start(u,y){if(this.c)throw(0,P.$6)();const b=this.i(u);return b.start({...y,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:y.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:u}),{pid:await A.Event.toPromise(b.onSpawn)}}async enableInspectPort(u){if(this.c)throw(0,P.$6)();const y=this.b.get(u);return y?y.enableInspectPort():!1}async kill(u){if(this.c)throw(0,P.$6)();const y=this.b.get(u);y&&y.kill()}async _killAllNow(){for(const[,u]of this.b)u.kill()}async _waitForAllExit(u){const y=[];for(const[,b]of this.b)y.push(b.waitForExit(u));return D.Promises.settled(y).then(()=>{})}};e.$N0b=k,e.$N0b=k=p=Ee([ne(0,s.$mj),ne(1,M.$s0b),ne(2,f.$$9b),ne(3,l.$tl)],k)}),define(oe[294],ae([0,1,37,8,2,24,20,5,41,39,69,61,54,90,12,247]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;let $=class extends s.$Tc{constructor(h,g,w,c,t,o,r,i){super(),this.c=h,this.f=g,this.g=w,this.h=c,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new A.$4g,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$qU.on(b.$c$b.request,(h,g)=>this.t(h,g,b.$c$b.response)),P.$qU.on(b.$d$b.request,(h,g)=>this.t(h,g,b.$d$b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(h,g,w){this.m.trace(`[SharedProcess] onWindowConnection for: ${w}`),this.a.isOpen()||this.a.open(),await this.whenReady();const c=await this.connect(w);if(h.sender.isDestroyed())return c.close();h.sender.postMessage(w,g,[c])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(b.$b$b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const h=new A.$ph;this.b?this.b.once(b.$b$b.initDone,()=>h.complete()):P.$qU.once(b.$b$b.initDone,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const h=new A.$ph;this.b?this.b.once(b.$b$b.ipcReady,()=>h.complete()):P.$qU.once(b.$b$b.ipcReady,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new k.$F0b(this.m,v.$Lo,this.j));const h=(0,u.$Cm)(this.g.args,this.g.isBuilt);let g;h.port&&(g=["--nolazy"],h.break?g.push(`--inspect-brk=${h.port}`):g.push(`--inspect=${h.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:g})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(h){return await this.z,(0,y.$Sf)(this.b).connect(h)}};e.$e$b=$,e.$e$b=$=Ee([ne(2,M.$X9b),ne(3,f.$2k),ne(4,D.$s0b),ne(5,S.$mj),ne(6,p.$n0b),ne(7,l.$In)],$)}),define(oe[295],ae([0,1,24,90,20,5,54,61,111,37,2,3,35,18,13]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=void 0;let b=class extends p.$Tc{constructor(d,h,g,w,c){super(),this.f=d,this.g=h,this.h=g,this.j=w,this.m=c,this.a=void 0,this.b=new k.$Ud,this.onRequestConnection=this.b.event,this.c=new k.$Ud,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$qU.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,p.$Rc)(()=>{l.$qU.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$F0b(this.m,D.$Lo,this.j);const d=(0,A.$Bm)(this.h.args,this.h.isBuilt),h=d.port?["--nolazy",`--inspect${d.break?"-brk":""}=${d.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const g=this.a.connect(),w=new f.$yU(g,"ptyHost"),c=new p.$Sc;return c.add(w),c.add((0,p.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:w,store:c,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const d={...(0,v.$un)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(d.VSCODE_LATENCY=String(h));const g=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return g&&typeof g=="number"&&(d.VSCODE_STARTUP_DELAY=String(g)),this.h.restoreSnapExportedVariables(),d}r(d,h){this.b.fire();const g=this.a.connect();if(d.sender.isDestroyed()){g.close();return}d.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[g])}};e.$Q$b=b,e.$Q$b=b=Ee([ne(1,u.$yi),ne(2,P.$X9b),ne(3,s.$s0b),ne(4,M.$mj)],b)}),define(oe[296],ae([0,1,2,6,5,29,61,28,45,3,8,20]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=e.$O$b=void 0,e.$O$b=(0,A.$5h)("utilityProcessWorker");let v=class extends P.$Tc{constructor(b,$,d,h){super(),this.b=b,this.c=$,this.f=d,this.g=h,this.a=new Map}async createWorker(b){const $=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${$})`);const d=this.h(b);this.a.has(d)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${$})`),this.disposeWorker(b));const h=new u(this.b,this.c,this.f,this.g,b);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(d,h);const g=new p.$ph;return l.Event.once(h.onDidTerminate)(w=>{w.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${w.code}, signal: ${w.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${w.code}, signal: ${w.signal}`),this.a.delete(d),g.complete({reason:w})}),g.p}h(b){return(0,f.$Si)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const $=this.h(b),d=this.a.get($);d&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),d.kill(),this.a.delete($))}};e.$P$b=v,e.$P$b=v=Ee([ne(0,s.$mj),ne(1,M.$$9b),ne(2,S.$tl),ne(3,k.$s0b)],v);let u=class extends P.$Tc{constructor(b,$,d,h,g){super(),this.c=b,this.f=$,this.g=d,this.h=h,this.j=g,this.a=this.B(new l.$Ud),this.onDidTerminate=this.a.event,this.b=new D.$G0b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const $=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:$,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};u=Ee([ne(0,s.$mj),ne(1,M.$$9b),ne(2,S.$tl),ne(3,k.$s0b)],u)}),define(oe[297],ae([0,1,15,3,2,273,29]),function(Q,e,P,A,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=void 0;let S=class extends s.$Tc{constructor(l){super(),this.b=l,this.a=this.B(new A.$Ud),this.onFoundInFrame=this.a.event,this.B(new M.$v$b)}async setIgnoreMenuShortcuts(l,p){let k;if(typeof l.windowId=="number"){const{windowId:v}=l,u=this.b.getWindowById(v);if(!u?.win)throw new Error(`Invalid windowId: ${v}`);k=u.win.webContents}else{const{webContentsId:v}=l;if(k=P.webContents.fromId(v),!k)throw new Error(`Invalid webContentsId: ${v}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(p)}async findInFrame(l,p,k,v){const y=this.c(l,p);if(typeof y.findInFrame=="function"){y.findInFrame(k,{findNext:v.findNext,forward:v.forward});const b=($,d)=>{d.finalUpdate&&(this.a.fire(d),y.removeListener("found-in-frame",b))};y.on("found-in-frame",b)}}async stopFindInFrame(l,p,k){const u=this.c(l,p);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}c(l,p){const k=this.b.getWindowById(l.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${l}`);const v=k.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===p);if(!v)throw new Error(`Unknown frame: ${p}`);return v}};e.$w$b=S,e.$w$b=S=Ee([ne(0,D.$$9b)],S)}),define(oe[298],ae([0,1,15,2,4,19,7,18,20,5,34,29,129,30]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=e.$y$b=e.$x$b=void 0;let b=class extends A.$Tc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(c,t,o,r,i){super(),this.g=c,this.h=t,this.j=o,this.m=r,this.n=i,this.b=$(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(c=>this.u(c)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(c=>this.u(c))}s(){this.f=!0,this.t()}t(){const c=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&c.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(c.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):c.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(c.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):c.add(n.uiState.display)),n}));const r=h(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(c){if(this.j.quitRequested)return;const t=this.w(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,u.$hi)(c.openedWorkspace)&&o.workspace?.id===c.openedWorkspace.id,i=(0,u.$ci)(c.openedWorkspace)&&o.folderUri&&M.$xg.isEqual(o.folderUri,c.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(c){return{windowId:c.id,workspace:(0,u.$hi)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,u.$ci)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const t=this.z(c),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(c){const t=this.g.getLastActiveWindow();if(!c.extensionTestsPath){if(c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const m=c.workspace;if((0,u.$hi)(m)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===m.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,u.$ci)(m)){const I=this.state.openedWindows.filter(E=>E.folderUri&&M.$xg.isEqual(E.folderUri,m.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(c.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===c.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const O=this.c||this.state.lastActiveWindow;if(!t&&O)return O.uiState}let o;const r=P.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const m=P.screen.getCursorScreenPoint();o=P.screen.getDisplayNearestPoint(m)}!o&&t&&(o=P.screen.getDisplayMatching(t.getBounds())),o||(o=P.screen.getPrimaryDisplay()||r[0])}let i=(0,v.$W9b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const m=t.serializeWindowState();m.mode===3?i.mode=3:i={...m,zoomLevel:void 0},a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(c){if(this.g.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===c.x||o.y===c.y);)c.x+=30,c.y+=30;return c}};e.$x$b=b,e.$x$b=b=y=Ee([ne(0,k.$$9b),ne(1,p.$lO),ne(2,f.$s0b),ne(3,l.$mj),ne(4,S.$yi)],b);function $(w){const c={openedWindows:[]},t=w||{openedWindows:[]};return t.lastActiveWindow&&(c.lastActiveWindow=d(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=d(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(c.openedWindows=t.openedWindows.map(o=>d(o))),c}e.$y$b=$;function d(w){const c={uiState:w.uiState};return w.backupPath&&(c.backupPath=w.backupPath),w.remoteAuthority&&(c.remoteAuthority=w.remoteAuthority),w.folder&&(c.folderUri=D.URI.parse(w.folder)),w.workspaceIdentifier&&(c.workspace={id:w.workspaceIdentifier.id,configPath:D.URI.parse(w.workspaceIdentifier.configURIPath)}),c}function h(w){return{lastActiveWindow:w.lastActiveWindow&&g(w.lastActiveWindow),lastPluginDevelopmentHostWindow:w.lastPluginDevelopmentHostWindow&&g(w.lastPluginDevelopmentHostWindow),openedWindows:w.openedWindows.map(c=>g(c))}}e.$z$b=h;function g(w){return{workspaceIdentifier:w.workspace&&{id:w.workspace.id,configURIPath:w.workspace.configPath.toString()},folder:w.folderUri&&w.folderUri.toString(),backupPath:w.backupPath,remoteAuthority:w.remoteAuthority,uiState:w.uiState}}}),define(oe[57],ae([0,1,15,3,42,2,13,9,19,21,194,66,55,24,6,5,56,131,30,97,98]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m0b=e.$l0b=void 0,e.$l0b=(0,y.$5h)("workspacesManagementMainService");let c=class extends M.$Tc{constructor(o,r,i,n,a){super(),this.g=o,this.h=r,this.j=i,this.m=n,this.n=a,this.a=this.B(new A.$Ud),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$Ud),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await l.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,f.$Gg)(this.c,r,h.$ri));for(const r of o){const i=(0,w.$i0b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>l.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===D.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(n=>this.t(o,n),n=>{}):this.t(o,i)}catch{return}}s(o){return(0,h.$si)(o,this.g)||(0,h.$xi)(o)}t(o,r){try{const i=this.u(o,r),n=(0,w.$i0b)(o);return{id:n.id,configPath:n.configPath,folders:(0,g.$ucb)(i.folders,n.configPath,f.$xg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,s.$bn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,g.$scb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:n}=this.w(o,r),a=i.configPath.fsPath;return await l.Promises.mkdir((0,S.$mc)(a),{recursive:!0}),await l.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$Gg)(this.c,i),a=(0,f.$Gg)(n,h.$ri),m=[];for(const O of o)m.push((0,g.$tcb)(O.uri,!0,O.name,n,f.$xg));return{workspace:(0,w.$i0b)(a),storedWorkspace:{folders:m,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,w.$i0b)(o)}isUntitledWorkspace(o){return(0,h.$si)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,f.$ug)(o.configPath);try{await l.Promises.rm((0,S.$mc)(r));const i=(0,S.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,o.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,S.$jc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const a=await this.C(o,(0,w.$i0b)(i));if(a)return this.b.fire({window:o,workspace:a.workspace}),a}async z(o,r,i){return i?(0,h.$hi)(o.openedWorkspace)&&f.$xg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,d.$f0b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,f.$Dg)(i)),detail:(0,p.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,h.$hi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$m0b=c,e.$m0b=c=Ee([ne(0,u.$X9b),ne(1,b.$mj),ne(2,$.$c0b),ne(3,k.$39b),ne(4,v.$49b)],c)}),define(oe[133],ae([0,1,15,37,23,6,29,30,57,12,5,61]),function(Q,e,P,A,s,M,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=e.$I0b=e.ID=void 0,e.ID="diagnosticsMainService",e.$I0b=(0,M.$5h)(e.ID);let v=class{constructor(y,b,$){this.a=y,this.b=b,this.c=$}async getRemoteDiagnostics(y){const b=this.a.getWindows();return(await Promise.all(b.map(async d=>{const h=d.remoteAuthority;if(!h)return;const g=`vscode:getDiagnosticInfoResponse${d.id}`,w={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(d):void 0};return new Promise(c=>{d.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:g,args:w}),A.$qU.once(g,(t,o)=>{o||c({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),c(o)}),setTimeout(()=>{c({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(d=>!!d)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const $ of P.BrowserWindow.getAllWindows()){const d=this.a.getWindowById($.id);d?y.push(await this.d(d)):y.push(this.e($))}const b=[];for(const{pid:$,name:d}of k.$F0b.getAll())b.push({pid:$,name:d});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:b,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(y){const b=await this.f(y),$=(0,l.$Sf)(y.win);return this.e($,b,y.remoteAuthority)}e(y,b=[],$){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:b,remoteAuthority:$}}async f(y){const b=[],$=y.openedWorkspace;if((0,S.$ci)($))b.push($.uri);else if((0,S.$hi)($)){const d=await this.b.resolveLocalWorkspace($.configPath);d&&d.folders.forEach(g=>{b.push(g.uri)})}return b}};e.$J0b=v,e.$J0b=v=Ee([ne(0,D.$$9b),ne(1,f.$l0b),ne(2,p.$mj)],v)}),define(oe[71],ae([0,1,48,15,26,156,50,3,2,13,9,4,7,106,88,21,104,182,55,24,6,20,5,27,70,29,30,57,17,243,235,65,14]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o,r,i,n,a,m,O,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=e.$W0b=void 0,e.$W0b=(0,w.$5h)("nativeHostMainService");let j=class extends f.$Tc{constructor(F,G,J,le,se,ue,Z,X,H,L){super(),this.a=F,this.b=G,this.c=J,this.f=le,this.g=se,this.h=ue,this.j=Z,this.m=X,this.n=H,this.r=L,this.onDidOpenMainWindow=S.Event.map(this.a.onDidOpenWindow,W=>W.id),this.onDidTriggerWindowSystemContextMenu=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:W,x:V,y:q})=>({windowId:W.id,x:V,y:q})),({windowId:W})=>!!this.a.getWindowById(W)),S.Event.filter(S.Event.map(this.b.onDidTriggerSystemContextMenu,({window:W,x:V,y:q})=>({windowId:W.id,x:V,y:q})),({windowId:W})=>!!this.b.getWindowById(W))),this.onDidMaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidMaximizeWindow,W=>W.id),W=>!!this.a.getWindowById(W)),S.Event.filter(S.Event.map(this.b.onDidMaximizeWindow,W=>W.id),W=>!!this.b.getWindowById(W))),this.onDidUnmaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidUnmaximizeWindow,W=>W.id),W=>!!this.a.getWindowById(W)),S.Event.filter(S.Event.map(this.b.onDidUnmaximizeWindow,W=>W.id),W=>!!this.b.getWindowById(W))),this.onDidChangeWindowFullScreen=S.Event.any(S.Event.map(this.a.onDidChangeFullScreen,W=>W.id),S.Event.map(this.b.onDidChangeFullScreen,W=>W.id)),this.onDidBlurMainWindow=S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(W,V)=>V.id),W=>!!this.a.getWindowById(W)),this.onDidFocusMainWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),W=>!!W),W=>W.id),S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(W,V)=>V.id),W=>!!this.a.getWindowById(W))),this.onDidBlurMainOrAuxiliaryWindow=S.Event.any(this.onDidBlurMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(W,V)=>V),W=>(0,E.$09b)(W.webContents)),W=>W.id)),this.onDidFocusMainOrAuxiliaryWindow=S.Event.any(this.onDidFocusMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(W,V)=>V),W=>(0,E.$09b)(W.webContents)),W=>W.id)),this.onDidResumeOS=S.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new S.$Ud),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(W,V,q)=>q),W=>!(Array.isArray(W)&&W.length===1&&W[0]==="workArea")),S.Event.fromNodeEventEmitter(A.screen,"display-added"),S.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,G){const J=this.a.getWindows().map(se=>({id:se.id,workspace:se.openedWorkspace??(0,n.$gi)(se.backupPath,se.isExtensionDevelopmentHost),title:se.win?.getTitle()??"",filename:se.getRepresentedFilename(),dirty:se.isDocumentEdited()})),le=[];return G.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(se=>({id:se.id,parentId:se.parentId,title:se.win?.getTitle()??"",filename:se.getRepresentedFilename()}))),[...J,...le]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const G=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(G)return G.id}openWindow(F,G,J){return Array.isArray(G)?this.t(F,G,J):this.u(F,G)}async t(F,G,J=Object.create(null)){G.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:G,cli:this.g.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0,forceProfile:J.forceProfile,forceTempProfile:J.forceTempProfile})}async u(F,G){await this.a.openEmptyWindow({context:5,contextWindowId:F},G)}async toggleFullScreen(F,G){this.D(G?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,G){this.D(G?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const G=A.screen.getCursorScreenPoint(),J=A.screen.getDisplayNearestPoint(G);return{point:G,display:J.bounds}}async isMaximized(F,G){return this.D(G?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,G){this.D(G?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,G){this.D(G?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,G){this.D(G?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,G){this.D(G?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,G,J){const le=this.D(J?.targetWindowId,F);if(le?.win){if(le.win.isFullScreen()){const se=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await se}le.win.setBounds(G)}}async updateWindowControls(F,G){this.D(G?.targetWindowId,F)?.updateWindowControls(G)}async focusWindow(F,G){this.D(G?.targetWindowId,F)?.focus({force:G?.force??!1})}async setMinimumSize(F,G,J){const le=this.F(F);if(le?.win){const[se,ue]=le.win.getSize(),[Z,X]=le.win.getMinimumSize(),[H,L]=[G??Z,J??X],[W,V]=[Math.max(se,H),Math.max(ue,L)];(Z!==H||X!==L)&&le.win.setMinimumSize(H,L),(se!==W||ue!==V)&&le.win.setSize(W,V)}}async saveWindowSplash(F,G){this.m.saveWindowSplash(F,G)}async installShellCommand(F){const{source:G,target:J}=await this.w();try{const{symbolicLink:le}=await b.SymlinkSupport.stat(G);if(le&&!le.dangling){const se=await(0,u.$uq)(G);if(J===se)return}await b.Promises.unlink(G)}catch(le){if(le.code!=="ENOENT")throw le}try{await b.Promises.symlink(J,G)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:se}=await this.showMessageBox(F,{type:"info",message:(0,d.localize)(0,null,this.j.nameShort),buttons:[(0,d.localize)(1,null),(0,d.localize)(2,null)]});if(se===1)throw new C.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${G}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ue)}catch{throw new Error((0,d.localize)(3,null,G))}}}async uninstallShellCommand(F){const{source:G}=await this.w();try{await b.Promises.unlink(G)}catch(J){switch(J.code){case"EACCES":{const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,d.localize)(4,null,this.j.nameShort),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]});if(le===1)throw new C.$5;try{const se=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(se)}catch{throw new Error((0,d.localize)(7,null,G))}break}case"ENOENT":break;default:throw J}}}async w(){const F=(0,p.$kc)(this.g.appRoot,"bin","code"),G=`/usr/local/bin/${this.j.applicationName}`;if(!await b.Promises.exists(F))throw new Error((0,d.localize)(8,null,F));return{source:G,target:F}}async showMessageBox(F,G){const J=this.H(F);return this.c.showMessageBox(G,J?.win??void 0)}async showSaveDialog(F,G){const J=this.H(F);return this.c.showSaveDialog(G,J?.win??void 0)}async showOpenDialog(F,G){const J=this.H(F);return this.c.showOpenDialog(G,J?.win??void 0)}async pickFileFolderAndOpen(F,G){const J=await this.c.pickFileFolder(G);J&&await this.z(await Promise.all(J.map(async le=>await b.SymlinkSupport.existsDirectory(le)?{folderUri:v.URI.file(le)}:{fileUri:v.URI.file(le)})),G,F)}async pickFolderAndOpen(F,G){const J=await this.c.pickFolder(G);J&&await this.z(J.map(le=>({folderUri:v.URI.file(le)})),G,F)}async pickFileAndOpen(F,G){const J=await this.c.pickFile(G);J&&await this.z(J.map(le=>({fileUri:v.URI.file(le)})),G,F)}async pickWorkspaceAndOpen(F,G){const J=await this.c.pickWorkspace(G);J&&await this.z(J.map(le=>({workspaceUri:v.URI.file(le)})),G,F)}async z(F,G,J){await this.a.open({context:3,contextWindowId:J,cli:this.g.args,urisToOpen:F,forceNewWindow:G.forceNewWindow})}async showItemInFolder(F,G){A.shell.showItemInFolder(G)}async setRepresentedFilename(F,G,J){this.D(J?.targetWindowId,F)?.setRepresentedFilename(G)}async setDocumentEdited(F,G,J){this.D(J?.targetWindowId,F)?.setDocumentEdited(G)}async openExternal(F,G){return this.g.unsetSnapExportedVariables(),A.shell.openExternal(G),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,G){return A.shell.trashItem(G)}async isAdmin(){let F;return k.$i?F=(await new Promise((G,J)=>{Q(["native-is-elevated"],G,J)}))():F=process.getuid?.()===0,F}async writeElevated(F,G,J,le){const se=await new Promise((ue,Z)=>{Q(["@vscode/sudo-prompt"],ue,Z)});return new Promise((ue,Z)=>{const X=[`"${this.C}"`];le?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${G.fsPath}"`,`"${J.fsPath}"`);const H={name:this.j.nameLong.replace("-",""),icns:k.$j&&this.g.isBuilt?(0,p.$jc)((0,p.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};se.exec(X.join(" "),H,(L,W,V)=>{W&&this.h.trace(`[sudo-prompt] received stdout: ${W}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),L?Z(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return k.$k||k.$i?!1:A.app.runningUnderARM64Translation}get C(){return k.$i?this.g.isBuilt?(0,p.$jc)((0,p.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.bat"):k.$k?this.g.isBuilt?(0,p.$jc)((0,p.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,p.$jc)(this.g.appRoot,"bin","code"):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$9m.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return k.$i&&(0,O.$U0b)()}async killProcess(F,G,J){process.kill(G,J)}async readClipboardText(F,G){return A.clipboard.readText(G)}async writeClipboardText(F,G,J){return A.clipboard.writeText(G,J)}async readClipboardFindText(F){return A.clipboard.readFindText()}async writeClipboardFindText(F,G){return A.clipboard.writeFindText(G)}async writeClipboardBuffer(F,G,J,le){return A.clipboard.writeBuffer(G,Buffer.from(J.buffer),le)}async readClipboardBuffer(F,G){return m.$ie.wrap(A.clipboard.readBuffer(G))}async hasClipboard(F,G,J){return A.clipboard.has(G,J)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,G){this.F(F)?.updateTouchBar(G)}async notifyReady(F){this.F(F)?.setReady()}async relaunch(F,G){return this.f.relaunch(G)}async reload(F,G){const J=this.F(F);if(J){if((0,n.$hi)(J.openedWorkspace)){const le=J.openedWorkspace.configPath;if(le.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.f.reload(J,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(F,G){return this.D(G?.targetWindowId,F)?.win?.close()}async quit(F){const G=this.a.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&G.win?G.win.close():this.f.quit()}async exit(F,G){await this.f.kill(G)}async resolveProxy(F,G){return this.F(F)?.win?.webContents?.session?.resolveProxy(G)}async loadCertificates(F){return(await new Promise((J,le)=>{Q(["@vscode/proxy-agent"],J,le)})).loadSystemCertificates({log:this.h})}findFreePort(F,G,J,le,se=1){return(0,$.$rg)(G,J,le,se)}async openDevTools(F,G){this.H(F)?.win?.webContents.openDevTools(G)}async toggleDevTools(F){this.H(F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,G,J){const le=this.F(F);if(!le||!le.win)throw new Error;return await new I.$V0b(le.win,G,this.h).inspect(J)}async windowsGetStringRegKey(F,G,J,le){if(!k.$i)return;const se=await new Promise((ue,Z)=>{Q(["@vscode/windows-registry"],ue,Z)});try{return se.GetStringRegKey(G,J,le)}catch{return}}D(F,G){return this.F(F)??this.G(F)??this.F(G)}F(F){if(typeof F=="number")return this.a.getWindowById(F)}G(F){if(typeof F=="number")return this.b.getWindowById(F)}H(F){let G=this.r.invokeFunction(i.$a0b);return G||(G=this.D(F)),G}};e.$X0b=j,Ee([D.$wh],j.prototype,"C",null),e.$X0b=j=Ee([ne(0,i.$$9b),ne(1,E.$99b),ne(2,h.$49b),ne(3,c.$s0b),ne(4,g.$X9b),ne(5,t.$mj),ne(6,o.$Ej),ne(7,r.$79b),ne(8,a.$l0b),ne(9,w.$4h)],j)}),define(oe[299],ae([0,1,15,26,8,23,33,2,13,4,7,108,37,180,91,133,55,24,5,71,79,27,80,34,61,60,29]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o,r,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=void 0;const m="issue.processExplorerWindowState";let O=class{static{a=this}static{this.a="#1E1E1E"}constructor(C,j,T,F,G,J,le,se,ue,Z,X){this.g=C,this.h=j,this.i=T,this.j=F,this.k=G,this.l=J,this.m=le,this.n=se,this.o=ue,this.p=Z,this.q=X,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){v.$qU.on("vscode:listProcesses",async C=>{const j=[];try{j.push({name:(0,u.localize)(0,null),rootProcess:await(0,k.$4r)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,y.$Im)(F)?j.push({name:F.hostName,rootProcess:F}):F.processes&&j.push({name:F.hostName,rootProcess:F.processes})})}catch(T){this.i.error(`Listing processes failed: ${T}`)}this.t(C,"vscode:listProcessesResponse",j)}),v.$qU.on("vscode:workbenchCommand",(C,j)=>{const{id:T,from:F,args:G}=j;let J;switch(F){case"processExplorer":J=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}J?.webContents.send("vscode:runAction",{id:T,from:F,args:G})}),v.$qU.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),v.$qU.on("vscode:pidToNameRequest",async C=>{const j=await this.k.getMainDiagnostics(),T=[];for(const F of j.windows)T.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:G}of r.$F0b.getAll())T.push([F,G]);this.t(C,"vscode:pidToNameResponse",T)})}async openReporter(C){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const j=new S.$Sc,T=j.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,T,{backgroundColor:C.styles.backgroundColor,title:(0,u.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:w.default}),this.b.loadURL(f.$ng.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const j=new S.$Sc,T=j.add(this.n.createIPCObjectUrl()),F=this.p.getItem(m,void 0),G=I(F)?F:this.v(this.f,800,500);this.d=this.u(G,T,{backgroundColor:C.styles.backgroundColor,title:(0,u.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:w.default}),this.d.loadURL(f.$ng.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const J=()=>{if(!this.d)return;const le=this.d.getSize(),se=this.d.getPosition();if(!le||!se)return;const ue={width:le[0],height:le[1],x:se[0],y:se[1]};this.p.setItem(m,ue)};this.d.on("moved",J),this.d.on("resized",J)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await P.contentTracing.stopRecording(`${(0,D.$cg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null,C),buttons:[(0,u.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,j)}async $getSystemInfo(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,j)}async $getPerformanceInfo(){try{const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,j)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(6,null),buttons:[(0,u.localize)(7,null),(0,u.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(9,null),buttons:[(0,u.localize)(10,null),(0,u.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const j=this.issueReporterWindowCheck(),T=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return s.Promises.withAsyncBody(async(F,G)=>{const J=new M.$5d;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:T,extensionId:C}),v.$qU.once(T,(le,se)=>{F(p.URI.parse(se))});try{await(0,s.$6g)(5e3),J.cancel(),G(new Error("Timed out waiting for issue reporter URI"))}finally{v.$qU.removeHandler(T)}})}async $getIssueReporterData(C){const j=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataProviderResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const G=new M.$5d;j.sendWhenReady("vscode:triggerIssueDataProvider",G.token,{replyChannel:T,extensionId:C}),v.$qU.once(T,(J,le)=>{F(le)});try{await(0,s.$6g)(5e3),G.cancel(),F("Error: Extension timed out waiting for issue reporter data")}finally{v.$qU.removeHandler(T)}})}async $getIssueReporterTemplate(C){const j=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataTemplateResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const G=new M.$5d;j.sendWhenReady("vscode:triggerIssueDataTemplate",G.token,{replyChannel:T,extensionId:C}),v.$qU.once(T,(J,le)=>{F(le)});try{await(0,s.$6g)(5e3),G.cancel(),F("Error: Extension timed out waiting for issue reporter template")}finally{v.$qU.removeHandler(T)}})}async $getReporterStatus(C,j){const T=[!1,!1],F=this.issueReporterWindowCheck(),G="vscode:triggerReporterStatus",J=new M.$5d;return F.sendWhenReady(G,J.token,{replyChannel:G,extensionId:C,extensionName:j}),await(0,s.$Wg)(new Promise(se=>v.$qU.once("vscode:triggerReporterStatusResponse",(ue,Z)=>se(Z))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),J.cancel()})??T}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,j,...T){C.sender.isDestroyed()||C.sender.send(j,...T)}u(C,j,T,F){const G=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:T.title,backgroundColor:T.backgroundColor||a.a,webPreferences:{preload:f.$ng.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$VC)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return G.setMenuBarVisibility(!1),G}v(C,j,T){let F;const G=P.screen.getAllDisplays();if(G.length===1)F=G[0];else{if(l.$j){const se=P.screen.getCursorScreenPoint();F=P.screen.getDisplayNearestPoint(se)}!F&&C&&(F=P.screen.getDisplayMatching(C.getBounds())),F||(F=P.screen.getPrimaryDisplay()||G[0])}const J=F.bounds,le={width:j,height:T,x:J.x+J.width/2-j/2,y:J.y+J.height/2-T/2};return J.width>0&&J.height>0&&(le.x<J.x&&(le.x=J.x),le.y<J.y&&(le.y=J.y),le.x>J.x+J.width&&(le.x=J.x),le.y>J.y+J.height&&(le.y=J.y),le.width>J.width&&(le.width=J.width),le.height>J.height&&(le.height=J.height)),le}};e.$Y0b=O,e.$Y0b=O=a=Ee([ne(1,d.$X9b),ne(2,h.$mj),ne(3,y.$Hm),ne(4,b.$I0b),ne(5,$.$49b),ne(6,g.$W0b),ne(7,t.$69b),ne(8,c.$Ej),ne(9,o.$lO),ne(10,n.$$9b)],O);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(oe[300],ae([0,1,23,18,24,20,5,71,27,53,28,49,100]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=void 0;let u=class extends v.$l$b{constructor(b,$,d,h,g,w,c,t){super(b,$,h,g,w,t),this.e=d,this.u=c}s(b){return(0,v.$k$b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d(k.$oV.CheckingForUpdates(b)),this.i.request({url:this.a},P.CancellationToken.None).then(l.$mp).then($=>{!$||!$.url||!$.version||!$.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(k.$oV.Idle(1))):this.d(k.$oV.AvailableForDownload($))}).then(void 0,$=>{this.j.error($);const d=b?$.message||$:void 0;this.d(k.$oV.Idle(1,d))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(k.$oV.Idle(1))}};e.$n$b=u,e.$n$b=u=Ee([ne(0,M.$s0b),ne(1,A.$yi),ne(2,p.$tl),ne(3,s.$X9b),ne(4,l.$gp),ne(5,D.$mj),ne(6,S.$W0b),ne(7,f.$Ej)],u)}),define(oe[301],ae([0,1,48,46,26,8,23,50,45,9,7,144,21,18,24,16,20,5,71,27,53,28,49,100]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=void 0;async function r(m,O=1e3){for(;!m();)await(0,M.$6g)(O)}let i;function n(){return typeof i>"u"&&(i=A.existsSync(l.$jc(l.$mc(process.execPath),"unins000.exe"))?0:1),i}let a=class extends o.$l$b{get cachePath(){const O=l.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(O,{recursive:!0}).then(()=>O)}constructor(O,I,E,C,j,T,F,G,J){super(O,I,C,j,T,J),this.u=E,this.v=F,this.w=G,O.setRelaunchHandler(this)}handleRelaunch(O){return O?.addArgs||O?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$oV.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(O){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$k$b)(I,O,this.k)}t(O){this.a&&(this.d(t.$oV.CheckingForUpdates(O)),this.i.request({url:this.a},D.CancellationToken.None).then(w.$mp).then(I=>{const E=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!O}),this.d(t.$oV.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$oV.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$oV.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>v.Promises.exists(C).then(j=>{if(j)return Promise.resolve(C);const T=`${C}.tmp`;return this.i.request({url:I.url},D.CancellationToken.None).then(F=>this.v.writeFile(p.URI.file(T),F.stream)).then(I.sha256hash?()=>(0,k.$lU)(T,I.sha256hash):()=>{}).then(()=>v.Promises.rename(T,C,!1)).then(()=>C)})).then(C=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},j?this.k.target==="user"?this.p():this.d(t.$oV.Downloaded(I)):this.d(t.$oV.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,f.$Si)(String(I)))}),this.j.error(I);const E=O?I.message||I:void 0;this.d(t.$oV.Idle(n(),E))}))}async o(O){O.update.url&&this.w.openExternal(void 0,O.update.url),this.d(t.$oV.Idle(n()))}async B(O){const I=await this.cachePath;return l.$jc(I,`CodeSetup-${this.k.quality}-${O}.exe`)}async C(O=null){const I=O?T=>!new RegExp(`${this.k.quality}-${O}\\.exe$`).test(T):()=>!0,E=await this.cachePath,j=(await v.Promises.readdir(E)).filter(I).map(async T=>{try{await v.Promises.unlink(l.$jc(E,T))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const O=this.state.update;this.d(t.$oV.Updating(O));const I=await this.cachePath;this.e.updateFilePath=l.$jc(I,`CodeSetup-${this.k.quality}-${O.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$oV.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,j=await new Promise((T,F)=>{Q(["@vscode/windows-mutex"],T,F)});r(()=>j.isActive(C)).then(()=>this.d(t.$oV.Ready(O)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(O){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$oV.Downloading(E)),this.e={packagePath:O},I?this.k.target==="user"?this.p():this.d(t.$oV.Downloaded(E)):this.d(t.$oV.Ready(E))}};e.$p$b=a,Ee([S.$wh],a.prototype,"cachePath",null),e.$p$b=a=Ee([ne(0,$.$s0b),ne(1,u.$yi),ne(2,c.$tl),ne(3,y.$X9b),ne(4,w.$gp),ne(5,d.$mj),ne(6,b.$pk),ne(7,h.$W0b),ne(8,g.$Ej)],a)}),define(oe[134],ae([0,1,15,8,23,51,3,2,13,68,4,7,190,26,66,18,55,24,64,16,20,5,27,80,252,82,28,103,70,60,29,30,57,129,39,34,56,69,22,6]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o,r,i,n,a,m,O,I,E,C,j,T,F,G,J,le,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=e.$p0b=void 0;var ue;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(ue||(ue={}));class Z extends S.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(D.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(D.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(D.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(D.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(D.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(D.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const W=(0,O.$SC)(this.r)==="custom";if(p.$j&&W&&L.setSheetOffset((0,p.$J)((0,u.release)())?28:22),W&&(p.$i&&(0,O.$TC)(this.r)||p.$j)){const V=this.s.getItem(Z.z);V&&this.updateWindowControls({height:V})}p.$i&&W&&L.hookWindowMessage(278,()=>{const[q,te]=L.getPosition(),he=P.screen.getCursorScreenPoint(),K=he.x-q,R=he.y-te;return(()=>!(K>30&&R>=0&&R<=Math.max(L.getBounds().height*.15,35)))()||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:K,y:R})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools()}constructor(L,W,V){super(),this.r=L,this.s=W,this.t=V,this.a=this.B(new D.$Ud),this.onDidClose=this.a.event,this.b=this.B(new D.$Ud),this.onDidMaximize=this.b.event,this.c=this.B(new D.$Ud),this.onDidUnmaximize=this.c.event,this.f=this.B(new D.$Ud),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Ud),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new D.$Ud),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.C=(0,O.$TC)(this.r),this.D=void 0,this.F=void 0}setRepresentedFilename(L){p.$j?this.win?.setRepresentedFilename(L):this.u=L}getRepresentedFilename(){return p.$j?this.win?.getRepresentedFilename():this.u}setDocumentEdited(L){p.$j&&this.win?.setDocumentEdited(L),this.w=L}isDocumentEdited(){return p.$j?!!this.win?.isDocumentEdited():!!this.w}focus(L){p.$j&&L?.force&&P.app.focus({steal:!0});const W=this.win;W&&(W.isMinimized()&&W.restore(),W.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(p.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.z="windowControlHeight"}updateWindowControls(L){const W=this.win;if(W){if(L.height&&this.s.setItem(X.z,L.height),p.$i&&this.C)W.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(p.$j&&L.height!==void 0){const V=(L.height-15)/2;V?W.setWindowButtonPosition({x:V,y:V}):W.setWindowButtonPosition(null)}}}toggleFullScreen(){this.G(!this.isFullScreen)}G(L){(0,O.$UC)(this.r)?this.H(L):this.J(L)}get isFullScreen(){if(p.$j&&typeof this.D=="boolean")return this.D;const L=this.win,W=L?.isFullScreen(),V=L?.isSimpleFullScreen();return!!(W||V)}H(L){const W=this.win;W?.isSimpleFullScreen()&&W?.setSimpleFullScreen(!1),this.I(L)}I(L){p.$j&&(this.D=L,this.F=new A.$ph,Promise.race([this.F.p,(0,A.$6g)(1e4)]).finally(()=>{this.D=void 0})),this.win?.setFullScreen(L)}J(L){const W=this.win;W?.isFullScreen()&&this.I(!1),W?.setSimpleFullScreen(L),W?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$p0b=Z;let X=class extends Z{get id(){return this.O}get backupPath(){return this.Q?.backupPath}get openedWorkspace(){return this.Q?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(W=>W.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$gi)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.Q?.remoteAuthority}get config(){return this.Q}get isExtensionDevelopmentHost(){return!!this.Q?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.Q?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.Q?.debugId}constructor(L,W,V,q,te,he,K,R,U,x,z,Y,N,B,_,ce,re,$e,me,ye,Pe){super(x,ye,q),this.db=W,this.eb=V,this.fb=te,this.gb=he,this.hb=K,this.ib=R,this.jb=U,this.kb=z,this.lb=Y,this.mb=N,this.nb=B,this.ob=_,this.pb=ce,this.qb=re,this.rb=$e,this.sb=me,this.L=this.B(new D.$Ud),this.onWillLoad=this.L.event,this.M=this.B(new D.$Ud),this.onDidSignalReady=this.M.event,this.N=this.B(new D.$Ud),this.onDidDestroy=this.N.event,this.U=[],this.W=[],this.X=void 0,this.Y=void 0,this.Z=void 0,this.$=this.B(this.rb.createIPCObjectUrl()),this.bb=!1,this.tb=0;{const[Le,ke]=this.Db(L.state);this.R=Le,this.db.trace("window#ctor: using window state",Le);const pe=this.R.mode===0||this.R.mode===3,ee=Pe.invokeFunction(I.$_9b,this.R,{show:!pe,webPreferences:{preload:f.$ng.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.$.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(ee),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.O=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),ge=p.$j&&fe?.nativeTabs===!0;(p.$j||p.$i)&&ke&&(!ge||P.BrowserWindow.getAllWindows().length===1)&&[this.R.width,this.R.height,this.R.x,this.R.y].every(Ie=>typeof Ie=="number")&&this.m.setBounds({width:this.R.width,height:this.R.height,x:this.R.x,y:this.R.y}),pe&&((0,l.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.R.mode===3&&this.G(!0),this.m.show(),(0,l.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Lb(),this.ub()}setReady(){for(this.db.trace(`window#load: window reported ready (id: ${this.O})`),this.tb=2;this.U.length;)this.U.pop()(this);this.M.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.U.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function W(){V.dispose(),q.dispose(),L()}const V=this.onDidClose(()=>W()),q=this.onWillLoad(()=>W())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(W,V)=>this.xb(2,{...V})),this.m.webContents.on("did-fail-load",(W,V,q)=>this.xb(3,{reason:q,exitCode:V})),this.m.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.ab&&(this.Q=this.ab,this.ab=void 0)}),this.B(this.onDidMaximize(()=>{this.Q&&(this.Q.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.Q&&(this.Q.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0})),this.B(this.r.onDidChangeConfiguration(W=>this.Ab(W))),this.B(this.lb.onDidDeleteUntitledWorkspace(W=>this.zb(W)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(W,V)=>{const q=await this.wb();V({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,q)})})}wb(){return this.vb||(this.vb=(0,r.$Ap)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,W){switch(L){case 2:this.db.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.db.error("CodeWindow: detected unresponsive");break;case 3:this.db.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:W?.reason,code:W?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:q}=await this.ob.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.Q?.workspace?(0,v.localize)(5,null):void 0},this.m);if(V!==2){const te=V===0;await this.yb(te,q)}}else if(L===2){let V;W?V=(0,v.localize)(7,null,W.reason,W.exitCode??"<unknown>"):V=(0,v.localize)(6,null);const{response:q,checkboxChecked:te}=await this.ob.showMessageBox({type:"warning",buttons:[this.Q?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:V,detail:this.Q?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.Q?.workspace?(0,v.localize)(13,null):void 0},this.m),he=q===0;await this.yb(he,te)}break}}async yb(L,W){const V=this.Q?.workspace;if(W&&V)try{const q=this.jb.workspaceStorage(V);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.db.error(q)}this.N.fire();try{if(L&&this.Q){let q,te;(0,E.$ci)(V)?q={folderUri:V.uri}:(0,E.$hi)(V)?q={workspaceUri:V.configPath}:te=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.Q.userEnv,cli:{...this.t.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:te,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.Q?.workspace?.id===L.id&&(this.Q.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const W=this.Hb();W!==this.S&&(this.S=W,this.Ib(W))}if(!L||L.affectsConfiguration("http.proxy")){let W=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.X||V!==this.Y)){this.X=W,this.Y=V;const q=W||"",te=V?`${V},<local>`:"<local>";this.db.trace(`Setting proxy to '${q}', bypassing '${te}'`),this.m.webContents.session.setProxy({proxyRules:q,proxyBypassRules:te,pacScript:""})}}}addTabbedWindow(L){p.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,W=Object.create(null)){this.db.trace(`window#load: attempt to load window (id: ${this.O})`),this.isDocumentEdited()&&(!W.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,W),this.tb===0?this.Q=L:this.ab=L,this.tb=1,this.m.loadURL(f.$ng.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.bb;this.bb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new A.$eh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.L.fire({workspace:L.workspace,reason:W.isReload?3:V?2:1})}Bb(L,W){const V=(this.Q??this.ab)?.userEnv;if(V){const q=(0,h.$5l)(V)&&!(0,h.$5l)(L.userEnv),te=this.isExtensionDevelopmentHost;(q||te)&&(L.userEnv={...V,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(L["disable-extensions"]=W.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Kb(),L.isCustomZoomLevel=typeof this.Z=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),L.perfMarks=(0,l.getMarks)(),this.$.update(L)}async reload(L){const W=Object.assign({},this.Q);W.workspace=await this.Cb(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&L&&(W.verbose=L.verbose,W.debugId=L.debugId,W.extensionEnvironment=L.extensionEnvironment,W["inspect-extensions"]=L["inspect-extensions"],W["inspect-brk-extensions"]=L["inspect-brk-extensions"],W["extensions-dir"]=L["extensions-dir"]),W.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),W.isInitialStartup=!1,W.policiesData=this.fb.serialize(),W.continueOn=this.t.continueOn,W.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},W.logLevel=this.eb.getLogLevel(),W.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(W,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$hi)(L.workspace)){const W=L.workspace.configPath;if(W.scheme===f.Schemas.file&&!await this.hb.exists(W))return}else if((0,E.$ci)(L.workspace)){const W=L.workspace.uri;if(W.scheme===f.Schemas.file&&!await this.hb.exists(W))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,j.$W9b)();if(this.isFullScreen){let V;try{V=P.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,j.$W9b)();return{mode:3,display:V?V.id:void 0,width:this.R.width||q.width,height:this.R.height||q.height,x:this.R.x||0,y:this.R.y||0,zoomLevel:this.Z}}const L=Object.create(null);let W;if(!p.$j&&this.m.isMaximized()?W=0:W=1,W===0?L.mode=0:L.mode=1,W===1||W===0){let V;W===1?V=this.getBounds():V=this.m.getNormalBounds(),L.x=V.x,L.y=V.y,L.width=V.width,L.height=V.height}return L.zoomLevel=this.Z,L}Db(L){(0,l.mark)("code/willRestoreCodeWindowState");let W=!1;if(L){this.Z=L.zoomLevel;try{const V=P.screen.getAllDisplays();W=V.length>1,L=this.Eb(L,V)}catch(V){this.db.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$W9b)(),W]}Eb(L,W){if(this.db.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.db.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.db.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const te=this.Fb(W[0]);if(te){let he=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!te||(L.x<te.x&&(L.x=te.x),L.y<te.y&&(L.y=te.y))};this.db.trace("window#validateWindowState: 1 monitor working area",te),he(),L.width>te.width&&(L.width=te.width),L.height>te.height&&(L.height=te.height),L.x>te.x+te.width-128&&(L.x=te.x+te.width-L.width),L.y>te.y+te.height-128&&(L.y=te.y+te.height-L.height),he()}return L}if(L.display&&L.mode===3){const te=W.find(he=>he.id===L.display);if(te&&typeof te.bounds?.x=="number"&&typeof te.bounds?.y=="number"){this.db.trace("window#validateWindowState: restoring fullscreen to previous display");const he=(0,j.$W9b)(3);return he.x=te.bounds.x,he.y=te.bounds.y,he}}let V,q;try{V=P.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),q=this.Fb(V)}catch{}if(V&&q&&L.x+L.width>q.x&&L.y+L.height>q.y&&L.x<q.x+q.width&&L.y<q.y+q.height)return this.db.trace("window#validateWindowState: multi-monitor working area",q),L}Fb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,W]=this.m.getPosition(),[V,q]=this.m.getSize();return{x:L,y:W,width:V,height:q}}G(L){super.G(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.S&&this.Ib(this.S,!1)}Hb(){let L=(0,O.$RC)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Ib(L,W=!0){p.$j||(L==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Jb(L)}):this.Jb(L))}Jb(L){const W=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!W),this.m.autoHideMenuBar=W;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.Z=L}Kb(){return typeof this.Z=="number"?this.Z:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,W,...V){this.isReady?this.send(L,...V):this.ready().then(()=>{W.isCancellationRequested||this.send(L,...V)})}send(L,...W){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.db.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...W)}catch(V){this.db.warn(`Error sending IPC message to channel '${L}' of window ${this.O}: ${(0,M.$Pi)(V)}`)}}}updateTouchBar(L){p.$j&&this.W.forEach((W,V)=>{const q=L[V];W.segments=this.Nb(q)})}Lb(){if(p.$j){for(let L=0;L<10;L++){const W=this.Mb();this.W.push(W)}this.m.setTouchBar(new P.TouchBar({items:this.W}))}}Mb(L=[]){const W=this.Nb(L),V=new P.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:V.segments[q].id,from:"touchbar"})}});return V}Nb(L=[]){return L.map(V=>{let q;V.icon&&!a.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===f.Schemas.file&&(q=P.nativeImage.createFromPath(k.URI.revive(V.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let te;return typeof V.title=="string"?te=V.title:te=V.title.value,{id:V.id,label:q?void 0:te,icon:q}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$q0b=X,e.$q0b=X=Ee([ne(1,c.$mj),ne(2,J.$n0b),ne(3,d.$X9b),ne(4,T.$In),ne(5,G.$c0b),ne(6,g.$pk),ne(7,i.$A0b),ne(8,i.$y0b),ne(9,b.$yi),ne(10,m.$79b),ne(11,C.$l0b),ne(12,y.$39b),ne(13,n.$tl),ne(14,$.$49b),ne(15,w.$s0b),ne(16,t.$Ej),ne(17,o.$69b),ne(18,I.$$9b),ne(19,F.$lO),ne(20,se.$4h)],X)}),define(oe[302],ae([0,1,15,18,24,20,5,34,134]),function(Q,e,P,A,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r0b=void 0;let l=class extends f.$p0b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(k,v,u,y,b,$){super(y,b,v),this.L=k,this.M=u,this.N=$,this.id=this.L.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.L.isDestroyed())return;const k=P.BrowserWindow.fromWebContents(this.L);k&&(this.M.trace("[aux window] Claimed browser window instance"),this.n(k),k.setMenu(null),this.N.registerAuxWindow(this))}};e.$r0b=l,e.$r0b=l=Ee([ne(1,s.$X9b),ne(2,D.$mj),ne(3,A.$yi),ne(4,S.$lO),ne(5,M.$s0b)],l)}),define(oe[303],ae([0,1,15,3,2,13,37,302,6,5,29]),function(Q,e,P,A,s,M,D,S,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=void 0;let k=class extends s.$Tc{constructor(u,y){super(),this.h=u,this.j=y,this.a=this.B(new A.$Ud),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new A.$Ud),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new A.$Ud),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new A.$Ud),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){P.app.on("browser-window-created",(u,y)=>{const b=this.getWindowById(y.id);b&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),b.tryClaimWindow())}),D.$qU.handle("vscode:registerAuxiliaryWindow",async(u,y)=>{const b=this.getWindowById(u.sender.id);return b&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),b.parentId=y),u.sender.id})}createWindow(){return this.h.invokeFunction(p.$_9b,void 0,{webPreferences:{preload:M.$ng.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(u){const y=new s.$Sc,b=this.h.createInstance(S.$r0b,u);this.g.set(b.id,b),y.add((0,s.$Rc)(()=>this.g.delete(b.id))),y.add(b.onDidMaximize(()=>this.a.fire(b))),y.add(b.onDidUnmaximize(()=>this.b.fire(b))),y.add(b.onDidEnterFullScreen(()=>this.c.fire(b))),y.add(b.onDidLeaveFullScreen(()=>this.c.fire(b))),y.add(b.onDidTriggerSystemContextMenu(({x:$,y:d})=>this.f.fire({window:b,x:$,y:d}))),A.Event.once(b.onDidClose)(()=>y.dispose())}getWindowById(u){return this.g.get(u)}getFocusedWindow(){const u=P.BrowserWindow.getFocusedWindow();if(u)return this.getWindowById(u.id)}getLastActiveWindow(){return(0,p.$b0b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$U$b=k,e.$U$b=k=Ee([ne(0,f.$4h),ne(1,l.$mj)],k)}),define(oe[83],ae([0,1,15,22,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,57,31,55]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=e.$90b=void 0,e.$90b=(0,y.$5h)("workspacesHistoryMainService");let r=class extends S.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,a,m,O,I){super(),this.f=n,this.g=a,this.h=m,this.j=O,this.m=I,this.c=this.B(new M.$Ud),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$3g(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],m=[];for(const I of n)if((0,h.$pcb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(a,I.workspace)&&a.push(I);else if((0,h.$qcb)(I))this.y(a,I.folderUri)||a.push(I);else{const E=this.z(m,I.fileUri),C=I.fileUri.scheme===f.Schemas.file&&o.G.indexOf((0,p.$Dg)(I.fileUri))>=0;!E&&!C&&(m.push(I),l.$i&&I.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const O=await this.r({workspaces:a,files:m});a=O.workspaces,m=O.files,a.length>o.a&&(a.length=o.a),m.length>o.a&&(m.length=o.a),await this.t({workspaces:a,files:m}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const a=E=>{const C=this.u(E);for(const j of n)if(p.$xg.isEqual(j,C))return!1;return!0},m=await this.getRecentlyOpened(),O=m.workspaces.filter(a),I=m.files.filter(a);(O.length!==m.workspaces.length||I.length!==m.files.length)&&(await this.t({files:I,workspaces:O}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:a}=await this.m.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null)],message:(0,u.localize)(2,null),detail:(0,u.localize)(3,null),cancelId:1});if(a!==0)return}await this.t({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const a=new c.$Ac(I=>p.$xg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)a.set(this.u(I),I);const m=new c.$Ac(I=>p.$xg.getComparisonKey(I));if(n?.files)for(const I of n.files)m.set(this.u(I),I);const O=await this.s();for(const I of O.workspaces){const E=a.get(this.u(I));E?E.label=E.label??I.label:a.set(this.u(I),I)}for(const I of O.files){const E=m.get(this.u(I));E?E.label=E.label??I.label:m.set(this.u(I),I)}return{workspaces:[...a.values()],files:[...m.values()]}}async s(){await this.j.whenReady;let n;const a=this.j.get(o.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(m){this.f.error("Unexpected error parsing opened paths list",m)}return(0,h.$wcb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,h.$xcb)(n)),-1,1)}u(n){return(0,h.$qcb)(n)?n.folderUri:(0,h.$rcb)(n)?n.fileUri:n.workspace.configPath}w(n,a){return!!n.find(m=>(0,h.$pcb)(m)&&m.workspace.id===a.id)}y(n,a){return!!n.find(m=>(0,h.$qcb)(m)&&p.$xg.isEqual(m.folderUri,a))}z(n,a){return!!n.find(m=>p.$xg.isEqual(m.fileUri,a))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(4,null),description:(0,u.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const I of P.app.getJumpListSettings().removedItems){const E=I.args;if(E){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);C&&a.push(k.URI.parse(C[2]))}}await this.removeRecentlyOpened(a);let m=!1;const O=(0,A.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,h.$pcb)(I)?I.workspace:I.folderUri,{title:C,description:j}=this.L(E,I.label);let T;return k.URI.isUri(E)?T=`--folder-uri "${E.toString()}"`:(m=!0,T=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:j.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));O.length>0&&n.push({type:"custom",name:m?(0,u.localize)(6,null):(0,u.localize)(7,null),items:O})}n.push({type:"recent"});try{const a=P.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}L(n,a){if(a)return{title:(0,D.$4v)(a).name,description:a};if(k.URI.isUri(n))return{title:(0,p.$Dg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,u.localize)(8,null),description:""};let m=(0,p.$Dg)(n.configPath);return m.endsWith(g.$oi)&&(m=m.substr(0,m.length-g.$oi.length-1)),{title:(0,u.localize)(9,null,m),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,D.$Vv)(n.fsPath):n.toString()}async N(){if(!l.$j)return;P.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let m=0;for(let I=0;I<n.workspaces.length&&m<o.C;I++){const E=this.u(n.workspaces[I]);if(E.scheme===f.Schemas.file){const C=(0,p.$ug)(E);await v.Promises.exists(C)&&(a.push(C),m++)}}const O=[];for(let I=0;I<n.files.length&&m<o.D;I++){const E=this.u(n.files[I]);if(E.scheme===f.Schemas.file){const C=(0,p.$ug)(E);if(o.G.includes((0,p.$Dg)(E))||a.includes(C))continue;await v.Promises.exists(C)&&(O.push(C),m++)}}O.reverse().forEach(I=>P.app.addRecentDocument(I)),a.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$00b=r,e.$00b=r=o=Ee([ne(0,$.$mj),ne(1,w.$l0b),ne(2,b.$s0b),ne(3,d.$A0b),ne(4,t.$49b)],r)}),define(oe[304],ae([0,1,15,8,23,47,4,7,181,65,18,24,20,5,231,71,27,34,28,49,60,29,83]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$$0b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(m,O,I,E,C,j,T,F,G,J,le,se){this.n=m,this.o=O,this.p=I,this.q=E,this.r=C,this.s=j,this.t=T,this.u=F,this.v=G,this.w=J,this.x=le,this.y=se,this.m=Object.create(null),this.g=new A.$eh(()=>this.F(),0),this.h=new A.$eh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,w.$SC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const m=this.t.getItem(o.a);m&&(m.menus&&(this.k=m.menus),m.keybindings&&(this.l=m.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,T,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:T?.id})},this.m["workbench.action.newWindow"]=(j,T,F)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(j,T,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,T,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,T,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const m=this.x.youTubeUrl;m&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(m,"openYouTubeUrl"));const O=this.x.requestFeatureUrl;O&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(O,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const j=E.indexOf("?")>0?"&":"?";this.ab(`${E}${j}lang=${D.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(m=>this.G(m)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const m=this.o.getValue("window.enableMenuBarMnemonics");return typeof m!="boolean"?!0:m}get D(){if(!D.$j)return!1;const m=this.o.getValue("window.nativeTabs");return typeof m!="boolean"?!1:m}updateMenu(m,O){this.k=m.menus,this.l=m.keybindings,this.t.setItem(o.a,m),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(m){D.$j&&(m.oldCount===0&&m.newCount>0||m.oldCount>0&&m.newCount===0)&&(this.d=m.newCount===0,this.E())}H(){if(!D.$j)return;const m=P.BrowserWindow.getFocusedWindow();this.f=!m||!!this.y.getWindowById(m.id),this.E()}I(){const m=P.Menu.getApplicationMenu();if(m&&this.j.push(m),Object.keys(this.k).length===0){this.J(D.$j?new P.Menu:null);return}const O=new P.Menu;let I;if(D.$j){const C=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),O.append(I)}if(D.$j&&!this.c){this.c=!0;const C=new P.Menu;C.append(new P.MenuItem({label:this.cb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(C)}if(this.M("File")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(1,null)),submenu:C});this.O(C,"File"),O.append(j)}if(this.M("Edit")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(2,null)),submenu:C});this.O(C,"Edit"),O.append(j)}if(this.M("Selection")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(3,null)),submenu:C});this.O(C,"Selection"),O.append(j)}if(this.M("View")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(4,null)),submenu:C});this.O(C,"View"),O.append(j)}if(this.M("Go")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(5,null)),submenu:C});this.O(C,"Go"),O.append(j)}if(this.M("Run")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(6,null)),submenu:C});this.O(C,"Run"),O.append(j)}if(this.M("Terminal")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(7,null)),submenu:C});this.O(C,"Terminal"),O.append(j)}let E;if(this.M("Window")){const C=new P.Menu;E=new P.MenuItem({label:this.cb(f.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(E&&O.append(E),this.M("Help")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),O.append(j)}O.items&&O.items.length>0?this.J(O):this.J(null),this.h.schedule()}J(m){if(P.Menu.setApplicationMenu(m),m)for(const O of this.y.getWindows())O.win?.setMenu(null)}K(m){const O=this.W(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const se=new P.Menu;this.O(se,"Preferences"),E=new P.MenuItem({label:this.cb(f.localize(11,null)),submenu:se})}const C=new P.Menu,j=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:C}),T=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),J=new P.MenuItem(this.$("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(se,ue,Z)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||X?.win?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),le=[O];le.push(...I),E&&le.push(n(),E),le.push(n(),j,n(),T,F,G,n(),J),le.forEach(se=>m.append(se))}async L(m){if(this.p.getWindowCount()===0)return!0;const O=this.o.getValue("window.confirmBeforeClose");if(O==="always"||O==="keyboardOnly"&&this.S(m)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return I===0}return!0}M(m){if(!D.$j&&(0,w.$SC)(this.o)==="custom")return!1;switch(m){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[m];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[m]}}N(m,O){O.forEach(I=>{if((0,y.$60b)(I))m.append(n());else if((0,y.$50b)(I)){const E=new P.Menu,C=new P.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),m.append(C)}else(0,y.$70b)(I)?m.append(this.Q(I)):(0,y.$80b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(m),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?m.append(new P.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):m.append(this.W(I.label,I.id,!1,I.checked)):m.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):m.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(m,O){this.k&&this.k[O]&&this.N(m,this.k[O].items)}P(m){const O=this.V();O.length&&(O.forEach(I=>m.append(I)),m.append(n()))}Q(m){const O=S.URI.revive(m.uri),I=m.id,E=I==="openRecentFile"?{fileUri:O}:I==="openRecentWorkspace"?{workspaceUri:O}:{folderUri:O};return new P.MenuItem(this.$(I,{label:m.label,click:async(C,j,T)=>{const F=this.R(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:m.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([O])}},!1))}R(m){return!!(m&&(!D.$j&&(m.ctrlKey||m.shiftKey)||D.$j&&(m.metaKey||m.altKey)))}S(m){return!!(m.triggeredByAccelerator||m.altKey||m.ctrlKey||m.metaKey||m.shiftKey)}T(m,O,I){const E={label:this.cb(m),role:I,enabled:!0};return new P.MenuItem(this.Z(O,E))}U(m){const O=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(f.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(n()),j.push(this.W(f.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[O,I,n(),C,...j,n(),E].forEach(T=>m.append(T))}V(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.cb(f.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.cb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.cb(f.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.cb(f.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(m,O,I,E){const C=this.cb(m),j=typeof O=="function"?O:(le,se,ue)=>{const Z=le?le.userSettingsLabel:null;let X=O;Array.isArray(O)&&(X=this.R(ue)?O[1]:O[0]),Z&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:X})},T=typeof I=="boolean"?I:this.p.getWindowCount()>0,F=typeof E=="boolean"?E:!1,G={label:C,click:j,enabled:T};F&&(G.type="checkbox",G.checked=F);let J;return typeof O=="string"?J=O:Array.isArray(O)&&(J=O[0]),D.$j&&(J==="editor.action.clipboardCutAction"?G.role="cut":J==="editor.action.clipboardCopyAction"?G.role="copy":J==="editor.action.clipboardPasteAction"&&(G.role="paste"),J==="undo"?G.click=this.X(j,{inDevTools:le=>le.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?G.click=this.X(j,{inDevTools:le=>le.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(G.click=this.X(j,{inDevTools:le=>le.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.Z(J,G))}X(m,O){return(I,E,C)=>{const j=P.BrowserWindow.getFocusedWindow();if(!j)return O.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return O.inDevTools(j.webContents.devToolsWebContents);m(I,E||j,C)}}Y(m){let O=P.BrowserWindow.getFocusedWindow();if(O){const E=this.y.getWindowById(O.id);E&&(O=this.p.getWindowById(E.parentId)?.win??null)}if(!O){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(O=E.win)}const I=O?this.p.getWindowById(O.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",m),D.$j&&!this.q.isBuilt&&!I.isReady&&(m.type==="commandId"&&m.commandId==="workbench.action.toggleDevTools"||m.type!=="commandId"&&m.userSettingsLabel==="alt+cmd+i"))return!1;if(m.type==="commandId"){const E={id:m.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:m.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",m),!1}Z(m,O){const I=typeof m=="string"?this.l[m]:void 0;if(I?.label){if(I.isNative!==!1)O.accelerator=I.label,O.userSettingsLabel=I.userSettingsLabel;else if(typeof O.label=="string"){const E=O.label.indexOf("[");E>=0?O.label=`${O.label.substr(0,E)} [${I.label}]`:O.label=`${O.label} [${I.label}]`}}else O.accelerator=void 0;return O}$(m,O,I=!O.accelerator){I&&(O=this.Z(m,O));const E=O.click;return O.click=(C,j,T)=>{this.bb(m),E?.(C,j,T)},O}ab(m,O){this.w.openExternal(void 0,m),this.bb(O)}bb(m){this.r.publicLog2("workbenchActionExecuted",{id:m,from:r})}cb(m){return(0,M.$1v)(m,!this.C)}};e.$$0b=i,e.$$0b=i=o=Ee([ne(0,g.$pV),ne(1,p.$yi),ne(2,c.$$9b),ne(3,k.$X9b),ne(4,h.$tl),ne(5,t.$90b),ne(6,d.$lO),ne(7,v.$s0b),ne(8,u.$mj),ne(9,b.$W0b),ne(10,$.$Ej),ne(11,l.$99b)],i);function n(){return new P.MenuItem({type:"separator"})}}),define(oe[305],ae([0,1,6,20,5,304]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=e.$_0b=void 0,e.$_0b=(0,P.$5h)("menubarMainService");let D=class{constructor(f,l,p){this.b=f,this.c=l,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$$0b)}async updateMenubar(f,l){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(l,f)}};e.$a$b=D,e.$a$b=D=Ee([ne(0,P.$4h),ne(1,A.$s0b),ne(2,s.$mj)],D)}),define(oe[306],ae([0,1,15,21,132,26,22,23,3,33,47,2,13,9,68,4,36,19,12,7,191,66,18,55,24,16,6,20,5,79,80,59,34,60,134,29,131,298,30,98,83,57,70,39,56,69,65]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o,r,i,n,a,m,O,I,E,C,j,T,F,G,J,le,se,ue,Z,X,H,L,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=void 0;function q(K){return(0,le.$hi)(K?.workspace)}function te(K){return(0,le.$ci)(K?.workspace)}let he=class extends k.$Tc{constructor(R,U,x,z,Y,N,B,_,ce,re,$e,me,ye,Pe,Le,ke,pe,ee,fe,ge){super(),this.s=R,this.t=U,this.u=x,this.w=z,this.z=Y,this.C=N,this.D=B,this.F=_,this.G=ce,this.H=re,this.I=$e,this.J=me,this.L=ye,this.M=Pe,this.N=Le,this.O=ke,this.P=pe,this.Q=ee,this.R=fe,this.S=ge,this.a=this.B(new f.$Ud),this.onDidOpenWindow=this.a.event,this.b=this.B(new f.$Ud),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new f.$Ud),this.onDidDestroyWindow=this.c.event,this.f=this.B(new f.$Ud),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new f.$Ud),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new f.$Ud),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new f.$Ud),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new f.$Ud),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new J.$x$b(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(R=>this.b.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const U=new k.$Sc;if(U.add(f.Event.any(R.onDidClose,R.onDidDestroy)(()=>U.dispose())),R.config.extensionDevelopmentPath)for(const x of R.config.extensionDevelopmentPath)U.add(this.Q.addValidFileRoot(x));R.config.extensionTestsPath&&U.add(this.Q.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,U){const x=this.F.args,z=U?.remoteAuthority||void 0,Y=!0,N=U?.forceReuseWindow,B=!N;return this.open({...R,cli:x,forceEmpty:Y,forceNewWindow:B,forceReuseWindow:N,remoteAuthority:z})}openExistingWindow(R,U){R.focus(),this.W(U,[R])}async open(R){this.w.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const U=[],x=[],z=[],Y=[],N=[];let B,_=0;const ce=await this.cb(R);this.w.trace("windowsManager#open pathsToOpen",ce);for(const Pe of ce)te(Pe)?R.addMode?U.push(Pe):x.push(Pe):q(Pe)?z.push(Pe):Pe.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),B.filesToOpenOrCreate.push(Pe)):Pe.backupPath?N.push({backupFolder:(0,u.$nc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):_++;R.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),R.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&R.waitMarkerFileURI&&(B.filesToWait={paths:(0,D.$Hb)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(Y.push(...this.M.getUntitledWorkspaces()),z.push(...Y),N.push(...this.I.getEmptyWindowBackups())):N.length=0;const{windows:re,filesOpenedInWindow:$e}=await this.X(R,z,x,N,_,B,U);if(this.w.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${x.length}, emptyToRestore: ${N.length}, emptyToOpen: ${_})`),re.length>1)if($e)$e.focus();else{const Pe=this.r.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let Le=!0,ke=!0;if(Pe){const pe=re.filter(ee=>this.r.state.lastActiveWindow&&ee.backupPath===this.r.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ke=!1)}if(Le)for(let pe=re.length-1;pe>=0;pe--){const ee=re[pe];if(!(ee.openedWorkspace&&Y.some(fe=>ee.openedWorkspace&&fe.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&N.some(fe=>ee.backupPath&&fe.backupFolder===(0,u.$nc)(ee.backupPath)))){ee.focus(),ke=!1;break}}ke&&re[re.length-1].focus()}const me=B&&B.filesToDiff.length>0,ye=B&&B.filesToMerge.length>0;if(!re.some(Pe=>Pe.isExtensionDevelopmentHost)&&!me&&!ye&&!R.noRecentEntry){const Pe=[];for(const Le of ce)q(Le)&&!Le.transient?Pe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):te(Le)?Pe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Pe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.L.addRecentlyOpened(Pe)}return this.W(R,re),re}W(R,U){const x=R.waitMarkerFileURI;R.context===0&&x&&U.length===1&&U[0]&&(async()=>{await U[0].whenClosedOrLoaded;try{await this.P.del(x)}catch{}})()}async X(R,U,x,z,Y,N,B){const _=[];let ce;function re(pe,ee){_.push(pe),ee&&(ce=pe,N=void 0)}let{openFolderInNewWindow:$e,openFilesInNewWindow:me}=this.ob(R);if(!R.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,ee=this.ub(pe);ee&&re(this.$(ee,B.map(fe=>fe.workspace.uri)))}const ye=x.length+U.length+z.length;if(N&&ye===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],ee=this.getWindows().filter(ge=>N&&(0,d.$Lg)(ge.remoteAuthority,N.remoteAuthority));let fe;pe?.fileUri&&!me&&((R.context===4||R.context===0||R.context===1)&&(fe=await(0,G.$e0b)(ee,pe.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(ee))),fe?(0,le.$hi)(fe.openedWorkspace)?U.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$ci)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):re(this.Y(R,fe,N),!0):re(await this.pb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const Pe=(0,D.$Mb)(U,pe=>pe.workspace.id);if(Pe.length>0){const pe=(0,D.$Hb)(Pe.map(ee=>(0,G.$f0b)(this.getWindows(),ee.workspace.configPath)));if(pe.length>0){const ee=pe[0],fe=(0,d.$Lg)(N?.remoteAuthority,ee.remoteAuthority)?N:void 0;re(this.Y(R,ee,fe),!!fe),$e=!0}for(const ee of Pe){if(pe.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===ee.workspace.id))continue;const fe=ee.remoteAuthority,ge=(0,d.$Lg)(N?.remoteAuthority,fe)?N:void 0;re(await this.bb(R,ee,$e,ge),!!ge),$e=!0}}const Le=(0,D.$Mb)(x,pe=>d.$xg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,D.$Hb)(Le.map(ee=>(0,G.$f0b)(this.getWindows(),ee.workspace.uri)));if(pe.length>0){const ee=pe[0],fe=(0,d.$Lg)(N?.remoteAuthority,ee.remoteAuthority)?N:void 0;re(this.Y(R,ee,fe),!!fe),$e=!0}for(const ee of Le){if(pe.some(Ie=>(0,le.$ci)(Ie.openedWorkspace)&&d.$xg.isEqual(Ie.openedWorkspace.uri,ee.workspace.uri)))continue;const fe=ee.remoteAuthority,ge=(0,d.$Lg)(N?.remoteAuthority,fe)?N:void 0;re(await this.bb(R,ee,$e,ge),!!ge),$e=!0}}const ke=(0,D.$Mb)(z,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const ee=pe.remoteAuthority,fe=(0,d.$Lg)(N?.remoteAuthority,ee)?N:void 0;re(await this.ab(R,!0,ee,fe,pe),!!fe),$e=!0}if(_.length===0||N){N&&!Y&&Y++;const pe=N?N.remoteAuthority:R.remoteAuthority;for(let ee=0;ee<Y;ee++)re(await this.ab(R,$e,pe,N),!!N),$e=!0}return{windows:(0,D.$Mb)(_),filesOpenedInWindow:ce}}Y(R,U,x){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Z(U);const z={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return U.sendWhenReady("vscode:openFiles",S.CancellationToken.None,z),U}Z(R){let U=R;const x=P.BrowserWindow.getFocusedWindow();if(x&&x.id!==R.id){const z=this.S.getWindowById(x.id);z&&z.parentId===R.id&&(U=z)}U.focus()}$(R,U){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:U}),R.focus();const x={foldersToAdd:U};return R.sendWhenReady("vscode:addFolders",S.CancellationToken.None,x),R}ab(R,U,x,z,Y){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:x,filesToOpen:z,forceNewWindow:U});let N;return!U&&typeof R.contextWindowId=="number"&&(N=this.getWindowById(R.contextWindowId)),this.pb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:x,forceNewWindow:U,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:z,windowToUse:N,emptyWindowBackupInfo:Y,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}bb(R,U,x,z,Y){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:U,filesToOpen:z}),!x&&!Y&&typeof R.contextWindowId=="number"&&(Y=this.getWindowById(R.contextWindowId)),this.pb({workspace:U.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:U.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:z,windowToUse:Y,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async cb(R){let U,x=!1,z=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(U=await this.db(R),x=!0):R.forceEmpty?U=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(U=await this.eb(R.cli),U.length===0&&U.push(Object.create(null)),x=!0):(U=await this.gb(),U.length===0&&U.push(Object.create(null)),z=!0),!R.addMode&&x){const Y=U.filter(N=>te(N));if(Y.length>1){const N=Y[0].remoteAuthority;if(Y.every(B=>(0,d.$Lg)(B.remoteAuthority,N))){const B=await this.M.createUntitledWorkspace(Y.map(_=>({uri:_.workspace.uri})));U.push({workspace:B,remoteAuthority:N}),U=U.filter(_=>!te(_))}}}if(R.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const Y=await this.gb();U.unshift(...Y.filter(N=>q(N)||te(N)||N.backupPath))}return U}async db(R){const U={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},x=await Promise.all((0,D.$Hb)(R.urisToOpen||[]).map(async z=>{const Y=await this.ib(z,U);if(Y)return Y.label=z.label,Y;const N=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:N.scheme===v.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:N.scheme===v.Schemas.file?(0,w.localize)(3,null,(0,p.$Uv)(N,{os:b.OS,tildify:this.F})):(0,w.localize)(4,null,N.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(x)}async eb(R){const U=[],x={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},z=R["folder-uri"];if(z){const B=await Promise.all(z.map(_=>{const ce=this.fb(_);if(ce)return this.ib({folderUri:ce},x)}));U.push(...(0,D.$Hb)(B))}const Y=R["file-uri"];if(Y){const B=await Promise.all(Y.map(_=>{const ce=this.fb(_);if(ce)return this.ib((0,le.$xi)(_)?{workspaceUri:ce}:{fileUri:ce},x)}));U.push(...(0,D.$Hb)(B))}const N=await Promise.all(R._.map(B=>x.remoteAuthority?this.nb(B,x):this.lb(B,x)));return U.push(...(0,D.$Hb)(N)),U}fb(R){try{const U=g.URI.parse(R);if(!U.scheme){this.w.error(`Invalid URI input string, scheme missing: ${R}`);return}return U.path?U:U.with({path:"/"})}catch(U){this.w.error(`Invalid URI input string: ${R}, ${U.message}`)}}async gb(){const R=this.hb();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const U=[];R!=="one"&&U.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&U.push(this.r.state.lastActiveWindow);const x=await Promise.all(U.map(async z=>{if(z.workspace){const Y=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(Y))return Y}else if(z.folderUri){const Y=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(te(Y))return Y}else if(R!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,D.$Hb)(x)}}}hb(){let R;return this.H.wasRestarted?R="all":(R=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async ib(R,U=Object.create(null)){const x=this.kb(R);return x.scheme===v.Schemas.file?((0,j.$QC)(R)&&(U={...U,forceOpenWorkspaceAsFile:!0}),this.lb(x.fsPath,U)):this.jb(R,U)}jb(R,U){let x=this.kb(R);const z=(0,E.$_k)(x)||U.remoteAuthority;if(x=(0,d.$Ng)((0,d.$Hg)(x)),(0,j.$QC)(R)){if(U.gotoLineMode){const{path:Y,line:N,column:B}=(0,l.$bg)(x.path);return{fileUri:x.with({path:Y}),options:{selection:N?{startLineNumber:N,startColumn:B||1}:void 0},remoteAuthority:z}}return{fileUri:x,remoteAuthority:z}}else if((0,j.$OC)(R))return{workspace:(0,se.$i0b)(x),remoteAuthority:z};return{workspace:(0,se.$j0b)(x),remoteAuthority:z}}kb(R){return(0,j.$OC)(R)?R.workspaceUri:(0,j.$PC)(R)?R.folderUri:R.fileUri}async lb(R,U,x){let z,Y;U.gotoLineMode&&({path:R,line:z,column:Y}=(0,l.$bg)(R)),R=(0,l.$9f)((0,u.$hc)(R),(0,$.cwd)());try{const N=await A.Promises.stat(R);if(N.isFile()){if(!U.forceOpenWorkspaceAsFile){const B=await this.M.resolveLocalWorkspace(g.URI.file(R));if(B)return B.transient&&U.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:i.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:g.URI.file(R),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:Y||1}:void 0}}}else{if(N.isDirectory())return{workspace:(0,se.$j0b)(g.URI.file(R),N),type:i.FileType.Directory,exists:!0};if(!b.$i&&R==="/dev/null")return{fileUri:g.URI.file(R),type:i.FileType.File,exists:!0}}}catch(N){if(N.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.mb(R,U);const B=g.URI.file(R);if(this.L.removeRecentlyOpened([B]),U.ignoreFileNotFound)return{fileUri:B,type:i.FileType.File,exists:!1}}}async mb(R,U){const x=g.URI.file(R),{response:z,checkboxChecked:Y}=await this.O.showMessageBox({type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],message:(0,w.localize)(8,null,x.authority),detail:(0,w.localize)(9,null,(0,p.$Uv)(x,{os:b.OS,tildify:this.F})),checkboxLabel:(0,w.localize)(10,null,x.authority),cancelId:1});if(z===0){if((0,s.addUNCHostToAllowlist)(x.authority),Y){const N={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(N.channel,N.args),this.sendToOpeningWindow(N.channel,N.args)}return this.lb(R,U,!0)}if(z===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(R,U)}nb(R,U){const x=R.charCodeAt(0),z=U.remoteAuthority;let Y,N;U.gotoLineMode&&({path:R,line:Y,column:N}=(0,l.$bg)(R)),x!==47&&((0,l.$8f)(x)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,l.$1f)(R)),R=`/${R}`);const B=g.URI.from({scheme:v.Schemas.vscodeRemote,authority:z,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,le.$xi)(R))return U.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:Y?{startLineNumber:Y,startColumn:N||1}:void 0},remoteAuthority:U.remoteAuthority}:{workspace:(0,se.$i0b)(B),remoteAuthority:z};if(U.gotoLineMode||u.$gc.basename(R).indexOf(".")!==-1)return{fileUri:B,options:{selection:Y?{startLineNumber:Y,startColumn:N||1}:void 0},remoteAuthority:z}}return{workspace:(0,se.$j0b)(B),remoteAuthority:z}}ob(R){const U=this.J.getValue("window"),x=U?.openFoldersInNewWindow||"default",z=U?.openFilesInNewWindow||"off";let Y=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(x==="on"||x==="off")&&(Y=x==="on");let N=!1;return R.forceNewWindow||R.forceReuseWindow?N=!!R.forceNewWindow&&!R.forceReuseWindow:(b.$j?R.context===1&&(N=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!R.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(N=z==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(R,U){const x=(0,G.$g0b)(this.getWindows(),R);if(x)return this.H.reload(x,U.cli),x.focus(),[x];let z=U.cli["folder-uri"]||[],Y=U.cli["file-uri"]||[],N=U.cli._;if(!N.length&&!z.length&&!Y.length&&!U.cli.extensionTestsPath){const ce=this.r.state.lastPluginDevelopmentHostWindow,re=ce?.workspace??ce?.folderUri;re&&(g.URI.isUri(re)?re.scheme===v.Schemas.file?N=[re.fsPath]:z=[re.toString()]:re.configPath.scheme===v.Schemas.file?N=[(0,d.$ug)(re.configPath)]:Y=[re.configPath.toString()])}let B=U.remoteAuthority;for(const ce of R)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=g.URI.parse(ce),$e=(0,E.$_k)(re);$e&&(B?(0,d.$Lg)($e,B)||this.w.error("more than one extension development path authority"):B=$e)}N=N.filter(ce=>{const re=g.URI.file(ce);return(0,G.$f0b)(this.getWindows(),re)?!1:(0,d.$Lg)((0,E.$_k)(re),B)}),z=z.filter(ce=>{const re=this.fb(ce);return re&&(0,G.$f0b)(this.getWindows(),re)?!1:re?(0,d.$Lg)((0,E.$_k)(re),B):!1}),Y=Y.filter(ce=>{const re=this.fb(ce);return re&&(0,G.$f0b)(this.getWindows(),re)?!1:re?(0,d.$Lg)((0,E.$_k)(re),B):!1}),U.cli._=N,U.cli["folder-uri"]=z,U.cli["file-uri"]=Y;const _={context:U.context,cli:U.cli,forceNewWindow:!0,forceEmpty:!N.length&&!z.length&&!Y.length,userEnv:U.userEnv,noRecentEntry:!0,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:B,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile};return this.open(_)}async pb(R){const U=this.J.getValue("window"),x=this.getLastActiveWindow(),z=x?.profile??this.G.defaultProfile;let Y;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(Y=R.windowToUse||x,Y&&Y.focus());const N={...this.F.args,...R.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,u.$jc)(this.F.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.u,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:v.Schemas.file}).fsPath,product:O.default,isInitialStartup:R.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:U?.autoDetectHighContrast??!0,autoDetectColorScheme:U?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Y){const B=Y.config;!N.extensionDevelopmentPath&&B?.extensionDevelopmentPath&&(N.extensionDevelopmentPath=B.extensionDevelopmentPath,N.extensionDevelopmentKind=B.extensionDevelopmentKind,N["enable-proposed-api"]=B["enable-proposed-api"],N.verbose=B.verbose,N["inspect-extensions"]=B["inspect-extensions"],N["inspect-brk-extensions"]=B["inspect-brk-extensions"],N.debugId=B.debugId,N.extensionEnvironment=B.extensionEnvironment,N["extensions-dir"]=B["extensions-dir"],N["disable-extensions"]=B["disable-extensions"]),N.loggers={global:N.loggers.global,window:B?.loggers.window??N.loggers.window}}else{const B=this.r.getNewWindowState(N);(0,y.mark)("code/willCreateCodeWindow");const _=Y=this.N.createInstance(T.$q0b,{state:B,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(_),this.n.set(_.id,_),this.a.fire(_),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ce=new k.$Sc;ce.add(_.onDidSignalReady(()=>this.b.fire(_))),ce.add(f.Event.once(_.onDidClose)(()=>this.sb(_,ce))),ce.add(f.Event.once(_.onDidDestroy)(()=>this.tb(_))),ce.add(_.onDidMaximize(()=>this.g.fire(_))),ce.add(_.onDidUnmaximize(()=>this.h.fire(_))),ce.add(_.onDidEnterFullScreen(()=>this.j.fire(_))),ce.add(_.onDidLeaveFullScreen(()=>this.j.fire(_))),ce.add(_.onDidTriggerSystemContextMenu(({x:$e,y:me})=>this.m.fire({window:_,x:$e,y:me})));const re=(0,h.$Sf)(_.win?.webContents);re.removeAllListeners("devtools-reload-page"),re.on("devtools-reload-page",()=>this.H.reload(_)),this.H.registerWindow(_)}return N.windowId=Y.id,Y.isReady?this.H.unload(Y,4).then(async B=>{B||await this.qb(Y,N,R,z)}):await this.qb(Y,N,R,z),Y}async qb(R,U,x,z){if(U.extensionDevelopmentPath||((0,le.$hi)(U.workspace)?U.backupPath=this.I.registerWorkspaceBackup({workspace:U.workspace,remoteAuthority:U.remoteAuthority}):(0,le.$ci)(U.workspace)?U.backupPath=this.I.registerFolderBackup({folderUri:U.workspace.uri,remoteAuthority:U.remoteAuthority}):U.backupPath=this.I.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,se.$k0b)().id,remoteAuthority:U.remoteAuthority})),this.G.isEnabled()){const Y=U.workspace??(0,le.$gi)(U.backupPath,!1),N=this.rb(x,Y,z),B=N instanceof Promise?await N:N;U.profiles.profile=B,U.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Y,B)}R.load(U)}rb(R,U,x){return R.forceProfile?this.G.profiles.find(z=>z.name===R.forceProfile)??this.G.createNamedProfile(R.forceProfile):R.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(U)??x}sb(R,U){this.n.delete(R.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),U.dispose()}tb(R){this.n.delete(R.id),this.c.fire(R)}getFocusedWindow(){const R=P.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(R){return this.vb(this.getWindows().filter(U=>(0,d.$Lg)(U.remoteAuthority,R)))}vb(R){return(0,F.$b0b)(R)}sendToFocused(R,...U){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,S.CancellationToken.None,...U)}sendToOpeningWindow(R,...U){this.B(f.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(R,S.CancellationToken.None,...U)}))}sendToAll(R,U,x){for(const z of this.getWindows())x&&x.indexOf(z.id)>=0||z.sendWhenReady(R,S.CancellationToken.None,U)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(R){return this.n.get(R)}getWindowByWebContents(R){const U=P.BrowserWindow.fromWebContents(R);if(U)return this.getWindowById(U.id)}};e.$A$b=he,e.$A$b=he=Ee([ne(3,m.$mj),ne(4,W.$n0b),ne(5,C.$lO),ne(6,H.$In),ne(7,r.$X9b),ne(8,L.$c0b),ne(9,a.$s0b),ne(10,c.$39b),ne(11,t.$yi),ne(12,ue.$90b),ne(13,Z.$l0b),ne(14,n.$4h),ne(15,o.$49b),ne(16,i.$pk),ne(17,I.$69b),ne(18,X.$79b),ne(19,V.$99b)],he)}),define(oe[307],ae([0,1,66,29,83,57]),function(Q,e,P,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$b=void 0;let D=class{constructor(f,l,p,k){this.a=f,this.b=l,this.c=p,this.d=k,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,l){const p=this.b.getWindowById(f);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),l)}createUntitledWorkspace(f,l,p){return this.a.createUntitledWorkspace(l,p)}deleteUntitledWorkspace(f,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(f,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(f,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$C$b=D,e.$C$b=D=Ee([ne(0,M.$l0b),ne(1,A.$$9b),ne(2,s.$90b),ne(3,P.$39b)],D)}),define(oe[308],ae([0,1,15,132,37,26,17,51,14,33,3,42,47,2,13,9,4,12,7,32,158,43,159,111,290,162,66,283,18,200,91,133,55,117,220,24,64,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,71,27,59,294,95,34,275,82,123,28,251,253,54,49,265,288,300,289,301,128,267,268,269,272,297,60,29,306,274,30,97,83,307,57,39,233,56,244,53,81,130,277,292,280,8,255,276,228,69,296,271,22,126,295,263,239,62,65,303]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o,r,i,n,a,m,O,I,E,C,j,T,F,G,J,le,se,ue,Z,X,H,L,W,V,q,te,he,K,R,U,x,z,Y,N,B,_,ce,re,$e,me,ye,Pe,Le,ke,pe,ee,fe,ge,Ie,Me,Te,je,Je,Be,He,Ve,ie,de,be,Se,ve,Ae,We,qe,Qe,xe,Xe,Ye,nt,st,ot,pt,yt,vt,kt,Et,St,at,gt,Pt,It,Ct,ct,Dt,$t,lt,Ot,At,ut,Rt,ht,Mt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=void 0;let dt=class extends u.$Tc{static{ft=this}static{this.a={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,De,Re,we,Oe,Ne,ze,Ke,Ue,Fe,Ge,Ze){super(),this.g=Ce,this.h=De,this.j=Re,this.m=we,this.n=Oe,this.s=Ne,this.t=ze,this.u=Ke,this.w=Ue,this.y=Fe,this.z=Ge,this.C=Ze,this.D(),this.F()}D(){const Ce=Ue=>Ue?.startsWith(`${y.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ue,Fe,Ge,Ze)=>Ce(Ze.requestingUrl)?Ge(De.has(Fe)):Ge(!1)),P.session.defaultSession.setPermissionCheckHandler((Ue,Fe,Ge,Ze)=>Ce(Ze.requestingUrl)?De.has(Fe):!1);const Re=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Ue=>{for(let Fe=Ue;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Oe=Ue=>Ue.resourceType==="xhr"||we(Ue.frame),Ne=Ue=>{const Fe=Ue.frame;if(!Fe||!this.b)return!1;const Ge=P.BrowserWindow.getAllWindows();for(const Ze of Ge)if(Fe.processId===Ze.webContents.mainFrame.processId)return!0;return!1},ze=(Ue,Fe)=>{if(Ue.path!=="/index.html")return!0;const Ge=Fe.frame;if(!Ge||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Ge.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ue,Fe)=>{const Ge=h.URI.parse(Ue.url);return Ge.scheme===y.Schemas.vscodeWebview&&!ze(Ge,Ue)?(this.m.error("Blocked vscode-webview request",Ue.url),Fe({cancel:!0})):Ge.scheme===y.Schemas.vscodeFileResource&&!Ne(Ue)?(this.m.error("Blocked vscode-file request",Ue.url),Fe({cancel:!0})):Ge.path.endsWith(".svg")&&!Re.has(Ge.scheme)?Fe({cancel:!Oe(Ue)}):Fe({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ue,Fe)=>{const Ge=Ue.responseHeaders,Ze=Ge["content-type"]||Ge["Content-Type"];if(Ze&&Array.isArray(Ze)){const _e=h.URI.parse(Ue.url);if(_e.path.endsWith(".svg")&&Re.has(_e.scheme))return Ge["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:Ge});if(!_e.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ze.some(tt=>tt.toLowerCase().includes("image/svg")))return Fe({cancel:!Oe(Ue)})}return Fe({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ue,Fe)=>{if(Ue.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ge=Ue.responseHeaders??Object.create(null);if(Ge["Access-Control-Allow-Origin"]===void 0)return Ge["Access-Control-Allow-Origin"]=["*"],Fe({cancel:!1,responseHeaders:Ge})}return Fe({cancel:!1})});const Ke=P.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,b.$jc)(this.s.codeCachePath,"chrome")),$.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,f.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,f.$Z)(Re)||(0,f.$1)(Re)}),process.on("unhandledRejection",Re=>(0,f.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,w.$rU)(),P.app.on("accessibility-support-changed",(Re,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),P.app.on("activate",async(Re,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Re,we)=>{(0,ht.$09b)(we)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Oe=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Oe.preventDefault()}),we.setWindowOpenHandler(Oe=>Oe.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Oe.url}}`),this.f?.openExternal(void 0,Oe.url),{action:"deny"}))});let Ce=[],De;P.app.on("open-file",(Re,we)=>{this.m.trace("app#open-file: ",we),Re.preventDefault(),Ce.push((0,We.$xi)(we)?{workspaceUri:h.URI.file(we)}:{fileUri:h.URI.file(we)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],De=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$qU.handle("vscode:fetchShellEnv",Re=>{const we=this.b?.getWindowByWebContents(Re.sender);let Oe,Ne;return we?.config?(Oe=we.config,Ne={...process.env,...we.config.userEnv}):(Oe=this.s.args,Ne=process.env),this.X(Oe,Ne,!1)}),s.$qU.handle("vscode:writeNlsFile",(Re,we,Oe)=>{const Ne=this.G([we]);if(!Ne||typeof Oe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ne,D.$ie.fromString(Oe))}),s.$qU.handle("vscode:readNlsFile",async(Re,...we)=>{const Oe=this.G(we);if(!Oe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Oe)).value.toString()}),s.$qU.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),s.$qU.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),s.$qU.on("vscode:reloadWindow",Re=>Re.sender.reload()),s.$qU.handle("vscode:notifyZoomLevel",async(Re,we)=>{const Oe=this.b?.getWindowById(Re.sender.id);Oe&&Oe.notifyZoomLevel(we)})}G(Ce){let De;for(const Re of Ce)typeof Re=="string"&&(typeof De!="string"?De=Re:De=(0,b.$jc)(De,Re));if(!(typeof De!="string"||!(0,b.$ic)(De)||!(0,l.$7f)(De,this.s.cachedLanguagesPath,!$.$k)))return h.URI.file(De)}H(Ce){if(Ce){const De={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.m.error(Ce.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ce=this.z.win32AppUserModelId;$.$i&&Ce&&P.app.setAppUserModelId(Ce);try{$.$j&&this.u.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.m.error(Fe)}const De=new t.$xU;this.t.onWillShutdown(Fe=>{Fe.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,we]=await Promise.all([(0,gt.$K$b)(this.w,this.m),(0,gt.$L$b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:Oe,sharedProcessClient:Ne}=this.P(Re,we),ze=await this.Q(Re,we,Oe);this.B(ze.createInstance(r.$C0b)),this.B(ze.createInstance(Et.$G$b)),ze.invokeFunction(Fe=>this.R(Fe,De,Ne));const Ke=await ze.invokeFunction(Fe=>this.I(Fe,De));this.J(De),this.t.phase=2,await ze.invokeFunction(Fe=>this.S(Fe,Ke)),this.t.phase=3,this.U(),this.B(new at.$eh(()=>{this.B((0,at.$ih)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ce,De){const Re=this.b=Ce.get(Se.$$9b),we=Ce.get(Je.$fV),Oe=this.f=Ce.get(N.$W0b),Ne=Ce.get(C.$49b),ze=this;we.registerHandler({async handleURL(_e,tt){return ze.O(Re,Ne,we,_e,tt)}});const Ke=this.B(new Ae.$B$b({onDidOpenMainWindow:Oe.onDidOpenMainWindow,onDidFocusMainWindow:Oe.onDidFocusMainWindow,getActiveWindowId:()=>Oe.getActiveWindowId(-1)})),Ue=new c.$Mh(_e=>Ke.getActiveClientId().then(tt=>_e===tt)),Fe=new Be.$s$b(Ue,this.m),Ge=De.getChannel("urlHandler",Fe);we.registerHandler(new Be.$r$b(Ge));const Ze=await this.L(Re,Ne);return this.B(new Ve.$t$b(Ze?.urls,we,Re,this.s,this.z,this.m)),Ze}J(Ce){const De=()=>({statusCode:404,data:"Not found"}),Re=new Rt.$V(()=>Ce.getChannel(ut.$S$b,new ut.$T$b));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(we,Oe)=>{const Ne=h.URI.parse(we.url);if(!Ne.authority.startsWith("window:"))return Oe(De());Re.value.call(ut.$R$b,[Ne]).then(ze=>Oe({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),Oe({statusCode:500,data:String(ze)})})})}async L(Ce,De){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Re.length+we.length===0)return;const Oe=[...Re,...we].map(Ke=>{try{return{uri:h.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Ne=[],ze=[];for(const Ke of Oe){if(!Ke)continue;const Ue=this.N(Ke.uri);if(Ue)if(await this.M(Ue,Ce,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Ue),Ne.push(Ue);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),ze.push(Ke)}return{urls:ze,openables:Ne}}async M(Ce,De,Re){let we,Oe;if((0,be.$OC)(Ce)?(we=Ce.workspaceUri,Oe=(0,i.localize)(0,null,we.scheme===y.Schemas.file?(0,v.$Uv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,be.$PC)(Ce)?(we=Ce.folderUri,Oe=(0,i.localize)(1,null,we.scheme===y.Schemas.file?(0,v.$Uv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ce.fileUri,Oe=(0,i.localize)(2,null,we.scheme===y.Schemas.file?(0,v.$Uv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==y.Schemas.file&&we.scheme!==y.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ke}=await Re.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Oe,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===y.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ke){const Ue={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===y.Schemas.file?"local":"remote"};De.sendToFocused(Ue.channel,Ue.args),De.sendToOpeningWindow(Ue.channel,Ue.args)}return!1}N(Ce){if(Ce.path){if(Ce.authority===y.Schemas.file){const De=h.URI.file(Ce.fsPath);return(0,We.$xi)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ce.authority===y.Schemas.vscodeRemote){const De=Ce.path.indexOf(b.$gc.sep,1);if(De!==-1){const Re=Ce.path.substring(1,De),we=Ce.path.substring(De);let Oe=Ce.query;const Ne=new URLSearchParams(Ce.query);Ne.get("windowId")==="_blank"&&(Ne.delete("windowId"),Oe=Ne.toString());const ze=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:Re,path:we,query:Oe,fragment:Ce.fragment});return(0,We.$xi)(we)?{workspaceUri:ze}:/:[\d]+$/.test(we)?{fileUri:ze}:{folderUri:ze}}}}}async O(Ce,De,Re,we,Oe){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Oe),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:h.URI.parse(we.query).path,query:""}));let Ne=!1;const ze=new URLSearchParams(we.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze.delete("windowId"),we=we.with({query:ze.toString()}),Ne=!0):$.$j&&Ce.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ne=!0);const Ke=ze.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),ze.delete("continueOn"),we=we.with({query:ze.toString()}),this.s.continueOn=Ke??void 0);const Ue=this.N(we);return Ue?await this.M(Ue,Ce,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ue,we.toString(!0)),(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},urisToOpen:[Ue],forceNewWindow:Ne,gotoLineMode:!0}))?.focus(),!0):Ne?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,_.$_k)(we)}))?.ready(),Re.open(we,Oe)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Oe),!1)}P(Ce,De){const Re=this.B(this.j.createInstance(ce.$e$b,Ce,De)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ne=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$yU(Ne,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),we))(),sharedProcessClient:we}}async Q(Ce,De,Re){const we=new te.$3h;switch(process.platform){case"win32":we.set(fe.$pV,new V.$2h(je.$p$b));break;case"linux":$.$l?we.set(fe.$pV,new V.$2h(Te.$o$b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$pV,new V.$2h(Me.$n$b));break;case"darwin":we.set(fe.$pV,new V.$2h(Ie.$m$b));break}we.set(Se.$$9b,new V.$2h(ve.$A$b,[Ce,De,this.h],!1)),we.set(ht.$99b,new V.$2h(Mt.$U$b,void 0,!1));const Oe=new C.$59b(this.m,this.z);we.set(C.$49b,Oe),we.set(U.$30b,new V.$2h(U.$40b,void 0,!1)),we.set(E.$I0b,new V.$2h(E.$J0b,void 0,!1)),we.set(I.$Hm,c.ProxyChannel.toService((0,c.$Kh)(Re.then(Fe=>Fe.getChannel("diagnostics"))))),we.set(he.$ozb,new V.$2h(K.$Y0b,[this.h])),we.set(j.$_U,new V.$2h(T.$K0b)),we.set(R.$Z0b,new V.$2h(R.$10b)),we.set(N.$W0b,new V.$2h(N.$X0b,void 0,!1)),we.set(ie.$u$b,new V.$2h(de.$w$b)),we.set(Y.$_0b,new V.$2h(Y.$a$b)),we.set(le.$L0b,new V.$2h(se.$N0b)),we.set(ye.$y0b,new V.$2h(ye.$z0b)),we.set(ye.$A0b,new V.$2h(ye.$B0b));const Ne=new Ot.$Q$b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new At.$Wr(Ne,this.u,this.m,this.n);we.set(lt.$xr,ze),$.$i?we.set(ue.$O0b,new V.$2h(Z.$P0b)):$.$j?we.set(ue.$O0b,new V.$2h(Z.$Q0b)):$.$k&&we.set(ue.$O0b,new V.$2h(Z.$R0b));const Ke=new a.$D0b(this.s,this.u,this.m,this.w);we.set(n.$39b,Ke);const Ue=new Xe.$m0b(this.s,this.m,this.C,Ke,Oe);if(we.set(Xe.$l0b,Ue),we.set(qe.$ocb,new V.$2h(xe.$C$b,void 0,!1)),we.set(Qe.$90b,new V.$2h(Qe.$00b,void 0,!1)),we.set(Je.$fV,new V.$2h(He.$hV,void 0,!1)),(0,ee.$Ro)(this.z,this.s)){const Fe=(0,ee.$Wo)(this.z,this.u),Ge=(0,c.$Kh)(Re.then(rt=>rt.getChannel("telemetryAppender"))),Ze=new ke.$h$b(Ge),_e=(0,Pe.$Ho)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Ce,De,Fe),tt=(0,ee.$Xo)(this.s),it={appenders:[Ze],commonProperties:_e,piiPaths:tt,sendErrorTelemetry:!0};we.set(Le.$tl,new V.$2h(pe.$or,[it],!1))}else we.set(Le.$tl,ee.$Lo);return we.set(yt.$Up,new V.$2h(Pt.$sO,void 0,!0)),we.set(vt.$Yp,new V.$2h(kt.$F$b,void 0,!0)),we.set(ct.$O$b,new V.$2h(ct.$P$b,void 0,!0)),await at.Promises.settled([Ke.initialize(),Ue.initialize()]),this.j.createChild(we)}R(Ce,De,Re){const we=this.B(new u.$Sc),Oe=c.ProxyChannel.fromService(Ce.get(U.$30b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Oe);const Ne=c.ProxyChannel.fromService(Ce.get(E.$I0b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ne);const ze=new nt.$D$b(Ce.get(Ye.$In));De.registerChannel("policy",ze),Re.then(et=>et.registerChannel("policy",ze));const Ke=this.y.getProvider(y.Schemas.file);(0,d.$Rf)(Ke instanceof W.$Aq);const Ue=new L.$S0b(Ke,this.m,this.s);De.registerChannel(X.$bO,Ue),Re.then(et=>et.registerChannel(X.$bO,Ue));const Fe=c.ProxyChannel.fromService(Ce.get(st.$c0b),we);De.registerChannel("userDataProfiles",Fe),Re.then(et=>et.registerChannel("userDataProfiles",Fe));const Ge=new ot.$jr(Ce.get(pt.$gp));Re.then(et=>et.registerChannel("request",Ge));const Ze=new ge.$i$b(Ce.get(fe.$pV));De.registerChannel("update",Ze);const _e=c.ProxyChannel.fromService(Ce.get(he.$ozb),we);De.registerChannel("issue",_e);const tt=c.ProxyChannel.fromService(Ce.get(j.$_U),we);De.registerChannel("encryption",tt);const it=c.ProxyChannel.fromService(Ce.get(re.$hl),we);De.registerChannel("sign",it);const rt=c.ProxyChannel.fromService(Ce.get(R.$Z0b),we);De.registerChannel("keyboardLayout",rt),this.f=Ce.get(N.$W0b);const mt=c.ProxyChannel.fromService(this.f,we);De.registerChannel("nativeHost",mt),Re.then(et=>et.registerChannel("nativeHost",mt));const jt=c.ProxyChannel.fromService(Ce.get(qe.$ocb),we);De.registerChannel("workspaces",jt);const Lt=c.ProxyChannel.fromService(Ce.get(Y.$_0b),we);De.registerChannel("menubar",Lt);const Ut=c.ProxyChannel.fromService(Ce.get(Je.$fV),we);De.registerChannel("url",Ut);const Ft=c.ProxyChannel.fromService(Ce.get(ie.$u$b),we);De.registerChannel("webview",Ft);const wt=this.B(new me.$f$b(this.m,Ce.get(ye.$y0b)));De.registerChannel("storage",wt),Re.then(et=>et.registerChannel("storage",wt));const Wt=this.B(new St.$H$b(Ce.get(ye.$y0b),Ce.get(st.$c0b),this.m));Re.then(et=>et.registerChannel("profileStorageListener",Wt));const Tt=c.ProxyChannel.fromService(Ce.get(lt.$xr),we);De.registerChannel(lt.TerminalIpcChannels.LocalPty,Tt);const Nt=c.ProxyChannel.fromService(Ce.get(ue.$O0b),we);De.registerChannel("externalTerminal",Nt);const bt=new It.$M$b(Ce.get(Ct.$n0b));De.registerChannel("logger",bt),Re.then(et=>et.registerChannel("logger",bt));const zt=new O.$E0b(Ce.get(Se.$$9b));De.registerChannel("extensionhostdebugservice",zt);const Bt=c.ProxyChannel.fromService(Ce.get(le.$L0b),we);De.registerChannel(le.$M0b,Bt);const qt=c.ProxyChannel.fromService(Ce.get(ct.$O$b),we);De.registerChannel(Dt.$N$b,qt)}async S(Ce,De){const Re=this.b=Ce.get(Se.$$9b);this.c=Ce.get(ht.$99b);const we=(0,G.$5l)(process.env)?0:4,Oe=this.s.args;if(De){if(De.openables.length>0)return Re.open({context:we,cli:Oe,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const it of De.urls){const rt=new URLSearchParams(it.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:rt.toString()}),Re.open({context:we,cli:Oe,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,ze=Oe._.length,Ke=!!Oe["folder-uri"],Ue=!!Oe["file-uri"],Fe=Oe["skip-add-to-recently-opened"]===!0,Ge=Oe.wait&&Oe.waitMarkerFilePath?h.URI.file(Oe.waitMarkerFilePath):void 0,Ze=Oe.remote||void 0,_e=Oe.profile,tt=Oe["profile-temp"];if(!ze&&!Ke&&!Ue){if(Oe["new-window"]||_e||tt)return Re.open({context:we,cli:Oe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Fe,waitMarkerFileURI:Ge,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:tt});if(Ne.length)return Re.open({context:1,cli:Oe,urisToOpen:Ne.map(it=>(0,We.$xi)(it)?{workspaceUri:h.URI.file(it)}:{fileUri:h.URI.file(it)}),noRecentEntry:Fe,waitMarkerFileURI:Ge,initialStartup:!0})}return Re.open({context:we,cli:Oe,forceNewWindow:Oe["new-window"]||!ze&&Oe["unity-launch"],diffMode:Oe.diff,mergeMode:Oe.merge,noRecentEntry:Fe,waitMarkerFileURI:Ge,gotoLineMode:Oe.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:_e,forceTempProfile:tt})}U(){this.W(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ce,De)=>{De({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.X(this.s.args,process.env,!0),this.Y(),$.$j&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ce=this.z.win32MutexName;if($.$i&&Ce)try{const De=await new Promise((we,Oe)=>{Q(["@vscode/windows-mutex"],we,Oe)}),Re=new De.Mutex(Ce);p.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(De){this.m.error(De)}}async X(Ce,De,Re){try{return await(0,J.$$l)(this.u,this.m,Ce,De)}catch(we){const Oe=(0,S.$Pi)(we);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",Oe):this.m.error(Oe)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,k.$jn)(De)),Oe=(0,ee.$To)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Oe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.$pg)()}"`,"}"],ze=De.substring(0,De.length-2).concat(`,
`,Ne.join(`
`));await this.y.writeFile(this.s.argvResource,D.$ie.fromString(ze))}else{const Ne=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Oe},`);Ne!==De&&await this.y.writeFile(this.s.argvResource,D.$ie.fromString(Ne))}}catch(Ce){this.m.error(Ce)}}};e.$V$b=dt,e.$V$b=dt=ft=Ee([ne(2,q.$4h),ne(3,z.$mj),ne(4,z.$nj),ne(5,F.$X9b),ne(6,x.$s0b),ne(7,m.$yi),ne(8,$e.$lO),ne(9,H.$pk),ne(10,B.$Ej),ne(11,st.$c0b)],dt)}),define(oe[313],ae([0,1,15,46,7,22,8,51,14,33,3,47,13,9,68,4,36,25,21,43,99,308,10,18,238,250,24,64,202,16,222,93,78,218,92,20,225,5,79,27,80,278,127,287,53,286,95,249,34,54,70,56,39,234,232,2,40,266,69,227,116,122,270,264]),function(Q,e,P,A,s,M,D,S,f,l,p,k,v,u,y,b,$,d,h,g,w,c,t,o,r,i,n,a,m,O,I,E,C,j,T,F,G,J,le,se,ue,Z,X,H,L,W,V,q,te,he,K,R,U,x,z,Y,N,B,_,ce,re,$e,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(ke){console.error(ke.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(je=>console.error(je));const[ke,pe,ee,fe,ge,Ie,Me,Te]=this.b();try{try{await this.d(ee,Te,fe,ge,Me)}catch(je){throw this.f(ee,Me,je),je}await ke.invokeFunction(async je=>{const Je=je.get(J.$mj),Be=je.get(F.$s0b),He=je.get(O.$pk),Ve=je.get(J.$nj),ie=await this.e(Je,ee,Be,ke,Me,!0);return h.Promises.writeFile(ee.mainLockfile,String(process.pid)).catch(de=>{Je.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Ie.logger=Ve.createLogger("main",{name:(0,t.localize)(0,null)}),p.Event.once(Be.onWillShutdown)(de=>{He.dispose(),fe.dispose(),de.join("instanceLockfile",h.Promises.unlink(ee.mainLockfile).catch(()=>{}))}),ke.createInstance(c.$V$b,ie,pe).startup()})}catch(je){ke.invokeFunction(this.i,je)}}b(){const ke=new T.$3h,pe=new Y.$Sc;process.once("exit",()=>pe.dispose());const ee={_serviceBrand:void 0,...le.default};ke.set(se.$Ej,ee);const fe=new n.$Y9b(this.j(),ee),ge=this.c(fe);ke.set(n.$X9b,fe);const Ie=new _.$o0b((0,J.$Aj)(fe),fe.logsHome);ke.set(_.$n0b,Ie);const Me=new G.$G7b(Ie.getLogLevel()),Te=pe.add(new ce.$tO(Me,[new J.$tj(Ie.getLogLevel())]));ke.set(J.$mj,Te);const je=new I.$bq(Te);ke.set(O.$pk,je);const Je=new E.$Aq(Te);je.registerProvider(v.Schemas.file,Je);const Be=new B.$1r(je);ke.set(N.$Zk,Be);const He=new $e.$oO(1,fe,Te,je);ke.set(te.$kO,He),ke.set(te.$lO,He);const Ve=new R.$d0b(He,Be,fe,je,Te);ke.set(R.$c0b,Ve),je.registerProvider(v.Schemas.vscodeUserData,new me.$7$b(v.Schemas.file,Je,v.Schemas.vscodeUserData,Ve,Be,Te));const ie=b.$i&&ee.win32RegValueName?pe.add(new x.$5$b(Te,ee.win32RegValueName)):fe.policyFile?pe.add(new z.$6$b(fe.policyFile,je,Te)):new U.$Kn;ke.set(U.$In,ie);const de=new r.$$n(Ve.defaultProfile.settingsResource,je,ie,Te);return ke.set(o.$yi,de),ke.set(F.$s0b,new C.$2h(F.$t0b,void 0,!1)),ke.set(L.$gp,new C.$2h(W.$3$b,void 0,!0)),ke.set(K.$79b,new C.$2h(K.$89b)),ke.set(V.$hl,new C.$2h(q.$4$b,void 0,!1)),ke.set(X.$zv,new C.$2h(H.$1$b)),ke.set(ue.$69b,new Z.$X$b(fe,Ve,Te)),[new j.$Dq(ke,!0),ge,fe,de,He,Me,ee,Ve]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ee=>{const fe=process.env[ee];typeof fe=="string"&&(pe[ee]=fe)}),Object.assign(process.env,pe),pe}async d(ke,pe,ee,fe,ge){await D.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:v.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,ke.backupHome].map(Ie=>Ie?h.Promises.mkdir(Ie,{recursive:!0}):void 0)),fe.init(),ee.initialize()]),pe.init()}async e(ke,pe,ee,fe,ge,Ie){let Me;try{(0,y.mark)("code/willStartMainServer"),Me=await(0,w.$Zh)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),p.Event.once(ee.onWillShutdown)(()=>Me.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.f(pe,ge,Te),Te;let je;try{je=await(0,w.$1h)(pe.mainIPCHandle,"main")}catch(Ve){if(!Ie||b.$i||Ve.code!=="ECONNREFUSED")throw Ve.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),Ve;try{(0,A.unlinkSync)(pe.mainIPCHandle)}catch(ie){throw ke.warn("Could not delete obsolete instance handle",ie),ie}return this.e(ke,pe,ee,fe,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ve=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(Ve),je.dispose(),new Error(Ve)}let Je;!pe.args.wait&&!pe.args.status&&(Je=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const Be=g.ProxyChannel.toService(je.getChannel("launch"),{disableMarshalling:!0}),He=g.ProxyChannel.toService(je.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return fe.invokeFunction(async()=>{const Ve=new i.$8r(he.$Lo,ge),ie=await He.getMainDiagnostics(),de=await He.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),be=await Ve.getDiagnostics(ie,de);throw console.log(be),new f.$ab});throw b.$i&&await this.h(Be,ke),ke.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),je.dispose(),Je&&clearTimeout(Je),new f.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new f.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Me}f(ke,pe,ee){if(ee.code==="EACCES"||ee.code==="EPERM"){const fe=(0,M.$Hb)([ke.userDataPath,ke.extensionsPath,w.$Vh]).map(ge=>(0,k.$Uv)(s.URI.file(ge),{os:b.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$Pi)(ee),fe.join(`
`)),pe)}}g(ke,pe,ee){P.dialog.showMessageBoxSync((0,re.$9v)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:pe},ee).options)}async h(ke,pe){if(b.$i){const ee=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ee);try{(await new Promise((fe,ge)=>{Q(["windows-foreground-love"],fe,ge)})).allowSetForegroundWindow(ee)}catch(fe){pe.error(fe)}}}i(ke,pe){const ee=ke.get(J.$mj),fe=ke.get(F.$s0b);let ge=0;pe&&(pe.isExpected?pe.message&&ee.trace(pe.message):(ge=1,pe.stack?ee.error(pe.stack):ee.error(`Startup error: ${pe.toString()}`))),fe.kill(ge)}j(){const ke=this.k((0,a.$2l)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,m.$W$b)(ke.verbose);pe&&((0,a.$4l)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const ee=(0,$.cwd)(),fe=ke.map(Me=>{let Te=String(Me),je;pe&&(je=(0,l.$bg)(Te),Te=je.path),Te&&(Te=this.m(ee,Te));const Je=(0,l.$9f)(Te,ee),Be=(0,u.$nc)(Je);return Be&&!(0,l.$5f)(Be)?null:pe&&je?(je.path=Je,this.n(je)):Je}),ge=b.$i||b.$j,Ie=(0,M.$Mb)(fe,Me=>Me&&ge?Me.toLowerCase():Me||"");return(0,M.$Hb)(Ie)}m(ke,pe){return b.$i&&(pe=(0,d.$Te)(pe,'"')),pe=(0,d.$Re)((0,d.$Re)(pe," "),"	"),b.$i&&(pe=(0,u.$kc)(ke,pe),pe=(0,d.$Te)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/29bef5673ebb1fc3a59b90c9d8bfd2bc61c3f011/core/vs/code/electron-main/main.js.map
