/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],D=0,O=me.length;D<O;D++)e[D]=ke[me[D]];return e};define(ke[157],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,I=new Map,L=new Map,b=new Map;function $(v,S){v.has(S.detail)||v.set(S.detail,-S.timestamp)}function y(v,S){const h=v.get(S.detail);h&&(h>=0||v.set(S.detail,h+S.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((v,S)=>v.timestamp-S.timestamp));for(const v of R)switch(v.type){case 10:$(g,v);break;case 11:case 12:y(g,v);break;case 21:$(I,v);break;case 22:y(I,v);break;case 33:$(L,v);break;case 34:y(L,v);break;case 31:$(b,v);break;case 32:y(b,v);break}let C=0;L.forEach(v=>C+=v);function m(v){const S=[];return v.forEach((h,f)=>S.push([f,h])),S}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(L),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,I){let L="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),I.forEach($=>{$.forEach((y,R)=>{typeof y>"u"&&(y=$[R]="-");const C=y.toString().length;b[R]=Math.max(C,b[R])})}),g.forEach(($,y)=>{L+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),L+=`|
`,g.forEach(($,y)=>{L+=`| ${"-".repeat(b[y])} `}),L+=`|
`,I.forEach($=>{$.forEach((y,R)=>{typeof y<"u"&&(L+=`| ${y+" ".repeat(b[R]-y.toString().length)} `)}),L+=`|
`}),L}}e.$U=D}),define(ke[158],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(h,f,o){const i=O(h,f);if(i!==-1)return h[i]}e.$fb=D;function O(h,f,o=h.length-1){for(let i=o;i>=0;i--){const r=h[i];if(f(r))return i}return-1}e.$gb=O;function g(h,f){const o=I(h,f);return o===-1?void 0:h[o]}e.$hb=g;function I(h,f,o=0,i=h.length){let r=o,n=i;for(;r<n;){const c=Math.floor((r+n)/2);f(h[c])?r=c+1:n=c}return r-1}e.$ib=I;function L(h,f){const o=b(h,f);return o===h.length?void 0:h[o]}e.$jb=L;function b(h,f,o=0,i=h.length){let r=o,n=i;for(;r<n;){const c=Math.floor((r+n)/2);f(h[c])?n=c:r=c+1}return r}e.$kb=b;function $(h,f,o=0,i=h.length){const r=b(h,f,o,i);return r===h.length?-1:r}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const o=I(this.e,f,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=y;function R(h,f){if(h.length===0)return;let o=h[0];for(let i=1;i<h.length;i++){const r=h[i];f(r,o)>0&&(o=r)}return o}e.$nb=R;function C(h,f){if(h.length===0)return;let o=h[0];for(let i=1;i<h.length;i++){const r=h[i];f(r,o)>=0&&(o=r)}return o}e.$ob=C;function m(h,f){return R(h,(o,i)=>-f(o,i))}e.$pb=m;function v(h,f){if(h.length===0)return-1;let o=0;for(let i=1;i<h.length;i++){const r=h[i];f(r,h[o])>0&&(o=i)}return o}e.$qb=v;function S(h,f){for(const o of h){const i=f(o);if(i!==void 0)return i}}e.$rb=S}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(L,b){const $=Object.create(null);for(const y of L){const R=b(y);let C=$[R];C||(C=$[R]=[]),C.push(y)}return $}e.$K=D;function O(L,b){const $=[],y=[];for(const R of L)b.has(R)||$.push(R);for(const R of b)L.has(R)||y.push(R);return{removed:$,added:y}}e.$L=O;function g(L,b){const $=[],y=[];for(const[R,C]of L)b.has(R)||$.push(C);for(const[R,C]of b)L.has(R)||y.push(C);return{removed:$,added:y}}e.$M=g;function I(L,b){const $=new Set;for(const y of b)L.has(y)&&$.add(y);return $}e.$N=I}),define(ke[52],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function D(L){return(b,$,y)=>{let R=null,C=null;if(typeof y.value=="function"?(R="value",C=y.value):typeof y.get=="function"&&(R="get",C=y.get),!C)throw new Error("not supported");y[R]=L(C,$)}}function O(L,b,$){let y=null,R=null;if(typeof $.value=="function"?(y="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",R=$.get),!R)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[C]}}e.$wh=O;function g(L,b,$){return D((y,R)=>{const C=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...v){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...v),v=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,v),this[m]=$?$():void 0},L)}})}e.$xh=g;function I(L,b,$){return D((y,R)=>{const C=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,v=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...h){if(this[m]||(this[m]=$?$():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...h)),this[S])return;const f=this[v]+L;f<=Date.now()?(this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$yh=I}),define(ke[14],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function O(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=O;function g(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function I(c){y(c)||e.$X.onUnexpectedError(c)}e.$1=I;function L(c){y(c)||e.$X.onUnexpectedExternalError(c)}e.$2=L;function b(c){if(c instanceof Error){const{name:t,message:u}=c,s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:u,stack:s,noTelemetry:r.isErrorNoTelemetry(c)}}return c}e.$3=b;const $="Canceled";function y(c){return c instanceof R?!0:c instanceof Error&&c.name===$&&c.message===$}e.$4=y;class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function C(){const c=new Error($);return c.name=c.message,c}e.$6=C;function m(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=m;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=v;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=h;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const u=new r;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(ke[19],Se([1,0,14,158]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(de,ge=0){return de[de.length-(1+ge)]}e.$sb=g;function I(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=I;function L(de,ge,x=(te,G)=>te===G){if(de===ge)return!0;if(!de||!ge||de.length!==ge.length)return!1;for(let te=0,G=de.length;te<G;te++)if(!x(de[te],ge[te]))return!1;return!0}e.$ub=L;function b(de,ge){const x=de.length-1;ge<x&&(de[ge]=de[x]),de.pop()}e.$vb=b;function $(de,ge,x){return y(de.length,te=>x(de[te],ge))}e.$wb=$;function y(de,ge){let x=0,te=de-1;for(;x<=te;){const G=(x+te)/2|0,ie=ge(G);if(ie<0)x=G+1;else if(ie>0)te=G-1;else return G}return-(x+1)}e.$xb=y;function R(de,ge,x){if(de=de|0,de>=ge.length)throw new TypeError("invalid index");const te=ge[Math.floor(ge.length*Math.random())],G=[],ie=[],fe=[];for(const ve of ge){const Pe=x(ve,te);Pe<0?G.push(ve):Pe>0?ie.push(ve):fe.push(ve)}return de<G.length?R(de,G,x):de<G.length+fe.length?fe[0]:R(de-(G.length+fe.length),ie,x)}e.$yb=R;function C(de,ge){const x=[];let te;for(const G of de.slice(0).sort(ge))!te||ge(te[0],G)!==0?(te=[G],x.push(te)):te.push(G);return x}e.$zb=C;function*m(de,ge){let x,te;for(const G of de)te!==void 0&&ge(te,G)?x.push(G):(x&&(yield x),x=[G]),te=G;x&&(yield x)}e.$Ab=m;function v(de,ge){for(let x=0;x<=de.length;x++)ge(x===0?void 0:de[x-1],x===de.length?void 0:de[x])}e.$Bb=v;function S(de,ge){for(let x=0;x<de.length;x++)ge(x===0?void 0:de[x-1],de[x],x+1===de.length?void 0:de[x+1])}e.$Cb=S;function h(de,ge,x){const te=[];function G(ve,Pe,be){if(Pe===0&&be.length===0)return;const De=te[te.length-1];De&&De.start+De.deleteCount===ve?(De.deleteCount+=Pe,De.toInsert.push(...be)):te.push({start:ve,deleteCount:Pe,toInsert:be})}let ie=0,fe=0;for(;;){if(ie===de.length){G(ie,0,ge.slice(fe));break}if(fe===ge.length){G(ie,de.length-ie,[]);break}const ve=de[ie],Pe=ge[fe],be=x(ve,Pe);be===0?(ie+=1,fe+=1):be<0?(G(ie,1,[]),ie+=1):be>0&&(G(ie,0,[Pe]),fe+=1)}return te}e.$Db=h;function f(de,ge,x){const te=h(de,ge,x),G=[],ie=[];for(const fe of te)G.push(...de.slice(fe.start,fe.start+fe.deleteCount)),ie.push(...fe.toInsert);return{removed:G,added:ie}}e.$Eb=f;function o(de,ge,x){if(x===0)return[];const te=de.slice(0,x).sort(ge);return r(de,ge,te,x,de.length),te}e.top=o;function i(de,ge,x,te,G){return x===0?Promise.resolve([]):new Promise((ie,fe)=>{(async()=>{const ve=de.length,Pe=de.slice(0,x).sort(ge);for(let be=x,De=Math.min(x+te,ve);be<ve;be=De,De=Math.min(De+te,ve)){if(be>x&&await new Promise(z=>setTimeout(z)),G&&G.isCancellationRequested)throw new D.$5;r(de,ge,Pe,be,De)}return Pe})().then(ie,fe)})}e.$Gb=i;function r(de,ge,x,te,G){for(const ie=x.length;te<G;te++){const fe=de[te];if(ge(fe,x[ie-1])<0){x.pop();const ve=(0,O.$kb)(x,Pe=>ge(fe,Pe)<0);x.splice(ve,0,fe)}}}function n(de){return de.filter(ge=>!!ge)}e.$Hb=n;function c(de){let ge=0;for(let x=0;x<de.length;x++)de[x]&&(de[ge]=de[x],ge+=1);de.length=ge}e.$Ib=c;function t(de,ge,x){de.splice(x,0,de.splice(ge,1)[0])}e.$Jb=t;function u(de){return!Array.isArray(de)||de.length===0}e.$Kb=u;function s(de){return Array.isArray(de)&&de.length>0}e.$Lb=s;function l(de,ge=x=>x){const x=new Set;return de.filter(te=>{const G=ge(te);return x.has(G)?!1:(x.add(G),!0)})}e.$Mb=l;function a(de){const ge=new Set;return x=>{const te=de(x);return ge.has(te)?!1:(ge.add(te),!0)}}e.$Nb=a;function d(de,ge){return de.length>0?de[0]:ge}e.$Ob=d;function k(de,ge){return de.length>0?de[de.length-1]:ge}e.$Pb=k;function P(de,ge,x=(te,G)=>te===G){let te=0;for(let G=0,ie=Math.min(de.length,ge.length);G<ie&&x(de[G],ge[G]);G++)te++;return te}e.$Qb=P;function p(de){return[].concat(...de)}e.$Rb=p;function w(de,ge){let x=typeof ge=="number"?de:0;typeof ge=="number"?x=de:(x=0,ge=de);const te=[];if(x<=ge)for(let G=x;G<ge;G++)te.push(G);else for(let G=x;G>ge;G--)te.push(G);return te}e.$Sb=w;function E(de,ge,x){return de.reduce((te,G)=>(te[ge(G)]=x?x(G):G,te),Object.create(null))}e.$Tb=E;function A(de,ge){return de.push(ge),()=>T(de,ge)}e.$Ub=A;function T(de,ge){const x=de.indexOf(ge);if(x>-1)return de.splice(x,1),ge}e.$Vb=T;function U(de,ge,x){const te=de.slice(0,ge),G=de.slice(ge);return te.concat(x,G)}e.$Wb=U;function N(de,ge){let x;if(typeof ge=="number"){let te=ge;x=()=>{const G=Math.sin(te++)*179426549;return G-Math.floor(G)}}else x=Math.random;for(let te=de.length-1;te>0;te-=1){const G=Math.floor(x()*(te+1)),ie=de[te];de[te]=de[G],de[G]=ie}}e.$Xb=N;function j(de,ge){const x=de.indexOf(ge);x>-1&&(de.splice(x,1),de.unshift(ge))}e.$Yb=j;function F(de,ge){const x=de.indexOf(ge);x>-1&&(de.splice(x,1),de.push(ge))}e.$Zb=F;function M(de,ge){for(const x of ge)de.push(x)}e.$1b=M;function B(de,ge){return Array.isArray(de)?de.map(ge):ge(de)}e.$2b=B;function X(de){return Array.isArray(de)?de:[de]}e.$3b=X;function ue(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=ue;function Z(de,ge,x){const te=Y(de,ge),G=de.length,ie=x.length;de.length=G+ie;for(let fe=G-1;fe>=te;fe--)de[fe+ie]=de[fe];for(let fe=0;fe<ie;fe++)de[fe+te]=x[fe]}e.$5b=Z;function J(de,ge,x,te){const G=Y(de,ge);let ie=de.splice(G,x);return ie===void 0&&(ie=[]),Z(de,G,te),ie}e.$6b=J;function Y(de,ge){return ge<0?Math.max(ge+de.length,0):Math.min(ge,de.length)}var he;(function(de){function ge(ie){return ie<0}de.isLessThan=ge;function x(ie){return ie<=0}de.isLessThanOrEqual=x;function te(ie){return ie>0}de.isGreaterThan=te;function G(ie){return ie===0}de.isNeitherLessOrGreaterThan=G,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(he||(e.CompareResult=he={}));function _(de,ge){return(x,te)=>ge(de(x),de(te))}e.$7b=_;function we(...de){return(ge,x)=>{for(const te of de){const G=te(ge,x);if(!he.isNeitherLessOrGreaterThan(G))return G}return he.neitherLessOrGreaterThan}}e.$8b=we;const oe=(de,ge)=>de-ge;e.$9b=oe;const K=(de,ge)=>(0,e.$9b)(de?1:0,ge?1:0);e.$0b=K;function W(de){return(ge,x)=>-de(ge,x)}e.$$b=W;class re{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let x=this.c;for(;x<this.g.length&&ge(this.g[x]);)x++;const te=x===this.c?null:this.g.slice(this.c,x);return this.c=x,te}takeFromEndWhile(ge){let x=this.d;for(;x>=0&&ge(this.g[x]);)x--;const te=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const x=this.g.slice(this.c,this.c+ge);return this.c+=ge,x}}e.$_b=re;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(x=>(ge(x),!0))}toArray(){const ge=[];return this.iterate(x=>(ge.push(x),!0)),ge}filter(ge){return new ye(x=>this.iterate(te=>ge(te)?x(te):!0))}map(ge){return new ye(x=>this.iterate(te=>x(ge(te))))}some(ge){let x=!1;return this.iterate(te=>(x=ge(te),!x)),x}findFirst(ge){let x;return this.iterate(te=>ge(te)?(x=te,!1):!0),x}findLast(ge){let x;return this.iterate(te=>(ge(te)&&(x=te),!0)),x}findLastMaxBy(ge){let x,te=!0;return this.iterate(G=>((te||he.isGreaterThan(ge(G,x)))&&(te=!1,x=G),!0)),x}}e.$ac=ye}),define(ke[60],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function O($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=O;function g($,y="Unreachable"){throw new Error(y)}e.$6c=g;function I($){if(!$)throw new D.$cb("Assertion Failed")}e.$7c=I;function L($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$8c=L;function b($,y){let R=0;for(;R<$.length-1;){const C=$[R],m=$[R+1];if(!y(C,m))return!1;R++}return!0}e.$9c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(O,g){const I=this;let L=!1,b;return function(){if(L)return b;if(L=!0,g)try{b=O.apply(I,arguments)}finally{g()}else b=O.apply(I,arguments);return b}}e.$db=D}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$bN=D,e.$cN=new D("id#")}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(O){function g(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=g;const I=Object.freeze([]);function L(){return I}O.empty=L;function*b(t){yield t}O.single=b;function $(t){return g(t)?t:b(t)}O.wrap=$;function y(t){return t||I}O.from=y;function*R(t){for(let u=t.length-1;u>=0;u--)yield t[u]}O.reverse=R;function C(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}O.first=m;function v(t,u){for(const s of t)if(u(s))return!0;return!1}O.some=v;function S(t,u){for(const s of t)if(u(s))return s}O.find=S;function*h(t,u){for(const s of t)u(s)&&(yield s)}O.filter=h;function*f(t,u){let s=0;for(const l of t)yield u(l,s++)}O.map=f;function*o(...t){for(const u of t)yield*u}O.concat=o;function i(t,u,s){let l=s;for(const a of t)l=u(l,a);return l}O.reduce=i;function*r(t,u,s=t.length){for(u<0&&(u+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);u<s;u++)yield t[u]}O.slice=r;function n(t,u=Number.POSITIVE_INFINITY){const s=[];if(u===0)return[s,t];const l=t[Symbol.iterator]();for(let a=0;a<u;a++){const d=l.next();if(d.done)return[s,O.empty()];s.push(d.value)}return[s,{[Symbol.iterator](){return l}}]}O.consume=n;async function c(t){const u=[];for await(const s of t)u.push(s);return Promise.resolve(u)}O.asyncToArray=c})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function L(t,u=!1){let s=0;const l=t.length;let a="",d=0,k=16,P=0;function p(j){let F=0,M=0;for(;F<j;){const B=t.charCodeAt(s);if(B>=48&&B<=57)M=M*16+B-48;else if(B>=65&&B<=70)M=M*16+B-65+10;else if(B>=97&&B<=102)M=M*16+B-97+10;else break;s++,F++}return F<j&&(M=-1),M}function w(j){s=j,a="",d=0,k=16,P=0}function E(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return P=3,t.substring(j,s);let F=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;F=s}else P=3;return t.substring(j,F)}function A(){let j="",F=s;for(;;){if(s>=l){j+=t.substring(F,s),P=2;break}const M=t.charCodeAt(s);if(M===34){j+=t.substring(F,s),s++;break}if(M===92){if(j+=t.substring(F,s),s++,s>=l){P=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const X=p(4);X>=0?j+=String.fromCharCode(X):P=4;break}default:P=5}F=s;continue}if(M>=0&&M<=31)if($(M)){j+=t.substring(F,s),P=2;break}else P=6;s++}return j}function T(){if(a="",P=0,d=s,s>=l)return d=l,k=17;let j=t.charCodeAt(s);if(b(j)){do s++,a+=String.fromCharCode(j),j=t.charCodeAt(s);while(b(j));return k=15}if($(j))return s++,a+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),k=14;switch(j){case 123:return s++,k=1;case 125:return s++,k=2;case 91:return s++,k=3;case 93:return s++,k=4;case 58:return s++,k=6;case 44:return s++,k=5;case 34:return s++,a=A(),k=10;case 47:{const F=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<l&&!$(t.charCodeAt(s));)s++;return a=t.substring(F,s),k=12}if(t.charCodeAt(s+1)===42){s+=2;const M=l-1;let B=!1;for(;s<M;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,P=1),a=t.substring(F,s),k=13}return a+=String.fromCharCode(j),s++,k=16}case 45:if(a+=String.fromCharCode(j),s++,s===l||!y(t.charCodeAt(s)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=E(),k=11;default:for(;s<l&&U(j);)s++,j=t.charCodeAt(s);if(d!==s){switch(a=t.substring(d,s),a){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return a+=String.fromCharCode(j),s++,k=16}}function U(j){if(b(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let j;do j=T();while(j>=12&&j<=15);return j}return{setPosition:w,getPosition:()=>s,scan:u?N:T,getToken:()=>k,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>P}}e.$_m=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,u){const s=[],l=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function P(p,w,E,A){d.value=p,d.offset=w,d.length=E,d.type=A,d.colonOffset=void 0,a=d}try{r(t,{onObjectBegin:(p,w)=>{if(u<=p)throw l;a=void 0,k=u>p,s.push("")},onObjectProperty:(p,w,E)=>{if(u<w||(P(p,w,E,"property"),s[s.length-1]=p,u<=w+E))throw l},onObjectEnd:(p,w)=>{if(u<=p)throw l;a=void 0,s.pop()},onArrayBegin:(p,w)=>{if(u<=p)throw l;a=void 0,s.push(0)},onArrayEnd:(p,w)=>{if(u<=p)throw l;a=void 0,s.pop()},onLiteralValue:(p,w,E)=>{if(u<w||(P(p,w,E,c(p)),u<=w+E))throw l},onSeparator:(p,w,E)=>{if(u<=w)throw l;if(p===":"&&a&&a.type==="property")a.colonOffset=w,k=!1,a=void 0;else if(p===","){const A=s[s.length-1];typeof A=="number"?s[s.length-1]=A+1:(k=!0,s[s.length-1]=""),a=void 0}}})}catch(p){if(p!==l)throw p}return{path:s,previousNode:a,isAtPropertyKey:k,matches:p=>{let w=0;for(let E=0;w<p.length&&E<s.length;E++)if(p[w]===s[E]||p[w]==="*")w++;else if(p[w]!=="**")return!1;return w===p.length}}}e.$an=C;function m(t,u=[],s=I.DEFAULT){let l=null,a=[];const d=[];function k(p){Array.isArray(a)?a.push(p):l!==null&&(a[l]=p)}return r(t,{onObjectBegin:()=>{const p={};k(p),d.push(a),a=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const p=[];k(p),d.push(a),a=p,l=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:k,onError:(p,w,E)=>{u.push({error:p,offset:w,length:E})}},s),a[0]}e.$bn=m;function v(t,u=[],s=I.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){l.type==="property"&&(l.length=p-l.offset,l=l.parent)}function d(p){return l.children.push(p),p}r(t,{onObjectBegin:p=>{l=d({type:"object",offset:p,length:-1,parent:l,children:[]})},onObjectProperty:(p,w,E)=>{l=d({type:"property",offset:w,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:p,offset:w,length:E,parent:l})},onObjectEnd:(p,w)=>{l.length=p+w-l.offset,l=l.parent,a(p+w)},onArrayBegin:(p,w)=>{l=d({type:"array",offset:p,length:-1,parent:l,children:[]})},onArrayEnd:(p,w)=>{l.length=p+w-l.offset,l=l.parent,a(p+w)},onLiteralValue:(p,w,E)=>{d({type:c(p),offset:w,length:E,parent:l,value:p}),a(w+E)},onSeparator:(p,w,E)=>{l.type==="property"&&(p===":"?l.colonOffset=w:p===","&&a(w))},onError:(p,w,E)=>{u.push({error:p,offset:w,length:E})}},s);const P=l.children[0];return P&&delete P.parent,P}e.$cn=v;function S(t,u){if(!t)return;let s=t;for(const l of u)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===l){s=d.children[1],a=!0;break}if(!a)return}else{const a=l;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.$dn=S;function h(t){if(!t.parent||!t.parent.children)return[];const u=h(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;u.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&u.push(s)}return u}e.$en=h;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const u=Object.create(null);for(const s of t.children){const l=s.children[1];l&&(u[s.children[0].value]=f(l))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$fn=f;function o(t,u,s=!1){return u>=t.offset&&u<t.offset+t.length||s&&u===t.offset+t.length}e.$gn=o;function i(t,u,s=!1){if(o(t,u,s)){const l=t.children;if(Array.isArray(l))for(let a=0;a<l.length&&l[a].offset<=u;a++){const d=i(l[a],u,s);if(d)return d}return t}}e.$hn=i;function r(t,u,s=I.DEFAULT){const l=L(t,!1);function a(_){return _?()=>_(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(_){return _?we=>_(we,l.getTokenOffset(),l.getTokenLength()):()=>!0}const k=a(u.onObjectBegin),P=d(u.onObjectProperty),p=a(u.onObjectEnd),w=a(u.onArrayBegin),E=a(u.onArrayEnd),A=d(u.onLiteralValue),T=d(u.onSeparator),U=a(u.onComment),N=d(u.onError),j=s&&s.disallowComments,F=s&&s.allowTrailingComma;function M(){for(;;){const _=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:j||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(_){case 12:case 13:j?B(10):U();break;case 16:B(1);break;case 15:case 14:break;default:return _}}}function B(_,we=[],oe=[]){if(N(_),we.length+oe.length>0){let K=l.getToken();for(;K!==17;){if(we.indexOf(K)!==-1){M();break}else if(oe.indexOf(K)!==-1)break;K=M()}}}function X(_){const we=l.getTokenValue();return _?A(we):P(we),M(),!0}function ue(){switch(l.getToken()){case 11:{let _=0;try{_=JSON.parse(l.getTokenValue()),typeof _!="number"&&(B(2),_=0)}catch{B(2)}A(_);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return M(),!0}function Z(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(X(!1),l.getToken()===6?(T(":"),M(),he()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function J(){k(),M();let _=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(_||B(4,[],[]),T(","),M(),l.getToken()===2&&F)break}else _&&B(6,[],[]);Z()||B(4,[],[2,5]),_=!0}return p(),l.getToken()!==2?B(7,[2],[]):M(),!0}function Y(){w(),M();let _=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(_||B(4,[],[]),T(","),M(),l.getToken()===4&&F)break}else _&&B(6,[],[]);he()||B(4,[],[4,5]),_=!0}return E(),l.getToken()!==4?B(8,[4],[]):M(),!0}function he(){switch(l.getToken()){case 3:return Y();case 1:return J();case 10:return X(!0);default:return ue()}}return M(),l.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):he()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.$in=r;function n(t,u){const s=L(t),l=[];let a,d=0,k;do switch(k=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:d!==k&&l.push(t.substring(d,k)),u!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,u)),d=s.getPosition();break}while(a!==17);return l.join("")}e.$jn=n;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$kn=c}),define(ke[43],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const L=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,L){const b=new D(I);if(this.a===D.Undefined)this.a=b,this.b=b;else if(L){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const L=I.prev;L.next=I.next,I.next.prev=L}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$4c=O}),define(ke[28],Se([1,0]),function(me,e){"use strict";var D,O,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(r,n,c){let t=r.get(n);return t===void 0&&(t=c,r.set(n,t)),t}e.$xc=I;function L(r){const n=[];return r.forEach((c,t)=>{n.push(`${t} => ${c}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=L;function b(r){const n=[];return r.forEach(c=>{n.push(c)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,c){this.uri=n,this.value=c}}function y(r){return Array.isArray(r)}class R{static{this.c=n=>n.toString()}constructor(n,c){if(this[D]="ResourceMap",n instanceof R)this.d=new Map(n.d),this.e=c??R.c;else if(y(n)){this.d=new Map,this.e=c??R.c;for(const[t,u]of n)this.set(t,u)}else this.d=new Map,this.e=n??R.c}set(n,c){return this.d.set(this.e(n),new $(n,c)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,c){typeof c<"u"&&(n=n.bind(c));for(const[t,u]of this.d)n(u.value,u.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=R;class C{constructor(n,c){this[O]="ResourceSet",!n||typeof n=="function"?this.c=new R(n):(this.c=new R(c),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,c){this.c.forEach((t,u)=>n.call(c,u,u,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[g]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,c=0){const t=this.c.get(n);if(t)return c!==0&&this.l(t,c),t.value}set(n,c,t=0){let u=this.c.get(n);if(u)u.value=c,t!==0&&this.l(u,t);else{switch(u={key:n,value:c,next:void 0,previous:void 0},t){case 0:this.j(u);break;case 1:this.i(u);break;case 2:this.j(u);break;default:this.j(u);break}this.c.set(n,u),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const c=this.c.get(n);if(c)return this.c.delete(n),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,c){const t=this.g;let u=this.d;for(;u;){if(c?n.bind(c)(u.value,u.key,this):n(u.value,u.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}values(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}entries(){const n=this,c=this.g;let t=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return u}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>n;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const c=n.next,t=n.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}n.next=void 0,n.previous=void 0,this.g++}l(n,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(n===this.d)return;const t=n.next,u=n.previous;n===this.e?(u.next=void 0,this.e=u):(t.previous=u,u.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(c===2){if(n===this.e)return;const t=n.next,u=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=u,u.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((c,t)=>{n.push([t,c])}),n}fromJSON(n){this.clear();for(const[c,t]of n)this.set(c,t)}}e.$Cc=v;class S extends v{constructor(n,c=1){super(),this.m=n,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,c=2){return super.get(n,c)}peek(n){return super.get(n,0)}set(n,c){return super.set(n,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class h{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let c=this.c.get(n)||0;return c===0?!1:(c--,c===0?this.c.delete(n):this.c.set(n,c),!0)}has(n){return this.c.has(n)}}e.$Ec=h;class f{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[c,t]of n)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(n,c){this.c.set(n,c),this.d.set(c,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const c=this.c.get(n);return c===void 0?!1:(this.c.delete(n),this.d.delete(c),!0)}forEach(n,c){this.c.forEach((t,u)=>{n.call(c,t,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=f;class o{constructor(){this.c=new Map}add(n,c){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(c)}delete(n,c){const t=this.c.get(n);t&&(t.delete(c),t.size===0&&this.c.delete(n))}forEach(n,c){const t=this.c.get(n);t&&t.forEach(c)}get(n){const c=this.c.get(n);return c||new Set}}e.$Gc=o;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[c,t]of r)if(!n.has(c)||n.get(c)!==t)return!1;for(const[c]of n)if(!r.has(c))return!1;return!0}e.$Hc=i}),define(ke[3],Se([1,0,19,73,28,74,53]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(A){let T=this.b.get(A);return T||(T={parent:null,source:null,isSingleton:!1,value:A,idx:y.a++},this.b.set(A,T)),T}trackDisposable(A){const T=this.c(A);T.source||(T.source=new Error().stack)}setParent(A,T){const U=this.c(A);U.parent=T}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,T){const U=T.get(A);if(U)return U;const N=A.parent?this.f(this.c(A.parent),T):A;return T.set(A,N),N}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,A).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(A=10,T){let U;if(T)U=T;else{const B=new Map,X=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,B).isSingleton);if(X.length===0)return;const ue=new Set(X.map(Z=>Z.value));if(U=X.filter(Z=>!(Z.parent&&ue.has(Z.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function N(B){function X(Z,J){for(;Z.length>0&&J.some(Y=>typeof Y=="string"?Y===Z[0]:Z[0].match(Y));)Z.shift()}const ue=B.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return X(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const j=new g.$Gc;for(const B of U){const X=N(B);for(let ue=0;ue<=X.length;ue++)j.add(X.slice(0,ue).join(`
`),B)}U.sort((0,D.$7b)(B=>B.idx,D.$9b));let F="",M=0;for(const B of U.slice(0,A)){M++;const X=N(B),ue=[];for(let Z=0;Z<X.length;Z++){let J=X[Z];J=`(shared with ${j.get(X.slice(0,Z+1).join(`
`)).size}/${U.length} leaks) at ${J}`;const he=j.get(X.slice(0,Z).join(`
`)),_=(0,O.$K)([...he].map(we=>N(we)[Z]),we=>we);delete _[X[Z]];for(const[we,oe]of Object.entries(_))ue.unshift(`    - stacktraces of ${oe.length} other leaks continue with ${we}`);ue.unshift(J)}F+=`


==================== Leaking disposable ${M}/${U.length}: ${B.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return U.length>A&&(F+=`


... and ${U.length-A} more leaking disposables

`),{leaks:U,details:F}}}e.$Ic=y;function R(E){$=E}if(e.$Jc=R,b){const E="__is_disposable_tracked__";R(new class{trackDisposable(A){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[E]||console.log(T)},3e3)}setParent(A,T){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsSingleton(A){}})}function C(E){return $?.trackDisposable(E),E}e.$Kc=C;function m(E){$?.markAsDisposed(E)}e.$Lc=m;function v(E,A){$?.setParent(E,A)}function S(E,A){if($)for(const T of E)$.setParent(T,A)}function h(E){return $?.markAsSingleton(E),E}e.$Mc=h;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Nc=f;function o(E){if(L.Iterable.is(E)){const A=[];for(const T of E)if(T)try{T.dispose()}catch(U){A.push(U)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Oc=o;function i(E){for(const A of E)f(A)&&A.dispose();return[]}e.$Pc=i;function r(...E){const A=n(()=>o(E));return S(E,A),A}e.$Qc=r;function n(E){const A=C({dispose:(0,I.$db)(()=>{m(A),E()})});return A}e.$Rc=n;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return v(A,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),v(A,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),v(this.q,this)}dispose(){m(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Tc=t;class u{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&v(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&v(A,null),A}}e.$Uc=u;class s{constructor(A){this.a=new u,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class l{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=l;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(A){let T=A;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,m(this))},this}}e.$Xc=a;class d{constructor(){this.a=new Map}acquire(A,...T){let U=this.a.get(A);U||(U={counter:0,object:this.b(A,...T)},this.a.set(A,U));const{object:N}=U,j=(0,I.$db)(()=>{--U.counter===0&&(this.c(A,U.object),this.a.delete(A))});return U.counter++,{object:N,dispose:j}}}e.$Yc=d;class k{constructor(A){this.a=A}async acquire(A,...T){const U=this.a.acquire(A,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(N){throw U.dispose(),N}}}e.$Zc=k;class P{constructor(A){this.object=A}dispose(){}}e.$1c=P;function p(E){const A=new c;try{E(A)}finally{A.dispose()}}e.$2c=p;class w{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(A)?.dispose(),this.a.set(A,T)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=w}),function(me,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,x){for(var te=0;te<x.length;te++){var G=x[te];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ge,G.key,G)}}function D(ge,x,te){return x&&e(ge.prototype,x),te&&e(ge,te),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function O(ge,x){if(ge){if(typeof ge=="string")return g(ge,x);var te=Object.prototype.toString.call(ge).slice(8,-1);if(te==="Object"&&ge.constructor&&(te=ge.constructor.name),te==="Map"||te==="Set")return Array.from(ge);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return g(ge,x)}}function g(ge,x){(x==null||x>ge.length)&&(x=ge.length);for(var te=0,G=new Array(x);te<x;te++)G[te]=ge[te];return G}function I(ge,x){var te=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(te)return(te=te.call(ge)).next.bind(te);if(Array.isArray(ge)||(te=O(ge))||x&&ge&&typeof ge.length=="number"){te&&(ge=te);var G=0;return function(){return G>=ge.length?{done:!0}:{done:!1,value:ge[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function b(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(x){return m[x]};function S(ge,x){if(x){if($.test(ge))return ge.replace(y,v)}else if(R.test(ge))return ge.replace(C,v);return ge}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(h,function(x,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ge,x){ge=typeof ge=="string"?ge:ge.source,x=x||"";var te={replace:function(ie,fe){return fe=fe.source||fe,fe=fe.replace(o,"$1"),ge=ge.replace(ie,fe),te},getRegex:function(){return new RegExp(ge,x)}};return te}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ge,x,te){if(ge){var G;try{G=decodeURIComponent(f(te)).replace(r,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}x&&!n.test(te)&&(te=a(x,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},u=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ge,x){t[" "+ge]||(u.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=p(ge,"/",!0)),ge=t[" "+ge];var te=ge.indexOf(":")===-1;return x.substring(0,2)==="//"?te?x:ge.replace(s,"$1")+x:x.charAt(0)==="/"?te?x:ge.replace(l,"$1")+x:ge+x}var d={exec:function(){}};function k(ge){for(var x=1,te,G;x<arguments.length;x++){te=arguments[x];for(G in te)Object.prototype.hasOwnProperty.call(te,G)&&(ge[G]=te[G])}return ge}function P(ge,x){var te=ge.replace(/\|/g,function(fe,ve,Pe){for(var be=!1,De=ve;--De>=0&&Pe[De]==="\\";)be=!be;return be?"|":" |"}),G=te.split(/ \|/),ie=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>x)G.splice(x);else for(;G.length<x;)G.push("");for(;ie<G.length;ie++)G[ie]=G[ie].trim().replace(/\\\|/g,"|");return G}function p(ge,x,te){var G=ge.length;if(G===0)return"";for(var ie=0;ie<G;){var fe=ge.charAt(G-ie-1);if(fe===x&&!te)ie++;else if(fe!==x&&te)ie++;else break}return ge.slice(0,G-ie)}function w(ge,x){if(ge.indexOf(x[1])===-1)return-1;for(var te=ge.length,G=0,ie=0;ie<te;ie++)if(ge[ie]==="\\")ie++;else if(ge[ie]===x[0])G++;else if(ge[ie]===x[1]&&(G--,G<0))return ie;return-1}function E(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ge,x){if(x<1)return"";for(var te="";x>1;)x&1&&(te+=ge),x>>=1,ge+=ge;return te+ge}function T(ge,x,te,G){var ie=x.href,fe=x.title?S(x.title):null,ve=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){G.state.inLink=!0;var Pe={type:"link",raw:te,href:ie,title:fe,text:ve,tokens:G.inlineTokens(ve)};return G.state.inLink=!1,Pe}return{type:"image",raw:te,href:ie,title:fe,text:S(ve)}}function U(ge,x){var te=ge.match(/^(\s+)(?:```)/);if(te===null)return x;var G=te[1];return x.split(`
`).map(function(ie){var fe=ie.match(/^\s+/);if(fe===null)return ie;var ve=fe[0];return ve.length>=G.length?ie.slice(G.length):ie}).join(`
`)}var N=function(){function ge(te){this.options=te||me.defaults}var x=ge.prototype;return x.space=function(G){var ie=this.rules.block.newline.exec(G);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},x.code=function(G){var ie=this.rules.block.code.exec(G);if(ie){var fe=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:p(fe,`
`)}}},x.fences=function(G){var ie=this.rules.block.fences.exec(G);if(ie){var fe=ie[0],ve=U(fe,ie[3]||"");return{type:"code",raw:fe,lang:ie[2]?ie[2].trim():ie[2],text:ve}}},x.heading=function(G){var ie=this.rules.block.heading.exec(G);if(ie){var fe=ie[2].trim();if(/#$/.test(fe)){var ve=p(fe,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(fe=ve.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:fe,tokens:this.lexer.inline(fe)}}},x.hr=function(G){var ie=this.rules.block.hr.exec(G);if(ie)return{type:"hr",raw:ie[0]}},x.blockquote=function(G){var ie=this.rules.block.blockquote.exec(G);if(ie){var fe=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},x.list=function(G){var ie=this.rules.block.list.exec(G);if(ie){var fe,ve,Pe,be,De,z,Q,ee,V,ae,le,Re,je=ie[1].trim(),He=je.length>1,Je={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Re=!1,!(!(ie=_e.exec(G))||this.rules.block.hr.test(G)));){if(fe=ie[0],G=G.substring(fe.length),ee=ie[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(be=2,le=ee.trimLeft()):(be=ie[2].search(/[^ ]/),be=be>4?1:be,le=ee.slice(be),be+=ie[1].length),z=!1,!ee&&/^ *$/.test(V)&&(fe+=V+`
`,G=G.substring(V.length+1),Re=!0),!Re)for(var ct=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),Ae=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");G&&(ae=G.split(`
`,1)[0],ee=ae,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(ee)||Ae.test(ee)||ct.test(ee)||ot.test(G)));){if(ee.search(/[^ ]/)>=be||!ee.trim())le+=`
`+ee.slice(be);else if(!z)le+=`
`+ee;else break;!z&&!ee.trim()&&(z=!0),fe+=ae+`
`,G=G.substring(ae.length+1)}Je.loose||(Q?Je.loose=!0:/\n *\n *$/.test(fe)&&(Q=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(le),ve&&(Pe=ve[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:fe,task:!!ve,checked:Pe,loose:!1,text:le}),Je.raw+=fe}Je.items[Je.items.length-1].raw=fe.trimRight(),Je.items[Je.items.length-1].text=le.trimRight(),Je.raw=Je.raw.trimRight();var Ue=Je.items.length;for(De=0;De<Ue;De++){this.lexer.state.top=!1,Je.items[De].tokens=this.lexer.blockTokens(Je.items[De].text,[]);var Le=Je.items[De].tokens.filter(function(ne){return ne.type==="space"}),Ye=Le.every(function(ne){for(var ce=ne.raw.split(""),Ie=0,Ve=I(ce),Xe;!(Xe=Ve()).done;){var nt=Xe.value;if(nt===`
`&&(Ie+=1),Ie>1)return!0}return!1});!Je.loose&&Le.length&&Ye&&(Je.loose=!0,Je.items[De].loose=!0)}return Je}},x.html=function(G){var ie=this.rules.block.html.exec(G);if(ie){var fe={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]);fe.type="paragraph",fe.text=ve,fe.tokens=this.lexer.inline(ve)}return fe}},x.def=function(G){var ie=this.rules.block.def.exec(G);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var fe=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:ie[0],href:ie[2],title:ie[3]}}},x.table=function(G){var ie=this.rules.block.table.exec(G);if(ie){var fe={type:"table",header:P(ie[1]).map(function(Q){return{text:Q}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ie[0];var ve=fe.align.length,Pe,be,De,z;for(Pe=0;Pe<ve;Pe++)/^ *-+: *$/.test(fe.align[Pe])?fe.align[Pe]="right":/^ *:-+: *$/.test(fe.align[Pe])?fe.align[Pe]="center":/^ *:-+ *$/.test(fe.align[Pe])?fe.align[Pe]="left":fe.align[Pe]=null;for(ve=fe.rows.length,Pe=0;Pe<ve;Pe++)fe.rows[Pe]=P(fe.rows[Pe],fe.header.length).map(function(Q){return{text:Q}});for(ve=fe.header.length,be=0;be<ve;be++)fe.header[be].tokens=this.lexer.inline(fe.header[be].text);for(ve=fe.rows.length,be=0;be<ve;be++)for(z=fe.rows[be],De=0;De<z.length;De++)z[De].tokens=this.lexer.inline(z[De].text);return fe}}},x.lheading=function(G){var ie=this.rules.block.lheading.exec(G);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},x.paragraph=function(G){var ie=this.rules.block.paragraph.exec(G);if(ie){var fe=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:fe,tokens:this.lexer.inline(fe)}}},x.text=function(G){var ie=this.rules.block.text.exec(G);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},x.escape=function(G){var ie=this.rules.inline.escape.exec(G);if(ie)return{type:"escape",raw:ie[0],text:S(ie[1])}},x.tag=function(G){var ie=this.rules.inline.tag.exec(G);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]):ie[0]}},x.link=function(G){var ie=this.rules.inline.link.exec(G);if(ie){var fe=ie[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ve=p(fe.slice(0,-1),"\\");if((fe.length-ve.length)%2===0)return}else{var Pe=w(ie[2],"()");if(Pe>-1){var be=ie[0].indexOf("!")===0?5:4,De=be+ie[1].length+Pe;ie[2]=ie[2].substring(0,Pe),ie[0]=ie[0].substring(0,De).trim(),ie[3]=""}}var z=ie[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);ee&&(z=ee[1],Q=ee[3])}else Q=ie[3]?ie[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(fe)?z=z.slice(1):z=z.slice(1,-1)),T(ie,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},x.reflink=function(G,ie){var fe;if((fe=this.rules.inline.reflink.exec(G))||(fe=this.rules.inline.nolink.exec(G))){var ve=(fe[2]||fe[1]).replace(/\s+/g," ");if(ve=ie[ve.toLowerCase()],!ve||!ve.href){var Pe=fe[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return T(fe,ve,fe[0],this.lexer)}},x.emStrong=function(G,ie,fe){fe===void 0&&(fe="");var ve=this.rules.inline.emStrong.lDelim.exec(G);if(ve&&!(ve[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=ve[1]||ve[2]||"";if(!Pe||Pe&&(fe===""||this.rules.inline.punctuation.exec(fe))){var be=ve[0].length-1,De,z,Q=be,ee=0,V=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ie=ie.slice(-1*G.length+be);(ve=V.exec(ie))!=null;)if(De=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!De){if(z=De.length,ve[3]||ve[4]){Q+=z;continue}else if((ve[5]||ve[6])&&be%3&&!((be+z)%3)){ee+=z;continue}if(Q-=z,!(Q>0)){if(z=Math.min(z,z+Q+ee),Math.min(be,z)%2){var ae=G.slice(1,be+ve.index+z);return{type:"em",raw:G.slice(0,be+ve.index+z+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var le=G.slice(2,be+ve.index+z-1);return{type:"strong",raw:G.slice(0,be+ve.index+z+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},x.codespan=function(G){var ie=this.rules.inline.code.exec(G);if(ie){var fe=ie[2].replace(/\n/g," "),ve=/[^ ]/.test(fe),Pe=/^ /.test(fe)&&/ $/.test(fe);return ve&&Pe&&(fe=fe.substring(1,fe.length-1)),fe=S(fe,!0),{type:"codespan",raw:ie[0],text:fe}}},x.br=function(G){var ie=this.rules.inline.br.exec(G);if(ie)return{type:"br",raw:ie[0]}},x.del=function(G){var ie=this.rules.inline.del.exec(G);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},x.autolink=function(G,ie){var fe=this.rules.inline.autolink.exec(G);if(fe){var ve,Pe;return fe[2]==="@"?(ve=S(this.options.mangle?ie(fe[1]):fe[1]),Pe="mailto:"+ve):(ve=S(fe[1]),Pe=ve),{type:"link",raw:fe[0],text:ve,href:Pe,tokens:[{type:"text",raw:ve,text:ve}]}}},x.url=function(G,ie){var fe;if(fe=this.rules.inline.url.exec(G)){var ve,Pe;if(fe[2]==="@")ve=S(this.options.mangle?ie(fe[0]):fe[0]),Pe="mailto:"+ve;else{var be;do be=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(be!==fe[0]);ve=S(fe[0]),fe[1]==="www."?Pe="http://"+ve:Pe=ve}return{type:"link",raw:fe[0],text:ve,href:Pe,tokens:[{type:"text",raw:ve,text:ve}]}}},x.inlineText=function(G,ie){var fe=this.rules.inline.text.exec(G);if(fe){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]:ve=S(this.options.smartypants?ie(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ve}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=i(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=i(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=i(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=i(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=i(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=i(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=i(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=i(F.reflink).replace("label",F._label).replace("ref",j._label).getRegex(),F.nolink=i(F.nolink).replace("ref",j._label).getRegex(),F.reflinkSearch=i(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=k({},F),F.pedantic=k({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=k({},F.normal,{escape:i(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=i(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=k({},F.gfm,{br:i(F.br).replace("{2,}","*").getRegex(),text:i(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ge){var x="",te,G,ie=ge.length;for(te=0;te<ie;te++)G=ge.charCodeAt(te),Math.random()>.5&&(G="x"+G.toString(16)),x+="&#"+G+";";return x}var X=function(){function ge(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||me.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:F.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=F.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=F.breaks:G.inline=F.gfm),this.tokenizer.rules=G}ge.lex=function(G,ie){var fe=new ge(ie);return fe.lex(G)},ge.lexInline=function(G,ie){var fe=new ge(ie);return fe.inlineTokens(G)};var x=ge.prototype;return x.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},x.blockTokens=function(G,ie){var fe=this;ie===void 0&&(ie=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Q,ee,V){return ee+"    ".repeat(V.length)});for(var ve,Pe,be,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(ve=Q.call({lexer:fe},G,ie))?(G=G.substring(ve.raw.length),ie.push(ve),!0):!1}))){if(ve=this.tokenizer.space(G)){G=G.substring(ve.raw.length),ve.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(ve);continue}if(ve=this.tokenizer.code(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(ve);continue}if(ve=this.tokenizer.fences(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.heading(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.hr(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.blockquote(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.list(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.html(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.def(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.lheading(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(be=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=G.slice(1),V=void 0;fe.options.extensions.startBlock.forEach(function(ae){V=ae.call({lexer:this},ee),typeof V=="number"&&V>=0&&(Q=Math.min(Q,V))}),Q<1/0&&Q>=0&&(be=G.substring(0,Q+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(be))){Pe=ie[ie.length-1],De&&Pe.type==="paragraph"?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(ve),De=be.length!==G.length,G=G.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+ve.raw,Pe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):ie.push(ve);continue}if(G){var z="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,ie},x.inline=function(G,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:G,tokens:ie}),ie},x.inlineTokens=function(G,ie){var fe=this;ie===void 0&&(ie=[]);var ve,Pe,be,De=G,z,Q,ee;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,z.index)+"["+A("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,z.index)+"["+A("a",z[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,z.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(ve=le.call({lexer:fe},G,ie))?(G=G.substring(ve.raw.length),ie.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.tag(G)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&ve.type==="text"&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):ie.push(ve);continue}if(ve=this.tokenizer.link(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ve.raw.length),Pe=ie[ie.length-1],Pe&&ve.type==="text"&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):ie.push(ve);continue}if(ve=this.tokenizer.emStrong(G,De,ee)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.codespan(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.br(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.del(G)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(ve=this.tokenizer.autolink(G,B)){G=G.substring(ve.raw.length),ie.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(G,B))){G=G.substring(ve.raw.length),ie.push(ve);continue}if(be=G,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Re=G.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Re),typeof je=="number"&&je>=0&&(le=Math.min(le,je))}),le<1/0&&le>=0&&(be=G.substring(0,le+1))}(),ve=this.tokenizer.inlineText(be,M)){G=G.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(ee=ve.raw.slice(-1)),Q=!0,Pe=ie[ie.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ve.raw,Pe.text+=ve.text):ie.push(ve);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return ie},D(ge,null,[{key:"rules",get:function(){return{block:j,inline:F}}}]),ge}(),ue=function(){function ge(te){this.options=te||me.defaults}var x=ge.prototype;return x.code=function(G,ie,fe){var ve=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(G,ve);Pe!=null&&Pe!==G&&(fe=!0,G=Pe)}return G=G.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+S(ve,!0)+'">'+(fe?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+(fe?G:S(G,!0))+`</code></pre>
`},x.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},x.html=function(G){return G},x.heading=function(G,ie,fe,ve){if(this.options.headerIds){var Pe=this.options.headerPrefix+ve.slug(fe);return"<h"+ie+' id="'+Pe+'">'+G+"</h"+ie+`>
`}return"<h"+ie+">"+G+"</h"+ie+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(G,ie,fe){var ve=ie?"ol":"ul",Pe=ie&&fe!==1?' start="'+fe+'"':"";return"<"+ve+Pe+`>
`+G+"</"+ve+`>
`},x.listitem=function(G){return"<li>"+G+`</li>
`},x.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(G){return"<p>"+G+`</p>
`},x.table=function(G,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ie+`</table>
`},x.tablerow=function(G){return`<tr>
`+G+`</tr>
`},x.tablecell=function(G,ie){var fe=ie.header?"th":"td",ve=ie.align?"<"+fe+' align="'+ie.align+'">':"<"+fe+">";return ve+G+("</"+fe+`>
`)},x.strong=function(G){return"<strong>"+G+"</strong>"},x.em=function(G){return"<em>"+G+"</em>"},x.codespan=function(G){return"<code>"+G+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(G){return"<del>"+G+"</del>"},x.link=function(G,ie,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<a href="'+S(G)+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=">"+fe+"</a>",ve},x.image=function(G,ie,fe){if(G=c(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<img src="'+G+'" alt="'+fe+'"';return ie&&(ve+=' title="'+ie+'"'),ve+=this.options.xhtml?"/>":">",ve},x.text=function(G){return G},ge}(),Z=function(){function ge(){}var x=ge.prototype;return x.strong=function(G){return G},x.em=function(G){return G},x.codespan=function(G){return G},x.del=function(G){return G},x.html=function(G){return G},x.text=function(G){return G},x.link=function(G,ie,fe){return""+fe},x.image=function(G,ie,fe){return""+fe},x.br=function(){return""},ge}(),J=function(){function ge(){this.seen={}}var x=ge.prototype;return x.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(G,ie){var fe=G,ve=0;if(this.seen.hasOwnProperty(fe)){ve=this.seen[G];do ve++,fe=G+"-"+ve;while(this.seen.hasOwnProperty(fe))}return ie||(this.seen[G]=ve,this.seen[fe]=0),fe},x.slug=function(G,ie){ie===void 0&&(ie={});var fe=this.serialize(G);return this.getNextSafeSlug(fe,ie.dryrun)},ge}(),Y=function(){function ge(te){this.options=te||me.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new J}ge.parse=function(G,ie){var fe=new ge(ie);return fe.parse(G)},ge.parseInline=function(G,ie){var fe=new ge(ie);return fe.parseInline(G)};var x=ge.prototype;return x.parse=function(G,ie){ie===void 0&&(ie=!0);var fe="",ve,Pe,be,De,z,Q,ee,V,ae,le,Re,je,He,Je,_e,ct,ot,rt,Ae,Ue=G.length;for(ve=0;ve<Ue;ve++){if(le=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(Ae=this.options.extensions.renderers[le.type].call({parser:this},le),Ae!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){fe+=Ae||"";continue}switch(le.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(le.tokens),le.depth,f(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(V="",ee="",De=le.header.length,Pe=0;Pe<De;Pe++)ee+=this.renderer.tablecell(this.parseInline(le.header[Pe].tokens),{header:!0,align:le.align[Pe]});for(V+=this.renderer.tablerow(ee),ae="",De=le.rows.length,Pe=0;Pe<De;Pe++){for(Q=le.rows[Pe],ee="",z=Q.length,be=0;be<z;be++)ee+=this.renderer.tablecell(this.parseInline(Q[be].tokens),{header:!1,align:le.align[be]});ae+=this.renderer.tablerow(ee)}fe+=this.renderer.table(V,ae);continue}case"blockquote":{ae=this.parse(le.tokens),fe+=this.renderer.blockquote(ae);continue}case"list":{for(Re=le.ordered,je=le.start,He=le.loose,De=le.items.length,ae="",Pe=0;Pe<De;Pe++)_e=le.items[Pe],ct=_e.checked,ot=_e.task,Je="",_e.task&&(rt=this.renderer.checkbox(ct),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(_e.tokens,He),ae+=this.renderer.listitem(Je,ot,ct);fe+=this.renderer.list(ae,Re,je);continue}case"html":{fe+=this.renderer.html(le.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(ae=le.tokens?this.parseInline(le.tokens):le.text;ve+1<Ue&&G[ve+1].type==="text";)le=G[++ve],ae+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);fe+=ie?this.renderer.paragraph(ae):ae;continue}default:{var Le='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return fe},x.parseInline=function(G,ie){ie=ie||this.renderer;var fe="",ve,Pe,be,De=G.length;for(ve=0;ve<De;ve++){if(Pe=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(be=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){fe+=be||"";continue}switch(Pe.type){case"escape":{fe+=ie.text(Pe.text);break}case"html":{fe+=ie.html(Pe.text);break}case"link":{fe+=ie.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,ie));break}case"image":{fe+=ie.image(Pe.href,Pe.title,Pe.text);break}case"strong":{fe+=ie.strong(this.parseInline(Pe.tokens,ie));break}case"em":{fe+=ie.em(this.parseInline(Pe.tokens,ie));break}case"codespan":{fe+=ie.codespan(Pe.text);break}case"br":{fe+=ie.br();break}case"del":{fe+=ie.del(this.parseInline(Pe.tokens,ie));break}case"text":{fe+=ie.text(Pe.text);break}default:{var z='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return fe},ge}();function he(ge,x,te){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof x=="function"&&(te=x,x=null),x=k({},he.defaults,x||{}),E(x),te){var G=x.highlight,ie;try{ie=X.lex(ge,x)}catch(De){return te(De)}var fe=function(z){var Q;if(!z)try{x.walkTokens&&he.walkTokens(ie,x.walkTokens),Q=Y.parse(ie,x)}catch(ee){z=ee}return x.highlight=G,z?te(z):te(null,Q)};if(!G||G.length<3||(delete x.highlight,!ie.length))return fe();var ve=0;he.walkTokens(ie,function(De){De.type==="code"&&(ve++,setTimeout(function(){G(De.text,De.lang,function(z,Q){if(z)return fe(z);Q!=null&&Q!==De.text&&(De.text=Q,De.escaped=!0),ve--,ve===0&&fe()})},0))}),ve===0&&fe();return}function Pe(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+S(De.message+"",!0)+"</pre>";throw De}try{var be=X.lex(ge,x);if(x.walkTokens){if(x.async)return Promise.all(he.walkTokens(be,x.walkTokens)).then(function(){return Y.parse(be,x)}).catch(Pe);he.walkTokens(be,x.walkTokens)}return Y.parse(be,x)}catch(De){Pe(De)}}he.options=he.setOptions=function(ge){return k(he.defaults,ge),b(he.defaults),he},he.getDefaults=L,he.defaults=me.defaults,he.use=function(){for(var ge=arguments.length,x=new Array(ge),te=0;te<ge;te++)x[te]=arguments[te];var G=k.apply(void 0,[{}].concat(x)),ie=he.defaults.extensions||{renderers:{},childTokens:{}},fe;x.forEach(function(ve){if(ve.extensions&&(fe=!0,ve.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var De=ie.renderers?ie.renderers[be.name]:null;De?ie.renderers[be.name]=function(){for(var z=arguments.length,Q=new Array(z),ee=0;ee<z;ee++)Q[ee]=arguments[ee];var V=be.renderer.apply(this,Q);return V===!1&&(V=De.apply(this,Q)),V}:ie.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[be.level]?ie[be.level].unshift(be.tokenizer):ie[be.level]=[be.tokenizer],be.start&&(be.level==="block"?ie.startBlock?ie.startBlock.push(be.start):ie.startBlock=[be.start]:be.level==="inline"&&(ie.startInline?ie.startInline.push(be.start):ie.startInline=[be.start]))}be.childTokens&&(ie.childTokens[be.name]=be.childTokens)})),ve.renderer&&function(){var be=he.defaults.renderer||new ue,De=function(ee){var V=be[ee];be[ee]=function(){for(var ae=arguments.length,le=new Array(ae),Re=0;Re<ae;Re++)le[Re]=arguments[Re];var je=ve.renderer[ee].apply(be,le);return je===!1&&(je=V.apply(be,le)),je}};for(var z in ve.renderer)De(z);G.renderer=be}(),ve.tokenizer&&function(){var be=he.defaults.tokenizer||new N,De=function(ee){var V=be[ee];be[ee]=function(){for(var ae=arguments.length,le=new Array(ae),Re=0;Re<ae;Re++)le[Re]=arguments[Re];var je=ve.tokenizer[ee].apply(be,le);return je===!1&&(je=V.apply(be,le)),je}};for(var z in ve.tokenizer)De(z);G.tokenizer=be}(),ve.walkTokens){var Pe=he.defaults.walkTokens;G.walkTokens=function(be){var De=[];return De.push(ve.walkTokens.call(this,be)),Pe&&(De=De.concat(Pe.call(this,be))),De}}fe&&(G.extensions=ie),he.setOptions(G)})},he.walkTokens=function(ge,x){for(var te=[],G=function(){var Pe=fe.value;switch(te=te.concat(x.call(he,Pe)),Pe.type){case"table":{for(var be=I(Pe.header),De;!(De=be()).done;){var z=De.value;te=te.concat(he.walkTokens(z.tokens,x))}for(var Q=I(Pe.rows),ee;!(ee=Q()).done;)for(var V=ee.value,ae=I(V),le;!(le=ae()).done;){var Re=le.value;te=te.concat(he.walkTokens(Re.tokens,x))}break}case"list":{te=te.concat(he.walkTokens(Pe.items,x));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[Pe.type]?he.defaults.extensions.childTokens[Pe.type].forEach(function(je){te=te.concat(he.walkTokens(Pe[je],x))}):Pe.tokens&&(te=te.concat(he.walkTokens(Pe.tokens,x)))}},ie=I(ge),fe;!(fe=ie()).done;)G();return te},he.parseInline=function(ge,x){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");x=k({},he.defaults,x||{}),E(x);try{var te=X.lexInline(ge,x);return x.walkTokens&&he.walkTokens(te,x.walkTokens),Y.parseInline(te,x)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},he.Parser=Y,he.parser=Y.parse,he.Renderer=ue,he.TextRenderer=Z,he.Lexer=X,he.lexer=X.lex,he.Tokenizer=N,he.Slugger=J,he.parse=he;var _=he.options,we=he.setOptions,oe=he.use,K=he.walkTokens,W=he.parseInline,re=he,ye=Y.parse,de=X.lex;me.Lexer=X,me.Parser=Y,me.Renderer=ue,me.Slugger=J,me.TextRenderer=Z,me.Tokenizer=N,me.getDefaults=L,me.lexer=de,me.marked=he,me.options=_,me.parse=re,me.parseInline=W,me.parser=ye,me.setOptions=we,me.use=oe,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=void 0;function D(h){const f=I(h);if(f&&f.length>0)return new Uint32Array(f)}e.$Qj=D;let O=0;const g=new Uint32Array(10);function I(h){if(O=0,L(h,C,4352),O>0||(L(h,m,4449),O>0)||(L(h,v,4520),O>0)||(L(h,S,12593),O))return g.subarray(0,O);if(h>=44032&&h<=55203){const f=h-44032,o=f%588,i=Math.floor(f/588),r=Math.floor(o/28),n=o%28-1;if(i<C.length?L(i,C,0):4352+i-12593<S.length&&L(4352+i,S,12593),r<m.length?L(r,m,0):4449+r-12593<S.length&&L(4449+r-12593,S,12593),n>=0&&(n<v.length?L(n,v,0):4520+n-12593<S.length&&L(4520+n-12593,S,12593)),O>0)return g.subarray(0,O)}}function L(h,f,o){h>=o&&h<o+f.length&&b(f[h-o])}function b(h){h!==0&&(g[O++]=h&255,h>>8&&(g[O++]=h>>8&255),h>>16&&(g[O++]=h>>16&255))}var $;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(y||(y={}));var R;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(R||(R={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=e.$Fl=void 0;const O=new D.$Dc(1e4);function g(y){return $(y,"NFC",O)}e.$Fl=g;const I=new D.$Dc(1e4);function L(y){return $(y,"NFD",I)}e.$Gl=L;const b=/[^\u0000-\u0080]/;function $(y,R,C){if(!y)return y;const m=C.get(y);if(m)return m;let v;return b.test(y)?v=y.normalize(R):v=y,C.set(y,v),v}e.$Hl=function(){const y=/[\u0300-\u036f]/g;return function(R){return L(R).replace(y,"")}}()}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.rot=e.$6l=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$6l=D;function O(b,$){return($+b%$)%$}e.rot=O;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$8l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$9l=I;class L{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$0l=L}),function(){function me(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function L($){I.push($,Date.now())}function b(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round(g+L.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:me)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(O){if(e[O])return e[O].exports;var g=e[O]={i:O,l:!1,exports:{}};return me[O].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(O,g,I){D.o(O,g)||Object.defineProperty(O,g,{enumerable:!0,get:I})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,g){if(1&g&&(O=D(O)),8&g||4&g&&typeof O=="object"&&O&&O.__esModule)return O;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:O}),2&g&&typeof O!="string")for(var L in O)D.d(I,L,function(b){return O[b]}.bind(null,L));return I},D.n=function(O){var g=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(g,"a",g),g},D.o=function(O,g){return Object.prototype.hasOwnProperty.call(O,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(O){var g;e=me.exports=oe,g=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,R=y++;$[R]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=y++;$[v]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var S=y++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var h=y++;$[h]="(?:"+$[R]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var o=y++;$[o]="(?:-("+$[h]+"(?:\\."+$[h]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var r=y++;$[r]="[0-9A-Za-z-]+";var n=y++;$[n]="(?:\\+("+$[r]+"(?:\\."+$[r]+")*))";var c=y++,t="v?"+$[v]+$[o]+"?"+$[n]+"?";$[c]="^"+t+"$";var u="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",s=y++;$[s]="^"+u+"$";var l=y++;$[l]="((?:<|>)?=?)";var a=y++;$[a]=$[C]+"|x|X|\\*";var d=y++;$[d]=$[R]+"|x|X|\\*";var k=y++;$[k]="[v=\\s]*("+$[d]+")(?:\\.("+$[d]+")(?:\\.("+$[d]+")(?:"+$[o]+")?"+$[n]+"?)?)?";var P=y++;$[P]="[v=\\s]*("+$[a]+")(?:\\.("+$[a]+")(?:\\.("+$[a]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var p=y++;$[p]="^"+$[l]+"\\s*"+$[k]+"$";var w=y++;$[w]="^"+$[l]+"\\s*"+$[P]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=y++;$[A]="(?:~>?)";var T=y++;$[T]="(\\s*)"+$[A]+"\\s+",b[T]=new RegExp($[T],"g");var U=y++;$[U]="^"+$[A]+$[k]+"$";var N=y++;$[N]="^"+$[A]+$[P]+"$";var j=y++;$[j]="(?:\\^)";var F=y++;$[F]="(\\s*)"+$[j]+"\\s+",b[F]=new RegExp($[F],"g");var M=y++;$[M]="^"+$[j]+$[k]+"$";var B=y++;$[B]="^"+$[j]+$[P]+"$";var X=y++;$[X]="^"+$[l]+"\\s*("+u+")$|^$";var ue=y++;$[ue]="^"+$[l]+"\\s*("+t+")$|^$";var Z=y++;$[Z]="(\\s*)"+$[l]+"\\s*("+u+"|"+$[k]+")",b[Z]=new RegExp($[Z],"g");var J=y++;$[J]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var Y=y++;$[Y]="^\\s*("+$[P]+")\\s+-\\s+("+$[P]+")\\s*$";var he=y++;$[he]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)g(_,$[_]),b[_]||(b[_]=new RegExp($[_]));function we(V,ae){if(V instanceof oe)return V;if(typeof V!="string"||V.length>I||!(ae?b[s]:b[c]).test(V))return null;try{return new oe(V,ae)}catch{return null}}function oe(V,ae){if(V instanceof oe){if(V.loose===ae)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof oe))return new oe(V,ae);g("SemVer",V,ae),this.loose=ae;var le=V.trim().match(ae?b[s]:b[c]);if(!le)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var je=+Re;if(je>=0&&je<L)return je}return Re}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=we,e.valid=function(V,ae){var le=we(V,ae);return le?le.version:null},e.clean=function(V,ae){var le=we(V.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(V){return g("SemVer.compare",this.version,this.loose,V),V instanceof oe||(V=new oe(V,this.loose)),this.compareMain(V)||this.comparePre(V)},oe.prototype.compareMain=function(V){return V instanceof oe||(V=new oe(V,this.loose)),W(this.major,V.major)||W(this.minor,V.minor)||W(this.patch,V.patch)},oe.prototype.comparePre=function(V){if(V instanceof oe||(V=new oe(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],Re=V.prerelease[ae];if(g("prerelease compare",ae,le,Re),le===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(le===void 0)return-1;if(le!==Re)return W(le,Re)}while(++ae)},oe.prototype.inc=function(V,ae){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,ae,le,Re){typeof le=="string"&&(Re=le,le=void 0);try{return new oe(V,le).inc(ae,Re).version}catch{return null}},e.diff=function(V,ae){if(ge(V,ae))return null;var le=we(V),Re=we(ae);if(le.prerelease.length||Re.prerelease.length){for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return"pre"+je;return"prerelease"}for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Re[je])return je},e.compareIdentifiers=W;var K=/^[0-9]+$/;function W(V,ae){var le=K.test(V),Re=K.test(ae);return le&&Re&&(V=+V,ae=+ae),le&&!Re?-1:Re&&!le?1:V<ae?-1:V>ae?1:0}function re(V,ae,le){return new oe(V,le).compare(new oe(ae,le))}function ye(V,ae,le){return re(V,ae,le)>0}function de(V,ae,le){return re(V,ae,le)<0}function ge(V,ae,le){return re(V,ae,le)===0}function x(V,ae,le){return re(V,ae,le)!==0}function te(V,ae,le){return re(V,ae,le)>=0}function G(V,ae,le){return re(V,ae,le)<=0}function ie(V,ae,le,Re){var je;switch(ae){case"===":typeof V=="object"&&(V=V.version),typeof le=="object"&&(le=le.version),je=V===le;break;case"!==":typeof V=="object"&&(V=V.version),typeof le=="object"&&(le=le.version),je=V!==le;break;case"":case"=":case"==":je=ge(V,le,Re);break;case"!=":je=x(V,le,Re);break;case">":je=ye(V,le,Re);break;case">=":je=te(V,le,Re);break;case"<":je=de(V,le,Re);break;case"<=":je=G(V,le,Re);break;default:throw new TypeError("Invalid operator: "+ae)}return je}function fe(V,ae){if(V instanceof fe){if(V.loose===ae)return V;V=V.value}if(!(this instanceof fe))return new fe(V,ae);g("comparator",V,ae),this.loose=ae,this.parse(V),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(V,ae){return W(ae,V)},e.major=function(V,ae){return new oe(V,ae).major},e.minor=function(V,ae){return new oe(V,ae).minor},e.patch=function(V,ae){return new oe(V,ae).patch},e.compare=re,e.compareLoose=function(V,ae){return re(V,ae,!0)},e.rcompare=function(V,ae,le){return re(ae,V,le)},e.sort=function(V,ae){return V.sort(function(le,Re){return e.compare(le,Re,ae)})},e.rsort=function(V,ae){return V.sort(function(le,Re){return e.rcompare(le,Re,ae)})},e.gt=ye,e.lt=de,e.eq=ge,e.neq=x,e.gte=te,e.lte=G,e.cmp=ie,e.Comparator=fe;var ve={};function Pe(V,ae){if(V instanceof Pe)return V.loose===ae?V:new Pe(V.raw,ae);if(V instanceof fe)return new Pe(V.value,ae);if(!(this instanceof Pe))return new Pe(V,ae);if(this.loose=ae,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function be(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,ae,le,Re,je,He,Je,_e,ct,ot,rt,Ae,Ue){return((ae=be(le)?"":be(Re)?">="+le+".0.0":be(je)?">="+le+"."+Re+".0":">="+ae)+" "+(_e=be(ct)?"":be(ot)?"<"+(+ct+1)+".0.0":be(rt)?"<"+ct+"."+(+ot+1)+".0":Ae?"<="+ct+"."+ot+"."+rt+"-"+Ae:"<="+_e)).trim()}function z(V,ae){for(var le=0;le<V.length;le++)if(!V[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<V.length;le++)if(g(V[le].semver),V[le].semver!==ve&&V[le].semver.prerelease.length>0){var Re=V[le].semver;if(Re.major===ae.major&&Re.minor===ae.minor&&Re.patch===ae.patch)return!0}return!1}return!0}function Q(V,ae,le){try{ae=new Pe(ae,le)}catch{return!1}return ae.test(V)}function ee(V,ae,le,Re){var je,He,Je,_e,ct;switch(V=new oe(V,Re),ae=new Pe(ae,Re),le){case">":je=ye,He=G,Je=de,_e=">",ct=">=";break;case"<":je=de,He=te,Je=ye,_e="<",ct="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(V,ae,Re))return!1;for(var ot=0;ot<ae.set.length;++ot){var rt=ae.set[ot],Ae=null,Ue=null;if(rt.forEach(function(Le){Le.semver===ve&&(Le=new fe(">=0.0.0")),Ae=Ae||Le,Ue=Ue||Le,je(Le.semver,Ae.semver,Re)?Ae=Le:Je(Le.semver,Ue.semver,Re)&&(Ue=Le)}),Ae.operator===_e||Ae.operator===ct||(!Ue.operator||Ue.operator===_e)&&He(V,Ue.semver)||Ue.operator===ct&&Je(V,Ue.semver))return!1}return!0}fe.prototype.parse=function(V){var ae=this.loose?b[X]:b[ue],le=V.match(ae);if(!le)throw new TypeError("Invalid comparator: "+V);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new oe(le[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return g("Comparator.test",V,this.loose),this.semver===ve||(typeof V=="string"&&(V=new oe(V,this.loose)),ie(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,ae){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Pe(V.value,ae),Q(this.value,le,ae);if(V.operator==="")return le=new Pe(this.value,ae),Q(V.semver,le,ae);var Re=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),He=this.semver.version===V.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),_e=ie(this.semver,"<",V.semver,ae)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ct=ie(this.semver,">",V.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Re||je||He&&Je||_e||ct},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(V){var ae=this.loose;V=V.trim(),g("range",V,ae);var le=ae?b[Y]:b[J];V=V.replace(le,De),g("hyphen replace",V),V=V.replace(b[Z],"$1$2$3"),g("comparator trim",V,b[Z]),V=(V=(V=V.replace(b[T],"$1~")).replace(b[F],"$1^")).split(/\s+/).join(" ");var Re=ae?b[X]:b[ue],je=V.split(" ").map(function(He){return function(Je,_e){return g("comp",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Ae,Ue){g("caret",Ae,Ue);var Le=Ue?b[B]:b[M];return Ae.replace(Le,function(Ye,ne,ce,Ie,Ve){var Xe;return g("caret",Ae,Ye,ne,ce,Ie,Ve),be(ne)?Xe="":be(ce)?Xe=">="+ne+".0.0 <"+(+ne+1)+".0.0":be(Ie)?Xe=ne==="0"?">="+ne+"."+ce+".0 <"+ne+"."+(+ce+1)+".0":">="+ne+"."+ce+".0 <"+(+ne+1)+".0.0":Ve?(g("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Xe=ne==="0"?ce==="0"?">="+ne+"."+ce+"."+Ie+Ve+" <"+ne+"."+ce+"."+(+Ie+1):">="+ne+"."+ce+"."+Ie+Ve+" <"+ne+"."+(+ce+1)+".0":">="+ne+"."+ce+"."+Ie+Ve+" <"+(+ne+1)+".0.0"):(g("no pr"),Xe=ne==="0"?ce==="0"?">="+ne+"."+ce+"."+Ie+" <"+ne+"."+ce+"."+(+Ie+1):">="+ne+"."+ce+"."+Ie+" <"+ne+"."+(+ce+1)+".0":">="+ne+"."+ce+"."+Ie+" <"+(+ne+1)+".0.0"),g("caret return",Xe),Xe})}(rt,ot)}).join(" ")}(Je,_e),g("caret",Je),Je=function(ct,ot){return ct.trim().split(/\s+/).map(function(rt){return function(Ae,Ue){var Le=Ue?b[N]:b[U];return Ae.replace(Le,function(Ye,ne,ce,Ie,Ve){var Xe;return g("tilde",Ae,Ye,ne,ce,Ie,Ve),be(ne)?Xe="":be(ce)?Xe=">="+ne+".0.0 <"+(+ne+1)+".0.0":be(Ie)?Xe=">="+ne+"."+ce+".0 <"+ne+"."+(+ce+1)+".0":Ve?(g("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Xe=">="+ne+"."+ce+"."+Ie+Ve+" <"+ne+"."+(+ce+1)+".0"):Xe=">="+ne+"."+ce+"."+Ie+" <"+ne+"."+(+ce+1)+".0",g("tilde return",Xe),Xe})}(rt,ot)}).join(" ")}(Je,_e),g("tildes",Je),Je=function(ct,ot){return g("replaceXRanges",ct,ot),ct.split(/\s+/).map(function(rt){return function(Ae,Ue){Ae=Ae.trim();var Le=Ue?b[w]:b[p];return Ae.replace(Le,function(Ye,ne,ce,Ie,Ve,Xe){g("xRange",Ae,Ye,ne,ce,Ie,Ve,Xe);var nt=be(ce),it=nt||be(Ie),Oe=it||be(Ve);return ne==="="&&Oe&&(ne=""),nt?Ye=ne===">"||ne==="<"?"<0.0.0":"*":ne&&Oe?(it&&(Ie=0),Oe&&(Ve=0),ne===">"?(ne=">=",it?(ce=+ce+1,Ie=0,Ve=0):Oe&&(Ie=+Ie+1,Ve=0)):ne==="<="&&(ne="<",it?ce=+ce+1:Ie=+Ie+1),Ye=ne+ce+"."+Ie+"."+Ve):it?Ye=">="+ce+".0.0 <"+(+ce+1)+".0.0":Oe&&(Ye=">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0"),g("xRange return",Ye),Ye})}(rt,ot)}).join(" ")}(Je,_e),g("xrange",Je),Je=function(ct,ot){return g("replaceStars",ct,ot),ct.trim().replace(b[he],"")}(Je,_e),g("stars",Je),Je}(He,ae)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Re)})),je=je.map(function(He){return new fe(He,ae)})},Pe.prototype.intersects=function(V,ae){if(!(V instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Re){return V.set.some(function(je){return je.every(function(He){return Re.intersects(He,ae)})})})})},e.toComparators=function(V,ae){return new Pe(V,ae).set.map(function(le){return le.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new oe(V,this.loose));for(var ae=0;ae<this.set.length;ae++)if(z(this.set[ae],V))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(V,ae,le){var Re=null,je=null;try{var He=new Pe(ae,le)}catch{return null}return V.forEach(function(Je){He.test(Je)&&(Re&&je.compare(Je)!==-1||(je=new oe(Re=Je,le)))}),Re},e.minSatisfying=function(V,ae,le){var Re=null,je=null;try{var He=new Pe(ae,le)}catch{return null}return V.forEach(function(Je){He.test(Je)&&(Re&&je.compare(Je)!==1||(je=new oe(Re=Je,le)))}),Re},e.validRange=function(V,ae){try{return new Pe(V,ae).range||"*"}catch{return null}},e.ltr=function(V,ae,le){return ee(V,ae,"<",le)},e.gtr=function(V,ae,le){return ee(V,ae,">",le)},e.outside=ee,e.prerelease=function(V,ae){var le=we(V,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(V,ae,le){return V=new Pe(V,le),ae=new Pe(ae,le),V.intersects(ae)},e.coerce=function(V){if(V instanceof oe)return V;if(typeof V!="string")return null;var ae=V.match(b[E]);return ae==null?null:we((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(me,e){var D,O,g=me.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{O=typeof clearTimeout=="function"?clearTimeout:L}catch{O=L}})();var $,y=[],R=!1,C=-1;function m(){R&&$&&(R=!1,$.length?y=$.concat(y):C=-1,y.length&&v())}function v(){if(!R){var f=b(m);R=!0;for(var o=y.length;o;){for($=y,y=[];++C<o;)$&&$[C].run();C=-1,o=y.length}$=null,R=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===L||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(f)}}function S(f,o){this.fun=f,this.array=o}function h(){}g.nextTick=function(f){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];y.push(new S(f,o)),y.length!==1||R||b(v)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=h,g.addListener=h,g.once=h,g.off=h,g.removeListener=h,g.removeAllListeners=h,g.emit=h,g.prependListener=h,g.prependOnceListener=h,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(I){return new O(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Qd=O}),define(ke[4],Se([1,0,14,74,3,75,38]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.Event=void 0;const b=!1,$=!1;var y;(function(p){p.None=()=>g.$Tc.None;function w(ie){if($){const{onDidAddListener:fe}=ie,ve=S.create();let Pe=0;ie.onDidAddListener=()=>{++Pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function E(ie,fe){return ue(ie,()=>{},0,void 0,!0,void 0,fe)}p.defer=E;function A(ie){return(fe,ve=null,Pe)=>{let be=!1,De;return De=ie(z=>{if(!be)return De?De.dispose():be=!0,fe.call(ve,z)},null,Pe),be&&De.dispose(),De}}p.once=A;function T(ie,fe,ve){return B((Pe,be=null,De)=>ie(z=>Pe.call(be,fe(z)),null,De),ve)}p.map=T;function U(ie,fe,ve){return B((Pe,be=null,De)=>ie(z=>{fe(z),Pe.call(be,z)},null,De),ve)}p.forEach=U;function N(ie,fe,ve){return B((Pe,be=null,De)=>ie(z=>fe(z)&&Pe.call(be,z),null,De),ve)}p.filter=N;function j(ie){return ie}p.signal=j;function F(...ie){return(fe,ve=null,Pe)=>{const be=(0,g.$Qc)(...ie.map(De=>De(z=>fe.call(ve,z))));return X(be,Pe)}}p.any=F;function M(ie,fe,ve,Pe){let be=ve;return T(ie,De=>(be=fe(be,De),be),Pe)}p.reduce=M;function B(ie,fe){let ve;const Pe={onWillAddFirstListener(){ve=ie(be.fire,be)},onDidRemoveLastListener(){ve?.dispose()}};fe||w(Pe);const be=new r(Pe);return fe?.add(be),be.event}function X(ie,fe){return fe instanceof Array?fe.push(ie):fe&&fe.add(ie),ie}function ue(ie,fe,ve=100,Pe=!1,be=!1,De,z){let Q,ee,V,ae=0,le;const Re={leakWarningThreshold:De,onWillAddFirstListener(){Q=ie(He=>{ae++,ee=fe(ee,He),Pe&&!V&&(je.fire(ee),ee=void 0),le=()=>{const Je=ee;ee=void 0,V=void 0,(!Pe||ae>1)&&je.fire(Je),ae=0},typeof ve=="number"?(clearTimeout(V),V=setTimeout(le,ve)):V===void 0&&(V=0,queueMicrotask(le))})},onWillRemoveListener(){be&&ae>0&&le?.()},onDidRemoveLastListener(){le=void 0,Q.dispose()}};z||w(Re);const je=new r(Re);return z?.add(je),je.event}p.debounce=ue;function Z(ie,fe=0,ve){return p.debounce(ie,(Pe,be)=>Pe?(Pe.push(be),Pe):[be],fe,void 0,!0,void 0,ve)}p.accumulate=Z;function J(ie,fe=(Pe,be)=>Pe===be,ve){let Pe=!0,be;return N(ie,De=>{const z=Pe||!fe(De,be);return Pe=!1,be=De,z},ve)}p.latch=J;function Y(ie,fe,ve){return[p.filter(ie,fe,ve),p.filter(ie,Pe=>!fe(Pe),ve)]}p.split=Y;function he(ie,fe=!1,ve=[],Pe){let be=ve.slice(),De=ie(ee=>{be?be.push(ee):Q.fire(ee)});Pe&&Pe.add(De);const z=()=>{be?.forEach(ee=>Q.fire(ee)),be=null},Q=new r({onWillAddFirstListener(){De||(De=ie(ee=>Q.fire(ee)),Pe&&Pe.add(De))},onDidAddFirstListener(){be&&(fe?setTimeout(z):z())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Pe&&Pe.add(Q),Q.event}p.buffer=he;function _(ie,fe){return(Pe,be,De)=>{const z=fe(new oe);return ie(function(Q){const ee=z.evaluate(Q);ee!==we&&Pe.call(be,ee)},void 0,De)}}p.chain=_;const we=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ve=>(fe(ve),ve)),this}filter(fe){return this.f.push(ve=>fe(ve)?ve:we),this}reduce(fe,ve){let Pe=ve;return this.f.push(be=>(Pe=fe(Pe,be),Pe)),this}latch(fe=(ve,Pe)=>ve===Pe){let ve=!0,Pe;return this.f.push(be=>{const De=ve||!fe(be,Pe);return ve=!1,Pe=be,De?be:we}),this}evaluate(fe){for(const ve of this.f)if(fe=ve(fe),fe===we)break;return fe}}function K(ie,fe,ve=Pe=>Pe){const Pe=(...Q)=>z.fire(ve(...Q)),be=()=>ie.on(fe,Pe),De=()=>ie.removeListener(fe,Pe),z=new r({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}p.fromNodeEventEmitter=K;function W(ie,fe,ve=Pe=>Pe){const Pe=(...Q)=>z.fire(ve(...Q)),be=()=>ie.addEventListener(fe,Pe),De=()=>ie.removeEventListener(fe,Pe),z=new r({onWillAddFirstListener:be,onDidRemoveLastListener:De});return z.event}p.fromDOMEventEmitter=W;function re(ie){return new Promise(fe=>A(ie)(fe))}p.toPromise=re;function ye(ie){const fe=new r;return ie.then(ve=>{fe.fire(ve)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}p.fromPromise=ye;function de(ie,fe,ve){return fe(ve),ie(Pe=>fe(Pe))}p.runAndSubscribe=de;function ge(ie,fe){let ve=null;function Pe(De){ve?.dispose(),ve=new g.$Sc,fe(De,ve)}Pe(void 0);const be=ie(De=>Pe(De));return(0,g.$Rc)(()=>{be.dispose(),ve?.dispose()})}p.runAndSubscribeWithStore=ge;class x{constructor(fe,ve){this._observable=fe,this.f=0,this.g=!1;const Pe={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ve||w(Pe),this.emitter=new r(Pe),ve&&ve.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ve){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ie,fe){return new x(ie,fe).emitter.event}p.fromObservable=te;function G(ie){return(fe,ve,Pe)=>{let be=0,De=!1;const z={beginUpdate(){be++},endUpdate(){be--,be===0&&(ie.reportChanges(),De&&(De=!1,fe.call(ve)))},handlePossibleChange(){},handleChange(){De=!0}};ie.addObserver(z),ie.reportChanges();const Q={dispose(){ie.removeObserver(z)}};return Pe instanceof g.$Sc?Pe.add(Q):Array.isArray(Pe)&&Pe.push(Q),Q}}p.fromObservableLight=G})(y||(e.Event=y={}));class R{static{this.all=new Set}static{this.f=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${R.f++}`,R.all.add(this)}start(w){this.g=new L.$Qd,this.listenerCount=w}stop(){if(this.g){const w=this.g.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.g=void 0}}}e.$Sd=R;let C=-1;function m(p){const w=C;return C=p,{dispose(){C=w}}}e.$Td=m;class v{constructor(w,E=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=E,this.g=0}dispose(){this.f?.clear()}check(w,E){const A=this.threshold;if(A<=0||E<A)return;this.f||(this.f=new Map);const T=this.f.get(w.value)||0;if(this.f.set(w.value,T+1),this.g-=1,this.g<=0){this.g=A*.5;let U,N=0;for(const[j,F]of this.f)(!U||N<F)&&(U=j,N=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${N}):`),console.warn(U)}return()=>{const U=this.f.get(w.value)||0;this.f.set(w.value,U-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class f{constructor(w){this.value=w,this.id=h++}}const o=2,i=(p,w)=>{if(p instanceof f)w(p);else for(let E=0;E<p.length;E++){const A=p[E];A&&w(A)}};class r{constructor(w){this.w=0,this.f=w,this.g=C>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const w=this.t;queueMicrotask(()=>{i(w,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(w,E,A)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Tc.None;if(this.m)return g.$Tc.None;E&&(w=w.bind(E));const T=new f(w);let U,N;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=S.create(),U=this.g.check(T.stack,this.w+1)),b&&(T.stack=N??S.create()),this.t?this.t instanceof f?(this.u??=new c,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Rc)(()=>{U?.(),this.x(T)});return A instanceof g.$Sc?A.add(j):Array.isArray(A)&&A.push(j),j},this.q}x(w){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,A=E.indexOf(w);if(A===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[A]=void 0;const T=this.u.current===this;if(this.w*o<=E.length){let U=0;for(let N=0;N<E.length;N++)E[N]?E[U++]=E[N]:T&&(this.u.end--,U<this.u.i&&this.u.i--);E.length=U}}y(w,E){if(!w)return;const A=this.f?.onListenerError||D.$1;if(!A){w.value(E);return}try{w.value(E)}catch(T){A(T)}}z(w){const E=w.current.t;for(;w.i<w.end;)this.y(E[w.i++],w.value);w.reset()}fire(w){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,w);else{const E=this.u;E.enqueue(this,w,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Ud=r;const n=()=>new c;e.$Vd=n;class c{constructor(){this.i=-1,this.end=0}enqueue(w,E,A){this.i=0,this.end=A,this.current=w,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(w,E,A){if(this.t)for(this.h||(this.h=new I.$4c),i(this.t,T=>this.h.push([T.value,w]));this.h.size>0&&!E.isCancellationRequested;){const[T,U]=this.h.shift(),N=[],j={...U,token:E,waitUntil:F=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");A&&(F=A(F,T)),N.push(F)}};try{T(j)}catch(F){(0,D.$1)(F);continue}Object.freeze(N),await Promise.allSettled(N).then(F=>{for(const M of F)M.status==="rejected"&&(0,D.$1)(M.reason)})}}}e.$Wd=t;class u extends r{get isPaused(){return this.h!==0}constructor(w){super(w),this.h=0,this.s=new I.$4c,this.A=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.A(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.w&&(this.h!==0?this.s.push(w):super.fire(w))}}e.$Xd=u;class s extends u{constructor(w){super(w),this.k=w.delay??100}fire(w){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(w)}}e.$Yd=s;class l extends r{constructor(w){super(w),this.h=[],this.k=w?.merge}fire(w){this.hasListeners()&&(this.h.push(w),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$Zd=l;class a{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(w){const E={event:w,listener:null};this.h.push(E),this.g&&this.m(E);const A=()=>{this.g&&this.o(E);const T=this.h.indexOf(E);this.h.splice(T,1)};return(0,g.$Rc)((0,O.$db)(A))}j(){this.g=!0,this.h.forEach(w=>this.m(w))}k(){this.g=!1,this.h.forEach(w=>this.o(w))}m(w){w.listener=w.event(E=>this.f.fire(E))}o(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.f.dispose()}}e.$1d=a;class d{constructor(w,E,A,T){this.f=new g.$Sc;const U=this.f.add(new a),N=this.f.add(new g.$3c);function j(F){N.set(F,U.add(T(F)))}for(const F of w)j(F);this.f.add(E(F=>{j(F)})),this.f.add(A(F=>{N.deleteAndDispose(F)})),this.event=U.event}dispose(){this.f.dispose()}}e.$2d=d;class k{constructor(){this.f=[]}wrapEvent(w){return(E,A,T)=>w(U=>{const N=this.f[this.f.length-1];N?N.push(()=>E.call(A,U)):E.call(A,U)},void 0,T)}bufferEvents(w){const E=[];this.f.push(E);const A=w();return this.f.pop(),E.forEach(T=>T()),A}}e.$3d=k;class P{constructor(){this.f=!1,this.g=y.None,this.h=g.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(w){this.g=w,this.f&&(this.h.dispose(),this.h=w(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$4d=P}),define(ke[21],Se([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.CancellationToken=void 0;const O=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.$Ud),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$5d=L}),define(ke[162],Se([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.$De=void 0;class O{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$5d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$De=O;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Ee=g;class I{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Fe=I}),define(ke[98],Se([1,0,14,3]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=void 0;function g(n){const c=n;return c?typeof c.read=="function":!1}e.$6d=g;function I(n){const c=n;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$7d=I;function L(n){const c=n;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$8d=L;function b(n,c){return new $(n,c)}e.$9d=b;class ${constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,D.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let u;switch(c){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const s=u.indexOf(t);s>=0&&u.splice(s,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(n,c){const t=[];let u;for(;(u=n.read())!==null;)t.push(u);return c(t)}e.$0d=y;function R(n,c,t){const u=[];let s;for(;(s=n.read())!==null&&u.length<t;)u.push(s);return s===null&&u.length>0?c(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const l=s;return s=void 0,l}return n.read()}}}e.$$d=R;function C(n,c){return new Promise((t,u)=>{const s=[];m(n,{onData:l=>{c&&s.push(l)},onError:l=>{c?u(l):t(void 0)},onEnd:()=>{t(c?c(s):void 0)}})})}e.$_d=C;function m(n,c,t){n.on("error",u=>{t?.isCancellationRequested||c.onError(u)}),n.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),n.on("data",u=>{t?.isCancellationRequested||c.onData(u)})}e.$ae=m;function v(n,c){return new Promise((t,u)=>{const s=new O.$Sc,l=[],a=P=>{if(l.push(P),l.length>c)return s.dispose(),n.pause(),t({stream:n,buffer:l,ended:!1})},d=P=>(s.dispose(),u(P)),k=()=>(s.dispose(),t({stream:n,buffer:l,ended:!0}));s.add((0,O.$Rc)(()=>n.removeListener("error",d))),n.on("error",d),s.add((0,O.$Rc)(()=>n.removeListener("end",k))),n.on("end",k),s.add((0,O.$Rc)(()=>n.removeListener("data",a))),n.on("data",a)})}e.$be=v;function S(n,c){const t=b(c);return t.end(n),t}e.$ce=S;function h(){const n=b(()=>{throw new Error("not supported")});return n.end(),n}e.$de=h;function f(n){let c=!1;return{read:()=>c?null:(c=!0,n)}}e.$ee=f;function o(n,c,t){const u=b(t);return m(n,{onData:s=>u.write(c.data(s)),onError:s=>u.error(c.error?c.error(s):s),onEnd:()=>u.end()}),u}e.$fe=o;function i(n,c,t){let u=!1;return{read:()=>{const s=c.read();return u?s:(u=!0,s!==null?t([n,s]):n)}}}e.$ge=i;function r(n,c,t){let u=!1;const s=b(t);return m(c,{onData:l=>u?s.write(l):(u=!0,s.write(t([n,l]))),onError:l=>s.error(l),onEnd:()=>{u||(u=!0,s.write(n)),s.end()}}),s}e.$he=r}),define(ke[22],Se([1,0,43,98]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;const g=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let L,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,A){return!(A?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(L||(L=new TextEncoder),new $(L.encode(E)))}static fromByteArray(E){const A=$.alloc(E.length);for(let T=0,U=E.length;T<U;T++)A.buffer[T]=E[T];return A}static concat(E,A){if(typeof A>"u"){A=0;for(let N=0,j=E.length;N<j;N++)A+=E[N].byteLength}const T=$.alloc(A);let U=0;for(let N=0,j=E.length;N<j;N++){const F=E[N];T.set(F,U),U+=F.byteLength}return T}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,A){return new $(this.buffer.subarray(E,A))}set(E,A){if(E instanceof $)this.buffer.set(E.buffer,A);else if(E instanceof Uint8Array)this.buffer.set(E,A);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),A);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,A){v(this.buffer,E,A)}readUInt32LE(E){return S(this.buffer,E)}writeUInt32LE(E,A){h(this.buffer,E,A)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,A){o(this.buffer,E,A)}indexOf(E,A=0){return y(this.buffer,E instanceof $?E.buffer:E,A)}}e.$ie=$;function y(w,E,A=0){const T=E.byteLength,U=w.byteLength;if(T===0)return 0;if(T===1)return w.indexOf(E[0]);if(T>U-A)return-1;const N=I.value;N.fill(E.length);for(let B=0;B<E.length;B++)N[E[B]]=E.length-B-1;let j=A+E.length-1,F=j,M=-1;for(;j<U;)if(w[j]===E[F]){if(F===0){M=j;break}j--,F--}else j+=Math.max(E.length-F,N[w[j]]),F=E.length-1;return M}e.$je=y;function R(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0}e.$ke=R;function C(w,E,A){w[A+0]=E&255,E=E>>>8,w[A+1]=E&255}e.$le=C;function m(w,E){return w[E]*2**24+w[E+1]*2**16+w[E+2]*2**8+w[E+3]}e.$me=m;function v(w,E,A){w[A+3]=E,E=E>>>8,w[A+2]=E,E=E>>>8,w[A+1]=E,E=E>>>8,w[A]=E}e.$ne=v;function S(w,E){return w[E+0]<<0>>>0|w[E+1]<<8>>>0|w[E+2]<<16>>>0|w[E+3]<<24>>>0}e.$oe=S;function h(w,E,A){w[A+0]=E&255,E=E>>>8,w[A+1]=E&255,E=E>>>8,w[A+2]=E&255,E=E>>>8,w[A+3]=E&255}e.$pe=h;function f(w,E){return w[E]}e.$qe=f;function o(w,E,A){w[A]=E}e.$re=o;function i(w){return O.$0d(w,E=>$.concat(E))}e.$se=i;function r(w){return O.$ee(w)}e.$te=r;function n(w){return O.$_d(w,E=>$.concat(E))}e.$ue=n;async function c(w){return w.ended?$.concat(w.buffer):$.concat([...w.buffer,await n(w.stream)])}e.$ve=c;function t(w){return O.$ce(w,E=>$.concat(E))}e.$we=t;function u(w){return O.$fe(w,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$xe=u;function s(w){return O.$9d(E=>$.concat(E),w)}e.$ye=s;function l(w,E){return O.$ge(w,E,A=>$.concat(A))}e.$ze=l;function a(w,E){return O.$he(w,E,A=>$.concat(A))}e.$Ae=a;function d(w){let E=0,A=0,T=0;const U=new Uint8Array(Math.floor(w.length/4*3)),N=F=>{switch(A){case 3:U[T++]=E|F,A=0;break;case 2:U[T++]=E|F>>>2,E=F<<6,A=3;break;case 1:U[T++]=E|F>>>4,E=F<<4,A=2;break;default:E=F<<2,A=1}};for(let F=0;F<w.length;F++){const M=w.charCodeAt(F);if(M>=65&&M<=90)N(M-65);else if(M>=97&&M<=122)N(M-97+26);else if(M>=48&&M<=57)N(M-48+52);else if(M===43||M===45)N(62);else if(M===47||M===95)N(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${w[F]}`)}}const j=T;for(;A>0;)N(0);return $.wrap(U).slice(0,j)}e.$Be=d;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:w},E=!0,A=!1){const T=A?P:k;let U="";const N=w.byteLength%3;let j=0;for(;j<w.byteLength-N;j+=3){const F=w[j+0],M=w[j+1],B=w[j+2];U+=T[F>>>2],U+=T[(F<<4|M>>>4)&63],U+=T[(M<<2|B>>>6)&63],U+=T[B&63]}if(N===1){const F=w[j+0];U+=T[F>>>2],U+=T[F<<4&63],E&&(U+="==")}else if(N===2){const F=w[j+0],M=w[j+1];U+=T[F>>>2],U+=T[(F<<4|M>>>4)&63],U+=T[M<<2&63],E&&(U+="=")}return U}e.$Ce=p}),define(ke[12],Se([1,0,162,43]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gf=e.$Ff=e.$Ef=e.$Df=e.GraphemeBreakType=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ie=g;const I=/{(\d+)}/g;function L(Ae,...Ue){return Ue.length===0?Ae:Ae.replace(I,function(Le,Ye){const ne=parseInt(Ye,10);return isNaN(ne)||ne<0||ne>=Ue.length?Le:Ue[ne]})}e.$Je=L;const b=/{([^}]+)}/g;function $(Ae,Ue){return Object.keys(Ue).length===0?Ae:Ae.replace(b,(Le,Ye)=>Ue[Ye]??Le)}e.$Ke=$;function y(Ae){return Ae.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}e.$Le=y;function R(Ae){return Ae.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}e.$Me=R;function C(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ne=C;function m(Ae,Ue){let Le=0;const Ye=Ue.charCodeAt(0);for(let ne=Ae.length-1;ne>=0;ne--)Ae.charCodeAt(ne)===Ye&&Le++;return Le}e.$Oe=m;function v(Ae,Ue,Le="\u2026"){return Ae.length<=Ue?Ae:`${Ae.substr(0,Ue)}${Le}`}e.$Pe=v;function S(Ae,Ue,Le="\u2026"){if(Ae.length<=Ue)return Ae;const Ye=Math.ceil(Ue/2)-Le.length/2,ne=Math.floor(Ue/2)-Le.length/2;return`${Ae.substr(0,Ye)}${Le}${Ae.substr(Ae.length-ne)}`}e.$Qe=S;function h(Ae,Ue=" "){const Le=f(Ae,Ue);return o(Le,Ue)}e.$Re=h;function f(Ae,Ue){if(!Ae||!Ue)return Ae;const Le=Ue.length;if(Le===0||Ae.length===0)return Ae;let Ye=0;for(;Ae.indexOf(Ue,Ye)===Ye;)Ye=Ye+Le;return Ae.substring(Ye)}e.$Se=f;function o(Ae,Ue){if(!Ae||!Ue)return Ae;const Le=Ue.length,Ye=Ae.length;if(Le===0||Ye===0)return Ae;let ne=Ye,ce=-1;for(;ce=Ae.lastIndexOf(Ue,ne-1),!(ce===-1||ce+Le!==ne);){if(ce===0)return"";ne=ce}return Ae.substring(0,ne)}e.$Te=o;function i(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ue=i;function r(Ae){return Ae.replace(/\*/g,"")}e.$Ve=r;function n(Ae,Ue,Le={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ue||(Ae=C(Ae)),Le.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Ye="";return Le.global&&(Ye+="g"),Le.matchCase||(Ye+="i"),Le.multiline&&(Ye+="m"),Le.unicode&&(Ye+="u"),new RegExp(Ae,Ye)}e.$We=n;function c(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Xe=c;function t(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Ye=t;function u(Ae){for(let Ue=0,Le=Ae.length;Ue<Le;Ue++){const Ye=Ae.charCodeAt(Ue);if(Ye!==32&&Ye!==9)return Ue}return-1}e.$Ze=u;function s(Ae,Ue=0,Le=Ae.length){for(let Ye=Ue;Ye<Le;Ye++){const ne=Ae.charCodeAt(Ye);if(ne!==32&&ne!==9)return Ae.substring(Ue,Ye)}return Ae.substring(Ue,Le)}e.$1e=s;function l(Ae,Ue=Ae.length-1){for(let Le=Ue;Le>=0;Le--){const Ye=Ae.charCodeAt(Le);if(Ye!==32&&Ye!==9)return Le}return-1}e.$2e=l;function a(Ae,Ue,Le){const Ye=[];let ne=0;for(const ce of Ae.matchAll(Ue)){if(Ye.push(Ae.slice(ne,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");ne=ce.index+ce[0].length,Ye.push(Le(ce[0],...ce.slice(1),ce.index,Ae,ce.groups))}return Ye.push(Ae.slice(ne)),Promise.all(Ye).then(ce=>ce.join(""))}e.$3e=a;function d(Ae,Ue){return Ae<Ue?-1:Ae>Ue?1:0}e.$4e=d;function k(Ae,Ue,Le=0,Ye=Ae.length,ne=0,ce=Ue.length){for(;Le<Ye&&ne<ce;Le++,ne++){const Xe=Ae.charCodeAt(Le),nt=Ue.charCodeAt(ne);if(Xe<nt)return-1;if(Xe>nt)return 1}const Ie=Ye-Le,Ve=ce-ne;return Ie<Ve?-1:Ie>Ve?1:0}e.$5e=k;function P(Ae,Ue){return p(Ae,Ue,0,Ae.length,0,Ue.length)}e.$6e=P;function p(Ae,Ue,Le=0,Ye=Ae.length,ne=0,ce=Ue.length){for(;Le<Ye&&ne<ce;Le++,ne++){let Xe=Ae.charCodeAt(Le),nt=Ue.charCodeAt(ne);if(Xe===nt)continue;if(Xe>=128||nt>=128)return k(Ae.toLowerCase(),Ue.toLowerCase(),Le,Ye,ne,ce);E(Xe)&&(Xe-=32),E(nt)&&(nt-=32);const it=Xe-nt;if(it!==0)return it}const Ie=Ye-Le,Ve=ce-ne;return Ie<Ve?-1:Ie>Ve?1:0}e.$7e=p;function w(Ae){return Ae>=48&&Ae<=57}e.$8e=w;function E(Ae){return Ae>=97&&Ae<=122}e.$9e=E;function A(Ae){return Ae>=65&&Ae<=90}e.$0e=A;function T(Ae,Ue){return Ae.length===Ue.length&&p(Ae,Ue)===0}e.$$e=T;function U(Ae,Ue){const Le=Ue.length;return Ue.length>Ae.length?!1:p(Ae,Ue,0,Le)===0}e.$_e=U;function N(Ae,Ue){const Le=Math.min(Ae.length,Ue.length);let Ye;for(Ye=0;Ye<Le;Ye++)if(Ae.charCodeAt(Ye)!==Ue.charCodeAt(Ye))return Ye;return Le}e.$af=N;function j(Ae,Ue){const Le=Math.min(Ae.length,Ue.length);let Ye;const ne=Ae.length-1,ce=Ue.length-1;for(Ye=0;Ye<Le;Ye++)if(Ae.charCodeAt(ne-Ye)!==Ue.charCodeAt(ce-Ye))return Ye;return Le}e.$bf=j;function F(Ae){return 55296<=Ae&&Ae<=56319}e.$cf=F;function M(Ae){return 56320<=Ae&&Ae<=57343}e.$df=M;function B(Ae,Ue){return(Ae-55296<<10)+(Ue-56320)+65536}e.$ef=B;function X(Ae,Ue,Le){const Ye=Ae.charCodeAt(Le);if(F(Ye)&&Le+1<Ue){const ne=Ae.charCodeAt(Le+1);if(M(ne))return B(Ye,ne)}return Ye}e.$ff=X;function ue(Ae,Ue){const Le=Ae.charCodeAt(Ue-1);if(M(Le)&&Ue>1){const Ye=Ae.charCodeAt(Ue-2);if(F(Ye))return B(Ye,Le)}return Le}class Z{get offset(){return this.e}constructor(Ue,Le=0){this.c=Ue,this.d=Ue.length,this.e=Le}setOffset(Ue){this.e=Ue}prevCodePoint(){const Ue=ue(this.c,this.e);return this.e-=Ue>=65536?2:1,Ue}nextCodePoint(){const Ue=X(this.c,this.d,this.e);return this.e+=Ue>=65536?2:1,Ue}eol(){return this.e>=this.d}}e.$gf=Z;class J{get offset(){return this.c.offset}constructor(Ue,Le=0){this.c=new Z(Ue,Le)}nextGraphemeLength(){const Ue=Re.getInstance(),Le=this.c,Ye=Le.offset;let ne=Ue.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const ce=Le.offset,Ie=Ue.getGraphemeBreakType(Le.nextCodePoint());if(ae(ne,Ie)){Le.setOffset(ce);break}ne=Ie}return Le.offset-Ye}prevGraphemeLength(){const Ue=Re.getInstance(),Le=this.c,Ye=Le.offset;let ne=Ue.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const ce=Le.offset,Ie=Ue.getGraphemeBreakType(Le.prevCodePoint());if(ae(Ie,ne)){Le.setOffset(ce);break}ne=Ie}return Ye-Le.offset}eol(){return this.c.eol()}}e.$hf=J;function Y(Ae,Ue){return new J(Ae,Ue).nextGraphemeLength()}e.$if=Y;function he(Ae,Ue){return new J(Ae,Ue).prevGraphemeLength()}e.$jf=he;function _(Ae,Ue){Ue>0&&M(Ae.charCodeAt(Ue))&&Ue--;const Le=Ue+Y(Ae,Ue);return[Le-he(Ae,Le),Le]}e.$kf=_;function we(Ae){const Ue=new J(Ae);let Le=0;for(;!Ue.eol();)Le++,Ue.nextGraphemeLength();return Le}e.$lf=we;let oe;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(Ae){return oe||(oe=K()),oe.test(Ae)}e.$mf=W;const re=/^[\t\n\r\x20-\x7E]*$/;function ye(Ae){return re.test(Ae)}e.$nf=ye,e.$of=/[\u2028\u2029]/;function de(Ae){return e.$of.test(Ae)}e.$pf=de;function ge(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$qf=ge;function x(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$rf=x;function te(Ae,Ue,Le=""){const Ye=Ae.trimStart();if(Ye.length<Ue)return Ye;const ne=/\b/g;let ce=0;for(;ne.test(Ye)&&!(Ye.length-ne.lastIndex<Ue);)ce=ne.lastIndex,ne.lastIndex+=1;return ce===0?Ye:Le+Ye.substring(ce).trimStart()}e.$sf=te;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function fe(Ae){return Ae&&(Ae=Ae.replace(G,"").replace(ie,"")),Ae}e.$tf=fe,e.$uf=String.fromCharCode(65279);function ve(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$vf=ve;function Pe(Ae){return ve(Ae)?Ae.substr(1):Ae}e.$wf=Pe;function be(Ae,Ue){if(!Ae||!Ue||Ae.length<Ue.length)return!1;const Le=Ue.length,Ye=Ae.toLowerCase();let ne=0,ce=-1;for(;ne<Le;){const Ie=Ye.indexOf(Ue[ne],ce+1);if(Ie<0)return!1;ce=Ie,ne++}return!0}e.$xf=be;function De(Ae,Ue=!1){return Ae?(Ue&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$yf=De;function z(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$zf=z;function Q(Ae,Ue=1){if(Ue===0)return"";let Le=-1;do Le=Ae.indexOf(`
`,Le+1),Ue--;while(Ue>0&&Le>=0);return Le===-1?Ae:(Ae[Le-1]==="\r"&&Le--,Ae.substr(0,Le))}e.$Af=Q;function ee(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$Bf=ee;function V(Ae){return Re.getInstance().getGraphemeBreakType(Ae)}e.$Cf=V;function ae(Ae,Ue){return Ae===0?Ue!==5&&Ue!==7:Ae===2&&Ue===3?!1:Ae===4||Ae===2||Ae===3||Ue===4||Ue===2||Ue===3?!0:!(Ae===8&&(Ue===8||Ue===9||Ue===11||Ue===12)||(Ae===11||Ae===9)&&(Ue===9||Ue===10)||(Ae===12||Ae===10)&&Ue===10||Ue===5||Ue===13||Ue===7||Ae===1||Ae===13&&Ue===14||Ae===6&&Ue===6)}var le;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=je()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===10?3:Ue===13?2:4;if(Ue<127)return 0;const Le=this.d,Ye=Le.length/3;let ne=1;for(;ne<=Ye;)if(Ue<Le[3*ne])ne=2*ne;else if(Ue>Le[3*ne+1])ne=2*ne+1;else return Le[3*ne+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ae,Ue){if(Ae===0)return 0;const Le=Je(Ae,Ue);if(Le!==void 0)return Le;const Ye=new Z(Ue,Ae);return Ye.prevCodePoint(),Ye.offset}e.$Df=He;function Je(Ae,Ue){const Le=new Z(Ue,Ae);let Ye=Le.prevCodePoint();for(;_e(Ye)||Ye===65039||Ye===8419;){if(Le.offset===0)return;Ye=Le.prevCodePoint()}if(!x(Ye))return;let ne=Le.offset;return ne>0&&Le.prevCodePoint()===8205&&(ne=Le.offset),ne}function _e(Ae){return 127995<=Ae&&Ae<=127999}var ct;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.$Ef="\xA0";class ot{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ee(Ue=>{function Le(it){const Oe=new Map;for(let pt=0;pt<it.length;pt+=2)Oe.set(it[pt],it[pt+1]);return Oe}function Ye(it,Oe){const pt=new Map(it);for(const[St,Nt]of Oe)pt.set(St,Nt);return pt}function ne(it,Oe){if(!it)return Oe;const pt=new Map;for(const[St,Nt]of it)Oe.has(St)&&pt.set(St,Nt);return pt}const ce=this.c.value;let Ie=Ue.filter(it=>!it.startsWith("_")&&it in ce);Ie.length===0&&(Ie=["_default"]);let Ve;for(const it of Ie){const Oe=Le(ce[it]);Ve=ne(Ve,Oe)}const Xe=Le(ce._common),nt=Ye(Xe,Ve);return new ot(nt)})}static getInstance(Ue){return ot.d.get(Array.from(Ue))}static{this.e=new O.$V(()=>Object.keys(ot.c.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return ot.e.value}constructor(Ue){this.f=Ue}isAmbiguous(Ue){return this.f.has(Ue)}getPrimaryConfusable(Ue){return this.f.get(Ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Ff=ot;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Ue){return rt.e().has(Ue)}static get codePoints(){return rt.e()}}e.$Gf=rt}),define(ke[123],Se([1,0,28,161,12]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.FuzzyScore=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.or=void 0;function I(...be){return function(De,z){for(let Q=0,ee=be.length;Q<ee;Q++){const V=be[Q](De,z);if(V)return V}return null}}e.or=I,e.$Sj=L.bind(void 0,!1),e.$Tj=L.bind(void 0,!0);function L(be,De,z){if(!z||z.length<De.length)return null;let Q;return be?Q=g.$_e(z,De):Q=z.indexOf(De)===0,Q?De.length>0?[{start:0,end:De.length}]:[]:null}function b(be,De){const z=De.toLowerCase().indexOf(be.toLowerCase());return z===-1?null:[{start:z,end:z+be.length}]}e.$Uj=b;function $(be,De){return y(be.toLowerCase(),De.toLowerCase(),0,0)}e.$Vj=$;function y(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]===De[Q]){let ee=null;return(ee=y(be,De,z+1,Q+1))?n({start:Q,end:Q+1},ee):null}return y(be,De,z,Q+1)}function R(be){return 97<=be&&be<=122}function C(be){return 65<=be&&be<=90}e.$Wj=C;function m(be){return 48<=be&&be<=57}function v(be){return be===32||be===9||be===10||be===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>S.add(be.charCodeAt(0)));function h(be){return v(be)||S.has(be)}function f(be,De){return be===De||h(be)&&h(De)}const o=new Map;function i(be){if(o.has(be))return o.get(be);let De;const z=(0,O.$Qj)(be);return z&&(De=z),o.set(be,De),De}function r(be){return R(be)||C(be)||m(be)}function n(be,De){return De.length===0?De=[be]:be.end===De[0].start?De[0].start=be.start:De.unshift(be),De}function c(be,De){for(let z=De;z<be.length;z++){const Q=be.charCodeAt(z);if(C(Q)||m(Q)||z>0&&!r(be.charCodeAt(z-1)))return z}return be.length}function t(be,De,z,Q){if(z===be.length)return[];if(Q===De.length)return null;if(be[z]!==De[Q].toLowerCase())return null;{let ee=null,V=Q+1;for(ee=t(be,De,z+1,Q+1);!ee&&(V=c(De,V))<De.length;)ee=t(be,De,z+1,V),V++;return ee===null?null:n({start:Q,end:Q+1},ee)}}function u(be){let De=0,z=0,Q=0,ee=0,V=0;for(let He=0;He<be.length;He++)V=be.charCodeAt(He),C(V)&&De++,R(V)&&z++,r(V)&&Q++,m(V)&&ee++;const ae=De/be.length,le=z/be.length,Re=Q/be.length,je=ee/be.length;return{upperPercent:ae,lowerPercent:le,alphaPercent:Re,numericPercent:je}}function s(be){const{upperPercent:De,lowerPercent:z}=be;return z===0&&De>.6}function l(be){const{upperPercent:De,lowerPercent:z,alphaPercent:Q,numericPercent:ee}=be;return z>.2&&De<.8&&Q>.6&&ee<.2}function a(be){let De=0,z=0,Q=0,ee=0;for(let V=0;V<be.length;V++)Q=be.charCodeAt(V),C(Q)&&De++,R(Q)&&z++,v(Q)&&ee++;return(De===0||z===0)&&ee===0?be.length<=30:De<=5}function d(be,De){if(!De||(De=De.trim(),De.length===0)||!a(be)||De.length>60)return null;const z=u(De);if(!l(z)){if(!s(z))return null;De=De.toLowerCase()}let Q=null,ee=0;for(be=be.toLowerCase();ee<De.length&&(Q=t(be,De,0,ee))===null;)ee=c(De,ee+1);return Q}e.$Xj=d;function k(be,De,z=!1){if(!De||De.length===0)return null;let Q=null,ee=0;for(be=be.toLowerCase(),De=De.toLowerCase();ee<De.length&&(Q=P(be,De,0,ee,z),Q===null);)ee=p(De,ee+1);return Q}e.$Yj=k;function P(be,De,z,Q,ee){let V=0;if(z===be.length)return[];if(Q===De.length)return null;if(!f(be.charCodeAt(z),De.charCodeAt(Q))){const Re=i(be.charCodeAt(z));if(!Re)return null;for(let je=0;je<Re.length;je++)if(!f(Re[je],De.charCodeAt(Q+je)))return null;V+=Re.length-1}let ae=null,le=Q+V+1;if(ae=P(be,De,z+1,le,ee),!ee)for(;!ae&&(le=p(De,le))<De.length;)ae=P(be,De,z+1,le,ee),le++;if(!ae)return null;if(be.charCodeAt(z)!==De.charCodeAt(Q)){const Re=i(be.charCodeAt(z));if(!Re)return ae;for(let je=0;je<Re.length;je++)if(Re[je]!==De.charCodeAt(Q+je))return ae}return n({start:Q,end:Q+V+1},ae)}function p(be,De){for(let z=De;z<be.length;z++)if(h(be.charCodeAt(z))||z>0&&h(be.charCodeAt(z-1)))return z;return be.length}const w=I(e.$Tj,d,b),E=I(e.$Tj,d,$),A=new D.$Dc(1e4);function T(be,De,z=!1){if(typeof be!="string"||typeof De!="string")return null;let Q=A.get(be);Q||(Q=new RegExp(g.$Ue(be),"i"),A.set(be,Q));const ee=Q.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?E(be,De):w(be,De)}e.$Zj=T;function U(be,De){const z=x(be,be.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?j(z):null}e.$1j=U;function N(be,De,z,Q,ee,V){const ae=Math.min(13,be.length);for(;z<ae;z++){const le=x(be,De,z,Q,ee,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return le}return[0,V]}e.$2j=N;function j(be){if(typeof be>"u")return[];const De=[],z=be[1];for(let Q=be.length-1;Q>1;Q--){const ee=be[Q]+z,V=De[De.length-1];V&&V.end===ee?V.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.$3j=j;const F=128;function M(){const be=[],De=[];for(let z=0;z<=F;z++)De[z]=0;for(let z=0;z<=F;z++)be.push(De.slice(0));return be}function B(be){const De=[];for(let z=0;z<=be;z++)De[z]=0;return De}const X=B(2*F),ue=B(2*F),Z=M(),J=M(),Y=M(),he=!1;function _(be,De,z,Q,ee){function V(le,Re,je=" "){for(;le.length<Re;)le=je+le;return le}let ae=` |   |${Q.split("").map(le=>V(le,3)).join("|")}
`;for(let le=0;le<=z;le++)le===0?ae+=" |":ae+=`${De[le-1]}|`,ae+=be[le].slice(0,ee+1).map(Re=>V(Re.toString(),3)).join("|")+`
`;return ae}function we(be,De,z,Q){be=be.substr(De),z=z.substr(Q),console.log(_(J,be,be.length,z,z.length)),console.log(_(Y,be,be.length,z,z.length)),console.log(_(Z,be,be.length,z,z.length))}function oe(be,De){if(De<0||De>=be.length)return!1;const z=be.codePointAt(De);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$rf(z)}}function K(be,De){if(De<0||De>=be.length)return!1;switch(be.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function W(be,De,z){return De[be]!==z[be]}function re(be,De,z,Q,ee,V,ae=!1){for(;De<z&&ee<V;)be[De]===Q[ee]&&(ae&&(X[De]=ee),De+=1),ee+=1;return De===z}e.$4j=re;var ye;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(be){be.Default=[-100,0];function De(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}be.isDefault=De})(de||(e.FuzzyScore=de={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,z){this.firstMatchCanBeWeak=De,this.boostFullMatch=z}}e.$5j=ge;function x(be,De,z,Q,ee,V,ae=ge.default){const le=be.length>F?F:be.length,Re=Q.length>F?F:Q.length;if(z>=le||V>=Re||le-z>Re-V||!re(De,z,le,ee,V,Re,!0))return;te(le,Re,z,V,De,ee);let je=1,He=1,Je=z,_e=V;const ct=[!1];for(je=1,Je=z;Je<le;je++,Je++){const Le=X[Je],Ye=ue[Je],ne=Je+1<le?ue[Je+1]:Re;for(He=Le-V+1,_e=Le;_e<ne;He++,_e++){let ce=Number.MIN_SAFE_INTEGER,Ie=!1;_e<=Ye&&(ce=G(be,De,Je,z,Q,ee,_e,Re,V,Z[je-1][He-1]===0,ct));let Ve=0;ce!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ve=ce+J[je-1][He-1]);const Xe=_e>Le,nt=Xe?J[je][He-1]+(Z[je][He-1]>0?-5:0):0,it=_e>Le+1&&Z[je][He-1]>0,Oe=it?J[je][He-2]+(Z[je][He-2]>0?-5:0):0;if(it&&(!Xe||Oe>=nt)&&(!Ie||Oe>=Ve))J[je][He]=Oe,Y[je][He]=3,Z[je][He]=0;else if(Xe&&(!Ie||nt>=Ve))J[je][He]=nt,Y[je][He]=2,Z[je][He]=0;else if(Ie)J[je][He]=Ve,Y[je][He]=1,Z[je][He]=Z[je-1][He-1]+1;else throw new Error("not possible")}}if(he&&we(be,z,Q,V),!ct[0]&&!ae.firstMatchCanBeWeak)return;je--,He--;const ot=[J[je][He],V];let rt=0,Ae=0;for(;je>=1;){let Le=He;do{const Ye=Y[je][Le];if(Ye===3)Le=Le-2;else if(Ye===2)Le=Le-1;else break}while(Le>=1);rt>1&&De[z+je-1]===ee[V+He-1]&&!W(Le+V-1,Q,ee)&&rt+1>Z[je][Le]&&(Le=He),Le===He?rt++:rt=1,Ae||(Ae=Le),je--,He=Le-1,ot.push(He)}Re===le&&ae.boostFullMatch&&(ot[0]+=2);const Ue=Ae-le;return ot[0]-=Ue,ot}e.$6j=x;function te(be,De,z,Q,ee,V){let ae=be-1,le=De-1;for(;ae>=z&&le>=Q;)ee[ae]===V[le]&&(ue[ae]=le,ae--),le--}function G(be,De,z,Q,ee,V,ae,le,Re,je,He){if(De[z]!==V[ae])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return ae===z-Q?Je=be[z]===ee[ae]?7:5:W(ae,ee,V)&&(ae===0||!W(ae-1,ee,V))?(Je=be[z]===ee[ae]?7:5,_e=!0):oe(V,ae)&&(ae===0||!oe(V,ae-1))?Je=5:(oe(V,ae-1)||K(V,ae-1))&&(Je=5,_e=!0),Je>1&&z===Q&&(He[0]=!0),_e||(_e=W(ae,ee,V)||oe(V,ae-1)||K(V,ae-1)),z===Q?ae>Re&&(Je-=_e?3:5):je?Je+=_e?2:0:Je+=_e?0:1,ae+1===le&&(Je-=_e?3:5),Je}function ie(be,De,z,Q,ee,V,ae){return ve(be,De,z,Q,ee,V,!0,ae)}e.$7j=ie;function fe(be,De,z,Q,ee,V,ae){return ve(be,De,z,Q,ee,V,!1,ae)}e.$8j=fe;function ve(be,De,z,Q,ee,V,ae,le){let Re=x(be,De,z,Q,ee,V,le);if(Re&&!ae)return Re;if(be.length>=3){const je=Math.min(7,be.length-1);for(let He=z+1;He<je;He++){const Je=Pe(be,He);if(Je){const _e=x(Je,Je.toLowerCase(),z,Q,ee,V,le);_e&&(_e[0]-=3,(!Re||_e[0]>Re[0])&&(Re=_e))}}}return Re}function Pe(be,De){if(De+1>=be.length)return;const z=be[De],Q=be[De+1];if(z!==Q)return be.slice(0,De)+Q+z+be.slice(De+2)}}),define(ke[54],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=void 0;function O(o){return g(o,0)}e.$Si=O;function g(o,i){switch(typeof o){case"object":return o===null?I(349,i):Array.isArray(o)?$(o,i):y(o,i);case"string":return b(o,i);case"boolean":return L(o,i);case"number":return I(o,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Ti=g;function I(o,i){return(i<<5)-i+o|0}e.$Ui=I;function L(o,i){return I(o?433:863,i)}function b(o,i){i=I(149417,i);for(let r=0,n=o.length;r<n;r++)i=I(o.charCodeAt(r),i);return i}e.$Vi=b;function $(o,i){return i=I(104579,i),o.reduce((r,n)=>g(n,r),i)}function y(o,i){return i=I(181387,i),Object.keys(o).sort().reduce((r,n)=>(r=b(n,r),g(o[n],r)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Wi=R;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(o,i,r=32){const n=r-i,c=~((1<<n)-1);return(o<<i|(c&o)>>>n)>>>0}function v(o,i=0,r=o.byteLength,n=0){for(let c=0;c<r;c++)o[i+c]=n}function S(o,i,r="0"){for(;o.length<i;)o=r+o;return o}function h(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Xi=h;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let c=this.r,t=this.u,u,s;for(t!==0?(u=t,s=-1,t=0):(u=i.charCodeAt(0),s=0);;){let l=u;if(D.$cf(u))if(s+1<r){const a=i.charCodeAt(s+1);D.$df(a)?(s++,l=D.$ef(u,a)):l=65533}else{t=u;break}else D.$df(u)&&(l=65533);if(c=this.w(n,c,l),s++,s<r)u=i.charCodeAt(s);else break}this.r=c,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,r=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,r.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,m(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let n=this.h,c=this.l,t=this.m,u=this.n,s=this.o,l,a,d;for(let k=0;k<80;k++)k<20?(l=c&t|~c&u,a=1518500249):k<40?(l=c^t^u,a=1859775393):k<60?(l=c&t|c&u|t&u,a=2400959708):(l=c^t^u,a=3395469782),d=m(n,5)+l+s+a+i.getUint32(k*4,!1)&4294967295,s=u,u=t,t=m(c,30),c=n,n=d;this.h=this.h+n&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+s&4294967295}}e.$Yi=f}),define(ke[39],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(O||(O={})),function(g){const I="error",L="warning",b="warn",$="info",y="ignore";function R(m){return m?D.$$e(I,m)?g.Error:D.$$e(L,m)||D.$$e(b,m)?g.Warning:D.$$e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=R;function C(m){switch(m){case g.Error:return I;case g.Warning:return L;case g.Info:return $;default:return y}}g.toString=C}(O||(O={})),e.default=O}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Rd=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,12]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class g{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const S=v.charCodeAt(0),h=this.b.charCodeAt(this.c);return S-h}value(){return this.b[this.c]}}e.$7h=g;class I{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,O.$5e)(v,this.b,0,v.length,this.c,this.d):(0,O.$7e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$8h=I;class L{constructor(v=!0,S=!0){this.f=v,this.g=S}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let S=v.length-1;S>=0;S--,this.c--){const h=this.b.charCodeAt(S);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,O.$5e)(v,this.b,0,v.length,this.d,this.e):(0,O.$7e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$9h=L;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(v,S){this.f=v,this.g=S,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,O.$6e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,O.$6e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,O.$4e)(v,this.c.query);if(this.d[this.e]===5)return(0,O.$4e)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$0h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(R||(R={}));class C{static forUris(v=()=>!1,S=()=>!1){return new C(new $(v,S))}static forPaths(v=!1){return new C(new L(void 0,!v))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,S){if(S){const h=S.slice(0);(0,D.$Xb)(h);for(const f of h)this.set(f,v)}else{const h=v.slice(0);(0,D.$Xb)(h);for(const f of h)this.set(f[0],f[1])}}set(v,S){const h=this.b.reset(v);let f;this.c||(this.c=new y,this.c.segment=h.value());const o=[];for(f=this.c;;){const r=h.cmp(f.segment);if(r>0)f.left||(f.left=new y,f.left.segment=h.value()),o.push([-1,f]),f=f.left;else if(r<0)f.right||(f.right=new y,f.right.segment=h.value()),o.push([1,f]),f=f.right;else if(h.hasNext())h.next(),f.mid||(f.mid=new y,f.mid.segment=h.value()),o.push([0,f]),f=f.mid;else break}const i=f.value;f.value=S,f.key=v;for(let r=o.length-1;r>=0;r--){const n=o[r][1];n.updateHeight();const c=n.balanceFactor();if(c<-1||c>1){const t=o[r][0],u=o[r+1][0];if(t===1&&u===1)o[r][1]=n.rotateLeft();else if(t===-1&&u===-1)o[r][1]=n.rotateRight();else if(t===1&&u===-1)n.right=o[r+1][1]=o[r+1][1].rotateRight(),o[r][1]=n.rotateLeft();else if(t===-1&&u===1)n.left=o[r+1][1]=o[r+1][1].rotateLeft(),o[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const S=this.b.reset(v);let h=this.c;for(;h;){const f=S.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(S.hasNext())S.next(),h=h.mid;else break}return h}has(v){const S=this.d(v);return!(S?.value===void 0&&S?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,S){const h=this.b.reset(v),f=[];let o=this.c;for(;o;){const i=h.cmp(o.segment);if(i>0)f.push([-1,o]),o=o.left;else if(i<0)f.push([1,o]),o=o.right;else if(h.hasNext())h.next(),f.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:r,value:n,segment:c}=i;this.e(i.key,!1),o.key=r,o.value=n,o.segment=c}}else{const i=o.left??o.right;if(f.length>0){const[r,n]=f[f.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const r=f[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),f[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),f[i][1]=r.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const S=this.b.reset(v);let h=this.c,f;for(;h;){const o=S.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(S.hasNext())S.next(),f=h.value||f,h=h.mid;else break}return h&&h.value||f}findSuperstr(v){return this.g(v,!1)}g(v,S){const h=this.b.reset(v);let f=this.c;for(;f;){const o=h.cmp(f.segment);if(o>0)f=f.left;else if(o<0)f=f.right;else if(h.hasNext())h.next(),f=f.mid;else return f.mid?this.h(f.mid):S?f.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[S,h]of this)v(h,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const S=[];return this.j(v,S),S[Symbol.iterator]()}j(v,S){v&&(v.left&&this.j(v.left,S),v.value&&S.push([v.key,v.value]),v.mid&&this.j(v.mid,S),v.right&&this.j(v.right,S))}_isBalanced(){const v=S=>{if(!S)return!0;const h=S.balanceFactor();return h<-1||h>1?!1:v(S.left)&&v(S.right)};return v(this.c)}}e.$$h=C}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=void 0;function D(c){return typeof c=="string"}e.$Hf=D;function O(c){return Array.isArray(c)&&c.every(t=>D(t))}e.$If=O;function g(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Jf=g;function I(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Kf=I;function L(c){return typeof c=="number"&&!isNaN(c)}e.$Lf=L;function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Mf=b;function $(c){return c===!0||c===!1}e.$Nf=$;function y(c){return typeof c>"u"}e.$Of=y;function R(c){return!C(c)}e.$Pf=R;function C(c){return y(c)||c===null}e.$Qf=C;function m(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Rf=m;function v(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Sf=v;function S(...c){const t=[];for(let u=0;u<c.length;u++){const s=c[u];if(C(s))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(s)}return t}e.$Tf=S;const h=Object.prototype.hasOwnProperty;function f(c){if(!g(c))return!1;for(const t in c)if(h.call(c,t))return!1;return!0}e.$Uf=f;function o(c){return typeof c=="function"}e.$Vf=o;function i(...c){return c.length>0&&c.every(o)}e.$Wf=i;function r(c,t){const u=Math.min(c.length,t.length);for(let s=0;s<u;s++)n(c[s],t[s])}e.$Xf=r;function n(c,t){if(D(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Yf=n}),define(ke[78],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=void 0;const O=Object.create(null);function g(b,$){if((0,D.$Hf)($)){const y=O[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return O[b]=$,{id:b}}function I(){return O}e.$9j=I;function L(){return Object.values(e.$$j)}e.$0j=L,e.$$j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugBreakpointPending:g("debug-breakpoint-pending",60377),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),diffSingle:g("diff-single",60450),diffMultiple:g("diff-multiple",60451),surroundWith:g("surround-with",60452),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=void 0;function O(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?O(n):n}),i}e.$un=O;function g(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(I.call(r,n)){const c=r[n];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.$Kf)(c)&&i.push(c)}}return o}e.$vn=g;const I=Object.prototype.hasOwnProperty;function L(o,i){return b(o,i,new Set)}e.$wn=L;function b(o,i,r){if((0,D.$Qf)(o))return o;const n=i(o);if(typeof n<"u")return n;if(Array.isArray(o)){const c=[];for(const t of o)c.push(b(t,i,r));return c}if((0,D.$Jf)(o)){if(r.has(o))throw new Error("Cannot clone recursive data-structure");r.add(o);const c={};for(const t in o)I.call(o,t)&&(c[t]=b(o[t],i,r));return r.delete(o),c}return o}function $(o,i,r=!0){return(0,D.$Jf)(o)?((0,D.$Jf)(i)&&Object.keys(i).forEach(n=>{n in o?r&&((0,D.$Jf)(o[n])&&(0,D.$Jf)(i[n])?$(o[n],i[n],r):o[n]=i[n]):o[n]=i[n]}),o):i}e.$xn=$;function y(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(r=0;r<o.length;r++)if(!y(o[r],i[r]))return!1}else{const c=[];for(n in o)c.push(n);c.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!y(c,t))return!1;for(r=0;r<c.length;r++)if(!y(o[c[r]],i[c[r]]))return!1}return!0}e.$yn=y;function R(o){const i=new Set;return JSON.stringify(o,(r,n)=>{if((0,D.$Jf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$zn=R;function C(o,i){const r=Object.create(null);return!o||!i||Object.keys(i).forEach(c=>{const t=o[c],u=i[c];y(t,u)||(r[c]=u)}),r}e.$An=C;function m(o,i){const r=i.toLowerCase(),n=Object.keys(o).find(c=>c.toLowerCase()===r);return n?o[n]:o[i]}e.$Bn=m;function v(o,i){const r=Object.create(null);for(const[n,c]of Object.entries(o))i(n,c)&&(r[n]=c);return r}e.$Cn=v;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$Dn=S;function h(o){const i=[];for(const r of S(o))typeof o[r]=="function"&&i.push(r);return i}e.$En=h;function f(o,i){const r=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},n={};for(const c of o)n[c]=r(c);return n}e.$Fn=f}),define(ke[61],Se([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$_j=e.ThemeColor=void 0;var O;(function(L){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=b})(O||(e.ThemeColor=O={}));function g(L){return{id:L}}e.$_j=g;var I;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(i){const r=b.exec(i.id);if(!r)return $(D.$$j.error);const[,n,c]=r,t=["codicon","codicon-"+n];return c&&t.push("codicon-modifier-"+c.substring(1)),t}L.asClassNameArray=$;function y(i){return $(i).join(" ")}L.asClassName=y;function R(i){return"."+$(i).join(".")}L.asCSSSelector=R;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}L.isThemeIcon=C;const m=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function v(i){const r=m.exec(i);if(!r)return;const[,n]=r;return{id:n}}L.fromString=v;function S(i){return{id:i}}L.fromId=S;function h(i,r){let n=i.id;const c=n.lastIndexOf("~");return c!==-1&&(n=n.substring(0,c)),r&&(n=`${n}~${r}`),{id:n}}L.modify=h;function f(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}L.getModifier=f;function o(i,r){return i.id===r.id&&i.color?.id===r.color?.id}L.isEqual=o})(I||(e.ThemeIcon=I={}))}),define(ke[164],Se([1,0,123,12,61]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=void 0;const I="$(",L=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${L.source}`,"g");function $(o){return o.replace(b,(i,r)=>r?i:`\\${i}`)}e.$ak=$;const y=new RegExp(`\\\\${L.source}`,"g");function R(o){return o.replace(y,i=>`\\${i}`)}e.$bk=R;const C=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function m(o){return o.indexOf(I)===-1?o:o.replace(C,(i,r,n,c)=>n?i:r||c||"")}e.$ck=m;function v(o){return o?o.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$dk=v;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(o){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const c=S.lastIndex,t=S.exec(o),u=o.substring(c,t?.index);if(u.length>0){i+=u;for(let s=0;s<u.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$ek=h;function f(o,i,r=!1){const{text:n,iconOffsets:c}=i;if(!c||c.length===0)return(0,D.$Zj)(o,n,r);const t=(0,O.$Se)(n," "),u=n.length-t.length,s=(0,D.$Zj)(o,t,r);if(s)for(const l of s){const a=c[l.start+u]+u;l.start+=a,l.end+=a}return s}e.$fk=f}),define(ke[124],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function O(I){return I<0?0:I>255?255:I|0}e.$Ge=O;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$He=g}),define(ke[30],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(g){return D.test(g)}e.$og=O,e.$pg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y}}()}),define(ke[165],Se([1,0,19,53,30]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=e.$nt=e.$mt=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$mt=I;function L(C,m,v){const S={id:(0,g.$pg)(),name:C,uri:m,data:v};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$nt=L;class b{constructor(){this.a=new Map}get size(){let m=0;for(const v of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const v=[...this.a.keys()];return O.Iterable.some(this,([S,h])=>h.asFile())&&v.push("files"),R($(m),v)}get(m){return this.a.get(this.b(m))?.[0]}append(m,v){const S=this.a.get(m);S?S.push(v):this.a.set(this.b(m),[v])}replace(m,v){this.a.set(this.b(m),[v])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,v]of this.a)for(const S of v)yield[m,S]}b(m){return $(m)}}e.$ot=b;function $(C){return C.toLowerCase()}function y(C,m){return R($(C),m.map($))}e.$pt=y;function R(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[S,h,f]=v;return f==="*"?m.some(o=>o.startsWith(h+"/")):!1}e.$qt=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$qt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tg=e.$sg=e.$rg=void 0;function O(b,$,y,R=1){let C=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,R,S=>{if(!C)return C=!0,clearTimeout(v),m(S)})})}e.$rg=O;function g(b,$,y,R){if($===0)return R(0);const C=new D.Socket;C.once("connect",()=>(L(C),g(b+y,$-1,y,R))),C.once("data",()=>{}),C.once("error",m=>(L(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,R):R(b))),C.connect(b,"127.0.0.1")}e.$sg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,$,y,R="127.0.0.1"){let C=!1,m,v=1;const S=D.createServer({pauseOnConnect:!0});function h(f,o){C||(C=!0,S.removeAllListeners(),S.close(),m&&clearTimeout(m),o(f))}return new Promise(f=>{m=setTimeout(()=>{h(0,f)},y),S.on("listening",()=>{h(b,f)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&v<$?(b++,v++,S.listen(b,R)):h(0,f)}),S.on("close",()=>{h(0,f)}),S.listen(b,R)})}e.$tg=I;function L(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[125],Se([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=void 0;class O{constructor(b){const $=(0,D.$Ge)(b);this.c=$,this.a=O.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$Ge)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$et=O;var g;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new O(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$ft=I}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function O(g){let I=0,L=0,b=0,$=0;for(let y=0,R=g.length;y<R;y++){const C=g.charCodeAt(y);C===13?(I===0&&(L=y),I++,y+1<R&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,I===0&&(L=y),I++,b=y+1)}return I===0&&(L=g.length),[I,L,g.length-b,$]}e.$tt=O}),define(ke[49],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const L=g.lineNumber|0,b=I.lineNumber|0;if(L===b){const $=g.column|0,y=I.column|0;return $-y}return L-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ss=D}),define(ke[29],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class O{constructor(I,L,b,$){I>b||I===b&&L>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=I,this.endColumn=L):(this.startLineNumber=I,this.startColumn=L,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return O.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return O.containsPosition(this,I)}static containsPosition(I,L){return!(L.lineNumber<I.startLineNumber||L.lineNumber>I.endLineNumber||L.lineNumber===I.startLineNumber&&L.column<I.startColumn||L.lineNumber===I.endLineNumber&&L.column>I.endColumn)}static strictContainsPosition(I,L){return!(L.lineNumber<I.startLineNumber||L.lineNumber>I.endLineNumber||L.lineNumber===I.startLineNumber&&L.column<=I.startColumn||L.lineNumber===I.endLineNumber&&L.column>=I.endColumn)}containsRange(I){return O.containsRange(this,I)}static containsRange(I,L){return!(L.startLineNumber<I.startLineNumber||L.endLineNumber<I.startLineNumber||L.startLineNumber>I.endLineNumber||L.endLineNumber>I.endLineNumber||L.startLineNumber===I.startLineNumber&&L.startColumn<I.startColumn||L.endLineNumber===I.endLineNumber&&L.endColumn>I.endColumn)}strictContainsRange(I){return O.strictContainsRange(this,I)}static strictContainsRange(I,L){return!(L.startLineNumber<I.startLineNumber||L.endLineNumber<I.startLineNumber||L.startLineNumber>I.endLineNumber||L.endLineNumber>I.endLineNumber||L.startLineNumber===I.startLineNumber&&L.startColumn<=I.startColumn||L.endLineNumber===I.endLineNumber&&L.endColumn>=I.endColumn)}plusRange(I){return O.plusRange(this,I)}static plusRange(I,L){let b,$,y,R;return L.startLineNumber<I.startLineNumber?(b=L.startLineNumber,$=L.startColumn):L.startLineNumber===I.startLineNumber?(b=L.startLineNumber,$=Math.min(L.startColumn,I.startColumn)):(b=I.startLineNumber,$=I.startColumn),L.endLineNumber>I.endLineNumber?(y=L.endLineNumber,R=L.endColumn):L.endLineNumber===I.endLineNumber?(y=L.endLineNumber,R=Math.max(L.endColumn,I.endColumn)):(y=I.endLineNumber,R=I.endColumn),new O(b,$,y,R)}intersectRanges(I){return O.intersectRanges(this,I)}static intersectRanges(I,L){let b=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,R=I.endColumn;const C=L.startLineNumber,m=L.startColumn,v=L.endLineNumber,S=L.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>v?(y=v,R=S):y===v&&(R=Math.min(R,S)),b>y||b===y&&$>R?null:new O(b,$,y,R)}equalsRange(I){return O.equalsRange(this,I)}static equalsRange(I,L){return!I&&!L?!0:!!I&&!!L&&I.startLineNumber===L.startLineNumber&&I.startColumn===L.startColumn&&I.endLineNumber===L.endLineNumber&&I.endColumn===L.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(I){return new D.$Ss(I.endLineNumber,I.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(I){return new D.$Ss(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,L){return new O(this.startLineNumber,this.startColumn,I,L)}setStartPosition(I,L){return new O(I,L,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(I){return new O(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(I){return new O(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new O(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,L=I){return new O(I.lineNumber,I.column,L.lineNumber,L.column)}static lift(I){return I?new O(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,L){return!(I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<L.startColumn||L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<I.startColumn)}static areIntersecting(I,L){return!(I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<=L.startColumn||L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,L){if(I&&L){const y=I.startLineNumber|0,R=L.startLineNumber|0;if(y===R){const C=I.startColumn|0,m=L.startColumn|0;if(C===m){const v=I.endLineNumber|0,S=L.endLineNumber|0;if(v===S){const h=I.endColumn|0,f=L.endColumn|0;return h-f}return v-S}return C-m}return y-R}return(I?1:0)-(L?1:0)}static compareRangesUsingEnds(I,L){return I.endLineNumber===L.endLineNumber?I.endColumn===L.endColumn?I.startLineNumber===L.startLineNumber?I.startColumn-L.startColumn:I.startLineNumber-L.startLineNumber:I.endColumn-L.endColumn:I.endLineNumber-L.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Ts=O}),define(ke[168],Se([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class O{static insert(I,L){return{range:new D.$Ts(I.lineNumber,I.column,I.lineNumber,I.column),text:L,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,L){return{range:I,text:L}}static replaceMove(I,L){return{range:I,text:L,forceMoveMarkers:!0}}}e.$Us=O}),define(ke[169],Se([1,0,49,29]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.SelectionDirection=void 0;var g;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends O.$Ts{constructor(b,$,y,R){super(b,$,y,R),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return I.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,b,$):new I(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Ss(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Ss(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new I(b,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new I(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new I(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new I(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new I(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,R=b.length;y<R;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,R,C){return C===0?new I(b,$,y,R):new I(y,R,b,$)}}e.$Vs=I}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0,e.$rs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.WordCharacterClass=void 0;var O;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class g extends D.$et{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$gt=g;function I(L){const b={};return $=>(b.hasOwnProperty($)||(b[$]=L($)),b[$])}e.$ht=I(L=>new g(L))}),define(ke[126],Se([1,0,53,3,75]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=e.$vs=e.$us=e.$ts=e.$ss=void 0,e.$ss="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$ss)C.indexOf(v)>=0||(m+="\\"+v);return m+="\\s]+)",new RegExp(m,"g")}e.$ts=I();function L(C){let m=e.$ts;if(C&&C instanceof RegExp)if(C.global)m=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),m=new RegExp(C.source,v)}return m.lastIndex=0,m}e.$us=L;const b=new g.$4c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,O.$Rc)(m)}e.$vs=$;function y(C,m,v,S,h){if(m=L(m),h||(h=D.Iterable.first(b)),v.length>h.maxLen){let n=C-h.maxLen/2;return n<0?n=0:S+=n,v=v.substring(n,C+h.maxLen/2),y(C,m,v,S,h)}const f=Date.now(),o=C-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-f>=h.timeBudget);n++){const c=o-h.windowSize*n;m.lastIndex=Math.max(0,c);const t=R(m,v,o,i);if(!t&&r||(r=t,c<=0))break;i=c}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return m.lastIndex=0,n}return null}e.$ws=y;function R(C,m,v,S){let h;for(;h=C.exec(m);){const f=h.index||0;if(f<=v&&C.lastIndex>=v)return h;if(S>0&&f>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=e.$Qt=e.IndentAction=void 0;var D;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class O{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),R=b.getStandardTokenType(y);return this.isOK(R)}g(b,$){for(let y=b;y<=$;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Qt=O;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Rt=g;function I(L,b,$){L.has(b)?L.get(b).push($):L.set(b,[$])}}),define(ke[173],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vZ=e.$uZ=e.$tZ=e.State=void 0;var O;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class g{constructor(S,h,f){const o=new Uint8Array(S*h);for(let i=0,r=S*h;i<r;i++)o[i]=f;this.a=o,this.rows=S,this.cols=h}get(S,h){return this.a[S*this.cols+h]}set(S,h,f){this.a[S*this.cols+h]=f}}class I{constructor(S){let h=0,f=0;for(let i=0,r=S.length;i<r;i++){const[n,c,t]=S[i];c>h&&(h=c),n>f&&(f=n),t>f&&(f=t)}h++,f++;const o=new g(f,h,0);for(let i=0,r=S.length;i<r;i++){const[n,c,t]=S[i];o.set(n,c,t)}this.a=o,this.b=h}nextState(S,h){return h<0||h>=this.b?0:this.a.get(S,h)}}e.$tZ=I;let L=null;function b(){return L===null&&(L=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var $;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function R(){if(y===null){y=new D.$et(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<v.length;h++)y.set(v.charCodeAt(h),1);const S=".,;:";for(let h=0;h<S.length;h++)y.set(S.charCodeAt(h),2)}return y}class C{static a(S,h,f,o,i){let r=i-1;do{const n=h.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>o);if(o>0){const n=h.charCodeAt(o-1),c=h.charCodeAt(r);(n===40&&c===41||n===91&&c===93||n===123&&c===125)&&r--}return{range:{startLineNumber:f,startColumn:o+1,endLineNumber:f,endColumn:r+2},url:h.substring(o,r+1)}}static computeLinks(S,h=b()){const f=R(),o=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),c=n.length;let t=0,u=0,s=0,l=1,a=!1,d=!1,k=!1,P=!1;for(;t<c;){let p=!1;const w=n.charCodeAt(t);if(l===13){let E;switch(w){case 40:a=!0,E=0;break;case 41:E=a?0:1;break;case 91:k=!0,d=!0,E=0;break;case 93:k=!1,E=d?0:1;break;case 123:P=!0,E=0;break;case 125:E=P?0:1;break;case 39:case 34:case 96:s===w?E=1:s===39||s===34||s===96?E=0:E=1;break;case 42:E=s===42?1:0;break;case 124:E=s===124?1:0;break;case 32:E=k?0:1;break;default:E=f.get(w)}E===1&&(o.push(C.a(f,n,i,u,t)),p=!0)}else if(l===12){let E;w===91?(d=!0,E=0):E=f.get(w),E===1?p=!0:l=13}else l=h.nextState(l,w),l===0&&(p=!0);p&&(l=1,a=!1,d=!1,P=!1,u=t+1,s=w),t++}l===13&&o.push(C.a(f,n,i,u,c))}return o}}e.$uZ=C;function m(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}e.$vZ=m}),define(ke[79],Se([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ev=e.$dv=e.$cv=e.$bv=e.ModelConstants=e.PositionAffinity=e.$av=e.TrackedRangeStickiness=e.$_u=e.$$u=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var O;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var g;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var L;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var b;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,D.$yn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$$u=R;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$_u=C;var m;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function v(n){return n&&typeof n.read=="function"}e.$av=v;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var h;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h||(e.ModelConstants=h={}));class f{constructor(c,t,u,s,l,a){this.identifier=c,this.range=t,this.text=u,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=l,this._isTracked=a}}e.$bv=f;class o{constructor(c,t,u){this.regex=c,this.wordSeparators=t,this.simpleSearch=u}}e.$cv=o;class i{constructor(c,t,u){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=u}}e.$dv=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$ev=r}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.$SB=e.NodeColor=e.$RB=void 0;class D{constructor(f,o){this.piece=f,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$SB)return g(this.right);let f=this;for(;f.parent!==e.$SB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$SB?e.$SB:f.parent}prev(){if(this.left!==e.$SB)return I(this.left);let f=this;for(;f.parent!==e.$SB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$SB?e.$SB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$RB=D;var O;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$SB=new D(null,0),e.$SB.parent=e.$SB,e.$SB.left=e.$SB,e.$SB.right=e.$SB,e.$SB.color=0;function g(h){for(;h.left!==e.$SB;)h=h.left;return h}e.$TB=g;function I(h){for(;h.right!==e.$SB;)h=h.right;return h}e.$UB=I;function L(h){return h===e.$SB?0:h.size_left+h.piece.length+L(h.right)}function b(h){return h===e.$SB?0:h.lf_left+h.piece.lineFeedCnt+b(h.right)}function $(){e.$SB.parent=e.$SB}function y(h,f){const o=f.right;o.size_left+=f.size_left+(f.piece?f.piece.length:0),o.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=o.left,o.left!==e.$SB&&(o.left.parent=f),o.parent=f.parent,f.parent===e.$SB?h.root=o:f.parent.left===f?f.parent.left=o:f.parent.right=o,o.left=f,f.parent=o}e.$VB=y;function R(h,f){const o=f.left;f.left=o.right,o.right!==e.$SB&&(o.right.parent=f),o.parent=f.parent,f.size_left-=o.size_left+(o.piece?o.piece.length:0),f.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),f.parent===e.$SB?h.root=o:f===f.parent.right?f.parent.right=o:f.parent.left=o,o.right=f,f.parent=o}e.$WB=R;function C(h,f){let o,i;if(f.left===e.$SB?(i=f,o=i.right):f.right===e.$SB?(i=f,o=i.left):(i=g(f.right),o=i.right),i===h.root){h.root=o,o.color=0,f.detach(),$(),h.root.parent=e.$SB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===f?(o.parent=i.parent,S(h,o)):(i.parent===f?o.parent=i:o.parent=i.parent,S(h,o),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===h.root?h.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$SB&&(i.left.parent=i),i.right!==e.$SB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,S(h,i)),f.detach(),o.parent.left===o){const c=L(o),t=b(o);if(c!==o.parent.size_left||t!==o.parent.lf_left){const u=c-o.parent.size_left,s=t-o.parent.lf_left;o.parent.size_left=c,o.parent.lf_left=t,v(h,o.parent,u,s)}}if(S(h,o.parent),r){$();return}let n;for(;o!==h.root&&o.color===0;)o===o.parent.left?(n=o.parent.right,n.color===1&&(n.color=0,o.parent.color=1,y(h,o.parent),n=o.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.right.color===0&&(n.left.color=0,n.color=1,R(h,n),n=o.parent.right),n.color=o.parent.color,o.parent.color=0,n.right.color=0,y(h,o.parent),o=h.root)):(n=o.parent.left,n.color===1&&(n.color=0,o.parent.color=1,R(h,o.parent),n=o.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.left.color===0&&(n.right.color=0,n.color=1,y(h,n),n=o.parent.left),n.color=o.parent.color,o.parent.color=0,n.left.color=0,R(h,o.parent),o=h.root));o.color=0,$()}e.$XB=C;function m(h,f){for(S(h,f);f!==h.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const o=f.parent.parent.right;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(h,f)),f.parent.color=0,f.parent.parent.color=1,R(h,f.parent.parent))}else{const o=f.parent.parent.left;o.color===1?(f.parent.color=0,o.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,R(h,f)),f.parent.color=0,f.parent.parent.color=1,y(h,f.parent.parent))}h.root.color=0}e.$YB=m;function v(h,f,o,i){for(;f!==h.root&&f!==e.$SB;)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}e.$ZB=v;function S(h,f){let o=0,i=0;if(f!==h.root){for(;f!==h.root&&f===f.parent.right;)f=f.parent;if(f!==h.root)for(f=f.parent,o=L(f.left)-f.size_left,i=b(f.left)-f.lf_left,f.size_left+=o,f.lf_left+=i;f!==h.root&&(o!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=o,f.parent.lf_left+=i),f=f.parent}}e.$1B=S}),define(ke[175],Se([1,0,19,124]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jv=e.$iv=e.$hv=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,O.$He)($);const R=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(R.length+m),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,O.$He)($),y=(0,O.$He)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,O.$He)($),y=(0,O.$He)(y);const R=this.a,C=this.b;if($>=R.length)return!1;const m=R.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(R.length-y),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,O.$He)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let R=y;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,R=this.a.length-1,C=0,m=0,v=0;for(;y<=R;)if(C=y+(R-y)/2|0,m=this.b[C],v=m-this.a[C],$<v)R=C-1;else if($>=m)y=C+1;else break;return new L(C,$-v)}}e.$hv=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],R=y>0?this.d[y-1]:0;return new L(y,$-R)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const R=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+R;for(let m=0;m<R;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$iv=I;class L{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$jv=L}),define(ke[176],Se([1,0,12,49,175]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=void 0;class I{constructor(b,$,y,R){this.d=b,this.f=$,this.g=y,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new O.$Ss(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let R=0;R<$;R++)y[R]=this.f[R].length+b;this.j=new g.$hv(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Ye)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const R=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),R[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$kv=I}),define(ke[99],Se([1,0,12,171,49,29,79]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=e.$2B=void 0;const b=999;class ${constructor(i,r,n,c){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=D.$We(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new L.$cv(r,this.wordSeparators?(0,O.$ht)(this.wordSeparators):null,n?this.searchString:null)}}e.$2B=$;function y(o){if(!o||o.length===0)return!1;for(let i=0,r=o.length;i<r;i++){const n=o.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const c=o.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$3B=y;function R(o,i,r){if(!r)return new L.$_u(o,null);const n=[];for(let c=0,t=i.length;c<t;c++)n[c]=i[c];return new L.$_u(o,n)}e.$4B=R;class C{constructor(i){const r=[];let n=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(r[n++]=c);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,c=r.length-1;if(c===-1||i<=r[0])return 0;for(;n<c;){const t=n+((c-n)/2>>0);r[t]>=i?c=t-1:r[t+1]>=i?(n=t,c=t):n=t+1}return n+1}}class m{static findMatches(i,r,n,c,t){const u=r.parseSearchRequest();return u?u.regex.multiline?this.b(i,n,new f(u.wordSeparators,u.regex),c,t):this.c(i,n,u,c,t):[]}static a(i,r,n,c,t,u){let s,l=0;c?(l=c.findLineFeedCountBeforeOffset(t),s=r+t+l):s=r+t;let a;if(c){const p=c.findLineFeedCountBeforeOffset(t+u.length)-l;a=s+u.length+p}else a=s+u.length;const d=i.getPositionAt(s),k=i.getPositionAt(a);return new I.$Ts(d.lineNumber,d.column,k.lineNumber,k.column)}static b(i,r,n,c,t){const u=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),l=i.getEOL()===`\r
`?new C(s):null,a=[];let d=0,k;for(n.reset(0);k=n.next(s);)if(a[d++]=R(this.a(i,u,s,l,k.index,k[0]),k,c),d>=t)return a;return a}static c(i,r,n,c,t){const u=[];let s=0;if(r.startLineNumber===r.endLineNumber){const a=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,a,r.startLineNumber,r.startColumn-1,s,u,c,t),u}const l=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,l,r.startLineNumber,r.startColumn-1,s,u,c,t);for(let a=r.startLineNumber+1;a<r.endLineNumber&&s<t;a++)s=this.d(n,i.getLineContent(a),a,0,s,u,c,t);if(s<t){const a=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,a,r.endLineNumber,0,s,u,c,t)}return u}static d(i,r,n,c,t,u,s,l){const a=i.wordSeparators;if(!s&&i.simpleSearch){const P=i.simpleSearch,p=P.length,w=r.length;let E=-p;for(;(E=r.indexOf(P,E+p))!==-1;)if((!a||h(a,r,w,E,p))&&(u[t++]=new L.$_u(new I.$Ts(n,E+1+c,n,E+1+p+c),null),t>=l))return t;return t}const d=new f(i.wordSeparators,i.regex);let k;d.reset(0);do if(k=d.next(r),k&&(u[t++]=R(new I.$Ts(n,k.index+1+c,n,k.index+1+k[0].length+c),k,s),t>=l))return t;while(k);return t}static findNextMatch(i,r,n,c){const t=r.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,u,c):this.f(i,n,u,c)}static e(i,r,n,c){const t=new g.$Ss(r.lineNumber,1),u=i.getOffsetAt(t),s=i.getLineCount(),l=i.getValueInRange(new I.$Ts(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),a=i.getEOL()===`\r
`?new C(l):null;n.reset(r.column-1);const d=n.next(l);return d?R(this.a(i,u,l,a,d.index,d[0]),d,c):r.lineNumber!==1||r.column!==1?this.e(i,new g.$Ss(1,1),n,c):null}static f(i,r,n,c){const t=i.getLineCount(),u=r.lineNumber,s=i.getLineContent(u),l=this.g(n,s,u,r.column,c);if(l)return l;for(let a=1;a<=t;a++){const d=(u+a-1)%t,k=i.getLineContent(d+1),P=this.g(n,k,d+1,1,c);if(P)return P}return null}static g(i,r,n,c,t){i.reset(c-1);const u=i.next(r);return u?R(new I.$Ts(n,u.index+1,n,u.index+1+u[0].length),u,t):null}static findPreviousMatch(i,r,n,c){const t=r.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,u,c):this.j(i,n,u,c)}static h(i,r,n,c){const t=this.b(i,new I.$Ts(1,1,r.lineNumber,r.column),n,c,10*b);if(t.length>0)return t[t.length-1];const u=i.getLineCount();return r.lineNumber!==u||r.column!==i.getLineMaxColumn(u)?this.h(i,new g.$Ss(u,i.getLineMaxColumn(u)),n,c):null}static j(i,r,n,c){const t=i.getLineCount(),u=r.lineNumber,s=i.getLineContent(u).substring(0,r.column-1),l=this.k(n,s,u,c);if(l)return l;for(let a=1;a<=t;a++){const d=(t+u-a-1)%t,k=i.getLineContent(d+1),P=this.k(n,k,d+1,c);if(P)return P}return null}static k(i,r,n,c){let t=null,u;for(i.reset(0);u=i.next(r);)t=R(new I.$Ts(n,u.index+1,n,u.index+1+u[0].length),u,c);return t}}e.$5B=m;function v(o,i,r,n,c){if(n===0)return!0;const t=i.charCodeAt(n-1);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const u=i.charCodeAt(n);if(o.get(u)!==0)return!0}return!1}function S(o,i,r,n,c){if(n+c===r)return!0;const t=i.charCodeAt(n+c);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const u=i.charCodeAt(n+c-1);if(o.get(u)!==0)return!0}return!1}function h(o,i,r,n,c){return v(o,i,r,n,c)&&S(o,i,r,n,c)}e.$6B=h;class f{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const c=n.index,t=n[0].length;if(c===this.b&&t===this.c){if(t===0){D.$ff(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||h(this._wordSeparators,i,r,c,t))return n}while(n);return null}}e.$7B=f}),define(ke[127],Se([1,0,49,29,79,174,99]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=void 0;const b=65535;function $(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class y{constructor(i,r,n,c,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=c,this.isBasicASCII=t}}function R(o,i=!0){const r=[0];let n=1;for(let c=0,t=o.length;c<t;c++){const u=o.charCodeAt(c);u===13?c+1<t&&o.charCodeAt(c+1)===10?(r[n++]=c+2,c++):r[n++]=c+1:u===10&&(r[n++]=c+1)}return i?$(r):r}e.$8B=R;function C(o,i){o.length=0,o[0]=0;let r=1,n=0,c=0,t=0,u=!0;for(let l=0,a=i.length;l<a;l++){const d=i.charCodeAt(l);d===13?l+1<a&&i.charCodeAt(l+1)===10?(t++,o[r++]=l+2,l++):(n++,o[r++]=l+1):d===10?(c++,o[r++]=l+1):u&&d!==9&&(d<32||d>126)&&(u=!1)}const s=new y($(o),n,c,t,u);return o.length=0,s}e.$9B=C;class m{constructor(i,r,n,c,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=c,this.length=t}}e.$0B=m;class v{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$$B=v;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==I.$SB&&i.iterate(i.root,n=>(n!==I.$SB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let c=0;c<n.length;c++){const t=n[c];if(t.node.parent===null||t.nodeStartOffset>=i){n[c]=null,r=!0;continue}}if(r){const c=[];for(const t of n)t!==null&&c.push(t);this.b=c}}}class f{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=I.$SB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let c=null;for(let t=0,u=i.length;t<u;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const s=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,s)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=b,n=r-Math.floor(r/3),c=n*2;let t="",u=0;const s=[];if(this.iterate(this.root,l=>{const a=this.R(l),d=a.length;if(u<=n||u+d<c)return t+=a,u+=d,!0;const k=t.replace(/\r\n|\r|\n/g,i);return s.push(new v(k,R(k))),t=a,u=d,!0}),u>0){const l=t.replace(/\r\n|\r|\n/g,i);s.push(new v(l,R(l)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,c=>{if(c===I.$SB)return!0;const t=this.R(c),u=t.length,s=i.G(r),l=i.G(r+u),a=i.getValueInRange2(s,l);return r+=u,t===a})}getOffsetAt(i,r){let n=0,c=this.root;for(;c!==I.$SB;)if(c.left!==I.$SB&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){n+=c.size_left;const t=this.B(c,i-c.lf_left-2);return n+=t+r-1}else i-=c.lf_left+c.piece.lineFeedCnt,n+=c.size_left+c.piece.length,c=c.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const c=i;for(;r!==I.$SB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const u=this.getOffsetAt(n+1,1),s=c-u;return new D.$Ss(n+1,s+1)}return new D.$Ss(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===I.$SB){const t=this.getOffsetAt(n+1,1),u=c-i-t;return new D.$Ss(n+1,u+1)}else r=r.right;return new D.$Ss(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,c);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,l=this.a[s.piece.bufferIndex].buffer,a=this.u(s.piece.bufferIndex,s.piece.start);return l.substring(a+i.remainder,a+r.remainder)}let n=i.node;const c=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let u=c.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==I.$SB;){const s=this.a[n.piece.bufferIndex].buffer,l=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){u+=s.substring(l,l+r.remainder);break}else u+=s.substr(l,n.piece.length);n=n.next()}return u}getLinesContent(){const i=[];let r=0,n="",c=!1;return this.iterate(this.root,t=>{if(t===I.$SB)return!0;const u=t.piece;let s=u.length;if(s===0)return!0;const l=this.a[u.bufferIndex].buffer,a=this.a[u.bufferIndex].lineStarts,d=u.start.line,k=u.end.line;let P=a[d]+u.start.column;if(c&&(l.charCodeAt(P)===10&&(P++,s--),i[r++]=n,n="",c=!1,s===0))return!0;if(d===k)return!this.f&&l.charCodeAt(P+s-1)===13?(c=!0,n+=l.substr(P,s-1)):n+=l.substr(P,s),!0;n+=this.f?l.substring(P,Math.max(P,a[d+1]-this.e)):l.substring(P,a[d+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let p=d+1;p<k;p++)n=this.f?l.substring(a[p],a[p+1]-this.e):l.substring(a[p],a[p+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&l.charCodeAt(a[k]+u.end.column-1)===13?(c=!0,u.end.column===0?r--:n=l.substr(a[k],u.end.column-1)):n=l.substr(a[k],u.end.column),!0}),c&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],c=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(c)}else{const r=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(c)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,c,t,u,s,l,a,d,k){const P=this.a[i.piece.bufferIndex],p=this.u(i.piece.bufferIndex,i.piece.start),w=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,u);let A;const T={line:0,column:0};let U,N;r._wordSeparators?(U=P.buffer.substring(w,E),N=j=>j+w,r.reset(0)):(U=P.buffer,N=j=>j,r.reset(w));do if(A=r.next(U),A){if(N(A.index)>=E)return d;this.s(i,N(A.index)-p,T);const j=this.t(i.piece.bufferIndex,t,T),F=T.line===t.line?T.column-t.column+c:T.column+1,M=F+A[0].length;if(k[d++]=(0,L.$4B)(new O.$Ts(n+j,F,n+j,M),A,l),N(A.index)+A[0].length>=E||d>=a)return d}while(A);return d}findMatchesLineByLine(i,r,n,c){const t=[];let u=0;const s=new L.$7B(r.wordSeparators,r.regex);let l=this.H(i.startLineNumber,i.startColumn);if(l===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let d=this.s(l.node,l.remainder);const k=this.s(a.node,a.remainder);if(l.node===a.node)return this.findMatchesInNode(l.node,s,i.startLineNumber,i.startColumn,d,k,r,n,c,u,t),t;let P=i.startLineNumber,p=l.node;for(;p!==a.node;){const E=this.t(p.piece.bufferIndex,d,p.piece.end);if(E>=1){const T=this.a[p.piece.bufferIndex].lineStarts,U=this.u(p.piece.bufferIndex,p.piece.start),N=T[d.line+E],j=P===i.startLineNumber?i.startColumn:1;if(u=this.findMatchesInNode(p,s,P,j,d,this.s(p,N-U),r,n,c,u,t),u>=c)return t;P+=E}const A=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const T=this.getLineContent(P).substring(A,i.endColumn-1);return u=this.n(r,s,T,i.endLineNumber,A,u,t,n,c),t}if(u=this.n(r,s,this.getLineContent(P).substr(A),P,A,u,t,n,c),u>=c)return t;P++,l=this.H(P,1),p=l.node,d=this.s(l.node,l.remainder)}if(P===i.endLineNumber){const E=P===i.startLineNumber?i.startColumn-1:0,A=this.getLineContent(P).substring(E,i.endColumn-1);return u=this.n(r,s,A,i.endLineNumber,E,u,t,n,c),t}const w=P===i.startLineNumber?i.startColumn:1;return u=this.findMatchesInNode(a.node,s,P,w,d,k,r,n,c,u,t),t}n(i,r,n,c,t,u,s,l,a){const d=i.wordSeparators;if(!l&&i.simpleSearch){const P=i.simpleSearch,p=P.length,w=n.length;let E=-p;for(;(E=n.indexOf(P,E+p))!==-1;)if((!d||(0,L.$6B)(d,n,w,E,p))&&(s[u++]=new g.$_u(new O.$Ts(c,E+1+t,c,E+1+p+t),null),u>=a))return u;return u}let k;r.reset(0);do if(k=r.next(n),k&&(s[u++]=(0,L.$4B)(new O.$Ts(c,k.index+1+t,c,k.index+1+k[0].length+t),k,l),u>=a))return u;while(k);return u}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==I.$SB){const{node:c,remainder:t,nodeStartOffset:u}=this.G(i),s=c.piece,l=s.bufferIndex,a=this.s(c,t);if(c.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&u+s.length===i&&r.length<b){this.F(c,r),this.y();return}if(u===i)this.o(r,c),this.h.validate(i);else if(u+c.piece.length>i){const d=[];let k=new m(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),this.u(l,s.end)-this.u(l,a));if(this.K()&&this.M(r)&&this.I(c,t)===10){const E={line:k.start.line+1,column:0};k=new m(k.bufferIndex,E,k.end,this.t(k.bufferIndex,E,k.end),k.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(c,t-1)===13){const E=this.s(c,t-1);this.C(c,E),r="\r"+r,c.piece.length===0&&d.push(c)}else this.C(c,a);else this.C(c,a);const P=this.w(r);k.length>0&&this.S(c,k);let p=c;for(let w=0;w<P.length;w++)p=this.S(p,P[w]);this.v(d)}else this.q(r,c)}else{const c=this.w(r);let t=this.T(null,c[0]);for(let u=1;u<c.length;u++)t=this.S(t,c[u])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===I.$SB)return;const n=this.G(i),c=this.G(i+r),t=n.node,u=c.node;if(t===u){const P=this.s(t,n.remainder),p=this.s(t,c.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const w=t.next();(0,I.$XB)(this,t),this.N(w),this.y();return}this.D(t,p),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,P),this.O(t),this.y();return}this.E(t,P,p),this.y();return}const s=[],l=this.s(t,n.remainder);this.C(t,l),this.h.validate(i),t.piece.length===0&&s.push(t);const a=this.s(u,c.remainder);this.D(u,a),u.piece.length===0&&s.push(u);const d=t.next();for(let P=d;P!==I.$SB&&P!==u;P=P.next())s.push(P);const k=t.piece.length===0?t.prev():t;this.v(s),this.O(k),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const u=r.piece,s={line:u.start.line+1,column:0},l=new m(u.bufferIndex,s,u.end,this.t(u.bufferIndex,s,u.end),u.length-1);r.piece=l,i+=`
`,(0,I.$ZB)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const c=this.w(i);let t=this.T(r,c[c.length-1]);for(let u=c.length-2;u>=0;u--)t=this.T(t,c[u]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),c=this.S(r,n[0]);let t=c;for(let u=1;u<n.length;u++)t=this.S(t,n[u]);this.N(c)}s(i,r,n){const c=i.piece,t=i.piece.bufferIndex,u=this.a[t].lineStarts,l=u[c.start.line]+c.start.column+r;let a=c.start.line,d=c.end.line,k=0,P=0,p=0;for(;a<=d&&(k=a+(d-a)/2|0,p=u[k],k!==d);)if(P=u[k+1],l<p)d=k-1;else if(l>=P)a=k+1;else break;return n?(n.line=k,n.column=l-p,null):{line:k,column:l-p}}t(i,r,n){if(n.column===0)return n.line-r.line;const c=this.a[i].lineStarts;if(n.line===c.length-1)return n.line-r.line;const t=c[n.line+1],u=c[n.line]+n.column;if(t>u+1)return n.line-r.line;const s=u-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,I.$XB)(this,i[r])}w(i){if(i.length>b){const d=[];for(;i.length>b;){const P=i.charCodeAt(b-1);let p;P===13||P>=55296&&P<=56319?(p=i.substring(0,b-1),i=i.substring(b-1)):(p=i.substring(0,b),i=i.substring(b));const w=R(p);d.push(new m(this.a.length,{line:0,column:0},{line:w.length-1,column:p.length-w[w.length-1]},w.length-1,p.length)),this.a.push(new v(p,w))}const k=R(i);return d.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new v(i,k)),d}let r=this.a[0].buffer.length;const n=R(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let d=0;d<n.length;d++)n[d]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let d=0;d<n.length;d++)n[d]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[u],l={line:u,column:s},a=new m(0,c,l,this.t(0,c,l),t-r);return this.g=l,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,c="";const t=this.h.get2(i);if(t){n=t.node;const u=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,l=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)c=s.substring(l+u,l+n.piece.length);else{const a=this.B(n,i-t.nodeStartLineNumber);return s.substring(l+u,l+a-r)}}else{let u=0;const s=i;for(;n!==I.$SB;)if(n.left!==I.$SB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const l=this.B(n,i-n.lf_left-2),a=this.B(n,i-n.lf_left-1),d=this.a[n.piece.bufferIndex].buffer,k=this.u(n.piece.bufferIndex,n.piece.start);return u+=n.size_left,this.h.set({node:n,nodeStartOffset:u,nodeStartLineNumber:s-(i-1-n.lf_left)}),d.substring(k+l,k+a-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const l=this.B(n,i-n.lf_left-2),a=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);c=a.substring(d+l,d+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==I.$SB;){const u=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),l=this.u(n.piece.bufferIndex,n.piece.start);return c+=u.substring(l,l+s-r),c}else{const s=this.u(n.piece.bufferIndex,n.piece.start);c+=u.substr(s,n.piece.length)}n=n.next()}return c}y(){let i=this.root,r=1,n=0;for(;i!==I.$SB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,c=this.s(i,r),t=c.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const u=this.t(i.piece.bufferIndex,n.start,c);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:c.column}}B(i,r){if(r<0)return 0;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?c[n.end.line]+n.end.column-c[n.start.line]-n.start.column:c[t]-c[n.start.line]-n.start.column}C(i,r){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),u=r,s=this.u(n.bufferIndex,u),l=this.t(n.bufferIndex,n.start,u),a=l-c,d=s-t,k=n.length+d;i.piece=new m(n.bufferIndex,n.start,u,l,k),(0,I.$ZB)(this,i,d,a)}D(i,r){const n=i.piece,c=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),u=r,s=this.t(n.bufferIndex,u,n.end),l=this.u(n.bufferIndex,u),a=s-c,d=t-l,k=n.length+d;i.piece=new m(n.bufferIndex,u,n.end,s,k),(0,I.$ZB)(this,i,d,a)}E(i,r,n){const c=i.piece,t=c.start,u=c.end,s=c.length,l=c.lineFeedCnt,a=r,d=this.t(c.bufferIndex,c.start,a),k=this.u(c.bufferIndex,r)-this.u(c.bufferIndex,t);i.piece=new m(c.bufferIndex,c.start,a,d,k),(0,I.$ZB)(this,i,k-s,d-l);const P=new m(c.bufferIndex,n,u,this.t(c.bufferIndex,n,u),this.u(c.bufferIndex,u)-this.u(c.bufferIndex,n)),p=this.S(i,P);this.N(p)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=r;const t=R(r,!1);for(let p=0;p<t.length;p++)t[p]+=c;if(n){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[u],l={line:u,column:s},a=i.piece.length+r.length,d=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,l),P=k-d;i.piece=new m(i.piece.bufferIndex,i.piece.start,l,k,a),this.g=l,(0,I.$ZB)(this,i,r.length,P)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let c=0;for(;r!==I.$SB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){c+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=r.size_left+r.piece.length,c+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,c=0;for(;n!==I.$SB;)if(n.left!==I.$SB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),u=this.B(n,i-n.lf_left-1);return c+=n.size_left,{node:n,remainder:Math.min(t+r-1,u),nodeStartOffset:c}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:c};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==I.$SB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),u=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:u}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(c)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$SB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,c=r.start.line,t=n[c]+r.start.column;return c===n.length-1||n[c+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$SB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const u=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,s,u),(0,I.$ZB)(this,i,-1,-1),i.piece.length===0&&n.push(i);const l={line:r.piece.start.line+1,column:0},a=r.piece.length-1,d=this.t(r.piece.bufferIndex,l,r.piece.end);r.piece=new m(r.piece.bufferIndex,l,r.piece.end,d,a),(0,I.$ZB)(this,r,-1,-1),r.piece.length===0&&n.push(r);const k=this.w(`\r
`);this.S(i,k[0]);for(let P=0;P<n.length;P++)(0,I.$XB)(this,n[P])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,I.$XB)(this,n);else{const c=n.piece,t={line:c.start.line+1,column:0},u=c.length-1,s=this.t(c.bufferIndex,t,c.end);n.piece=new m(c.bufferIndex,t,c.end,s,u),(0,I.$ZB)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===I.$SB)return r(I.$SB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===I.$SB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,c=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(c,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,c)}S(i,r){const n=new I.$RB(r,1);if(n.left=I.$SB,n.right=I.$SB,n.parent=I.$SB,n.size_left=0,n.lf_left=0,this.root===I.$SB)this.root=n,n.color=0;else if(i.right===I.$SB)i.right=n,n.parent=i;else{const t=(0,I.$TB)(i.right);t.left=n,n.parent=t}return(0,I.$YB)(this,n),n}T(i,r){const n=new I.$RB(r,1);if(n.left=I.$SB,n.right=I.$SB,n.parent=I.$SB,n.size_left=0,n.lf_left=0,this.root===I.$SB)this.root=n,n.color=0;else if(i.left===I.$SB)i.left=n,n.parent=i;else{const c=(0,I.$UB)(i.left);c.right=n,n.parent=c}return(0,I.$YB)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$_B=f}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8=e.$h8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const L=this.a.get(I);return this.a.delete(I),L}}addDragOperationTransfer(I,L){this.a.set(I,L)}}e.$h8=D;class O{constructor(I){this.identifier=I}}e.$i8=O}),define(ke[178],Se([1,0,4,3]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Ud,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,O.$Rc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new I(this,b,$);return this.b.set(b,y),(0,O.$Rc)(()=>{const R=this.b.get(b);!R||R!==y||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$st=g;class I extends O.$Tc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;class I extends O.$Tc{constructor(m,v="",S="",h=!0,f){super(),this.h=this.B(new D.$Ud),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=v,this.u=S,this.w=h,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,v){this.C&&await this.C(m)}}e.$Ji=I;class L extends O.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Ud),this.onWillRun=this.f.event,this.m=this.B(new D.$Ud),this.onDidRun=this.m.event}async run(m,v){if(!m.enabled)return;this.f.fire({action:m});let S;try{await this.u(m,v)}catch(h){S=h}this.m.fire({action:m,error:S})}async u(m,v){await m.run(v)}}e.$Ki=L;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let v=[];for(const S of m)S.length&&(v.length?v=[...v,new b,...S]:v=S);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Li=b;class ${get actions(){return this.a}constructor(m,v,S,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=v,this.class=h,this.a=S}async run(){}}e.$Mi=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Ni=y;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Oi=R}),define(ke[181],Se([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0;const O=60,g=O*60,I=g*24,L=I*7,b=I*30,$=I*365;function y(C,m,v,S){typeof C!="number"&&(C=C.getTime());const h=Math.round((new Date().getTime()-C)/1e3);if(h<-30)return(0,D.localize)(0,null,y(new Date().getTime()+h*1e3,!1));if(!S&&h<30)return(0,D.localize)(1,null);let f;return h<O?(f=h,m?f===1?v?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):v?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?v?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):v?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):h<g?(f=Math.floor(h/O),m?f===1?v?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):v?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?v?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):v?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):h<I?(f=Math.floor(h/g),m?f===1?v?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):v?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?v?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):v?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):h<L?(f=Math.floor(h/I),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):h<b?(f=Math.floor(h/L),m?f===1?v?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):v?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?v?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):v?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):h<$?(f=Math.floor(h/b),m?f===1?v?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):v?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?v?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):v?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(h/$),m?f===1?v?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):v?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?v?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):v?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$um=y;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$vm=R}),define(ke[183],Se([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),L(C.stack)||L(C.stacktrace)):b(C)}function L(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const v=D.$Hb(C),S=$(v[0],m);return v.length>1?g.localize(4,null,S,v.length):S}if(O.$Hf(C))return C;if(C.detail){const v=C.detail;if(v.error)return I(v.error,m);if(v.exception)return I(v.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Pi=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Qi=y;function R(C,m){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=m,v}e.$Ri=R}),define(ke[184],Se([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[10],Se([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let O=!1,g=!1,I=!1,L=!1,b=!1,$=!1,y=!1,R=!1,C=!1,m=!1,v,S=e.$g,h=e.$g,f,o;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",c=n&&r?.type==="renderer";if(typeof r=="object"){O=r.platform==="win32",g=r.platform==="darwin",I=r.platform==="linux",L=I&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,y=n,C=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,S=e.$g;const w=r.env.VSCODE_NLS_CONFIG;if(w)try{const E=JSON.parse(w),A=E.availableLanguages["*"];v=E.locale,h=E.osLocale,S=A||e.$g,f=E._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!c?(o=navigator.userAgent,O=o.indexOf("Windows")>=0,g=o.indexOf("Macintosh")>=0,R=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=o.indexOf("Linux")>=0,m=o?.indexOf("Mobi")>=0,$=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=v,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=u;let s=0;g?s=1:O?s=3:I&&(s=2),e.$i=O,e.$j=g,e.$k=I,e.$l=L,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=m,e.$t=C,e.$u=s,e.$v=o,e.$w=S;var l;(function(w){function E(){return e.$w}w.value=E;function A(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}w.isDefaultVariant=A;function T(){return e.$w==="en"}w.isDefault=T})(l||(e.Language=l={})),e.$x=v,e.$y=h,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const w=[];i.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let T=0,U=w.length;T<U;T++){const N=w[T];if(N.id===A.data.vscodeScheduleAsyncWork){w.splice(T,1),N.callback();return}}});let E=0;return A=>{const T=++E;w.push({id:T,callback:A}),i.postMessage({vscodeScheduleAsyncWork:T},"*")}}return w=>setTimeout(w)})();var a;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=g||R?2:O?1:3;let d=!0,k=!1;function P(){if(!k){k=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,d=new Uint16Array(w.buffer)[0]===(2<<8)+1}return d}e.$D=P,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function p(w){return parseFloat(w)>=20}e.$J=p}),define(ke[50],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;O={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(ke[16],Se([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,g=97,I=90,L=122,b=46,$=47,y=92,R=58,C=63;class m extends Error{constructor(u,s,l){let a;typeof s=="string"&&s.indexOf("not ")===0?(a="must not be",s=s.replace(/^not /,"")):a="must be";const d=u.indexOf(".")!==-1?"property":"argument";let k=`The "${u}" ${d} ${a} of type ${s}`;k+=`. Received type ${typeof l}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,u){if(t===null||typeof t!="object")throw new m(u,"Object",t)}function S(t,u){if(typeof t!="string")throw new m(u,"string",t)}const h=D.$dc==="win32";function f(t){return t===$||t===y}function o(t){return t===$}function i(t){return t>=O&&t<=I||t>=g&&t<=L}function r(t,u,s,l){let a="",d=0,k=-1,P=0,p=0;for(let w=0;w<=t.length;++w){if(w<t.length)p=t.charCodeAt(w);else{if(l(p))break;p=$}if(l(p)){if(!(k===w-1||P===1))if(P===2){if(a.length<2||d!==2||a.charCodeAt(a.length-1)!==b||a.charCodeAt(a.length-2)!==b){if(a.length>2){const E=a.lastIndexOf(s);E===-1?(a="",d=0):(a=a.slice(0,E),d=a.length-1-a.lastIndexOf(s)),k=w,P=0;continue}else if(a.length!==0){a="",d=0,k=w,P=0;continue}}u&&(a+=a.length>0?`${s}..`:"..",d=2)}else a.length>0?a+=`${s}${t.slice(k+1,w)}`:a=t.slice(k+1,w),d=w-k-1;k=w,P=0}else p===b&&P!==-1?++P:P=-1}return a}function n(t,u){v(u,"pathObject");const s=u.dir||u.root,l=u.base||`${u.name||""}${u.ext||""}`;return s?s===u.root?`${s}${l}`:`${s}${t}${l}`:l}e.$fc={resolve(...t){let u="",s="",l=!1;for(let a=t.length-1;a>=-1;a--){let d;if(a>=0){if(d=t[a],S(d,"path"),d.length===0)continue}else u.length===0?d=D.cwd():(d=D.env[`=${u}`]||D.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==u.toLowerCase()&&d.charCodeAt(2)===y)&&(d=`${u}\\`));const k=d.length;let P=0,p="",w=!1;const E=d.charCodeAt(0);if(k===1)f(E)&&(P=1,w=!0);else if(f(E))if(w=!0,f(d.charCodeAt(1))){let A=2,T=A;for(;A<k&&!f(d.charCodeAt(A));)A++;if(A<k&&A!==T){const U=d.slice(T,A);for(T=A;A<k&&f(d.charCodeAt(A));)A++;if(A<k&&A!==T){for(T=A;A<k&&!f(d.charCodeAt(A));)A++;(A===k||A!==T)&&(p=`\\\\${U}\\${d.slice(T,A)}`,P=A)}}}else P=1;else i(E)&&d.charCodeAt(1)===R&&(p=d.slice(0,2),P=2,k>2&&f(d.charCodeAt(2))&&(w=!0,P=3));if(p.length>0)if(u.length>0){if(p.toLowerCase()!==u.toLowerCase())continue}else u=p;if(l){if(u.length>0)break}else if(s=`${d.slice(P)}\\${s}`,l=w,w&&u.length>0)break}return s=r(s,!l,"\\",f),l?`${u}\\${s}`:`${u}${s}`||"."},normalize(t){S(t,"path");const u=t.length;if(u===0)return".";let s=0,l,a=!1;const d=t.charCodeAt(0);if(u===1)return o(d)?"\\":t;if(f(d))if(a=!0,f(t.charCodeAt(1))){let P=2,p=P;for(;P<u&&!f(t.charCodeAt(P));)P++;if(P<u&&P!==p){const w=t.slice(p,P);for(p=P;P<u&&f(t.charCodeAt(P));)P++;if(P<u&&P!==p){for(p=P;P<u&&!f(t.charCodeAt(P));)P++;if(P===u)return`\\\\${w}\\${t.slice(p)}\\`;P!==p&&(l=`\\\\${w}\\${t.slice(p,P)}`,s=P)}}}else s=1;else i(d)&&t.charCodeAt(1)===R&&(l=t.slice(0,2),s=2,u>2&&f(t.charCodeAt(2))&&(a=!0,s=3));let k=s<u?r(t.slice(s),!a,"\\",f):"";return k.length===0&&!a&&(k="."),k.length>0&&f(t.charCodeAt(u-1))&&(k+="\\"),l===void 0?a?`\\${k}`:k:a?`${l}\\${k}`:`${l}${k}`},isAbsolute(t){S(t,"path");const u=t.length;if(u===0)return!1;const s=t.charCodeAt(0);return f(s)||u>2&&i(s)&&t.charCodeAt(1)===R&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,s;for(let d=0;d<t.length;++d){const k=t[d];S(k,"path"),k.length>0&&(u===void 0?u=s=k:u+=`\\${k}`)}if(u===void 0)return".";let l=!0,a=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++a;const d=s.length;d>1&&f(s.charCodeAt(1))&&(++a,d>2&&(f(s.charCodeAt(2))?++a:l=!1))}if(l){for(;a<u.length&&f(u.charCodeAt(a));)a++;a>=2&&(u=`\\${u.slice(a)}`)}return e.$fc.normalize(u)},relative(t,u){if(S(t,"from"),S(u,"to"),t===u)return"";const s=e.$fc.resolve(t),l=e.$fc.resolve(u);if(s===l||(t=s.toLowerCase(),u=l.toLowerCase(),t===u))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===y;)a++;let d=t.length;for(;d-1>a&&t.charCodeAt(d-1)===y;)d--;const k=d-a;let P=0;for(;P<u.length&&u.charCodeAt(P)===y;)P++;let p=u.length;for(;p-1>P&&u.charCodeAt(p-1)===y;)p--;const w=p-P,E=k<w?k:w;let A=-1,T=0;for(;T<E;T++){const N=t.charCodeAt(a+T);if(N!==u.charCodeAt(P+T))break;N===y&&(A=T)}if(T!==E){if(A===-1)return l}else{if(w>E){if(u.charCodeAt(P+T)===y)return l.slice(P+T+1);if(T===2)return l.slice(P+T)}k>E&&(t.charCodeAt(a+T)===y?A=T:T===2&&(A=3)),A===-1&&(A=0)}let U="";for(T=a+A+1;T<=d;++T)(T===d||t.charCodeAt(T)===y)&&(U+=U.length===0?"..":"\\..");return P+=A,U.length>0?`${U}${l.slice(P,p)}`:(l.charCodeAt(P)===y&&++P,l.slice(P,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$fc.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===y){if(u.charCodeAt(1)===y){const s=u.charCodeAt(2);if(s!==C&&s!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(i(u.charCodeAt(0))&&u.charCodeAt(1)===R&&u.charCodeAt(2)===y)return`\\\\?\\${u}`;return t},dirname(t){S(t,"path");const u=t.length;if(u===0)return".";let s=-1,l=0;const a=t.charCodeAt(0);if(u===1)return f(a)?t:".";if(f(a)){if(s=l=1,f(t.charCodeAt(1))){let P=2,p=P;for(;P<u&&!f(t.charCodeAt(P));)P++;if(P<u&&P!==p){for(p=P;P<u&&f(t.charCodeAt(P));)P++;if(P<u&&P!==p){for(p=P;P<u&&!f(t.charCodeAt(P));)P++;if(P===u)return t;P!==p&&(s=l=P+1)}}}}else i(a)&&t.charCodeAt(1)===R&&(s=u>2&&f(t.charCodeAt(2))?3:2,l=s);let d=-1,k=!0;for(let P=u-1;P>=l;--P)if(f(t.charCodeAt(P))){if(!k){d=P;break}}else k=!1;if(d===-1){if(s===-1)return".";d=s}return t.slice(0,d)},basename(t,u){u!==void 0&&S(u,"ext"),S(t,"path");let s=0,l=-1,a=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,P=-1;for(d=t.length-1;d>=s;--d){const p=t.charCodeAt(d);if(f(p)){if(!a){s=d+1;break}}else P===-1&&(a=!1,P=d+1),k>=0&&(p===u.charCodeAt(k)?--k===-1&&(l=d):(k=-1,l=P))}return s===l?l=P:l===-1&&(l=t.length),t.slice(s,l)}for(d=t.length-1;d>=s;--d)if(f(t.charCodeAt(d))){if(!a){s=d+1;break}}else l===-1&&(a=!1,l=d+1);return l===-1?"":t.slice(s,l)},extname(t){S(t,"path");let u=0,s=-1,l=0,a=-1,d=!0,k=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(u=l=2);for(let P=t.length-1;P>=u;--P){const p=t.charCodeAt(P);if(f(p)){if(!d){l=P+1;break}continue}a===-1&&(d=!1,a=P+1),p===b?s===-1?s=P:k!==1&&(k=1):s!==-1&&(k=-1)}return s===-1||a===-1||k===0||k===1&&s===a-1&&s===l+1?"":t.slice(s,a)},format:n.bind(null,"\\"),parse(t){S(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.length;let l=0,a=t.charCodeAt(0);if(s===1)return f(a)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(f(a)){if(l=1,f(t.charCodeAt(1))){let A=2,T=A;for(;A<s&&!f(t.charCodeAt(A));)A++;if(A<s&&A!==T){for(T=A;A<s&&f(t.charCodeAt(A));)A++;if(A<s&&A!==T){for(T=A;A<s&&!f(t.charCodeAt(A));)A++;A===s?l=A:A!==T&&(l=A+1)}}}}else if(i(a)&&t.charCodeAt(1)===R){if(s<=2)return u.root=u.dir=t,u;if(l=2,f(t.charCodeAt(2))){if(s===3)return u.root=u.dir=t,u;l=3}}l>0&&(u.root=t.slice(0,l));let d=-1,k=l,P=-1,p=!0,w=t.length-1,E=0;for(;w>=l;--w){if(a=t.charCodeAt(w),f(a)){if(!p){k=w+1;break}continue}P===-1&&(p=!1,P=w+1),a===b?d===-1?d=w:E!==1&&(E=1):d!==-1&&(E=-1)}return P!==-1&&(d===-1||E===0||E===1&&d===P-1&&d===k+1?u.base=u.name=t.slice(k,P):(u.name=t.slice(k,d),u.base=t.slice(k,P),u.ext=t.slice(d,P))),k>0&&k!==l?u.dir=t.slice(0,k-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(h){const t=/\\/g;return()=>{const u=D.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let u="",s=!1;for(let l=t.length-1;l>=-1&&!s;l--){const a=l>=0?t[l]:c();S(a,"path"),a.length!==0&&(u=`${a}/${u}`,s=a.charCodeAt(0)===$)}return u=r(u,!s,"/",o),s?`/${u}`:u.length>0?u:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=r(t,!u,"/",o),t.length===0?u?"/":s?"./":".":(s&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let u;for(let s=0;s<t.length;++s){const l=t[s];S(l,"path"),l.length>0&&(u===void 0?u=l:u+=`/${l}`)}return u===void 0?".":e.$gc.normalize(u)},relative(t,u){if(S(t,"from"),S(u,"to"),t===u||(t=e.$gc.resolve(t),u=e.$gc.resolve(u),t===u))return"";const s=1,l=t.length,a=l-s,d=1,k=u.length-d,P=a<k?a:k;let p=-1,w=0;for(;w<P;w++){const A=t.charCodeAt(s+w);if(A!==u.charCodeAt(d+w))break;A===$&&(p=w)}if(w===P)if(k>P){if(u.charCodeAt(d+w)===$)return u.slice(d+w+1);if(w===0)return u.slice(d+w)}else a>P&&(t.charCodeAt(s+w)===$?p=w:w===0&&(p=0));let E="";for(w=s+p+1;w<=l;++w)(w===l||t.charCodeAt(w)===$)&&(E+=E.length===0?"..":"/..");return`${E}${u.slice(d+p)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$;let s=-1,l=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===$){if(!l){s=a;break}}else l=!1;return s===-1?u?"/":".":u&&s===1?"//":t.slice(0,s)},basename(t,u){u!==void 0&&S(u,"ext"),S(t,"path");let s=0,l=-1,a=!0,d;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,P=-1;for(d=t.length-1;d>=0;--d){const p=t.charCodeAt(d);if(p===$){if(!a){s=d+1;break}}else P===-1&&(a=!1,P=d+1),k>=0&&(p===u.charCodeAt(k)?--k===-1&&(l=d):(k=-1,l=P))}return s===l?l=P:l===-1&&(l=t.length),t.slice(s,l)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===$){if(!a){s=d+1;break}}else l===-1&&(a=!1,l=d+1);return l===-1?"":t.slice(s,l)},extname(t){S(t,"path");let u=-1,s=0,l=-1,a=!0,d=0;for(let k=t.length-1;k>=0;--k){const P=t.charCodeAt(k);if(P===$){if(!a){s=k+1;break}continue}l===-1&&(a=!1,l=k+1),P===b?u===-1?u=k:d!==1&&(d=1):u!==-1&&(d=-1)}return u===-1||l===-1||d===0||d===1&&u===l-1&&u===s+1?"":t.slice(u,l)},format:n.bind(null,"/"),parse(t){S(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.charCodeAt(0)===$;let l;s?(u.root="/",l=1):l=0;let a=-1,d=0,k=-1,P=!0,p=t.length-1,w=0;for(;p>=l;--p){const E=t.charCodeAt(p);if(E===$){if(!P){d=p+1;break}continue}k===-1&&(P=!1,k=p+1),E===b?a===-1?a=p:w!==1&&(w=1):a!==-1&&(w=-1)}if(k!==-1){const E=d===0&&s?1:d;a===-1||w===0||w===1&&a===k-1&&a===d+1?u.base=u.name=t.slice(E,k):(u.name=t.slice(E,a),u.base=t.slice(E,k),u.ext=t.slice(a,k))}return d>0?u.dir=t.slice(0,d-1):s&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,16]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0;const g=new D.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),I=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(P,p,w=!1){const E=P||"",A=p||"",T=g.value.collator.compare(E,A);return g.value.collatorIsNumeric&&T===0&&E!==A?E<A?-1:1:T}e.$Hq=b;function $(P,p){const w=I.value.collator;return P=P||"",p=p||"",n(w,P,p)}e.$Iq=$;function y(P,p){const w=I.value.collator;return P=P||"",p=p||"",s(P,p)||n(w,P,p)}e.$Jq=y;function R(P,p){const w=I.value.collator;return P=P||"",p=p||"",u(P,p)||n(w,P,p)}e.$Kq=R;function C(P,p){return P=P||"",p=p||"",P===p?0:P<p?-1:1}e.$Lq=C;function m(P,p){const[w,E]=i(P),[A,T]=i(p);let U=g.value.collator.compare(E,T);if(U===0){if(g.value.collatorIsNumeric&&E!==T)return E<T?-1:1;if(U=g.value.collator.compare(w,A),g.value.collatorIsNumeric&&U===0&&w!==A)return w<A?-1:1}return U}e.$Mq=m;function v(P,p){P=P||"",p=p||"";const w=r(P),E=r(p),A=I.value.collator,T=L.value.collator;return n(T,w,E)||n(A,P,p)}e.$Nq=v;function S(P,p){P=P||"",p=p||"";const w=r(P),E=r(p),A=I.value.collator,T=L.value.collator;return n(T,w,E)||s(P,p)||n(A,P,p)}e.$Oq=S;function h(P,p){P=P||"",p=p||"";const w=r(P),E=r(p),A=I.value.collator,T=L.value.collator;return n(T,w,E)||u(P,p)||n(A,P,p)}e.$Pq=h;function f(P,p){P=P||"",p=p||"";const w=r(P).toLowerCase(),E=r(p).toLowerCase();return w!==E?w<E?-1:1:P!==p?P<p?-1:1:0}e.$Qq=f;const o=/^(.*?)(\.([^.]*))?$/;function i(P,p=!1){const w=P?o.exec(P):[];let E=[w&&w[1]||"",w&&w[3]||""];return p&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function r(P){const p=P?o.exec(P):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function n(P,p,w){const E=P.compare(p,w);return E!==0?E:p.length!==w.length?p.length<w.length?-1:1:0}function c(P){const p=P.charAt(0);return p.toLocaleUpperCase()!==p}function t(P){const p=P.charAt(0);return p.toLocaleLowerCase()!==p}function u(P,p){return c(P)&&t(p)?-1:t(P)&&c(p)?1:0}function s(P,p){return t(P)&&c(p)?-1:c(P)&&t(p)?1:0}function l(P,p,w=!1){return w||(P=P&&P.toLowerCase(),p=p&&p.toLowerCase()),P===p?0:P<p?-1:1}function a(P,p,w=!1){const E=P.split(O.sep),A=p.split(O.sep),T=E.length-1,U=A.length-1;let N,j;for(let F=0;;F++){if(N=T===F,j=U===F,N&&j)return b(E[F],A[F],w);if(N)return-1;if(j)return 1;const M=l(E[F],A[F],w);if(M!==0)return M}}e.$Rq=a;function d(P,p,w){const E=P.toLowerCase(),A=p.toLowerCase(),T=k(P,p,w);if(T)return T;const U=E.endsWith(w),N=A.endsWith(w);if(U!==N)return U?-1:1;const j=b(E,A);return j!==0?j:E.localeCompare(A)}e.$Sq=d;function k(P,p,w){const E=P.toLowerCase(),A=p.toLowerCase(),T=E.startsWith(w),U=A.startsWith(w);if(T!==U)return T?-1:1;if(T&&U){if(E.length<A.length)return-1;if(E.length>A.length)return 1}return 0}e.$Tq=k}),define(ke[33],Se([1,0,16,10,12,18]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=void 0;function L(d){return d===47||d===92}e.$Zf=L;function b(d){return d.replace(/[\\/]/g,D.$gc.sep)}e.$1f=b;function $(d){return d.indexOf("/")===-1&&(d=b(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$2f=$;function y(d,k=D.$gc.sep){if(!d)return"";const P=d.length,p=d.charCodeAt(0);if(L(p)){if(L(d.charCodeAt(1))&&!L(d.charCodeAt(2))){let E=3;const A=E;for(;E<P&&!L(d.charCodeAt(E));E++);if(A!==E&&!L(d.charCodeAt(E+1))){for(E+=1;E<P;E++)if(L(d.charCodeAt(E)))return d.slice(0,E+1).replace(/[\\/]/g,k)}}return k}else if(o(p)&&d.charCodeAt(1)===58)return L(d.charCodeAt(2))?d.slice(0,2)+k:d.slice(0,2);let w=d.indexOf("://");if(w!==-1){for(w+=3;w<P;w++)if(L(d.charCodeAt(w)))return d.slice(0,w+1)}return""}e.$3f=y;function R(d){if(!O.$i||!d||d.length<5)return!1;let k=d.charCodeAt(0);if(k!==92||(k=d.charCodeAt(1),k!==92))return!1;let P=2;const p=P;for(;P<d.length&&(k=d.charCodeAt(P),k!==92);P++);return!(p===P||(k=d.charCodeAt(P+1),isNaN(k)||k===92))}e.$4f=R;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(d,k=O.$i){const P=k?C:m;return!(!d||d.length===0||/^\s+$/.test(d)||(P.lastIndex=0,P.test(d))||k&&v.test(d)||d==="."||d===".."||k&&d[d.length-1]==="."||k&&d.length!==d.trim().length||d.length>255)}e.$5f=S;function h(d,k,P){const p=d===k;return!P||p?p:!d||!k?!1:(0,g.$$e)(d,k)}e.$6f=h;function f(d,k,P,p=D.sep){if(d===k)return!0;if(!d||!k||k.length>d.length)return!1;if(P){if(!(0,g.$_e)(d,k))return!1;if(k.length===d.length)return!0;let E=k.length;return k.charAt(k.length-1)===p&&E--,d.charAt(E)===p}return k.charAt(k.length-1)!==p&&(k+=p),d.indexOf(k)===0}e.$7f=f;function o(d){return d>=65&&d<=90||d>=97&&d<=122}e.$8f=o;function i(d,k){return O.$i&&d.endsWith(":")&&(d+=D.sep),(0,D.$ic)(d)||(d=(0,D.$jc)(k,d)),d=(0,D.$hc)(d),O.$i?(d=(0,g.$Te)(d,D.sep),d.endsWith(":")&&(d+=D.sep)):(d=(0,g.$Te)(d,D.sep),d||(d=D.sep)),d}e.$9f=i;function r(d){const k=(0,D.$hc)(d);return O.$i?d.length>3?!1:n(k)&&(d.length===2||k.charCodeAt(2)===92):k===D.$gc.sep}e.$0f=r;function n(d,k=O.$i){return k?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$$f=n;function c(d,k=O.$i){return n(d,k)?d[0]:void 0}e.$_f=c;function t(d,k,P){return k.length>d.length?-1:d===k?0:(P&&(d=d.toLowerCase(),k=k.toLowerCase()),d.indexOf(k))}e.$ag=t;function u(d){const k=d.split(":");let P,p,w;for(const E of k){const A=Number(E);(0,I.$Lf)(A)?p===void 0?p=A:w===void 0&&(w=A):P=P?[P,E].join(":"):E}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:p!==void 0?p:void 0,column:w!==void 0?w:p!==void 0?1:void 0}}e.$bg=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(d,k,P=8){let p="";for(let E=0;E<P;E++){let A;E===0&&O.$i&&!k&&(P===3||P===4)?A=l:A=s,p+=A.charAt(Math.floor(Math.random()*A.length))}let w;return k?w=`${k}-${p}`:w=p,d?(0,D.$jc)(d,w):w}e.$cg=a}),define(ke[129],Se([1,0,128,123,54,16,10,12]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=void 0;const $=0,y=[$,[]];function R(B,X,ue,Z){if(!B||!X)return y;const J=B.length,Y=X.length;if(J<Y)return y;const he=B.toLowerCase();return C(X,ue,Y,B,he,J,Z)}e.$Uq=R;function C(B,X,ue,Z,J,Y,he){const _=[],we=[];for(let re=0;re<ue;re++){const ye=re*Y,de=ye-Y,ge=re>0,x=B[re],te=X[re];for(let G=0;G<Y;G++){const ie=G>0,fe=ye+G,ve=fe-1,Pe=de+G-1,be=ie?_[ve]:0,De=ge&&ie?_[Pe]:0,z=ge&&ie?we[Pe]:0;let Q;!De&&ge?Q=0:Q=m(x,te,Z,J,G,z),Q&&De+Q>=be&&(he||ge||J.startsWith(X,G))?(we[fe]=z+1,_[fe]=De+Q):(we[fe]=$,_[fe]=be)}}const oe=[];let K=ue-1,W=Y-1;for(;K>=0&&W>=0;){const re=K*Y+W;we[re]===$||(oe.push(W),K--),W--}return[_[ue*Y-1],oe.reverse()]}function m(B,X,ue,Z,J,Y){let he=0;if(!v(X,Z[J]))return he;if(he+=1,Y>0&&(he+=Y*5),B===ue[J]&&(he+=1),J===0)he+=8;else{const _=S(ue.charCodeAt(J-1));_?he+=_:(0,O.$Wj)(ue.charCodeAt(J))&&Y===0&&(he+=2)}return he}function v(B,X){return B===X?!0:B==="/"||B==="\\"?X==="/"||X==="\\":!1}function S(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function f(B,X,ue=0,Z=0){const J=X;return J.values&&J.values.length>1?o(B,J.values,ue,Z):i(B,X,ue,Z)}e.$Vq=f;function o(B,X,ue,Z){let J=0;const Y=[];for(const he of X){const[_,we]=i(B,he,ue,Z);if(typeof _!="number")return h;J+=_,Y.push(...we)}return[J,P(Y)]}function i(B,X,ue,Z){const J=(0,O.$6j)(X.original,X.originalLowercase,ue,B,B.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,O.$3j)(J)]:h}const r=Object.freeze({score:0}),n=1<<18,c=1<<17,t=1<<16;function u(B,X,ue,Z){const J=Z.values?Z.values:[Z];return(0,g.$Si)({[Z.normalized]:{values:J.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:B,description:X,allowNonContiguousMatches:ue}})}function s(B,X,ue,Z,J){if(!B||!X.normalized)return r;const Y=Z.getItemLabel(B);if(!Y)return r;const he=Z.getItemDescription(B),_=u(Y,he,ue,X),we=J[_];if(we)return we;const oe=l(Y,he,Z.getItemPath(B),X,ue);return J[_]=oe,oe}e.$Wq=s;function l(B,X,ue,Z,J){const Y=!ue||!Z.containsPathSeparator;return ue&&(L.$k?Z.pathNormalized===ue:(0,b.$$e)(Z.pathNormalized,ue))?{score:n,labelMatch:[{start:0,end:B.length}],descriptionMatch:X?[{start:0,end:X.length}]:void 0}:Z.values&&Z.values.length>1?a(B,X,ue,Z.values,Y,J):d(B,X,ue,Z,Y,J)}function a(B,X,ue,Z,J,Y){let he=0;const _=[],we=[];for(const oe of Z){const{score:K,labelMatch:W,descriptionMatch:re}=d(B,X,ue,oe,J,Y);if(K===$)return r;he+=K,W&&_.push(...W),re&&we.push(...re)}return{score:he,labelMatch:P(_),descriptionMatch:P(we)}}function d(B,X,ue,Z,J,Y){if(J||!X){const[he,_]=R(B,Z.normalized,Z.normalizedLowercase,Y&&!Z.expectContiguousMatch);if(he){const we=(0,O.$Tj)(Z.normalized,B);let oe;if(we){oe=c;const K=Math.round(Z.normalized.length/B.length*100);oe+=K}else oe=t;return{score:oe+he,labelMatch:we||k(_)}}}if(X){let he=X;ue&&(he=`${X}${I.sep}`);const _=he.length,we=`${he}${B}`,[oe,K]=R(we,Z.normalized,Z.normalizedLowercase,Y&&!Z.expectContiguousMatch);if(oe){const W=k(K),re=[],ye=[];return W.forEach(de=>{de.start<_&&de.end>_?(re.push({start:0,end:de.end-_}),ye.push({start:de.start,end:_})):de.start>=_?re.push({start:de.start-_,end:de.end-_}):ye.push(de)}),{score:oe,labelMatch:re,descriptionMatch:ye}}}return r}function k(B){const X=[];if(!B)return X;let ue;for(const Z of B)ue&&ue.end===Z?ue.end+=1:(ue={start:Z,end:Z+1},X.push(ue));return X}function P(B){const X=B.sort((J,Y)=>J.start-Y.start),ue=[];let Z;for(const J of X)!Z||!p(Z,J)?(Z=J,ue.push(J)):(Z.start=Math.min(Z.start,J.start),Z.end=Math.max(Z.end,J.end));return ue}function p(B,X){return!(B.end<X.start||X.end<B.start)}function w(B,X,ue,Z,J,Y){const he=s(B,ue,Z,J,Y),_=s(X,ue,Z,J,Y),we=he.score,oe=_.score;if((we===n||oe===n)&&we!==oe)return we===n?-1:1;if(we>t||oe>t){if(we!==oe)return we>oe?-1:1;if(we<c&&oe<c){const x=A(he.labelMatch,_.labelMatch);if(x!==0)return x}const de=J.getItemLabel(B)||"",ge=J.getItemLabel(X)||"";if(de.length!==ge.length)return de.length-ge.length}if(we!==oe)return we>oe?-1:1;const K=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,W=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(K&&!W)return-1;if(W&&!K)return 1;const re=E(B,he,J),ye=E(X,_,J);return re&&ye&&re!==ye?ye>re?-1:1:T(B,X,ue,J)}e.$Xq=w;function E(B,X,ue){let Z=-1,J=-1;if(X.descriptionMatch&&X.descriptionMatch.length?Z=X.descriptionMatch[0].start:X.labelMatch&&X.labelMatch.length&&(Z=X.labelMatch[0].start),X.labelMatch&&X.labelMatch.length){if(J=X.labelMatch[X.labelMatch.length-1].end,X.descriptionMatch&&X.descriptionMatch.length){const Y=ue.getItemDescription(B);Y&&(J+=Y.length)}}else X.descriptionMatch&&X.descriptionMatch.length&&(J=X.descriptionMatch[X.descriptionMatch.length-1].end);return J-Z}function A(B,X){if(!B&&!X||(!B||!B.length)&&(!X||!X.length))return 0;if(!X||!X.length)return-1;if(!B||!B.length)return 1;const ue=B[0].start,J=B[B.length-1].end-ue,Y=X[0].start,_=X[X.length-1].end-Y;return J===_?0:_<J?1:-1}function T(B,X,ue,Z){const J=Z.getItemLabel(B)||"",Y=Z.getItemLabel(X)||"",he=Z.getItemDescription(B),_=Z.getItemDescription(X),we=J.length+(he?he.length:0),oe=Y.length+(_?_.length:0);if(we!==oe)return we-oe;const K=Z.getItemPath(B),W=Z.getItemPath(X);return K&&W&&K.length!==W.length?K.length-W.length:J!==Y?(0,D.$Sq)(J,Y,ue.normalized):he&&_&&he!==_?(0,D.$Sq)(he,_,ue.normalized):K&&W&&K!==W?(0,D.$Sq)(K,W,ue.normalized):0}function U(B){return B.startsWith('"')&&B.endsWith('"')}const N=" ";function j(B){typeof B!="string"&&(B="");const X=B.toLowerCase(),{pathNormalized:ue,normalized:Z,normalizedLowercase:J}=F(B),Y=ue.indexOf(I.sep)>=0,he=U(B);let _;const we=B.split(N);if(we.length>1)for(const oe of we){const K=U(oe),{pathNormalized:W,normalized:re,normalizedLowercase:ye}=F(oe);re&&(_||(_=[]),_.push({original:oe,originalLowercase:oe.toLowerCase(),pathNormalized:W,normalized:re,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:B,originalLowercase:X,pathNormalized:ue,normalized:Z,normalizedLowercase:J,values:_,containsPathSeparator:Y,expectContiguousMatch:he}}e.$Yq=j;function F(B){let X;L.$i?X=B.replace(/\//g,I.sep):X=B.replace(/\\/g,I.sep);const ue=(0,b.$Ve)(X).replace(/\s|"/g,"");return{pathNormalized:X,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function M(B){return Array.isArray(B)?j(B.map(X=>X.original).join(N)):j(B.original)}e.$Zq=M}),define(ke[100],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0,e.$es=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(R){const C=(0,D.$oc)(R),m=O[C.toLowerCase()];return m!==void 0?m:L(R)}e.$fs=I;function L(R){const C=(0,D.$oc)(R);return g[C.toLowerCase()]}e.$gs=L;function b(R){for(const C in g)if(g[C]===R)return C}e.$hs=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(R,C){const m=$.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:R}e.$is=y}),define(ke[101],Se([1,0,10]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.TerminateResponseCode=e.Source=void 0;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(b,...$){const y=$.reduce((m,v)=>(m[v]=!0,m),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let v=0;v<R.length;v++)if(m.search(R[v])!==-1){delete b[m];break}})}e.$Ql=I;function L(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Rl=L}),define(ke[2],Se([1,0,16,10]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,L=/^\/\//;function b(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!g.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(l,a){return!l&&!a?"file":l}function y(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const R="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(a){return a instanceof v?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,d,k,P,p,w=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=$(a,w),this.authority=d||R,this.path=y(this.scheme,k||R),this.query=P||R,this.fragment=p||R,b(this,w))}get fsPath(){return n(this,!1)}with(a){if(!a)return this;let{scheme:d,authority:k,path:P,query:p,fragment:w}=a;return d===void 0?d=this.scheme:d===null&&(d=R),k===void 0?k=this.authority:k===null&&(k=R),P===void 0?P=this.path:P===null&&(P=R),p===void 0?p=this.query:p===null&&(p=R),w===void 0?w=this.fragment:w===null&&(w=R),d===this.scheme&&k===this.authority&&P===this.path&&p===this.query&&w===this.fragment?this:new f(d,k,P,p,w)}static parse(a,d=!1){const k=m.exec(a);return k?new f(k[2]||R,s(k[4]||R),s(k[5]||R),s(k[7]||R),s(k[9]||R),d):new f(R,R,R,R,R)}static file(a){let d=R;if(O.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const k=a.indexOf(C,2);k===-1?(d=a.substring(2),a=C):(d=a.substring(2,k),a=a.substring(k)||C)}return new f("file",d,a,R,R)}static from(a,d){return new f(a.scheme,a.authority,a.path,a.query,a.fragment,d)}static joinPath(a,...d){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.$i&&a.scheme==="file"?k=v.file(D.$fc.join(n(a,!0),...d)).path:k=D.$gc.join(a.path,...d),a.with({path:k})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof v)return a;{const d=new f(a);return d._formatted=a.external??null,d._fsPath=a._sep===h?a.fsPath??null:null,d}}else return a}}e.URI=v;function S(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}e.$vc=S;const h=O.$i?1:void 0;class f extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=h),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(l,a,d){let k,P=-1;for(let p=0;p<l.length;p++){const w=l.charCodeAt(p);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||a&&w===47||d&&w===91||d&&w===93||d&&w===58)P!==-1&&(k+=encodeURIComponent(l.substring(P,p)),P=-1),k!==void 0&&(k+=l.charAt(p));else{k===void 0&&(k=l.substr(0,p));const E=o[w];E!==void 0?(P!==-1&&(k+=encodeURIComponent(l.substring(P,p)),P=-1),k+=E):P===-1&&(P=p)}}return P!==-1&&(k+=encodeURIComponent(l.substring(P))),k!==void 0?k:l}function r(l){let a;for(let d=0;d<l.length;d++){const k=l.charCodeAt(d);k===35||k===63?(a===void 0&&(a=l.substr(0,d)),a+=o[k]):a!==void 0&&(a+=l[d])}return a!==void 0?a:l}function n(l,a){let d;return l.authority&&l.path.length>1&&l.scheme==="file"?d=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?d=l.path.substr(1):d=l.path[1].toLowerCase()+l.path.substr(2):d=l.path,O.$i&&(d=d.replace(/\//g,"\\")),d}e.$wc=n;function c(l,a){const d=a?r:i;let k="",{scheme:P,authority:p,path:w,query:E,fragment:A}=l;if(P&&(k+=P,k+=":"),(p||P==="file")&&(k+=C,k+=C),p){let T=p.indexOf("@");if(T!==-1){const U=p.substr(0,T);p=p.substr(T+1),T=U.lastIndexOf(":"),T===-1?k+=d(U,!1,!1):(k+=d(U.substr(0,T),!1,!1),k+=":",k+=d(U.substr(T+1),!1,!0)),k+="@"}p=p.toLowerCase(),T=p.lastIndexOf(":"),T===-1?k+=d(p,!1,!0):(k+=d(p.substr(0,T),!1,!0),k+=p.substr(T))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const T=w.charCodeAt(1);T>=65&&T<=90&&(w=`/${String.fromCharCode(T+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const T=w.charCodeAt(0);T>=65&&T<=90&&(w=`${String.fromCharCode(T+32)}:${w.substr(2)}`)}k+=d(w,!0,!1)}return E&&(k+="?",k+=d(E,!1,!1)),A&&(k+="#",k+=a?A:i(A,!1,!1)),k}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(l){return l.match(u)?l.replace(u,a=>t(a)):l}}),define(ke[185],Se([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$nq=e.$mq=e.$lq=void 0;function O(y){const R=y;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$lq=O;function g(y){const R=[];let C;try{const m=JSON.parse(y.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),C=v.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",y.arguments)}return{args:R,stack:C}}e.$mq=g;function I(y){if(typeof y!="string")return I(g(y).stack);const R=y;if(R){const C=L(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$nq=I;function L(y){if(!y)return y;const R=y.indexOf(`
`);return R===-1?y:y.substring(0,R)}function b(y,R){const{args:C,stack:m}=g(y),v=typeof C[0]=="string"&&C.length===1;let S=L(m);S&&(S=`(${S.trim()})`);let h=[];if(typeof C[0]=="string"?S&&v?h=[`%c[${R}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:h=[`%c[${R}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:h=[`%c[${R}]%`,$("blue"),...C],S&&!v&&h.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,h)}e.log=b;function $(y){return`color: ${y}`}}),define(ke[55],Se([1,0,22,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function g($){return JSON.stringify($,L)}e.$zh=g;function I($){let y=JSON.parse($);return y=b(y),y}e.$Ah=I;function L($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return O.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ie||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=b($[R],y+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=b($[R],y+1))}return $}e.$Bh=b}),define(ke[17],Se([1,0,14,10,12,2]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={}));function b(m,v){return I.URI.isUri(m)?(0,g.$$e)(m.scheme,v):(0,g.$_e)(m,v+":")}e.$dg=b;function $(m,...v){return v.some(S=>b(m,S))}e.$eg=$,e.$fg="vscode-tkn",e.$gg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${L.vscodeRemoteResource}`}set(v,S,h){this.a[v]=S,this.b[v]=h}setConnectionToken(v,S){this.c[v]=S}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(r){return D.$1(r),v}const S=v.authority;let h=this.a[S];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const f=this.b[S],o=this.c[S];let i=`path=${encodeURIComponent(v.path)}`;return typeof o=="string"&&(i+=`&${e.$gg}=${encodeURIComponent(o)}`),I.URI.from({scheme:O.$o?this.d:L.vscodeRemoteResource,authority:`${h}:${f}`,path:this.f,query:i})}}e.$hg=new y,e.$ig="vs/../../extensions",e.$jg="vs/../../node_modules",e.$kg="vs/../../node_modules.asar",e.$lg="vs/../../node_modules.asar.unpacked",e.$mg="vscode-app";class R{static{this.a=e.$mg}asBrowserUri(v){const S=this.b(v,me);return this.uriToBrowserUri(S)}uriToBrowserUri(v){return v.scheme===L.vscodeRemote?e.$hg.rewrite(v):v.scheme===L.file&&(O.$m||O.$q===`${L.vscodeFileResource}://${R.a}`)?v.with({scheme:L.vscodeFileResource,authority:v.authority||R.a,query:null,fragment:null}):v}asFileUri(v){const S=this.b(v,me);return this.uriToFileUri(S)}uriToFileUri(v){return v.scheme===L.vscodeFileResource?v.with({scheme:L.file,authority:v.authority!==R.a?v.authority:null,query:null,fragment:null}):v}b(v,S){return I.URI.isUri(v)?v:I.URI.parse(S.toUrl(v))}}e.$ng=new R;var C;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const S="vscode-coi";function h(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:I.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const r=i?.get(S);if(r)return v.get(r)}m.getHeadersFromQuery=h;function f(o,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";o instanceof URLSearchParams?o.set(S,n):o[S]=n}m.addSearchParam=f})(C||(e.COI=C={}))}),define(ke[186],Se([1,0,157,17,10,2]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=void 0;class L{constructor(m,v,S){this.id=m,this.dependencies=v,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,v,S)=>{typeof m!="string"&&(S=v,v=m,m=null),(typeof v!="object"||!Array.isArray(v))&&(S=v,v=null),this.c.push(new L(m,v,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const v=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!v)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h(m){return new Promise((v,S)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const f=()=>{h.removeEventListener("load",o),h.removeEventListener("error",i)},o=r=>{f(),v(this.c.pop())},i=r=>{f(),S(r)};h.addEventListener("load",o),h.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),h.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(m){return new Promise((v,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),v(this.c.pop())}catch(h){S(h)}})}async j(m){try{const v=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(m).fsPath,o=v.readFileSync(f).toString(),i=h.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function R(C,m,v){if(D.$T){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const S=`${C}/${m}`;if($.has(S))return $.get(S);let h;if(/^\w[\w\d+.-]*:\/\//.test(S))h=S;else{const r=`${v&&!g.$o?O.$kg:O.$jg}/${S}`;h=O.$ng.asBrowserUri(r).toString(!0)}const f=b.INSTANCE.load(h);return $.set(S,f),f}else return await new Promise((S,h)=>{me([C],S,h)})}e.$eD=R}),define(ke[23],Se([1,0,33,17,16,10,12,2]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.DataUri=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=void 0;function $(v){return(0,b.$wc)(v,!0)}e.$ug=$;class y{constructor(S){this.a=S}compare(S,h,f=!1){return S===h?0:(0,L.$4e)(this.getComparisonKey(S,f),this.getComparisonKey(h,f))}isEqual(S,h,f=!1){return S===h?!0:!S||!h?!1:this.getComparisonKey(S,f)===this.getComparisonKey(h,f)}getComparisonKey(S,h=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,h,f=!1){if(S.scheme===h.scheme){if(S.scheme===O.Schemas.file)return D.$7f($(S),$(h),this.a(S))&&S.query===h.query&&(f||S.fragment===h.fragment);if((0,e.$Lg)(S.authority,h.authority))return D.$7f(S.path,h.path,this.a(S),"/")&&S.query===h.query&&(f||S.fragment===h.fragment)}return!1}joinPath(S,...h){return b.URI.joinPath(S,...h)}basenameOrAuthority(S){return(0,e.$Dg)(S)||S.authority}basename(S){return g.$gc.basename(S.path)}extname(S){return g.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let h;return S.scheme===O.Schemas.file?h=b.URI.file(g.$mc($(S))).path:(h=g.$gc.dirname(S.path),S.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),h="/")),S.with({path:h})}normalizePath(S){if(!S.path.length)return S;let h;return S.scheme===O.Schemas.file?h=b.URI.file(g.$hc($(S))).path:h=g.$gc.normalize(S.path),S.with({path:h})}relativePath(S,h){if(S.scheme!==h.scheme||!(0,e.$Lg)(S.authority,h.authority))return;if(S.scheme===O.Schemas.file){const i=g.$lc($(S),$(h));return I.$i?D.$1f(i):i}let f=S.path||"/";const o=h.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(f.length,o.length);i<r&&!(f.charCodeAt(i)!==o.charCodeAt(i)&&f.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);f=o.substr(0,i)+f.substr(i)}return g.$gc.relative(f,o)}resolvePath(S,h){if(S.scheme===O.Schemas.file){const f=b.URI.file(g.$kc($(S),h));return S.with({authority:f.authority,path:f.path})}return h=D.$2f(h),S.with({path:g.$gc.resolve(S.path,h)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,h){return S===h||S!==void 0&&h!==void 0&&(0,L.$$e)(S,h)}hasTrailingPathSeparator(S,h=g.sep){if(S.scheme===O.Schemas.file){const f=$(S);return f.length>D.$3f(f).length&&f[f.length-1]===h}else{const f=S.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,h=g.sep){return(0,e.$Mg)(S,h)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,h=g.sep){let f=!1;if(S.scheme===O.Schemas.file){const o=$(S);f=o!==void 0&&o.length===D.$3f(o).length&&o[o.length-1]===h}else{h="/";const o=S.path;f=o.length===1&&o.charCodeAt(o.length-1)===47}return!f&&!(0,e.$Mg)(S,h)?S.with({path:S.path+"/"}):S}}e.$vg=y,e.$wg=new y(()=>!1),e.$xg=new y(v=>v.scheme===O.Schemas.file?!I.$k:!0),e.$yg=new y(v=>!0),e.$zg=e.$wg.isEqual.bind(e.$wg),e.$Ag=e.$wg.isEqualOrParent.bind(e.$wg),e.$Bg=e.$wg.getComparisonKey.bind(e.$wg),e.$Cg=e.$wg.basenameOrAuthority.bind(e.$wg),e.$Dg=e.$wg.basename.bind(e.$wg),e.$Eg=e.$wg.extname.bind(e.$wg),e.$Fg=e.$wg.dirname.bind(e.$wg),e.$Gg=e.$wg.joinPath.bind(e.$wg),e.$Hg=e.$wg.normalizePath.bind(e.$wg),e.$Ig=e.$wg.relativePath.bind(e.$wg),e.$Jg=e.$wg.resolvePath.bind(e.$wg),e.$Kg=e.$wg.isAbsolutePath.bind(e.$wg),e.$Lg=e.$wg.isEqualAuthority.bind(e.$wg),e.$Mg=e.$wg.hasTrailingPathSeparator.bind(e.$wg),e.$Ng=e.$wg.removeTrailingPathSeparator.bind(e.$wg),e.$Og=e.$wg.addTrailingPathSeparator.bind(e.$wg);function R(v,S){const h=[];for(let f=0;f<v.length;f++){const o=S(v[f]);v.some((i,r)=>r===f?!1:(0,e.$Ag)(o,S(i)))||h.push(v[f])}return h}e.$Pg=R;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function S(h){const f=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,c]=r.split(":");n&&c&&f.set(n,c)});const i=h.path.substring(0,h.path.indexOf(";"));return i&&f.set(v.META_DATA_MIME,i),f}v.parseMetaData=S})(C||(e.DataUri=C={}));function m(v,S,h){if(S){let f=v.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),v.with({scheme:h,authority:S,path:f})}return v.with({scheme:h})}e.$Qg=m}),define(ke[11],Se([1,0,21,14,4,3,23,10,163,43]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.Promises=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=void 0;function R(x){return!!x&&typeof x.then=="function"}e.$Rg=R;function C(x){const te=new D.$5d,G=x(te.token),ie=new Promise((fe,ve)=>{const Pe=te.token.onCancellationRequested(()=>{Pe.dispose(),ve(new O.$5)});Promise.resolve(G).then(be=>{Pe.dispose(),te.dispose(),fe(be)},be=>{Pe.dispose(),te.dispose(),ve(be)})});return new class{cancel(){te.cancel(),te.dispose()}then(fe,ve){return ie.then(fe,ve)}catch(fe){return this.then(void 0,fe)}finally(fe){return ie.finally(fe)}}}e.$Sg=C;function m(x,te,G){return new Promise((ie,fe)=>{const ve=te.onCancellationRequested(()=>{ve.dispose(),ie(G)});x.then(ie,fe).finally(()=>ve.dispose())})}e.$Tg=m;function v(x,te){return new Promise((G,ie)=>{const fe=te.onCancellationRequested(()=>{fe.dispose(),ie(new O.$5)});x.then(G,ie).finally(()=>fe.dispose())})}e.$Ug=v;async function S(x){let te=-1;const G=x.map((ie,fe)=>ie.then(ve=>(te=fe,ve)));try{return await Promise.race(G)}finally{x.forEach((ie,fe)=>{fe!==te&&ie.cancel()})}}e.$Vg=S;function h(x,te,G){let ie;const fe=setTimeout(()=>{ie?.(void 0),G?.()},te);return Promise.race([x.finally(()=>clearTimeout(fe)),new Promise(ve=>ie=ve)])}e.$Wg=h;function f(x){return new Promise((te,G)=>{const ie=x();R(ie)?ie.then(te,G):te(ie)})}e.$Xg=f;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const G=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(G,G).then(ie)})}return new Promise((G,ie)=>{this.b.then(G,ie)})}return this.a=te(),new Promise((G,ie)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,ie(fe)})})}dispose(){this.f=!0}}e.$Yg=o;class i{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$Zg=i;class r{constructor(){this.a=new Map}queue(te,G){const fe=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(te)===fe&&this.a.delete(te)});return this.a.set(te,fe),fe}}e.$1g=r;const n=(x,te)=>{let G=!0;const ie=setTimeout(()=>{G=!1,te()},x);return{isTriggered:()=>G,dispose:()=>{clearTimeout(ie),G=!1}}},c=x=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,x())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,G=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((fe,ve)=>{this.d=fe,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Rd?c(ie):n(G,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$2g=t;class u{constructor(te){this.a=new t(te),this.b=new o}trigger(te,G){return this.a.trigger(()=>this.b.queue(te),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$3g=u;class s{constructor(){this.a=!1,this.b=new Promise((te,G)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$4g=s;class l extends s{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$5g=l;function a(x,te){return te?new Promise((G,ie)=>{const fe=setTimeout(()=>{ve.dispose(),G()},x),ve=te.onCancellationRequested(()=>{clearTimeout(fe),ve.dispose(),ie(new O.$5)})}):C(G=>a(x,G))}e.$6g=a;function d(x,te=0,G){const ie=setTimeout(()=>{x(),G&&fe.dispose()},te),fe=(0,I.$Rc)(()=>{clearTimeout(ie),G?.deleteAndLeak(fe)});return G?.add(fe),fe}e.$7g=d;function k(x){const te=[];let G=0;const ie=x.length;function fe(){return G<ie?x[G++]():null}function ve(Pe){Pe!=null&&te.push(Pe);const be=fe();return be?be.then(ve):Promise.resolve(te)}return Promise.resolve(null).then(ve)}e.$8g=k;function P(x,te=ie=>!!ie,G=null){let ie=0;const fe=x.length,ve=()=>{if(ie>=fe)return Promise.resolve(G);const Pe=x[ie++];return Promise.resolve(Pe()).then(De=>te(De)?Promise.resolve(De):ve())};return ve()}e.$9g=P;function p(x,te=ie=>!!ie,G=null){if(x.length===0)return Promise.resolve(G);let ie=x.length;const fe=()=>{ie=-1;for(const ve of x)ve.cancel?.()};return new Promise((ve,Pe)=>{for(const be of x)be.then(De=>{--ie>=0&&te(De)?(fe(),ve(De)):ie===0&&ve(G)}).catch(De=>{--ie>=0&&(fe(),Pe(De))})})}e.$0g=p;class w{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new g.$Ud}whenIdle(){return this.size>0?g.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,ie)=>{this.g.push({factory:te,c:G,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const G=te.factory();G.then(te.c,te.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$$g=w;class E extends w{constructor(){super(1)}}e.$_g=E;class A{constructor(){this.a=new J,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$ah=A;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new _;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,G=L.$wg){const ie=G.getComparisonKey(te);return this.a.get(ie)?.size??0}queueFor(te,G,ie=L.$wg){const fe=ie.getComparisonKey(te);let ve=this.a.get(fe);if(!ve){ve=new E;const Pe=this.f++,be=g.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(Pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$3c),this.d.set(Pe,be),this.a.set(fe,ve)}return ve.queue(G)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$bh=T;class U{constructor(te,G){this.a=-1,typeof te=="function"&&typeof G=="number"&&this.setIfNotSet(te,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},G)}setIfNotSet(te,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},G))}}e.$ch=U;class N{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,G,ie=globalThis){this.cancel();const fe=ie.setInterval(()=>{te()},G);this.d=(0,I.$Rc)(()=>{ie.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$dh=N;class j{constructor(te,G){this.b=-1,this.a=te,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$eh=j;class F{constructor(te,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=te,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$fh=F;class M extends j{constructor(te,G){super(te,G),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$gh=M;class B extends I.$Tc{constructor(te,G){super(),this.g=te,this.h=G,this.a=[],this.b=this.B(new I.$Uc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of te)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$hh=B,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$jh=(x,te)=>{(0,b.$B)(()=>{if(G)return;const ie=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$jh=(x,te,G)=>{const ie=x.requestIdleCallback(te,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,x.cancelIdleCallback(ie))}}},e.$ih=x=>(0,e.$jh)(globalThis,x)}();class X{constructor(te,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$jh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$kh=X;class ue extends X{constructor(te){super(globalThis,te)}}e.$lh=ue;async function Z(x,te,G){let ie;for(let fe=0;fe<G;fe++)try{return await x()}catch(ve){ie=ve,await a(te)}throw ie}e.$mh=Z;class J{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,G,ie){return this.a={taskId:te,cancel:()=>ie?.(),promise:G},G.then(()=>this.d(te),()=>this.d(te)),G}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let G,ie;const fe=new Promise((ve,Pe)=>{G=ve,ie=Pe});this.b={run:te,promise:fe,promiseResolve:G,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$nh=J;class Y{constructor(te,G=()=>Date.now()){this.d=te,this.f=G,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$oh=Y;var he;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(he||(he={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,G)=>{this.a=te,this.b=G})}complete(te){return new Promise(G=>{this.a(te),this.d={outcome:0,value:te},G()})}error(te){return new Promise(G=>{this.b(te),this.d={outcome:1,value:te},G()})}cancel(){return this.error(new O.$5)}}e.$ph=_;var we;(function(x){async function te(ie){let fe;const ve=await Promise.all(ie.map(Pe=>Pe.then(be=>be,be=>{fe||(fe=be)})));if(typeof fe<"u")throw fe;return ve}x.settled=te;function G(ie){return new Promise(async(fe,ve)=>{try{await ie(fe,ve)}catch(Pe){ve(Pe)}})}x.withAsyncBody=G})(we||(e.Promises=we={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$qh=oe;class K{constructor(te){this.b=te,this.a=new y.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$rh=K;var W;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(W||(W={}));class re{static fromArray(te){return new re(G=>{G.emitMany(te)})}static fromPromise(te){return new re(async G=>{G.emitMany(await te)})}static fromPromises(te){return new re(async G=>{await Promise.all(te.map(async ie=>G.emitOne(await ie)))})}static merge(te){return new re(async G=>{await Promise.all(te.map(async ie=>{for await(const fe of ie)G.emitOne(fe)}))})}static{this.EMPTY=re.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new g.$Ud,queueMicrotask(async()=>{const G={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(te(G)),this.j()}catch(ie){this.k(ie)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(te,G){return new re(async ie=>{for await(const fe of te)ie.emitOne(G(fe))})}map(te){return re.map(this,te)}static filter(te,G){return new re(async ie=>{for await(const fe of te)G(fe)&&ie.emitOne(fe)})}filter(te){return re.filter(this,te)}static coalesce(te){return re.filter(te,G=>!!G)}coalesce(){return re.coalesce(this)}static async toPromise(te){const G=[];for await(const ie of te)G.push(ie);return G}toPromise(){return re.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$sh=re;class ye extends re{constructor(te,G){super(G),this.l=te}cancel(){this.l.cancel()}}e.$th=ye;function de(x){const te=new D.$5d,G=x(te.token);return new ye(te,async ie=>{const fe=te.token.onCancellationRequested(()=>{fe.dispose(),te.dispose(),ie.reject(new O.$5)});try{for await(const ve of G){if(te.token.isCancellationRequested)return;ie.emitOne(ve)}fe.dispose(),te.dispose()}catch(ve){fe.dispose(),te.dispose(),ie.reject(ve)}})}e.$uh=de;class ge{constructor(){this.a=new _,this.b=new re(ie=>{if(te){ie.reject(te);return}return G&&ie.emitMany(G),this.d=fe=>ie.reject(fe),this.f=fe=>ie.emitOne(fe),this.a.p});let te,G;this.f=ie=>{G||(G=[]),G.push(ie)},this.d=ie=>{te||(te=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$vh=ge}),define(ke[34],Se([1,0,19,11,33,28,16,10,12]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=void 0;function y(){return Object.create(null)}e.$Gj=y,e.$Hj="**",e.$Ij="/";const R="[/\\\\]",C="[^/\\\\]",m=/\//g;function v(ue,Z){switch(ue){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${Z?`|${R}${C}+`:""})*?`}}function S(ue,Z){if(!ue)return[];const J=[];let Y=!1,he=!1,_="";for(const we of ue){switch(we){case Z:if(!Y&&!he){J.push(_),_="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":he=!0;break;case"]":he=!1;break}_+=we}return _&&J.push(_),J}e.$Jj=S;function h(ue){if(!ue)return"";let Z="";const J=S(ue,e.$Ij);if(J.every(Y=>Y===e.$Hj))Z=".*";else{let Y=!1;J.forEach((he,_)=>{if(he===e.$Hj){if(Y)return;Z+=v(2,_===J.length-1)}else{let we=!1,oe="",K=!1,W="";for(const re of he){if(re!=="}"&&we){oe+=re;continue}if(K&&(re!=="]"||!W)){let ye;re==="-"?ye=re:(re==="^"||re==="!")&&!W?ye="^":re===e.$Ij?ye="":ye=(0,$.$Ne)(re),W+=ye;continue}switch(re){case"{":we=!0;continue;case"[":K=!0;continue;case"}":{const de=`(?:${S(oe,",").map(ge=>h(ge)).join("|")})`;Z+=de,we=!1,oe="";break}case"]":{Z+="["+W+"]",K=!1,W="";break}case"?":Z+=C;continue;case"*":Z+=v(1);continue;default:Z+=(0,$.$Ne)(re)}}_<J.length-1&&(J[_+1]!==e.$Hj||_+2<J.length)&&(Z+=R)}Y=he===e.$Hj})}return Z}const f=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),u=function(){return!1},s=function(){return null};function l(ue,Z){if(!ue)return s;let J;typeof ue!="string"?J=ue.pattern:J=ue,J=J.trim();const Y=`${J}_${!!Z.trimForExclusions}`;let he=t.get(Y);if(he)return a(he,ue);let _;return f.test(J)?he=k(J.substr(4),J):(_=o.exec(d(J,Z)))?he=P(_[1],J):(Z.trimForExclusions?r:i).test(J)?he=p(J,Z):(_=n.exec(d(J,Z)))?he=w(_[1].substr(1),J,!0):(_=c.exec(d(J,Z)))?he=w(_[1],J,!1):he=E(J),t.set(Y,he),a(he,ue)}function a(ue,Z){if(typeof Z=="string")return ue;const J=function(Y,he){return(0,g.$7f)(Y,Z.base,!b.$k)?ue((0,$.$Se)(Y.substr(Z.base.length),L.sep),he):null};return J.allBasenames=ue.allBasenames,J.allPaths=ue.allPaths,J.basenames=ue.basenames,J.patterns=ue.patterns,J}function d(ue,Z){return Z.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function k(ue,Z){return function(J,Y){return typeof J=="string"&&J.endsWith(ue)?Z:null}}function P(ue,Z){const J=`/${ue}`,Y=`\\${ue}`,he=function(we,oe){return typeof we!="string"?null:oe?oe===ue?Z:null:we===ue||we.endsWith(J)||we.endsWith(Y)?Z:null},_=[ue];return he.basenames=_,he.patterns=[Z],he.allBasenames=_,he}function p(ue,Z){const J=B(ue.slice(1,-1).split(",").map(oe=>l(oe,Z)).filter(oe=>oe!==s),ue),Y=J.length;if(!Y)return s;if(Y===1)return J[0];const he=function(oe,K){for(let W=0,re=J.length;W<re;W++)if(J[W](oe,K))return ue;return null},_=J.find(oe=>!!oe.allBasenames);_&&(he.allBasenames=_.allBasenames);const we=J.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return we.length&&(he.allPaths=we),he}function w(ue,Z,J){const Y=L.sep===L.$gc.sep,he=Y?ue:ue.replace(m,L.sep),_=L.sep+he,we=L.$gc.sep+ue;let oe;return J?oe=function(K,W){return typeof K=="string"&&(K===he||K.endsWith(_)||!Y&&(K===ue||K.endsWith(we)))?Z:null}:oe=function(K,W){return typeof K=="string"&&(K===he||!Y&&K===ue)?Z:null},oe.allPaths=[(J?"*/":"./")+ue],oe}function E(ue){try{const Z=new RegExp(`^${h(ue)}$`);return function(J){return Z.lastIndex=0,typeof J=="string"&&Z.test(J)?ue:null}}catch{return s}}function A(ue,Z,J){return!ue||typeof Z!="string"?!1:T(ue)(Z,void 0,J)}e.$Kj=A;function T(ue,Z={}){if(!ue)return u;if(typeof ue=="string"||U(ue)){const J=l(ue,Z);if(J===s)return u;const Y=function(he,_){return!!J(he,_)};return J.allBasenames&&(Y.allBasenames=J.allBasenames),J.allPaths&&(Y.allPaths=J.allPaths),Y}return F(ue,Z)}e.$Lj=T;function U(ue){const Z=ue;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$Mj=U;function N(ue){return ue.allBasenames||[]}e.$Nj=N;function j(ue){return ue.allPaths||[]}e.$Oj=j;function F(ue,Z){const J=B(Object.getOwnPropertyNames(ue).map(oe=>M(oe,ue[oe],Z)).filter(oe=>oe!==s)),Y=J.length;if(!Y)return s;if(!J.some(oe=>!!oe.requiresSiblings)){if(Y===1)return J[0];const oe=function(re,ye){let de;for(let ge=0,x=J.length;ge<x;ge++){const te=J[ge](re,ye);if(typeof te=="string")return te;(0,O.$Rg)(te)&&(de||(de=[]),de.push(te))}return de?(async()=>{for(const ge of de){const x=await ge;if(typeof x=="string")return x}return null})():null},K=J.find(re=>!!re.allBasenames);K&&(oe.allBasenames=K.allBasenames);const W=J.reduce((re,ye)=>ye.allPaths?re.concat(ye.allPaths):re,[]);return W.length&&(oe.allPaths=W),oe}const he=function(oe,K,W){let re,ye;for(let de=0,ge=J.length;de<ge;de++){const x=J[de];x.requiresSiblings&&W&&(K||(K=(0,L.$nc)(oe)),re||(re=K.substr(0,K.length-(0,L.$oc)(oe).length)));const te=x(oe,K,re,W);if(typeof te=="string")return te;(0,O.$Rg)(te)&&(ye||(ye=[]),ye.push(te))}return ye?(async()=>{for(const de of ye){const ge=await de;if(typeof ge=="string")return ge}return null})():null},_=J.find(oe=>!!oe.allBasenames);_&&(he.allBasenames=_.allBasenames);const we=J.reduce((oe,K)=>K.allPaths?oe.concat(K.allPaths):oe,[]);return we.length&&(he.allPaths=we),he}function M(ue,Z,J){if(Z===!1)return s;const Y=l(ue,J);if(Y===s)return s;if(typeof Z=="boolean")return Y;if(Z){const he=Z.when;if(typeof he=="string"){const _=(we,oe,K,W)=>{if(!W||!Y(we,oe))return null;const re=he.replace("$(basename)",()=>K),ye=W(re);return(0,O.$Rg)(ye)?ye.then(de=>de?ue:null):ye?ue:null};return _.requiresSiblings=!0,_}}return Y}function B(ue,Z){const J=ue.filter(oe=>!!oe.basenames);if(J.length<2)return ue;const Y=J.reduce((oe,K)=>{const W=K.basenames;return W?oe.concat(W):oe},[]);let he;if(Z){he=[];for(let oe=0,K=Y.length;oe<K;oe++)he.push(Z)}else he=J.reduce((oe,K)=>{const W=K.patterns;return W?oe.concat(W):oe},[]);const _=function(oe,K){if(typeof oe!="string")return null;if(!K){let re;for(re=oe.length;re>0;re--){const ye=oe.charCodeAt(re-1);if(ye===47||ye===92)break}K=oe.substr(re)}const W=Y.indexOf(K);return W!==-1?he[W]:null};_.basenames=Y,_.patterns=he,_.allBasenames=Y;const we=ue.filter(oe=>!oe.basenames);return we.push(_),we}function X(ue,Z){return(0,D.$ub)(ue,Z,(J,Y)=>typeof J=="string"&&typeof Y=="string"?J===Y:typeof J!="string"&&typeof Y!="string"?J.base===Y.base&&J.pattern===Y.pattern:!1)}e.$Pj=X}),define(ke[80],Se([1,0,14,164,23,12,2]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=m(this.supportThemeIcons?(0,O.$ak)(i):i).replace(/([ \t]+)/g,(n,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${v(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,I.$Ne)(r),"g");return i.replace(n,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$gk=$;function y(o){return R(o)?!o.value:Array.isArray(o)?o.every(y):!0}e.$hk=y;function R(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$ik=R;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,g.$zg)(L.URI.from(o.baseUri),L.URI.from(i.baseUri)))}e.$jk=C;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$kk=m;function v(o,i){const r=o.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,o,`${"`".repeat(n)}`].join(`
`)}e.$lk=v;function S(o){return o.replace(/"/g,"&quot;")}e.$mk=S;function h(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$nk=h;function f(o){const i=[],r=o.split("|").map(c=>c.trim());o=r[0];const n=r[1];if(n){const c=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),u=c?c[1]:"",s=t?t[1]:"",l=isFinite(parseInt(s)),a=isFinite(parseInt(u));l&&i.push(`width="${s}"`),a&&i.push(`height="${u}"`)}return{href:o,dimensions:i}}e.$ok=f}),define(ke[102],Se([1,0,19,33,16,10,23,12]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=void 0;function $(l,a){const{os:d,tildify:k,relative:P}=a;if(P){const E=y(l,P,d);if(typeof E=="string")return E}let p=l.fsPath;if(d===1&&!I.$i?p=p.replace(/\//g,"\\"):d!==1&&I.$i&&(p=p.replace(/\\/g,"/")),d!==1&&k?.userHome){const E=k.userHome.fsPath;let A;l.scheme!==k.userHome.scheme&&l.path[0]===g.$gc.sep&&l.path[1]!==g.$gc.sep?A=k.userHome.with({path:l.path}).fsPath:A=p,p=m(A,E,d)}return(d===1?g.$fc:g.$gc).normalize(R(p,d===1))}e.$Uv=$;function y(l,a,d){const k=d===1?g.$fc:g.$gc,P=d===3?L.$wg:L.$yg,p=a.getWorkspace(),w=(0,D.$Ob)(p.folders);if(!w)return;l.scheme!==w.uri.scheme&&l.path[0]===g.$gc.sep&&l.path[1]!==g.$gc.sep&&(l=w.uri.with({path:l.path}));const E=a.getWorkspaceFolder(l);if(!E)return;let A;if(P.isEqual(E.uri,l)?A="":A=P.relativePath(E.uri,l)??"",A&&(A=k.normalize(A)),p.folders.length>1&&!a.noPrefix){const T=E.name?E.name:P.basenameOrAuthority(E.uri);A=A?`${T} \u2022 ${A}`:T}return A}function R(l,a=I.$i){return(0,O.$$f)(l,a)?l.charAt(0).toUpperCase()+l.slice(1):l}e.$Vv=R;let C=Object.create(null);function m(l,a,d=I.OS){if(d===1||!l||!a)return l;let k=C.original===a?C.normalized:void 0;k||(k=a,I.$i&&(k=(0,O.$1f)(k)),k=`${(0,b.$Te)(k,g.$gc.sep)}${g.$gc.sep}`,C={original:a,normalized:k});let P=l;return I.$i&&(P=(0,O.$1f)(P)),(d===3?P.startsWith(k):(0,b.$_e)(P,k))?`~/${P.substr(k.length)}`:l}e.$Wv=m;function v(l,a){return l.replace(/^~($|\/|\\)/,`${a}$1`)}e.$Xv=v;const S="\u2026",h="\\\\",f="~";function o(l,a=g.sep){const d=new Array(l.length);let k=!1;for(let P=0;P<l.length;P++){const p=l[P];if(p===""){d[P]=`.${a}`;continue}if(!p){d[P]=p;continue}k=!0;let w="",E=p;E.indexOf(h)===0?(w=E.substr(0,E.indexOf(h)+h.length),E=E.substr(E.indexOf(h)+h.length)):E.indexOf(a)===0?(w=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(f)===0&&(w=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length));const A=E.split(a);for(let T=1;k&&T<=A.length;T++)for(let U=A.length-T;k&&U>=0;U--){k=!1;let N=A.slice(U,U+T).join(a);for(let j=0;!k&&j<l.length;j++)if(j!==P&&l[j]&&l[j].indexOf(N)>-1){const F=U+T===A.length,M=U>0&&l[j].indexOf(a)>-1?a+N:N,B=l[j].endsWith(M);k=!F||B}if(!k){let j="";(A[0].endsWith(":")||w!=="")&&(U===1&&(U=0,T++,N=A[0]+a+N),U>0&&(j=A[0]+a),j=w+j),U>0&&(j=j+S+a),j=j+N,U+T<A.length&&(j=j+a+S),d[P]=j}}k&&(d[P]=p)}return d}e.$Yv=o;var i;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(l,a=Object.create(null)){const d=[];let k=!1,P="";for(const p of l)if(p==="$"||k&&p==="{")P&&d.push({value:P,type:i.TEXT}),P="",k=!0;else if(p==="}"&&k){const w=a[P];if(typeof w=="string")w.length&&d.push({value:w,type:i.VARIABLE});else if(w){const E=d[d.length-1];(!E||E.type!==i.SEPARATOR)&&d.push({value:w.label,type:i.SEPARATOR})}P="",k=!1}else P+=p;return P&&!k&&d.push({value:P,type:i.TEXT}),d.filter((p,w)=>{if(p.type===i.SEPARATOR){const E=d[w-1],A=d[w+1];return[E,A].every(T=>T&&(T.type===i.VARIABLE||T.type===i.TEXT)&&T.value.length>0)}return!0}).map(p=>p.value).join("")}e.$Zv=r;function n(l,a){return I.$j||a?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):l.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$1v=n;function c(l,a){return I.$j||a?l.replace(/\(&&\w\)|&&/g,""):I.$i?l.replace(/&&|&/g,d=>d==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.$2v=c;function t(l){return l.replace(/&/g,"&&")}e.$3v=t;function u(l){if(l.endsWith("]")){const a=l.lastIndexOf(" [",l.length-2);if(a!==-1){const d=s(l.substring(0,a)),k=l.substring(a);return{name:d.name+k,parentPath:d.parentPath}}}return s(l)}e.$4v=u;function s(l){const a=l.indexOf("/")!==-1?g.$gc:g.$fc,d=a.basename(l),k=a.dirname(l);return d.length?{name:d,parentPath:k}:{name:k,parentPath:""}}}),define(ke[130],Se([1,0,22,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const v=this.a.transformIncoming(m);return v===m?m:g(O.URI.from(v))}transformOutgoing(m){const v=this.a.transformOutgoing(m);return v===m?m:g(O.URI.from(v))}transformOutgoingURI(m){const v=this.a.transformOutgoing(m);return v===m?m:O.URI.from(v)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$3m=I,e.$4m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function L(C,m,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof O.URI)return m.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const h=L(C[S],m,v+1);h!==null&&(C[S]=h)}}return null}function b(C,m){const v=L(C,m,0);return v===null?C:v}e.$5m=b;function $(C,m,v,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?O.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$ie)return null;for(const h in C)if(Object.hasOwnProperty.call(C,h)){const f=$(C[h],m,v,S+1);f!==null&&(C[h]=f)}}return null}function y(C,m){const v=$(C,m,!1,0);return v===null?C:v}e.$6m=y;function R(C,m){const v=$(C,m,!0,0);return v===null?C:v}e.$7m=R}),define(ke[31],Se([1,0,56,63,384,11,33,76,16,10,23,2]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function v(M,B=m.UNLINK,X){if((0,L.$0f)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===m.UNLINK?h(M):S(M,X)}async function S(M,B=(0,L.$cg)((0,O.tmpdir)())){try{try{await D.promises.rename(M,B)}catch(X){return X.code==="ENOENT"?void 0:h(M)}h(B).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function h(M){return(0,g.promisify)(D.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function f(M){if((0,L.$0f)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function o(M,B){return n(await(B?i(M):(0,g.promisify)(D.readdir)(M)))}async function i(M){try{return await(0,g.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const B=[],X=await o(M);for(const ue of X){let Z=!1,J=!1,Y=!1;try{const he=await e.Promises.lstat((0,$.$jc)(M,ue));Z=he.isFile(),J=he.isDirectory(),Y=he.isSymbolicLink()}catch(he){console.warn("[node.js fs] unexpected error from lstat after readdir: ",he)}B.push({name:ue,isFile:()=>Z,isDirectory:()=>J,isSymbolicLink:()=>Y})}return B}function r(M){return n(D.readdirSync(M))}e.readdirSync=r;function n(M){return M.map(B=>typeof B=="string"?y.$j?(0,b.$Fl)(B):B:(B.name=y.$j?(0,b.$Fl)(B.name):B.name,B))}async function c(M){const B=await o(M),X=[];for(const ue of B)await u.existsDirectory((0,$.$jc)(M,ue))&&X.push(ue);return X}function t(M,B=1e3){return new Promise(X=>{let ue=!1;const Z=setInterval(()=>{ue||(ue=!0,D.access(M,J=>{ue=!1,J&&(clearInterval(Z),X(void 0))}))},B)})}e.whenDeleted=t;var u;(function(M){async function B(Z){let J;try{if(J=await e.Promises.lstat(Z),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(y.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(he){if(he.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw he}throw Y}}M.stat=B;async function X(Z){try{const{stat:J,symbolicLink:Y}=await M.stat(Z);return J.isFile()&&Y?.dangling!==!0}catch{}return!1}M.existsFile=X;async function ue(Z){try{const{stat:J,symbolicLink:Y}=await M.stat(Z);return J.isDirectory()&&Y?.dangling!==!0}catch{}return!1}M.existsDirectory=ue})(u||(e.SymlinkSupport=u={}));const s=new I.$bh;function l(M,B,X){return s.queueFor(C.URI.file(M),()=>{const ue=p(X);return new Promise((Z,J)=>k(M,B,ue,Y=>Y?J(Y):Z()))},R.$xg)}let a=!0;function d(M){a=M}e.configureFlushOnWrite=d;function k(M,B,X,ue){if(!a)return D.writeFile(M,B,{mode:X.mode,flag:X.flag},ue);D.open(M,X.flag,X.mode,(Z,J)=>{if(Z)return ue(Z);D.writeFile(J,B,Y=>{if(Y)return D.close(J,()=>ue(Y));D.fdatasync(J,he=>(he&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",he),d(!1)),D.close(J,_=>ue(_))))})})}function P(M,B,X){const ue=p(X);if(!a)return D.writeFileSync(M,B,{mode:ue.mode,flag:ue.flag});const Z=D.openSync(M,ue.flag,ue.mode);try{D.writeFileSync(Z,B);try{D.fdatasyncSync(Z)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),d(!1)}}finally{D.closeSync(Z)}}e.writeFileSync=P;function p(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function w(M,B,X=6e4){if(M!==B)try{y.$i&&typeof X=="number"?await E(M,B,Date.now(),X):await(0,g.promisify)(D.rename)(M,B)}catch(ue){if(M.toLowerCase()!==B.toLowerCase()&&ue.code==="EXDEV"||M.endsWith("."))await A(M,B,{preserveSymlinks:!1}),await v(M,m.MOVE);else throw ue}}async function E(M,B,X,ue,Z=0){try{return await(0,g.promisify)(D.rename)(M,B)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-X>=ue)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${J}`),J;if(Z===0){let Y=!1;try{const{stat:he}=await u.stat(B);he.isFile()||(Y=!0)}catch{}if(Y)throw J}return await(0,I.$6g)(Math.min(100,Z*10)),E(M,B,X,ue,Z+1)}}async function A(M,B,X){return U(M,B,{root:{source:M,target:B},options:X,handledSourcePaths:new Set})}const T=511;async function U(M,B,X){if(X.handledSourcePaths.has(M))return;X.handledSourcePaths.add(M);const{stat:ue,symbolicLink:Z}=await u.stat(M);if(Z){if(X.options.preserveSymlinks)try{return await F(M,B,X)}catch{}if(Z.dangling)return}return ue.isDirectory()?N(M,B,ue.mode&T,X):j(M,B,ue.mode&T)}async function N(M,B,X,ue){await e.Promises.mkdir(B,{recursive:!0,mode:X});const Z=await o(M);for(const J of Z)await U((0,$.$jc)(M,J),(0,$.$jc)(B,J),ue)}async function j(M,B,X){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,X)}async function F(M,B,X){let ue=await e.Promises.readlink(M);(0,L.$7f)(ue,X.root.source,!y.$k)&&(ue=(0,$.$jc)(X.root.target,ue.substr(X.root.source.length+1))),await e.Promises.symlink(ue,B)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(M,B,X,ue,Z)=>new Promise((J,Y)=>{D.read(M,B,X,ue,Z,(he,_,we)=>he?Y(he):J({bytesRead:_,buffer:we}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(M,B,X,ue,Z)=>new Promise((J,Y)=>{D.write(M,B,X,ue,Z,(he,_,we)=>he?Y(he):J({bytesWritten:_,buffer:we}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return c}get writeFile(){return l}get rm(){return v}get rename(){return w}get copy(){return A}}}),define(ke[103],Se([1,0,56,16,10,12,31]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=e.$sq=void 0;function b(m){if(g.$k)return m;const v=(0,O.$mc)(m);if(m===v)return m;const S=((0,O.$nc)(m)||m).toLowerCase();try{const f=(0,L.readdirSync)(v).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=b(v);if(o)return(0,O.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=b(v);if(i)return(0,O.$jc)(i,f[o])}}}catch{}return null}e.$sq=b;async function $(m){if(g.$k)return m;const v=(0,O.$mc)(m);if(m===v)return m;const S=((0,O.$nc)(m)||m).toLowerCase();try{const f=(await L.Promises.readdir(v)).filter(o=>o.toLowerCase()===S);if(f.length===1){const o=await $(v);if(o)return(0,O.$jc)(o,f[0])}else if(f.length>1){const o=f.indexOf(S);if(o>=0){const i=await $(v);if(i)return(0,O.$jc)(i,f[o])}}}catch{}return null}e.$tq=$;async function y(m){try{return await L.Promises.realpath(m)}catch{const S=C(m);return await L.Promises.access(S,D.constants.R_OK),S}}e.$uq=y;function R(m){try{return D.realpathSync(m)}catch{const S=C(m);return D.accessSync(S,D.constants.R_OK),S}}e.$vq=R;function C(m){return(0,I.$Te)((0,O.$hc)(m),O.sep)}}),define(ke[104],Se([1,0,16,10,50,101,18,31]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Tl=e.$Sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Sl=$;function y(C){let m=[],v=!1;const S=function(h){if(v){m.push(h);return}(!C.send(h,o=>{if(o&&console.error(o),v=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(r=>S(r))}})||O.$i)&&(v=!0)};return{send:S}}e.$Tl=y;var R;(function(C){async function m(v,S,h){if(D.$ic(v))return v;if(S===void 0&&(S=g.cwd()),D.$mc(v)!=="."||(h===void 0&&L.$Hf(g.env.PATH)&&(h=g.env.PATH.split(D.$tc)),h===void 0||h.length===0))return D.$jc(S,v);async function o(i){if(await b.Promises.exists(i)){let r;try{r=await b.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await b.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of h){let r;if(D.$ic(i)?r=D.$jc(i,v):r=D.$jc(S,i,v),await o(r))return r;let n=r+".com";if(await o(n)||(n=r+".exe",await o(n)))return n}return D.$jc(S,v)}C.findExecutable=m})(R||(e.win32=R={}))});var Ge=this&&this.__decorate||function(me,e,D,O){var g=arguments.length,I=g<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(me,e,D,O);else for(var b=me.length-1;b>=0;b--)(L=me[b])&&(I=(g<3?L(I):g>3?L(e,D,I):L(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(ke[81],Se([1,0,19,11,22,21,52,14,4,3,55,12,18]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.ProxyChannel=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.RequestInitiator=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;var v;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(v||(v={}));function S(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(h||(h={}));function f(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(o||(o={}));function i(Z){let J=0;for(let Y=0;;Y+=7){const he=Z.read(1);if(J|=(he.buffer[0]&127)<<Y,!(he.buffer[0]&128))return J}}const r=s(0);function n(Z,J){if(J===0){Z.write(r);return}let Y=0;for(let _=J;_!==0;_=_>>>7)Y++;const he=g.$ie.alloc(Y);for(let _=0;J!==0;_++)he.buffer[_]=J&127,J=J>>>7,J>0&&(he.buffer[_]|=128);Z.write(he)}class c{constructor(J){this.b=J,this.a=0}read(J){const Y=this.b.slice(this.a,this.a+J);return this.a+=Y.byteLength,Y}}e.$Ch=c;class t{constructor(){this.a=[]}get buffer(){return g.$ie.concat(this.a)}write(J){this.a.push(J)}}e.$Dh=t;var u;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(u||(u={}));function s(Z){const J=g.$ie.alloc(1);return J.writeUInt8(Z,0),J}const l={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object),Uint:s(u.Int)},a=typeof Buffer<"u";function d(Z,J){if(typeof J>"u")Z.write(l.Undefined);else if(typeof J=="string"){const Y=g.$ie.fromString(J);Z.write(l.String),n(Z,Y.byteLength),Z.write(Y)}else if(a&&Buffer.isBuffer(J)){const Y=g.$ie.wrap(J);Z.write(l.Buffer),n(Z,Y.byteLength),Z.write(Y)}else if(J instanceof g.$ie)Z.write(l.VSBuffer),n(Z,J.byteLength),Z.write(J);else if(Array.isArray(J)){Z.write(l.Array),n(Z,J.length);for(const Y of J)d(Z,Y)}else if(typeof J=="number"&&(J|0)===J)Z.write(l.Uint),n(Z,J);else{const Y=g.$ie.fromString(JSON.stringify(J));Z.write(l.Object),n(Z,Y.byteLength),Z.write(Y)}}e.$Eh=d;function k(Z){switch(Z.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return Z.read(i(Z)).toString();case u.Buffer:return Z.read(i(Z)).buffer;case u.VSBuffer:return Z.read(i(Z));case u.Array:{const Y=i(Z),he=[];for(let _=0;_<Y;_++)he.push(k(Z));return he}case u.Object:return JSON.parse(Z.read(i(Z)).toString());case u.Int:return i(Z)}}e.$Fh=k;class P{constructor(J,Y,he=null,_=1e3){this.h=J,this.j=Y,this.k=he,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(J,Y){this.b.set(J,Y),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const Y=this.o([J.type]);this.k?.logOutgoing(Y,0,1,f(J.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([J.type,J.id],J.data);this.k?.logOutgoing(Y,J.id,1,f(J.type),J.data);return}}}o(J,Y=void 0){const he=new t;return d(he,J),d(he,Y),this.p(he.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const Y=new c(J),he=k(Y),_=k(Y),we=he[0];switch(we){case 100:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}: ${he[2]}.${he[3]}`,_),this.s({type:we,id:he[1],channelName:he[2],name:he[3],arg:_});case 102:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}: ${he[2]}.${he[3]}`,_),this.t({type:we,id:he[1],channelName:he[2],name:he[3],arg:_});case 101:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}`),this.u({type:we,id:he[1]});case 103:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(we)}`),this.u({type:we,id:he[1]})}}s(J){const Y=this.b.get(J.channelName);if(!Y){this.v(J);return}const he=new I.$5d;let _;try{_=Y.call(this.j,J.name,J.arg,he.token)}catch(K){_=Promise.reject(K)}const we=J.id;_.then(K=>{this.m({id:we,data:K,type:201})},K=>{K instanceof Error?this.m({id:we,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:we,data:K,type:203})}).finally(()=>{oe.dispose(),this.d.delete(J.id)});const oe=(0,y.$Rc)(()=>he.cancel());this.d.set(J.id,oe)}t(J){const Y=this.b.get(J.channelName);if(!Y){this.v(J);return}const he=J.id,we=Y.listen(this.j,J.name,J.arg)(oe=>this.m({id:he,data:oe,type:204}));this.d.set(J.id,we)}u(J){const Y=this.d.get(J.id);Y&&(Y.dispose(),this.d.delete(J.id))}v(J){let Y=this.g.get(J.channelName);Y||(Y=[],this.g.set(J.channelName,Y));const he=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:J,timeoutTimer:he})}w(J){const Y=this.g.get(J);if(Y){for(const he of Y)switch(clearTimeout(he.timeoutTimer),he.request.type){case 100:this.s(he.request);break;case 102:this.t(he.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Gh=P;var p;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class w{constructor(J,Y=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Ud,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(he=>this.s(he)),this.j=Y}getChannel(J){const Y=this;return{call(he,_,we){return Y.a?Promise.reject(new b.$5):Y.m(J,he,_,we)},listen(he,_){return Y.a?$.Event.None:Y.o(J,he,_)}}}m(J,Y,he,_=I.CancellationToken.None){const we=this.g++,K={id:we,type:100,channelName:J,name:Y,arg:he};if(_.isCancellationRequested)return Promise.reject(new b.$5);let W;return new Promise((ye,de)=>{if(_.isCancellationRequested)return de(new b.$5);const ge=()=>{const ie=fe=>{switch(fe.type){case 201:this.f.delete(we),ye(fe.data);break;case 202:{this.f.delete(we);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,de(ve);break}case 203:this.f.delete(we),de(fe.data);break}};this.f.set(we,ie),this.p(K)};let x=null;this.b===o.Idle?ge():(x=(0,O.$Sg)(ie=>this.u()),x.then(()=>{x=null,ge()}));const te=()=>{x?(x.cancel(),x=null):this.p({id:we,type:101}),de(new b.$5)},G=_.onCancellationRequested(te);W=(0,y.$Qc)((0,y.$Rc)(te),G),this.d.add(W)}).finally(()=>{W.dispose(),this.d.delete(W)})}o(J,Y,he){const _=this.g++,oe={id:_,type:102,channelName:J,name:Y,arg:he};let K=null;const W=new $.$Ud({onWillAddFirstListener:()=>{K=(0,O.$Sg)(ye=>this.u()),K.then(()=>{K=null,this.d.add(W),this.p(oe)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(W),this.p({id:_,type:103}))}}),re=ye=>W.fire(ye.data);return this.f.set(_,re),W.event}p(J){switch(J.type){case 100:case 102:{const Y=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(Y,J.id,0,`${S(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const Y=this.q([J.type,J.id]);this.j?.logOutgoing(Y,J.id,0,S(J.type));return}}}q(J,Y=void 0){const he=new t;return d(he,J),d(he,Y),this.r(he.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const Y=new c(J),he=k(Y),_=k(Y),we=he[0];switch(we){case 200:return this.j?.logIncoming(J.byteLength,0,0,f(we)),this.t({type:he[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,he[1],0,f(we),_),this.t({type:he[0],id:he[1],data:_})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=w,Ge([L.$wh],w.prototype,"onDidInitializePromise",null);class E{get connections(){const J=[];return this.f.forEach(Y=>J.push(Y)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new $.$Ud,this.onDidAddConnection=this.g.event,this.h=new $.$Ud,this.onDidRemoveConnection=this.h.event,this.j=new y.$Sc,this.j.add(J(({protocol:Y,onDidClientDisconnect:he})=>{const _=$.Event.once(Y.onMessage);this.j.add(_(we=>{const oe=new c(we),K=k(oe),W=new P(Y,K),re=new w(Y);this.a.forEach((de,ge)=>W.registerChannel(ge,de));const ye={channelServer:W,channelClient:re,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(he(()=>{W.dispose(),re.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(J,Y){const he=this;return{call(_,we,oe){let K;if((0,m.$Vf)(Y)){const re=(0,D.$4b)(he.connections.filter(Y));K=re?Promise.resolve(re):$.Event.toPromise($.Event.filter(he.onDidAddConnection,Y))}else K=Y.routeCall(he,_,we);const W=K.then(re=>re.channelClient.getChannel(J));return T(W).call(_,we,oe)},listen(_,we){if((0,m.$Vf)(Y))return he.k(J,Y,_,we);const oe=Y.routeEvent(he,_,we).then(K=>K.channelClient.getChannel(J));return T(oe).listen(_,we)}}}k(J,Y,he,_){const we=this;let oe;const K=new $.$Ud({onWillAddFirstListener:()=>{oe=new y.$Sc;const W=new $.$1d,re=new Map,ye=ge=>{const te=ge.channelClient.getChannel(J).listen(he,_),G=W.add(te);re.set(ge,G)},de=ge=>{const x=re.get(ge);x&&(x.dispose(),re.delete(ge))};we.connections.filter(Y).forEach(ye),$.Event.filter(we.onDidAddConnection,Y)(ye,void 0,oe),we.onDidRemoveConnection(de,void 0,oe),W.event(K.fire,K,oe),oe.add(W)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return K.event}registerChannel(J,Y){this.a.set(J,Y);for(const he of this.f)he.channelServer.registerChannel(J,Y)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Ih=E;class A{constructor(J,Y,he=null){const _=new t;d(_,Y),J.send(_.buffer),this.a=new w(J,he),this.d=new P(J,Y,he)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,Y){this.d.registerChannel(J,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Jh=A;function T(Z){return{call(J,Y,he){return Z.then(_=>_.call(J,Y,he))},listen(J,Y){const he=new $.$4d;return Z.then(_=>he.input=_.listen(J,Y)),he.event}}}e.$Kh=T;function U(Z){let J=!1;return{call(Y,he,_){return J?Z.call(Y,he,_):(0,O.$6g)(0).then(()=>J=!0).then(()=>Z.call(Y,he,_))},listen(Y,he){if(J)return Z.listen(Y,he);const _=new $.$4d;return(0,O.$6g)(0).then(()=>J=!0).then(()=>_.input=Z.listen(Y,he)),_.event}}}e.$Lh=U;class N{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const Y of J.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Mh=N;var j;(function(Z){function J(we,oe,K){const W=we,re=K&&K.disableMarshalling,ye=new Map;for(const de in W)he(de)&&ye.set(de,$.Event.buffer(W[de],!0,void 0,oe));return new class{listen(de,ge,x){const te=ye.get(ge);if(te)return te;if(_(ge)){const G=W[ge];if(typeof G=="function")return G.call(W,x)}throw new b.$bb(`Event not found: ${ge}`)}call(de,ge,x){const te=W[ge];if(typeof te=="function"){if(!re&&Array.isArray(x))for(let ie=0;ie<x.length;ie++)x[ie]=(0,R.$Bh)(x[ie]);let G=te.apply(W,x);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${ge}`)}}}Z.fromService=J;function Y(we,oe){const K=oe&&oe.disableMarshalling;return new Proxy({},{get(W,re){if(typeof re=="string")return oe?.properties?.has(re)?oe.properties.get(re):_(re)?function(ye){return we.listen(re,ye)}:he(re)?we.listen(re):async function(...ye){let de;oe&&!(0,m.$Qf)(oe.context)?de=[oe.context,...ye]:de=ye;const ge=await we.call(re,de);return K?ge:(0,R.$Bh)(ge)};throw new b.$bb(`Property not found: ${String(re)}`)}})}Z.toService=Y;function he(we){return we[0]==="o"&&we[1]==="n"&&C.$0e(we.charCodeAt(2))}function _(we){return/^onDynamic/.test(we)&&C.$0e(we.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const J=Z.toString();if(J!=="[object Object]")return J}return Z}function B(Z){return Array.isArray(Z)?Z.map(M):M(Z)}function X(Z,J,Y,he,_,we,oe){oe=B(oe);const K=F[_],W=K[he%K.length];let re=[`%c[${Z}]%c[${String(J).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(he).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(we)?(re=re.concat(oe),re.push(")")):re.push(oe),console.log.apply(console,re)}class ue{constructor(J,Y){this.d=J,this.f=Y,this.a=0,this.b=0}logOutgoing(J,Y,he,_,we){this.b+=J,X(this.d,this.b,J,Y,he,_,we)}logIncoming(J,Y,he,_,we){this.a+=J,X(this.f,this.a,J,Y,he,_,we)}}e.$Nh=ue}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.ProtocolConstants=e.$Oh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const a=new WeakMap;let d=0;function k(p,w){if(!a.has(p)){const E=String(++d);a.set(p,E)}return a.get(p)}function P(p,w,E,A){if(!l.enableDiagnostics)return;const T=k(p,w);if(A instanceof D.$ie||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const U=D.$ie.alloc(A.byteLength);U.set(A),l.records.push({timestamp:Date.now(),id:T,label:w,type:E,buff:U})}else l.records.push({timestamp:Date.now(),id:T,label:w,type:E,data:A})}l.traceSocketEvent=P})(b||(e.SocketDiagnostics=b={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function R(){return y||(y=D.$ie.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,d){if(a===0)return R();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const w=this.a[0];return d&&(this.a.shift(),this.b-=a),w}if(this.a[0].byteLength>a){const w=this.a[0].slice(0,a);return d&&(this.a[0]=this.a[0].slice(a),this.b-=a),w}const k=D.$ie.alloc(a);let P=0,p=0;for(;a>0;){const w=this.a[p];if(w.byteLength>a){const E=w.slice(0,a);k.set(E,P),P+=a,d&&(this.a[p]=w.slice(a),this.b-=a),a-=a}else k.set(w,P),P+=w.byteLength,d?(this.a.shift(),this.b-=w.byteLength):p++,a-=w.byteLength}return k}}e.$Oh=C;var m;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class h{constructor(a,d,k,P){this.type=a,this.id=d,this.ack=k,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Tc{constructor(a){super(),this.f=this.B(new O.$Ud),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,P=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new h(k,P,p,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=D.$ie.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(d,a.data)}g(a,d){const k=this.f===0;return this.d.push(a,d),this.f+=a.byteLength+d.byteLength,k}h(){const a=D.$ie.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,d){this.g(a,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends g.$Tc{constructor(a){super(),this.f=new O.$Ud,this.onMessage=this.f.event,this.g=new O.$Ud,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new h(1,0,0,a))}}e.$Ph=i;class r extends I.$Jh{static fromSocket(a,d){return new r(new i(a),d)}get onDidDispose(){return this.b.onDidDispose}constructor(a,d,k=null){super(a,d,k),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$Qh=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$Ud({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$Rh=n;class c{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,d=this.a;for(;d;)d=d.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let d=0,k=this.a;for(;k;)a[d++]=k.data,k=k.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const d=new c(a);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const a=Date.now();for(let d=0;d<u.a;d++)this.c[d]=a-1e3*d;setInterval(()=>{for(let d=u.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),d=(1+u.a)*1e3;let k=0;for(let P=0;P<u.a;P++)a-this.c[P]<=d&&k++;return 1-k/u.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??u.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Sc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new h(5,0,0,R());this.p.write(a),this.p.flush()}sendPause(){const a=new h(7,0,0,R());this.p.write(a)}sendResume(){const a=new h(8,0,0,R());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,d){this.a=!0,this.r.dispose(),this.r=new g.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new h(3,0,this.h,R());this.p.write(a);const d=this.b.toArray();for(let k=0,P=d.length;k<P;k++)this.p.write(d[k]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const d=this.b.peek();if(d&&d.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new h(6,0,0,R())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let k=0,P=d.length;k<P;k++)this.p.write(d[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const d=++this.c;this.h=this.g;const k=new h(1,d,this.h,a);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(a){const d=new h(2,0,0,a);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),d=Date.now()-a.writtenTime,k=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(d>=2e4&&k>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:k});return}const p=Math.max(2e4-d,2e4-k,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new h(3,0,this.h,R());this.p.write(a)}D(){this.h=this.g;const a=new h(9,0,this.h,R());this.p.write(a)}}e.$Sh=s}),define(ke[187],Se([1,0,51,11,22,21,185,14,4,3,24,104,101,81]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class S extends v.$Gh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$ie.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$pq=S;class h{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Ud,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new O.$2g(r),this.d=null,this.f=null}getChannel(o){const i=this;return{call(r,n,c){return i.k(o,r,n,c)},listen(r,n){return i.l(o,r,n)}}}k(o,i,r,n=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const c=this.n(o),t=(0,O.$Sg)(l=>c.call(i,r,l)),u=n.onCancellationRequested(()=>t.cancel()),s=(0,y.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{u.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,r){if(!this.b)return $.Event.None;this.b.cancel();let n;const c=new $.$Ud({onWillAddFirstListener:()=>{n=this.n(o).listen(i,r)(c.fire,c),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$un)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,m.$Rl)(i.env),this.d=(0,D.fork)(this.i,o,i);const r=new $.$Ud;$.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,L.$lq)(a)){(0,L.log)(a,`IPC Library: ${this.j.serverName}`);return}r.fire(g.$ie.wrap(Buffer.from(a,"base64")))});const c=this.j.useQueue?(0,C.$Tl)(this.d):this.d,t=a=>this.d&&this.d.connected&&c.send(a.buffer.toString("base64")),u=r.event,s={send:t,onMessage:u};this.f=new v.$Hh(s);const l=()=>this.o();process.once("exit",l),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,d)=>{process.removeListener("exit",l),this.c.forEach(k=>(0,y.$Oc)(k)),this.c.clear(),a!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:d})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qq=h}),define(ke[188],Se([1,0,11,4,3,55,18]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.StorageState=e.$op=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const v=m;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$op=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class R extends g.$Tc{static{this.a=100}constructor(v,S=Object.create(null)){super(),this.r=v,this.s=S,this.b=this.B(new O.$Xd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$3g(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((S,h)=>this.w(h,S)),v.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(v,S){if(this.c===y.Closed)return;let h=!1;(0,L.$Qf)(S)?h=this.f.delete(v):this.f.get(v)!==S&&(this.f.set(v,S),h=!0),h&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,S){const h=this.f.get(v);return(0,L.$Qf)(h)?S:h}getBoolean(v,S){const h=this.get(v);return(0,L.$Qf)(h)?S:h==="true"}getNumber(v,S){const h=this.get(v);return(0,L.$Qf)(h)?S:parseInt(h,10)}getObject(v,S){const h=this.get(v);return(0,L.$Qf)(h)?S:(0,I.$Ah)(h)}async set(v,S,h=!1){if(this.c===y.Closed)return;if((0,L.$Qf)(S))return this.delete(v,h);const f=(0,L.$Jf)(S)||Array.isArray(S)?(0,I.$zh)(S):String(S);if(this.f.get(v)!==f)return this.f.set(v,f),this.j.set(v,f),this.h.delete(v),this.b.fire({key:v,external:h}),this.D()}async delete(v,S=!1){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$pp=R;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((S,h)=>this.a.set(h,S)),v.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$qp=C}),define(ke[189],Se([1,0,12,10,22]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.$at=e.$_s=void 0;let I;function L(){return I||(I=new TextDecoder("UTF-16LE")),I}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function R(){return y||(y=O.$D()?L():$()),y}e.$_s=R;function C(S,h,f){const o=new Uint16Array(S.buffer,h,f);return f>0&&(o[0]===65279||o[0]===65534)?m(S,h,f):L().decode(o)}e.$at=C;function m(S,h,f){const o=[];let i=0;for(let r=0;r<f;r++){const n=g.$ke(S,h);h+=2,o[i++]=String.fromCharCode(n)}return o.join("")}class v{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return R().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const f=this.a-this.d;f<=1&&(f===0||D.$cf(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const f=h.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=h;return}for(let o=0;o<f;o++)this.b[this.d++]=h.charCodeAt(o)}}e.$bt=v}),define(ke[190],Se([1,0,22,189]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,R,C,m){this.oldPosition=y,this.oldText=R,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,R,C){const m=R.length;D.$ne(y,m,C),C+=4;for(let v=0;v<m;v++)D.$le(y,R.charCodeAt(v),C),C+=2;return C}static d(y,R){const C=D.$me(y,R);return R+=4,(0,O.$at)(y,R,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,R){return D.$ne(y,this.oldPosition,R),R+=4,D.$ne(y,this.newPosition,R),R+=4,R=I.c(y,this.oldText,R),R=I.c(y,this.newText,R),R}static read(y,R,C){const m=D.$me(y,R);R+=4;const v=D.$me(y,R);R+=4;const S=I.d(y,R);R+=I.a(S);const h=I.d(y,R);return R+=I.a(h),C.push(new I(m,S,v,h)),R}}e.$ct=I;function L($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$dt=L;class b{constructor(y,R){this.a=y,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,R=0,C=this.n(y),m=this.l(R);for(;y<this.f||R<this.h;){if(C===null){this.k(m),m=this.l(++R);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++R);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[o,i]=b.r(m,C.newPosition-m.oldPosition);this.k(o),m=i;continue}if(C.newPosition<m.oldPosition){const[o,i]=b.q(C,m.oldPosition-C.newPosition);this.m(o),C=i;continue}let h,f;if(m.oldEnd===C.newEnd)h=C,f=m,C=this.n(++y),m=this.l(++R);else if(m.oldEnd<C.newEnd){const[o,i]=b.q(C,m.oldLength);h=o,f=m,C=i,m=this.l(++R)}else{const[o,i]=b.r(m,C.newLength);h=C,f=o,C=this.n(++y),m=i}this.d[this.e++]=new I(h.oldPosition,h.oldText,f.newPosition,f.newText),this.g+=h.newLength-h.oldLength,this.j+=f.newLength-f.oldLength}const v=b.s(this.d);return b.t(v)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,R){return new I(R.oldPosition-y,R.oldText,R.newPosition,R.newText)}static p(y,R){return new I(R.oldPosition,R.oldText,R.newPosition+y,R.newText)}static q(y,R){const C=y.newText.substr(0,R),m=y.newText.substr(R);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+R,m)]}static r(y,R){const C=y.oldText.substr(0,R),m=y.oldText.substr(R);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+R,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const R=[];let C=0,m=y[0];for(let v=1;v<y.length;v++){const S=y[v];m.oldEnd===S.oldPosition?m=new I(m.oldPosition,m.oldText+S.oldText,m.newPosition,m.newText+S.newText):(R[C++]=m,m=S)}return R[C++]=m,R}static t(y){if(y.length===0)return y;const R=[];let C=0;for(let m=0;m<y.length;m++){const v=y[m];v.oldText!==v.newText&&(R[C++]=v)}return R}}}),define(ke[191],Se([1,0,34,16]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0;function g(I,L,b,$,y,R){if(Array.isArray(I)){let C=0;for(const m of I){const v=g(m,L,b,$,y,R);if(v===10)return v;v>C&&(C=v)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===b?10:0:0;if(I){const{language:C,pattern:m,scheme:v,hasAccessToAllModels:S,notebookType:h}=I;if(!$&&!S)return 0;h&&y&&(L=y);let f=0;if(v)if(v===L.scheme)f=10;else if(v==="*")f=5;else return 0;if(C)if(C===b)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(h)if(h===R)f=10;else if(h==="*"&&R!==void 0)f=Math.max(f,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,O.$hc)(m.base)},o===L.fsPath||(0,D.$Kj)(o,L.fsPath))f=10;else return 0}return f}else return 0}}e.$At=g}),define(ke[192],Se([1,0,4,12,29,79,127,167,190,3]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=void 0;class R extends y.$Tc{constructor(m,v,S,h,f,o,i){super(),this.m=this.B(new D.$Ud),this.onDidChangeContent=this.m.event,this.f=v,this.j=!o,this.g=h,this.h=f,this.c=new L.$_B(m,S,i)}equals(m){return!(m instanceof R)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,v){return this.c.getOffsetAt(m,v)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,v){const S=m+v,h=this.getPositionAt(m),f=this.getPositionAt(S);return new g.$Ts(h.lineNumber,h.column,f.lineNumber,f.column)}getValueInRange(m,v=0){if(m.isEmpty())return"";const S=this.n(v);return this.c.getValueInRange(m,S)}getValueLengthInRange(m,v=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const S=this.getOffsetAt(m.startLineNumber,m.startColumn),h=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const o=this.n(v),i=this.getEOL();if(o.length!==i.length){const r=o.length-i.length,n=m.endLineNumber-m.startLineNumber;f=r*n}return h-S+f}getCharacterCountInRange(m,v=0){if(this.j){let S=0;const h=m.startLineNumber,f=m.endLineNumber;for(let o=h;o<=f;o++){const i=this.getLineContent(o),r=o===h?m.startColumn-1:0,n=o===f?m.endColumn-1:i.length;for(let c=r;c<n;c++)O.$cf(i.charCodeAt(c))?(S=S+1,c=c+1):S=S+1}return S+=this.n(v).length*(f-h),S}return this.getValueLengthInRange(m,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,v){return this.c.getLineCharCode(m,v)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const v=O.$Ze(this.getLineContent(m));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(m){const v=O.$2e(this.getLineContent(m));return v===-1?0:v+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,v,S){let h=this.g,f=this.h,o=this.j,i=!0,r=[];for(let a=0;a<m.length;a++){const d=m[a];i&&d._isTracked&&(i=!1);const k=d.range;if(d.text){let A=!0;o||(A=!O.$nf(d.text),o=A),!h&&A&&(h=O.$mf(d.text)),!f&&A&&(f=O.$pf(d.text))}let P="",p=0,w=0,E=0;if(d.text){let A;[p,w,E,A]=(0,b.$tt)(d.text);const T=this.getEOL();A===0||A===(T===`\r
`?2:1)?P=d.text:P=d.text.replace(/\r\n|\r|\n/g,T)}r[a]={sortIndex:a,identifier:d.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:P,eolCount:p,firstLineLength:w,lastLineLength:E,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}r.sort(R.u);let n=!1;for(let a=0,d=r.length-1;a<d;a++){const k=r[a].range.getEndPosition(),P=r[a+1].range.getStartPosition();if(P.isBeforeOrEqual(k)){if(P.isBefore(k))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const c=S||v?R._getInverseEditRanges(r):[],t=[];if(v)for(let a=0;a<r.length;a++){const d=r[a],k=c[a];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let P=k.startLineNumber;P<=k.endLineNumber;P++){let p="";P===k.startLineNumber&&(p=this.getLineContent(d.range.startLineNumber),O.$Ze(p)!==-1)||t.push({lineNumber:P,oldContent:p})}}let u=null;if(S){let a=0;u=[];for(let d=0;d<r.length;d++){const k=r[d],P=c[d],p=this.getValueInRange(k.range),w=k.rangeOffset+a;a+=k.text.length-p.length,u[d]={sortIndex:k.sortIndex,identifier:k.identifier,range:P,text:p,textChange:new $.$ct(k.rangeOffset,p,w,k.text)}}n||u.sort((d,k)=>d.sortIndex-k.sortIndex)}this.g=h,this.h=f,this.j=o;const s=this.t(r);let l=null;if(v&&t.length>0){t.sort((a,d)=>d.lineNumber-a.lineNumber),l=[];for(let a=0,d=t.length;a<d;a++){const k=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===k)continue;const P=t[a].oldContent,p=this.getLineContent(k);p.length===0||p===P||O.$Ze(p)!==-1||l.push(k)}}return this.m.fire(),new I.$dv(u,s,l)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let v=!1;const S=m[0].range,h=m[m.length-1].range,f=new g.$Ts(S.startLineNumber,S.startColumn,h.endLineNumber,h.endColumn);let o=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,l=m.length;s<l;s++){const a=m[s],d=a.range;v=v||a.forceMoveMarkers,r.push(this.getValueInRange(new g.$Ts(o,i,d.startLineNumber,d.startColumn))),a.text.length>0&&r.push(a.text),o=d.endLineNumber,i=d.endColumn}const n=r.join(""),[c,t,u]=(0,b.$tt)(n);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:n,eolCount:c,firstLineLength:t,lastLineLength:u,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(m){m.sort(R.w);const v=[];for(let S=0;S<m.length;S++){const h=m[S],f=h.range.startLineNumber,o=h.range.startColumn,i=h.range.endLineNumber,r=h.range.endColumn;if(f===i&&o===r&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const n=new g.$Ts(f,o,i,r);v.push({range:n,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return v}findMatchesLineByLine(m,v,S,h){return this.c.findMatchesLineByLine(m,v,S,h)}getPieceTree(){return this.c}static _getInverseEditRange(m,v){const S=m.startLineNumber,h=m.startColumn,[f,o,i]=(0,b.$tt)(v);let r;if(v.length>0){const n=f+1;n===1?r=new g.$Ts(S,h,S,h+o):r=new g.$Ts(S,h,S+n-1,i+1)}else r=new g.$Ts(S,h,S,h);return r}static _getInverseEditRanges(m){const v=[];let S=0,h=0,f=null;for(let o=0,i=m.length;o<i;o++){const r=m[o];let n,c;f?f.range.endLineNumber===r.range.startLineNumber?(n=S,c=h+(r.range.startColumn-f.range.endColumn)):(n=S+(r.range.startLineNumber-f.range.endLineNumber),c=r.range.startColumn):(n=r.range.startLineNumber,c=r.range.startColumn);let t;if(r.text.length>0){const u=r.eolCount+1;u===1?t=new g.$Ts(n,c,n,c+r.firstLineLength):t=new g.$Ts(n,c,n+u-1,r.lastLineLength+1)}else t=new g.$Ts(n,c,n,c);S=t.endLineNumber,h=t.endColumn,v.push(t),f=r}return v}static u(m,v){const S=g.$Ts.compareRangesUsingEnds(m.range,v.range);return S===0?m.sortIndex-v.sortIndex:S}static w(m,v){const S=g.$Ts.compareRangesUsingEnds(m.range,v.range);return S===0?v.sortIndex-m.sortIndex:-S}}e.$aC=R}),define(ke[193],Se([1,0,12,127,192]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class I{constructor($,y,R,C,m,v,S,h,f){this.a=$,this.b=y,this.c=R,this.d=C,this.e=m,this.f=v,this.g=S,this.h=h,this.j=f}k($){const y=this.c+this.d+this.e,R=this.c+this.e;return y===0?$===1?`
`:`\r
`:R>y/2?`\r
`:`
`}create($){const y=this.k($),R=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,v=R.length;m<v;m++){const S=R[m].buffer.replace(/\r\n|\r|\n/g,y),h=(0,O.$8B)(S);R[m]=new O.$$B(S,h)}const C=new g.$aC(R,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$vf($)&&(this.b=D.$uf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,O.$9B)(this.e,$);this.a.push(new O.$$B($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$mf($)),this.k||(this.k=D.$pf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,O.$8B)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$bC=L}),define(ke[131],Se([1,0,22,10]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$=e.$q$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,v=C.length;m<v;m+=4){const S=C[m+0],h=C[m+1],f=C[m+2],o=C[m+3];C[m+0]=o,C[m+1]=f,C[m+2]=h,C[m+3]=S}}function L(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return O.$D()||I(m),D.$ie.wrap(m)}function b(C){const m=C.buffer;if(O.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function $(C){const m=new Uint32Array(y(C));let v=0;if(m[v++]=C.id,C.type==="full")m[v++]=1,m[v++]=C.data.length,m.set(C.data,v),v+=C.data.length;else{m[v++]=2,m[v++]=C.deltas.length;for(const S of C.deltas)m[v++]=S.start,m[v++]=S.deleteCount,S.data?(m[v++]=S.data.length,m.set(S.data,v),v+=S.data.length):m[v++]=0}return L(m)}e.$q$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const v of C.deltas)v.data&&(m+=v.data.length)}return m}function R(C){const m=b(C);let v=0;const S=m[v++];if(m[v++]===1){const i=m[v++],r=m.subarray(v,v+i);return v+=i,{id:S,type:"full",data:r}}const f=m[v++],o=[];for(let i=0;i<f;i++){const r=m[v++],n=m[v++],c=m[v++];let t;c>0&&(t=m.subarray(v,v+c),v+=c),o[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:o}}e.$r$=R}),define(ke[194],Se([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,10,170,126,194]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(ce,Ie,Ve,Xe){this.id=ce,this.name=Ie,this.defaultValue=Ve,this.schema=Xe}applyUpdate(ce,Ie){return v(ce,Ie)}compute(ce,Ie,Ve){return Ve}}class m{constructor(ce,Ie){this.newValue=ce,this.didChange=Ie}}e.ApplyUpdateResult=m;function v(ne,ce){if(typeof ne!="object"||typeof ce!="object"||!ne||!ce)return new m(ce,ne!==ce);if(Array.isArray(ne)||Array.isArray(ce)){const Ve=Array.isArray(ne)&&Array.isArray(ce)&&D.$ub(ne,ce);return new m(ce,!Ve)}let Ie=!1;for(const Ve in ce)if(ce.hasOwnProperty(Ve)){const Xe=v(ne[Ve],ce[Ve]);Xe.didChange&&(ne[Ve]=Xe.newValue,Ie=!0)}return new m(ne,Ie)}class S{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ie){return v(ce,Ie)}validate(ce){return this.defaultValue}}class h{constructor(ce,Ie,Ve,Xe){this.id=ce,this.name=Ie,this.defaultValue=Ve,this.schema=Xe}applyUpdate(ce,Ie){return v(ce,Ie)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ie,Ve){return Ve}}function f(ne,ce){return typeof ne>"u"?ce:ne==="false"?!1:!!ne}e.boolean=f;class o extends h{constructor(ce,Ie,Ve,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=Ve),super(ce,Ie,Ve,Xe)}validate(ce){return f(ce,this.defaultValue)}}function i(ne,ce,Ie,Ve){if(typeof ne>"u")return ce;let Xe=parseInt(ne,10);return isNaN(Xe)?ce:(Xe=Math.max(Ie,Xe),Xe=Math.min(Ve,Xe),Xe|0)}e.clampedInt=i;class r extends h{static clampedInt(ce,Ie,Ve,Xe){return i(ce,Ie,Ve,Xe)}constructor(ce,Ie,Ve,Xe,nt,it=void 0){typeof it<"u"&&(it.type="integer",it.default=Ve,it.minimum=Xe,it.maximum=nt),super(ce,Ie,Ve,it),this.minimum=Xe,this.maximum=nt}validate(ce){return r.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function n(ne,ce,Ie,Ve){if(typeof ne>"u")return ce;const Xe=c.float(ne,ce);return c.clamp(Xe,Ie,Ve)}e.clampedFloat=n;class c extends h{static clamp(ce,Ie,Ve){return ce<Ie?Ie:ce>Ve?Ve:ce}static float(ce,Ie){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ie;const Ve=parseFloat(ce);return isNaN(Ve)?Ie:Ve}constructor(ce,Ie,Ve,Xe,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(ce,Ie,Ve,nt),this.validationFn=Xe}validate(ce){return this.validationFn(c.float(ce,this.defaultValue))}}class t extends h{static string(ce,Ie){return typeof ce!="string"?Ie:ce}constructor(ce,Ie,Ve,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=Ve),super(ce,Ie,Ve,Xe)}validate(ce){return t.string(ce,this.defaultValue)}}function u(ne,ce,Ie,Ve){return typeof ne!="string"?ce:Ve&&ne in Ve?Ve[ne]:Ie.indexOf(ne)===-1?ce:ne}e.stringSet=u;class s extends h{constructor(ce,Ie,Ve,Xe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Xe,nt.default=Ve),super(ce,Ie,Ve,nt),this.c=Xe}validate(ce){return u(ce,this.defaultValue,this.c)}}class l extends C{constructor(ce,Ie,Ve,Xe,nt,it,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=nt,Oe.default=Xe),super(ce,Ie,Ve,Oe),this.c=nt,this.d=it}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function a(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ie,Ve){return Ve===0?ce.accessibilitySupport:Ve}}class k extends C{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertSpace:f(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function p(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function E(ne){switch(ne){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function A(ne){switch(ne){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class T extends S{constructor(){super(140)}compute(ce,Ie,Ve){const Xe=["monaco-editor"];return Ie.get(39)&&Xe.push(Ie.get(39)),ce.extraEditorClassName&&Xe.push(ce.extraEditorClassName),Ie.get(73)==="default"?Xe.push("mouse-default"):Ie.get(73)==="copy"&&Xe.push("mouse-copy"),Ie.get(110)&&Xe.push("showUnused"),Ie.get(138)&&Xe.push("showDeprecated"),Xe.join(" ")}}class U extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Ie,Ve){return Ve&&ce.emptySelectionClipboard}}class N extends C{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{cursorMoveOnType:f(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":u(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":u(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ie.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?j.OFF:ce==="true"?j.ON:ce:ce?j.ON:j.OFF}}e.EditorFontLigatures=j;class F extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?F.OFF:ce==="true"?F.TRANSLATE:ce:ce?F.TRANSLATE:F.OFF}compute(ce,Ie,Ve){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class M extends S{constructor(){super(50)}compute(ce,Ie,Ve){return ce.fontInfo}}class B extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Ie=c.float(ce,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ie,6,100)}compute(ce,Ie,Ve){return ce.fontInfo.fontSize}}class X extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(r.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class ue extends C{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ve,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ve,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ve,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ve,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ve,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{multiple:u(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??u(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??u(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??u(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??u(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??u(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends C{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:f(Ie.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ie.above,this.defaultValue.above)}}}var J;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class Y extends S{constructor(){super(143)}compute(ce,Ie,Ve){return Y.computeLayout(Ie,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ie=ce.height/ce.lineHeight,Ve=Math.floor(ce.paddingTop/ce.lineHeight);let Xe=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Xe=Math.max(Xe,Ie-1));const nt=(Ve+ce.viewLineCount+Xe)/(ce.pixelRatio*ce.height),it=Math.floor(ce.viewLineCount/nt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Xe,desiredRatio:nt,minimapLineCount:it}}static c(ce,Ie){const Ve=ce.outerWidth,Xe=ce.outerHeight,nt=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const it=Ie.stableMinimapLayoutInput,Oe=it&&ce.outerHeight===it.outerHeight&&ce.lineHeight===it.lineHeight&&ce.typicalHalfwidthCharacterWidth===it.typicalHalfwidthCharacterWidth&&ce.pixelRatio===it.pixelRatio&&ce.scrollBeyondLastLine===it.scrollBeyondLastLine&&ce.paddingTop===it.paddingTop&&ce.paddingBottom===it.paddingBottom&&ce.minimap.enabled===it.minimap.enabled&&ce.minimap.side===it.minimap.side&&ce.minimap.size===it.minimap.size&&ce.minimap.showSlider===it.minimap.showSlider&&ce.minimap.renderCharacters===it.minimap.renderCharacters&&ce.minimap.maxColumn===it.minimap.maxColumn&&ce.minimap.scale===it.minimap.scale&&ce.verticalScrollbarWidth===it.verticalScrollbarWidth&&ce.isViewportWrapping===it.isViewportWrapping,pt=ce.lineHeight,St=ce.typicalHalfwidthCharacterWidth,Nt=ce.scrollBeyondLastLine,Wt=ce.minimap.renderCharacters;let Et=nt>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Kt=ce.minimap.maxColumn,Ot=ce.minimap.size,Xt=ce.minimap.side,Ut=ce.verticalScrollbarWidth,Lt=ce.viewLineCount,et=ce.remainingWidth,Gt=ce.isViewportWrapping,Jt=Wt?2:3;let ht=Math.floor(nt*Xe);const bt=ht/nt;let zt=!1,qt=!1,Dt=Jt*Et,ft=Et/nt,At=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Fe,desiredRatio:Ne,minimapLineCount:Ce}=Y.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Nt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Xe,lineHeight:pt,pixelRatio:nt});if(Lt/Ce>1)zt=!0,qt=!0,Et=1,Dt=1,ft=Et/nt;else{let Te=!1,qe=Et+1;if(Ot==="fit"){const xe=Math.ceil((Tt+Lt+Fe)*Dt);Gt&&Oe&&et<=Ie.stableFitRemainingWidth?(Te=!0,qe=Ie.stableFitMaxMinimapScale):Te=xe>ht}if(Ot==="fill"||Te){zt=!0;const xe=Et;Dt=Math.min(pt*nt,Math.max(1,Math.floor(1/Ne))),Gt&&Oe&&et<=Ie.stableFitRemainingWidth&&(qe=Ie.stableFitMaxMinimapScale),Et=Math.min(qe,Math.max(1,Math.floor(Dt/Jt))),Et>xe&&(At=Math.min(2,Et/xe)),ft=Et/nt/At,ht=Math.ceil(Math.max(gt,Tt+Lt+Fe)*Dt),Gt?(Ie.stableMinimapLayoutInput=ce,Ie.stableFitRemainingWidth=et,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const xt=Math.floor(Kt*ft),Ct=Math.min(xt,Math.max(0,Math.floor((et-Ut-2)*ft/(St+ft)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(nt*Ct);const Ft=Qe/nt;Qe=Math.floor(Qe*At);const Vt=Wt?1:2,Qt=Xt==="left"?0:Ve-Ct-Ut;return{renderMinimap:Vt,minimapLeft:Qt,minimapWidth:Ct,minimapHeightIsEditorHeight:zt,minimapIsSampling:qt,minimapScale:Et,minimapLineHeight:Dt,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:bt}}static computeLayout(ce,Ie){const Ve=Ie.outerWidth|0,Xe=Ie.outerHeight|0,nt=Ie.lineHeight|0,it=Ie.lineNumbersDigitCount|0,Oe=Ie.typicalHalfwidthCharacterWidth,pt=Ie.maxDigitWidth,St=Ie.pixelRatio,Nt=Ie.viewLineCount,Wt=ce.get(135),Et=Wt==="inherit"?ce.get(134):Wt,Kt=Et==="inherit"?ce.get(130):Et,Ot=ce.get(133),Xt=Ie.isDominatedByLongLines,Ut=ce.get(57),Lt=ce.get(67).renderType!==0,et=ce.get(68),Gt=ce.get(104),Jt=ce.get(83),ht=ce.get(72),bt=ce.get(102),zt=bt.verticalScrollbarSize,qt=bt.verticalHasArrows,Dt=bt.arrowSize,ft=bt.horizontalScrollbarSize,At=ce.get(43),xt=ce.get(109)!=="never";let Ct=ce.get(65);At&&xt&&(Ct+=16);let Qe=0;if(Lt){const st=Math.max(it,et);Qe=Math.round(st*pt)}let Ft=0;Ut&&(Ft=nt*Ie.glyphMarginDecorationLaneCount);let Vt=0,Qt=Vt+Ft,gt=Qt+Qe,Tt=gt+Ct;const Fe=Ve-Ft-Qe-Ct;let Ne=!1,Ce=!1,se=-1;Et==="inherit"&&Xt?(Ne=!0,Ce=!0):Kt==="on"||Kt==="bounded"?Ce=!0:Kt==="wordWrapColumn"&&(se=Ot);const Te=Y.c({outerWidth:Ve,outerHeight:Xe,lineHeight:nt,typicalHalfwidthCharacterWidth:Oe,pixelRatio:St,scrollBeyondLastLine:Gt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:ht,verticalScrollbarWidth:zt,viewLineCount:Nt,remainingWidth:Fe,isViewportWrapping:Ce},Ie.memory||new R);Te.renderMinimap!==0&&Te.minimapLeft===0&&(Vt+=Te.minimapWidth,Qt+=Te.minimapWidth,gt+=Te.minimapWidth,Tt+=Te.minimapWidth);const qe=Fe-Te.minimapWidth,xe=Math.max(1,Math.floor((qe-zt-2)/Oe)),Ke=qt?Dt:0;return Ce&&(se=Math.max(1,xe),Kt==="bounded"&&(se=Math.min(se,Ot))),{width:Ve,height:Xe,glyphMarginLeft:Vt,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:Qe,decorationsLeft:gt,decorationsWidth:Ct,contentLeft:Tt,contentWidth:qe,minimap:Te,viewportColumn:xe,isWordWrapMinified:Ne,isViewportWrapping:Ce,wrappingColumn:se,verticalScrollbarWidth:zt,horizontalScrollbarHeight:ft,overviewRuler:{top:Ke,width:zt,height:Xe-2*Ke,right:0}}}}e.EditorLayoutInfoComputer=Y;class he extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return u(ce,"simple",["simple","advanced"])}compute(ce,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}var _;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class we extends C{constructor(){const ce={enabled:_.On};super(64,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",enum:[_.Off,_.OnCode,_.On],default:ce.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:u(ce.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class oe extends C{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:u(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:u(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:f(Ie.padding,this.defaultValue.padding)}}}class W extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):r.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ie,Ve){return Ve<0?r.clampedInt(-Ve*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class re extends c{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>c.clamp(ce,0,150),{markdownDescription:b.localize(66,null)})}compute(ce,Ie,Ve){return ce.fontInfo.lineHeight}}class ye extends C{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ce.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(77,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),autohide:f(Ie.autohide,this.defaultValue.autohide),size:u(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(Ie.side,this.defaultValue.side,["right","left"]),showSlider:u(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ie.scale,1,1,3),maxColumn:r.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(ne){return ne==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{top:r.clampedInt(Ie.top,0,0,1e3),bottom:r.clampedInt(Ie.bottom,0,0,1e3)}}}class x extends C{constructor(){const ce={enabled:!0,cycle:!0};super(85,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(81,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),cycle:f(Ie.cycle,this.defaultValue.cycle)}}}class te extends S{constructor(){super(141)}compute(ce,Ie,Ve){return ce.pixelRatio}}class G extends C{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(82,null),b.localize(83,null),b.localize(84,null)]}];super(88,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ce.strings,description:b.localize(85,null)},comments:{anyOf:Ie,default:ce.comments,description:b.localize(86,null)},other:{anyOf:Ie,default:ce.other,description:b.localize(87,null)}},default:ce,markdownDescription:b.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const St=ce?"on":"off";return{comments:St,strings:St,other:St}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:Xe}=ce,nt=["on","inline","off"];let it,Oe,pt;return typeof Ie=="boolean"?it=Ie?"on":"off":it=u(Ie,this.defaultValue.other,nt),typeof Ve=="boolean"?Oe=Ve?"on":"off":Oe=u(Ve,this.defaultValue.comments,nt),typeof Xe=="boolean"?pt=Xe?"on":"off":pt=u(Xe,this.defaultValue.strings,nt),{other:it,comments:Oe,strings:pt}}}var ie;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(89,null),b.localize(90,null),b.localize(91,null),b.localize(92,null)],default:"on",description:b.localize(93,null)})}validate(ce){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ie=4,Ve=ce):ce==="interval"?Ie=3:ce==="relative"?Ie=2:ce==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function ve(ne){const ce=ne.get(97);return ce==="editable"?ne.get(90):ce!=="on"}e.filterValidationDecorations=ve;class Pe extends C{constructor(){const ce=[],Ie={type:"number",description:b.localize(94,null)};super(101,"rulers",ce,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(95,null),format:"color-hex"}}}]},default:ce,description:b.localize(96,null)})}validate(ce){if(Array.isArray(ce)){const Ie=[];for(const Ve of ce)if(typeof Ve=="number")Ie.push({column:r.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Xe=Ve;Ie.push({column:r.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return Ie.sort((Ve,Xe)=>Ve.column-Xe.column),Ie}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ne,ce){if(typeof ne!="string")return ce;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends C{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(97,null),b.localize(98,null),b.localize(99,null)],default:"auto",description:b.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(101,null),b.localize(102,null),b.localize(103,null)],default:"auto",description:b.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(108,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce,Ve=r.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=r.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ie.vertical,this.defaultValue.vertical),horizontal:De(Ie.horizontal,this.defaultValue.horizontal),useShadows:f(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:r.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:r.clampedInt(Ie.verticalSliderSize,Xe,0,1e3),scrollByPage:f(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(115,null)}})}applyUpdate(ce,Ie){let Ve=!1;Ie.allowedCharacters&&ce&&(O.$yn(ce.allowedCharacters,Ie.allowedCharacters)||(ce={...ce,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&ce&&(O.$yn(ce.allowedLocales,Ie.allowedLocales)||(ce={...ce,allowedLocales:Ie.allowedLocales},Ve=!0));const Xe=super.applyUpdate(ce,Ie);return Ve?new m(Xe.newValue,!0):Xe}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{nonBasicASCII:le(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:le(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:le(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ie){if(typeof ce!="object"||!ce)return Ie;const Ve={};for(const[Xe,nt]of Object.entries(ce))nt===!0&&(Ve[Xe]=!0);return Ve}}class ee extends C{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(117,null),b.localize(118,null),b.localize(119,null)],description:b.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(121,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),mode:u(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class V extends C{constructor(){const ce={enabled:I.$rs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$rs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(122,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(123,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends C{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:ce.bracketPairs,description:b.localize(127,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(128,null),b.localize(129,null),b.localize(130,null)],default:ce.bracketPairsHorizontal,description:b.localize(131,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(132,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(133,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(134,null),b.localize(135,null),b.localize(136,null)],default:ce.highlightActiveIndentation,description:b.localize(137,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{bracketPairs:le(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:le(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function le(ne,ce,Ie){const Ve=Ie.indexOf(ne);return Ve===-1?ce:Ie[Ve]}class Re extends C{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(138,null),b.localize(139,null)],default:ce.insertMode,description:b.localize(140,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(141,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(142,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(143,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(144,null),b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ce.selectionMode,markdownDescription:b.localize(148,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(149,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(150,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(151,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(152,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(153,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(154,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(155,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertMode:u(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ie.preview,this.defaultValue.preview),previewMode:u(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ie.showMethods,this.defaultValue.showMethods),showFunctions:f(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ie.showFields,this.defaultValue.showFields),showVariables:f(Ie.showVariables,this.defaultValue.showVariables),showClasses:f(Ie.showClasses,this.defaultValue.showClasses),showStructs:f(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ie.showModules,this.defaultValue.showModules),showProperties:f(Ie.showProperties,this.defaultValue.showProperties),showEvents:f(Ie.showEvents,this.defaultValue.showEvents),showOperators:f(Ie.showOperators,this.defaultValue.showOperators),showUnits:f(Ie.showUnits,this.defaultValue.showUnits),showValues:f(Ie.showValues,this.defaultValue.showValues),showConstants:f(Ie.showConstants,this.defaultValue.showConstants),showEnums:f(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ie.showKeywords,this.defaultValue.showKeywords),showWords:f(Ie.showWords,this.defaultValue.showWords),showColors:f(Ie.showColors,this.defaultValue.showColors),showFiles:f(Ie.showFiles,this.defaultValue.showFiles),showReferences:f(Ie.showReferences,this.defaultValue.showReferences),showFolders:f(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ie.showUsers,this.defaultValue.showUsers),showIssues:f(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(186,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(187,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Je extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(188,null),b.localize(189,null),b.localize(190,null),b.localize(191,null)],description:b.localize(192,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ie,Ve){return Ie.get(2)===2?0:Ve}}class _e extends S{constructor(){super(144)}compute(ce,Ie,Ve){const Xe=Ie.get(143);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class ct extends C{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(193,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showDropSelector:u(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends C{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(197,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(198,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(199,null),b.localize(200,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showPasteSelector:u(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Ae:g.$k?Ue:rt,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ye;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.letterSpacing=63]="letterSpacing",ne[ne.lightbulb=64]="lightbulb",ne[ne.lineDecorationsWidth=65]="lineDecorationsWidth",ne[ne.lineHeight=66]="lineHeight",ne[ne.lineNumbers=67]="lineNumbers",ne[ne.lineNumbersMinChars=68]="lineNumbersMinChars",ne[ne.linkedEditing=69]="linkedEditing",ne[ne.links=70]="links",ne[ne.matchBrackets=71]="matchBrackets",ne[ne.minimap=72]="minimap",ne[ne.mouseStyle=73]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=75]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=77]="multiCursorModifier",ne[ne.multiCursorPaste=78]="multiCursorPaste",ne[ne.multiCursorLimit=79]="multiCursorLimit",ne[ne.occurrencesHighlight=80]="occurrencesHighlight",ne[ne.overviewRulerBorder=81]="overviewRulerBorder",ne[ne.overviewRulerLanes=82]="overviewRulerLanes",ne[ne.padding=83]="padding",ne[ne.pasteAs=84]="pasteAs",ne[ne.parameterHints=85]="parameterHints",ne[ne.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=88]="quickSuggestions",ne[ne.quickSuggestionsDelay=89]="quickSuggestionsDelay",ne[ne.readOnly=90]="readOnly",ne[ne.readOnlyMessage=91]="readOnlyMessage",ne[ne.renameOnType=92]="renameOnType",ne[ne.renderControlCharacters=93]="renderControlCharacters",ne[ne.renderFinalNewline=94]="renderFinalNewline",ne[ne.renderLineHighlight=95]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=97]="renderValidationDecorations",ne[ne.renderWhitespace=98]="renderWhitespace",ne[ne.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ne[ne.roundedSelection=100]="roundedSelection",ne[ne.rulers=101]="rulers",ne[ne.scrollbar=102]="scrollbar",ne[ne.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=104]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=105]="scrollPredominantAxis",ne[ne.selectionClipboard=106]="selectionClipboard",ne[ne.selectionHighlight=107]="selectionHighlight",ne[ne.selectOnLineNumbers=108]="selectOnLineNumbers",ne[ne.showFoldingControls=109]="showFoldingControls",ne[ne.showUnused=110]="showUnused",ne[ne.snippetSuggestions=111]="snippetSuggestions",ne[ne.smartSelect=112]="smartSelect",ne[ne.smoothScrolling=113]="smoothScrolling",ne[ne.stickyScroll=114]="stickyScroll",ne[ne.stickyTabStops=115]="stickyTabStops",ne[ne.stopRenderingLineAfter=116]="stopRenderingLineAfter",ne[ne.suggest=117]="suggest",ne[ne.suggestFontSize=118]="suggestFontSize",ne[ne.suggestLineHeight=119]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ne[ne.suggestSelection=121]="suggestSelection",ne[ne.tabCompletion=122]="tabCompletion",ne[ne.tabIndex=123]="tabIndex",ne[ne.unicodeHighlighting=124]="unicodeHighlighting",ne[ne.unusualLineTerminators=125]="unusualLineTerminators",ne[ne.useShadowDOM=126]="useShadowDOM",ne[ne.useTabStops=127]="useTabStops",ne[ne.wordBreak=128]="wordBreak",ne[ne.wordSeparators=129]="wordSeparators",ne[ne.wordWrap=130]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=133]="wordWrapColumn",ne[ne.wordWrapOverride1=134]="wordWrapOverride1",ne[ne.wordWrapOverride2=135]="wordWrapOverride2",ne[ne.wrappingIndent=136]="wrappingIndent",ne[ne.wrappingStrategy=137]="wrappingStrategy",ne[ne.showDeprecated=138]="showDeprecated",ne[ne.inlayHints=139]="inlayHints",ne[ne.editorClassName=140]="editorClassName",ne[ne.pixelRatio=141]="pixelRatio",ne[ne.tabFocusMode=142]="tabFocusMode",ne[ne.layoutInfo=143]="layoutInfo",ne[ne.wrappingInfo=144]="wrappingInfo",ne[ne.defaultColorDecorators=145]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(201,null)})),acceptSuggestionOnEnter:Le(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(202,null),""],markdownDescription:b.localize(203,null)})),accessibilitySupport:Le(new d),accessibilityPageSize:Le(new r(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(204,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(205,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(206,null),tags:["accessibility"]})),autoClosingBrackets:Le(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingComments:Le(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(210,null),b.localize(211,null),""],description:b.localize(212,null)})),autoClosingDelete:Le(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(213,null),""],description:b.localize(214,null)})),autoClosingOvertype:Le(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(215,null),""],description:b.localize(216,null)})),autoClosingQuotes:Le(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(217,null),b.localize(218,null),""],description:b.localize(219,null)})),autoIndent:Le(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[b.localize(220,null),b.localize(221,null),b.localize(222,null),b.localize(223,null),b.localize(224,null)],description:b.localize(225,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(226,null),b.localize(227,null),b.localize(228,null),""],description:b.localize(229,null)})),bracketPairColorization:Le(new V),bracketPairGuides:Le(new ae),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:b.localize(230,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(231,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(232,null)})),codeLensFontSize:Le(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(233,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(234,null)})),colorDecoratorActivatedOn:Le(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),colorDecoratorsLimit:Le(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(239,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(240,null)})),comments:Le(new k),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(241,null)})),cursorBlinking:Le(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:b.localize(242,null)})),cursorSmoothCaretAnimation:Le(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(243,null),b.localize(244,null),b.localize(245,null)],description:b.localize(246,null)})),cursorStyle:Le(new l(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:b.localize(247,null)})),cursorSurroundingLines:Le(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(248,null)})),cursorSurroundingLinesStyle:Le(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(249,null),b.localize(250,null)],markdownDescription:b.localize(251,null)})),cursorWidth:Le(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(252,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(253,null)})),emptySelectionClipboard:Le(new U),dropIntoEditor:Le(new ct),stickyScroll:Le(new oe),experimentalWhitespaceRendering:Le(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(254,null),b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(258,null)})),find:Le(new N),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(259,null)})),foldingStrategy:Le(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(260,null),b.localize(261,null)],description:b.localize(262,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(263,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(264,null)})),foldingMaximumRegions:Le(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(265,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(266,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(267,null)})),fontInfo:Le(new M),fontLigatures2:Le(new j),fontSize:Le(new B),fontWeight:Le(new X),fontVariations:Le(new F),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(268,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(269,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(270,null)})),gotoLocation:Le(new ue),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(271,null)})),hover:Le(new Z),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new c(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:b.localize(272,null)})),lightbulb:Le(new we),lineDecorationsWidth:Le(new W),lineHeight:Le(new re),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:b.localize(273,null)})),links:Le(new o(70,"links",!0,{description:b.localize(274,null)})),matchBrackets:Le(new s(71,"matchBrackets","always",["always","near","never"],{description:b.localize(275,null)})),minimap:Le(new ye),mouseStyle:Le(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(74,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(276,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:g.$j?b.localize(277,null):b.localize(278,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(279,null)})),multiCursorModifier:Le(new l(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[b.localize(280,null),b.localize(281,null)],markdownDescription:b.localize(282,null)})),multiCursorPaste:Le(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),multiCursorLimit:Le(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(286,null)})),occurrencesHighlight:Le(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(287,null),b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:b.localize(291,null)})),overviewRulerLanes:Le(new r(82,"overviewRulerLanes",3,0,3)),padding:Le(new ge),pasteAs:Le(new ot),parameterHints:Le(new x),peekWidgetDefaultFocus:Le(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(292,null),b.localize(293,null)],description:b.localize(294,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(295,null)})),quickSuggestions:Le(new G),quickSuggestionsDelay:Le(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(296,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new o(92,"renameOnType",!1,{description:b.localize(297,null),markdownDeprecationMessage:b.localize(298,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:b.localize(299,null),restricted:!0})),renderFinalNewline:Le(new s(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(300,null)})),renderLineHighlight:Le(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(301,null)],description:b.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(303,null)})),renderValidationDecorations:Le(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(304,null),b.localize(305,null),b.localize(306,null),""],description:b.localize(307,null)})),revealHorizontalRightPadding:Le(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:b.localize(308,null)})),rulers:Le(new Pe),scrollbar:Le(new z),scrollBeyondLastColumn:Le(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(309,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(310,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:b.localize(311,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:b.localize(312,null),included:g.$k})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:b.localize(313,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(314,null),b.localize(315,null),b.localize(316,null)],description:b.localize(317,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:b.localize(318,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:b.localize(319,null)})),inlayHints:Le(new K),snippetSuggestions:Le(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(320,null),b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),smartSelect:Le(new je),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:b.localize(325,null)})),stopRenderingLineAfter:Le(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Re),inlineSuggest:Le(new ee),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(326,null)})),suggestFontSize:Le(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(329,null)})),suggestSelection:Le(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabCompletion:Le(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),tabIndex:Le(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Q),unusualLineTerminators:Le(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:b.localize(342,null)})),wordBreak:Le(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),wordSeparators:Le(new t(129,"wordSeparators",L.$ss,{description:b.localize(346,null)})),wordWrap:Le(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null),b.localize(350,null)],description:b.localize(351,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(352,null)})),wordWrapOverride1:Le(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new T),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(353,null)})),pixelRatio:Le(new te),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(354,null)})),layoutInfo:Le(new Y),wrappingInfo:Le(new _e),wrappingIndent:Le(new Je),wrappingStrategy:Le(new he)}}),define(ke[195],Se([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Lt=e.$Kt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Jt=e.$It=e.SymbolKinds=e.SymbolTag=e.$Ht=e.$Gt=e.SymbolKind=e.$Ft=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Et=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Dt=e.$Ct=e.$Bt=void 0;class ${constructor(j,F,M){this.offset=j,this.type=F,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Bt=$;class y{constructor(j,F){this.tokens=j,this.endState=F,this._tokenizationResultBrand=void 0}}e.$Ct=y;class R{constructor(j,F){this.tokens=j,this.endState=F,this._encodedTokenizationResultBrand=void 0}}e.$Dt=R;var C;(function(N){N[N.Method=0]="Method",N[N.Function=1]="Function",N[N.Constructor=2]="Constructor",N[N.Field=3]="Field",N[N.Variable=4]="Variable",N[N.Class=5]="Class",N[N.Struct=6]="Struct",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Event=10]="Event",N[N.Operator=11]="Operator",N[N.Unit=12]="Unit",N[N.Value=13]="Value",N[N.Constant=14]="Constant",N[N.Enum=15]="Enum",N[N.EnumMember=16]="EnumMember",N[N.Keyword=17]="Keyword",N[N.Text=18]="Text",N[N.Color=19]="Color",N[N.File=20]="File",N[N.Reference=21]="Reference",N[N.Customcolor=22]="Customcolor",N[N.Folder=23]="Folder",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue",N[N.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(N){const j=new Map;j.set(0,D.$$j.symbolMethod),j.set(1,D.$$j.symbolFunction),j.set(2,D.$$j.symbolConstructor),j.set(3,D.$$j.symbolField),j.set(4,D.$$j.symbolVariable),j.set(5,D.$$j.symbolClass),j.set(6,D.$$j.symbolStruct),j.set(7,D.$$j.symbolInterface),j.set(8,D.$$j.symbolModule),j.set(9,D.$$j.symbolProperty),j.set(10,D.$$j.symbolEvent),j.set(11,D.$$j.symbolOperator),j.set(12,D.$$j.symbolUnit),j.set(13,D.$$j.symbolValue),j.set(15,D.$$j.symbolEnum),j.set(14,D.$$j.symbolConstant),j.set(15,D.$$j.symbolEnum),j.set(16,D.$$j.symbolEnumMember),j.set(17,D.$$j.symbolKeyword),j.set(27,D.$$j.symbolSnippet),j.set(18,D.$$j.symbolText),j.set(19,D.$$j.symbolColor),j.set(20,D.$$j.symbolFile),j.set(21,D.$$j.symbolReference),j.set(22,D.$$j.symbolCustomColor),j.set(23,D.$$j.symbolFolder),j.set(24,D.$$j.symbolTypeParameter),j.set(25,D.$$j.account),j.set(26,D.$$j.issues);function F(X){let ue=j.get(X);return ue||(console.info("No codicon found for CompletionItemKind "+X),ue=D.$$j.symbolProperty),ue}N.toIcon=F;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function B(X,ue){let Z=M.get(X);return typeof Z>"u"&&!ue&&(Z=9),Z}N.fromString=B})(m||(e.CompletionItemKinds=m={}));var v;(function(N){N[N.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var S;(function(N){N[N.None=0]="None",N[N.KeepWhitespace=1]="KeepWhitespace",N[N.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var h;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(e.CompletionTriggerKind=h={}));var f;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class o{constructor(j,F,M,B){this.range=j,this.text=F,this.completionKind=M,this.isSnippetText=B}equals(j){return I.$Ts.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$Et=o;var i;(function(N){N[N.Invoke=1]="Invoke",N[N.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function c(N){return N&&O.URI.isUri(N.uri)&&I.$Ts.isIRange(N.range)&&(I.$Ts.isIRange(N.originSelectionRange)||I.$Ts.isIRange(N.targetSelectionRange))}e.$Ft=c;var t;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Gt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function u(N,j){return(0,b.localize)(26,null,N,e.$Gt[j])}e.$Ht=u;var s;(function(N){N[N.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var l;(function(N){const j=new Map;j.set(0,D.$$j.symbolFile),j.set(1,D.$$j.symbolModule),j.set(2,D.$$j.symbolNamespace),j.set(3,D.$$j.symbolPackage),j.set(4,D.$$j.symbolClass),j.set(5,D.$$j.symbolMethod),j.set(6,D.$$j.symbolProperty),j.set(7,D.$$j.symbolField),j.set(8,D.$$j.symbolConstructor),j.set(9,D.$$j.symbolEnum),j.set(10,D.$$j.symbolInterface),j.set(11,D.$$j.symbolFunction),j.set(12,D.$$j.symbolVariable),j.set(13,D.$$j.symbolConstant),j.set(14,D.$$j.symbolString),j.set(15,D.$$j.symbolNumber),j.set(16,D.$$j.symbolBoolean),j.set(17,D.$$j.symbolArray),j.set(18,D.$$j.symbolObject),j.set(19,D.$$j.symbolKey),j.set(20,D.$$j.symbolNull),j.set(21,D.$$j.symbolEnumMember),j.set(22,D.$$j.symbolStruct),j.set(23,D.$$j.symbolEvent),j.set(24,D.$$j.symbolOperator),j.set(25,D.$$j.symbolTypeParameter);function F(M){let B=j.get(M);return B||(console.info("No codicon found for SymbolKind "+M),B=D.$$j.symbolProperty),B}N.toIcon=F})(l||(e.SymbolKinds=l={}));class a{static asEditOperation(j){return g.$Us.replace(I.$Ts.lift(j.range),j.text)}}e.$It=a;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(j){switch(j){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(j)}constructor(j){this.value=j}}e.$Jt=d;var k;(function(N){function j(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}N.is=j})(k||(e.Command=k={}));var P;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(P||(e.CommentThreadCollapsibleState=P={}));var p;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(p||(e.CommentThreadState=p={}));var w;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(w||(e.CommentMode=w={}));var E;(function(N){N[N.Published=0]="Published",N[N.Draft=1]="Draft"})(E||(e.CommentState=E={}));var A;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(A||(e.InlayHintKind=A={}));class T{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Kt=T,e.$Lt=new L.$st;var U;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(U||(e.ExternalUriOpenerPriority=U={}))}),define(ke[196],Se([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[225],Se([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[226],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,14,198]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,O.localize)(0,null,y[0]);case 2:return(0,O.localize)(1,null,y[0],y[1]);case 3:return(0,O.localize)(2,null,y[0],y[1],y[2]);default:return}}const L=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const C=this.d,m=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:R}),this.f.push(v)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,C=!1,m=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const S=this.c.charCodeAt(R);if(C)C=!1;else if(S===47&&!m){R++;break}else S===91?m=!0:S===92?C=!0:S===93&&(m=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Zi=$}),define(ke[237],Se([1,0,23,39,201,385]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||L.test(o)}e.$_o=$;function y(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$ap=y;function R(o){if(!o)return null;const i=o.majorBase,r=o.majorMustEqual,n=o.minorBase;let c=o.minorMustEqual;const t=o.patchBase;let u=o.patchMustEqual;o.hasCaret&&(i===0||(c=!1),u=!1);let s=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,a,d,k]=l;s=Date.UTC(Number(a),Number(d)-1,Number(k))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:c,patchBase:t,patchMustEqual:u,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$bp=R;function C(o,i,r){let n;typeof o=="string"?n=R(y(o)):n=o;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof r=="string"?t=R(y(r)):t=r,!n||!t)return!1;const u=n.majorBase,s=n.minorBase,l=n.patchBase;let a=t.majorBase,d=t.minorBase,k=t.patchBase;const P=t.notBefore;let p=t.majorMustEqual,w=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?u>a?!0:u<a?!1:s>d?!0:s<d||c&&c<P?!1:l>=k:(u===1&&a===0&&(!p||!w||!E)&&(a=1,d=0,k=0,p=!0,w=!1,E=!1),u<a?!1:u>a?!p:s<d?!1:s>d?!w:l<k?!1:l>k?!E:!(c&&c<P))}e.$cp=C;function m(o,i,r,n,c){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([O.default.Error,g.localize(0,null)]),t;if(typeof n.name!="string")return t.push([O.default.Error,g.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([O.default.Error,g.localize(2,null,"version")]),t;if(!n.engines)return t.push([O.default.Error,g.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([O.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!f(n.extensionDependencies))return t.push([O.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!f(n.activationEvents))return t.push([O.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([O.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([O.default.Warning,g.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([O.default.Error,g.localize(9,null,"main")]),t;{const l=(0,D.$Gg)(r,n.main);(0,D.$Ag)(l,r)||t.push([O.default.Warning,g.localize(10,null,l.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([O.default.Error,g.localize(11,null,"browser")]),t;{const l=(0,D.$Gg)(r,n.browser);(0,D.$Ag)(l,r)||t.push([O.default.Warning,g.localize(12,null,l.path,r.path)])}}if(!I.valid(n.version))return t.push([O.default.Error,g.localize(13,null)]),t;const u=[];if(!v(o,i,n,c,u))for(const l of u)t.push([O.default.Error,l]);return t}e.$dp=m;function v(o,i,r,n,c){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:h(o,i,r.engines.vscode,c)}e.$ep=v;function S(o,i,r){return o==="*"||h(i,r,o)}e.$fp=S;function h(o,i,r,n=[]){const c=R(y(r));if(!c)return n.push(g.localize(14,null,r)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return n.push(g.localize(15,null,r)),!1}else if(!c.majorMustEqual)return n.push(g.localize(16,null,r)),!1;return C(o,i,c)?!0:(n.push(g.localize(17,null,o,r)),!1)}function f(o){if(!Array.isArray(o))return!1;for(let i=0,r=o.length;i<r;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class D{constructor(g,I=[],L=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=L}}e.$2h=D}),define(ke[106],Se([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.InstantiationType=void 0;const O=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(b,$,y){$ instanceof D.$2h||($=new D.$2h($,[],!!y)),O.push([b,$])}e.$Xr=I;function L(){return O}e.$Yr=L}),define(ke[238],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class D{constructor(I,L){this.key=I,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Bq=D;class O{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const L of this.a.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const b=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(L);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(I){const L=this.b(I);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(I){const L=this.b(I);let b=this.a.get(L);return b||(b=new D(L,I),this.a.set(L,b)),b}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[L,b]of this.a)I.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,L]of this.a){const b=new Set([I]),$=this.c(L,b);if($)return $}}c(I,L){for(const[b,$]of I.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const y=this.c($,L);if(y)return y;L.delete(b)}}}e.$Cq=O}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function b($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=b})(D||(e._util=D={})),e.$4h=g("instantiationService");function O(L,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:L,index:$}):(b[D.DI_DEPENDENCIES]=[{id:L,index:$}],b[D.DI_TARGET]=b)}function g(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const b=function($,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,$,R)};return b.toString=()=>L,D.serviceIds.set(L,b),b}e.$5h=g;function I(L){return L}e.$6h=I}),define(ke[45],Se([1,0,18,2,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.ConfigurationTarget=e.$Ai=e.$zi=e.$yi=void 0,e.$yi=(0,g.$5h)("configurationService");function I(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}e.$zi=I;function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}e.$Ai=L;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Bi=$;function y(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Ci=y;function R(o,i){const r=Object.create(null);for(const n in o)C(r,n,o[n],i);return r}e.$Di=R;function C(o,i,r,n){const c=i.split("."),t=c.pop();let u=o;for(let s=0;s<c.length;s++){const l=c[s];let a=u[l];switch(typeof a){case"undefined":a=u[l]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${c.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}u=a}if(typeof u=="object"&&u!==null)try{u[t]=r}catch{n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(u)}`)}e.$Ei=C;function m(o,i){const r=i.split(".");v(o,r)}e.$Fi=m;function v(o,i){const r=i.shift();if(i.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const n=o[r];typeof n=="object"&&!Array.isArray(n)&&(v(n,i),Object.keys(n).length===0&&delete o[r])}}function S(o,i,r){function n(u,s){let l=u;for(const a of s){if(typeof l!="object"||l===null)return;l=l[a]}return l}const c=i.split("."),t=n(o,c);return typeof t>"u"?r:t}e.$Gi=S;function h(o,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?D.$Jf(o[n])&&D.$Jf(i[n])?h(o[n],i[n],r):r&&(o[n]=i[n]):o[n]=i[n])})}e.$Hi=h;function f(o){return o.replace(/[\[\]]/g,"")}e.$Ii=f}),define(ke[46],Se([1,0,10,12,236,5,197,14]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.ContextKeyExprType=e.$1i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(K,W){if($.get(K)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,W)}e.$1i=y;const R=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},v=(0,L.localize)(0,null),S=(0,L.localize)(1,null),h=(0,L.localize)(2,null),f=(0,L.localize)(3,null),o=(0,L.localize)(4,null),i=(0,L.localize)(5,null),r=(0,L.localize)(6,null),n=(0,L.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=m){this.k=W,this.d=new g.$Zi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:g.$Zi.getLexeme(ye),additionalInfo:de}),c.c}return re}catch(re){if(re!==c.c)throw re;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const re=this.o();W.push(re)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const re=this.s();W.push(re)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,f),re?.negate()}case 17:return this.z(),A.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const re=this.l();return this.A(1,f),re}case 17:{const re=W.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const ge=de.lexeme,x=ge.lastIndexOf("/"),te=x===ge.length-1?void 0:this.w(ge.substring(x+1));let G;try{G=new RegExp(ge.substring(1,x),te)}catch{throw this.B("REGEX",de)}return M.create(re,G)}switch(de.type){case 10:case 19:{const ge=[de.lexeme];this.z();let x=this.D(),te=0;for(let Pe=0;Pe<de.lexeme.length;Pe++)de.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Pe=0;Pe<x.lexeme.length;Pe++)x.lexeme.charCodeAt(Pe)===40?te++:de.lexeme.charCodeAt(Pe)===41&&te--}if(te<0)break;ge.push(g.$Zi.getLexeme(x)),this.z(),x=this.D()}const G=ge.join(""),ie=G.lastIndexOf("/"),fe=ie===G.length-1?void 0:this.w(G.substring(ie+1));let ve;try{ve=new RegExp(G.substring(1,ie),fe)}catch{throw this.B("REGEX",de)}return t.regex(re,ve)}case 18:{const ge=de.lexeme;this.z();let x=null;if(!(0,O.$Ie)(ge)){const te=ge.indexOf("/"),G=ge.lastIndexOf("/");if(te!==G&&te>=0){const ie=ge.slice(te+1,G),fe=ge[G+1]==="i"?"i":"";try{x=new RegExp(ie,fe)}catch{throw this.B("REGEX",de)}}}if(x===null)throw this.B("REGEX",de);return M.create(re,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const de=this.u();return t.notIn(re,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(re,de);switch(de){case"true":return t.has(re);case"false":return t.not(re);default:return t.equals(re,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(re,de);switch(de){case"true":return t.not(re);case"false":return t.has(re);default:return t.notEquals(re,de)}}case 5:return this.z(),j.create(re,this.u());case 6:return this.z(),F.create(re,this.u());case 7:return this.z(),U.create(re,this.u());case 8:return this.z(),N.create(re,this.u());case 13:return this.z(),t.in(re,this.u());default:return t.has(re)}}case 20:throw this.h.push({message:r,offset:W.offset,lexeme:"",additionalInfo:n}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,re){if(this.C(W))return this.z();throw this.B(re,this.D())}B(W,re,ye){const de=(0,L.localize)(8,null,W,g.$Zi.getLexeme(re)),ge=re.offset,x=g.$Zi.getLexeme(re);return this.h.push({message:de,offset:ge,lexeme:x,additionalInfo:ye}),c.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$2i=c;class t{static false(){return a.INSTANCE}static true(){return d.INSTANCE}static has(W){return k.create(W)}static equals(W,re){return P.create(W,re)}static notEquals(W,re){return E.create(W,re)}static regex(W,re){return M.create(W,re)}static in(W,re){return p.create(W,re)}static notIn(W,re){return w.create(W,re)}static not(W){return A.create(W)}static and(...W){return ue.create(W,null,!0)}static or(...W){return Z.create(W,null,!0)}static greater(W,re){return U.create(W,re)}static greaterEquals(W,re){return N.create(W,re)}static smaller(W,re){return j.create(W,re)}static smallerEquals(W,re){return F.create(W,re)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$3i=t;function u(K){const W=new c({regexParsingWithErrorRecovery:!1});return K.map(re=>(W.parse(re),W.lexingErrors.length>0?W.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,L.localize)(9,null,ye.additionalInfo):(0,L.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$4i=u;function s(K,W){const re=K?K.substituteConstants():void 0,ye=W?W.substituteConstants():void 0;return!re&&!ye?!0:!re||!ye?!1:re.equals(ye)}e.$5i=s;function l(K,W){return K.cmp(W)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return d.INSTANCE}}e.$6i=a;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return a.INSTANCE}}e.$7i=d;class k{static create(W,re=null){const ye=$.get(W);return typeof ye=="boolean"?ye?d.INSTANCE:a.INSTANCE:new k(W,re)}constructor(W,re){this.key=W,this.c=re,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:Y(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=$.get(this.key);return typeof W=="boolean"?W?d.INSTANCE:a.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$8i=k;class P{static create(W,re,ye=null){if(typeof re=="boolean")return re?k.create(W,ye):A.create(W,ye);const de=$.get(W);return typeof de=="boolean"?re===(de?"true":"false")?d.INSTANCE:a.INSTANCE:new P(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?d.INSTANCE:a.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$9i=P;class p{static create(W,re){return new p(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:he(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.f),ye=W.getValue(this.d);return Array.isArray(re)?re.includes(ye):typeof ye=="string"&&typeof re=="object"&&re!==null?R.call(re,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$0i=p;class w{static create(W,re){return new w(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=11,this.c=p.create(W,re)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$$i=w;class E{static create(W,re,ye=null){if(typeof re=="boolean")return re?A.create(W,ye):k.create(W,ye);const de=$.get(W);return typeof de=="boolean"?re===(de?"true":"false")?a.INSTANCE:d.INSTANCE:new E(W,re,ye)}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=$.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?a.INSTANCE:d.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$_i=E;class A{static create(W,re=null){const ye=$.get(W);return typeof ye=="boolean"?ye?a.INSTANCE:d.INSTANCE:new A(W,re)}constructor(W,re){this.c=W,this.d=re,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:Y(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=$.get(this.c);return typeof W=="boolean"?W?a.INSTANCE:d.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$aj=A;function T(K,W){if(typeof K=="string"){const re=parseFloat(K);isNaN(re)||(K=re)}return typeof K=="string"||typeof K=="number"?W(K):a.INSTANCE}class U{static create(W,re,ye=null){return T(re,de=>new U(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$bj=U;class N{static create(W,re,ye=null){return T(re,de=>new N(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$cj=N;class j{static create(W,re,ye=null){return T(re,de=>new j(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$dj=j;class F{static create(W,re,ye=null){return T(re,de=>new F(W,de,ye))}constructor(W,re,ye){this.c=W,this.d=re,this.f=ye,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:he(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$ej=F;class M{static create(W,re){return new M(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return re<ye?-1:re>ye?1:0}equals(W){if(W.type===this.type){const re=this.f?this.f.source:"",ye=W.f?W.f.source:"";return this.d===W.d&&re===ye}return!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$fj=M;class B{static create(W){return new B(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new B(this.c.map(W))}negate(){return this.c}}e.$gj=B;function X(K){let W=null;for(let re=0,ye=K.length;re<ye;re++){const de=K[re].substituteConstants();if(K[re]!==de&&W===null){W=[];for(let ge=0;ge<re;ge++)W[ge]=K[ge]}W!==null&&(W[re]=de)}return W===null?K:W}class ue{static create(W,re,ye){return ue.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=l(this.expr[re],W.expr[re]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:ue.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].evaluate(W))return!1;return!0}static d(W,re,ye){const de=[];let ge=!1;for(const x of W)if(x){if(x.type===1){ge=!0;continue}if(x.type===0)return a.INSTANCE;if(x.type===6){de.push(...x.expr);continue}de.push(x)}if(de.length===0&&ge)return d.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(l);for(let x=1;x<de.length;x++)de[x-1].equals(de[x])&&(de.splice(x,1),x--);if(de.length===1)return de[0];for(;de.length>1;){const x=de[de.length-1];if(x.type!==9)break;de.pop();const te=de.pop(),G=de.length===0,ie=Z.create(x.expr.map(fe=>ue.create([fe,te],null,ye)),null,G);ie&&(de.push(ie),de.sort(l))}if(de.length===1)return de[0];if(ye){for(let x=0;x<de.length;x++)for(let te=x+1;te<de.length;te++)if(de[x].negate().equals(de[te]))return a.INSTANCE;if(de.length===1)return de[0]}return new ue(de,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new ue(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());this.c=Z.create(W,this,!0)}return this.c}}e.$hj=ue;class Z{static create(W,re,ye){return Z.d(W,re,ye)}constructor(W,re){this.expr=W,this.c=re,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,ye=this.expr.length;re<ye;re++){const de=l(this.expr[re],W.expr[re]);if(de!==0)return de}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,ye=this.expr.length;re<ye;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:Z.create(W,this.c,!1)}evaluate(W){for(let re=0,ye=this.expr.length;re<ye;re++)if(this.expr[re].evaluate(W))return!0;return!1}static d(W,re,ye){let de=[],ge=!1;if(W){for(let x=0,te=W.length;x<te;x++){const G=W[x];if(G){if(G.type===0){ge=!0;continue}if(G.type===1)return d.INSTANCE;if(G.type===9){de=de.concat(G.expr);continue}de.push(G)}}if(de.length===0&&ge)return a.INSTANCE;de.sort(l)}if(de.length!==0){if(de.length===1)return de[0];for(let x=1;x<de.length;x++)de[x-1].equals(de[x])&&(de.splice(x,1),x--);if(de.length===1)return de[0];if(ye){for(let x=0;x<de.length;x++)for(let te=x+1;te<de.length;te++)if(de[x].negate().equals(de[te]))return d.INSTANCE;if(de.length===1)return de[0]}return new Z(de,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new Z(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());for(;W.length>1;){const re=W.shift(),ye=W.shift(),de=[];for(const ge of oe(re))for(const x of oe(ye))de.push(ue.create([ge,x],null,!1));W.unshift(Z.create(de,null,!1))}this.c=Z.create(W,this,!0)}return this.c}}e.$ij=Z;class J extends k{static{this.d=[]}static all(){return J.d.values()}constructor(W,re,ye){super(W,null),this.f=re,typeof ye=="object"?J.d.push({...ye,key:W}):ye!==!0&&J.d.push({key:W,description:ye,type:re!=null?typeof re:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return P.create(this.key,W)}notEqualsTo(W){return E.create(this.key,W)}}e.$jj=J,e.$kj=(0,I.$5h)("contextKeyService");function Y(K,W){return K<W?-1:K>W?1:0}function he(K,W,re,ye){return K<re?-1:K>re?1:W<ye?-1:W>ye?1:0}function _(K,W){if(K.type===0||W.type===1)return!0;if(K.type===9)return W.type===9?we(K.expr,W.expr):!1;if(W.type===9){for(const re of W.expr)if(_(K,re))return!0;return!1}if(K.type===6){if(W.type===6)return we(W.expr,K.expr);for(const re of K.expr)if(_(re,W))return!0;return!1}return K.equals(W)}e.$lj=_;function we(K,W){let re=0,ye=0;for(;re<K.length&&ye<W.length;){const de=K[re].cmp(W[ye]);if(de<0)return!1;de===0&&re++,ye++}return re===K.length}function oe(K){return K.type===9?K.expr:[K]}}),define(ke[239],Se([1,0,23,39,199,5,102,10,24]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.ConfirmResult=e.$7v=e.$6v=e.$5v=void 0,e.$5v=(0,I.$5h)("dialogService");var y;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(y||(y={}));class R{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,o){const i=[];switch(o){case y.Confirmation:{const r=f;r.primaryButton?i.push(r.primaryButton):i.push((0,g.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const r=f;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const r=f;r.primaryButton?i.push(r.primaryButton):i.push((0,g.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===O.default.Info?"info":f===O.default.Error?"error":f===O.default.Warning?"warning":"none"}f(f,o,i){const r=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&r.push(f.cancelButton);let n=r[o]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$6v=R,e.$7v=(0,I.$5h)("fileDialogService");var C;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function v(h){const f=[];return f.push(...h.slice(0,m).map(o=>typeof o=="string"?o:(0,D.$Dg)(o))),h.length>m&&(h.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,h.length-m))),f.push(""),f.join(`
`)}e.$8v=v;function S(h,f){const o=(0,$.$un)(h);let i=(o.buttons??[]).map(t=>(0,L.$2v)(t)),r=(h.buttons||[]).map((t,u)=>u),n=0,c=o.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const u=r[c];r.splice(c,1),r.splice(1,0,u),c=1}b.$k&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(c=n-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const u=r[c];r.splice(c,1),r.push(u),c=i.length-1}}return o.buttons=i,o.defaultId=n,o.cancelId=c,o.noLink=!0,o.title=o.title||f.nameLong,{options:o,buttonIndeces:r}}e.$9v=S}),define(ke[133],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=void 0,e.$_h=(0,D.$5h)("environmentService"),e.$ai=(0,D.$6h)(e.$_h)}),define(ke[134],Se([1,0,200,5]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$xo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=void 0,e.$lo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$mo=new RegExp(e.$lo),e.$no="__web_extension",e.$oo="skipWalkthrough",e.$po="extensionsSync",e.$qo="dependecyOrPackExtensionInstall";function g(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ro=g;function I(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$so=I;function L(o,i){switch(o){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$to=L;function b(o,i){return i==="web"&&!o.includes("web")}e.$uo=b;function $(o,i,r){return b(i,r)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===r}e.$vo=$;function y(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$wo=y;var R;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(o){o.Install="install",o.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var v;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$xo=(0,O.$5h)("extensionGalleryService");var S;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var h;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(h||(e.ExtensionSignaturetErrorCode=h={}));class f extends Error{constructor(i,r){super(i),this.code=r,this.name=r}}e.$yo=f,e.$zo=(0,O.$5h)("extensionManagementService"),e.$Ao="extensionsIdentifiers/disabled",e.$Bo="extensionsIdentifiers/enabled",e.$Co=(0,O.$5h)("IGlobalExtensionEnablementService"),e.$Do=(0,O.$5h)("IExtensionTipsService"),e.$Eo=(0,D.localize)(0,null),e.$Fo={value:e.$Eo,original:"Extensions"},e.$Go=(0,D.localize2)(1,"Preferences")}),define(ke[240],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=e.$R2b=void 0,e.$R2b=(0,D.$5h)("externalTerminal"),e.$S2b="Terminal.app"}),define(ke[241],Se([1,0,51,52,17,16,10,101,31,104,202,240]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=e.$Q0b=e.$P0b=void 0;const m=R.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends v{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(D,c,y.$Sl(),t)}spawnTerminal(c,t,u,s){const l=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=I.$nc(l,".exe").toLowerCase();if(a==="cmder")return c.spawn(l,s?[s]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return l.indexOf(" ")>=0&&d.push('""'),d.push(l),a==="wt"&&d.push("-d ."),new Promise((k,P)=>{const p=o(process),w=c.spawn(u,d,{cwd:s,env:p,detached:!0});w.on("error",P),w.on("exit",()=>k())})}async runInTerminal(c,t,u,s,l){const a="windowsExec"in l&&l.windowsExec?l.windowsExec:S.getDefaultTerminalWindows(),d=await S.f();return new Promise((k,P)=>{const p=`"${t} - ${m}"`,w=`""${u.join('" "')}" & pause"`,E=Object.assign({},o(process),s);Object.keys(E).filter(j=>E[j]===null).forEach(j=>delete E[j]);const A={cwd:t,env:E,windowsVerbatimArguments:!0};let T,U;I.$nc(a,".exe")==="wt"?(T=a,U=["-d",".",S.b,"/c",w]):d?(T=d,U=["-d",t,a,"/c",w]):(T=S.b,U=["/c","start",p,"/wait",a,"/c",w]),D.spawn(T,U,A).on("error",j=>{P(i(j))}),k(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const c=await y.win32.findExecutable("wt");return await $.Promises.exists(c)?c:void 0}catch{return}}}e.$P0b=S,Ge([O.$wh],S,"f",null);class h extends v{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,u,s,l){const a=l.osxExec||C.$S2b;return new Promise((d,k)=>{if(a===C.$S2b||a==="iTerm.app"){const P=a===C.$S2b?"TerminalHelper":"iTermHelper",w=[g.$ng.asFileUri(`vs/workbench/contrib/externalTerminal/node/${P}.scpt`).fsPath,"-t",c||m,"-w",t];for(const T of u)w.push("-a"),w.push(T);if(s){const T=Object.assign({},o(process),s);for(const U in T){const N=T[U];N===null?(w.push("-u"),w.push(U)):(w.push("-e"),w.push(`${U}=${N}`))}}let E="";const A=D.spawn(h.b,w);A.on("error",T=>{k(i(T))}),A.stderr.on("data",T=>{E+=T.toString()}),A.on("exit",T=>{if(T===0)d(void 0);else if(E){const U=E.split(`
`,1);k(new Error(U[0]))}else k(new Error(R.localize(1,null,P,T)))})}else k(new Error(R.localize(2,null,a)))})}spawnTerminal(c,t,u){const s=t.osxExec||C.$S2b;return new Promise((l,a)=>{const d=["-a",s];u&&d.push(u);const k=o(process),P=c.spawn("/usr/bin/open",d,{cwd:u,env:k});P.on("error",a),P.on("exit",()=>l())})}}e.$Q0b=h;class f extends v{static{this.b=R.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(D,c,t)}runInTerminal(c,t,u,s,l){const a=l.linuxExec?Promise.resolve(l.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((d,k)=>{const P=[];a.then(p=>{p.indexOf("gnome-terminal")>=0?P.push("-x"):P.push("-e"),P.push("bash"),P.push("-c");const w=`${r(u)}; echo; read -p "${f.b}" -n1;`;P.push(`''${w}''`);const E=Object.assign({},o(process),s);Object.keys(E).filter(N=>E[N]===null).forEach(N=>delete E[N]);const A={cwd:t,env:E};let T="";const U=D.spawn(p,P,A);U.on("error",N=>{k(i(N))}),U.stderr.on("data",N=>{T+=N.toString()}),U.on("exit",N=>{if(N===0)d(void 0);else if(T){const j=T.split(`
`,1);k(new Error(j[0]))}else k(new Error(R.localize(4,null,p,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!L.$k)f.d=Promise.resolve("xterm");else{const c=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(c,t,u){const s=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((l,a)=>{s.then(d=>{const k=o(process),P=c.spawn(d,[],{cwd:u,env:k});P.on("error",a),P.on("exit",()=>l())})})}}e.$R0b=f;function o(n){const c={...n.env};return(0,b.$Ql)(c),c}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(R.localize(5,null,n.path)):n}function r(n){let c="";for(const t of n)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(ke[32],Se([1,0,77,16,12,18,2,203,5,10,17,43]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileKind=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileOperationResult=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileChangeType=e.$Hk=e.FileOperation=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileSystemProviderErrorCode=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileSystemProviderCapabilities=e.$rk=e.FilePermission=e.FileType=e.$qk=e.$pk=void 0,e.$pk=(0,$.$5h)("fileService");function m(_){return _.create===!0}e.$qk=m;var v;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var S;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function h(_){const we=_;return!!we&&typeof we.onDidChange=="function"}e.$rk=h;var f;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function o(_){return!!(_.capabilities&2)}e.$sk=o;function i(_){return!!(_.capabilities&8)}e.$tk=i;function r(_){return!!(_.capabilities&131072)}e.$uk=r;function n(_){return!!(_.capabilities&4)}e.$vk=n;function c(_){return!!(_.capabilities&16)}e.$wk=c;function t(_){return o(_)?!!(_.capabilities&16384):!1}e.$xk=t;function u(_){return o(_)?!!(_.capabilities&32768):!1}e.$yk=u;function s(_){return!!(_.capabilities&65536)}e.$zk=s;function l(_){return!!(_.capabilities&2048)}e.$Ak=l;var a;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class d extends Error{static create(we,oe){const K=new d(we.toString(),oe);return p(K,oe),K}constructor(we,oe){super(we),this.code=oe}}e.$Bk=d;function k(_,we){return d.create(_,we)}e.$Ck=k;function P(_){return _||k((0,b.localize)(0,null),a.Unknown)}e.$Dk=P;function p(_,we){return _.name=we?`${we} (FileSystemError)`:"FileSystemError",_}e.$Ek=p;function w(_){if(!_)return a.Unknown;if(_ instanceof d)return _.code;const we=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!we)return a.Unknown;switch(we[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$Fk=w;function E(_){if(_ instanceof F)return _.fileOperationResult;switch(w(_)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$Gk=E;var A;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class T{constructor(we,oe,K){this.resource=we,this.operation=oe,this.target=K}isOperation(we){return this.operation===we}}e.$Hk=T;var U;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class N{static{this.a=null}constructor(we,oe){this.c=oe,this.b=void 0,this.d=new C.$V(()=>{const K=D.$$h.forUris(()=>this.c);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.f=new C.$V(()=>{const K=D.$$h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.g=new C.$V(()=>{const K=D.$$h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of we){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==N.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=N.a):this.b!==void 0&&(this.b=N.a))}}contains(we,...oe){return this.h(we,{includeChildren:!1},...oe)}affects(we,...oe){return this.h(we,{includeChildren:!0},...oe)}h(we,oe,...K){if(!we)return!1;const W=K.length>0;return!!((!W||K.includes(1))&&(this.d.value.get(we)||oe.includeChildren&&this.d.value.findSuperstr(we))||(!W||K.includes(0))&&(this.f.value.get(we)||oe.includeChildren&&this.f.value.findSuperstr(we))||(!W||K.includes(2))&&(this.g.value.findSubstr(we)||oe.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$Ik=N;function j(_,we,oe){return!_||!we||_===we||we.length>_.length?!1:(we.charAt(we.length-1)!==O.sep&&(we+=O.sep),oe?(0,g.$_e)(_,we):_.indexOf(we)===0)}e.$Jk=j;class F extends Error{constructor(we,oe,K){super(we),this.fileOperationResult=oe,this.options=K}}e.$Kk=F;class M extends F{constructor(we,oe,K,W){super(we,oe,W),this.fileOperationResult=oe,this.size=K}}e.$Lk=M;class B extends F{constructor(we,oe,K){super(we,2,K),this.stat=oe}}e.$Mk=B;var X;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$Nk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ok={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Pk="files.associations",e.$Qk="files.exclude",e.$Rk="files.readonlyInclude",e.$Sk="files.readonlyExclude",e.$Tk="files.readonlyFromPermissions";var ue;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Uk="";function Z(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Vk=Z;async function J(_,we){if(!we.hasProvider(L.URI.from({scheme:_.scheme})))return new Promise(oe=>{const K=we.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===_.scheme&&W.added&&(K.dispose(),oe())})})}e.$Wk=J;class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(we){return(0,I.$Lf)(we)||(we=0),we<Y.KB?(0,b.localize)(1,null,we.toFixed(0)):we<Y.MB?(0,b.localize)(2,null,(we/Y.KB).toFixed(2)):we<Y.GB?(0,b.localize)(3,null,(we/Y.MB).toFixed(2)):we<Y.TB?(0,b.localize)(4,null,(we/Y.GB).toFixed(2)):(0,b.localize)(5,null,(we/Y.TB).toFixed(2))}}e.$Xk=Y;function he(_){const we=typeof _=="string"||_?.scheme===R.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===R.Schemas.file?1024*Y.MB:we?10*Y.MB:y.$o?50*Y.MB:1024*Y.MB}e.$Yk=he}),define(ke[242],Se([1,0,22,14,204,32]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;async function L(R,C,m,v,S,h){let f;try{await b(R,C,m,v,S,h)}catch(o){f=o}finally{f&&S.errorTransformer&&(f=S.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$aq=L;async function b(R,C,m,v,S,h){$(h);const f=await R.open(C,{create:!1});try{$(h);let o=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=D.$ie.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),c=S&&typeof S.position=="number"?S.position:0,t=0;do i=await R.read(f,c,n.buffer,t,n.byteLength-t),c+=i,t+=i,o+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await m.write(v(n)),n=D.$ie.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&$(h)&&y(o,S));if(t>0){let u=t;typeof r=="number"&&(u=Math.min(t,r)),m.write(v(n.slice(0,u)))}}catch(o){throw(0,I.$Dk)(o)}finally{await R.close(f)}}function $(R){if(R.isCancellationRequested)throw(0,O.$6)();return!0}function y(R,C){if(typeof C?.limits?.size=="number"&&R>C.limits.size)throw(0,I.$Ck)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,10,2,32]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=void 0;function $(o){return o.recursive===!0}e.$cq=$;class y extends O.$Tc{static{this.a=5}constructor(i,r,n,c){super(),this.h=i,this.j=r,this.m=n,this.n=c,this.c=this.B(new O.$Uc),this.f=void 0,this.g=0}s(){const i=new O.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$dq=y;class R extends y{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$eq=R;class C extends y{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$fq=C;function m(o){return o.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}e.$gq=m;function v(o){const i=new f;for(const r of o)i.processEvent(r);return i.coalesce()}e.$hq=v;function S(o,i){return typeof i=="string"&&!i.startsWith(D.$Hj)&&!(0,g.$ic)(i)?{base:o,pattern:i}:i}e.$iq=S;function h(o,i){const r=[];for(const n of i)r.push((0,D.$Lj)(S(o,n)));return r}e.$jq=h;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const c=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):c===2&&t===1?r.type=0:c===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,c)=>n.resource.fsPath.length-c.resource.fsPath.length).filter(n=>r.some(c=>(0,b.$Jk)(n.resource.fsPath,c,!I.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,56,11,21,33,3,76,16,10,23,2,103,31,84]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=void 0;class h extends L.$Tc{static{this.a=100}static{this.b=75}constructor(i,r,n,c){super(),this.m=i,this.n=r,this.r=n,this.s=c,this.c=this.B(new O.$hh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$gh(t=>this.z(t),h.b)),this.g=(0,S.$jq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$jq)(this.m.path,this.m.includes):void 0,this.j=new g.$5d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await v.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await v.Promises.realpath(i.path),i.path===r&&(r=await(0,m.$tq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(y.$j&&(0,I.$7f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Tc.None;const n=new g.$5d(this.j.token),c=new L.$Sc;try{const t=C.URI.file(this.m.path),u=(0,$.$nc)(i),s=(0,D.watch)(i);c.add((0,L.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const l=new Set;if(r)try{for(const d of await v.Promises.readdir(i))l.add(d)}catch(d){this.D(d)}const a=new Map;c.add((0,L.$Rc)(()=>{for(const[,d]of a)d.dispose();a.clear()})),s.on("error",(d,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${d}, ${k})`),this.dispose()}),s.on("change",(d,k)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${d}"] ${k}`);let P="";if(k&&(P=k.toString(),y.$j&&(P=(0,b.$Fl)(P))),!(!P||d!=="change"&&d!=="rename"))if(r)if(d==="rename"){a.get(P)?.dispose();const p=setTimeout(async()=>{if(a.delete(P),P===u&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const w=await this.C((0,$.$jc)(i,P));if(n.token.isCancellationRequested)return;let E;w?l.has(P)?E=0:(E=1,l.add(P)):(l.delete(P),E=2),this.y({resource:(0,R.$Gg)(t,P),type:E,cId:this.m.correlationId})},h.a);a.set(P,(0,L.$Rc)(()=>clearTimeout(p)))}else{let p;l.has(P)?p=0:(p=1,l.add(P)),this.y({resource:(0,R.$Gg)(t,P),type:p,cId:this.m.correlationId})}else if(d==="rename"||P!==u){const p=setTimeout(async()=>{const w=await v.Promises.exists(i);n.token.isCancellationRequested||(w?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},h.a);c.clear(),c.add((0,L.$Rc)(()=>clearTimeout(p)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,L.$Rc)(()=>{n.dispose(!0),c.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$hq)(i);if(r.length>0){if(this.s)for(const c of r)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return v.Promises.exists(i);try{const r=(0,$.$nc)(i);return(await v.Promises.readdir((0,$.$mc)(i))).some(c=>c===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$wq=h;async function f(o,i,r,n,c=512){const t=await v.Promises.open(o,"r"),u=Buffer.allocUnsafe(c),s=new g.$5d(n);let l,a=!1;const d={path:o,excludes:[],recursive:!1},k=new h(d,P=>{(async()=>{for(const{type:p}of P)if(p===0){if(a)return;a=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:w}=await v.Promises.read(t,u,0,c,null);if(!w||s.token.isCancellationRequested)break;i(u.slice(0,w))}}catch(w){l=new Error(w),s.dispose(!0)}finally{a=!1}}})()});return await k.ready,r(),new Promise((P,p)=>{s.token.onCancellationRequested(async()=>{k.dispose();try{await v.Promises.close(t)}catch(w){l=new Error(w)}l?p(l):P()})})}e.$xq=f}),define(ke[244],Se([1,0,4,34,3,10,243]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;class b extends g.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Ud),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Ud),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const R=this.j(y),C=R.filter(v=>{const S=this.c.get(v.path);return S?!(0,O.$Pj)(S.request.excludes,v.excludes)||!(0,O.$Pj)(S.request.includes,v.includes):!0}),m=Array.from(this.c.values()).filter(({request:v})=>!R.find(S=>S.path===v.path&&(0,O.$Pj)(S.excludes,v.excludes)&&(0,O.$Pj)(S.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.m(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.h(v);for(const v of C)this.g(v)}g(y){const R=new L.$wq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:R};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const R=this.c.get(y);R&&(this.c.delete(y),R.instance.dispose())}j(y){const R=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let v=R.get(C.correlationId);v||(v=new Map,R.set(C.correlationId,v)),v.set(m,C)}return Array.from(R.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,R]of this.c)R.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,R){return R?`[File Watcher (node.js)] ${y} (path: ${R.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$yq=b}),define(ke[245],Se([1,0,84,244]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class g extends D.$eq{constructor(L,b,$){super(L,b,$),this.s()}r(L){return L.add(new O.$yq)}}e.$zq=g}),define(ke[246],Se([1,0,17,81,187,84]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=void 0;class L extends I.$fq{constructor($,y,R){super($,y,R),this.s()}r($){const y=$.add(new g.$qq(D.$ng.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:R,signal:C})=>this.t(`terminated by itself with code ${R}, signal: ${C}`))),O.ProxyChannel.toService((0,O.$Lh)(y.getChannel("watcher")))}}e.$rq=L}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class D{constructor(...g){this.a=new Map;for(const[I,L]of g)this.set(I,L)}set(g,I){const L=this.a.get(g);return this.a.set(g,I),L}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$3h=D}),define(ke[247],Se([1,0,11,14,3,105,238,5,107,75]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=void 0;const R=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$3h,o=!1,i,r=R){this.f=f,this.g=o,this.h=i,this.i=r,this.o=new Set,this.f.set(b.$4h,this),this._globalGraph=r?i?._globalGraph??new L.$Cq(n=>n):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...o){const i=S.traceInvocation(this.i,f);let r=!1;try{return f({get:c=>{if(r)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...o)}finally{r=!0,i.stop()}}createInstance(f,...o){let i,r;return f instanceof I.$2h?(i=S.traceCreation(this.i,f.ctor),r=this.j(f.ctor,f.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,f),r=this.j(f,o,i)),i.stop(),r}j(f,o=[],i){const r=b._util.getServiceDependencies(f).sort((t,u)=>t.index-u.index),n=[];for(const t of r){const u=this.m(t.id,i);u||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(u)}const c=r.length>0?r[0].index:o.length;if(o.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${o.length} static arguments`);const t=c-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,c)}return Reflect.construct(f,o.concat(n))}k(f,o){if(this.f.get(f)instanceof I.$2h)this.f.set(f,o);else if(this.h)this.h.k(f,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const o=this.f.get(f);return!o&&this.h?this.h.l(f):o}m(f,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof I.$2h?this.q(f,i,o.branch(f,!0)):(o.branch(f,!1),i)}q(f,o,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,o,i)}finally{this.o.delete(f)}}r(f,o,i){const r=new L.$Cq(t=>t.id.toString());let n=0;const c=[{id:f,desc:o,_trace:i}];for(;c.length;){const t=c.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new C(r);for(const u of b._util.getServiceDependencies(t.desc.ctor)){const s=this.l(u.id);if(s||this.u(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),s instanceof I.$2h){const l={id:u.id,desc:s,_trace:t._trace.branch(u.id,!0)};r.insertEdge(t,l),c.push(l)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new C(r);break}for(const{data:u}of t){if(this.l(u.id)instanceof I.$2h){const l=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,l)}r.removeNode(u)}}return this.l(f)}s(f,o,i=[],r,n){if(this.f.get(f)instanceof I.$2h)return this.t(f,o,i,r,n);if(this.h)return this.h.s(f,o,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(f,o,i=[],r,n){if(r){const c=new m(void 0,this.g,this,this.i);c.c=String(f);const t=new Map,u=new D.$lh(()=>{const s=c.j(o,i,n);for(const[l,a]of t){const d=s[l];if(typeof d=="function")for(const k of a)k.disposable=d.apply(s,k.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,l){if(!u.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let k=t.get(l);return k||(k=new y.$4c,t.set(l,k)),(p,w,E)=>{if(u.isInitialized)return u.value[l](p,w,E);{const A={listener:[p,w,E],disposable:void 0},T=k.push(A);return(0,g.$Rc)(()=>{T(),A.disposable?.dispose()})}}}if(l in s)return s[l];const a=u.value;let d=a[l];return typeof d!="function"||(d=d.bind(a),s[l]=d),d},set(s,l,a){return u.value[l]=a,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,i,n)}u(f,o){if(o&&console.warn(f),this.g)throw new Error(f)}}e.$Dq=m;var v;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(v||(v={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,o){return f?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(f,o){return f?new S(1,o.name):S.c}static{this.f=0}constructor(f,o){this.type=f,this.name=o,this.g=Date.now(),this.h=[]}branch(f,o){const i=new S(3,f.toString());return this.h.push([f,o,i]),i}stop(){const f=Date.now()-this.g;S.f+=f;let o=!1;function i(n,c){const t=[],u=new Array(n+1).join("	");for(const[s,l,a]of c.h)if(l&&a){o=!0,t.push(`${u}CREATES -> ${s}`);const d=i(n+1,a);d&&t.push(d)}else t.push(`${u}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(f>2||o)&&S.all.add(r.join(`
`))}}e.$Eq=S}),define(ke[13],Se([1,0,44,4,54,3,28,10,23,18,2,46,5]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.log=e.$pj=e.LogLevel=e.$oj=e.$nj=e.$mj=void 0,e.$mj=(0,m.$5h)("logService"),e.$nj=(0,m.$5h)("loggerService");function v(){return new Date().toISOString()}function S(p){return(0,y.$Lf)(p)}e.$oj=S;var h;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$pj=h.Info;function f(p,w,E){switch(w){case h.Trace:p.trace(E);break;case h.Debug:p.debug(E);break;case h.Info:p.info(E);break;case h.Warning:p.warn(E);break;case h.Error:p.error(E);break;case h.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=f;function o(p,w=!1){let E="";for(let A=0;A<p.length;A++){let T=p[A];if(T instanceof Error&&(T=(0,D.$Pi)(T,w)),typeof T=="object")try{T=JSON.stringify(T)}catch{}E+=(A>0?" ":"")+T}return E}class i extends I.$Tc{constructor(){super(...arguments),this.b=e.$pj,this.c=this.B(new O.$Ud),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==h.Off&&this.b<=w}}e.$rj=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...E){this.f(h.Trace)&&this.g(h.Trace,o([w,...E],!0))}debug(w,...E){this.f(h.Debug)&&this.g(h.Debug,o([w,...E]))}info(w,...E){this.f(h.Info)&&this.g(h.Info,o([w,...E]))}warn(w,...E){this.f(h.Warning)&&this.g(h.Warning,o([w,...E]))}error(w,...E){if(this.f(h.Error))if(w instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=w.stack,this.g(h.Error,o(A))}else this.g(h.Error,o([w,...E]))}flush(){}}e.$sj=r;class n extends i{constructor(w=e.$pj){super(),this.setLevel(w),this.g=!b.$i}trace(w,...E){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...E):console.log(`[main ${v()}]`,w,...E))}debug(w,...E){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...E):console.log(`[main ${v()}]`,w,...E))}info(w,...E){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...E):console.log(`[main ${v()}]`,w,...E))}warn(w,...E){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,w,...E):console.warn(`[main ${v()}]`,w,...E))}error(w,...E){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,w,...E):console.error(`[main ${v()}]`,w,...E))}flush(){}}e.$tj=n;class c extends i{constructor(w=e.$pj,E=!0){super(),this.g=E,this.setLevel(w)}trace(w,...E){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...E):console.log(w,...E))}debug(w,...E){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...E):console.log(w,...E))}info(w,...E){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...E):console.log(w,...E))}warn(w,...E){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...E):console.log(w,...E))}error(w,...E){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...E):console.error(w,...E))}flush(){}}e.$uj=c;class t extends i{constructor(w,E=e.$pj){super(),this.g=w,this.setLevel(E)}trace(w,...E){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(w),...E])}debug(w,...E){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(w),...E])}info(w,...E){this.f(h.Info)&&this.g.log(h.Info,[this.h(w),...E])}warn(w,...E){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(w),...E])}error(w,...E){this.f(h.Error)&&this.g.log(h.Error,[this.h(w),...E])}h(w){return typeof w=="string"?w:(0,D.$Pi)(w,this.f(h.Trace))}flush(){}}e.$vj=t;class u extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const E of this.g)E.setLevel(w);super.setLevel(w)}trace(w,...E){for(const A of this.g)A.trace(w,...E)}debug(w,...E){for(const A of this.g)A.debug(w,...E)}info(w,...E){for(const A of this.g)A.info(w,...E)}warn(w,...E){for(const A of this.g)A.warn(w,...E)}error(w,...E){for(const A of this.g)A.error(w,...E)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$wj=u;class s extends I.$Tc{constructor(w,E,A){if(super(),this.h=w,this.j=E,this.b=new L.$Ac,this.c=this.B(new O.$Ud),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$Ud),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$Ud),this.onDidChangeVisibility=this.g.event,A)for(const T of A)this.b.set(T.resource,{logger:void 0,info:T})}m(w){return(0,y.$Hf)(w)?[...this.b.values()].find(E=>E.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,E){const A=this.n(w),T=(0,y.$Hf)(w)?w:E?.id??(0,g.$Si)(A.toString()).toString(16);let U=this.b.get(A)?.logger;const N=E?.logLevel==="always"?h.Trace:E?.logLevel;U||(U=this.s(A,N??this.getLogLevel(A)??this.h,{...E,id:T}));const j={logger:U,info:{resource:A,id:T,logLevel:N,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(A,j),U}n(w){return(0,y.$Hf)(w)?(0,$.$Gg)(this.j,`${w}.log`):w}setLogLevel(w,E){if(R.URI.isUri(w)){const A=w,T=E,U=this.b.get(A);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([A,T]))}else{this.h=w;for(const[A,T]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,E){const A=this.m(w);A&&E!==!A.info.hidden&&(A.info.hidden=!E,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,E]))}getLogLevel(w){let E;return w&&(E=this.b.get(w)?.info.logLevel),E??this.h}registerLogger(w){const E=this.b.get(w.resource);E?E.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const E=this.b.get(w);E&&(E.logger&&E.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$xj=s;class l{constructor(){this.onDidChangeLogLevel=new O.$Ud().event}setLevel(w){}getLevel(){return h.Info}trace(w,...E){}debug(w,...E){}info(w,...E){}warn(w,...E){}error(w,...E){}critical(w,...E){}dispose(){}flush(){}}e.$yj=l;class a extends l{}e.$zj=a;function d(p){if(p.verbose)return h.Trace;if(typeof p.logLevel=="string"){const w=P(p.logLevel.toLowerCase());if(w!==void 0)return w}return e.$pj}e.$Aj=d;function k(p){switch(p){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.$Bj=k;function P(p){switch(p){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$Cj=P,e.$Dj=new C.$jj("logLevel",k(h.Info))}),define(ke[248],Se([1,0,19,11,14,4,3,16,84,13]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class R extends L.$Tc{constructor(m,v){super(),this.a=m,this.b=v,this.c=this.B(new I.$Ud),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Ud),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$3g(0)),this.w=[],this.y=this.B(new O.$3g(0))}watch(m,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(m,v):this.z(m,v)}n(m,v){const S={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},h=(0,D.$Ub)(this.j,S);return this.r(),(0,L.$Rc)(()=>{h(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,$.$gq)(v)),v=>this.G(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.j)(0,$.$cq)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.j)(0,$.$cq)(v)&&m.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,v){const S={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},h=(0,D.$Ub)(this.w,S);return this.C(),(0,L.$Rc)(()=>{h(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$gq)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$kq=R}),define(ke[249],Se([1,0,56,386,11,28,22,4,33,3,16,10,23,98,31,205,32,242,248,44,246,245]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(u){console.error(`Error enabling graceful-fs: ${(0,r.$Pi)(u)}`)}})();class t extends i.$kq{static{this.I=!1}constructor(s,l){super(s,l),this.onDidChangeCapabilities=b.Event.None,this.N=new I.$Ac(a=>m.$xg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:l,symbolicLink:a}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(l,a),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:f.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const l=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),a=[];return await Promise.all(l.map(async d=>{try{let k;d.isSymbolicLink()?k=(await this.stat((0,m.$Gg)(s,d.name))).type:k=this.M(d),a.push([d.name,k])}catch(k){this.a.trace(k)}})),a}catch(l){throw this.fb(l)}}M(s,l){let a;return l?.dangling?a=f.FileType.Unknown:s.isFile()?a=f.FileType.File:s.isDirectory()?a=f.FileType.Directory:a=f.FileType.Unknown,l&&(a|=f.FileType.SymbolicLink),a}async O(s){const l=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let a;for(;a=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await a.wait();const d=new g.$4g;return this.N.set(s,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,y.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(s)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),d.open()})}async readFile(s,l){let a;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),a=await this.O(s));const d=this.H(s);return await S.Promises.readFile(d)}catch(d){throw this.fb(d)}finally{a?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,l,a){const d=(0,v.$9d)(k=>L.$ie.concat(k.map(P=>L.$ie.wrap(P))).buffer);return(0,o.$aq)(this,s,d,k=>k.buffer,{...l,bufferSize:256*1024},a),d}async writeFile(s,l,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,m.$Gg)((0,m.$Fg)(s),`${(0,m.$Dg)(s)}${a.atomic.postfix}`),l,a):this.S(s,l,a)}async Q(s){try{const l=this.H(s),{symbolicLink:a}=await S.SymlinkSupport.stat(l);if(a)return!1}catch{}return!0}async R(s,l,a,d){const k=new y.$Sc;try{k.add(await this.O(s)),k.add(await this.O(l)),await this.S(l,a,d,!0);try{await this.rename(l,s,{overwrite:!0})}catch(P){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{k.dispose()}}async S(s,l,a,d){let k;try{const P=this.H(s);if(!a.create||!a.overwrite){if(await S.Promises.exists(P)){if(!a.overwrite)throw(0,f.$Ck)((0,h.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,f.$Ck)((0,h.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(s,{create:!0,unlock:a.unlock},d),await this.write(k,0,l,0,l.byteLength)}catch(P){throw await this.gb(s,P)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,l,a){const d=this.H(s);let k;(0,f.$qk)(l)&&!a&&(k=await this.O(s));let P;try{if((0,f.$qk)(l)&&l.unlock)try{const{stat:w}=await S.SymlinkSupport.stat(d);w.mode&128||await S.Promises.chmod(d,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let p;if((0,f.$qk)(l)){if(C.$i)try{await S.Promises.truncate(d,0),p="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}p||(p="w")}else p="r";P=await S.Promises.open(d,p)}catch(p){throw k?.dispose(),(0,f.$qk)(l)?await this.gb(s,p):this.fb(p)}if(this.U.set(P,0),(0,f.$qk)(l)&&this.X.set(P,s),k){const p=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${d})`),this.W.set(P,k),p&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${d})`),p.dispose())}return P}async close(s){const l=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await S.Promises.close(s)}catch(a){throw this.fb(a)}finally{l&&(this.W.get(s)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),l.dispose())}}async read(s,l,a,d,k){const P=this.Z(s,l);let p=null;try{p=(await S.Promises.read(s,a,d,k,P)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(s,P,p)}return p}Z(s,l){return l===this.U.get(s)?null:l}$(s,l,a){const d=this.U.get(s);typeof d=="number"&&(typeof l=="number"||(typeof a=="number"?this.U.set(s,d+a):this.U.delete(s)))}async write(s,l,a,d,k){return(0,g.$mh)(()=>this.ab(s,l,a,d,k),100,3)}async ab(s,l,a,d,k){const P=this.Z(s,l);let p=null;try{p=(await S.Promises.write(s,a,d,k,P)).bytesWritten}catch(w){throw await this.gb(this.X.get(s),w)}finally{this.$(s,P,p)}return p}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(l){throw this.fb(l)}}async delete(s,l){try{const a=this.H(s);if(l.recursive){let d;l?.atomic!==!1&&l.atomic.postfix&&(d=(0,R.$jc)((0,R.$mc)(a),`${(0,R.$nc)(a)}${l.atomic.postfix}`)),await S.Promises.rm(a,S.RimRafMode.MOVE,d)}else try{await S.Promises.unlink(a)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let k=!1;try{const{stat:P,symbolicLink:p}=await S.SymlinkSupport.stat(a);k=P.isDirectory()&&!p}catch{}if(k)await S.Promises.rmdir(a);else throw d}else throw d}}catch(a){throw this.fb(a)}}async rename(s,l,a){const d=this.H(s),k=this.H(l);if(d!==k)try{await this.bb(s,l,"move",a.overwrite),await S.Promises.rename(d,k)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,h.localize)(2,null,(0,R.$nc)(d),(0,R.$nc)((0,R.$mc)(k)),P.toString()))),this.fb(P)}}async copy(s,l,a){const d=this.H(s),k=this.H(l);if(d!==k)try{await this.bb(s,l,"copy",a.overwrite),await S.Promises.copy(d,k,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,h.localize)(3,null,(0,R.$nc)(d),(0,R.$nc)((0,R.$mc)(k)),P.toString()))),this.fb(P)}}async bb(s,l,a,d){const k=this.H(s),P=this.H(l);let p=!1;if(!!(this.capabilities&1024)||(p=(0,$.$6f)(k,P,!0)),p){if(a==="copy")throw(0,f.$Ck)((0,h.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const E=await this.L(s);if(!E)throw(0,f.$Ck)((0,h.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const A=await this.L(l);if(A){if(!d)throw(0,f.$Ck)((0,h.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&A.type&f.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,l){return this.cb(s,l,!1)}async cb(s,l,a){const d=this.H(s),k=this.H(l),P=!!(this.capabilities&1024);if((0,$.$6f)(d,k,!P))return;const p=new y.$Sc;try{p.add(await this.O(s)),p.add(await this.O(l)),a&&await S.Promises.mkdir((0,R.$mc)(k),{recursive:!0}),await S.Promises.copyFile(d,k)}catch(w){if(w.code==="ENOENT"&&!a)return this.cb(s,l,!0);throw this.fb(w)}finally{p.dispose()}}t(s,l,a){return new n.$rq(d=>s(d),d=>l(d),a)}F(s,l,a){return new c.$zq(d=>s(d),d=>l(d),a)}fb(s){if(s instanceof f.$Bk)return s;let l=s,a;switch(s.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=f.FileSystemProviderErrorCode.Unknown;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.$Ck)(l,a)}async gb(s,l){let a=this.fb(l);if(s&&a.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await S.SymlinkSupport.stat(this.H(s));d.mode&128||(a=(0,f.$Ck)(l,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return a}}e.$Aq=t}),define(ke[250],Se([1,0,3,13]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0;class g extends D.$Tc{constructor(L,b=[]){super(),this.a=new O.$wj([L,...b]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.$tO=g}),define(ke[251],Se([1,0,32,13]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,R,C,m,v){try{const S=await new Promise((f,o)=>{me(["@vscode/spdlog"],f,o)});S.setFlushOn(g.Trace);const h=await S.createAsyncRotatingLogger(y,R,C,m);return v?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(S){console.error(S)}return null}function L(y,R,C){switch(R){case O.LogLevel.Trace:y.trace(C);break;case O.LogLevel.Debug:y.debug(C);break;case O.LogLevel.Info:y.info(C);break;case O.LogLevel.Warning:y.warn(C);break;case O.LogLevel.Error:y.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(y,R){switch(R){case O.LogLevel.Trace:y.setLevel(g.Trace);break;case O.LogLevel.Debug:y.setLevel(g.Debug);break;case O.LogLevel.Info:y.setLevel(g.Info);break;case O.LogLevel.Warning:y.setLevel(g.Warning);break;case O.LogLevel.Error:y.setLevel(g.Error);break;case O.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends O.$sj{constructor(R,C,m,v,S){super(),this.m=[],this.setLevel(S),this.n=this.s(R,C,m,v),this.B(this.onDidChangeLogLevel(h=>{this.r&&b(this.r,h)}))}async s(R,C,m,v){const S=m?6:1,h=30/S*D.$Xk.MB,f=await I(R,C,h,S,v);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)L(this.r,o,i);this.m=[]}}g(R,C){this.r?L(this.r,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$iO=$}),define(ke[135],Se([1,0,39,206,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function y(S,h){return h-S}$.compare=y;const R=Object.create(null);R[$.Error]=(0,O.localize)(0,null),R[$.Warning]=(0,O.localize)(1,null),R[$.Info]=(0,O.localize)(2,null);function C(S){return R[S]||""}$.toString=C;function m(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function v(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=v}(L||(e.MarkerSeverity=L={}));var b;(function($){const y="";function R(m){return C(m,!0)}$.makeKey=R;function C(m,v){const S=[y];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(y),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(y),m.severity!==void 0&&m.severity!==null?S.push(L.toString(m.severity)):S.push(y),m.message&&v?S.push(m.message.replace("\xA6","\\\xA6")):S.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(y),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(y),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$zt=(0,g.$5h)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.NotificationsFilter=e.$pv=e.NeverShowAgainScope=e.NotificationPriority=e.$ov=e.Severity=void 0,e.Severity=O.default,e.$ov=(0,g.$5h)("notificationService");var I;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var L;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function b(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}e.$pv=b;var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class y{constructor(){this.progress=new R,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$qv=y;class R{infinite(){}done(){}total(m){}worked(m){}}e.$rv=R}),define(ke[253],Se([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)O=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:I.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(ke[136],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=void 0,e.$Ej=(0,D.$5h)("productService"),e.$Fj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(D,O){e(D,O,me)}};define(ke[85],Se([1,0,11,21,3,5]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.ProgressLocation=e.$sv=void 0,e.$sv=(0,I.$5h)("progressService");var L;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$tv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$uv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const v=this.d;this.d=()=>{v?.(),m()}}):Promise.resolve()}}e.$vv=$;let y=class extends g.$Tc{constructor(m,v){super(),this.a=new D.$ph,v.withProgress(m,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$Rc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$wv=y,e.$wv=y=Ge([We(1,e.$sv)],y);class R extends g.$Tc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Sc)}start(m){this.stop();const v=++this.a,S=new O.$5d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Rc)(()=>S.cancel())),this.b.add((0,g.$Rc)(()=>this.c?this.c.done():void 0)),{id:v,token:S.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$xv=R,e.$yv=(0,I.$5h)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;class g{constructor(){this.a=new Map}add(L,b){D.ok(O.$Hf(L)),D.ok(O.$Jf(b)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Gn=new g}),define(ke[108],Se([1,0,4,37]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0,e.$Hn={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this.b=new D.$Ud,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new I;O.$Gn.add(e.$Hn.JSONContribution,L)}),define(ke[86],Se([1,0,19,4,18,196,45,108,37]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.ConfigurationScope=e.$Ln=e.EditPresentationTypes=void 0;var y;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$Ln={Configuration:"base.contributions.configuration"};var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Mn={properties:{},patternProperties:{}},e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn="vscode://schemas/settings/resourceLanguage",e.$Tn="vscode://schemas/settings/configurationDefaults";const C=$.$Gn.as(b.$Hn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new O.$Ud,this.onDidSchemaChange=this.i.event,this.j=new O.$Ud,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Sn,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const s=new Set;this.n(t,u,s),C.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const u=new Set;this.o(t,u),C.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const s=new Set;this.o(u,s),this.n(t,!1,s),C.registerSchema(e.$Sn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const s=[];for(const{overrides:l,source:a}of t)for(const d in l)if(u.add(d),e.$Vn.test(d)){const k=this.a.get(d),P=k?.valuesSources??new Map;if(a)for(const A of Object.keys(l[d]))P.set(A,a);const p={...k?.value||{},...l[d]};this.a.set(d,{source:a,value:p,valuesSources:P});const w=(0,L.$Ii)(d),E={type:"object",default:p,description:I.localize(1,null,w),$ref:e.$Sn,defaultDefaultValue:p,source:g.$Hf(a)?void 0:a,defaultValueSource:a};s.push(...h(d)),this.d[d]=E,this.b.properties[d]=E}else{this.a.set(d,{value:l[d],source:a});const k=this.d[d];k&&(this.w(d,k),this.r(d,k))}this.m(s)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:s,source:l}of t)for(const a in s){const d=this.a.get(a),k=g.$Hf(l)?l:l?.id,P=g.$Hf(d?.source)?d?.source:d?.source?.id;if(k===P)if(u.add(a),this.a.delete(a),e.$Vn.test(a))delete this.d[a],delete this.b.properties[a];else{const p=this.d[a];p&&(this.w(a,p),this.r(a,p))}}this.u()}deltaConfiguration(t){let u=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,s){t.forEach(l=>{this.p(l,u,l.extensionInfo,l.restrictedProperties,void 0,s),this.c.push(l),this.q(l)})}o(t,u){const s=l=>{if(l.properties)for(const a in l.properties){u.add(a);const d=this.d[a];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[a],this.s(a,l.properties[a])}l.allOf?.forEach(a=>s(a))};for(const l of t){s(l);const a=this.c.indexOf(l);a!==-1&&this.c.splice(a,1)}}p(t,u=!0,s,l,a=3,d){a=g.$Qf(t.scope)?a:t.scope;const k=t.properties;if(k)for(const p in k){const w=k[p];if(u&&r(p,w)){delete k[p];continue}if(w.source=s,w.defaultDefaultValue=k[p].default,this.w(p,w),e.$Vn.test(p)?w.scope=void 0:(w.scope=g.$Qf(w.scope)?a:w.scope,w.restricted=g.$Qf(w.restricted)?!!l?.includes(p):w.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.f[p]=k[p],delete k[p];continue}else this.d[p]=k[p],k[p].policy?.name&&this.e.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),d.add(p)}const P=t.allOf;if(P)for(const p of P)this.p(p,u,s,l,a,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=s=>{const l=s.properties;if(l)for(const d in l)this.r(d,l[d]);s.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$Mn.properties[t]=u,u.scope){case 1:e.$Nn.properties[t]=u;break;case 2:e.$On.properties[t]=u;break;case 6:e.$Pn.properties[t]=u;break;case 3:e.$Qn.properties[t]=u;break;case 4:e.$Rn.properties[t]=u;break;case 5:e.$Rn.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$Mn.properties[t],u.scope){case 1:delete e.$Nn.properties[t];break;case 2:delete e.$On.properties[t];break;case 6:delete e.$Pn.properties[t];break;case 3:delete e.$Qn.properties[t];break;case 4:case 5:delete e.$Rn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,s={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Sn};this.w(u,s),e.$Mn.properties[u]=s,e.$Nn.properties[u]=s,e.$On.properties[u]=s,e.$Pn.properties[u]=s,e.$Qn.properties[u]=s,e.$Rn.properties[u]=s}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Sn};e.$Mn.patternProperties[e.$Un]=t,e.$Nn.patternProperties[e.$Un]=t,e.$On.patternProperties[e.$Un]=t,e.$Pn.patternProperties[e.$Un]=t,e.$Qn.patternProperties[e.$Un]=t,e.$Rn.patternProperties[e.$Un]=t,this.i.fire()}w(t,u){const s=this.a.get(t);let l=s?.value,a=s?.source;g.$Of(l)&&(l=u.defaultDefaultValue,a=void 0),g.$Of(l)&&(l=o(u.type)),u.default=l,u.defaultValueSource=a}}const v="\\[([^\\]]+)\\]",S=new RegExp(v,"g");e.$Un=`^(${v})+$`,e.$Vn=new RegExp(e.$Un);function h(c){const t=[];if(e.$Vn.test(c)){let u=S.exec(c);for(;u?.length;){const s=u[1].trim();s&&t.push(s),u=S.exec(c)}}return(0,D.$Mb)(t)}e.$Wn=h;function f(c){return c.reduce((t,u)=>`${t}[${u}]`,"")}e.$Xn=f;function o(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Yn=o;const i=new m;$.$Gn.add(e.$Ln.Configuration,i);function r(c,t){return c.trim()?e.$Vn.test(c)?I.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?I.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$Zn=r;function n(){const c=[],t=i.getConfigurationProperties();for(const u of Object.keys(t))c.push([u,t[u].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$1n=n}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,45,86,37]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0;function v(u){return Object.isFrozen(u)?u:b.$vn(u)}class S{constructor(s={},l=[],a=[],d){this.b=s,this.c=l,this.d=a,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof S)return l;const a=new h("");return a.parseRaw(l),a.configurationModel});this.f=s.reduce((l,a)=>a===l?a:l.merge(a),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$Gi)(this.contents,s):this.contents}inspect(s,l){const a=this.rawConfiguration.getValue(s),d=l?this.rawConfiguration.getOverrideValue(s,l):void 0,k=l?this.rawConfiguration.override(l).getValue(s):a;return{value:a,override:d,merged:k}}getOverrideValue(s,l){const a=this.i(l);return a?s?(0,R.$Gi)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const a of this.overrides)a.identifiers.includes(s)&&l.push(...a.keys);return D.$Mb(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return D.$Mb(s)}override(s){let l=this.a.get(s);return l||(l=this.g(s),this.a.set(s,l)),l}merge(...s){const l=b.$un(this.contents),a=b.$un(this.overrides),d=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const P of s)if(k.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(l,P.contents);for(const p of P.overrides){const[w]=a.filter(E=>D.$ub(E.identifiers,p.identifiers));w?(this.h(w.contents,p.contents),w.keys.push(...p.keys),w.keys=D.$Mb(w.keys)):a.push(b.$un(p))}for(const p of P.keys)d.indexOf(p)===-1&&d.push(p)}return new S(l,d,a,k.every(P=>P instanceof S)?void 0:k)}g(s){const l=this.i(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const a={};for(const d of D.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let k=this.contents[d];const P=l[d];P&&(typeof k=="object"&&typeof P=="object"?(k=b.$un(k),this.h(k,P)):k=P),a[d]=k}return new S(a,this.keys,this.overrides)}h(s,l){for(const a of Object.keys(l)){if(a in s&&$.$Jf(s[a])&&$.$Jf(l[a])){this.h(s[a],l[a]);continue}s[a]=b.$un(l[a])}}i(s){let l=null,a=null;const d=k=>{k&&(a?this.h(a,k):a=b.$un(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===s?l=k.contents:k.identifiers.includes(s)&&d(k.contents);return d(l),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.j(s,l,!0)}setValue(s,l){this.j(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,R.$Fi)(this.contents,s),C.$Vn.test(s)&&this.overrides.splice(this.overrides.findIndex(a=>D.$ub(a.identifiers,(0,C.$Wn)(s))),1))}j(s,l,a){(0,R.$Ei)(this.contents,s,l,d=>console.error(d)),a=a||this.keys.indexOf(s)===-1,a&&this.keys.push(s),C.$Vn.test(s)&&this.overrides.push({identifiers:(0,C.$Wn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$Di)(this.contents[s],d=>console.error(d))})}}e.$2n=S;class h{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,l){if(!$.$Qf(s)){const a=this.g(s);this.parseRaw(a,l)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,l){this.a=s;const{contents:a,keys:d,overrides:k,restricted:P,hasExcludedProperties:p}=this.h(s,l);this.b=new S(a,d,k,p?[s]:void 0),this.c=P||[]}g(s){let l={},a=null,d=[];const k=[],P=[];function p(E){Array.isArray(d)?d.push(E):a!==null&&(d[a]=E)}const w={onObjectBegin:()=>{const E={};p(E),k.push(d),d=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{d=k.pop()},onArrayBegin:()=>{const E=[];p(E),k.push(d),d=E,a=null},onArrayEnd:()=>{d=k.pop()},onLiteralValue:p,onError:(E,A,T)=>{P.push({error:E,offset:A,length:T})}};if(s)try{g.$in(s,w),l=d[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return l}h(s,l){const a=m.$Gn.as(C.$Ln.Configuration).getConfigurationProperties(),d=this.i(s,a,!0,l);s=d.raw;const k=(0,R.$Di)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),P=Object.keys(s),p=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:k,keys:P,overrides:p,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(s,l,a,d){let k=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:k};const P={},p=[];for(const w in s)if(C.$Vn.test(w)&&a){const E=this.i(s[w],l,!1,d);P[w]=E.raw,k=k||E.hasExcludedProperties,p.push(...E.restricted)}else{const E=l[w],A=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&p.push(w),!d.exclude?.includes(w)&&(d.include?.includes(w)||(A===void 0||d.scopes===void 0||d.scopes.includes(A))&&!(d.skipRestricted&&E?.restricted))?P[w]=s[w]:k=!0}return{raw:P,restricted:p,hasExcludedProperties:k}}j(s,l){const a=[];for(const d of Object.keys(s))if(C.$Vn.test(d)){const k={};for(const P in s[d])k[P]=s[d][P];a.push({identifiers:(0,C.$Wn)(d),keys:Object.keys(k),contents:(0,R.$Di)(k,l)})}return a}}e.$3n=h;class f extends I.$Tc{constructor(s,l,a,d){super(),this.c=s,this.f=l,this.g=d,this.b=this.B(new O.$Ud),this.onDidChange=this.b.event,this.a=new h(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&a.isEqual(k.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$4n=f;class o{constructor(s,l,a,d,k,P,p,w,E,A,T,U,N){this.a=s,this.b=l,this.c=a,this.overrideIdentifiers=d,this.d=k,this.f=P,this.g=p,this.h=w,this.i=E,this.j=A,this.k=T,this.l=U,this.m=N}get value(){return v(this.c)}n(s,l,a){const d=s.inspect(l,a);return{get value(){return v(d.value)},get override(){return v(d.override)},get merged(){return v(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(s,l,a,d,k=new S,P=new S,p=new L.$Ac,w=new S,E=new L.$Ac){this.c=s,this.d=l,this.f=a,this.g=d,this.h=k,this.i=P,this.j=p,this.l=w,this.m=E,this.a=null,this.b=new L.$Ac,this.n=null}getValue(s,l,a){return this.p(s,l,a).getValue(s)}updateValue(s,l,a={}){let d;a.resource?(d=this.m.get(a.resource),d||(d=new S,this.m.set(a.resource,d))):d=this.l,l===void 0?d.removeValue(s):d.setValue(s,l),a.resource||(this.a=null)}inspect(s,l,a){const d=this.p(s,l,a),k=this.t(l.resource,a),P=l.resource?this.m.get(l.resource)||this.l:this.l,p=new Set;for(const w of d.overrides)for(const E of w.identifiers)d.getOverrideValue(s,E)!==void 0&&p.add(E);return new o(s,l,d.getValue(s),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,k||void 0,P)}keys(s){const l=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,l){this.j.set(s,l),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const a=[];if(!l){const{added:d,updated:k,removed:P}=c(this.c,s);l=[...d,...k,...P]}for(const d of l)for(const k of(0,C.$Wn)(d)){const P=this.c.getKeysForOverrideIdentifier(k),p=s.getKeysForOverrideIdentifier(k),w=[...p.filter(E=>P.indexOf(E)===-1),...P.filter(E=>p.indexOf(E)===-1),...P.filter(E=>!b.$yn(this.c.override(k).getValue(E),s.override(k).getValue(E)))];a.push([k,w])}return this.updateDefaultConfiguration(s),{keys:l,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:a,removed:d}=c(this.d,s),k=[...l,...a,...d];return k.length&&this.updatePolicyConfiguration(s),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.applicationConfiguration,s),P=[...l,...a,...d];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:k}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.localUserConfiguration,s),P=[...l,...a,...d];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:k}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.remoteUserConfiguration,s),P=[...l,...a,...d];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:k}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:a,removed:d,overrides:k}=c(this.workspaceConfiguration,s),P=[...l,...a,...d];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:k}}compareAndUpdateFolderConfiguration(s,l){const a=this.folderConfigurations.get(s),{added:d,updated:k,removed:P,overrides:p}=c(a,l),w=[...d,...k,...P];return(w.length||!a)&&this.updateFolderConfiguration(s,l),{keys:w,overrides:p}}compareAndDeleteFolderConfiguration(s){const l=this.folderConfigurations.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:d,removed:k,overrides:P}=c(l,void 0);return{keys:[...a,...d,...k],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,l,a){let d=this.q(l,a);return l.overrideIdentifier&&(d=d.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(d=d.merge(this.d)),d}q({resource:s},l){let a=this.r();if(l&&s){const d=l.getFolder(s);d&&(a=this.s(d.uri)||a);const k=this.m.get(s);k&&(a=a.merge(k))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let l=this.b.get(s);if(!l){const a=this.r(),d=this.j.get(s);d?(l=a.merge(d),this.b.set(s,l)):l=a}return l}t(s,l){if(l&&s){const a=l.getFolder(s);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,l)=>{const{contents:a,overrides:d,keys:k}=this.j.get(l);return s.push([l,{contents:a,overrides:d,keys:k}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this.i.keys.forEach(l=>s.add(l)),this.j.forEach(l=>l.keys.forEach(a=>s.add(a))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}v(s){const l=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>l.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>l.add(a)),this.i.getKeysForOverrideIdentifier(s).forEach(a=>l.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(d=>l.add(d))),[...l.values()]}static parse(s){const l=this.w(s.defaults),a=this.w(s.policy),d=this.w(s.application),k=this.w(s.user),P=this.w(s.workspace),p=s.folders.reduce((w,E)=>(w.set(y.URI.revive(E[0]),this.w(E[1])),w),new L.$Ac);return new i(l,a,d,k,new S,P,p,new S,new L.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$5n=i;function r(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,l=new Map;for(const d of u)d.keys.forEach(k=>s.add(k)),d.overrides.forEach(([k,P])=>{const p=(0,L.$xc)(l,k,new Set);P.forEach(w=>p.add(w))});const a=[];return l.forEach((d,k)=>a.push([k,[...d.values()]])),{keys:[...s.values()],overrides:a}}e.$6n=r;class n{constructor(s,l,a,d){this.change=s,this.f=l,this.g=a,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const P of k)this.affectedKeys.add(P);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,l){const a=this.a+s,d=this.d.indexOf(a);if(d<0)return!1;const k=d+a.length;if(k>=this.d.length)return!1;const P=this.d.charCodeAt(k);if(P!==this.b&&P!==this.c)return!1;if(l){const p=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.f?.workspace):void 0,w=this.g.getValue(s,l,this.h);return!b.$yn(p,w)}return!0}}e.$7n=n;function c(u,s){const{added:l,removed:a,updated:d}=t(s?.rawConfiguration,u?.rawConfiguration),k=[],P=u?.getAllOverrideIdentifiers()||[],p=s?.getAllOverrideIdentifiers()||[];if(s){const w=p.filter(E=>!P.includes(E));for(const E of w)k.push([E,s.getKeysForOverrideIdentifier(E)])}if(u){const w=P.filter(E=>!p.includes(E));for(const E of w)k.push([E,u.getKeysForOverrideIdentifier(E)])}if(s&&u){for(const w of P)if(p.includes(w)){const E=t({contents:u.getOverrideValue(void 0,w)||{},keys:u.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});k.push([w,[...E.added,...E.removed,...E.updated]])}}return{added:l,removed:a,updated:d,overrides:k}}function t(u,s){const l=u?s?u.keys.filter(k=>s.keys.indexOf(k)===-1):[...u.keys]:[],a=s?u?s.keys.filter(k=>u.keys.indexOf(k)===-1):[...s.keys]:[],d=[];if(u&&s){for(const k of s.keys)if(u.keys.indexOf(k)!==-1){const P=(0,R.$Gi)(s.contents,k),p=(0,R.$Gi)(u.contents,k);b.$yn(P,p)||d.push(k)}}return{added:l,removed:a,updated:d}}}),define(ke[255],Se([1,0,22,4,3,82]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prb=e.$orb=e.$nrb=e.$mrb=void 0;const L=(y,R,C)=>{const m=new Uint8Array(16);for(let h=0;h<16;h++)m[h]=Math.round(Math.random()*256);const v=(0,D.$Ce)(D.$ie.wrap(m));return[`GET ws://localhost${y}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$mrb=L,e.$nrb=D.$ie.fromString(`\r
\r
`);async function b(y,R,C,m,v){y.write(D.$ie.fromString((0,e.$mrb)(R,C,m)));const S=new g.$Sc;try{return await new Promise((h,f)=>{let o;S.add(y.onData(i=>{o?o=D.$ie.concat([o,i],o.byteLength+i.byteLength):o=i;const r=o.indexOf(e.$nrb);if(r===-1)return;h(y),y.pauseData();const n=o.slice(r+e.$nrb.byteLength);n.byteLength&&v.onData.fire(n)})),S.add(y.onClose(i=>f(i??new Error("socket closed")))),S.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(h){throw y.dispose(),h}finally{S.dispose()}}e.$orb=b;class $ extends g.$Tc{constructor(R,C){super(),this.g=R,this.a=this.B(new O.$Xd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new O.$Ud),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,R,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$prb=$}),define(ke[64],Se([1,0,14,5]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.RemoteAuthorityResolverErrorCode=e.$9k=e.$8k=e.RemoteConnectionType=e.$7k=void 0,e.$7k=(0,O.$5h)("remoteAuthorityResolverService");var g;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$8k=I;class L{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$9k=L;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,v){super(C),this._message=C,this._code=m,this._detail=v,this.isHandled=m===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,$.prototype)}}e.$0k=$;function y(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.$$k=y}),define(ke[65],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0;function O(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$_k=O;function g(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.$al=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$bl=I;function L(y){const{host:R,port:C}=$(y);if(typeof C>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:C}}e.$cl=L;function b(y,R){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=R),{host:C,port:m}}e.$dl=b;function $(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(ke[26],Se([1,0,12,5,65]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.TargetPlatform=e.ExtensionType=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em="extensions.user.cache",e.$fm="extensions.builtin.cache",e.$gm="undefined_publisher",e.$hm=["ui","workspace","web"];function I(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$im=I,e.$jm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(L||(e.ExtensionType=L={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f>"u"||f===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){const i=typeof f=="string"?f:f.value,r=typeof o=="string"?o:o.value;return D.$$e(i,r)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$km=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const o of f)this.add(o)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$lm=y;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,o){this.c.set($.toKey(f),o)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$mm=R;function C(h){return m(h)}e.$nm=C;function m(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.$om=m;function v(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.$pm=v;function S(h,f){if(f){const o=`onResolveRemoteAuthority:${(0,g.$al)(f)}`;return!!h.activationEvents?.includes(o)}return!1}e.$qm=S,e.$rm=(0,O.$5h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,14,26]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gF=e.$fF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(L,b){this.a.set(L,b)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const b=Object.create(null);for(const $ of L){const y=this.readActivationEvents($);y.length>0&&(b[O.$km.toKey($.identifier)]=y)}return b}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const b=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${O.$km.toKey(L.identifier)}`);if(!L.contributes)return b;for(const $ in L.contributes){const y=this.a.get($);if(!y)continue;const R=L.contributes[$],C=Array.isArray(R)?R:[R];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$fF=g,e.$gF=new g}),define(ke[256],Se([1,0,11,22,21,14,4,3,57,38,30,82,64,65]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.PersistentConnectionEventType=e.$kl=e.$jl=e.$il=e.ConnectionType=void 0;const S=30*1e3;var h;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function f(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(K){const W=new g.$5d;return setTimeout(()=>W.cancel(),K),W.token}function i(K,W){if(K.isCancellationRequested||W.isCancellationRequested)return g.CancellationToken.Cancelled;const re=new g.$5d;return K.onCancellationRequested(()=>re.cancel()),W.onCancellationRequested(()=>re.cancel()),re.token}class r{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new b.$Sc,this.promise=new Promise((re,ye)=>{this.f=re,this.g=ye}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function n(K,W){const re=new r(W);return re.registerDisposable(K.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),ge=J(de);ge?re.reject(ge):re.resolve(de)})),re.promise}function c(K,W,re,ye,de,ge,x,te){const G=new r(te),ie=y.$Qd.create(!1);return K.info(`Creating a socket (${x})...`),$.mark(`code/willCreateSocket/${ge}`),W.connect(re,ye,de,x).then(fe=>{G.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${x}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),K.info(`Creating a socket (${x}) was successful after ${ie.elapsed()} ms.`),G.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${x}) returned an error after ${ie.elapsed()} ms.`),K.error(fe),G.reject(fe)}),G.promise}function t(K,W){const re=new r(W);return K.then(ye=>{re.didTimeout||re.resolve(ye)},ye=>{re.didTimeout||re.reject(ye)}),re.promise}async function u(K,W,re,ye){const de=we(K,W);K.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,v.$bl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,f(W),`renderer-${f(W)}-${K.reconnectionToken}`,ye)}catch(fe){throw K.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),K.logService.error(fe),fe}K.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let x,te;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(ge,null),x=K.reconnectionProtocol,te=!1):(x=new C.$Sh({socket:ge}),te=!0),K.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const G=await t(K.signService.createNewMessage((0,R.$pg)()),ye),ie={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};x.sendControl(O.$ie.fromString(JSON.stringify(ie)));try{const fe=await n(x,i(ye,o(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(K.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(K.signService.validate(G,fe.signedData),ye)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Pe=await t(K.signService.sign(fe.data),ye),be={type:"connectionType",commit:K.commit,signedData:Pe,desiredConnectionType:W};return re&&(be.args=re),K.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(O.$ie.fromString(JSON.stringify(be))),{protocol:x,ownsProtocol:te}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(K.logService.error(`${de} the handshake timed out. Error:`),K.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(fe)),te&&Z(x),fe}}async function s(K,W,re,ye){const de=Date.now(),ge=we(K,W),{protocol:x,ownsProtocol:te}=await u(K,W,re,ye),G=new r(ye);return G.registerDisposable(x.onControlMessage(ie=>{const fe=JSON.parse(ie.toString()),ve=J(fe);ve?(K.logService.error(`${ge} received error control message when negotiating connection. Error:`),K.logService.error(ve),te&&Z(x),G.reject(ve)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${oe(de)}!`),G.resolve({protocol:x,firstMessage:fe}))})),G.promise}async function l(K,W){const{protocol:re}=await s(K,1,void 0,W);return{protocol:re}}async function a(K,W,re){const{protocol:ye,firstMessage:de}=await s(K,2,W,re),ge=de&&de.debugPort;return{protocol:ye,debugPort:ge}}async function d(K,W,re){const ye=Date.now(),de=we(K,3),{protocol:ge}=await u(K,3,W,re);return K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${oe(ye)}!`),ge}async function k(K,W,re){const{connectTo:ye,connectionToken:de}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:de,reconnectionToken:W,reconnectionProtocol:re,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function P(K,W,re){return w(K,async ye=>{const{protocol:de}=await l(ye,g.CancellationToken.None);return new X(K,W,re,ye.reconnectionToken,de)})}e.$il=P;async function p(K,W){return w(K,async re=>{const{protocol:ye,debugPort:de}=await a(re,W,g.CancellationToken.None);return new ue(K,W,re.reconnectionToken,ye,de)})}e.$jl=p;async function w(K,W){for(let ye=1;;ye++)try{const de=(0,R.$pg)(),ge=await k(K,de,null);return await W(ge)}catch(de){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(de);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(de),B.triggerPermanentFailure(0,0,m.$0k.isHandled(de)),de}}async function E(K,W,re){const ye=await k(K,(0,R.$pg)(),null);return await d(ye,{host:W,port:re},g.CancellationToken.None)}e.$kl=E;function A(K){return(0,D.$Sg)(W=>new Promise((re,ye)=>{const de=setTimeout(re,K*1e3);W.onCancellationRequested(()=>{clearTimeout(de),re()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(W,re){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.type=0}}e.$ll=U;class N{constructor(W,re,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$ml=N;class j{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=2}}e.$nl=j;class F{constructor(W,re,ye){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.type=4}}e.$ol=F;class M{constructor(W,re,ye,de){this.reconnectionToken=W,this.millisSinceLastIncomingData=re,this.attempt=ye,this.handled=de,this.type=3}}e.$pl=M;class B extends b.$Tc{static triggerPermanentFailure(W,re,ye){this._permanentFailure=!0,this.f=W,this.g=re,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(W=>W.y())}static debugPauseSocketWriting(){this.j.forEach(W=>W.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(W,re,ye,de,ge){super(),this.t=W,this.u=re,this.reconnectionToken=ye,this.protocol=de,this.w=ge,this.m=this.B(new L.$Ud),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new F(this.reconnectionToken,0,0)),this.B(de.onSocketClose(x=>{const te=_(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(x=>{const te=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Rc)(()=>{const x=B.j.indexOf(this);x>=0&&B.j.splice(x,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const W=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const re=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<re.length?re[ye]:re[re.length-1];try{if(de>0){const x=A(de);this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,x)),this.u.logService.info(`${W} waiting for ${de} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${W} resolving connection...`);const ge=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${W} connecting to ${ge.connectTo}...`),await this.G(ge,o(S)),this.u.logService.info(`${W} reconnected!`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$0k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,I.$4)(ge)){this.u.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$0k){this.u.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$0k.isHandled(ge));break}this.u.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(W,re,ye){this.w?B.triggerPermanentFailure(W,re,ye):this.D(W,re,ye)}D(W,re,ye){this.m.fire(new M(this.reconnectionToken,W,re,ye)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ql=B;class X extends B{constructor(W,re,ye,de,ge){super(1,W,de,ge,!0),this.client=this.B(new C.$Qh(ge,{remoteAuthority:re,clientId:ye},W.ipcLogger))}async G(W,re){await l(W,re)}}e.$rl=X;class ue extends B{constructor(W,re,ye,de,ge){super(2,W,ye,de,!1),this.H=re,this.debugPort=ge}async G(W,re){await a(W,this.H,re)}}e.$sl=ue;function Z(K){try{K.acceptDisconnect();const W=K.getSocket();K.dispose(),W.dispose()}catch(W){(0,I.$1)(W)}}function J(K){if(K&&K.type==="error"){const W=new Error(`Connection error: ${K.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Y(K,W){for(;K.length<W;)K+=" ";return K}function he(K,W){return`[remote-connection][${Y(f(K),13)}][${W.substr(0,5)}\u2026]`}function _(K,W,re){return`${he(K,W)}[${re?"reconnect":"initial"}]`}function we(K,W){return`${_(W,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function oe(K){return`${Date.now()-K} ms`}}),define(ke[257],Se([1,0,3,5]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=void 0,e.$el=(0,O.$5h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(L,b){return this.a[L]??=[],this.a[L].push(b),(0,D.$Rc)(()=>{const $=this.a[L]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[L]?.splice($,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,b,$,y){const R=this.b(L);if(!R)throw new Error(`No socket factory found for ${L}`);return R.connect(L,b,$,y)}}e.$fl=g}),define(ke[258],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const L=String(D.a++);return this.b.set(L,I),{id:L,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const L=this.b.get(g.id);if(!L)return!1;this.b.delete(g.id);try{return L.validate(I)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$96b=D}),define(ke[109],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=void 0,e.$gl="signService",e.$hl=(0,D.$5h)(e.$gl)}),define(ke[138],Se([1,0,258]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=void 0;class O extends D.$96b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(L=>new L.signer().sign(I))}h(){return new Promise((I,L)=>me(["vsda"],I,L))}}e.$4$b=O}),define(ke[259],Se([1,0,10,50,30]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,y,R,C,m,v,S,h,f){const o=Object.create(null);o["common.machineId"]=v,o["common.sqmId"]=S,o.sessionID=(0,g.$pg)()+Date.now(),o.commitHash=C,o.version=m,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$h)(D.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=R,o["common.product"]=f||"desktop",h&&(o["common.msftInternal"]=h);let i=0;const r=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(o["common.snap"]="true");const n=I(y);return n&&(o["common.platformDetail"]=n),o}e.$Ho=L;function b($){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return $.some(C=>R===C)}e.$Io=b}),define(ke[260],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=void 0,e.$tl=(0,D.$5h)("telemetryService"),e.$ul=(0,D.$5h)("customEndpointTelemetryService"),e.$vl="telemetry.currentSessionDate",e.$wl="telemetry.firstSessionDate",e.$xl="telemetry.lastSessionDate",e.$yl="telemetry.machineId",e.$zl="telemetry.sqmId",e.$Al="telemetry",e.$Bl="telemetry.telemetryLevel",e.$Cl="telemetry.enableCrashReporter",e.$Dl="telemetry.enableTelemetry";var O;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(ke[87],Se([1,0,24,18,4,45,65,259,260]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;class y{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$Jo=y;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ko=R,e.$Lo=new R;class C{async publicLog(a,d,k){}async publicLogError(a,d,k){}}e.$Mo=C,e.$No="telemetry",e.$Oo="extensionTelemetryLog",e.$Po={log:()=>null,flush:()=>Promise.resolve(null)};function m(l,a){return g.Event.debounce(a.onDidChangeConfiguration,(k,P)=>{const p=k?new Set([...k.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:p}},1e3,!0)(k=>{k.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,I.$Bi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$Qo=m;function v(l,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!l.enableTelemetry)}e.$Ro=v;function S(l,a){return a.extensionTestsLocationURI?!0:!(a.isBuilt||a.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.$So=S;function h(l){const a=l.getValue($.$Bl),d=l.getValue($.$Cl);if(l.getValue($.$Dl)===!1||d===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$To=h;function f(l){const a={},d={},k={};r(l,k);for(let P in k){P=P.length>150?P.substr(P.length-149):P;const p=k[P];typeof p=="number"?d[P]=p:typeof p=="boolean"?d[P]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${p.length}`),a[P]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(a[P]=p)}return{properties:a,measurements:d}}e.$Uo=f;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(l){if(!l)return"none";const a=(0,L.$al)(l);return o.has(a)?a:"other"}e.$Vo=i;function r(l,a,d=0,k){if(l)for(const P of Object.getOwnPropertyNames(l)){const p=l[P],w=k?k+P:P;Array.isArray(p)?a[w]=(0,D.$zn)(p):p instanceof Date?a[w]=p.toISOString():(0,O.$Jf)(p)?d<2?r(p,a,d+1,w+"."):a[w]=(0,D.$zn)(p):a[w]=p}}function n(l,a){const d=l.msftInternalDomains||[],k=a.getValue("telemetry.internalTesting");return(0,b.$Io)(d)||k}e.$Wo=n;function c(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.$Xo=c;function t(l,a){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let d=l;const k=[];for(const E of a)for(;;){const A=E.exec(l);if(!A)break;k.push([A.index,E.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(d="";;){const E=p.exec(l);if(!E)break;const A=k.some(([T,U])=>E.index<U&&T<p.lastIndex);!P.test(E[0])&&!A&&(d+=l.substring(w,E.index)+"<REDACTED: user-file-path>",w=p.lastIndex)}return w<l.length&&(d+=l.substr(w)),d}function u(l){if(!l)return l;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of a)if(d.regex.test(l))return`<REDACTED: ${d.label}>`;return l}function s(l,a){return(0,D.$wn)(l,d=>{if(d instanceof y||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let k=d.replaceAll("%20"," ");k=t(k,a);for(const P of a)k=k.replace(P,"");return k=u(k),k}})}e.$Yo=s}),define(ke[261],Se([1,0,12,134,26,10,2,14,50,87]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;function R(s,l){return s.uuid&&l.uuid?s.uuid===l.uuid:s.id===l.id?!0:(0,D.$6e)(s.id,l.id)===0}e.$Zo=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(l){const a=l.manifest?l.manifest.version:l.version,d=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new m(l.identifier,a,d)}static parse(l){const a=C.exec(l);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(l,a,d="undefined"){this.version=a,this.targetPlatform=d,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof m?R(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$1o=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const l=v.exec(s);return l&&l[1]?[f(l[1]),l[2]]:[f(s),void 0]}e.$2o=S;function h(s,l){return`${s}.${l}`}e.$3o=h;function f(s){return s.toLowerCase()}e.$4o=f;function o(s,l){return f(h(s??g.$gm,l))}e.$5o=o;function i(s,l){const a=[],d=k=>{for(const P of a)if(P.some(p=>R(l(p),l(k))))return P;return null};for(const k of s){const P=d(k);P?P.push(k):a.push([k])}return a}e.$6o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$7o=r;function n(s){return{id:new y.$Jo(s.identifier.id),name:new y.$Jo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$8o=n,e.$9o=new g.$km("pprice.better-merge");function c(s,l){const a=[],d=l.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const k=d.shift();if(k&&a.every(P=>!R(P.identifier,{id:k}))){const P=s.filter(p=>R(p.identifier,{id:k}));P.length===1&&(a.push(P[0]),d.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$0o=c;async function t(s,l){if(!I.$k)return!1;let a;try{a=(await s.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){l.debug("Error while getting the os-release file.",(0,b.$0)(k))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(s,l){const a=await t(s,l),d=(0,O.$to)(a?"alpine":I.$u,$.$ec);return l.debug("ComputeTargetPlatform:",d),d}e.$$o=u}),define(ke[262],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=e.$Lr=void 0;function D($){return[...$.entries()]}e.$Lr=D;function O($){return $?[...$.entries()]:[]}e.$Mr=O;function g($){return new Map($)}e.$Nr=g;function I($){return new Map($??[])}e.$Or=I;function L($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),O(y[1].descriptionMap)])}e.$Pr=L;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$Qr=b}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,L=5){const b=I($=>{const y=typeof $=="string"?$:$.data;let R=this.a.get(g);if(R){R.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),L);R={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,R)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$Grb=D}),define(ke[264],Se([1,0,11,78,61,4,18,2,207,108,37]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.IconFontDefinition=e.IconContribution=e.$vw=void 0,e.$vw={IconContribution:"base.contributions.icons"};var C;(function(n){function c(t,u){let s=t.defaults;for(;g.ThemeIcon.isThemeIcon(s);){const l=S.getIcon(s.id);if(!l)return;s=l.defaults}return s}n.getDefinition=c})(C||(e.IconContribution=C={}));var m;(function(n){function c(u){return{weight:u.weight,style:u.style,src:u.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=c;function t(u){const s=l=>(0,L.$Hf)(l)?l:void 0;if(u&&Array.isArray(u.src)&&u.src.every(l=>(0,L.$Hf)(l.format)&&(0,L.$Hf)(l.location)))return{weight:s(u.weight),style:s(u.style),src:u.src.map(l=>({format:l.format,location:b.URI.parse(l.location)}))}}n.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class v{constructor(){this.a=new I.$Ud,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,t,u,s){const l=this.b[c];if(l){if(u&&!l.description){l.description=u,this.d.properties[c].markdownDescription=`${u} $(${c})`;const k=this.e.enum.indexOf(c);k!==-1&&(this.e.enumDescriptions[k]=u),this.a.fire()}return l}const a={id:c,description:u,defaults:t,deprecationMessage:s};this.b[c]=a;const d={$ref:"#/definitions/icons"};return s&&(d.deprecationMessage=s),u&&(d.markdownDescription=`${u}: $(${c})`),this.d.properties[c]=d,this.e.enum.push(c),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const t=this.e.enum.indexOf(c);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,t){const u=this.f[c];return u||(this.f[c]=t,this.a.fire(),t)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(l,a)=>l.id.localeCompare(a.id),t=l=>{for(;g.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(l=>this.b[l]);for(const l of s.filter(a=>!!a.description).sort(c))u.push(`|<i class="${t(l)}"></i>|${l.id}|${g.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const l of s.filter(a=>!g.ThemeIcon.isThemeIcon(a.defaults)).sort(c))u.push(`|<i class="${t(l)}"></i>|${l.id}|`);return u.join(`
`)}}const S=new v;R.$Gn.add(e.$vw.IconContribution,S);function h(n,c,t,u){return S.registerIcon(n,c,t,u)}e.$ww=h;function f(){return S}e.$xw=f;function o(){const n=(0,O.$9j)();for(const c in n){const t="\\"+n[c].toString(16);S.registerIcon(c,{fontCharacter:t})}}o(),e.$yw="vscode://schemas/icons";const i=R.$Gn.as(y.$Hn.JSONContribution);i.registerSchema(e.$yw,S.getIconSchema());const r=new D.$eh(()=>i.notifySchemaChanged(e.$yw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$zw=h("widget-close",O.$$j.close,(0,$.localize)(2,null)),e.$Aw=h("goto-previous-location",O.$$j.arrowUp,(0,$.localize)(3,null)),e.$Bw=h("goto-next-location",O.$$j.arrowDown,(0,$.localize)(4,null)),e.$Cw=g.ThemeIcon.modify(O.$$j.sync,"spin"),e.$Dw=g.ThemeIcon.modify(O.$$j.loading,"spin")}),define(ke[88],Se([1,0,4,45,5,13]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.ProvidedOnAutoForward=e.$Bv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Av=e.$zv=void 0,e.$zv=(0,g.$5h)("tunnelService"),e.$Av=(0,g.$5h)("sharedTunnelsService");var L;(function(f){f.Http="http",f.Https="https"})(L||(e.TunnelProtocol=L={}));var b;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(f){return!!f.forwardPort}e.$Bv=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function R(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(o)return{address:o[1],port:+o[2]}}e.$Cv=R,e.$Dv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$Dv.indexOf(f)>=0}e.$Ev=C,e.$Fv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$Fv.indexOf(f)>=0}e.$Gv=m;function v(f,o,i,r){if(i===1)return!1;if(i===2&&m(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return f<1024}e.$Hv=v;class S{constructor(o,i,r){this.remoteAddress=o,this.localAddress=i,this.b=r,this.a=new D.$Ud,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Iv=S;let h=class{constructor(o,i){this.k=o,this.l=i,this.a=new D.$Ud,this.onTunnelOpened=this.a.event,this.b=new D.$Ud,this.onTunnelClosed=this.b.event,this.c=new D.$Ud,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const r of i){const n=Array.from(r.values());for(const c of n){const t=await c.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,r,n,c){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(m(o)||C(o))&&(o=e.$Dv[0]);const r=this.s(o,i);if(r)return++r.refcount,r.value}openTunnel(o,i,r,n,c,t=!1,u,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${c}.`);const l=this.f??o;if(!l)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(l,i,r,n,c,t,u,s);return a?a.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,r),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.o(d);return(d.tunnelRemoteHost!==i||d.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&d.privacy!==u&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const r=i.get(o.tunnelRemotePort);r&&(r.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,r))}}}}async p(o,i,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const n=r.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),n}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const r=this.e.get(o);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.p(o,i,n)}}q(o,i,r){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:r})}async r(o,i){const r=this.e.get(o);if(r){const n=r.get(i),c=n?await n.value:void 0;(!c||typeof c=="string")&&r.delete(i),r.size===0&&this.e.delete(o)}}s(o,i){const r=[o];C(o)?(r.push(...e.$Dv),r.push(...e.$Fv)):m(o)&&r.push(...e.$Fv);const n=r.map(c=>this.e.get(c));for(const c of n){const t=c?.get(i);if(t)return t}}canTunnel(o){return!!R(o)}u(o,i,r,n,c,t,u){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this.j.add(s);const l=n===void 0?r:n,a={elevationRequired:c?this.isPortPrivileged(l):!1},d={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==b.Private:void 0,protocol:u},k=o.forwardPort(d,a);return k?(this.q(i,r,k),k.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),k}};e.$Jv=h,e.$Jv=h=Ge([We(0,I.$mj),We(1,O.$yi)],h)}),define(ke[265],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=void 0,e.$Zk=(0,D.$5h)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Kv=void 0,e.$Kv=(0,D.$5h)("editSessionIdentityService");var O;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(ke[267],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=void 0;function O($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$BK=O;function g($){if($.folders.length)return $.folders.every(y=>O(y.uri))?$.folders[0].uri:void 0;if($.configuration&&O($.configuration))return $.configuration}e.$CK=g;function I($){return g($)?.scheme}e.$DK=I;function L($){return g($)?.authority}e.$EK=L;function b($){return g($)!==void 0}e.$FK=b}),define(ke[40],Se([1,0,209,16,77,23,2,5,17]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.WorkbenchState=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0,e.$bi=(0,b.$5h)("contextService");function y(l){const a=l;return typeof a?.id=="string"&&L.URI.isUri(a.uri)}e.$ci=y;function R(l){return typeof l?.id=="string"&&!y(l)&&!m(l)}e.$di=R,e.$ei={id:"ext-dev"},e.$fi={id:"empty-window"};function C(l,a){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,O.$nc)(l)}:a?e.$ei:e.$fi;const d=l;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$gi=C;function m(l){const a=l;return typeof a?.id=="string"&&L.URI.isUri(a.configPath)}e.$hi=m;function v(l){const a=l;if(a?.uri)return{id:a.id,uri:L.URI.revive(a.uri)};const d=l;if(d?.configPath)return{id:d.id,configPath:L.URI.revive(d.configPath)};if(l?.id)return{id:l.id}}e.$ii=v;var S;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function h(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$ji=h;function f(l){const a=l;return!!(a&&typeof a=="object"&&L.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$ki=f;class o{constructor(a,d,k,P,p){this.h=a,this.j=k,this.k=P,this.l=p,this.c=g.$$h.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=g.$$h.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$li=o;class i{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,I.$Gg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$mi=i;function r(l){return new i({uri:l,index:0,name:(0,I.$Cg)(l)},{uri:l.toString()})}e.$ni=r,e.$oi="code-workspace",e.$pi=`.${e.$oi}`,e.$qi=[{name:(0,D.localize)(0,null),extensions:[e.$oi]}],e.$ri="workspace.json";function n(l,a){return I.$xg.isEqualOrParent(l,a.untitledWorkspacesHome)}e.$si=n;function c(l){let a;return L.URI.isUri(l)?a=l:a=l.configuration,a?.scheme===$.Schemas.tmp}e.$ti=c,e.$ui="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$ui}e.$vi=t;function u(l,a){return!n(l,a)&&!c(l)}e.$wi=u;function s(l){return(typeof l=="string"?(0,O.$oc)(l):(0,I.$Eg)(l))===e.$pi}e.$xi=s}),define(ke[268],Se([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,11,30,12,18]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.ProfileResourceType=void 0;var r;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(l){const a=l;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&L.URI.isUri(a.location)&&L.URI.isUri(a.globalStorageHome)&&L.URI.isUri(a.settingsResource)&&L.URI.isUri(a.keybindingsResource)&&L.URI.isUri(a.tasksResource)&&L.URI.isUri(a.snippetsHome)&&L.URI.isUri(a.extensionsResource))}e.$1k=n,e.$2k=(0,R.$5h)("IUserDataProfilesService");function c(l,a){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:L.URI.revive(l.location).with({scheme:a}),globalStorageHome:L.URI.revive(l.globalStorageHome).with({scheme:a}),settingsResource:L.URI.revive(l.settingsResource).with({scheme:a}),keybindingsResource:L.URI.revive(l.keybindingsResource).with({scheme:a}),tasksResource:L.URI.revive(l.tasksResource).with({scheme:a}),snippetsHome:L.URI.revive(l.snippetsHome).with({scheme:a}),extensionsResource:L.URI.revive(l.extensionsResource).with({scheme:a}),cacheHome:L.URI.revive(l.cacheHome).with({scheme:a}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}e.$3k=c;function t(l,a,d,k,P,p){return{id:l,name:a,location:d,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:p&&P?.useDefaultFlags?.globalState?p.globalStorageHome:(0,I.$Gg)(d,"globalStorage"),settingsResource:p&&P?.useDefaultFlags?.settings?p.settingsResource:(0,I.$Gg)(d,"settings.json"),keybindingsResource:p&&P?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,I.$Gg)(d,"keybindings.json"),tasksResource:p&&P?.useDefaultFlags?.tasks?p.tasksResource:(0,I.$Gg)(d,"tasks.json"),snippetsHome:p&&P?.useDefaultFlags?.snippets?p.snippetsHome:(0,I.$Gg)(d,"snippets"),extensionsResource:p&&P?.useDefaultFlags?.extensions?p.extensionsResource:(0,I.$Gg)(d,"extensions.json"),cacheHome:(0,I.$Gg)(k,l),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$4k=t;let u=class extends g.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,d,k,P){super(),this.t=a,this.u=d,this.w=k,this.y=P,this.f=!0,this.h=this.B(new O.$Ud),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$Ud),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$Ud),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$Ud),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Gg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Gg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),d=[a];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,i.$Hf)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}d.push(t((0,I.$Dg)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},a))}}catch(p){this.y.error(p)}const k=new v.$Ac,P=new Map;if(d.length)try{const p=this.Q();if(p.workspaces)for(const[w,E]of Object.entries(p.workspaces)){const A=L.URI.parse(w),T=d.find(U=>U.id===E);T&&k.set(A,T)}if(p.emptyWindows)for(const[w,E]of Object.entries(p.emptyWindows)){const A=d.find(T=>T.id===E);A&&P.set(w,A)}}catch(p){this.y.error(p)}this.z={profiles:d,workspaces:k,emptyWindows:P}}return this.z}D(){const a=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const d="Temp",k=new RegExp(`${(0,o.$Ne)(d)}\\s(\\d+)`);let P=0;for(const w of this.profiles){const E=k.exec(w.name),A=E?parseInt(E[1]):0;P=A>P?A:P}const p=`${d} ${P+1}`;return this.createProfile((0,D.$Si)((0,f.$pg)()).toString(16),p,{transient:!0},a)}async createNamedProfile(a,d,k){return this.createProfile((0,D.$Si)((0,f.$pg)()).toString(16),a,d,k)}async createProfile(a,d,k,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(a,d,k);return P&&await this.setProfileForWorkspace(P,p),p}async F(a,d,k){if(!(0,i.$Hf)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(d);return P||(P=(async()=>{try{const p=this.profiles.find(A=>A.name===d||A.id===a);if(p)return p;const w=t(a,d,(0,I.$Gg)(this.profilesHome,a),this.g,k,this.defaultProfile);await this.u.createFolder(w.location);const E=[];return this.j.fire({profile:w,join(A){E.push(A)}}),await h.Promises.settled(E),this.I([w],[],[]),w}finally{this.r.delete(d)}})(),this.r.set(d,P)),P}async updateProfile(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(P=>P.id===a.id);if(!k)throw new Error(`Profile '${a.name}' does not exist`);return k=t(k.id,d.name??k.name,k.location,this.g,{shortName:d.shortName??k.shortName,icon:d.icon===null?void 0:d.icon??k.icon,transient:d.transient??k.isTransient,useDefaultFlags:d.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(P=>P.id===a.id);if(!d)throw new Error(`Profile '${a.name}' does not exist`);const k=[];this.m.fire({profile:d,join(P){k.push(P)}});try{await Promise.allSettled(k)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(P){(0,y.$Gk)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(P=>P.id===d.id);if(!k)throw new Error(`Profile '${d.name}' does not exist`);this.L(a,k)}unsetWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(d=>d.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(a.map(d=>this.removeProfile(d)))}getProfileForWorkspace(a){const d=this.G(a);return L.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(a){return(0,m.$ci)(a)?a.uri:(0,m.$hi)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location)))}I(a,d,k){const P=[...this.profiles,...a],p=[];this.s.profiles=[];for(let w of P)w.isDefault||d.some(E=>w.id===E.id)||(w=k.find(E=>w.id===E.id)??w,w.isTransient?this.s.profiles.push(w):p.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(p),this.z=void 0,this.J(a,d,k)}J(a,d,k){this.h.fire({added:a,removed:d,updated:k,all:this.profiles})}L(a,d,k){k=d?.isTransient?!0:k,k||this.L(a,void 0,!0);const P=this.G(a),p=k?this.s:this.C;L.URI.isUri(P)?(p.workspaces.delete(P),d&&p.workspaces.set(P,d)):(p.emptyWindows.delete(P),d&&p.emptyWindows.set(P,d)),k||this.M()}M(){const a={};for(const[k,P]of this.C.workspaces.entries())a[k.toString()]=P.id;const d={};for(const[k,P]of this.C.emptyWindows.entries())d[k.toString()]=P.id;this.R({workspaces:a,emptyWindows:d}),this.z=void 0}N(a){const d={},k=this.D();if(a.workspaces)for(const[p,w]of Object.entries(a.workspaces)){const E=L.URI.parse(w);d[p]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}const P={};if(a.emptyWindows)for(const[p,w]of Object.entries(a.emptyWindows)){const E=L.URI.parse(w);P[p]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}return{workspaces:d,emptyWindows:P}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$5k=u,e.$5k=u=Ge([We(0,$.$_h),We(1,y.$pk),We(2,S.$Zk),We(3,C.$mj)],u);class s extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$6k=s}),define(ke[269],Se([1,0,11,4,3,57,18,188,5,268]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$tp=e.$sp=e.$rp=void 0,e.$rp="__$__isNewStorageMarker",e.$sp="__$__targetStorageMarker",e.$tp=(0,$.$5h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function v(i){const r=i.get(e.$sp);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$up=v;class S extends g.$Tc{static{this.a=60*1e3}constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new O.$Xd),this.c=this.B(new O.$Xd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$Ud),this.onWillSaveState=this.f.event,this.h=this.B(new D.$eh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,c){return O.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),c)}n(){this.j.value=(0,D.$ih)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:c,external:t}=n;if(c===e.$sp){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:c,target:this.J(r)[c],external:t})}w(r){this.f.fire({reason:r})}get(r,n,c){return this.P(n)?.get(r,c)}getBoolean(r,n,c){return this.P(n)?.getBoolean(r,c)}getNumber(r,n,c){return this.P(n)?.getNumber(r,c)}getObject(r,n,c){return this.P(n)?.getObject(r,c)}storeAll(r,n){this.y(()=>{for(const c of r)this.store(c.key,c.value,c.scope,c.target,n)})}store(r,n,c,t,u=!1){if((0,L.$Qf)(n)){this.remove(r,c,u);return}this.y(()=>{this.z(r,c,t),this.P(c)?.set(r,n,u)})}remove(r,n,c=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,c)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const c=[],t=this.J(r);for(const u of Object.keys(t))t[u]===n&&c.push(u);return c}z(r,n,c,t=!1){const u=this.J(n);typeof c=="number"?u[r]!==c&&(u[r]=c,this.P(n)?.set(e.$sp,JSON.stringify(u),t)):typeof u[r]=="number"&&(delete u[r],this.P(n)?.set(e.$sp,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?v(n):Object.create(null)}isNew(r){return this.getBoolean(e.$rp,r)===!0}async flush(r=R.NONE){this.f.fire({reason:r});const n=this.P(-1),c=this.P(0),t=this.P(1);switch(r){case R.NONE:await D.Promises.settled([n?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([n?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return o(r,n,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(R.NONE),(0,y.$1k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||h(n)&&h(r))}N(r,n,c){this.y(()=>{const t=new Set;for(const[u,s]of r)t.add(u),n.get(u)!==s&&this.u(c,{key:u,external:!0});for(const[u]of n.items)t.has(u)||this.u(c,{key:u,external:!0})})}}e.$vp=S;function h(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$wp=h;class f extends S{constructor(){super(),this.U=this.B(new b.$pp(new b.$qp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$pp(new b.$qp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$pp(new b.$qp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$xp=f;async function o(i,r,n,c,t,u){const s=A=>{try{return JSON.parse(A)}catch{return A}},l=new Map,a=new Map;i.forEach((A,T)=>{l.set(T,A),a.set(T,s(A))});const d=new Map,k=new Map;r.forEach((A,T)=>{d.set(T,A),k.set(T,s(A))});const P=new Map,p=new Map;n.forEach((A,T)=>{P.set(T,A),p.set(T,s(A))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const w=[];if(l.forEach((A,T)=>{w.push({key:T,value:A})}),console.table(w),console.groupEnd(),console.log(a),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];d.forEach((T,U)=>{A.push({key:U,value:T})}),console.table(A),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${u})`);const E=[];P.forEach((A,T)=>{E.push({key:T,value:A})}),console.table(E),console.groupEnd(),console.log(p)}e.$yp=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Sfc=D}),define(ke[58],Se([1,0,17,23,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new O.$vg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Vfc=I,e.$Wfc=(0,g.$5h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0,e.$mN=(0,D.$5h)("IExtHostInitDataService")}),define(ke[270],Se([1,0,214,13,250,27]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;let L=class extends g.$tO{constructor($,y,R){const C=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=R.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$3hc=L,e.$3hc=L=Ge([We(1,O.$nj),We(2,I.$mN)],L)}),define(ke[271],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=e.$Egc=void 0;class O{constructor(L,b,$){this.h=new Map,this.a=L,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$eh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of y.values())R.complete()}catch(R){for(const C of y.values())C.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,b){let $=this.f[L];return typeof $>"u"&&($=b),$}update(L,b){this.f[L]=b;const $=this.h.get(L);if($!==void 0)return $.p;const y=new D.$ph;return this.h.set(L,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Egc=O;class g extends O{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,b){super(L.identifier.value,!0,b),this.j=L}}e.$Fgc=g}),define(ke[272],Se([1,0,4,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class g{constructor(L){this.c=L,this.a=new D.$Ud,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Ud,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,b,$,y){const C=this.c.getNotebookDocument(O.URI.revive(L)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(L,b){this.c.getNotebookDocument(O.URI.revive(L)).acceptDirty(b)}$acceptModelSaved(L){const b=this.c.getNotebookDocument(O.URI.revive(L));this.a.fire(b.apiNotebook)}}e.$shc=g}),define(ke[20],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0,e.$9M=(0,D.$5h)("IExtHostRpcService");class O{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$0M=O}),define(ke[273],Se([1,0,26,4]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class g{#e;constructor(L,b){this.b=new O.$Ud,this.onDidChange=this.b.event,this.a=D.$km.toKey(L.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(L){return this.#e.get(this.a,L)}store(L,b){return this.#e.store(this.a,L,b)}delete(L){return this.#e.delete(this.a,L)}}e.$Mgc=g}),define(ke[66],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=void 0,e.$cgc=(0,D.$5h)("IURITransformerService");class O{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$dgc=O}),define(ke[274],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kb=e.$$kb=void 0;class O{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new O,C=JSON.stringify(b,(v,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const h=I(S);if(h)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:h,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=y.buffers.map(v=>{const S=new Uint8Array(v);return D.$ie.wrap(S)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$$kb=g;function I(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(b,$){const y=$.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),R=$.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const S=v,{index:h}=S,f=y[h];if(S.view)switch(S.view.type){case 1:return new Int8Array(f,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return v}:void 0;return{message:JSON.parse(b,R),arrayBuffers:y}}e.$_kb=L}),define(ke[275],Se([1,0,276,387,388,62,2,13,389]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;const y=!1;function R(r,n,c,t,u,s){const l=s.environment.useHostProxy,a=typeof l=="boolean"?l:!s.remote.isRemote,d={resolveProxy:p=>r.resolveProxy(p),lookupProxyAuthorization:f.bind(void 0,t,u,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(n),addCertificatesV2:()=>v(n),log:t,getLogLevel:()=>{const p=t.getLevel();switch(p){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return w(p)}function w(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const p=[];if(s.remote.isRemote&&p.push((0,$.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const w=r.loadCertificates();w.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),p.push(w)}return(await Promise.all(p)).flat()},env:process.env},k=(0,$.createProxyResolver)(d),P=C(d,k);return h(c,P)}e.$yic=R;function C(r,n){return{http:Object.assign(D,(0,$.createHttpPatch)(r,D,n)),https:Object.assign(O,(0,$.createHttpPatch)(r,O,n)),net:Object.assign(I,(0,$.createNetPatch)(r,I)),tls:Object.assign(g,(0,$.createTlsPatch)(r,g))}}function m(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}function v(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",y)&&!!n.get("systemCertificates")}const S=new Map;function h(r,n){return r.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,u=t._load;t._load=function(l,a,d){if(l==="net")return n.net;if(l==="tls")return n.tls;if(l!=="http"&&l!=="https")return u.apply(this,arguments);const k=c.findSubstr(L.URI.file(a.filename));let P=S.get(k);if(P||S.set(k,P={}),!P[l]){const p=n[l];P[l]={...p}}return P[l]}})}async function f(r,n,c,t,u,s,l,a){const d=t[s];l&&(t[s]=l),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${d}`);const k=l||d,P=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(n,P,u),P.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const p=await new Promise((U,N)=>{me(["kerberos"],U,N)}),w=new URL(s),E=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${E}`),"Negotiate "+await(await p.initializeClient(E)).step("")}catch(p){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let o=!1;function i(r,n,c){o||!n.length||(o=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(ke[277],Se([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;function O(I){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:I,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function g(I){return new D.$3m(O(I))}e.$2r=g}),define(ke[139],Se([1,0,224,18,2,3,5,37,32,17,44,180,39]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=e.$2E=e.EditorsOrder=e.$1E=e.CloseDirection=e.$ZE=e.$YE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.EditorInputCapabilities=e.$PE=e.SaveReason=e.Verbosity=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=void 0,e.$CE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$DE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$EE="workbench.editor.sidebysideEditor",e.$FE="workbench.editors.textDiffEditor",e.$GE="workbench.editors.binaryResourceDiffEditor";var v;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var S;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function h(oe){const K=oe;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$HE=h;function f(oe,K,W){for(const re of W.visibleEditorPanes)if(re.group.id===K&&oe.matches(re.input))return re.getViewState()}e.$IE=f;function o(oe){if(k(oe))return!1;const K=oe;return g.URI.isUri(K?.resource)}e.$JE=o;function i(oe){if(k(oe))return!1;const K=oe;return K?.original!==void 0&&K.modified!==void 0}e.$KE=i;function r(oe){if(k(oe))return!1;const K=oe;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}e.$LE=r;function n(oe){if(k(oe)||i(oe))return!1;const K=oe;return K?.primary!==void 0&&K.secondary!==void 0}e.$ME=n;function c(oe){if(k(oe))return!1;const K=oe;return K?K.resource===void 0||K.resource.scheme===y.Schemas.untitled||K.forceUntitled===!0:!1}e.$NE=c;function t(oe){if(k(oe))return!1;const K=oe;return g.URI.isUri(K?.base?.resource)&&g.URI.isUri(K?.input1?.resource)&&g.URI.isUri(K?.input2?.resource)&&g.URI.isUri(K?.result?.resource)}e.$OE=t;var u;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var s;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class l{constructor(){this.a=new Map}registerSource(K,W){let re=this.a.get(K);return re||(re={source:K,label:W},this.a.set(K,re)),re.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$PE=new l;var a;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class d extends I.$Tc{}e.$QE=d;function k(oe){return oe instanceof d}e.$RE=k;function P(oe){const K=oe;return g.URI.isUri(K?.preferredResource)}function p(oe){const K=oe;return k(K?.primary)&&k(K?.secondary)}e.$SE=p;function w(oe){const K=oe;return k(K?.modified)&&k(K?.original)}e.$TE=w;function E(oe,K,W,re,ye){return we(re,[(0,C.$Oi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const de={...W,limits:{size:Number.MAX_VALUE}};oe.openEditor(K,de)}}),(0,C.$Oi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$UE=E;function A(oe){return k(oe?.editor)}e.$VE=A;function T(oe){const K=oe;return A(oe)&&K?.group!==void 0}e.$WE=T;function U(oe){const K=oe;return typeof K?.groupId=="number"&&k(K.editor)}e.$XE=U;var N;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var j;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var F;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class M{getOriginalUri(K,W){if(!K)return;if(t(K))return e.$ZE.getOriginalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(W?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===F.ANY)return this.getOriginalUri(ye,{filterByScheme:W.filterByScheme})??this.getOriginalUri(de,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===F.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const re=P(K)?K.preferredResource:K.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}a(K){return p(K)||n(K)?{primary:K.primary,secondary:K.secondary}:w(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,W){if(!K)return;if(t(K))return e.$ZE.getCanonicalUri(K.result,W);if(W?.supportSideBySide){const{primary:ye,secondary:de}=this.a(K);if(ye&&de){if(W?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===F.ANY)return this.getCanonicalUri(ye,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:W.filterByScheme});K=W.supportSideBySide===F.PRIMARY?ye:de}}if(i(K)||r(K)||n(K)||t(K))return;const re=K.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}b(K,W){if(Array.isArray(W)){if(W.some(re=>K.scheme===re))return K}else if(W===K.scheme)return K}}var B;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(B||(e.EditorCloseMethod=B={}));function X(oe,K,W,re){if(!oe.isSticky(K))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return W===B.MOUSE||W===B.KEYBOARD;case"mouse":return W===B.MOUSE;case"keyboard":return W===B.KEYBOARD}return!1}e.$YE=X,e.$ZE=new M;var ue;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(K){const W=this.a=K.get(L.$4h);for(const[re,ye]of this.c)this.e(re,ye,W);this.c.clear()}e(K,W,re){const ye=re.createInstance(W);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,O.$Sf)(this.b)}registerEditorSerializer(K,W){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,W,this.a):this.c.set(K,W),(0,I.$Rc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}b.$Gn.add(e.$CE.EditorFactory,new Z);async function J(oe,K,W){return!oe||!oe.length?[]:await Promise.all(oe.map(async re=>{const ye=g.URI.revive(re.fileUri);if(!ye){W.info("Cannot resolve the path because it is not valid.",re);return}if(!await K.canHandleResource(ye)){W.info("Cannot resolve the path because it cannot be handled",re);return}let ge=re.exists,x=re.type;if(typeof ge!="boolean"||typeof x!="number")try{x=(await K.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(G){W.error(G),ge=!1}if(!ge&&re.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",re);return}if(x===$.FileType.Directory){W.info("Cannot resolve the path because it is a directory",re);return}const te={...re.options,pinned:!0};return ge?{resource:ye,options:te}:{resource:ye,options:te,forceUntitled:!0}}))}e.$1E=J;var Y;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function he(oe){const K=oe;if(!K)return!1;const W=K;if(W.modified)return he(W.modified);const re=K;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$2E=he;function _(oe){return(0,R.$Qi)(oe)}e.$3E=_;function we(oe,K,W){const re=(0,R.$Ri)(oe,K);return re.forceMessage=W?.forceMessage,re.forceSeverity=W?.forceSeverity,re.allowDialog=W?.allowDialog,re}e.$4E=we}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.$$E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$0E=e.ViewContentGroups=e.$9E=e.$8E=e.ViewContainerLocation=e.Extensions=e.$7E=e.$6E=e.$5E=void 0,e.$5E="views",e.$6E=(0,O.localize)(0,null),e.$7E=(0,C.$ww)("default-view-icon",R.$$j.window,(0,O.localize)(1,null));var m;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var v;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$8E=[0,1,2];function S(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$9E=S;class h extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Ud),this.onDidRegister=this.c.event,this.f=this.B(new D.$Ud),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,l,a){const d=this.get(s.id);if(d)return d;const k=s;return k.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,L.$xc)(this.g,l,[]).push(k),a?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:l}),k}deregisterViewContainer(s){for(const l of this.g.keys()){const a=this.g.get(l),d=a?.indexOf(s);if(d!==-1){a?.splice(d,1),a.length===0&&this.g.delete(l),this.f.fire({viewContainer:s,viewContainerLocation:l});return}}}get(s){return this.all.filter(l=>l.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(a=>a?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(l=>this.getViewContainerLocation(l)===s)}}b.$Gn.add(m.ViewContainersRegistry,new h);var f;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(f||(e.ViewContentGroups=f={}));function o(u,s){const l=u.group??f.More,a=s.group??f.More;return l!==a?l.localeCompare(a):(u.order??5)-(s.order??5)}class i extends I.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Ud),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Ud),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Ud),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Ud),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(s,l){this.registerViews2([{views:s,viewContainer:l}])}registerViews2(s){s.forEach(({views:l,viewContainer:a})=>this.r(l,a)),this.c.fire(s)}deregisterViews(s,l){const a=this.s(s,l);a.length&&this.f.fire({views:a,viewContainer:l})}moveViews(s,l){for(const a of this.m.keys())if(a!==l){const d=this.s(s,a);d.length&&(this.r(d,l),this.g.fire({views:d,from:a,to:l}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const l of this.j){const a=(this.m.get(l)||[]).filter(d=>d.id===s)[0];if(a)return a}return null}getViewContainer(s){for(const l of this.j)if((this.m.get(l)||[]).filter(d=>d.id===s)[0])return l;return null}registerViewWelcomeContent(s,l){return this.n.add(s,l),this.h.fire(s),(0,I.$Rc)(()=>{this.n.delete(s,l),this.h.fire(s)})}registerViewWelcomeContent2(s,l){const a=new Map;for(const[d,k]of l)this.n.add(s,k),a.set(d,(0,I.$Rc)(()=>{this.n.delete(s,k),this.h.fire(s)}));return this.h.fire(s),a}getViewWelcomeContent(s){const l=[];return this.n.forEach(s,a=>l.push(a)),l.sort(o)}r(s,l){let a=this.m.get(l);a||(a=[],this.m.set(l,a),this.j.push(l));for(const d of s){if(this.getView(d.id)!==null)throw new Error((0,O.localize)(2,null,d.id));a.push(d)}}s(s,l){const a=this.m.get(l);if(!a)return[];const d=[],k=[];for(const P of a)s.includes(P)?d.push(P):k.push(P);return d.length&&(k.length?this.m.set(l,k):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),d}}b.$Gn.add(m.ViewsRegistry,new i),e.$0E=(0,g.$5h)("viewDescriptorService");var r;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(s,l){this.c=!1,this.d=!1,(0,y.$xn)(this,s),this.d=!!l,this.resolve=async a=>{if(l&&!this.c){const d=await l(a);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$$E=c;class t extends Error{constructor(s){super((0,O.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$_E=t}),define(ke[279],Se([1,0,2,29,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$3F=e.$2F=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(O.$Ts.isIRange)}e.$2F=I;function L(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$3F=L;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$4F=(0,g.$5h)("IChatService")}),define(ke[140],Se([1,0,4,11,226]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Ud,this.n=new D.$Ud,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,R){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,R,b)};v(S)}},R)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,O.$6g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,O.$6g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Elb=I}),define(ke[280],Se([1,0,227,46,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$MH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$LH=e.MemoryRangeType=e.$KH=e.State=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=void 0,e.$HG="workbench.view.debug",e.$IG="workbench.debug.variablesView",e.$JG="workbench.debug.watchExpressionsView",e.$KG="workbench.debug.callStackView",e.$LG="workbench.debug.loadedScriptsView",e.$MG="workbench.debug.breakPointsView",e.$NG="workbench.debug.disassemblyView",e.$OG="workbench.panel.repl",e.$PG="workbench.panel.repl.view",e.$QG=new O.$jj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$RG=new O.$jj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$SG=new O.$jj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$TG="debugUx",e.$UG=new O.$jj(e.$TG,"default",{type:"string",description:D.localize(3,null)}),e.$VG=new O.$jj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$WG=new O.$jj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$XG=new O.$jj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$YG=new O.$jj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$ZG=new O.$jj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$1G=new O.$jj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$2G=new O.$jj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$3G=new O.$jj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$4G=new O.$jj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$5G=new O.$jj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$6G=new O.$jj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$7G=new O.$jj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$8G=new O.$jj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$9G=new O.$jj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$0G=new O.$jj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$$G=new O.$jj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$_G=new O.$jj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$aH=new O.$jj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$bH=new O.$jj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$cH=new O.$jj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$dH=new O.$jj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$eH=new O.$jj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$fH=new O.$jj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$gH=new O.$jj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$hH=new O.$jj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$iH=new O.$jj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$jH=new O.$jj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$kH=new O.$jj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$lH=new O.$jj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$mH=new O.$jj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$nH=new O.$jj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$oH=new O.$jj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$pH=new O.$jj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$qH=new O.$jj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$rH=new O.$jj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$sH=new O.$jj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$tH=new O.$jj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$uH=new O.$jj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$vH=new O.$jj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$wH=new O.$jj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$xH=new O.$jj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$yH=new O.$jj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$zH=new O.$jj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$AH=new O.$jj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$BH=new O.$jj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$CH=new O.$jj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$DH=new O.$jj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$EH=new O.$jj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$FH=I,e.$GH="editor.contrib.debug",e.$HH="editor.contrib.breakpoint",e.$IH="debug",e.$JH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var L;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(L||(e.State=L={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$KH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$LH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$MH=(0,g.$5h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE",m[m.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}))}),define(ke[281],Se([1,0,12,2,16,24,17,29,21,19]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=void 0;const R=/{([^}]+)}/g;function C(P,p,w){return P.replace(R,function(E,A){return p&&A.length>0&&A[0]!=="_"?E:w&&w.hasOwnProperty(A)?w[A]:E})}e.$9F=C;function m(P){const p={};for(const w of Object.keys(P))w.startsWith("!")||(p[w]=P[w]);return p}e.$0F=m;function v(P){return P.configuration.request==="attach"&&!S(P)&&(!P.parentSession||v(P.parentSession))}e.$$F=v;function S(P){let p=P.configuration.type;if(p)return p==="vslsShare"&&(p=P.configuration.adapterProxy.configuration.type),(0,D.$$e)(p,"extensionhost")||(0,D.$$e)(p,"pwa-extensionhost")?P:P.parentSession?S(P.parentSession):void 0}e.$_F=S;function h(P){return P.type&&(P.label||P.program||P.runtime)}e.$aG=h;function f(P,p,w){let E,A=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=T.exec(P);){const N=U.index+1,j=N+U[0].length;if(N<=p&&j>=w){E=U[0],A=N;break}}if(E){const N=/\w+/g;let j=null;for(;(j=N.exec(E))&&!(j.index+1+A+j[0].length>=w););j&&(E=E.substring(0,N.lastIndex))}return E?{start:A,end:A+E.length-1}:{start:0,end:0}}e.$bG=f;async function o(P,p,w,E){if(P.evaluatableExpressionProvider.has(p)){const A=P.evaluatableExpressionProvider.ordered(p),T=(0,y.$Hb)(await Promise.all(A.map(async U=>{try{return await U.provideEvaluatableExpression(p,w,E??$.CancellationToken.None)}catch{return}})));if(T.length>0){let U=T[0].expression;const N=T[0].range;return U||(U=p.getLineContent(w.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:U}}}else{const A=p.getLineContent(w.lineNumber),{start:T,end:U}=f(A,w.column,w.column),N=A.substring(T-1,U);return{matchingExpression:N,range:new b.$Ts(w.lineNumber,T,w.lineNumber,T+N.length)}}return null}e.$cG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(P){return!!(P&&P.match(i))}e.$dG=r;function n(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(r(P.path))return O.URI.parse(P.path);if((0,g.$ic)(P.path))return O.URI.file(P.path)}return P.path}function c(P){if(typeof P.path=="object"){const p=O.URI.revive(P.path);if(p)return p.scheme===L.Schemas.file?p.fsPath:p.toString()}return P.path}function t(P,p){const w=p?n:c,E=(0,I.$un)(P);return s(E,(A,T)=>{A&&T&&(T.path=w(T))}),E}e.$eG=t;function u(P,p){const w=p?n:c,E=(0,I.$un)(P);return s(E,(A,T)=>{!A&&T&&(T.path=w(T))}),E}e.$fG=u;function s(P,p){switch(P.type){case"event":{const w=P;switch(w.event){case"output":p(!1,w.body.source);break;case"loadedSource":p(!1,w.body.source);break;case"breakpoint":p(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=P;switch(w.command){case"setBreakpoints":p(!0,w.arguments.source);break;case"breakpointLocations":p(!0,w.arguments.source);break;case"source":p(!0,w.arguments.source);break;case"gotoTargets":p(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(E=>p(!1,E));break;default:break}break}case"response":{const w=P;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(E=>p(!1,E.source));break;case"loadedSources":w.body.sources.forEach(E=>p(!1,E));break;case"scopes":w.body.scopes.forEach(E=>p(!1,E.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(E=>p(!1,E.source));break;case"setBreakpoints":w.body.breakpoints.forEach(E=>p(!1,E.source));break;case"disassemble":w.body?.instructions.forEach(A=>p(!1,A.location));break;default:break}break}}}function l(P){return P.filter(p=>!p.presentation?.hidden).sort((p,w)=>p.presentation?w.presentation?p.presentation.group?w.presentation.group?p.presentation.group!==w.presentation.group?p.presentation.group.localeCompare(w.presentation.group):a(p.presentation.order,w.presentation.order):-1:w.presentation.group?1:a(p.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$gG=l;function a(P,p){return typeof P!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:P-p}async function d(P,p){const w=P.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(w!=="none"&&(await p.saveAll(),w==="allEditorsInActiveGroup")){const E=p.activeEditorPane;E&&E.input.resource?.scheme===L.Schemas.untitled&&await p.save({editor:E.input,groupId:E.group.id})}await P.reloadConfiguration()}e.$hG=d;const k=(P,p)=>!P||!p?P===p:P.name===p.name&&P.path===p.path&&P.sourceReference===p.sourceReference;e.$iG=k}),define(ke[282],Se([1,0,51,62,24,16,10,12,31,228,140]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=e.$$hc=e.$0hc=e.$9hc=void 0;class C extends R.$Elb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",r=>this.w(r))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(C.b);for(const c of n){const t=c.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$9hc=C;class m extends C{startSession(){return new Promise((o,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$0hc=m;class v extends m{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$$hc=v;class S extends m{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.path,o)}}e.$_hc=S;class h extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,r=this.y.options||{};try{if(o)if(I.$ic(o)){if(!await $.Promises.exists(o))throw new Error(y.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=g.$xn(g.$un(process.env),r.env)),o==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const u=D.fork(i[0],i.slice(1),t);if(!u.pid)throw new Error(y.localize(2,null,i[0]));this.x=u}else throw new Error(y.localize(3,null));else{const c={env:n};r.cwd&&(c.cwd=r.cwd),this.x=D.spawn(o,i,c)}this.x.on("error",c=>{this.m.fire(c)}),this.x.on("exit",(c,t)=>{this.n.fire(c)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.m.fire(c)}),this.x.stdin.on("error",c=>{this.m.fire(c)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),L.$i?new Promise((o,i)=>{const r=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,c,t){if(n)return i(n)});r.on("exit",o),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const r=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?r.runtime=I.$jc(i,o.runtime):r.runtime=o.runtime),o.runtimeArgs&&(r.runtimeArgs=o.runtimeArgs),o.program&&(I.$ic(o.program)?r.program=o.program:r.program=I.$jc(i,o.program)),o.args&&(r.args=o.args);const n=o;return n.win&&(r.win=h.A(n.win,i)),n.winx86&&(r.winx86=h.A(n.winx86,i)),n.windows&&(r.windows=h.A(n.windows,i)),n.osx&&(r.osx=h.A(n.osx,i)),n.linux&&(r.linux=h.A(n.linux,i)),r}static platformAdapterExecutable(o,i){let r=Object.create(null);i=i.toLowerCase();for(const l of o)if(l.contributes){const a=l.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&b.$$e(d.type,i)).forEach(d=>{const k=h.A(d,l.extensionLocation.fsPath);r=g.$xn(r,k,l.isBuiltin)})}let n;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:L.$i?n=r.win||r.windows:L.$j?n=r.osx:L.$k&&(n=r.linux),n=n||r;const c=n.program||r.program,t=n.args||r.args,u=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(u)return{type:"executable",command:u,args:(s||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$aic=h}),define(ke[283],Se([1,0,51,33,10]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=void 0;function I(y,R){return new Promise((C,m)=>{let v="";const S=D.spawn(y,R);S.pid&&S.stdout.on("data",h=>{v+=h.toString()}),S.on("error",h=>{m(h)}),S.on("close",h=>{C(v)})})}async function L(y){if(y)if(g.$i){const R=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{R.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(R=>{const C=R.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$bic=L;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,R,C,m,v){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let h,f=" ";switch(S){case 1:if(h=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),m){const o=(0,O.$_f)(m);o&&(f+=`${o}:; `),f+=`cd ${h(m)}; `}if(v)for(const o in v){const i=v[o];i===null?f+=`Remove-Item env:${o}; `:f+=`\${env:${o}}='${i}'; `}if(R.length>0){const o=R.shift(),i=C?o:h(o);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of R)f+=r==="<"||r===">"||C?r:h(r),f+=" "}break;case 0:if(h=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),m){const o=(0,O.$_f)(m);o&&(f+=`${o}: && `),f+=`cd ${h(m)} && `}if(v){f+='cmd /C "';for(const o in v){let i=v[o];i===null?f+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),f+=`set "${o}=${i}" && `)}}for(const o of R)f+=o==="<"||o===">"||C?o:h(o),f+=" ";v&&(f+='"');break;case 2:{h=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${h(m)} ; `),v){f+="/usr/bin/env";for(const i in v){const r=v[i];r===null?f+=` -u ${o(i)}`:f+=` ${o(`${i}=${r}`)}`}f+=" "}for(const i of R)f+=i==="<"||i===">"||C?i:h(i),f+=" ";break}}return f}e.$cic=$}),define(ke[111],Se([1,0,22,34,53,100,17,16,10,46]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.$9I=e.$8I=e.CellStatusbarAlignment=e.$7I=e.$6I=e.$5I=e.NotebookEditorPriority=e.$4I=e.$3I=e.$2I=e.$1I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$ZI=e.$YI=e.$XI=e.$WI=e.CellKind=e.$VI=e.$UI=e.$TI=void 0,e.$TI="workbench.editor.notebook",e.$UI="workbench.editor.notebookTextDiffEditor",e.$VI="workbench.editor.interactive";var R;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(R||(e.CellKind=R={})),e.$WI=["application/json","application/javascript","text/html","image/svg+xml",I.$es.latex,I.$es.markdown,"image/png","image/jpeg",I.$es.text],e.$XI=[I.$es.latex,I.$es.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$es.text],e.$YI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$ZI="_notAvailable";var C;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var v;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var S;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var h;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var f;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var o;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var i;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(M){M.scheme=L.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${B.join("")}]+`),ue=7;function Z(oe,K){const W=K.toString(ue),ye=`${W.length<B.length?B[W.length-1]:"z"}${W}s${(0,D.$Ce)(D.$ie.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:M.scheme,fragment:ye})}M.generate=Z;function J(oe){if(oe.scheme!==M.scheme)return;const K=oe.fragment.indexOf("s");if(K<0)return;const W=parseInt(oe.fragment.substring(0,K).replace(X,""),ue),re=(0,D.$Be)(oe.fragment.substring(K+1)).toString();if(!isNaN(W))return{handle:W,notebook:oe.with({scheme:re,fragment:null})}}M.parse=J;function Y(oe,K){return oe.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${oe.scheme!==L.Schemas.file?oe.scheme:""}`})}M.generateCellOutputUri=Y;function he(oe){if(oe.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!K)return;const W=K[1]&&K[1]!==""?K[1]:void 0,re=K[2];return{outputId:W,notebook:oe.with({scheme:re||L.Schemas.file,fragment:null})}}M.parseCellOutputUri=he;function _(oe,K,W){return M.generate(oe,K).with({scheme:W})}M.generateCellPropertyUri=_;function we(oe,K){if(oe.scheme===K)return M.parse(oe.with({scheme:M.scheme}))}M.parseCellPropertyUri=we})(r||(e.CellUri=r={}));const n=M=>$.$i?M.replace(/\//g,"\\"):M;class c{constructor(B=[],X=e.$WI){this.e=X,this.d=[...new Set(B)].map(ue=>({pattern:ue,matches:O.$Lj(n(ue))}))}sort(B){const X=new Map(g.Iterable.map(B,Z=>[Z,n(Z)]));let ue=[];for(const{matches:Z}of this.d)for(const[J,Y]of X)if(Z(Y)){ue.push(J),X.delete(J);break}return X.size&&(ue=ue.concat([...X.keys()].sort((Z,J)=>this.e.indexOf(Z)-this.e.indexOf(J)))),ue}prioritize(B,X){const ue=this.f(B);if(ue===-1){this.d.unshift({pattern:B,matches:O.$Lj(n(B))});return}const Z=new Set(X.map(Y=>this.f(Y,ue)));Z.delete(-1);const J=Array.from(Z).sort();this.d.splice(ue+1,0,...J.map(Y=>this.d[Y]));for(let Y=J.length-1;Y>=0;Y--)this.d.splice(J[Y],1)}toArray(){return this.d.map(B=>B.pattern)}f(B,X=this.d.length){const ue=n(B);for(let Z=0;Z<X;Z++)if(this.d[Z].matches(ue))return Z;return-1}}e.$1I=c;function t(M,B,X,ue=(Z,J)=>Z===J){const Z=[];function J(_,we,oe){if(we===0&&oe.length===0)return;const K=Z[Z.length-1];K&&K.start+K.deleteCount===_?(K.deleteCount+=we,K.toInsert.push(...oe)):Z.push({start:_,deleteCount:we,toInsert:oe})}let Y=0,he=0;for(;;){if(Y===M.length){J(Y,0,B.slice(he));break}if(he===B.length){J(Y,M.length-Y,[]);break}const _=M[Y],we=B[he];if(ue(_,we)){Y+=1,he+=1;continue}X(we)?(J(Y,1,[]),Y+=1):(J(Y,0,[we]),he+=1)}return Z}e.$2I=t,e.$3I=new y.$jj("notebookEditorCursorAtBoundary","none"),e.$4I=new y.$jj("notebookEditorCursorAtLineBoundary","none");var u;(function(M){M.default="default",M.option="option"})(u||(e.NotebookEditorPriority=u={}));function s(M){const B=M;return!!((typeof B.include=="string"||O.$Mj(B.include))&&(typeof B.exclude=="string"||O.$Mj(B.exclude)))}e.$5I=s;function l(M,B,X){if(Array.isArray(M.viewType)&&M.viewType.indexOf(B)>=0||M.viewType===B)return!0;if(M.filenamePattern){const ue=s(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,Z=s(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(O.$Kj(ue,(0,b.$nc)(X.fsPath).toLowerCase()))return!(Z&&O.$Kj(Z,(0,b.$nc)(X.fsPath).toLowerCase()))}return!1}e.$6I=l,e.$7I={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var a;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class d{static{this.d="notebook/"}static create(B){return`${d.d}${B}`}static parse(B){if(B.startsWith(d.d))return B.substring(d.d.length)}}e.$8I=d;function k(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.$9I=k;const P=new TextDecoder;function p(M){const B=[];let X=!1;for(const Y of M)(B.length===0||X)&&(B.push(Y),X=!0);let ue=A(B);const Z=D.$ie.concat(B.map(Y=>D.$ie.wrap(Y))),J=F(Z);return ue=ue||J.byteLength!==Z.byteLength,{data:J,didCompression:ue}}e.$0I=p,e.$$I=`${String.fromCharCode(27)}[A`;const w=e.$$I.split("").map(M=>M.charCodeAt(0)),E=10;function A(M){let B=!1;return M.forEach((X,ue)=>{if(ue===0||X.length<e.$$I.length)return;const Z=M[ue-1],J=X.subarray(0,e.$$I.length);if(J[0]===w[0]&&J[1]===w[1]&&J[2]===w[2]){const Y=Z.lastIndexOf(E);if(Y===-1)return;B=!0,M[ue-1]=Z.subarray(0,Y),M[ue]=X.subarray(e.$$I.length)}}),B}function T(M){let B=M;do M=B,B=M.replace(/[^\n]\x08/gm,"");while(B.length<M.length);return M}function U(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const B=M.match(/^(.*)\r+/m)[1];let X=M.match(/\r+(.*)$/m)[1];X=X+B.slice(X.length,B.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return M}const N="\b".charCodeAt(0),j="\r".charCodeAt(0);function F(M){return!M.buffer.includes(N)&&!M.buffer.includes(j)?M:D.$ie.fromString(U(T(P.decode(M.buffer))))}}),define(ke[7],Se([1,0,19,14,80,28,100,12,18,2,30,26,32,64,111]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S){"use strict";var h,f,o,i,r,n,c,t,u,s,l,a,d,k,P,p,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$XM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$WM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.TestRunProfileKind=e.TestResultState=e.$CM=e.$BM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$AM=e.NotebookVariablesRequestKind=e.$zM=e.$yM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$xM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.ColorThemeKind=e.$rM=e.$qM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$pM=e.DebugConsoleMode=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$jM=e.$iM=e.FileChangeType=e.$hM=e.$gM=e.$fM=e.$eM=e.InlineCompletionTriggerKind=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.ConfigurationTarget=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$TL=e.ViewBadge=e.ProgressLocation=e.$SL=e.$RL=e.TaskScope=e.ShellQuoting=e.$QL=e.$PL=e.$OL=e.TaskPanelKind=e.TaskRevealKind=e.$NL=e.TerminalLocation=e.$ML=e.$LL=e.$KL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$JL=e.$IL=e.$HL=e.$GL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$FL=e.StatusBarAlignment=e.ViewColumn=e.$EL=e.$DL=e.$CL=e.$BL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$AL=e.$zL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.LanguageStatusSeverity=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.CodeActionTriggerKind=e.$nL=e.$mL=e.SymbolTag=e.SymbolKind=e.$lL=e.$kL=e.DocumentHighlightKind=e.$jL=e.$iL=e.$hL=e.$gL=e.DiagnosticSeverity=e.DiagnosticTag=e.$fL=e.$eL=e.FileEditType=e.$dL=e.$cL=e.$bL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(H){return Object.assign(H,{apply:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const Me=pe.length===1?[]:pe[1];return Reflect.construct(H,Me,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const[Me,...Ze]=pe;return Reflect.construct(H,Ze,Me.constructor)}}})}var A;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var T;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let U=h=class{static from(...q){let pe=q;return new h(function(){if(pe){for(const Me of pe)Me&&typeof Me.dispose=="function"&&Me.dispose();pe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$7K=U,e.$7K=U=h=Ge([E],U);let N=f=class{static Min(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Me=1;Me<q.length;Me++){const Ze=q[Me];Ze.isBefore(pe)&&(pe=Ze)}return pe}static Max(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Me=1;Me<q.length;Me++){const Ze=q[Me];Ze.isAfter(pe)&&(pe=Ze)}return pe}static isPosition(q){if(!q)return!1;if(q instanceof f)return!0;const{line:pe,character:Me}=q;return typeof pe=="number"&&typeof Me=="number"}static of(q){if(q instanceof f)return q;if(this.isPosition(q))return new f(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,pe){if(q<0)throw(0,O.$7)("line must be non-negative");if(pe<0)throw(0,O.$7)("character must be non-negative");this.c=q,this.e=pe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,pe=0){if(q===null||pe===null)throw(0,O.$7)();let Me;return typeof q>"u"?Me=0:typeof q=="number"?Me=q:(Me=typeof q.lineDelta=="number"?q.lineDelta:0,pe=typeof q.characterDelta=="number"?q.characterDelta:0),Me===0&&pe===0?this:new f(this.line+Me,this.character+pe)}with(q,pe=this.character){if(q===null||pe===null)throw(0,O.$7)();let Me;return typeof q>"u"?Me=this.line:typeof q=="number"?Me=q:(Me=typeof q.line=="number"?q.line:this.line,pe=typeof q.character=="number"?q.character:this.character),Me===this.line&&pe===this.character?this:new f(Me,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$8K=N,e.$8K=N=f=Ge([E],N);let j=o=class{static isRange(q){return q instanceof o?!0:q?N.isPosition(q.start)&&N.isPosition(q.end):!1}static of(q){if(q instanceof o)return q;if(this.isRange(q))return new o(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,pe,Me,Ze){let tt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ze=="number"?(tt=new N(q,pe),lt=new N(Me,Ze)):N.isPosition(q)&&N.isPosition(pe)&&(tt=N.of(q),lt=N.of(pe)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(q){return o.isRange(q)?this.contains(q.start)&&this.contains(q.end):N.isPosition(q)?!(N.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const pe=N.Max(q.start,this.c),Me=N.Min(q.end,this.e);if(!pe.isAfter(Me))return new o(pe,Me)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const pe=N.Min(q.start,this.c),Me=N.Max(q.end,this.end);return new o(pe,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,pe=this.end){if(q===null||pe===null)throw(0,O.$7)();let Me;return q?N.isPosition(q)?Me=q:(Me=q.start||this.start,pe=q.end||this.end):Me=this.start,Me.isEqual(this.c)&&pe.isEqual(this.end)?this:new o(Me,pe)}toJSON(){return[this.start,this.end]}};e.$9K=j,e.$9K=j=o=Ge([E],j);let F=i=class extends j{static isSelection(q){return q instanceof i?!0:q?j.isRange(q)&&N.isPosition(q.anchor)&&N.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,pe,Me,Ze){let tt,lt;if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ze=="number"?(tt=new N(q,pe),lt=new N(Me,Ze)):N.isPosition(q)&&N.isPosition(pe)&&(tt=N.of(q),lt=N.of(pe)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$0K=F,e.$0K=F=i=Ge([E],F);const M=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,O.$7)("connectionToken")};class B{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe,Me){if(typeof q!="string"||q.length===0)throw(0,O.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,O.$7)("port");typeof Me<"u"&&M(Me),this.host=q,this.port=Math.round(pe),this.connectionToken=Me}}e.$$K=B;class X{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe){this.makeConnection=q,this.connectionToken=pe,typeof pe<"u"&&M(pe)}}e.$_K=X;class ue extends Error{static NotAvailable(q,pe){return new ue(q,v.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(q){return new ue(q,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,pe=v.RemoteAuthorityResolverErrorCode.Unknown,Me){super(q),this._message=q,this._code=pe,this._detail=Me,Object.setPrototypeOf(this,ue.prototype)}}e.$aL=ue;var Z;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var J;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let Y=r=class{static isTextEdit(q){return q instanceof r?!0:q?j.isRange(q)&&typeof q.newText=="string":!1}static replace(q,pe){return new r(q,pe)}static insert(q,pe){return r.replace(new j(q,q),pe)}static delete(q){return r.replace(q,"")}static setEndOfLine(q){const pe=new r(new j(new N(0,0),new N(0,0)),"");return pe.newEol=q,pe}get range(){return this.c}set range(q){if(q&&!j.isRange(q))throw(0,O.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,O.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,O.$7)("newEol");this.f=q}constructor(q,pe){this.c=q,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$bL=Y,e.$bL=Y=r=Ge([E],Y);let he=n=class{static isNotebookCellEdit(q){return q instanceof n?!0:q?ei.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,pe){return new n(q,pe)}static insertCells(q,pe){return new n(new ei(q,q),pe)}static deleteCells(q){return new n(q,[])}static updateCellMetadata(q,pe){const Me=new n(new ei(q,q),[]);return Me.newCellMetadata=pe,Me}static updateNotebookMetadata(q){const pe=new n(new ei(0,0),[]);return pe.newNotebookMetadata=q,pe}constructor(q,pe){this.range=q,this.newCells=pe}};e.$cL=he,e.$cL=he=n=Ge([E],he);class _{static isSnippetTextEdit(q){return q instanceof _?!0:q?j.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,pe){return new _(q,pe)}static insert(q,pe){return _.replace(new j(q,q),pe)}constructor(q,pe){this.range=q,this.snippet=pe}}e.$dL=_;var we;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,pe,Me,Ze){this.c.push({_type:1,from:q,to:pe,options:Me,metadata:Ze})}createFile(q,pe,Me){this.c.push({_type:1,from:void 0,to:q,options:pe,metadata:Me})}deleteFile(q,pe,Me){this.c.push({_type:1,from:q,to:void 0,options:pe,metadata:Me})}e(q,pe,Me){this.c.push({_type:3,metadata:Me,uri:q,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(q,pe,Me,Ze){const tt=pe.start,lt=pe.end;(tt!==lt||Me.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:lt-tt,cells:Me,metadata:Ze})}g(q,pe,Me,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:pe,metadata:Me}})}replace(q,pe,Me,Ze){this.c.push({_type:2,uri:q,edit:new Y(pe,Me),metadata:Ze})}insert(q,pe,Me,Ze){this.replace(q,new j(pe,pe),Me,Ze)}delete(q,pe,Me){this.replace(q,pe,"",Me)}has(q){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===q.toString())}set(q,pe){if(pe)for(const Me of pe){if(!Me)continue;let Ze,tt;Array.isArray(Me)?(Ze=Me[0],tt=Me[1]):Ze=Me,he.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,tt):this.f(q,Ze.range,Ze.newCells,tt):_.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Ze,metadata:tt})}else{for(let Me=0;Me<this.c.length;Me++){const Ze=this.c[Me];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Me]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const pe=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===q.toString()&&pe.push(Me.edit);return pe}entries(){const q=new I.$Ac;for(const pe of this.c)if(pe._type===2){let Me=q.get(pe.uri);Me||(Me=[pe.uri,[]],q.set(pe.uri,Me)),Me[1].push(pe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$eL=oe,e.$eL=oe=Ge([E],oe);let K=c=class{static isSnippetString(q){return q instanceof c?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=c.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,pe=this.e++){if(typeof q=="function"){const Me=new c;Me.e=this.e,q(Me),this.e=Me.e,q=Me.value}else q=c.c(q);return this.value+="${",this.value+=pe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,pe=this.e++){const Me=q.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(q,pe){if(typeof pe=="function"){const Me=new c;Me.e=this.e,pe(Me),this.e=Me.e,pe=Me.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$fL=K,e.$fL=K=c=Ge([E],K);var W;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var re;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?j.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,pe){if(this.uri=q,pe)if(j.isRange(pe))this.range=j.of(pe);else if(N.isPosition(pe))this.range=new j(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$gL=ye,e.$gL=ye=t=Ge([E],ye);let de=class{static is(q){return q?typeof q.message=="string"&&q.location&&j.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,pe){this.location=q,this.message=pe}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.location.range.isEqual(pe.location.range)&&q.location.uri.toString()===pe.location.uri.toString()}};e.$hL=de,e.$hL=de=Ge([E],de);let ge=class{constructor(q,pe,Me=re.Error){if(!j.isRange(q))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=q,this.message=pe,this.severity=Me}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.severity===pe.severity&&q.code===pe.code&&q.severity===pe.severity&&q.source===pe.source&&q.range.isEqual(pe.range)&&(0,D.$ub)(q.tags,pe.tags)&&(0,D.$ub)(q.relatedInformation,pe.relatedInformation,de.isEqual)}};e.$iL=ge,e.$iL=ge=Ge([E],ge);let x=class{constructor(q,pe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=pe}};e.$jL=x,e.$jL=x=Ge([E],x);var te;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let G=class{constructor(q,pe=te.Text){this.range=q,this.kind=pe}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$kL=G,e.$kL=G=Ge([E],G);let ie=class{constructor(q,pe){this.uri=q,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$lL=ie,e.$lL=ie=Ge([E],ie);var fe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var ve;(function(H){H[H.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Pe=u=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,pe,Me,Ze,tt){this.name=q,this.kind=pe,this.containerName=tt,typeof Me=="string"&&(this.containerName=Me),Ze instanceof ye?this.location=Ze:Me instanceof j&&(this.location=new ye(Ze,Me)),u.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$mL=Pe,e.$mL=Pe=u=Ge([E],Pe);let be=s=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(s.validate)}constructor(q,pe,Me,Ze,tt){this.name=q,this.detail=pe,this.kind=Me,this.range=Ze,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$nL=be,e.$nL=be=s=Ge([E],be);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let z=class{constructor(q,pe){this.title=q,this.kind=pe}};e.$oL=z,e.$oL=z=Ge([E],z);let Q=class{static{l=this}static{this.c="."}constructor(q){this.value=q}append(q){return new l(this.value?this.value+l.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+l.c)}};e.$pL=Q,e.$pL=Q=l=Ge([E],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(q,pe){if(this.range=q,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$qL=ee,e.$qL=ee=Ge([E],ee);class V{constructor(q,pe,Me,Ze,tt,lt){this.kind=q,this.name=pe,this.detail=Me,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$rL=V;class ae{constructor(q,pe){this.fromRanges=pe,this.from=q}}e.$sL=ae;class le{constructor(q,pe){this.fromRanges=pe,this.to=q}}e.$tL=le;var Re;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let je=class{constructor(q,pe){this.range=q,this.command=pe}get isResolved(){return!!this.command}};e.$uL=je,e.$uL=je=Ge([E],je);let He=a=class{#e;static isMarkdownString(q){return q instanceof a?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,pe=!1){this.#e=new g.$gk(q,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,pe){return this.#e.appendCodeblock(pe??"",q),this}};e.$vL=He,e.$vL=He=a=Ge([E],He);let Je=class{constructor(q,pe){this.label=q,this.documentation=pe}};e.$wL=Je,e.$wL=Je=Ge([E],Je);let _e=class{constructor(q,pe){this.label=q,this.documentation=pe,this.parameters=[]}};e.$xL=_e,e.$xL=_e=Ge([E],_e);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$yL=ct,e.$yL=ct=Ge([E],ct);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Ae=class{constructor(q){this.value=q}};e.$zL=Ae,e.$zL=Ae=Ge([E],Ae);let Ue=class{constructor(q,pe,Me){this.position=q,this.label=pe,this.kind=Me}};e.$AL=Ue,e.$AL=Ue=Ge([E],Ue);var Le;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le||(e.CompletionTriggerKind=Le={}));var Ye;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Ye||(e.CompletionItemKind=Ye={}));var ne;(function(H){H[H.Deprecated=1]="Deprecated"})(ne||(e.CompletionItemTag=ne={}));let ce=class{constructor(q,pe){this.label=q,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$BL=ce,e.$BL=ce=Ge([E],ce);let Ie=class{constructor(q=[],pe=!1){this.items=q,this.isIncomplete=pe}};e.$CL=Ie,e.$CL=Ie=Ge([E],Ie);let Ve=class{constructor(q,pe,Me){this.insertText=q,this.range=pe,this.command=Me}};e.$DL=Ve,e.$DL=Ve=Ge([E],Ve);let Xe=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$EL=Xe,e.$EL=Xe=Ge([E],Xe);var nt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var it;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(it||(e.StatusBarAlignment=it={}));function Oe(H,q){return`${C.$km.toKey(H)}.${q}`}e.$FL=Oe;var pt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(pt||(e.TextEditorLineNumbersStyle=pt={}));var St;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(St||(e.TextDocumentSaveReason=St={}));var Nt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Nt||(e.TextEditorRevealType=Nt={}));var Wt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Wt||(e.TextEditorSelectionChangeKind=Wt={}));var Et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Kt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(H){function q(pe){switch(pe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(Wt||(e.TextEditorSelectionChangeKind=Wt={}));var Ot;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(H){function q(pe){switch(pe){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(Ot||(e.SyntaxTokenType=Ot={}));let Xt=class{constructor(q,pe){if(pe&&!y.URI.isUri(pe))throw(0,O.$7)("target");if(!j.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.target=pe}};e.$GL=Xt,e.$GL=Xt=Ge([E],Xt);let Ut=class{constructor(q,pe,Me,Ze){this.red=q,this.green=pe,this.blue=Me,this.alpha=Ze}};e.$HL=Ut,e.$HL=Ut=Ge([E],Ut);let Lt=class{constructor(q,pe){if(pe&&!(pe instanceof Ut))throw(0,O.$7)("color");if(!j.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.color=pe}};e.$IL=Lt,e.$IL=Lt=Ge([E],Lt);let et=class{constructor(q){if(!q||typeof q!="string")throw(0,O.$7)("label");this.label=q}};e.$JL=et,e.$JL=et=Ge([E],et);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Jt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Jt||(e.SourceControlInputBoxValidationType=Jt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class bt{constructor(q,pe,Me){if(this.startIndex=q,this.length=pe,this.tooltip=Me,typeof q!="number"||q<0)throw(0,O.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,O.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,O.$7)("tooltip")}}e.$KL=bt;class zt{constructor(q){this.uri=q}}e.$LL=zt;class qt{constructor(q){this.terminalCommand=q}}e.$ML=qt;var Dt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,O.$7)("options")}}e.$NL=ft;var At;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var xt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let Ct=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(q){switch(q){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(q,pe){if(this.label=pe,typeof q!="string"||typeof pe!="string")throw(0,O.$7)("name");this.c=q}get id(){return this.c}};e.$OL=Ct,e.$OL=Ct=d=Ge([E],Ct);function Qe(H){let q="";for(let pe=0;pe<H.length;pe++)q+=H[pe].replace(/,/g,",,")+",";return q}let Ft=class{constructor(q,pe,Me){if(typeof q!="string")throw(0,O.$7)("process");this.e=[],this.c=q,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Me):this.f=pe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,O.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)q.push(pe);return Qe(q)}};e.$PL=Ft,e.$PL=Ft=Ge([E],Ft);let Vt=class{constructor(q,pe,Me){if(this.f=[],Array.isArray(pe)){if(!q)throw(0,O.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q,this.f=pe,this.g=Me}else{if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q,this.g=pe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)q.push(typeof pe=="string"?pe:pe.value);return Qe(q)}};e.$QL=Vt,e.$QL=Vt=Ge([E],Vt);var Qt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Tt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$pg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$RL=Tt;let Fe=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,pe,Me,Ze,tt,lt){this.k=!1,this.l=this.definition=q;let mt;typeof pe=="string"?(this.n=this.name=pe,this.u=this.source=Me,this.execution=Ze,mt=tt,this.k=!0):pe===gt.Global||pe===gt.Workspace?(this.target=pe,this.n=this.name=Me,this.u=this.source=Ze,this.execution=tt,mt=lt):(this.target=pe,this.n=this.name=Me,this.u=this.source=Ze,this.execution=tt,mt=lt),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Ft?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof Vt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Tt?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,R.$pg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,O.$7)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,O.$7)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const pe=this.l.type;(k.g===pe||k.e===pe||k.f===pe||k.c===pe)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,O.$7)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$SL=Fe,e.$SL=Fe=k=Ge([E],Fe);var Ne;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Ne||(e.ProgressLocation=Ne={}));var Ce;(function(H){function q(pe){const Me=pe;return(0,$.$Lf)(Me.value)?Me.tooltip&&!(0,$.$Hf)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}H.isViewBadge=q})(Ce||(e.ViewBadge=Ce={}));let se=P=class{static isTreeItem(q,pe){const Me=q;if(Me.checkboxState!==void 0){const Ze=(0,$.$Lf)(Me.checkboxState)?Me.checkboxState:(0,$.$Jf)(Me.checkboxState)&&(0,$.$Lf)(Me.checkboxState.state)?Me.checkboxState.state:void 0,tt=!(0,$.$Lf)(Me.checkboxState)&&(0,$.$Jf)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==qe.Checked&&Ze!==qe.Unchecked||tt!==void 0&&!(0,$.$Hf)(tt))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(q instanceof P)return!0;if(Me.label!==void 0&&!(0,$.$Hf)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,$.$Hf)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,$.$Hf)(Me.iconPath)&&!y.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,$.$Hf)(Me.iconPath.id))){const Ze=Me.iconPath;if(!Ze||!(0,$.$Hf)(Ze.light)&&!y.URI.isUri(Ze.light)&&!(0,$.$Hf)(Ze.dark)&&!y.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,$.$Hf)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!y.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,$.$Hf)(Me.tooltip)&&!(Me.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<Te.None&&Me.collapsibleState>Te.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,$.$Hf)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(q,pe=Te.None){this.collapsibleState=pe,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$TL=se,e.$TL=se=P=Ge([E],se);var Te;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Te||(e.TreeItemCollapsibleState=Te={}));var qe;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$UL=xe,e.$UL=xe=Ge([E],xe);class Ke extends xe{}e.$VL=Ke;class st extends Ke{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$WL=st;class $t{constructor(q,pe,Me,Ze){this.name=q,this.uri=pe,this._itemId=Me,this.c=Ze}data(){return this.c()}}e.$XL=$t;let Bt=class{#e=new Map;constructor(q){for(const[pe,Me]of q??[]){const Ze=this.#e.get(this.#t(pe));Ze?Ze.push(Me):this.#e.set(this.#t(pe),[Me])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,pe){this.#e.set(this.#t(q),[pe])}forEach(q,pe){for(const[Me,Ze]of this.#e)for(const tt of Ze)q.call(pe,tt,Me,this)}*[Symbol.iterator](){for(const[q,pe]of this.#e)for(const Me of pe)yield[q,Me]}#t(q){return q.toLowerCase()}};e.$YL=Bt,e.$YL=Bt=Ge([E],Bt);let kt=class{constructor(q){this.insertText=q}};e.$ZL=kt,e.$ZL=kt=Ge([E],kt);let It=class{constructor(q,pe){this.label=pe,this.insertText=q}};e.$1L=It,e.$1L=It=Ge([E],It);let yt=class{constructor(q,pe){this.id=q,this.color=pe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$2L=yt,e.$2L=yt=Ge([E],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let gi=class{constructor(q){this.id=q}};e.$3L=gi,e.$3L=gi=Ge([E],gi);var Rt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Rt||(e.ConfigurationTarget=Rt={}));let Di=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,pe){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,O.$7)("base");if(typeof pe!="string")throw(0,O.$7)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$4L=Di,e.$4L=Di=Ge([E],Di);const Gi=new WeakMap;function Pt(H,q){Gi.set(H,q)}e.$5L=Pt;let ri=class{constructor(q,pe,Me,Ze){this.enabled=typeof q=="boolean"?q:!0,typeof pe=="string"&&(this.condition=pe),typeof Me=="string"&&(this.hitCondition=Me),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Gi.get(this)??(0,R.$pg)()),this.c}};e.$6L=ri,e.$6L=ri=Ge([E],ri);let mi=class extends ri{constructor(q,pe,Me,Ze,tt){if(super(pe,Me,Ze,tt),q===null)throw(0,O.$7)("location");this.location=q}};e.$7L=mi,e.$7L=mi=Ge([E],mi);let ci=class extends ri{constructor(q,pe,Me,Ze,tt){super(pe,Me,Ze,tt),this.functionName=q}};e.$8L=ci,e.$8L=ci=Ge([E],ci);let Ci=class extends ri{constructor(q,pe,Me,Ze,tt,lt,mt){if(super(Ze,tt,lt,mt),!pe)throw(0,O.$7)("dataId");this.label=q,this.dataId=pe,this.canPersist=Me}};e.$9L=Ci,e.$9L=Ci=Ge([E],Ci);let Ii=class{constructor(q,pe,Me){this.command=q,this.args=pe||[],this.options=Me}};e.$0L=Ii,e.$0L=Ii=Ge([E],Ii);let jt=class{constructor(q,pe){this.port=q,this.host=pe}};e.$$L=jt,e.$$L=jt=Ge([E],jt);let $i=class{constructor(q){this.path=q}};e.$_L=$i,e.$_L=$i=Ge([E],$i);let Pi=class{constructor(q){this.implementation=q}};e.$aM=Pi,e.$aM=Pi=Ge([E],Pi);let ui=class{constructor(q,pe,Me){this.session=q,this.threadId=pe,this.frameId=Me}};e.$bM=ui,e.$bM=ui=Ge([E],ui);let li=class{constructor(q,pe){this.session=q,this.threadId=pe}};e.$cM=li,e.$cM=li=Ge([E],li);let dt=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$dM=dt,e.$dM=dt=Ge([E],dt);var Ji;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let _t=class{constructor(q,pe){this.range=q,this.text=pe}};e.$eM=_t,e.$eM=_t=Ge([E],_t);let si=class{constructor(q,pe,Me=!0){this.range=q,this.variableName=pe,this.caseSensitiveLookup=Me}};e.$fM=si,e.$fM=si=Ge([E],si);let bi=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$gM=bi,e.$gM=bi=Ge([E],bi);let Ai=class{constructor(q,pe){this.frameId=q,this.stoppedLocation=pe}};e.$hM=Ai,e.$hM=Ai=Ge([E],Ai);var Qi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Li=p=class extends Error{static FileExists(q){return new p(q,m.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(q){return new p(q,m.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(q){return new p(q,m.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(q){return new p(q,m.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(q){return new p(q,m.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(q){return new p(q,m.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(q,pe=m.FileSystemProviderErrorCode.Unknown,Me){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Me?.name??"Unknown",(0,m.$Ek)(this,pe),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$iM=Li,e.$iM=Li=p=Ge([E],Li);let wi=class{constructor(q,pe,Me){this.start=q,this.end=pe,this.kind=Me}};e.$jM=wi,e.$jM=wi=Ge([E],wi);var Xi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ri;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var hi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var Yi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Yi||(e.CommentState=Yi={}));var pi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(pi||(e.CommentThreadState=pi={}));class Mi{constructor(q,pe=[]){this.tokenTypes=q,this.tokenModifiers=pe}}e.$kM=Mi;function un(H){return typeof H>"u"||(0,$.$If)(H)}class Fi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let pe=0,Me=q.tokenTypes.length;pe<Me;pe++)this.k.set(q.tokenTypes[pe],pe);for(let pe=0,Me=q.tokenModifiers.length;pe<Me;pe++)this.l.set(q.tokenModifiers[pe],pe)}}push(q,pe,Me,Ze,tt){if(typeof q=="number"&&typeof pe=="number"&&typeof Me=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.o(q,pe,Me,Ze,tt);if(j.isRange(q)&&typeof pe=="string"&&un(Me))return this.n(q,pe,Me);throw(0,O.$7)()}n(q,pe,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,tt=q.start.character,lt=q.end.character-q.start.character,mt=this.k.get(pe);let Ht=0;if(Me)for(const Zt of Me){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(Zt);Ht|=1<<ii>>>0}this.o(Ze,tt,lt,mt,Ht)}o(q,pe,Me,Ze,tt){if(this.f&&(q<this.c||q===this.c&&pe<this.e)){this.f=!1;const Ht=this.g.length/5|0;let Zt=0,ii=0;for(let ni=0;ni<Ht;ni++){let ai=this.g[5*ni],Hi=this.g[5*ni+1];ai===0?(ai=Zt,Hi+=ii):ai+=Zt,this.g[5*ni]=ai,this.g[5*ni+1]=Hi,Zt=ai,ii=Hi}}let lt=q,mt=pe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Me,this.g[this.j++]=Ze,this.g[this.j++]=tt,this.c=q,this.e=pe}static q(q){const pe=[],Me=q.length/5|0;for(let mt=0;mt<Me;mt++)pe[mt]=mt;pe.sort((mt,Ht)=>{const Zt=q[5*mt],ii=q[5*Ht];if(Zt===ii){const ni=q[5*mt+1],ai=q[5*Ht+1];return ni-ai}return Zt-ii});const Ze=new Uint32Array(q.length);let tt=0,lt=0;for(let mt=0;mt<Me;mt++){const Ht=5*pe[mt],Zt=q[Ht+0],ii=q[Ht+1],ni=q[Ht+2],ai=q[Ht+3],Hi=q[Ht+4],Cn=Zt-tt,jn=Cn===0?ii-lt:ii,Ki=5*mt;Ze[Ki+0]=Cn,Ze[Ki+1]=jn,Ze[Ki+2]=ni,Ze[Ki+3]=ai,Ze[Ki+4]=Hi,tt=Zt,lt=ii}return Ze}build(q){return this.f?new oi(new Uint32Array(this.g),q):new oi(Fi.q(this.g),q)}}e.$lM=Fi;class oi{constructor(q,pe){this.resultId=pe,this.data=q}}e.$mM=oi;class ln{constructor(q,pe,Me){this.start=q,this.deleteCount=pe,this.data=Me}}e.$nM=ln;class hn{constructor(q,pe){this.resultId=pe,this.edits=q}}e.$oM=hn;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let di=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$pM=di,e.$pM=di=Ge([E],di);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var _i;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var vi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(vi||(e.ExtensionKind=vi={}));class en{static validate(q){if(typeof q.badge=="string"){let pe=(0,b.$if)(q.badge,0);if(pe<q.badge.length&&(pe+=(0,b.$if)(q.badge,pe)),q.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!yt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,pe,Me){this.badge=q,this.tooltip=pe,this.color=Me}}e.$qM=en;let Ti=class{constructor(q){this.kind=q}};e.$rM=Ti,e.$rM=Ti=Ge([E],Ti);var Ni;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class ei{static isNotebookRange(q){return q instanceof ei?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,pe){if(q<0)throw(0,O.$7)("start must be positive");if(pe<0)throw(0,O.$7)("end must be positive");q<=pe?(this.c=q,this.e=pe):(this.c=pe,this.e=q)}with(q){let pe=this.c,Me=this.e;return q.start!==void 0&&(pe=q.start),q.end!==void 0&&(Me=q.end),pe===this.c&&Me===this.e?this:new ei(pe,Me)}}e.$sM=ei;class yi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(pe=>yi.isNotebookCellData(pe))}static isNotebookCellData(q){return!0}constructor(q,pe,Me,Ze,tt,lt,mt){this.kind=q,this.value=pe,this.languageId=Me,this.mime=Ze,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,yi.validate(this)}}e.$tM=yi;class dn{constructor(q){this.cells=q}}e.$uM=dn;class Yt{static isNotebookCellOutputItem(q){return q instanceof Yt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const pe={name:q.name,message:q.message,stack:q.stack};return Yt.json(pe,"application/vnd.code.notebook.error")}static stdout(q){return Yt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Yt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,pe="application/octet-stream"){return new Yt(q,pe)}static#e=new TextEncoder;static text(q,pe=L.$es.text){const Me=Yt.#e.encode(String(q));return new Yt(Me,pe)}static json(q,pe="text/x-json"){const Me=JSON.stringify(q,void 0,"	");return Yt.text(Me,pe)}constructor(q,pe){this.data=q,this.mime=pe;const Me=(0,L.$is)(pe,!0);if(!Me)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$vM=Yt;class Ei{static isNotebookCellOutput(q){return q instanceof Ei?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,pe=!1){const Me=new Set,Ze=new Set;for(let tt=0;tt<q.length;tt++){const lt=q[tt],mt=(0,L.$is)(lt.mime);if(!Me.has(mt)||(0,S.$9I)(mt)){Me.add(mt);continue}Ze.add(tt),pe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ze.size===0?q:q.filter((tt,lt)=>!Ze.has(lt))}constructor(q,pe,Me){this.items=Ei.ensureUniqueMimeTypes(q,!0),typeof pe=="string"?(this.id=pe,this.metadata=Me):(this.id=(0,R.$pg)(),this.metadata=pe??Me)}}e.$wM=Ei;var ki;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ki||(e.NotebookCellKind=ki={}));var Oi;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Be;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Be||(e.NotebookCellStatusBarAlignment=Be={}));var ti;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ti||(e.NotebookEditorRevealType=ti={}));class tn{constructor(q,pe){this.text=q,this.alignment=pe}}e.$xM=tn;var at;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(at||(e.NotebookControllerAffinity=at={}));var wt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(wt||(e.NotebookControllerAffinity2=wt={}));class fn{constructor(q,pe=[]){this.uri=q,this.provides=(0,D.$3b)(pe)}}e.$yM=fn;class gn{constructor(q){this.label=q}}e.$zM=gn;var ji;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ji||(e.NotebookVariablesRequestKind=ji={}));let Ui=class{constructor(q,pe){this.label=q,this.timestamp=pe}};e.$AM=Ui,e.$AM=Ui=Ge([E],Ui);var fi;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class mn{constructor(q,pe){this.ranges=q,this.wordPattern=pe}}e.$BM=mn;class sn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$CM=sn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let zi=class{constructor(q=void 0,pe=void 0,Me=void 0,Ze=!1){this.include=q,this.exclude=pe,this.profile=Me,this.continuous=Ze}};e.$DM=zi,e.$DM=zi=Ge([E],zi);let Bi=w=class{static diff(q,pe,Me){const Ze=new w(q);return Ze.expectedOutput=pe,Ze.actualOutput=Me,Ze}constructor(q){this.message=q}};e.$EM=Bi,e.$EM=Bi=w=Ge([E],Bi);let Wi=class{constructor(q){this.id=q}};e.$FM=Wi,e.$FM=Wi=Ge([E],Wi);class Si{constructor(q,pe){this.covered=q,this.total=pe}}e.$GM=Si;const qi=H=>{if(H&&H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`)};class Vi{static fromDetails(q,pe){const Me=new Si(0,0),Ze=new Si(0,0),tt=new Si(0,0);for(const mt of pe)if("branches"in mt){Me.total+=1,Me.covered+=mt.executionCount>0?1:0;for(const Ht of mt.branches)Ze.total+=1,Ze.covered+=Ht.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const lt=new Vi(q,Me,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=pe,lt}constructor(q,pe,Me,Ze){this.uri=q,this.statementCoverage=pe,this.branchCoverage=Me,this.functionCoverage=Ze,qi(pe),qi(Me),qi(Ze)}}e.$HM=Vi;class $n{constructor(q,pe,Me=[]){this.executionCount=q,this.location=pe,this.branches=Me}}e.$IM=$n;class bn{constructor(q,pe){this.executionCount=q,this.location=pe}}e.$JM=bn;class $e{constructor(q,pe,Me){this.name=q,this.executionCount=pe,this.location=Me}}e.$KM=$e;var Ee;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var ze;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(ze||(e.WorkspaceTrustState=ze={}));var ut;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ut||(e.PortAutoForwardAction=ut={}));class vt{constructor(q,pe,Me,Ze,tt,lt){this.kind=q,this.name=pe,this.detail=Me,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$LM=vt;class Mt{constructor(q){this.uri=q}}e.$MM=Mt;class cn{constructor(q,pe){this.original=q,this.modified=pe}}e.$NM=cn;class In{constructor(q,pe,Me,Ze){this.base=q,this.input1=pe,this.input2=Me,this.result=Ze}}e.$OM=In;class Pn{constructor(q,pe){this.uri=q,this.viewType=pe}}e.$PM=Pn;class An{constructor(q){this.viewType=q}}e.$QM=An;class Ln{constructor(q,pe){this.uri=q,this.notebookType=pe}}e.$RM=Ln;class Rn{constructor(q,pe,Me){this.original=q,this.modified=pe,this.notebookType=Me}}e.$SM=Rn;class Mn{constructor(){}}e.$TM=Mn;class Fn{constructor(q,pe){this.uri=q,this.inputBoxUri=pe}}e.$UM=Fn;class Tn{constructor(q){this.providerId=q}}e.$VM=Tn;var wn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var pn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(pn||(e.ChatAgentCopyKind=pn={}));var vn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Nn{constructor(q,pe){this.label=q,this.values=pe}}e.$WM=Nn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class On{constructor(q,pe){this.role=q,this.content=pe}}e.$XM=On;var kn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(ke[141],Se([1,0,60,17,12,176,126,7,19]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=e.$$M=void 0;const y=new Map;function R(S,h){h?y.set(S,h):y.delete(S)}e.$$M=R;function C(S){return y.get(S)}class m extends I.$kv{constructor(h,f,o,i,r,n,c,t){super(f,o,i,r),this.c=h,this.m=n,this.q=c,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,$.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===O.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(f){return f?h.s(f):h.getText()},get eol(){return h.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(f){return h.t(f)},offsetAt(f){return h.u(f)},positionAt(f){return h.v(f)},validateRange(f){return h.w(f)},validatePosition(f){return h.x(f)},getWordRangeAtPosition(f,o){return h.y(f,o)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,D.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,D.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const f=this.w(h);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const o=this.g,i=f.start.line,r=f.end.line,n=[];n.push(this.f[i].substring(f.start.character));for(let c=i+1;c<r;c++)n.push(this.f[c]);return n.push(this.f[r].substring(0,f.end.character)),n.join(o)}t(h){let f;if(h instanceof b.$8K?f=h.line:typeof h=="number"&&(f=h),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new v(f,this.f[f],f===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const f=this.j.getIndexOf(h),o=this.f[f.index].length;return new b.$8K(f.index,Math.min(f.remainder,o))}w(h){if(!(h instanceof b.$9K))throw new Error("Invalid argument");const f=this.x(h.start),o=this.x(h.end);return f===h.start&&o===h.end?h:new b.$9K(f.line,f.character,o.line,o.character)}x(h){if(!(h instanceof b.$8K))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:f,character:o}=h,i=!1;if(f<0)f=0,o=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,o=this.f[f].length,i=!0;else{const r=this.f[f].length;o<0?(o=0,i=!0):o>r&&(o=r,i=!0)}return i?new b.$8K(f,o):h}y(h,f){const o=this.x(h);if(!f)f=C(this.m);else if((0,g.$Xe)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,L.$ws)(o.character+1,(0,L.$us)(f),this.f[o.line],0);if(i)return new b.$9K(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$_M=m;class v{constructor(h,f,o){this.a=h,this.b=f,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$9K(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$9K(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$aN=v}),define(ke[284],Se([1,0,7,20,4]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;let I=class{constructor(b){this.a=new D.$rM(D.ColorThemeKind.Dark),this.b=new g.$Ud}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$rM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Qhc=I,e.$Qhc=I=Ge([We(0,O.$9M)],I)}),define(ke[285],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.CellExecutionUpdateType=void 0;var O;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$aJ=(0,D.$5h)("INotebookExecutionService")}),define(ke[286],Se([1,0,3,29,193,99]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQb=void 0;class L extends D.$Tc{constructor($,y,R){super(),this._source=$,this.b=y,this.c=R,this.a=void 0}f($){const y=$.getLineCount();return new O.$Ts(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$bC;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:R,disposable:C}=y.create(1);this.b=R,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$bC;y.acceptChunk($);const R=y.finish(!0),{textBuffer:C,disposable:m}=R.create(1);return this.B(m),C})),this.a}findInInputs($){const R=new I.$2B($,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs($){const R=new I.$2B($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),R,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$DQb=L}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var O;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class g{static fromExtHostTestItem(L,b,$=L.parent){if(L._isRoot)return new g([b]);const y=[L.id];for(let R=$;R&&R.id!==b;R=R.parent)y.push(R.id);return y.push(b),new g(y.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const b=L.indexOf("\0");return b===-1?L:L.slice(0,b)}static fromString(L){return new g(L.split("\0"))}static join(L,b){return new g([...L.path,b])}static joinToString(L,b){return L.toString()+"\0"+b}static parentId(L){const b=L.lastIndexOf("\0");return b===-1?void 0:L.slice(0,b)}static localId(L){const b=L.lastIndexOf("\0");return b===-1?L:L.slice(b+1)}static isChild(L,b){return b.startsWith(L)&&b[L.length]==="\0"}static compare(L,b){return L===b?0:g.isChild(L,b)?2:g.isChild(b,L)?3:1}constructor(L,b=L.length){if(this.path=L,this.d=b,L.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new g(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new g(this.path,L)}compare(L){if(typeof L=="string")return g.compare(this.toString(),L);for(let b=0;b<L.d&&b<this.d;b++)if(L.path[b]!==this.path[b])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$WJ=g}),define(ke[89],Se([1,0,2,49,29,67]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$4J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$3J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2J=e.$1J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YJ=e.$XJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(F){F[F.Unset=0]="Unset",F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var b;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(F){F[F.Run=2]="Run",F[F.Debug=4]="Debug",F[F.Coverage=8]="Coverage",F[F.HasNonDefaultProfile=16]="HasNonDefaultProfile",F[F.HasConfigurable=32]="HasConfigurable",F[F.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$XJ=[2,4,8,16,32,64];const y=F=>"runId"in F;e.$YJ=y;var R;(function(F){F.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),F.deserialize=(M,B)=>({range:g.$Ts.lift(B.range),uri:M.asCanonicalUri(D.URI.revive(B.uri))})})(R||(e.IRichLocation=R={}));var C;(function(F){F[F.Error=0]="Error",F[F.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(F){F.serialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&R.serialize(M.location)}),F.deserialize=(M,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&R.deserialize(M,B.location)})})(m||(e.ITestErrorMessage=m={}));const v=(F,M)=>`${M?"s":"e"}${F}`;e.$ZJ=v;var S;(function(F){F.serialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&R.serialize(M.location)}),F.deserialize=(M,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&R.deserialize(M,B.location)})})(S||(e.ITestOutputMessage=S={}));var h;(function(F){F.serialize=M=>M.type===0?m.serialize(M):S.serialize(M),F.deserialize=(M,B)=>B.type===0?m.deserialize(M,B):S.deserialize(M,B)})(h||(e.ITestMessage=h={}));var f;(function(F){F.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),F.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(h.serialize)}),F.deserialize=(M,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(X=>h.deserialize(M,X))})})(f||(e.ITestTaskState=f={}));const o="\0",i=(F,M)=>F+o+M;e.$1J=i;const r=F=>{const M=F.indexOf(o);return{ctrlId:F.slice(0,M),tagId:F.slice(M+1)}};e.$2J=r;var n;(function(F){F.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),F.deserialize=(M,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?M.asCanonicalUri(D.URI.revive(B.uri)):void 0,range:B.range?g.$Ts.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(n||(e.ITestItem=n={}));var c;(function(F){F[F.NotExpandable=0]="NotExpandable",F[F.Expandable=1]="Expandable",F[F.BusyExpanding=2]="BusyExpanding",F[F.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(F){F.serialize=M=>({expand:M.expand,item:n.serialize(M.item)}),F.deserialize=(M,B)=>({controllerId:I.$WJ.root(B.item.extId),expand:B.expand,item:n.deserialize(M,B.item)})})(t||(e.InternalTestItem=t={}));var u;(function(F){F.serialize=M=>{let B;return M.item&&(B={},M.item.label!==void 0&&(B.label=M.item.label),M.item.tags!==void 0&&(B.tags=M.item.tags),M.item.busy!==void 0&&(B.busy=M.item.busy),M.item.uri!==void 0&&(B.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(B.range=M.item.range?.toJSON()),M.item.description!==void 0&&(B.description=M.item.description),M.item.error!==void 0&&(B.error=M.item.error),M.item.sortText!==void 0&&(B.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:B}},F.deserialize=M=>{let B;return M.item&&(B={},M.item.label!==void 0&&(B.label=M.item.label),M.item.tags!==void 0&&(B.tags=M.item.tags),M.item.busy!==void 0&&(B.busy=M.item.busy),M.item.range!==void 0&&(B.range=M.item.range?g.$Ts.lift(M.item.range):null),M.item.description!==void 0&&(B.description=M.item.description),M.item.error!==void 0&&(B.error=M.item.error),M.item.sortText!==void 0&&(B.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:B}}})(u||(e.ITestItemUpdate=u={}));const s=(F,M)=>{M.expand!==void 0&&(F.expand=M.expand),M.item!==void 0&&(F.item=F.item?Object.assign(F.item,M.item):M.item)};e.$3J=s;var l;(function(F){F.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serializeWithoutMessages)}),F.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(f.serialize)}),F.deserialize=(M,B)=>({...t.deserialize(M,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(X=>f.deserialize(M,X)),retired:!0})})(l||(e.TestResultItem=l={}));var a;(function(F){F.empty=()=>({covered:0,total:0}),F.sum=(M,B)=>{M.covered+=B.covered,M.total+=B.total}})(a||(e.ICoveredCount=a={}));var d;(function(F){F.serialize=M=>({statement:M.statement,branch:M.branch,function:M.function,details:M.details?.map(w.serialize),uri:M.uri.toJSON()}),F.deserialize=(M,B)=>({statement:B.statement,branch:B.branch,function:B.function,details:B.details?.map(w.deserialize),uri:M.asCanonicalUri(D.URI.revive(B.uri))})})(d||(e.IFileCoverage=d={}));function k(F){return{...F,location:F.location?.toJSON()}}function P(F){return F.location=F.location?O.$Ss.isIPosition(F.location)?O.$Ss.lift(F.location):g.$Ts.lift(F.location):void 0,F}e.$4J=3;var p;(function(F){F[F.Function=0]="Function",F[F.Statement=1]="Statement",F[F.Branch=2]="Branch"})(p||(e.DetailType=p={}));var w;(function(F){F.serialize=M=>M.type===0?A.serialize(M):T.serialize(M),F.deserialize=M=>M.type===0?A.deserialize(M):T.deserialize(M)})(w||(e.CoverageDetails=w={}));var E;(function(F){F.serialize=k,F.deserialize=P})(E||(e.IBranchCoverage=E={}));var A;(function(F){F.serialize=k,F.deserialize=P})(A||(e.IFunctionCoverage=A={}));var T;(function(F){F.serialize=M=>({...k(M),branches:M.branches?.map(E.serialize)}),F.deserialize=M=>({...P(M),branches:M.branches?.map(E.deserialize)})})(T||(e.IStatementCoverage=T={}));var U;(function(F){F[F.Add=0]="Add",F[F.Update=1]="Update",F[F.DocumentSynced=2]="DocumentSynced",F[F.Remove=3]="Remove",F[F.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",F[F.Retire=5]="Retire",F[F.AddTag=6]="AddTag",F[F.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var N;(function(F){F.deserialize=(M,B)=>B.op===0?{op:B.op,item:t.deserialize(M,B.item)}:B.op===1?{op:B.op,item:u.deserialize(B.item)}:B.op===2?{op:B.op,uri:M.asCanonicalUri(D.URI.revive(B.uri)),docv:B.docv}:B,F.serialize=M=>M.op===0?{op:M.op,item:t.serialize(M.item)}:M.op===1?{op:M.op,item:u.serialize(M.item)}:M})(N||(e.TestsDiffOp=N={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const B=this.v();for(const X of M)switch(X.op){case 0:this.l(t.deserialize(this.k,X.item),B);break;case 1:this.o(u.deserialize(X.item),B);break;case 3:this.p(X.itemId,B);break;case 5:this.q(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.c.set(X.tag.id,X.tag);break;case 7:this.c.delete(X.id);break}B.complete?.()}l(M,B){const X=I.$WJ.parentId(M.item.extId)?.toString();let ue;if(!X)ue=this.w(M),this.g.add(ue),this.f.set(M.item.extId,ue);else if(this.f.has(X)){const Z=this.f.get(X);Z.children.add(M.item.extId),ue=this.w(M,Z),this.f.set(M.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return B.add?.(ue),M.expand===2&&this.h++,ue}o(M,B){const X=this.f.get(M.extId);if(X)return M.expand!==void 0&&(X.expand===2&&this.h--,M.expand===2&&this.h++),(0,e.$3J)(X,M),B.update?.(X),X}p(M,B){const X=this.f.get(M);if(!X)return;const ue=I.$WJ.parentId(X.item.extId)?.toString();ue?this.f.get(ue).children.delete(X.item.extId):this.g.delete(X);const Z=[[M]];for(;Z.length;)for(const J of Z.pop()){const Y=this.f.get(J);Y&&(Z.push(Y.children),this.f.delete(J),B.remove?.(Y,Y!==X),Y.expand===2&&this.h--)}}q(M){}updatePendingRoots(M){this.j+=M}v(){return{}}}e.$5J=j}),define(ke[112],Se([1,0,11,4,3,60,89,67]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,r)=>i===r,C=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),m=(i,r)=>{let n;for(const[c,t]of C)t(i[c],r[c])||(n?n[c]=r[c]:n={[c]:r[c]});return n};class v extends g.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new D.$eh(()=>this.flushDiff(),200)),this.g=this.B(new O.$Ud),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,L.$3J)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,L.$3J)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const c=this.tree.get(r);if(c){if((c.expandLevels===void 0||n>c.expandLevels)&&(c.expandLevels=n),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,n-1):t.wait().then(()=>this.L(c,n-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,n-1)):this.L(c,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(b.$WJ.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const c of n.ops)this.w(r,c);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,I.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const c=b.$WJ.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let u=this.tree.get(c.toString());if(!u){u={fullId:c,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(r)}}),this.I(r,u,n);return}if(u.actual===r){this.H(r,u,n);return}if(u.actual.uri?.toString()!==r.uri?.toString())return this.O(c.toString()),this.z(r,n);const s=this.s.getChildren(u.actual),l=u.actual,a=m(this.s.toITestItem(l),this.s.toITestItem(r));this.s.getApiFor(l).listener=void 0,u.actual=r,u.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(r.tags,l.tags,c.toString()),delete a.tags),this.w(u,{op:4,update:a})),this.I(r,u,n);for(const[d,k]of s)this.s.getChildren(r).get(k.id)||this.O(b.$WJ.joinToString(c,k.id));this.y(u.actual.uri)}C(r,n,c){const t=new Set(n.map(u=>u.id));for(const u of r)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:c,item:{tags:r.map(u=>(0,L.$1J)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$1J)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,L.$1J)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,c){this.G(r,c);const t=this.s.getApiFor(r);t.parent=c?.actual,t.listener=u=>this.w(n,u),this.J(n)}I(r,n,c){this.H(r,n,c);for(const[t,u]of this.s.getChildren(r))this.z(u,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const c=[];for(const[t,u]of this.s.getChildren(r.actual)){const s=this.expand(b.$WJ.joinToString(r.fullId,u.id),n);(0,D.$Rg)(s)&&c.push(s)}if(c.length)return Promise.all(c).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const u=new D.$4g;return u.open(),u}r.expand=2,this.N(r);const n=r.resolveBarrier=new D.$4g,c=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(u){c(u)}return(0,D.$Rg)(t)?t.catch(c).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const c=[n];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,s]of this.s.getChildren(t.actual))c.push(this.tree.get(b.$WJ.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$YM=v;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$ZM=S;class h extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$1M=h;class f extends Error{constructor(r,n,c){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${c}".`)}}e.$2M=f;const o=(i,r,n)=>{let c=new Map;return{get size(){return c.size},forEach(t,u){for(const s of c.values())t.call(u,s,this)},[Symbol.iterator](){return c.entries()},replace(t){const u=new Map,s=new Set(c.keys()),l={op:5,ops:[]};for(const a of t){if(!(a instanceof n))throw new h(a.id);const d=r(a).controllerId;if(d!==i.controllerId)throw new f(a.id,d,i.controllerId);if(u.has(a.id))throw new S(a.id);u.set(a.id,a),s.delete(a.id),l.ops.push({op:0,item:a})}for(const a of s.keys())l.ops.push({op:3,id:a});i.listener?.(l),c=u},add(t){if(!(t instanceof n))throw new h(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$3M=o}),define(ke[142],Se([1,0,112]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=e.$4M=void 0;const O=new WeakMap,g=(L,b)=>{const $={controllerId:b};return O.set(L,$),$};e.$4M=g;const I=L=>{const b=O.get(L);if(!b)throw new D.$1M(L?.id||"<unknown>");return b};e.$5M=I}),define(ke[113],Se([1,0,17,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tvb=e.$svb=e.$rvb=e.$qvb=e.$pvb=void 0,e.$pvb="vscode-cdn.net",e.$qvb=`vscode-resource.${e.$pvb}`,e.$rvb=`'self' https://*.${e.$pvb}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=O.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),O.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${I(b.authority)}.${e.$qvb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$svb=g;function I(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function L(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$tvb=L}),define(ke[287],Se([1,0,4,3,113]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class I{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new O.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const C of this.c.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,R,C){let m;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===b){m=r;break}if(!m)throw new Error("not a visible editor");const v=this,S=this.a++,h=new D.$Ud,f=new D.$Ud,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,g.$svb)(r,v.f)}get cspSource(){return g.$rvb}set options(r){this.b=r,v.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,v.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(r){return v.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=o,this.onDidDispose=f.event}dispose(){v.c.has(S)&&(v.c.delete(S),v.d.$disposeEditorInset(S),f.fire(),f.dispose(),h.dispose())}};return this.d.$createEditorInset(S,m.id,m.value.document.uri,$+1,y,R||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:b,inset:i,onDidReceiveMessage:h}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$agc=I}),define(ke[288],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=e.VariableKind=e.$UN=void 0,e.$UN=(0,D.$5h)("configurationResolverService");var O;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator",I.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class g extends Error{constructor(L,b){super(b),this.variable=L}}e.$VN=g}),define(ke[289],Se([1,0,16,50,18,24,10,102,231,288,12]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,S,h,f){this.h=new Map,this.a=v,this.b=S,this.g=h,f&&(this.c=f.then(o=>this.i(o)))}i(v){if(L.$i){const S=Object.create(null);return Object.keys(v).forEach(h=>{S[h.toLowerCase()]=v[h]}),S}return v}resolveWithEnvironment(v,S,h){return this.l({env:this.i(v),userHome:void 0},S?S.uri:void 0,h)}async resolveAsync(v,S){const h={env:await this.c,userHome:await this.g};return this.l(h,v?v.uri:void 0,S)}async j(v,S,h,f){const o=I.$un(S);L.$i&&o.windows?Object.keys(o.windows).forEach(r=>o[r]=o.windows[r]):L.$j&&o.osx?Object.keys(o.osx).forEach(r=>o[r]=o.osx[r]):L.$k&&o.linux&&Object.keys(o.linux).forEach(r=>o[r]=o.linux[r]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,o,h,f)}async resolveAnyAsync(v,S,h){return this.j(v,S,h)}async resolveAnyMap(v,S,h){const f=new Map;return{newConfig:await this.j(v,S,h,f),resolvedVariables:f}}resolveWithInteractionReplace(v,S,h,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,S,h,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,S){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,S)}async l(v,S,h,f,o){if(g.$Hf(h))return this.m(v,S,h,f,o);if(Array.isArray(h))return Promise.all(h.map(i=>this.l(v,S,i,f,o)));if(g.$Jf(h)){const i=Object.create(null),r=await Promise.all(Object.keys(h).map(async n=>[await this.m(v,S,n,f,o),await this.l(v,S,h[n],f,o)]));for(const[n,c]of r)i[n]=c;return i}return h}m(v,S,h,f,o){return(0,R.$3e)(h,C.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(C.VARIABLE_LHS))return i;let n=await this.o(v,i,r,S,f);return o?.set(r,n),n!==i&&g.$Hf(n)&&n.match(C.VARIABLE_REGEXP)&&(n=await this.m(v,S,n,f,o)),n})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,S,h,f,o){let i;const r=h.split(":");r.length>1&&(h=r[0],i=r[1]);const n=u=>{const s=this.a.getFilePath();if(s)return(0,b.$Vv)(s);throw new y.$VN(u,(0,$.localize)(0,null,S))},c=u=>{const s=n(u);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$Vv)(l)}throw new y.$VN(u,(0,$.localize)(1,null,S,D.$nc(s)))},t=u=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new y.$VN(u,(0,$.localize)(2,null,S,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$VN(u,(0,$.localize)(3,null,S)):new y.$VN(u,(0,$.localize)(4,null,S))};switch(h){case"env":if(i){if(v.env){const u=v.env[L.$i?i.toLowerCase():i];if(g.$Hf(u))return u}return""}throw new y.$VN(y.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const u=this.a.getConfigurationValue(f,i);if(g.$Qf(u))throw new y.$VN(y.VariableKind.Config,(0,$.localize)(6,null,S,i));if(g.$Jf(u))throw new y.$VN(y.VariableKind.Config,(0,$.localize)(7,null,S,i));return u}throw new y.$VN(y.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,o,"command");case"input":return this.p(y.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const u=await this.a.getExtension(i);if(!u)throw new y.$VN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(u.extensionLocation)}throw new y.$VN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,b.$Vv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,b.$Vv)(this.n(t(y.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Vv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new y.$VN(y.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new y.$VN(y.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new y.$VN(y.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(y.VariableKind.File);case"fileWorkspaceFolder":return c(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(c(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),n(y.VariableKind.RelativeFile)):n(y.VariableKind.RelativeFile);case"relativeFileDirname":{const u=D.$mc(n(y.VariableKind.RelativeFileDirname));if(f||i){const s=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),u);return s.length===0?".":s}return u}case"fileDirname":return D.$mc(n(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(n(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(n(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=D.$nc(n(y.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-D.$oc(u).length)}case"fileDirnameBasename":return D.$nc(D.$mc(n(y.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||S}case"execInstallFolder":{const u=this.a.getAppRoot();return u||S}case"pathSeparator":case"/":return D.sep;default:try{const u=i?`${h}:${i}`:h;return this.p(y.VariableKind.Unknown,S,u,o,void 0)}catch{return S}}}}p(v,S,h,f,o){if(h&&f){const i=o===void 0?f[h]:f[o+":"+h];if(typeof i=="string")return i;throw new y.$VN(v,(0,$.localize)(14,null,S))}return S}}e.$0N=C}),define(ke[143],Se([1,0,5,139]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.OpenEditorContext=e.GroupsOrder=e.$9C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$8C=void 0,e.$8C=(0,D.$5h)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var L;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(S){const h=S;return(0,O.$RE)(h?.editor)&&(0,O.$RE)(h?.replacement)}e.$9C=y;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(S){const h=S;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.$0C=m;function v(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$$C=v}),define(ke[290],Se([1,0,5,143]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=void 0,e.$_C=(0,D.$5h)("editorService"),e.$aD=-1,e.$bD=-2,e.$cD=-3;function g(I){const L=I;return typeof I=="number"||(0,O.$0C)(L)}e.$dD=g}),define(ke[144],Se([1,0,5,133]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=void 0,e.$pK=(0,D.$6h)(O.$_h)}),define(ke[145],Se([1,0,26,4,16,3]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.$$7b=e.$07b=e.$97b=e.$87b=void 0;class L{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$87b=L;class b{static isHostExtension(o,i,r){if(i.getExtensionDescription(o))return!1;const n=r.getExtensionDescription(o);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(o,i){this.j=o,this.c=new O.$Ud,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$mm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=h(this.e,i),this.e=this.e.concat(o);const r=b.l(this.e);return this.e=h(this.e,r.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,r)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,s){this.addNode(u),this.addNode(s),this.c.has(u)?this.c.get(u).push(s):this.c.set(u,[s])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,s){const l=i.getArcs(u);for(let a=0;a<l.length;a++)if(!s.has(l[a]))return!1;return!0}getNodes(){return this.e}},r=new D.$mm;for(const u of o)if(r.set(u.identifier,u),u.extensionDependencies)for(const s of u.extensionDependencies)i.addArc(D.$km.toKey(u.identifier),D.$km.toKey(s));const n=new Set;i.getNodes().filter(u=>i.getArcs(u).length===0).forEach(u=>n.add(u));const c=i.getNodes().filter(u=>!n.has(u));let t;do{t=!1;for(let u=0;u<c.length;u++){const s=c[u];i.hasOnlyGoodArcs(s,n)&&(c.splice(u,1),u--,n.add(s),t=!0)}}while(t);return c.map(u=>r.get(u))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$97b=b;class ${constructor(o,i){this.versionId=o,this.extensions=i}}e.$07b=$;class y{constructor(o){this.d=new m,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new R(this,i)}deltaExtensions(o,i,r){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$$7b=y;class R extends I.$Tc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$_7b=R;class C{constructor(o){this.name=o,this.promise=new Promise((i,r)=>{this.c=i})}resolve(o){this.c(o)}}class m{constructor(){this.c=[],this.d=!1}async acquire(o){const i=new C(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};o.resolve((0,I.$Rc)(n))}}var v;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(v||(v={}));function S(f,o){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,r=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==r)return i-r;const n=g.$gc.basename(f.extensionLocation.path),c=g.$gc.basename(o.extensionLocation.path);return n<c?-1:n>c?1:0}function h(f,o){const i=new D.$lm(o);return f.filter(r=>!i.has(r.identifier))}}),define(ke[291],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.ExtHostConnectionType=void 0;var D;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[O.ENV_KEY]=this.pipeName}}e.$Om=O;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Pm=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Qm=I;function L(R){delete R[O.ENV_KEY],delete R[g.ENV_KEY],delete R[I.ENV_KEY]}function b(R,C){L(C),R.serialize(C)}e.$Rm=b;function $(R){if(R[O.ENV_KEY])return y(R,new O(R[O.ENV_KEY]));if(R[g.ENV_KEY])return y(R,new g);if(R[I.ENV_KEY])return y(R,new I);throw new Error("No connection information defined in environment!")}e.$Sm=$;function y(R,C){return L(R),C}}),define(ke[114],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$tm=e.$sm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(O||(e.UIKind=O={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function L(y){const R=D.$ie.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$sm=L;function b(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$tm=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Se([1,0,5,4,13,27,114,65,87,24,2,3,217]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=void 0;let v=class extends C.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new O.$Ud),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$Ud),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Oo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,g.$oj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,r){const n=this.getTelemetryDetails(),c=new S(i,r,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(o,i,r){this.f=o,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$al)((0,$.$Vo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const c=r.filter(t=>!t.isDisposed);c.length===0?this.r.delete(n):this.r.set(n,c)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const n=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(o.value),!1;let c=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$nN=v,e.$nN=v=Ge([We(0,I.$mN),We(1,g.$nj)],v);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,r,n,c,t,u){this.g=r,this.h=n,this.i=c,this.j=t,this.a=new O.$Ud,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,$.$Yo)(i,[]),this.c&&(i=(0,y.$xn)(i,this.c)),this.b||(i=(0,y.$xn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const r={name:o.name,message:o.message,stack:o.stack,cause:o.cause},n=(0,$.$Yo)(r,[]),c=new Error(n.message,{cause:n.cause});c.stack=n.stack,c.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$oN=S;function h(f){const o=Date.now()-new Date(f).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$pN=h,e.$qN=(0,D.$5h)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,261,137,26,5]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GF=e.$FF=e.$EF=e.ActivationKind=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.ExtensionHostStartup=e.$yF=e.$xF=e.$wF=e.$vF=void 0,e.$vF=Object.freeze({identifier:new L.$km("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$wF="extensions.webWorker",e.$xF=(0,b.$5h)("extensionService");class ${constructor(c){this.dependency=c}}e.$yF=$;var y;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,u){this.c=c,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$gF.createActivationEventsMap(this.d)}}set(c,t,u){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const s=[],l=[],a=[],d=[],k=C(this.d),P=C(t),p=(U,N)=>U.extensionLocation.toString()===N.extensionLocation.toString()||U.isBuiltin===N.isBuiltin||U.isUserBuiltin===N.isUserBuiltin||U.isUnderDevelopment===N.isUnderDevelopment;for(const U of this.d){const N=P.get(U.identifier);if(!N){s.push(U.identifier),k.delete(U.identifier);continue}if(!p(U,N)){s.push(U.identifier),k.delete(U.identifier);continue}}for(const U of t){const N=k.get(U.identifier);if(!N){l.push(U);continue}if(!p(N,U)){s.push(N.identifier),k.delete(N.identifier);continue}}const w=new L.$lm(this.e),E=new L.$lm(u);for(const U of this.e)E.has(U)||a.push(U);for(const U of u)w.has(U)||d.push(U);const A=I.$gF.createActivationEventsMap(l),T={versionId:c,toRemove:s,toAdd:l,addActivationEvents:A,myToRemove:a,myToAdd:d};return this.delta(T),T}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:s,myToAdd:l}=c,a=new L.$lm(t),d=new L.$lm(s);for(let k=0;k<this.d.length;k++)a.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)d.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of u)this.d.push(k);for(const k of l)this.e.push(k);return this.f=null,c}containsExtension(c){for(const t of this.e)if(L.$km.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=I.$gF.readActivationEvents(t);for(const s of u)c.add(s)}return c}}e.$zF=R;function C(n){const c=new L.$mm;for(const t of n)c.set(t.identifier,t);return c}function m(n,c){return n.enabledApiProposals?n.enabledApiProposals.includes(c):!1}e.$AF=m;function v(n,c){if(!m(n,c))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$BF=v;class S{constructor(c,t,u,s){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=s}}e.$CF=S;class h{constructor(c,t){this.description=c,this.value=t}}e.$DF=h;var f;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function o(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,g.$5o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$EF=o;function i(n,c){return{identifier:new L.$km((0,g.$3o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!c,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$FF=i;class r{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$GF=r}),define(ke[292],Se([1,0,14,145,26,25,13,11]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=e.$zgc=e.$ygc=e.$xgc=e.$wgc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,i,r,n){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$wgc=$;class y{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$xgc=y;class R{constructor(o,i,r,n,c,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=c,this.subscriptions=t}}e.$ygc=R;class C extends R{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$zgc=C;class m extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Agc=m;class v extends R{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,r,n){this.g=n,this.a=o,this.b=i,this.c=r,this.d=new g.$mm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,r]of this.d)o.push(r.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const r=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const r=this.a.getExtensionDescription(o);if(!r)throw new Error(`Extension '${o}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(o){const i=o.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new v(c));return this.c.onExtensionActivationError(o.id,c,new I.$yF(o.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of n){if(this.m(c))continue;const t=this.d.get(c);if(t){r.push(t);continue}if(this.l(c)){r.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:o.reason}));continue}const u=this.a.getExtensionDescription(c);if(u){if(!u.main&&!u.browser)continue;r.push(this.j({id:u.identifier,reason:o.reason}));continue}const s=i.displayName||i.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${c}'`),a=this.k(o,i.displayName,[],new v(l));return this.c.onExtensionActivationError(i.identifier,l,new I.$yF(c)),a}return this.k(o,i.displayName,r,null)}k(o,i,r,n){const c=new h(o.id,i,o.reason,r,n,this.c,this.g);return this.d.set(o.id,c),c}l(o){return O.$97b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Bgc=S,e.$Bgc=S=Ge([We(3,L.$mj)],S);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,r,n,c,t,u){this.c=o,this.d=i,this.f=r,this.g=n,this.h=c,this.j=t,this.k=u,this.a=new b.$4g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new v(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new v(i),this.b&&D.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};h=Ge([We(6,L.$mj)],h)}),define(ke[15],Se([1,0,19,22,165,74,80,28,160,55,100,24,18,2,29,83,135,142,139,111,67,89,290,25,7]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$8M=e.$7M=e.MarkdownString=e.$6M=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Fe){function Ne(se){const{selectionStartLineNumber:Te,selectionStartColumn:qe,positionLineNumber:xe,positionColumn:Ke}=se,st=new s.$8K(Te-1,qe-1),$t=new s.$8K(xe-1,Ke-1);return new s.$0K(st,$t)}Fe.to=Ne;function Ce(se){const{anchor:Te,active:qe}=se;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Fe.from=Ce})(l||(e.Selection=l={}));var a;(function(Fe){function Ne(se){if(!se)return;const{start:Te,end:qe}=se;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Fe.from=Ne;function Ce(se){if(!se)return;const{startLineNumber:Te,startColumn:qe,endLineNumber:xe,endColumn:Ke}=se;return new s.$9K(Te-1,qe-1,xe-1,Ke-1)}Fe.to=Ce})(a||(e.Range=a={}));var d;(function(Fe){function Ne(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Fe.to=Ne})(d||(e.TokenType=d={}));var k;(function(Fe){function Ne(se){return new s.$8K(se.lineNumber-1,se.column-1)}Fe.to=Ne;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Fe.from=Ce})(k||(e.Position=k={}));var P;(function(Fe){function Ne(Te,qe,xe){return(0,D.$Hb)((0,D.$3b)(Te).map(Ke=>Ce(Ke,qe,xe)))}Fe.from=Ne;function Ce(Te,qe,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:se(Te.scheme,qe),pattern:ne.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function se(Te,qe){return qe&&typeof Te=="string"?qe.transformOutgoingScheme(Te):Te}})(P||(e.DocumentSelector=P={}));var p;(function(Fe){function Ne(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Fe.from=Ne;function Ce(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Fe.to=Ce})(p||(e.DiagnosticTag=p={}));var w;(function(Fe){function Ne(se){let Te;return se.code&&((0,m.$Hf)(se.code)||(0,m.$Lf)(se.code)?Te=String(se.code):Te={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Te,severity:A.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(E.from),tags:Array.isArray(se.tags)?(0,D.$Hb)(se.tags.map(p.from)):void 0}}Fe.from=Ne;function Ce(se){const Te=new s.$iL(a.to(se),se.message,A.to(se.severity));return Te.source=se.source,Te.code=(0,m.$Hf)(se.code)?se.code:se.code?.value,Te.relatedInformation=se.relatedInformation&&se.relatedInformation.map(E.to),Te.tags=se.tags&&(0,D.$Hb)(se.tags.map(p.to)),Te}Fe.to=Ce})(w||(e.Diagnostic=w={}));var E;(function(Fe){function Ne(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Fe.from=Ne;function Ce(se){return new s.$hL(new s.$gL(se.resource,a.to(se)),se.message)}Fe.to=Ce})(E||(e.DiagnosticRelatedInformation=E={}));var A;(function(Fe){function Ne(se){switch(se){case s.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Fe.from=Ne;function Ce(se){switch(se){case f.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Fe.to=Ce})(A||(e.DiagnosticSeverity=A={}));var T;(function(Fe){function Ne(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.$bD:t.$aD}Fe.from=Ne;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=Ce})(T||(e.ViewColumn=T={}));function U(Fe){return typeof Fe.range<"u"}function N(Fe){return Fe.length===0?!0:!!U(Fe[0])}e.$6M=N;var j;(function(Fe){function Ne(Ke){return Ke.map(Fe.from)}Fe.fromMany=Ne;function Ce(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function se(Ke){let st;if(Ce(Ke)){const{language:It,value:yt}=Ke;st={value:"```"+It+`
`+yt+"\n```\n"}}else s.$vL.isMarkdownString(Ke)?st={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?st={value:Ke}:st={value:""};const $t=Object.create(null);st.uris=$t;const Bt=It=>{try{let yt=v.URI.parse(It,!0);yt=yt.with({query:Te(yt.query,$t)}),$t[It]=yt}catch{}return""},kt=new $.marked.Renderer;return kt.link=Bt,kt.image=It=>typeof It=="string"?Bt(L.$ok(It).href):"",(0,$.marked)(st.value,{renderer:kt}),st}Fe.from=se;function Te(Ke,st){if(!Ke)return Ke;let $t;try{$t=(0,y.$Ah)(Ke)}catch{}if(!$t)return Ke;let Bt=!1;return $t=(0,C.$wn)($t,kt=>{if(v.URI.isUri(kt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[It]=kt,Bt=!0,It}else return}),Bt?JSON.stringify($t):Ke}function qe(Ke){const st=new s.$vL(Ke.value,Ke.supportThemeIcons);return st.isTrusted=Ke.isTrusted,st.supportHtml=Ke.supportHtml,st.baseUri=Ke.baseUri?v.URI.from(Ke.baseUri):void 0,st}Fe.to=qe;function xe(Ke){if(Ke)return typeof Ke=="string"?Ke:Fe.from(Ke)}Fe.fromStrict=xe})(j||(e.MarkdownString=j={}));function F(Fe){return N(Fe)?Fe.map(Ne=>({range:a.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?j.fromMany(Ne.hoverMessage):Ne.hoverMessage?j.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Fe.map(Ne=>({range:a.from(Ne)}))}e.$7M=F;function M(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?v.URI.file(Fe):Fe}e.$8M=M;var B;(function(Fe){function Ne(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?M(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Fe.from=Ne})(B||(e.ThemableDecorationAttachmentRenderOptions=B={}));var X;(function(Fe){function Ne(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?M(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?B.from(Ce.before):void 0,after:Ce.after?B.from(Ce.after):void 0}}Fe.from=Ne})(X||(e.ThemableDecorationRenderOptions=X={}));var ue;(function(Fe){function Ne(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Ne})(ue||(e.DecorationRangeBehavior=ue={}));var Z;(function(Fe){function Ne(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ue.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?X.from(Ce.light):void 0,dark:Ce.dark?X.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?M(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?B.from(Ce.before):void 0,after:Ce.after?B.from(Ce.after):void 0}}Fe.from=Ne})(Z||(e.DecorationRenderOptions=Z={}));var J;(function(Fe){function Ne(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Fe.from=Ne;function Ce(se){const Te=new s.$bL(a.to(se.range),se.text);return Te.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Te}Fe.to=Ce})(J||(e.TextEdit=J={}));var Y;(function(Fe){function Ne(se,Te){const qe={edits:[]};if(se instanceof s.$eL){const xe=new b.$Bc;for(const Ke of se._allEntries())Ke._type===1&&v.URI.isUri(Ke.to)&&Ke.from===void 0&&xe.add(Ke.to);for(const Ke of se._allEntries())if(Ke._type===1){let st;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?st={type:"base64",value:(0,O.$Ce)(O.$ie.wrap(Ke.options.contents))}:st={type:"dataTransferItem",id:Ke.options.contents._itemId}),qe.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:st},metadata:Ke.metadata})}else Ke._type===2?qe.edits.push({resource:Ke.uri,textEdit:J.from(Ke.edit),versionId:xe.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?qe.edits.push({resource:Ke.uri,textEdit:{range:a.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:xe.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&qe.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(pt.from)}})}return qe}Fe.from=Ne;function Ce(se){const Te=new s.$eL,qe=new b.$Ac;for(const xe of se.edits)if(xe.textEdit){const Ke=xe,st=v.URI.revive(Ke.resource),$t=a.to(Ke.textEdit.range),Bt=Ke.textEdit.text,kt=Ke.textEdit.insertAsSnippet;let It;kt?It=s.$dL.replace($t,new s.$fL(Bt)):It=s.$bL.replace($t,Bt);const yt=qe.get(st);yt?yt.push(It):qe.set(st,[It])}else Te.renameFile(v.URI.revive(xe.oldResource),v.URI.revive(xe.newResource),xe.options);for(const[xe,Ke]of qe)Te.set(xe,Ke);return Te}Fe.to=Ce})(Y||(e.WorkspaceEdit=Y={}));var he;(function(Fe){const Ne=Object.create(null);Ne[s.SymbolKind.File]=0,Ne[s.SymbolKind.Module]=1,Ne[s.SymbolKind.Namespace]=2,Ne[s.SymbolKind.Package]=3,Ne[s.SymbolKind.Class]=4,Ne[s.SymbolKind.Method]=5,Ne[s.SymbolKind.Property]=6,Ne[s.SymbolKind.Field]=7,Ne[s.SymbolKind.Constructor]=8,Ne[s.SymbolKind.Enum]=9,Ne[s.SymbolKind.Interface]=10,Ne[s.SymbolKind.Function]=11,Ne[s.SymbolKind.Variable]=12,Ne[s.SymbolKind.Constant]=13,Ne[s.SymbolKind.String]=14,Ne[s.SymbolKind.Number]=15,Ne[s.SymbolKind.Boolean]=16,Ne[s.SymbolKind.Array]=17,Ne[s.SymbolKind.Object]=18,Ne[s.SymbolKind.Key]=19,Ne[s.SymbolKind.Null]=20,Ne[s.SymbolKind.EnumMember]=21,Ne[s.SymbolKind.Struct]=22,Ne[s.SymbolKind.Event]=23,Ne[s.SymbolKind.Operator]=24,Ne[s.SymbolKind.TypeParameter]=25;function Ce(Te){return typeof Ne[Te]=="number"?Ne[Te]:6}Fe.from=Ce;function se(Te){for(const qe in Ne)if(Ne[qe]===Te)return Number(qe);return s.SymbolKind.Property}Fe.to=se})(he||(e.SymbolKind=he={}));var _;(function(Fe){function Ne(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Fe.from=Ne;function Ce(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Fe.to=Ce})(_||(e.SymbolTag=_={}));var we;(function(Fe){function Ne(se){return{name:se.name,kind:he.from(se.kind),tags:se.tags&&se.tags.map(_.from),containerName:se.containerName,location:ye.from(se.location)}}Fe.from=Ne;function Ce(se){const Te=new s.$mL(se.name,he.to(se.kind),se.containerName,ye.to(se.location));return Te.tags=se.tags&&se.tags.map(_.to),Te}Fe.to=Ce})(we||(e.WorkspaceSymbol=we={}));var oe;(function(Fe){function Ne(se){const Te={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:he.from(se.kind),tags:se.tags?.map(_.from)??[]};return se.children&&(Te.children=se.children.map(Ne)),Te}Fe.from=Ne;function Ce(se){const Te=new s.$nL(se.name,se.detail,he.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,D.$Lb)(se.tags)&&(Te.tags=se.tags.map(_.to)),se.children&&(Te.children=se.children.map(Ce)),Te}Fe.to=Ce})(oe||(e.DocumentSymbol=oe={}));var K;(function(Fe){function Ne(se){const Te=new s.$rL(he.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Fe.to=Ne;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,name:se.name,detail:se.detail,kind:he.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(_.from)}}Fe.from=Ce})(K||(e.CallHierarchyItem=K={}));var W;(function(Fe){function Ne(Ce){return new s.$sL(K.to(Ce.from),Ce.fromRanges.map(se=>a.to(se)))}Fe.to=Ne})(W||(e.CallHierarchyIncomingCall=W={}));var re;(function(Fe){function Ne(Ce){return new s.$tL(K.to(Ce.to),Ce.fromRanges.map(se=>a.to(se)))}Fe.to=Ne})(re||(e.CallHierarchyOutgoingCall=re={}));var ye;(function(Fe){function Ne(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Fe.from=Ne;function Ce(se){return new s.$gL(v.URI.revive(se.uri),a.to(se.range))}Fe.to=Ce})(ye||(e.location=ye={}));var de;(function(Fe){function Ne(se){const Te=se,qe=se;return{originSelectionRange:Te.originSelectionRange?a.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:qe.uri,range:a.from(Te.targetRange?Te.targetRange:qe.range),targetSelectionRange:Te.targetSelectionRange?a.from(Te.targetSelectionRange):void 0}}Fe.from=Ne;function Ce(se){return{targetUri:v.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Fe.to=Ce})(de||(e.DefinitionLink=de={}));var ge;(function(Fe){function Ne(se){return{range:a.from(se.range),contents:j.fromMany(se.contents)}}Fe.from=Ne;function Ce(se){return new s.$jL(se.contents.map(j.to),a.to(se.range))}Fe.to=Ce})(ge||(e.Hover=ge={}));var x;(function(Fe){function Ne(se){return{range:a.from(se.range),expression:se.expression}}Fe.from=Ne;function Ce(se){return new s.$dM(a.to(se.range),se.expression)}Fe.to=Ce})(x||(e.EvaluatableExpression=x={}));var te;(function(Fe){function Ne(se){if(se instanceof s.$eM)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof s.$fM)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.$gM)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Ne;function Ce(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Fe.to=Ce})(te||(e.InlineValue=te={}));var G;(function(Fe){function Ne(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Fe.from=Ne;function Ce(se){return new s.$hM(se.frameId,a.to(se.stoppedLocation))}Fe.to=Ce})(G||(e.InlineValueContext=G={}));var ie;(function(Fe){function Ne(se){return{range:a.from(se.range),kind:se.kind}}Fe.from=Ne;function Ce(se){return new s.$kL(a.to(se.range),se.kind)}Fe.to=Ce})(ie||(e.DocumentHighlight=ie={}));var fe;(function(Fe){function Ne(se){return{uri:se.uri,highlights:se.highlights.map(ie.from)}}Fe.from=Ne;function Ce(se){return new s.$lL(v.URI.revive(se.uri),se.highlights.map(ie.to))}Fe.to=Ce})(fe||(e.MultiDocumentHighlight=fe={}));var ve;(function(Fe){function Ne(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Fe.to=Ne})(ve||(e.CompletionTriggerKind=ve={}));var Pe;(function(Fe){function Ne(Ce){return{triggerKind:ve.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Fe.to=Ne})(Pe||(e.CompletionContext=Pe={}));var be;(function(Fe){function Ne(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Fe.from=Ne;function Ce(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Fe.to=Ce})(be||(e.CompletionItemTag=be={}));var De;(function(Fe){const Ne=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(qe){return Ne.get(qe)??9}Fe.from=Ce;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(qe){return se.get(qe)??s.CompletionItemKind.Property}Fe.to=Te})(De||(e.CompletionItemKind=De={}));var z;(function(Fe){function Ne(Ce,se){const Te=new s.$BL(Ce.label);return Te.insertText=Ce.insertText,Te.kind=De.to(Ce.kind),Te.tags=Ce.tags?.map(be.to),Te.detail=Ce.detail,Te.documentation=L.$ik(Ce.documentation)?j.to(Ce.documentation):Ce.documentation,Te.sortText=Ce.sortText,Te.filterText=Ce.filterText,Te.preselect=Ce.preselect,Te.commitCharacters=Ce.commitCharacters,S.$Ts.isIRange(Ce.range)?Te.range=a.to(Ce.range):typeof Ce.range=="object"&&(Te.range={inserting:a.to(Ce.range.insert),replacing:a.to(Ce.range.replace)}),Te.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Te.insertText=new s.$fL(Ce.insertText):(Te.insertText=Ce.insertText,Te.textEdit=Te.range instanceof s.$9K?new s.$bL(Te.range,Te.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ce.additionalTextEdits.map(qe=>J.to(qe))),Te.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Te}Fe.to=Ne})(z||(e.CompletionItem=z={}));var Q;(function(Fe){function Ne(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:j.fromStrict(se.documentation)}}Fe.from=Ne;function Ce(se){return{label:se.label,documentation:L.$ik(se.documentation)?j.to(se.documentation):se.documentation}}Fe.to=Ce})(Q||(e.ParameterInformation=Q={}));var ee;(function(Fe){function Ne(se){return{label:se.label,documentation:j.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Q.from):[],activeParameter:se.activeParameter}}Fe.from=Ne;function Ce(se){return{label:se.label,documentation:L.$ik(se.documentation)?j.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Q.to):[],activeParameter:se.activeParameter}}Fe.to=Ce})(ee||(e.SignatureInformation=ee={}));var V;(function(Fe){function Ne(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.from):[]}}Fe.from=Ne;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(ee.to):[]}}Fe.to=Ce})(V||(e.SignatureHelp=V={}));var ae;(function(Fe){function Ne(Ce,se){const Te=new s.$AL(k.to(se.position),typeof se.label=="string"?se.label:se.label.map(le.to.bind(void 0,Ce)),se.kind&&Re.to(se.kind));return Te.textEdits=se.textEdits&&se.textEdits.map(J.to),Te.tooltip=L.$ik(se.tooltip)?j.to(se.tooltip):se.tooltip,Te.paddingLeft=se.paddingLeft,Te.paddingRight=se.paddingRight,Te}Fe.to=Ne})(ae||(e.InlayHint=ae={}));var le;(function(Fe){function Ne(Ce,se){const Te=new s.$zL(se.label);return Te.tooltip=L.$ik(se.tooltip)?j.to(se.tooltip):se.tooltip,h.Command.is(se.command)&&(Te.command=Ce.fromInternal(se.command)),se.location&&(Te.location=ye.to(se.location)),Te}Fe.to=Ne})(le||(e.InlayHintLabelPart=le={}));var Re;(function(Fe){function Ne(se){return se}Fe.from=Ne;function Ce(se){return se}Fe.to=Ce})(Re||(e.InlayHintKind=Re={}));var je;(function(Fe){function Ne(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Fe.from=Ne;function Ce(se){let Te;if(se.url)try{Te=typeof se.url=="string"?v.URI.parse(se.url,!0):v.URI.revive(se.url)}catch{}return new s.$GL(a.to(se.range),Te)}Fe.to=Ce})(je||(e.DocumentLink=je={}));var He;(function(Fe){function Ne(se){const Te=new s.$JL(se.label);return se.textEdit&&(Te.textEdit=J.to(se.textEdit)),se.additionalTextEdits&&(Te.additionalTextEdits=se.additionalTextEdits.map(qe=>J.to(qe))),Te}Fe.to=Ne;function Ce(se){return{label:se.label,textEdit:se.textEdit?J.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Te=>J.from(Te)):void 0}}Fe.from=Ce})(He||(e.ColorPresentation=He={}));var Je;(function(Fe){function Ne(se){return new s.$HL(se[0],se[1],se[2],se[3])}Fe.to=Ne;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Fe.from=Ce})(Je||(e.Color=Je={}));var _e;(function(Fe){function Ne(se){return{range:a.from(se.range)}}Fe.from=Ne;function Ce(se){return new s.$qL(a.to(se.range))}Fe.to=Ce})(_e||(e.SelectionRange=_e={}));var ct;(function(Fe){function Ne(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Fe.to=Ne})(ct||(e.TextDocumentSaveReason=ct={}));var ot;(function(Fe){function Ne(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Ne;function Ce(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Fe.to=Ce})(ot||(e.TextEditorLineNumbersStyle=ot={}));var rt;(function(Fe){function Ne(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Fe.from=Ne;function Ce(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Fe.to=Ce})(rt||(e.EndOfLine=rt={}));var Ae;(function(Fe){function Ne(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Ne})(Ae||(e.ProgressLocation=Ae={}));var Ue;(function(Fe){function Ne(se){const Te={start:se.start+1,end:se.end+1};return se.kind&&(Te.kind=Le.from(se.kind)),Te}Fe.from=Ne;function Ce(se){const Te={start:se.start-1,end:se.end-1};return se.kind&&(Te.kind=Le.to(se.kind)),Te}Fe.to=Ce})(Ue||(e.FoldingRange=Ue={}));var Le;(function(Fe){function Ne(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return h.$Jt.Comment;case s.FoldingRangeKind.Imports:return h.$Jt.Imports;case s.FoldingRangeKind.Region:return h.$Jt.Region}}Fe.from=Ne;function Ce(se){if(se)switch(se.value){case h.$Jt.Comment.value:return s.FoldingRangeKind.Comment;case h.$Jt.Imports.value:return s.FoldingRangeKind.Imports;case h.$Jt.Region.value:return s.FoldingRangeKind.Region}}Fe.to=Ce})(Le||(e.FoldingRangeKind=Le={}));var Ye;(function(Fe){function Ne(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?a.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$DE.id:void 0}}Fe.from=Ne})(Ye||(e.TextEditorOpenOptions=Ye={}));var ne;(function(Fe){function Ne(qe){return qe instanceof s.$4L?qe.toJSON():typeof qe=="string"?qe:Ce(qe)||se(qe)?new s.$4L(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Fe.from=Ne;function Ce(qe){const xe=qe;return xe?v.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function se(qe){const xe=qe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(qe){return typeof qe=="string"?qe:new s.$4L(v.URI.revive(qe.baseUri),qe.pattern)}Fe.to=Te})(ne||(e.GlobPattern=ne={}));var ce;(function(Fe){function Ne(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Ne);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:ne.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Fe.from=Ne})(ce||(e.LanguageSelector=ce={}));var Ie;(function(Fe){function Ne(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Te=>Array.isArray(Te)&&Te.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&v.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(xe=>xe instanceof s.$9K)))}Fe.is=Ne;function Ce(se){return{documents:se.documents.map(Te=>Te.map(qe=>({uri:v.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(xe=>a.from(xe))})))}}Fe.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ve;(function(Fe){function Ne(se){return{start:se.start,end:se.end}}Fe.from=Ne;function Ce(se){return new s.$sM(se.start,se.end)}Fe.to=Ce})(Ve||(e.NotebookRange=Ve={}));var Xe;(function(Fe){function Ne(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Fe.to=Ne;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Fe.from=Ce})(Xe||(e.NotebookCellExecutionSummary=Xe={}));var nt;(function(Fe){function Ne(Ce){if(Ce===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===r.NotebookCellExecutionState.Pending)return;if(Ce===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Fe.to=Ne})(nt||(e.NotebookCellExecutionState=nt={}));var it;(function(Fe){function Ne(se){switch(se){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Fe.from=Ne;function Ce(se){switch(se){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Fe.to=Ce})(it||(e.NotebookCellKind=it={}));var Oe;(function(Fe){function Ne(se){const Te={metadata:se.metadata??Object.create(null),cells:[]};for(const qe of se.cells)s.$tM.validate(qe),Te.cells.push(pt.from(qe));return Te}Fe.from=Ne;function Ce(se){const Te=new s.$uM(se.cells.map(pt.to));return(0,m.$Uf)(se.metadata)||(Te.metadata=se.metadata),Te}Fe.to=Ce})(Oe||(e.NotebookData=Oe={}));var pt;(function(Fe){function Ne(se){return{cellKind:it.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Xe.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Nt.from):[]}}Fe.from=Ne;function Ce(se){return new s.$tM(it.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Nt.to):void 0,se.metadata,se.internalMetadata?Xe.to(se.internalMetadata):void 0)}Fe.to=Ce})(pt||(e.NotebookCellData=pt={}));var St;(function(Fe){function Ne(se){return{mime:se.mime,valueBytes:O.$ie.wrap(se.data)}}Fe.from=Ne;function Ce(se){return new s.$vM(se.valueBytes.buffer,se.mime)}Fe.to=Ce})(St||(e.NotebookCellOutputItem=St={}));var Nt;(function(Fe){function Ne(se){return{outputId:se.id,items:se.items.map(St.from),metadata:se.metadata}}Fe.from=Ne;function Ce(se){const Te=se.items.map(St.to);return new s.$wM(Te,se.outputId,se.metadata)}Fe.to=Ce})(Nt||(e.NotebookCellOutput=Nt={}));var Wt;(function(Fe){function Ne(Te){return se(Te)?{include:ne.from(Te.include)??void 0,exclude:ne.from(Te.exclude)??void 0}:ne.from(Te)??void 0}Fe.from=Ne;function Ce(Te){return se(Te)?{include:ne.to(Te.include),exclude:ne.to(Te.exclude)}:ne.to(Te)}Fe.to=Ce;function se(Te){const qe=Te;return qe?!(0,m.$Qf)(qe.include)&&!(0,m.$Qf)(qe.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var Et;(function(Fe){function Ne(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(qe,Te),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Fe.from=Ne})(Et||(e.NotebookStatusBarItem=Et={}));var Kt;(function(Fe){function Ne(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(qe,Te),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Fe.from=Ne})(Kt||(e.NotebookKernelSourceAction=Kt={}));var Ot;(function(Fe){function Ne(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Fe.from=Ne})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Xt;(function(Fe){function Ne(se){return{uri:se.uri,provides:se.provides}}Fe.from=Ne;function Ce(se){return new s.$yM(v.URI.revive(se.uri),se.provides)}Fe.to=Ce})(Xt||(e.NotebookRendererScript=Xt={}));var Ut;(function(Fe){function Ne(se){return{message:j.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Fe.from=Ne;function Ce(se){const Te=new s.$EM(typeof se.message=="string"?se.message:j.to(se.message));return Te.actualOutput=se.actual,Te.expectedOutput=se.expected,Te.contextValue=se.contextValue,Te.location=se.location?ye.to(se.location):void 0,Te}Fe.to=Ce})(Ut||(e.TestMessage=Ut={}));var Lt;(function(Fe){Fe.namespace=c.$1J,Fe.denamespace=c.$2J})(Lt||(e.TestTag=Lt={}));var et;(function(Fe){function Ne(se){const Te=(0,o.$5M)(se).controllerId;return{extId:n.$WJ.fromExtHostTestItem(se,Te).toString(),label:se.label,uri:v.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(qe=>Lt.namespace(Te,qe.id)),range:S.$Ts.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&j.fromStrict(se.error)||null}}Fe.from=Ne;function Ce(se){return{parent:void 0,error:void 0,id:n.$WJ.fromString(se.extId).localId,label:se.label,uri:v.URI.revive(se.uri),tags:(se.tags||[]).map(Te=>{const{tagId:qe}=Lt.denamespace(Te);return new s.$FM(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Fe.toPlain=Ce})(et||(e.TestItem=et={})),function(Fe){function Ne(se){return{id:se.id}}Fe.from=Ne;function Ce(se){return new s.$FM(se.id)}Fe.to=Ce}(Lt||(e.TestTag=Lt={}));var Gt;(function(Fe){const Ne=(se,Te)=>{const qe=[];for(const[Ke,st]of Te)n.$WJ.compare(st.item.extId,Ke)===2&&(Te.delete(Ke),qe.push(st));const xe={...et.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(st=>st.type===0).map(Ut.to)})),children:qe.map(Ke=>Ne(Ke,Te))};for(const Ke of xe.children)Ke.parent=xe;return xe};function Ce(se){const Te=[],qe=new Map;for(const xe of se.items){qe.set(xe.item.extId,xe);const Ke=n.$WJ.root(xe.item.extId);se.request.targets.some(st=>st.controllerId===Ke&&st.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:se.completedAt,results:Te.map(xe=>Ne(xe,qe))}}Fe.to=Ce})(Gt||(e.TestResults=Gt={}));var Jt;(function(Fe){function Ne(qe){return{covered:qe.covered,total:qe.total}}function Ce(qe){return"line"in qe?k.from(qe):a.from(qe)}function se(qe){return"branches"in qe?{count:qe.executionCount,location:Ce(qe.location),type:1,branches:qe.branches.length?qe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,name:qe.name,count:qe.executionCount,location:Ce(qe.location)}}Fe.fromDetailed=se;function Te(qe){return{uri:qe.uri,statement:Ne(qe.statementCoverage),branch:qe.branchCoverage&&Ne(qe.branchCoverage),function:qe.functionCoverage&&Ne(qe.functionCoverage),details:qe.detailedCoverage?.map(se)}}Fe.fromFile=Te})(Jt||(e.TestCoverage=Jt={}));var ht;(function(Fe){function Ne(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Fe.to=Ne})(ht||(e.CodeActionTriggerKind=ht={}));var bt;(function(Fe){function Ne(se){const Te=new s.$LM(he.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Fe.to=Ne;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,kind:he.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(_.from)}}Fe.from=Ce})(bt||(e.TypeHierarchyItem=bt={}));var zt;(function(Fe){function Ne(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Fe.from=Ne})(zt||(e.ViewBadge=zt={}));var qt;(function(Fe){function Ne(qe,xe,Ke){const st=xe.fileData;return st?new s.$WL(new s.$XL(st.name,v.URI.revive(st.uri),st.id,(0,I.$db)(()=>Ke(st.id)))):qe===R.$es.uriList&&xe.uriListData?new s.$VL(Te(xe.uriListData)):new s.$VL(xe.asString)}Fe.to=Ne;async function Ce(qe,xe){const Ke=await xe.asString();if(qe===R.$es.uriList)return{asString:Ke,fileData:void 0,uriListData:se(Ke)};const st=xe.asFile();return{asString:Ke,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}Fe.from=Ce;function se(qe){return g.$qt.split(qe).map(xe=>{if(xe.startsWith("#"))return xe;try{return v.URI.parse(xe)}catch{}return xe})}function Te(qe){return g.$qt.create(qe.map(xe=>typeof xe=="string"?xe:v.URI.revive(xe)))}})(qt||(e.DataTransferItem=qt={}));var Dt;(function(Fe){function Ne(se,Te){const qe=se.items.map(([xe,Ke])=>[xe,qt.to(xe,Ke,Te)]);return new s.$YL(qe)}Fe.toDataTransfer=Ne;async function Ce(se){const Te={items:[]},qe=[];for(const[xe,Ke]of se)qe.push((async()=>{Te.items.push([xe,await qt.from(xe,Ke)])})());return await Promise.all(qe),Te}Fe.from=Ce})(Dt||(e.DataTransfer=Dt={}));var ft;(function(Fe){function Ne(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Fe.from=Ne})(ft||(e.ChatReplyFollowup=ft={}));var At;(function(Fe){function Ne(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:ft.from(Ce)}Fe.from=Ne})(At||(e.ChatFollowup=At={}));var xt;(function(Fe){function Ne(se){const Te=new s.$XM(Ct.to(se.role),se.content);return Te.name=se.name,Te}Fe.to=Ne;function Ce(se){return{role:Ct.from(se.role),content:se.content,name:se.name}}Fe.from=Ce})(xt||(e.ChatMessage=xt={}));var Ct;(function(Fe){function Ne(se){switch(se){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Fe.to=Ne;function Ce(se){switch(se){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Fe.from=Ce})(Ct||(e.ChatMessageRole=Ct={}));var Qe;(function(Fe){function Ne(Te){const qe={};for(const xe of Object.keys(Te))qe[xe]=Te[xe].map(Fe.to);return qe}Fe.objectTo=Ne;function Ce(Te){return{level:Ft.to(Te.level),kind:Te.kind,value:(0,v.$vc)(Te.value)?v.URI.revive(Te.value):Te.value,description:Te.description}}Fe.to=Ce;function se(Te){return{level:Ft.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Fe.from=se})(Qe||(e.ChatVariable=Qe={}));var Ft;(function(Fe){function Ne(se){switch(se){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Fe.to=Ne;function Ce(se){switch(se){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Fe.from=Ce})(Ft||(e.ChatVariableLevel=Ft={}));var Vt;(function(Fe){function Ne(Ce){switch(Ce){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Fe.to=Ne})(Vt||(e.InteractiveEditorResponseFeedbackKind=Vt={}));var Qt;(function(Fe){function Ne(Ce,se){return"placeholder"in se&&"resolvedContent"in se?{content:se.placeholder,kind:"asyncContent"}:"markdownContent"in se?((0,u.$BF)(Ce,"chatAgents2Additions"),{content:j.from(se.markdownContent),kind:"markdownContent"}):"content"in se?"vulnerabilities"in se&&se.vulnerabilities?((0,u.$BF)(Ce,"chatAgents2Additions"),{content:se.content,vulnerabilities:se.vulnerabilities,kind:"vulnerability"}):typeof se.content=="string"?{content:se.content,kind:"content"}:((0,u.$BF)(Ce,"chatAgents2Additions"),{content:j.from(se.content),kind:"markdownContent"}):"documents"in se?{documents:se.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(qe=>a.from(qe))})),kind:"usedContext"}:"reference"in se?{reference:"uri"in se.reference?{uri:se.reference.uri,range:a.from(se.reference.range)}:se.reference,kind:"reference"}:"inlineReference"in se?{inlineReference:"uri"in se.inlineReference?{uri:se.inlineReference.uri,range:a.from(se.inlineReference.range)}:se.inlineReference,name:se.title,kind:"inlineReference"}:"agentName"in se?((0,u.$BF)(Ce,"chatAgents2Additions"),{agentName:se.agentName,command:se.command,kind:"agentDetection"}):"treeData"in se?{treeData:se.treeData,kind:"treeData"}:"message"in se?{content:se.message,kind:"progressMessage"}:void 0}Fe.from=Ne})(Qt||(e.ChatResponseProgress=Qt={}));var gt;(function(Fe){function Ne(Ce){return{label:Ce.label,values:Ce.values.map(Qe.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Fe.from=Ne})(gt||(e.ChatAgentCompletionItem=gt={}));var Tt;(function(Fe){function Ne(Ce,se,Te){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:se.toInternal(Ce,Te)}Fe.from=Ne})(Tt||(e.TerminalQuickFix=Tt={}))}),define(ke[293],Se([1,0,2,14,7,15,75]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class b{constructor(y,R,C,m={timeout:1500,errors:3}){this.c=y,this.d=R,this.f=C,this.g=m,this.a=new L.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(R,C,m)=>{const S={dispose:this.a.push([R,C,y])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(y,R){const C=D.URI.revive(y);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),S=[];try{for(const h of[...this.a]){if(m)break;const f=this.d.getDocument(C),o=await this.h(h,{document:f,reason:I.TextDocumentSaveReason.to(R)});S.push(o)}}finally{clearTimeout(v)}return S}h([y,R,C],m){const v=this.b.get(y);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(C,y,R,m).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const h=this.b.get(y);this.b.set(y,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,R,C,m){const v=[],S=Date.now(),{document:h,reason:f}=m,{version:o}=h,i=Object.freeze({document:h,reason:f,waitUntil(r){if(Object.isFrozen(v))throw(0,O.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{R.apply(C,[i])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,n)=>{const c=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(c),r(t)}).catch(t=>{clearTimeout(c),n(t)})}).then(r=>{const n={edits:[]};for(const c of r)if(Array.isArray(c)&&c.every(t=>t instanceof g.$bL))for(const{newText:t,newEol:u,range:s}of c)n.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:s&&I.Range.from(s),text:t,eol:u&&I.EndOfLine.from(u)}});if(n.edits.length!==0)return o===h.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$8gc=b}),define(ke[294],Se([1,0,17,2,15,7,111]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=void 0;class b{constructor(C,m,v,S){this.start=C,this.deletedCount=m,this.deletedItems=v,this.items=S}asApiEvent(){return{range:new I.$sM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,v){this.notebook=C,this.h=m,this.j=v,this.handle=v.handle,this.uri=O.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(g.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,v){const S=v.map(g.NotebookCellOutputItem.to),h=this.a.find(f=>f.id===C);if(h&&(m||(h.items.length=0),h.items.push(...S),h.items.length>1&&h.items.every(f=>L.$9I(f.mime)))){const f=new Map,o=[];h.items.forEach(i=>{let r;f.has(i.mime)?r=f.get(i.mime):(r=[],f.set(i.mime,r),o.push(i.mime)),r.push(i.data)}),h.items.length=0,o.forEach(i=>{const r=L.$0I(f.get(i));h.items.push({mime:i,data:r.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$ahc=$;class y{static{this.a=0}constructor(C,m,v,S,h){this.k=C,this.l=m,this.m=v,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(h=>h.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,v){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const S={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},h=[];for(const o of C.rawEvents)o.kind===L.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===L.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===L.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),h.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),h.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),h.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===L.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),h.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),h.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const f=new Map;for(let o=0;o<h.length;o++){const i=h[o],r=f.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,v=C.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),C.with({start:m,end:v})}p(C){C=this.o(C);const m=[];for(let v=C.start;v<C.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,v){if(this.j)return;const S=[],h=[],f=[];if(C.reverse().forEach(o=>{const r=o[2].map(t=>{const u=new $(this,this.l,t);return m||h.push($.asModelAddData(this.apiNotebook,t)),u}),n=new b(o[0],o[1],[],r),c=this.b.splice(o[0],o[1],...r);for(const t of c)f.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:f}),v)for(const o of S)v.push(o.asApiEvent())}s(C,m,v,S){const h=this.b.splice(C,m);this.b.splice(v,0,...h);const f=[new b(C,m,h.map(o=>o.apiCell),[]),new b(v,0,[],h)];for(const o of f)S.push(o.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,v,S){this.b[C].setOutputItems(m,v,S)}v(C,m){const v=this.b[C];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(C,m){const v=this.b[C];v.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$bhc=y}),define(ke[295],Se([1,0,4,2,15,7]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class L{constructor($,y,R,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=R,this.f=C,this.a=new D.$Wd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,R,C)=>{const m=function(S){y.call(R,S)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,R){const C=O.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},R,async(h,f)=>{const o=Date.now(),i=await await Promise.resolve(h);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof I.$eL?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(v.length===0)return!0;const S={edits:[]};for(const h of v){const{edits:f}=g.WorkspaceEdit.from(h);S.edits=S.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$rhc=L}),define(ke[146],Se([1,0,14,15,7]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,R,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=R,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$sM.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,O.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$chc=I}),define(ke[296],Se([1,0,4,13,15]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;let I=class{constructor(b,$){this.c=b,this.d=$,this.a=new D.$Ud,this.b=new D.$Ud,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const y=this.d.getEditorById(b);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(g.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(g.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(g.ViewColumn.to(b[$]))}};e.$thc=I,e.$thc=I=Ge([We(0,O.$mj)],I)}),define(ke[297],Se([1,0,15,85,21,52,14]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class b{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,v){const S=this.b++,{title:h,location:f,cancellable:o}=m,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(f),title:h,source:i,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(L.$2),this.d(S,v,!!o)}d(C,m,v){let S;v&&(S=new g.$5d,this.c.set(C,S));const h=o=>{this.a.$progressEnd(o),this.c.delete(o),S?.dispose()};let f;try{f=m(new y(this.a,C),v&&S?S.token:g.CancellationToken.None)}catch(o){throw h(C),o}return f.then(o=>h(C),o=>h(C)),f}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$Ahc=b;function $(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class y extends O.$uv{constructor(C,m){super(v=>this.throttledReport(v)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Ge([(0,I.$yh)(100,(R,C)=>$(R,C),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(ke[147],Se([1,0,29,142,67,112,89,15,2]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=e.$jN=e.$iN=void 0;const y=(r,n,c,t)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set(s){if(!c(u,s)){const l=u;u=s,r.listener?.(t(s,l))}}}},R=(r,n)=>r===n,C={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(r,n)=>!(r.length!==n.length||r.some(c=>!n.find(t=>c.id===t.id)))},m=r=>n=>({op:4,update:r(n)}),v=(r,n)=>({range:(()=>{let c;const t=m(u=>({range:D.$Ts.lift(b.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return c},set(u){r.listener?.({op:6}),C.range(c,u)||(c=u,r.listener?.(t(u)))}}})(),label:y(r,n,C.label,m(c=>({label:c}))),description:y(r,void 0,C.description,m(c=>({description:c}))),sortText:y(r,void 0,C.sortText,m(c=>({sortText:c}))),canResolveChildren:y(r,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:y(r,!1,C.busy,m(c=>({busy:c}))),error:y(r,void 0,C.error,m(c=>({error:b.MarkdownString.fromStrict(c)||null}))),tags:y(r,[],C.tags,(c,t)=>({op:1,new:c.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=r=>{const n=g.$WJ.fromString(r.extId),c=new f(n.controllerId,n.localId,r.label,$.URI.revive(r.uri)||void 0);return c.range=b.Range.to(r.range||void 0),c.description=r.description||void 0,c.sortText=r.sortText||void 0,c.tags=r.tags.map(t=>b.TestTag.to({id:(0,L.$2J)(t).tagId})),c},h=r=>{let n;for(const c of r.tests){const t=S(c.item);(0,O.$5M)(t).parent=n,n=t}return n};e.$iN=h;class f{constructor(n,c,t,u){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const s=(0,O.$4M)(this,n);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,I.$3M)(s,O.$5M,f),enumerable:!0,writable:!1},...v(s,t)})}}e.$jN=f;class o extends f{constructor(n,c){super(n,n,c,void 0),this._isRoot=!0}}e.$kN=o;class i extends I.$YM{constructor(n,c,t){super({controllerId:n,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:O.$5M,getChildren:u=>u.children,root:new o(n,c),toITestItem:b.TestItem.from})}}e.$lN=i}),define(ke[148],Se([1,0,60,14,121,15,7]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=e.$eN=e.$dN=void 0;class b{static{this.c=new g.$bN("TextEditorDecorationType")}constructor(m,v,S){const h=b.c.nextId();m.$registerTextEditorDecorationType(v.identifier,h,I.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:h,dispose(){m.$removeTextEditorDecorationType(h)}})}}e.$dN=b;class ${constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let S=null;if(m instanceof L.$8K)S=new L.$9K(m,m);else if(m instanceof L.$9K)S=m;else throw new Error("Unrecognized location");this.l(S,v,!1)}insert(m,v){this.k(),this.l(new L.$9K(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof L.$9K)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,S){const h=this.c.validateRange(m);this.g.push({range:h,text:v,forceMoveMarkers:S})}setEndOfLine(m){if(this.k(),m!==L.EndOfLine.LF&&m!==L.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=m}}class y{constructor(m,v,S,h){this.c=m,this.d=v,this._accept(S),this.e=h;const f=this;this.value={get tabSize(){return f.f},set tabSize(o){f.n(o)},get indentSize(){return f.g},set indentSize(o){f.p(o)},get insertSpaces(){return f.j},set insertSpaces(o){f.s(o)},get cursorStyle(){return f.k},set cursorStyle(o){f.t(o)},get lineNumbers(){return f.l},set lineNumbers(o){f.u(o)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}n(m){const v=this.m(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}p(m){const v=this.o(m);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const v=this.q(m);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let S=!1;if(typeof m.tabSize<"u"){const h=this.m(m.tabSize);h==="auto"?(S=!0,v.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,S=!0,v.tabSize=h)}if(typeof m.indentSize<"u"){const h=this.o(m.indentSize);h==="tabSize"?(S=!0,v.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,S=!0,v.indentSize=h)}if(typeof m.insertSpaces<"u"){const h=this.q(m.insertSpaces);h==="auto"?(S=!0,v.insertSpaces=h):this.j!==h&&(this.j=h,S=!0,v.insertSpaces=h)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,S=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,S=!0,v.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(m,v){v.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(S)})}}e.$eN=y;class R{constructor(m,v,S,h,f,o,i,r){this.id=m,this.j=v,this.k=S,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,o,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return h.value},set document(c){throw new O.$9("document")},get selection(){return n.c&&n.c[0]},set selection(c){if(!(c instanceof L.$0K))throw(0,O.$7)("selection");n.c=[c],n.l()},get selections(){return n.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof L.$0K)))throw(0,O.$7)("selections");n.c=c,n.l()},get visibleRanges(){return n.e},set visibleRanges(c){throw new O.$9("visibleRanges")},get options(){return n.d.value},set options(c){n.g||n.d.assign(c)},get viewColumn(){return n.f},set viewColumn(c){throw new O.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(h.value,t);return c(u),n.m(u)},insertSnippet(c,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(l=>I.Range.from(l));else if(t instanceof L.$8K){const{lineNumber:l,column:a}=I.Position.from(t);s=[{startLineNumber:l,startColumn:a,endLineNumber:l,endColumn:a}]}else if(t instanceof L.$9K)s=[I.Range.from(t)];else{s=[];for(const l of t)if(l instanceof L.$9K)s.push(I.Range.from(l));else{const{lineNumber:a,column:d}=I.Position.from(l);s.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return v.$tryInsertSnippet(m,h.value.version,c.value,s,u)},setDecorations(c,t){const u=t.length===0;u&&!n.h.has(c.key)||(u?n.h.delete(c.key):n.h.add(c.key),n.n(()=>{if(I.$6M(t))return v.$trySetDecorations(m,c.key,I.$7M(t));{const s=new Array(4*t.length);for(let l=0,a=t.length;l<a;l++){const d=t[l];s[4*l]=d.start.line+1,s[4*l+1]=d.start.character+1,s[4*l+2]=d.end.line+1,s[4*l+3]=d.end.character+1}return v.$trySetDecorationsFast(m,c.key,s)}}))},revealRange(c,t){n.n(()=>v.$tryRevealRange(m,I.Range.from(c),t||L.TextEditorRevealType.Default))},show(c){v.$tryShowEditor(m,I.ViewColumn.from(c))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const S=v.edits.map(f=>f.range);S.sort((f,o)=>f.end.line===o.end.line?f.end.character===o.end.character?f.start.line===o.start.line?f.start.character-o.start.character:f.start.line-o.start.line:f.end.character-o.end.character:f.end.line-o.end.line);for(let f=0,o=S.length-1;f<o;f++){const i=S[f].end;if(S[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=v.edits.map(f=>({range:I.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,h,{setEndOfLine:typeof v.setEndOfLine=="number"?I.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$fN=R}),define(ke[298],Se([1,0,219,23,2,4,3,278,11,7,18,19,15,80,21,177,25]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;function o(n,c){if((0,R.$Hf)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends L.$Tc{constructor(c,t,u){super(),this.f=c,this.g=t,this.h=u,this.a=new Map,this.b=new h.$h8;function s(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>s(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(a=>s(a)?this.r(a):a):l})}registerTreeDataProvider(c,t,u){const s=this.createTreeView(c,{treeDataProvider:t},u);return{dispose:()=>s.dispose()}}createTreeView(c,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,k=this.m(c,t,u),P={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:l,hasHandleDrag:a,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(c,P),w={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,f.$BF)(u,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,f.$BF)(u,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(E){(0,v.$ik)(E)&&(0,f.$BF)(u,"treeViewMarkdownMessage"),k.message=E},get title(){return k.title},set title(E){k.title=E},get description(){return k.description},set description(E){k.description=E},get badge(){return k.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?k.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(k.badge=void 0)},reveal:(E,A)=>k.reveal(E,A),dispose:async()=>{await p,this.a.delete(c),k.dispose()}};return this.B(w),w}$getChildren(c,t){const u=this.a.get(c);return u?u.getChildren(t):Promise.reject(new b.$_E(c))}async $handleDrop(c,t,u,s,l,a,d,k){const P=this.a.get(c);if(!P)return Promise.reject(new b.$_E(c));const p=m.DataTransfer.toDataTransfer(u,async w=>(await this.f.$resolveDropFileData(c,t,w)).buffer);return d===c&&k&&await this.j(p,P,k,l,a),P.onDrop(p,s,l)}async j(c,t,u,s,l){const a=this.b.removeDragOperationTransfer(l);if(a)(await a)?.forEach((d,k)=>{d&&c.set(k,d)});else if(l&&t.handleDrag){const d=t.handleDrag(u,c,s);this.b.addDragOperationTransfer(l,d),await d}return c}async $handleDrag(c,t,u,s){const l=this.a.get(c);if(!l)return Promise.reject(new b.$_E(c));const a=await this.j(new y.$YL,l,t,s,u);if(!(!a||s.isCancellationRequested))return m.DataTransfer.from(a)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new b.$_E(c);return t.hasResolve}$resolve(c,t,u){const s=this.a.get(c);if(!s)throw new b.$_E(c);return s.resolveTreeItem(t,u)}$setExpanded(c,t,u){const s=this.a.get(c);if(!s)throw new b.$_E(c);s.setExpanded(t,u)}$setSelectionAndFocus(c,t,u){const s=this.a.get(c);if(!s)throw new b.$_E(c);s.setSelectionAndFocus(t,u)}$setVisible(c,t){const u=this.a.get(c);if(!u){if(!t)return;throw new b.$_E(c)}u.setVisible(t)}$changeCheckboxState(c,t){const u=this.a.get(c);if(!u)throw new b.$_E(c);u.setCheckboxState(t)}m(c,t,u){const s=this.B(new r(c,t,this.f,this.g.converter,this.h,u));return this.a.set(c,s),s}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$Thc=i;class r extends L.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,R.$Qf)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,u,s,l,a){if(super(),this.I=c,this.J=u,this.L=s,this.M=l,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Ud),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Ud),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Ud),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Ud),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Ud),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Ud),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Ud),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$5d,a.contributes&&a.contributes.views)for(const p in a.contributes.views)for(const w of a.contributes.views[p])w.id===c&&(this.P=w.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let d,k;const P=I.Event.debounce(this.F.event,(p,w)=>(p||(p={message:!1,elements:[]}),w.element!==!1&&(d||(d=new Promise(E=>k=E),this.G=this.G.then(()=>d)),Array.isArray(w.element)?p.elements.push(...w.element):p.elements.push(w.element)),w.message&&(p.message=!0),p),200,!0);this.B(P(({message:p,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const E=k;return d=null,this.$(w).then(()=>E())})),p&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let u=this.X(c);return u||(u=await this.Y(t)),u?u.map(s=>s.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const u=(0,R.$Qf)(t.select)?!0:t.select,s=(0,R.$Qf)(t.focus)?!1:t.focus,l=(0,R.$Qf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(a=>this.W(c,a[a.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:a.map(k=>k.item)},{select:u,focus:s,expand:l})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:u,focus:s,expand:l})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=m.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const u=this.getExtensionElement(c);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(c,t){const u=!(0,C.$ub)(this.s,c);this.s=c;const s=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async u=>{const s=this.getExtensionElement(u.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(c,t,u){const s=[];for(const l of c){const a=this.getExtensionElement(l);a&&s.push(a)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,u){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$Xg)(()=>this.g?.handleDrop?this.g.handleDrop(s,c,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(c);if(u){const s=this.m.get(u);if(s){const l=await this.f.resolveTreeItem(s.extensionItem,u,t)??s.extensionItem;return this.hb(l),s.item.tooltip=this.eb(l.tooltip),s.item.command=this.fb(s.disposableStore,l.command),s.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(s=>(u.push(s),u))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Xg)(()=>this.f.getParent(c))}W(c,t){const u=this.m.get(c);return u?Promise.resolve(u):(0,$.$Xg)(()=>this.f.getTreeItem(c)).then(s=>this.kb(c,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(s);if(l){const a=this.m.get(l);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const u=this.getExtensionElement(c);t=u?this.m.get(u):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new S.$5d(this.Z.token);try{const u=c?this.m.get(c):void 0,s=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const l=(0,C.$Hb)(s||[]),a=await Promise.all((0,C.$Hb)(l).map(k=>this.f.getTreeItem(k)));if(t.token.isCancellationRequested)return;const d=a.map((k,P)=>k?this.db(l[P],k,u):null);return(0,C.$Hb)(d)}finally{t.dispose()}}$(c){if(c.some(u=>!u))return this.Z.dispose(!0),this.Z=new S.$5d,this.tb(),this.J.$refresh(this.I);{const u=this.ab(c);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(c){const t=new Set,u=c.map(l=>this.m.get(l));for(const l of u)if(l&&!t.has(l.item.handle)){let a=l;for(;a&&a.parent&&u.findIndex(d=>a&&a.parent&&d&&d.item.handle===a.parent.item.handle)===-1;){const d=this.j.get(a.parent.item.handle);a=d?this.m.get(d):void 0}a&&!a.parent&&t.add(l.item.handle)}const s=[];return t.forEach(l=>{const a=this.j.get(l);if(a){const d=this.m.get(a);d&&(!d.parent||!t.has(d.parent.item.handle))&&s.push(l)}}),s}bb(c){const t={};return Promise.all(c.map(u=>this.cb(u).then(s=>{s&&(t[u]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,$.$Xg)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const l=this.ib(t,s,u.parent);return this.pb(t,l,u,u.parent),u.dispose(),l}return null})}return Promise.resolve(null)}db(c,t,u){const s=this.ib(c,t,u);if(t.id&&this.j.has(s.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(c,s),this.qb(s,u),s}eb(c){return y.$vL.isMarkdownString(c)?m.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,u,s;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,u=c.checkboxState.tooltip,s=c.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:s}}hb(c){if(!y.$TL.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,u){this.hb(t);const s=this.B(new L.$Sc),l=this.kb(c,t,u),a=this.lb(t);return{item:{handle:l,parentHandle:u?u.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,R.$Qf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(c){return c.iconPath instanceof y.$2L?c.iconPath:void 0}kb(c,{id:t,label:u,resourceUri:s},l,a){if(t)return`${r.b}/${t}`;const d=o(u,this.N),k=l?l.item.handle:r.a;let P=d?d.label:s?(0,O.$Dg)(s):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const p=this.m.has(c)?this.m.get(c).item.handle:void 0,w=this.X(l)||[];let E,A=0;do{if(E=`${k}/${A}:${P}`,a||!this.j.has(E)||p===E)break;A++}while(A<=w.length);return E}lb(c){if(c.iconPath&&!(c.iconPath instanceof y.$2L))return typeof c.iconPath=="string"||g.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof y.$2L)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return g.URI.isUri(c)?c:g.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,u,s){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(c,t);const l=this.X(s)||[],a=l.filter(d=>d.item.handle===u.item.handle)[0];a&&l.splice(l.indexOf(a),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[299],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[300],Se([1,0,233,14,39,134,108,37,26,299,136,137]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=void 0;const m=b.$Gn.as(L.$Hn.JSONContribution);class v{constructor(c,t,u){this.a=c,this.b=t,this.c=u}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(g.default.Error,c)}warn(c){this.d(g.default.Warning,c)}info(c){this.d(g.default.Info,c)}}e.$pF=v;class S{static a(c){const t=new $.$lm;for(let u=0,s=c.length;u<s;u++)t.add(c[u].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new S(t,[]);if(!t||!t.length)return new S([],c);const u=this.a(c),s=this.a(t),l=t.filter(d=>!u.has(d.description.identifier)),a=c.filter(d=>!s.has(d.description.identifier));return new S(l,a)}constructor(c,t){this.added=c,this.removed=t}}e.$qF=S;class h{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=S.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,O.$1)(c)}}}e.$rF=h;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$sF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$jm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$lo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$lo}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new h(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$gF.register(c.extensionPoint,c.activationEventsGenerator),e.$sF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,m.registerSchema(o,e.$sF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$tF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};b.$Gn.add(r.ExtensionsRegistry,new i),e.$uF=b.$Gn.as(r.ExtensionsRegistry),m.registerSchema(o,e.$sF),m.registerSchema(R.$Fj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ke[301],Se([1,0,229,18,24,300,46,4]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function v(S,h,f){if(!S)return;const o=O.$Hf(S.type)?S.type:void 0;if(!o||o.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)O.$Hf(r)&&i.push(r);return{extensionId:h.value,taskType:o,required:i,properties:S.properties?g.$un(S.properties):{},when:S.when?L.$3i.deserialize(S.when):void 0}}m.from=v})(y||(y={}));const R=I.$uF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,v)=>{for(const S of m)S.type&&v.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Ud,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,S)=>{R.setHandler((h,f)=>{this.c=void 0;try{for(const o of f.removed){const i=o.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const o of f.added){const i=o.value;for(const r of i){const n=y.from(r,o.description.identifier,o.collector);n&&(this.a[n.taskType]=n)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const S of this.all()){const h={type:"object",additionalProperties:!1};S.required.length>0&&(h.required=S.required.slice(0)),S.properties!==void 0?h.properties=g.$un(S.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[S.taskType]},v.push(h)}this.c={oneOf:v}}return this.c}}e.$wG=new C}),define(ke[302],Se([1,0,230,18,23,24,46,301]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$GG=e.JsonSchemaVersion=e.ExecutionEngine=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$AG=e.ShellQuoting=e.$zG=e.$yG=e.$xG=void 0,e.$xG="settings",e.$yG=new L.$jj("taskRunning",!1,D.localize(0,null)),e.$zG={value:D.localize(1,null),original:"Tasks"};var $;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$AG="$customized",function(F){function M(B){if(!B)return F.Strong;switch(B.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=M}($||(e.ShellQuoting=$={}));var y;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R||(e.RevealKind=R={})),function(F){function M(B){switch(B.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=M}(R||(e.RevealKind=R={}));var C;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(F){function M(B){switch(B.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=M}(C||(e.RevealProblemKind=C={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m||(e.PanelKind=m={})),function(F){function M(B){switch(B.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=M}(m||(e.PanelKind=m={}));var v;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var S;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(F){function M(X){switch(X.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=M;function B(X){switch(X){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=B}(S||(e.RuntimeType=S={}));var h;(function(F){function M(B){return O.$Hf(B)?B:B.value}F.value=M})(h||(e.CommandString=h={}));var f;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function M(X){return X===F.Clean._id||X===F.Build._id||X===F.Rebuild._id||X===F.Test._id}F.is=M;function B(X){if(X!==void 0)return O.$Hf(X)?M(X)?{_id:X,isDefault:!1}:void 0:X}F.from=B})(f||(e.TaskGroup=f={}));var o;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function M(B){switch(B){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=M})(i||(e.TaskSourceKind=i={}));var r;(function(F){F.parallel="parallel",F.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var c;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(M,B,X,ue,Z,J){this._label="",this._id=M,B&&(this._label=B),X&&(this.type=X),this.runOptions=ue,this.configurationProperties=Z,this._source=J}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,B=!1){if(M===void 0)return!1;if(O.$Hf(M))return M===this._label||M===this.configurationProperties.identifier||B&&M===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.$BG=t;class u extends t{constructor(M,B,X,ue,Z,J,Y,he){super(M,X,void 0,Y,he,B),this.command={},this._source=B,this.hasDefinedMatchers=J,Z&&(this.command=Z)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case S.Shell:B="shell";break;case S.Process:B="process";break;case S.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(M){return M instanceof u}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$xG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.d();if(!M)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const X={type:e.$AG,folder:M,id:B};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Dg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new u(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$CG=u;class s extends t{constructor(M,B,X,ue,Z,J,Y){super(M,X,ue,J,Y,B),this._source=B,this.configures=Z}static is(M){return M instanceof s}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Dg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$xG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.d();if(!M)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const X={type:e.$AG,folder:M,id:B};return JSON.stringify(X)}}e.$DG=s;class l extends t{constructor(M,B,X,ue,Z,J,Y,he,_){super(M,X,ue,he,_,B),this.defines=Z,this.hasDefinedMatchers=Y,this.command=J,this.icon=_.icon,this.hide=_.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof l}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new l(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$EG=l;class a extends t{constructor(M,B,X,ue,Z,J){super(M,X,ue,Z,J,B),this._source=B}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new a(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.$FG=a;var d;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(F){F._default=F.Terminal}(d||(e.ExecutionEngine=d={}));var k;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class P{constructor(M){this.c=new Map;for(let B=0;B<M.length;B++)this.c.set(M[B].uri.toString(),B)}compare(M,B){const X=M.getWorkspaceFolder(),ue=B.getWorkspaceFolder();if(X&&ue){let Z=this.c.get(X.uri.toString());Z=Z===void 0?0:Z+1;let J=this.c.get(ue.uri.toString());return J=J===void 0?0:J+1,Z===J?M._label.localeCompare(B._label):Z-J}else return!X&&ue?-1:X&&!ue?1:0}}e.$GG=P;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p||(e.TaskEventKind=p={}));var w;(function(F){F.SingleRun="singleRun",F.Background="background"})(w||(e.TaskRunType=w={}));var E;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var A;(function(F){function M(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?"background":"singleRun",group:he.configurationProperties.group,__task:he}}function B(he,_,we){return{...M(he),kind:"start",terminalId:_,resolvedVariables:we}}F.start=B;function X(he,_,we){return{...M(he),kind:"processStarted",terminalId:_,processId:we}}F.processStarted=X;function ue(he,_,we){return{...M(he),kind:"processEnded",terminalId:_,exitCode:we}}F.processEnded=ue;function Z(he,_,we){return{...M(he),kind:"terminated",exitReason:we,terminalId:_}}F.terminated=Z;function J(he,_,we){return{...M(_),kind:he,terminalId:we}}F.general=J;function Y(){return{kind:"changed"}}F.changed=Y})(A||(e.TaskEvent=A={}));var T;(function(F){function M(X){const ue=Object.keys(X).sort();let Z="";for(const J of ue){let Y=X[J];Y instanceof Object?Y=M(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),Z+=J+","+Y+","}return Z}function B(X){const Z={_key:M(X),type:X.taskType};return Object.assign(Z,X),Z}F.create=B})(T||(e.KeyedTaskIdentifier=T={}));var U;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var N;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(N||(e.TasksSchemaProperties=N={}));var j;(function(F){function M(B,X){const ue=b.$wG.get(B.type);if(ue===void 0){const he=I.$un(B);return delete he._key,T.create(he)}const Z=Object.create(null);Z.type=ue.taskType;const J=new Set;ue.required.forEach(he=>J.add(he));const Y=ue.properties;for(const he of Object.keys(Y)){const _=B[he];if(_!=null)Z[he]=_;else if(J.has(he)){const we=Y[he];if(we.default!==void 0)Z[he]=I.$un(we.default);else switch(we.type){case"boolean":Z[he]=!1;break;case"number":case"integer":Z[he]=0;break;case"string":Z[he]="";break;default:X.error(D.localize(2,null,JSON.stringify(B,void 0,0),he));return}}}return T.create(Z)}F.createTaskIdentifier=M})(j||(e.TaskDefinition=j={}))}),define(ke[303],Se([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b8b=e.$a8b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,b)=>{this.b=L,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,D.$1)(L))}then(L,b){return this.j().then(L,b)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$a8b=O;class g extends O{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$b8b=g}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sv=e.$Rv=e.$Qv=e.$Pv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Pv=D;const O=[];function g(b){const $=new D(b);return O[$.nid]=$,$}e.$Qv=g;function I(b){return O[b].sid}e.$Rv=I;class L{constructor($){this.value=$}}e.$Sv=L}),define(ke[6],Se([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$5K=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$4K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var g;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var L;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var b;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var R;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$4K=C;var m;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var v;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var S;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$5K={MainThreadAuthentication:(0,D.$Qv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Qv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Qv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Qv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Qv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Qv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Qv)("MainThreadCommands"),MainThreadComments:(0,D.$Qv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Qv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Qv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Qv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Qv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Qv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Qv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Qv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Qv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Qv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Qv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Qv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Qv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Qv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Qv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Qv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Qv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Qv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Qv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Qv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Qv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Qv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Qv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Qv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Qv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Qv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Qv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Qv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Qv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Qv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Qv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Qv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Qv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Qv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Qv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Qv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Qv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Qv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Qv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Qv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Qv)("MainThreadSCM"),MainThreadSearch:(0,D.$Qv)("MainThreadSearch"),MainThreadShare:(0,D.$Qv)("MainThreadShare"),MainThreadTask:(0,D.$Qv)("MainThreadTask"),MainThreadWindow:(0,D.$Qv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Qv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Qv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Qv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Qv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Qv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Qv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Qv)("MainThreadInteractive"),MainThreadChat:(0,D.$Qv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Qv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Qv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Qv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Qv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Qv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Qv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Qv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Qv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Qv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Qv)("MainThreadIssueReporter")},e.$6K={ExtHostCommands:(0,D.$Qv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Qv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Qv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Qv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Qv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Qv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Qv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Qv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Qv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Qv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Qv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Qv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Qv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Qv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Qv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Qv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Qv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Qv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Qv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Qv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Qv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Qv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Qv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Qv)("ExtHostSCM"),ExtHostSearch:(0,D.$Qv)("ExtHostSearch"),ExtHostTask:(0,D.$Qv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Qv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Qv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Qv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Qv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Qv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Qv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Qv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Qv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Qv)("ExtHostProgress"),ExtHostComments:(0,D.$Qv)("ExtHostComments"),ExtHostSecretState:(0,D.$Qv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Qv)("ExtHostStorage"),ExtHostUrls:(0,D.$Qv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Qv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Qv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Qv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Qv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Qv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Qv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Qv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Qv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Qv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Qv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Qv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Qv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Qv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Qv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Qv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Qv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Qv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Qv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Qv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Qv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Qv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Qv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Qv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Qv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Qv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Qv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Qv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Qv)("ExtHostIssueReporter")}}),define(ke[304],Se([1,0,6,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$5K.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(L);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(L,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(L,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new O.$7K(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$Tfc=g}),define(ke[91],Se([1,0,5,13,6,20]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=e.$Zfc=void 0,e.$Zfc=(0,D.$5h)("IExtHostApiDeprecationService");let L=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$5K.MainThreadTelemetry)}report($,y,R){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$1fc=L,e.$1fc=L=Ge([We(0,I.$9M),We(1,O.$mj)],L),e.$2fc=Object.freeze(new class{report(b,$,y){}})}),define(ke[305],Se([1,0,4,6,7,26]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class L{constructor(y){this.b=new Map,this.c=new D.$Ud,this.onDidChangeSessions=this.c.event,this.d=new b,this.f=new b,this.a=y.getProxy(O.$5K.MainThreadAuthentication)}async getSession(y,R,C,m={}){const v=I.$km.toKey(y.identifier),S=[...C].sort().join(" ");return await this.d.getOrCreate(`${v} ${R} ${S}`,async()=>{await this.a.$ensureProvider(R);const h=y.displayName||y.name;return this.a.$getSession(R,C,v,h,m)})}async getSessions(y,R,C){const m=I.$km.toKey(y.identifier),v=[...C].sort().join(" ");return await this.f.getOrCreate(`${m} ${v}`,async()=>{await this.a.$ensureProvider(R);const S=y.displayName||y.name;return this.a.$getSessions(R,C,m,S)})}async removeSession(y,R){const C=this.b.get(y);return C?C.provider.removeSession(R):this.a.$removeSession(y,R)}registerAuthenticationProvider(y,R,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:R,provider:C,options:m??{supportsMultipleAccounts:!1}});const v=C.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(y,S));return this.a.$registerAuthenticationProvider(y,R,m?.supportsMultipleAccounts??!1),new g.$7K(()=>{v.dispose(),this.b.delete(y),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,R,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(R,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,R){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,R){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,R){return this.c.fire({provider:{id:y,label:R}}),Promise.resolve()}}e.$5fc=L;class b{constructor(){this.a=new Map}getOrCreate(y,R){const C=this.a.get(y);if(C)return C;const m=R().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(ke[306],Se([1,0,6,20,15]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;let I=class{constructor(b,$){this.a=b.getProxy(D.$5K.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const R=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};e.$6fc=I,e.$6fc=I=Ge([We(0,O.$9M)],I)}),define(ke[307],Se([1,0,53,3,6,15]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class L{static{this.a=0}constructor(y,R){this.extension=y,this.provider=R,this.handle=L.a++}}class b{static{this.a=0}constructor(y){this.b=new Map,this.c=new Map,this.d=y.getProxy(g.$5K.MainThreadChat)}registerChatProvider(y,R,C){const m=new L(y,C);return this.b.set(m.handle,m),this.d.$registerChatProvider(m.handle,R),(0,O.$Rc)(()=>{this.d.$unregisterChatProvider(m.handle),this.b.delete(m.handle)})}transferChatSession(y,R){const C=D.Iterable.find(this.c.keys(),m=>this.c.get(m)===y)??0;typeof C=="number"&&this.d.$transferChatSession(C,R)}sendInteractiveRequestToProvider(y,R){this.d.$sendRequestToProvider(y,R)}async $prepareChat(y,R){const C=this.b.get(y);if(!C)return;const m=await C.provider.prepareSession(R);if(!m)return;const v=b.a++;return this.c.set(v,m),{id:v,requesterUsername:m.requester?.name,requesterAvatarIconUri:m.requester?.icon,responderUsername:m.responder?.name,responderAvatarIconUri:m.responder?.icon,inputPlaceholder:m.inputPlaceholder}}async $provideWelcomeMessage(y,R){const C=this.b.get(y);if(!C||!C.provider.provideWelcomeMessage)return;const m=await C.provider.provideWelcomeMessage(R);if(m)return m.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(S=>I.ChatReplyFollowup.from(S)):I.MarkdownString.from(v))}async $provideSampleQuestions(y,R){const C=this.b.get(y);if(!C||!C.provider.provideSampleQuestions)return;const m=await C.provider.provideSampleQuestions(R);if(m)return m?.map(v=>I.ChatReplyFollowup.from(v))}$releaseSession(y){this.c.delete(y)}}e.$7fc=b}),define(ke[308],Se([1,0,11,21,44,4,38,18,2,210,85,6,15,7,279,25]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class f{static{this.a=0}constructor(r,n,c){this.i=n,this.j=c,this.b=new Map,this.g=new Map,this.h=new Map,this.d=r.getProxy(C.$5K.MainThreadChatAgents2)}createChatAgent(r,n,c){const t=f.a++,u=new o(r,n,this.d,t,c);return this.b.set(t,u),this.d.$registerAgent(t,n,{}),u.apiAgent}async $invokeAgent(r,n,c,t,u,s){this.g.delete(n);const l=this.b.get(r);if(!l)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let a=!1;function d(){if(a)throw new Error("Only valid while executing the command")}const k=new D.$ph;s.onCancellationRequested(()=>k.complete()),this.i.allowListExtensionWhile(l.extension.identifier,k.p);const P=t.command?await l.validateSlashCommand(t.command):void 0,p=L.$Qd.create(!1);let w;try{const E=l.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:P},{history:u.history.map(m.ChatMessage.to)},new R.$uv(A=>{d(),typeof w>"u"&&"content"in A&&(w=p.elapsed());const T=m.ChatResponseProgress.from(l.extension,A);if(!T){this.j.error("Unknown progress type: "+JSON.stringify(A));return}if("placeholder"in A&&"resolvedContent"in A){const U=Promise.all([this.d.$handleProgressChunk(c,T),A.resolvedContent]);(0,D.$Tg)(U,s).then(N=>{if(!N)return;const[j,F]=N,M=m.ChatResponseProgress.from(l.extension,F);if(!M){this.j.error("Unknown progress type: "+JSON.stringify(F));return}this.d.$handleProgressChunk(c,M,j??void 0)})}else this.d.$handleProgressChunk(c,T)}),s);return await(0,D.$Tg)(Promise.resolve(E).then(A=>{if(A){this.g.set(n,A);let T=this.h.get(n);T||(T=new Map,this.h.set(n,T)),T.set(c,A);const U={firstProgress:w,totalElapsed:p.elapsed()};return{errorDetails:A.errorDetails,timings:U}}else this.g.delete(n)}),s)}catch(E){return this.j.error(E,l.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Pi)(E)),responseIsIncomplete:!0}}}finally{a=!0,k.complete()}}$releaseSession(r){this.g.delete(r),this.h.delete(r)}async $provideSlashCommands(r,n){const c=this.b.get(r);return c?c.provideSlashCommand(n):[]}$provideFollowups(r,n,c){const t=this.b.get(r);if(!t)return Promise.resolve([]);const u=this.g.get(n);return u?t.provideFollowups(u,c):Promise.resolve([])}$acceptFeedback(r,n,c,t,u){const s=this.b.get(r);if(!s)return;const l=this.h.get(n)?.get(c);if(!l)return;let a;switch(t){case S.InteractiveSessionVoteDirection.Down:a=v.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:a=v.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze(u?{result:l,kind:a,reportIssue:u}:{result:l,kind:a}))}$acceptAction(r,n,c,t){const u=this.b.get(r);if(!u)return;const s=this.h.get(n)?.get(c);s&&t.action.kind!=="vote"&&u.acceptAction(Object.freeze({action:t.action,result:s}))}async $invokeCompletionProvider(r,n,c){const t=this.b.get(r);return t?(await t.invokeCompletionProvider(n,c)).map(m.ChatAgentCompletionItem.from):[]}}e.$9fc=f;class o{constructor(r,n,c,t,u){this.extension=r,this.t=n,this.u=c,this.w=t,this.x=u,this.o=new I.$Ud,this.q=new I.$Ud}acceptFeedback(r){this.o.fire(r)}acceptAction(r){this.q.fire(r)}async invokeCompletionProvider(r,n){return this.s?await this.s.provider.provideCompletionItems(r,n)??[]:[]}async validateSlashCommand(r){this.b||(await this.provideSlashCommand(O.CancellationToken.None),(0,b.$Rf)(this.b));const n=this.b.find(c=>c.name===r);if(!n)throw new Error(`Unknown slashCommand: ${r}`);return n}async provideSlashCommand(r){if(!this.a)return[];const n=await this.a.provideSlashCommands(r);return n?(this.b=n,n.map(c=>({name:c.name,description:c.description,followupPlaceholder:c.followupPlaceholder,shouldRepopulate:c.shouldRepopulate,sampleRequest:c.sampleRequest}))):[]}async provideFollowups(r,n){if(!this.d)return[];const c=await this.d.provideFollowups(r,n);return c?c.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let r=!1,n=!1;const c=()=>{r||n||(n=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$2L?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),n=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(u){t.g=u,c()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(u){t.h=u,c()},get iconPath(){return t.i},set iconPath(u){t.i=u,c()},get slashCommandProvider(){return t.a},set slashCommandProvider(u){t.a=u,c()},get followupProvider(){return t.d},set followupProvider(u){t.d=u,c()},get isDefault(){return(0,h.$BF)(t.extension,"defaultChatAgent"),t.j},set isDefault(u){(0,h.$BF)(t.extension,"defaultChatAgent"),t.j=u,c()},get helpTextPrefix(){return(0,h.$BF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(u){if((0,h.$BF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=u,c()},get helpTextPostfix(){return(0,h.$BF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(u){if((0,h.$BF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=u,c()},get isSecondary(){return(0,h.$BF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(u){(0,h.$BF)(t.extension,"defaultChatAgent"),t.n=u,c()},get sampleRequest(){return t.m},set sampleRequest(u){t.m=u,c()},get supportIssueReporting(){return(0,h.$BF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(u){(0,h.$BF)(t.extension,"chatAgents2Additions"),t.r=u,c()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(u){if(t.s=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,u.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,h.$AF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){r=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(r,n,c,t){return this.x(r,n,c,t)}}}),define(ke[309],Se([1,0,21,3,6,15,85,26,11,4]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class R{constructor(S,h){this.stream=new $.$vh,this.stream=h??new $.$vh;const f=this;this.apiObj={option:S,response:f.stream.asyncIterable}}}class C{constructor(S,h){this.a=new y.$Ud,this.b=new Map,this.c=new $.$vh,this.d=!1;const f=this;this.apiObject={result:S,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){h.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let h=this.b.get(S.index);h||(this.b.size===0?h=new R(S.index,this.c):h=new R(S.index),this.b.set(S.index,h),this.a.fire(h.apiObj)),h.stream.emitOne(S.part)}}class m{static{this.a=1}constructor(S,h){this.d=h,this.c=new Map,this.e=new Map,this.f=new b.$mm,this.b=S.getProxy(g.$5K.MainThreadChatProvider)}registerProvider(S,h,f,o){const i=m.a++;return this.c.set(i,{extension:S,provider:f}),this.b.$registerProvider(i,h,{extension:S,model:o.name??""}),(0,O.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,h,f,o,i){const r=this.c.get(S);if(!r)return;const n=new L.$uv(async c=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(h,{index:c.index,part:c.part})});return r.provider.provideChatResponse(f.map(I.ChatMessage.to),o,n,i)}allowListExtensionWhile(S,h){this.f.set(S,h),h.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,h){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(h);if(!f)throw new Error(`ChatAccess '${h}' NOT found`);const o=this;return{get model(){return f.model},get isRevoked(){return!o.f.has(S)},makeRequest(i,r,n){if(!o.f.has(S))throw new Error("Access to chat has been revoked");const c=new D.$5d(n),t=Math.random()*1e6|0,u=o.b.$fetchResponse(S,h,t,i.map(I.ChatMessage.from),r??{},c.token),s=new C(u,c);return o.e.set(t,{res:s}),u.finally(()=>{o.e.delete(t)}),s.apiObject}}}async $handleResponseFragment(S,h){const f=this.e.get(S);f&&f.res.handleFragment(h)}}e.$8fc=m}),define(ke[310],Se([1,0,3,6,14,15]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class L{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(O.$5K.MainThreadChatVariables)}async $resolveVariable($,y,R){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{prompt:y},R);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,R,C){const m=L.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:R},resolver:C}),this.c.$registerVariable(m,{name:y,description:R}),(0,D.$Rc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$0fc=L}),define(ke[311],Se([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class O{constructor(I){const L=I.getProxy(D.$5K.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(b){return L.$writeText(b)}})}}e.$$fc=O}),define(ke[35],Se([1,0,18,7,15,24,6,19,13,55,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=void 0;let s=class{#e;#t;#i;constructor(p,w,E){this.b=new Map,this.c=new Map,this.#e=p.getProxy(L.$5K.MainThreadCommands),this.d=w,this.#i=E,this.#t=p.getProxy(L.$5K.MainThreadTelemetry),this.converter=new l(this,A=>{const T=this.c.get(A);return T?.result===d.Void?T:void 0},w),this.f=[{processArgument(A){return(0,y.$Bh)(A)}},{processArgument(A){return(0,I.$wn)(A,function(T){if(R.$Ts.isIRange(T))return g.Range.to(T);if(C.$Ss.isIPosition(T))return g.Position.to(T);if(R.$Ts.isIRange(T.range)&&m.URI.isUri(T.uri))return g.location.to(T);if(T instanceof o.$ie)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const w=this.registerCommand(!1,p.id,async(...E)=>{const A=p.args.map((U,N)=>{if(!U.validate(E[N]))throw new Error(`Invalid argument '${U.name}' when running '${p.id}', received: ${typeof E[N]=="object"?JSON.stringify(E[N],null,"	"):E[N]} `);return U.convert(E[N])}),T=await this.executeCommand(p.internalId,...A);return p.result.convert(T,E,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new O.$7K(()=>{w.dispose(),this.c.delete(p.id)})}registerCommand(p,w,E,A,T,U){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:E,thisArg:A,metadata:T,extension:U}),p&&this.#e.$registerCommand(w),new O.$7K(()=>{this.b.delete(w)&&p&&this.#e.$unregisterCommand(w)})}executeCommand(p,...w){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,w,!0)}async g(p,w,E){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,w,!1);{let A=!1;const T=(0,I.$wn)(w,function(U){if(U instanceof O.$8K)return g.Position.from(U);if(U instanceof O.$9K)return g.Range.from(U);if(U instanceof O.$gL)return g.location.from(U);if(O.$sM.isNotebookRange(U))return g.NotebookRange.from(U);if(U instanceof ArrayBuffer)return A=!0,o.$ie.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return A=!0,o.$ie.wrap(U);if(U instanceof o.$ie)return A=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(p,A?new i.$Sv(T):T,E);return(0,y.$Bh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(p,w,!1);throw U}}}async h(p,w,E){const A=this.b.get(p);if(!A)throw new Error("Unknown command");const{callback:T,thisArg:U,metadata:N}=A;if(N?.args)for(let F=0;F<N.args.length;F++)try{(0,D.$Yf)(w[F],N.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${N.args[F].name}' - ${N.args[F].description}`)}const j=n.$Qd.create();try{return await T.apply(U,w)}catch(F){if(p===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...w);M&&(p=M.command)}if(this.d.error(F,p,A.extension?.identifier),!E)throw F;if(A.extension?.identifier){const M=this.#i.onExtensionError(A.extension.identifier,F);this.d.trace("forwarded error to extension?",M,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Pi)(F)),this.id=p,this.source=A.extension?.displayName??A.extension?.name}}}finally{this.j(A,p,j.elapsed())}}j(p,w,E){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new c.$Jo(w),duration:E})}$executeContributedCommand(p,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const E=this.b.get(p);return E?(w=w.map(A=>this.f.reduce((T,U)=>U.processArgument(T,E.extension?.identifier),A)),this.h(p,w,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(w=>(p&&(w=w.filter(E=>E[0]!=="_")),w))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[w,E]of this.b){const{metadata:A}=E;A&&(p[w]=A)}return Promise.resolve(p)}};e.$rN=s,e.$rN=s=Ge([We(0,h.$9M),We(1,$.$mj),We(2,t.$qN)],s),e.$sN=(0,S.$5h)("IExtHostCommands");class l{constructor(p,w,E){this.d=p,this.f=w,this.g=E,this.delegatingCommandId=`__vsc${(0,u.$pg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,w){if(!p)return;const E={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return E;const A=this.f(p.command);if(A)E.id=A.internalId,E.arguments=A.args.map((T,U)=>T.convert(p.arguments&&p.arguments[U]));else if((0,b.$Lb)(p.arguments)){const T=`${p.command} /${++this.c}`;this.b.set(T,p),w.add((0,v.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),E.$ident=T,E.id=this.delegatingCommandId,E.arguments=[T],this.g.trace("CommandsConverter#CREATE",p.command,T)}return E}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const w=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$tN=l;class a{static{this.Uri=new a("uri","Uri of a text document",p=>m.URI.isUri(p),p=>p)}static{this.Position=new a("position","A position in a text document",p=>O.$8K.isPosition(p),g.Position.from)}static{this.Range=new a("range","A range in a text document",p=>O.$9K.isRange(p),g.Range.from)}static{this.Selection=new a("selection","A selection in a text document",p=>O.$0K.isSelection(p),g.Selection.from)}static{this.Number=new a("number","",p=>typeof p=="number",p=>p)}static{this.String=new a("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=a.Arr(a.String)}static Arr(p){return new a(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,w=>Array.isArray(w)&&w.every(E=>p.validate(E)),w=>w.map(E=>p.convert(E)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",p=>p instanceof O.$rL,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",p=>p instanceof O.$LM,g.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",p=>p instanceof f.$jN,g.TestItem.from)}constructor(p,w,E,A){this.name=p,this.description=w,this.validate=E,this.convert=A}optional(){return new a(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,w){return new a(p??this.name,w??this.description,this.validate,this.convert)}}e.$uN=a;class d{static{this.Void=new d("no result",p=>p)}constructor(p,w){this.description=p,this.convert=w}}e.$vN=d;class k{constructor(p,w,E,A,T){this.id=p,this.internalId=w,this.description=E,this.args=A,this.result=T}}e.$wN=k}),define(ke[312],Se([1,0,19,17,2,83,131,46,35,15,7]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;const C=[new $.$wN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of DocumentHighlight-instances.",v(y.DocumentHighlight.to))),new $.$wN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$uN.Uri],new $.$vN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,f)=>{if((0,D.$Kb)(h))return;class o extends R.$mL{static to(r){const n=new o(r.name,y.SymbolKind.to(r.kind),r.containerName||"",new R.$gL(f[0],y.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=y.Range.to(r.selectionRange),n.children=r.children?r.children.map(o.to):[],n}}return h.map(o.to)})),new $.$wN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$uN.Uri,new $.$uN("options","Formatting options",h=>!0,h=>h)],new $.$vN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$wN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$uN.Uri,$.$uN.Range,new $.$uN("options","Formatting options",h=>!0,h=>h)],new $.$vN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$wN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$uN.Uri,$.$uN.Position,new $.$uN("ch","Trigger character",h=>typeof h=="string",h=>h),new $.$uN("options","Formatting options",h=>!0,h=>h)],new $.$vN("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$wN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$wN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$wN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$wN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$wN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of Location-instances.",v(y.location.to))),new $.$wN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new $.$wN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$uN.Uri,new $.$uN("position","A position in a text document",h=>Array.isArray(h)&&h.every(f=>R.$8K.isPosition(f)),h=>h.map(y.Position.from))],new $.$vN("A promise that resolves to an array of ranges.",h=>h.map(f=>{let o;for(const i of f.reverse())o=new R.$qL(y.Range.to(i),o);return o}))),new $.$wN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$uN.String.with("query","Search string")],new $.$vN("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(y.WorkspaceSymbol.to))),new $.$wN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(y.CallHierarchyItem.to))),new $.$wN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$uN.CallHierarchyItem],new $.$vN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(y.CallHierarchyIncomingCall.to))),new $.$wN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$uN.CallHierarchyItem],new $.$vN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(y.CallHierarchyOutgoingCall.to))),new $.$wN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:y.Range.to(h.range),placeholder:h.text}})),new $.$wN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$uN.Uri,$.$uN.Position,$.$uN.String.with("newName","The new symbol name")],new $.$vN("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return y.WorkspaceEdit.to(h)}})),new $.$wN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$uN.Uri,$.$uN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$vN("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(y.DocumentLink.to))),new $.$wN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$uN.Uri],new $.$vN("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new R.$kM(h.tokenTypes,h.tokenModifiers)})),new $.$wN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$uN.Uri],new $.$vN("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,L.$r$)(h);if(f.type==="full")return new R.$mM(f.data,void 0)})),new $.$wN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$uN.Uri,$.$uN.Range.optional()],new $.$vN("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new R.$kM(h.tokenTypes,h.tokenModifiers)})),new $.$wN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$uN.Uri,$.$uN.Range],new $.$vN("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,L.$r$)(h);if(f.type==="full")return new R.$mM(f.data,void 0)})),new $.$wN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$uN.Uri,$.$uN.Position,$.$uN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$uN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$vN("A promise that resolves to a CompletionList-instance.",(h,f,o)=>{if(!h)return new R.$CL([]);const i=h.suggestions.map(r=>y.CompletionItem.to(r,o));return new R.$CL(i,h.incomplete)})),new $.$wN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$uN.Uri,$.$uN.Position,$.$uN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$vN("A promise that resolves to SignatureHelp.",h=>{if(h)return y.SignatureHelp.to(h)})),new $.$wN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$uN.Uri,$.$uN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$vN("A promise that resolves to an array of CodeLens-instances.",(h,f,o)=>v(i=>new R.$uL(y.Range.to(i.range),i.command&&o.fromInternal(i.command)))(h))),new $.$wN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$uN.Uri,new $.$uN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>R.$9K.isRange(h),h=>R.$0K.isSelection(h)?y.Selection.from(h):y.Range.from(h)),$.$uN.String.with("kind","Code action kind to return code actions for").optional(),$.$uN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$vN("A promise that resolves to an array of Command-instances.",(h,f,o)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const r=new R.$oL(i.title,i.kind?new R.$pL(i.kind):void 0);return i.edit&&(r.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(r.command=o.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(h))),new $.$wN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$uN.Uri],new $.$vN("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(f=>new R.$IL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$wN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$uN("color","The color to show and insert",h=>h instanceof R.$HL,y.Color.from),new $.$uN("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:y.Range.from(h.range)}))],new $.$vN("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(y.ColorPresentation.to):[])),new $.$wN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$uN.Uri,$.$uN.Range],new $.$vN("A promise that resolves to an array of Inlay objects",(h,f,o)=>h.map(y.InlayHint.to.bind(void 0,o)))),new $.$wN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$uN.Uri],new $.$vN("A promise that resolves to an array of FoldingRange objects",(h,f)=>{if(h)return h.map(y.FoldingRange.to)})),new $.$wN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$vN("A promise that resolves to an array of NotebookContentProvider static info objects.",v(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$wN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$uN.Uri,$.$uN.Range,new $.$uN("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof R.$9K,h=>y.InlineValueContext.from(h))],new $.$vN("A promise that resolves to an array of InlineValue objects",h=>h.map(y.InlineValue.to))),new $.$wN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$uN("uriOrString","Uri-instance or string (only http/https)",h=>g.URI.isUri(h)||typeof h=="string"&&(0,O.$eg)(h,O.Schemas.http,O.Schemas.https),h=>h),new $.$uN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[y.ViewColumn.from(h),void 0]:[y.ViewColumn.from(h.viewColumn),y.TextEditorOpenOptions.from(h)])).optional(),$.$uN.String.with("label","").optional()],$.$vN.Void),new $.$wN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$uN.Uri.with("resource","Resource to open"),$.$uN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$uN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[y.ViewColumn.from(h),void 0]:[y.ViewColumn.from(h.viewColumn),y.TextEditorOpenOptions.from(h)])).optional()],$.$vN.Void),new $.$wN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$uN.Uri.with("left","Left-hand side resource of the diff editor"),$.$uN.Uri.with("right","Right-hand side resource of the diff editor"),$.$uN.String.with("title","Human readable title for the diff editor").optional(),new $.$uN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[y.ViewColumn.from(h.viewColumn),y.TextEditorOpenOptions.from(h)]).optional()],$.$vN.Void),new $.$wN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$uN.String.with("title","Human readable title for the changes editor"),new $.$uN("resourceList","List of resources to compare",h=>{for(const f of h){if(f.length!==3)return!1;const[o,i,r]=f;if(!g.URI.isUri(o)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},h=>h)],$.$vN.Void),new $.$wN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$uN.Uri,$.$uN.Position],new $.$vN("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(y.TypeHierarchyItem.to))),new $.$wN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$uN.TypeHierarchyItem],new $.$vN("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(y.TypeHierarchyItem.to))),new $.$wN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$uN.TypeHierarchyItem],new $.$vN("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(y.TypeHierarchyItem.to))),new $.$wN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$uN.TestItem],$.$vN.Void),new $.$wN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$uN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$vN.Void),new $.$wN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$uN.String.with("name","The context key name"),new $.$uN("value","The context key value",()=>!0,h=>h)],$.$vN.Void),new $.$wN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$uN.Uri,$.$uN.StringArray,new $.$uN("MappedEditsContext","Mapped Edits Context",h=>y.MappedEditsContext.is(h),h=>y.MappedEditsContext.from(h))],new $.$vN("A promise that resolves to a workspace edit or null",h=>h?y.WorkspaceEdit.to(h):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$4i)}}e.$4fc=m;function v(h){return f=>{if(Array.isArray(f))return f.map(h)}}function S(h){if(!Array.isArray(h))return;const f=[];for(const o of h)I.$Ft(o)?f.push(y.DefinitionLink.to(o)):f.push(y.location.to(o));return f}}),define(ke[313],Se([1,0,11,52,4,3,2,83,26,15,7,6,25]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;function v(S,h,f){const o=S.getProxy(C.$5K.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$mm,h.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const k=this.b.get(d.handle);return k?k.value:d}else if(d&&d.$mid===7){const k=this.b.get(d.commentControlHandle);if(!k)return d;const P=k.getCommentThread(d.commentThreadHandle);return P?P.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const P=k.getCommentThread(d.thread.commentThreadHandle);return P?d.$mid===8?P.value:{thread:P.value,text:d.text}:d}else if(d&&d.$mid===10){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const P=k.getCommentThread(d.thread.commentThreadHandle);if(!P)return d;const p=d.commentUniqueId,w=P.getCommentByUniqueId(p);return w||d}else if(d&&d.$mid===11){const k=this.b.get(d.thread.commentControlHandle);if(!k)return d;const P=k.getCommentThread(d.thread.commentThreadHandle);if(!P)return d;const p=d.text,w=d.commentUniqueId,E=P.getCommentByUniqueId(w);return E?(typeof E.body=="string"?E.body=p:E.body=new R.$vL(p),E):d}return d}})}createCommentController(d,k,P){const p=i.a++,w=new n(d,p,k,P);this.b.set(w.handle,w);const E=this.c.get(d.identifier)||[];return E.push(w),this.c.set(d.identifier,E),w.value}async $createCommentThreadTemplate(d,k,P){const p=this.b.get(d);p&&p.$createCommentThreadTemplate(k,P)}async $updateCommentThreadTemplate(d,k,P){const p=this.b.get(d);p&&p.$updateCommentThreadTemplate(k,P)}$deleteCommentThread(d,k){this.b.get(d)?.$deleteCommentThread(k)}$provideCommentingRanges(d,k,P){const p=this.b.get(d);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const w=f.getDocument(L.URI.revive(k));return(0,D.$Xg)(async()=>{const E=await p.commentingRangeProvider.provideCommentingRanges(w,P);let A;return Array.isArray(E)?A={ranges:E,fileComments:!1}:E?A={ranges:E.ranges||[],fileComments:E.fileComments||!1}:A=E??void 0,A}).then(E=>{let A;return E&&(A={ranges:E.ranges.map(T=>y.Range.from(T)),fileComments:E.fileComments}),A})}$toggleReaction(d,k,P,p,w){const E=this.b.get(d);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Xg)(()=>{const A=E.getCommentThread(k);if(A){const T=A.getCommentByUniqueId(p.uniqueIdInThread);if(E!==void 0&&T&&E.reactionHandler)return E.reactionHandler(T,u(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,k,P,p,w,E,A,T){this.m=k,this.n=P,this.o=p,this.p=w,this.q=E,this.extensionDescription=A,this.r=T,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Ud,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Uc,this.l.value=new I.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),o.$createCommentThread(k,this.handle,this.n,this.o,y.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{o.$deleteCommentThread(k,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(N){U.range=N},get comments(){return U.comments},set comments(N){U.comments=N},get collapsibleState(){return U.collapsibleState},set collapsibleState(N){U.collapsibleState=N},get canReply(){return U.canReply},set canReply(N){U.canReply=N},get contextValue(){return U.contextValue},set contextValue(N){U.contextValue=N},get label(){return U.label},set label(N){U.label=N},get state(){return U.state},set state(N){U.state=N},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Sc);const d=P=>Object.prototype.hasOwnProperty.call(this.b,P),k={};d("range")&&(k.range=y.Range.from(this.p)),d("label")&&(k.label=this.label),d("contextValue")&&(k.contextValue=this.contextValue??null),d("comments")&&(k.comments=this.q.map(P=>c(this,P,this.k,this.extensionDescription))),d("collapsibleState")&&(k.collapseState=s(this.g)),d("canReply")&&(k.canReply=this.canReply),d("state")&&(k.state=l(this.h)),d("isTemplate")&&(k.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(d){for(const k of this.k){const P=k[0],p=k[1];if(d===p)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ge([(0,O.$xh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,k,P,p){this.f=d,this.g=k,this.h=P,this.i=p,this.a=new Map,o.$registerCommentController(this.handle,P,p,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,A,T){return w.createCommentThread(E,A,T).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(d,k,P){k===void 0&&(0,m.$BF)(this.f,"fileComments");const p=new r(this.id,this.handle,void 0,d,k,P,this.f,!1);return this.a.set(p.handle,p),p}$createCommentThreadTemplate(d,k){const P=new r(this.id,this.handle,void 0,L.URI.revive(d),y.Range.to(k),[],this.f,!0);return P.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(d,k){const P=this.a.get(d);P&&(P.range=y.Range.to(k))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function c(a,d,k,P){let p=k.get(d);return p||(p=++a.commentHandle,k.set(d,p)),d.state!==void 0&&(0,m.$BF)(P,"commentsDraftState"),d.reactions?.some(w=>w.reactors!==void 0)&&(0,m.$BF)(P,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:p,body:typeof d.body=="string"?d.body:y.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(w=>t(w)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?y.$8M(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted,reactors:a.reactors&&a.reactors.length>0&&typeof a.reactors[0]!="string"?a.reactors.map(d=>d.name):a.reactors}}function u(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?L.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1,reactors:a.reactors?.map(d=>({name:d}))}}function s(a){if(a!==void 0)switch(a){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(a){if(a!==void 0)switch(a){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$bgc=v}),define(ke[314],Se([1,0,24,6,27,20]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let L=class{constructor(R,C){this.a=R.getProxy(O.$5K.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,C){const m=this,v=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m.e(R,C,v,arguments)}})}e(R,C,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(v,this.b)}),this.c&&this.f(R,m,v)}};e.$2hc=L,e.$2hc=L=Ge([We(0,I.$9M),We(1,g.$mN)],L);const b=1e5;function $(y,R){const C=[];if(y.length)for(let m=0;m<y.length;m++){let v=y[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const S=v;S.stack?v=S.stack:v=S.toString()}C.push(v)}if(R){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$zn)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[149],Se([1,0,2,6,7,5,20,13,19,12,16,25]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=void 0;let v=class{static{m=this}static{this.c=0}static{this.d=250}constructor(h,f){this.h=f,this.f=new Map,this.g=h.getProxy(O.$5K.MainThreadDecorations)}registerFileDecorationProvider(h,f){const o=m.c++;this.f.set(o,{provider:h,extensionDescription:f}),this.g.$registerDecorationProvider(o,f.identifier.value);const i=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(o,null);return}const n=(0,$.$3b)(r);if(n.length<=m.d){this.g.$onDidChange(o,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,n.length);const c=n.map(s=>({uri:s,rank:(0,y.$Oe)(s.path,"/")})),t=(0,$.$zb)(c,(s,l)=>s.rank-l.rank||(0,y.$4e)(s.uri.path,l.uri.path)),u=[];e:for(const s of t){let l;for(const a of s){const d=(0,R.$mc)(a.uri.path);if(l!==d&&(l=d,u.push(a.uri)>=m.d))break e}}this.g.$onDidChange(o,u)});return new g.$7K(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(h,f,o){if(!this.f.has(h))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(h);return await Promise.all(f.map(async c=>{try{const{uri:t,id:u}=c,s=await Promise.resolve(r.provideFileDecoration(D.URI.revive(t),o));if(!s)return;try{g.$qM.validate(s),s.badge&&typeof s.badge!="string"&&(0,C.$BF)(n,"codiconDecoration"),i[u]=[s.propagate,s.tooltip,s.badge,s.color]}catch(l){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),i}};e.$4gc=v,e.$4gc=v=m=Ge([We(0,L.$9M),We(1,b.$mj)],v),e.$5gc=(0,I.$5h)("IExtHostDecorations")}),define(ke[315],Se([1,0,211,135,2,6,7,15,4,13,28,58]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0;class v{#e;#t;#i;constructor(f,o,i,r,n,c,t,u){this.d=f,this.e=o,this.f=i,this.g=r,this.h=n,this.c=!1,this.f=Math.max(r,i),this.#i=new R.$Ac(s=>c.getComparisonKey(s)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,o){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!o){this.delete(f);return}this.#i.set(f,o.slice()),i=[f]}else if(Array.isArray(f)){i=[];let c;f=[...f].sort(v.k);for(const t of f){const[u,s]=t;if((!c||u.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=u,i.push(u),this.#i.set(u,[])),s)this.#i.get(u)?.push(...s);else{const l=this.#i.get(u);l&&(l.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const c of i){let t=[];const u=this.#i.get(c);if(u)if(u.length>this.g){t=[];const s=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const a of u)if(a.severity===s[l]&&t.push({...b.Diagnostic.from(a),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,D.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(s=>({...b.Diagnostic.from(s),modelVersionId:this.h(c)}));if(r.push([c,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,r)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,o){this.j();for(const[i,r]of this)f.call(o,i,r,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const o=this.#i.get(f);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,o){return f[0].toString()<o[0].toString()?-1:f[0].toString()>o[0].toString()?1:0}}e.$Xfc=v;let S=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const o=new R.$Ac;for(const i of f)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(f,o,i,r){this.j=o,this.k=i,this.l=r,this.g=new Map,this.h=new $.$Yd({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(I.$5K.MainThreadDiagnostics)}createDiagnosticCollection(f,o){const{g:i,f:r,h:n,j:c,k:t,l:u}=this,s=new class{$changeMany(d,k){r.$changeMany(d,k),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,d,k.length===0?"CLEARING":k)}$clear(d){r.$clear(d),c.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,d)}dispose(){r.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+m.c++,l=o;else if(!i.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+m.c++;while(i.has(l))}return new class extends v{constructor(){super(o,l,m.e,m.d,d=>u.getDocument(d)?.version,t.extUri,s,n),i.set(l,this)}dispose(){super.dispose(),i.delete(l)}}}getDiagnostics(f){if(f)return this.m(f);{const o=new Map,i=[];for(const r of this.g.values())r.forEach((n,c)=>{let t=o.get(n.toString());typeof t>"u"&&(t=i.length,o.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(f){let o=[];for(const i of this.g.values())i.has(f)&&(o=o.concat(i.get(f)));return o}$acceptMarkersChange(f){if(!this.n){const o="_generated_mirror",i=new v(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of f)this.n.set(g.URI.revive(o),i.map(b.Diagnostic.to))}};e.$Yfc=S,e.$Yfc=S=m=Ge([We(1,y.$mj),We(2,C.$Wfc)],S)}),define(ke[316],Se([1,0,2,6,25]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;class I{constructor(b){this.a=b.getProxy(O.$5K.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$BF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(R=>D.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$6gc=I}),define(ke[317],Se([1,0,14,2,7,6,17,21,12]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class y{static{this.a=0}constructor(C,m,v){this.d=m,this.e=v,this.b=new Map,this.c=C.getProxy(I.$5K.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(L.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=y.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,C);let S;if(typeof m.onDidChange=="function"){let h;S=m.onDidChange(async f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;h&&await h;const o=this.$provideTextDocumentContent(v,f).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(f);if(!r)return;const n=(0,$.$Ye)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(f,i)}).catch(D.$1).finally(()=>{h===o&&(h=void 0)});h=o})}return new g.$7K(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,m){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(O.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$7gc=y}),define(ke[318],Se([1,0,4,3,2,6,141,15,18,24,7]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class C{constructor(v,S){this.a=new D.$Ud,this.b=new D.$Ud,this.c=new D.$Ud,this.d=new D.$Ud,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Sc,this.h=new Map,this.f=v.getProxy(I.$5K.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(h=>{for(const f of h)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const f of h)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const S=this.g.getDocument(v);if(S)return S}getDocument(v){const S=this.getDocumentData(v);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return S.document}ensureDocumentData(v){const S=this.g.getDocument(v);if(S)return Promise.resolve(S);let h=this.h.get(v.toString());return h||(h=this.f.$tryOpenDocument(v).then(f=>{this.h.delete(v.toString());const o=g.URI.revive(f);return(0,$.$Sf)(this.g.getDocument(o))},f=>(this.h.delete(v.toString()),Promise.reject(f))),this.h.set(v.toString(),h)),h}createDocumentData(v){return this.f.$tryCreateDocument(v).then(S=>g.URI.revive(S))}$acceptModelLanguageChanged(v,S){const h=g.URI.revive(v),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(S),this.a.fire(f.document)}$acceptModelSaved(v){const S=g.URI.revive(v),h=this.g.getDocument(S);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(v,S){const h=g.URI.revive(v),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");f._acceptIsDirty(S),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,S,h){const f=g.URI.revive(v),o=this.g.getDocument(f);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),o.onEvents(S);let i;S.isUndoing?i=R.TextDocumentChangeReason.Undo:S.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,y.$vn)({document:o.document,contentChanges:S.changes.map(r=>({range:b.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(v,S){(0,L.$$M)(v,S)}}e.$Ufc=C}),define(ke[69],Se([1,0,60,4,3,2,5,6,141,20,148,15,13,28,17,53,43]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=void 0;class o{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,c){this.h=n,this.i=c,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new O.$Ud,this.e=new O.$Ud,this.f=new O.$Ud,this.g=new O.$Ud,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const c=[],t=[],u=[];if(n.removedDocuments)for(const s of n.removedDocuments){const l=I.URI.revive(s),a=this.c.get(l);a?.unref()&&(this.c.delete(l),c.push(a.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const l=I.URI.revive(s.uri);let a=this.c.get(l);if(a&&l.scheme!==S.Schemas.vscodeNotebookCell&&l.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);a||(a=new o(new $.$_M(this.h.getProxy(b.$5K.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(l,a),t.push(a.value)),a.ref()}if(n.removedEditors)for(const s of n.removedEditors){const l=this.b.get(s);this.b.delete(s),l&&u.push(l)}if(n.addedEditors)for(const s of n.addedEditors){const l=I.URI.revive(s.documentUri);D.ok(this.c.has(l),`document '${l}' does not exist`),D.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const a=this.c.get(l).value,d=new R.$fN(s.id,this.h.getProxy(b.$5K.MainThreadTextEditors),this.i,new f.$V(()=>a.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(k=>C.Range.to(k)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,d)}n.newActiveEditor!==void 0&&(D.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,g.$Oc)(c),(0,g.$Oc)(u),n.removedDocuments&&this.e.fire(c),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return h.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const c=this.b.get(this.a);return n?c:c?.value}allEditors(){return[...this.b.values()]}};e.$gN=i,e.$gN=i=Ge([We(0,y.$9M),We(1,m.$mj)],i),e.$hN=(0,L.$5h)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,L.$5h)("IExtHostEditorTabs");class C{constructor(f,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$MM(I.URI.revive(this.b.input.uri));case 2:return new R.$NM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new R.$OM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new R.$PM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$QM(this.b.input.viewType);case 4:return new R.$RM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$SM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$TM;case 9:return new R.$UM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$VM(this.b.input.providerId);default:return}}}class m{constructor(f,o){this.c=[],this.d="",this.b=f,this.e=o;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,o={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const o=this.c.find(i=>i.tabId===f.tabDto.id);if(!o)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(f.tabDto),o}activeTabId(){return this.d}}let v=class{constructor(f){this.b=new O.$Ud,this.c=new O.$Ud,this.e=[],this.a=f.getProxy(b.$5K.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,o={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Sf)(f.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(f){const o=new Set(this.e.map(s=>s.groupId)),i=new Set(f.map(s=>s.groupId)),r=(0,D.$L)(o,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),c=[],t=[];this.e=f.map(s=>{const l=new m(s,()=>this.d);return r.added.includes(l.groupId)?c.push(l.apiObject):t.push(l.apiObject),l});const u=(0,g.$Sf)(f.find(s=>s.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:c,closed:n,changed:t}))}$acceptTabGroupUpdate(f){const o=this.e.find(i=>i.groupId===f.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const o=this.e.find(r=>r.groupId===f.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(o=>o.apiObject===f)}async i(f,o){const i=[];for(const r of f){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,o)}async j(f,o){const i=[];for(const r of f){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,o)}};e.$vgc=v,e.$vgc=v=Ge([We(0,$.$9M)],v);function S(h){return h.tabs!==void 0}}),define(ke[319],Se([1,0,6,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$5K.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(L);if(!y)throw new Error("Embedding vector provider not found");const R=await y.provideEmbeddingVector(b,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(L,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new O.$7K(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$9gc=g}),define(ke[320],Se([1,0,2,6,3,7,15,173,12,22,25,80]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class m{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const f=this.a.indexOf(h);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),f=[];let o,i,r=14,n=14;for(const c of h){let t=o?(0,$.$af)(o,c):0;for(t===0?i=1:i=n;t<c.length;t++)t+1===c.length?(r=n,n=9):n+=1,f.push([i,c.toUpperCase().charCodeAt(t),n]),f.push([i,c.toLowerCase().charCodeAt(t),n]),i=n;o=c,n=r}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$tZ(f)}}provideDocumentLinks(h){this.c();const f=[],o=b.$uZ.computeLinks({getLineContent(i){return h.lineAt(i-1).text},getLineCount(){return h.lineCount}},this.b);for(const i of o){const r=L.DocumentLink.to(i);r.target&&f.push(r)}return f}}class v{constructor(h,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(O.$5K.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,f,o,i={}){if(v.j(o),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const r=this.h++;this.b.add(f),this.d.add(f),this.c.set(r,o);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof o.copy=="function"&&(n+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,R.$BF)(h,"fsChunks"),n+=4);let c;i.isReadonly&&(0,C.$ik)(i.isReadonly)&&(c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,f,n,c).catch(u=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${f}`),console.error(u)});const t=o.onDidChangeFile(u=>{const s=[];for(const l of u){const{uri:a,type:d}=l;if(a.scheme!==f)continue;let k;switch(d){case I.FileChangeType.Changed:k=0;break;case I.FileChangeType.Created:k=1;break;case I.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:a,type:k})}this.a.$onFileSystemChange(r,s)});return(0,g.$Rc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:f,ctime:o,mtime:i,size:r,permissions:n}=h;return{type:f,ctime:o,mtime:i,size:r,permissions:n}}$stat(h,f){return Promise.resolve(this.l(h).stat(D.URI.revive(f))).then(o=>v.k(o))}$readdir(h,f){return Promise.resolve(this.l(h).readDirectory(D.URI.revive(f)))}$readFile(h,f){return Promise.resolve(this.l(h).readFile(D.URI.revive(f))).then(o=>y.$ie.wrap(o))}$writeFile(h,f,o,i){return Promise.resolve(this.l(h).writeFile(D.URI.revive(f),o.buffer,i))}$delete(h,f,o){return Promise.resolve(this.l(h).delete(D.URI.revive(f),o))}$rename(h,f,o,i){return Promise.resolve(this.l(h).rename(D.URI.revive(f),D.URI.revive(o),i))}$copy(h,f,o,i){const r=this.l(h);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(D.URI.revive(f),D.URI.revive(o),i))}$mkdir(h,f){return Promise.resolve(this.l(h).createDirectory(D.URI.revive(f)))}$watch(h,f,o,i){const r=this.l(h).watch(D.URI.revive(o),i);this.f.set(f,r)}$unwatch(h,f){const o=this.f.get(f);o&&(o.dispose(),this.f.delete(f))}$open(h,f,o){const i=this.l(h);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),o))}$close(h,f){const o=this.l(h);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(f))}$read(h,f,o,i){const r=this.l(h);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=y.$ie.alloc(i);return Promise.resolve(r.read(f,o,n.buffer,0,i)).then(c=>n.slice(0,c))}$write(h,f,o,i){const r=this.l(h);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(f,o,i.buffer,0,i.byteLength))}l(h){const f=this.c.get(h);if(!f){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return f}}e.$0gc=v}),define(ke[71],Se([1,0,6,32,7,22,5,20,58,3,11,23,17]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=e.$jgc=void 0;let S=v=class{constructor(f,o){this.b=new Map,this.c=new R.$bh,this.a=f.getProxy(D.$5K.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const c=i.b.get(r.scheme);return c?(await i.a.$ensureActivation(r.scheme),n=await c.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===O.FilePermission.Readonly?1:void 0}}catch(n){v.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return v.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return v.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return v.e(n)}},async writeFile(r,n){try{const c=i.b.get(r.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(c.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,I.$ie.wrap(n))}catch(c){return v.e(c)}},async delete(r,n){try{const c=i.b.get(r.scheme);return c&&!c.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await c.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(c){return v.e(c)}},async rename(r,n,c){try{return await i.a.$rename(r,n,{overwrite:!1,...c})}catch(t){return v.e(t)}},async copy(r,n,c){try{return await i.a.$copy(r,n,{overwrite:!1,...c})}catch(t){return v.e(t)}},isWritableFileSystem(r){const n=o.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(f,o,i){const r=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await f.stat(i)).type&O.FileType.Directory))throw g.$iM.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(O.$Fk(n)!==O.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(i)),i=o.dirname(i)}for(let n=r.length-1;n>=0;n--){i=o.joinPath(i,r[n]);try{await f.createDirectory(i)}catch(c){if(O.$Fk(c)!==O.FileSystemProviderErrorCode.FileExists)throw c}}}static e(f){if(f instanceof g.$iM)throw f;if(f instanceof O.$Bk)switch(f.code){case O.FileSystemProviderErrorCode.FileExists:throw g.$iM.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw g.$iM.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw g.$iM.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw g.$iM.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw g.$iM.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw g.$iM.Unavailable(f.message);default:throw new g.$iM(f.message,f.name)}if(!(f instanceof Error))throw new g.$iM(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$iM.Unavailable(f.message);switch(f.name){case O.FileSystemProviderErrorCode.FileExists:throw g.$iM.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw g.$iM.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw g.$iM.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw g.$iM.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw g.$iM.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw g.$iM.Unavailable(f.message);default:throw new g.$iM(f.message,f.name)}}addFileSystemProvider(f,o,i){return this.b.set(f,{impl:o,extUri:i?.isCaseSensitive?C.$wg:C.$yg,isReadonly:!!i?.isReadonly}),(0,y.$Rc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$wg}};e.$jgc=S,e.$jgc=S=v=Ge([We(0,b.$9M),We(1,$.$Wfc)],S),e.$kgc=(0,L.$5h)("IExtHostConsumerFileSystem")}),define(ke[321],Se([1,0,4,34,2,6,15,7,43]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,S,h,f,o,i){this.a=Math.random(),this.b=new D.$Ud,this.c=new D.$Ud,this.d=new D.$Ud,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,O.$Lj)(o),n=typeof o=="string",c=i?.correlate,t=f(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(c&&typeof u.session>"u")){if(!i?.ignoreCreateEvents)for(const s of u.created){const l=g.URI.revive(s);r(l.fsPath)&&(!n||S.getWorkspaceFolder(l))&&this.b.fire(l)}if(!i?.ignoreChangeEvents)for(const s of u.changed){const l=g.URI.revive(s);r(l.fsPath)&&(!n||S.getWorkspaceFolder(l))&&this.c.fire(l)}if(!i?.ignoreDeleteEvents)for(const s of u.deleted){const l=g.URI.revive(s);r(l.fsPath)&&(!n||S.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$7K.from(this.i(v,h,o,i,i?.correlate),this.b,this.c,this.d,t)}i(v,S,h,f,o){const i=b.$7K.from();if(typeof h=="string")return i;const r=v.getProxy(I.$5K.MainThreadFileSystemEventService);let n=!1;return(h.pattern.includes(O.$Hj)||h.pattern.includes(O.$Ij))&&(n=!0),r.$watch(S.identifier.value,this.a,h.baseUri,{recursive:n,excludes:f?.excludes??[]},!!o),b.$7K.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(v){this.a=v,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,S,h){this.j=v,this.k=S,this.l=h,this.a=new D.$Ud,this.b=new D.$Ud,this.c=new D.$Ud,this.d=new D.$Ud,this.g=new D.$Wd,this.h=new D.$Wd,this.i=new D.$Wd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,S,h,f){return new y(this.j,v,S,this.a.event,L.GlobPattern.from(h),f)}$onFileEvent(v){this.a.fire(new R(v))}$onDidRunFileOperation(v,S){switch(v){case 2:this.b.fire(Object.freeze({files:S.map(h=>({oldUri:g.URI.revive(h.source),newUri:g.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(h=>g.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(h=>g.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,S){return(h,f,o)=>{const i=function(n){h.call(f,n)};return i.extension=v,S.event(i,void 0,o)}}async $onWillRunFileOperation(v,S,h,f){switch(v){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:g.URI.revive(o.source),newUri:g.URI.revive(o.target)}))},h,f);case 1:return await this.n(this.i,{files:S.map(o=>g.URI.revive(o.target))},h,f);case 0:case 3:return await this.n(this.h,{files:S.map(o=>g.URI.revive(o.target))},h,f)}}async n(v,S,h,f){const o=new Set,i=[];if(await v.fireAsync(S,f,async(n,c)=>{const t=Date.now(),u=await Promise.resolve(n);u instanceof b.$eL&&(i.push([c.extension,u]),o.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",c.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:c}=L.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(c)}return{edit:r,extensionNames:Array.from(o)}}}e.$$gc=C}),define(ke[322],Se([1,0,3,2,6,15,7,35,11]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class y{static{this.a=0}constructor(v,S){this.extension=v,this.provider=S,this.handle=y.a++}}class R{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,S,h,f){this.f=h,this.g=f,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$5K.MainThreadInlineChat),S.registerApiCommand(new b.$wN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$uN("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?I.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?I.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?I.Position.from(o.position):void 0}})],b.$vN.Void))}registerProvider(v,S,h){const f=new y(v,S);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,h?.label??v.displayName??v.name,v.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",h?.supportReportIssue??!1),(0,D.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(v,S,h,f){const o=this.b.get(v);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(O.URI.revive(S)),r=I.Selection.to(h),n=await o.provider.prepareInteractiveEditorSession({document:i,selection:r},f);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new R(n)),{id:c,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(n.wholeRange),message:n.message}}async $provideResponse(v,S,h,f){const o=this.b.get(v);if(!o)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:h.prompt,selection:I.Selection.to(h.selection),wholeRange:I.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,withIntentDetection:h.withIntentDetection};let n=!1;const c={report:async P=>{if(!h.live&&P.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||f.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:P.message,edits:P.edits?.map(I.TextEdit.from),editsShouldBeInstant:P.editsShouldBeInstant,slashCommand:P.slashCommand?.command,markdownFragment:L.$vL.isMarkdownString(P.content)?P.content.value:P.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,r,c,f));let u;try{u=await(0,$.$Tg)(t,f)}finally{n=!0}if(!u)return;const s=i.responses.push(u)-1,l={wholeRange:I.Range.from(u.wholeRange),placeholder:u.placeholder};if(!C.h(u))return{...l,id:s,type:"editorEdit",message:I.MarkdownString.from(u.contents),edits:[]};const{edits:a,contents:d}=u,k=d!==void 0?I.MarkdownString.from(d):void 0;return a instanceof L.$eL?{...l,id:s,type:"bulkEdit",edits:I.WorkspaceEdit.from(a),message:k}:{...l,id:s,type:"editorEdit",edits:a.map(I.TextEdit.from),message:k}}async $provideFollowups(v,S,h,f){const o=this.b.get(v),i=this.d.get(S),r=i?.responses[h];if(o&&r&&o.provider.provideFollowups){const n=Promise.resolve(o.provider.provideFollowups(i.session,r,f));return(await(0,$.$Tg)(n,f))?.map(I.ChatReplyFollowup.from)}}$handleFeedback(v,S,h,f){const o=this.b.get(v),i=this.d.get(S),r=i?.responses[h];if(o&&r){const n=I.InteractiveEditorResponseFeedbackKind.to(f);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(v,S){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$_gc=C}),define(ke[323],Se([1,0,2,35]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;class g{constructor(L,b,$,y,R){this.a=b,this.b=$,this.c=y;const C=new O.$wN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$uN("showOptions","Show Options",m=>!0,m=>m),new O.$uN("resource","Interactive resource Uri",m=>!0,m=>m),new O.$uN("controllerId","Notebook controller Id",m=>!0,m=>m),new O.$uN("title","Interactive editor title",m=>!0,m=>m)],new O.$vN("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(L,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$mhc=g}),define(ke[324],Se([1,0,6,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class g{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(D.$5K.MainThreadIssueReporter)}async $getIssueReporterUri(L,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(L);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(L,b){const $=L.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new O.$7K(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(L,b){const $=L.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new O.$7K(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$nhc=g}),define(ke[325],Se([1,0,3,6]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class g{constructor(L){this.b=0,this.a=L.getProxy(O.$5K.MainThreadLabelService)}$registerResourceLabelFormatter(L){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,L),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$ohc=g}),define(ke[326],Se([1,0,2,24,15,7,83,6,12,29,19,18,169,21,26,3,131,121,110,38,14,11,25,213]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class s{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentSymbols(z,Q){const ee=this.d.getDocument(z),V=await this.e.provideDocumentSymbols(ee,Q);if(!(0,R.$Kb)(V))return V[0]instanceof I.$nL?V.map(g.DocumentSymbol.from):s.f(V)}static f(z){z=z.slice(0).sort((V,ae)=>{let le=V.location.range.start.compareTo(ae.location.range.start);return le===0&&(le=ae.location.range.end.compareTo(V.location.range.end)),le});const Q=[],ee=[];for(const V of z){const ae={name:V.name||"!!MISSING: name!!",kind:g.SymbolKind.from(V.kind),tags:V.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:g.Range.from(V.location.range),selectionRange:g.Range.from(V.location.range),children:[]};for(;;){if(ee.length===0){ee.push(ae),Q.push(ae);break}const le=ee[ee.length-1];if(y.$Ts.containsRange(le.range,ae.range)&&!y.$Ts.equalsRange(le.range,ae.range)){le.children?.push(ae),ee.push(ae);break}ee.pop()}}return Q}}class l{constructor(z,Q,ee,V,ae,le){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=ae,this.l=le,this.d=new i.$Sfc("CodeLens"),this.e=new Map}async provideCodeLenses(z,Q){const ee=this.f.getDocument(z),V=await this.h.provideCodeLenses(ee,Q);if(!V||Q.isCancellationRequested)return;const ae=this.d.add(V),le=new h.$Sc;this.e.set(ae,le);const Re={cacheId:ae,lenses:[]};for(let je=0;je<V.length;je++)Re.lenses.push({cacheId:[ae,je],range:g.Range.from(V[je].range),command:this.g.toInternal(V[je].command,le)});return Re}async resolveCodeLens(z,Q){const ee=z.cacheId&&this.d.get(...z.cacheId);if(!ee)return;let V;if(typeof this.h.resolveCodeLens!="function"||ee.isResolved?V=ee:V=await this.h.resolveCodeLens(ee,Q),V||(V=ee),Q.isCancellationRequested)return;const ae=z.cacheId&&this.e.get(z.cacheId[0]);if(ae){if(!V.command){const le=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,le),this.l.error(le);return}return z.command=this.g.toInternal(V.command,ae),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function a(De){return Array.isArray(De)?De.map(g.DefinitionLink.from):De?[g.DefinitionLink.from(De)]:[]}class d{constructor(z,Q){this.d=z,this.e=Q}async provideDefinition(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideDefinition(V,ae,ee);return a(le)}}class k{constructor(z,Q){this.d=z,this.e=Q}async provideDeclaration(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideDeclaration(V,ae,ee);return a(le)}}class P{constructor(z,Q){this.d=z,this.e=Q}async provideImplementation(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideImplementation(V,ae,ee);return a(le)}}class p{constructor(z,Q){this.d=z,this.e=Q}async provideTypeDefinition(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideTypeDefinition(V,ae,ee);return a(le)}}class w{constructor(z,Q){this.d=z,this.e=Q}async provideHover(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideHover(V,ae,ee);if(!(!le||(0,R.$Kb)(le.contents)))return le.range||(le.range=V.getWordRangeAtPosition(ae)),le.range||(le.range=new I.$9K(ae,ae)),g.Hover.from(le)}}class E{constructor(z,Q){this.d=z,this.e=Q}async provideEvaluatableExpression(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideEvaluatableExpression(V,ae,ee);if(le)return g.EvaluatableExpression.from(le)}}class A{constructor(z,Q){this.d=z,this.e=Q}async provideInlineValues(z,Q,ee,V){const ae=this.d.getDocument(z),le=await this.e.provideInlineValues(ae,g.Range.to(Q),g.InlineValueContext.to(ee),V);if(Array.isArray(le))return le.map(Re=>g.InlineValue.from(Re))}}class T{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentHighlights(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideDocumentHighlights(V,ae,ee);if(Array.isArray(le))return le.map(g.DocumentHighlight.from)}}class U{constructor(z,Q){this.d=z,this.e=Q}async provideMultiDocumentHighlights(z,Q,ee,V){const ae=this.d.getDocument(z),le=ee.map(He=>this.d.getDocument(He)),Re=g.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(ae,Re,le,V);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class N{constructor(z,Q){this.d=z,this.e=Q}async provideLinkedEditingRanges(z,Q,ee){const V=this.d.getDocument(z),ae=g.Position.to(Q),le=await this.e.provideLinkedEditingRanges(V,ae,ee);if(le&&Array.isArray(le.ranges))return{ranges:(0,R.$Hb)(le.ranges.map(g.Range.from)),wordPattern:le.wordPattern}}}class j{constructor(z,Q){this.d=z,this.e=Q}async provideReferences(z,Q,ee,V){const ae=this.d.getDocument(z),le=g.Position.to(Q),Re=await this.e.provideReferences(ae,le,ee,V);if(Array.isArray(Re))return Re.map(g.location.from)}}class F{static{this.d=1e3}constructor(z,Q,ee,V,ae,le,Re){this.g=z,this.h=Q,this.j=ee,this.k=V,this.l=ae,this.m=le,this.n=Re,this.e=new i.$Sfc("CodeAction"),this.f=new Map}async provideCodeActions(z,Q,ee,V){const ae=this.g.getDocument(z),le=m.$Vs.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),Re=[];for(const ot of this.j.getDiagnostics(z))if(le.intersection(ot.range)&&Re.push(ot)>F.d)break;const je={diagnostics:Re,only:ee.only?new I.$pL(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},He=await this.k.provideCodeActions(ae,le,je,V);if(!(0,R.$Lb)(He)||V.isCancellationRequested)return;const Je=this.e.add(He),_e=new h.$Sc;this.f.set(Je,_e);const ct=[];for(let ot=0;ot<He.length;ot++){const rt=He[ot];rt&&(F.o(rt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)})):(je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ct.push({cacheId:[Je,ot],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(g.Diagnostic.from),edit:rt.edit&&g.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$AF)(this.m,"codeActionAI")?rt.isAI:!1,disabled:rt.disabled?.reason})))}return{cacheId:Je,actions:ct}}async resolveCodeAction(z,Q){const[ee,V]=z,ae=this.e.get(ee,V);if(!ae||F.o(ae))return{};if(!this.k.resolveCodeAction)return{};const le=await this.k.resolveCodeAction(ae,Q)??ae;let Re;le.edit&&(Re=g.WorkspaceEdit.from(le.edit,void 0));let je;if(le.command){const He=this.f.get(ee);He&&(je=this.h.toInternal(le.command,He))}return{edit:Re,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class M{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,V,ae){this.d=z,this.e=Q,this.f=ee,this.g=V,this.h=ae}async prepareDocumentPaste(z,Q,ee,V){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(z),le=Q.map(He=>g.Range.to(He)),Re=g.DataTransfer.toDataTransfer(ee,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(ae,le,Re,V),V.isCancellationRequested)return;const je=Array.from(Re).filter(([,He])=>!(He instanceof I.$VL));return g.DataTransfer.from(je)}async providePasteEdits(z,Q,ee,V,ae){if(!this.f.provideDocumentPasteEdits)return;const le=this.e.getDocument(Q),Re=ee.map(Je=>g.Range.to(Je)),je=g.DataTransfer.toDataTransfer(V,async Je=>(await this.d.$resolvePasteFileData(this.g,z,Je)).buffer),He=await this.f.provideDocumentPasteEdits(le,Re,je,ae);if(He)return{label:He.label??(0,u.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:M.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class B{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentFormattingEdits(z,Q,ee){const V=this.d.getDocument(z),ae=await this.e.provideDocumentFormattingEdits(V,Q,ee);if(Array.isArray(ae))return ae.map(g.TextEdit.from)}}class X{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeFormattingEdits(z,Q,ee,V){const ae=this.d.getDocument(z),le=g.Range.to(Q),Re=await this.e.provideDocumentRangeFormattingEdits(ae,le,ee,V);if(Array.isArray(Re))return Re.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,Q,ee,V){(0,C.$Rf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(z),le=Q.map(g.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ae,le,ee,V);if(Array.isArray(Re))return Re.map(g.TextEdit.from)}}class ue{constructor(z,Q){this.d=z,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,Q,ee,V,ae){const le=this.d.getDocument(z),Re=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(le,Re,ee,V,ae);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class Z{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$Sfc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,Q){const ee=await this.e.provideWorkspaceSymbols(z,Q);if(!(0,R.$Lb)(ee))return{symbols:[]};const V=this.d.add(ee),ae={cacheId:V,symbols:[]};for(let le=0;le<ee.length;le++){const Re=ee[le];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ae.symbols.push({...g.WorkspaceSymbol.from(Re),cacheId:[V,le]})}return ae}async resolveWorkspaceSymbol(z,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const ee=this.d.get(...z.cacheId);if(ee){const V=await this.e.resolveWorkspaceSymbol(ee,Q);return V&&(0,O.$xn)(z,g.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class J{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideRenameEdits(z,Q,ee,V){const ae=this.d.getDocument(z),le=g.Position.to(Q);try{const Re=await this.e.provideRenameEdits(ae,le,ee,V);return Re?g.WorkspaceEdit.from(Re):void 0}catch(Re){const je=J.g(Re);return je?{rejectReason:je,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(z,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(z),ae=g.Position.to(Q);try{const le=await this.e.prepareRename(V,ae,ee);let Re,je;if(I.$9K.isRange(le)?(Re=le,je=V.getText(le)):(0,C.$Jf)(le)&&(Re=le.range,je=le.placeholder),!Re||!je)return;if(Re.start.line>ae.line||Re.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Re),text:je}}catch(le){const Re=J.g(le);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(le)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class Y{constructor(z,Q){this.resultId=z,this.tokens=Q}}class he{constructor(z,Q){this.f=z,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,Q,ee){const V=this.f.getDocument(z),ae=Q!==0?this.d.get(Q):null;let le=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ae.resultId,ee):await this.g.provideDocumentSemanticTokens(V,ee);return ae&&this.d.delete(Q),le?(le=he.h(le),this.o(he.n(ae,le),le)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return he.j(z)?he.k(z)?z:new I.$mM(new Uint32Array(z.data),z.resultId):he.l(z)?he.m(z)?z:new I.$oM(z.edits.map(Q=>new I.$nM(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const Q of z.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(z,Q){if(!he.j(Q)||!z||!z.tokens)return Q;const ee=z.tokens,V=ee.length,ae=Q.data,le=ae.length;let Re=0;const je=Math.min(V,le);for(;Re<je&&ee[Re]===ae[Re];)Re++;if(Re===V&&Re===le)return new I.$oM([],Q.resultId);let He=0;const Je=je-Re;for(;He<Je&&ee[V-He-1]===ae[le-He-1];)He++;return new I.$oM([{start:Re,deleteCount:V-Re-He,data:ae.subarray(Re,le-He)}],Q.resultId)}o(z,Q){if(he.j(z)){const ee=this.e++;return this.d.set(ee,new Y(z.resultId,z.data)),(0,f.$q$)({id:ee,type:"full",data:z.data})}if(he.l(z)){const ee=this.e++;return he.j(Q)?this.d.set(ee,new Y(Q.resultId,Q.data)):this.d.set(ee,new Y(z.resultId)),(0,f.$q$)({id:ee,type:"delta",deltas:(z.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class _{constructor(z,Q){this.d=z,this.e=Q}async provideDocumentRangeSemanticTokens(z,Q,ee){const V=this.d.getDocument(z),ae=await this.e.provideDocumentRangeSemanticTokens(V,g.Range.to(Q),ee);return ae?this.f(ae):null}f(z){return(0,f.$q$)({id:0,type:"full",data:z.data})}}class we{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,Q,ee,V,ae){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=ae,this.d=new i.$Sfc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,Q,ee,V){const ae=this.f.getDocument(z),le=g.Position.to(Q),Re=ae.getWordRangeAtPosition(le)||new I.$9K(le,le),je=Re.with({end:le}),He=new r.$Qd,Je=await this.h.provideCompletionItems(ae,le,V,g.CompletionContext.to(ee));if(!Je||V.isCancellationRequested)return;const _e=Array.isArray(Je)?new I.$CL(Je):Je,ct=we.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),ot=new h.$Sc;this.e.set(ct,ot);const rt=[],Ae={x:ct,b:rt,a:{replace:g.Range.from(Re),insert:g.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let Ue=0;Ue<_e.items.length;Ue++){const Le=_e.items[Ue],Ye=this.l(Le,[ct,Ue],je,Re);rt.push(Ye)}return Ae}async resolveCompletionItem(z,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=this.l(ee,z),ae=await this.h.resolveCompletionItem(ee,Q);if(!ae)return;const le=this.l(ae,z);return(V.h!==le.h||V.i!==le.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V.n!==le.n||V.o!==le.o||!(0,O.$yn)(V.p,le.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,d:le.d,c:le.c,l:le.l,h:le.h,i:le.i,n:le.n,o:le.o,p:le.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q,ee,V){const ae=this.e.get(Q[0]);if(!ae)throw Error("DisposableStore is missing...");const le=this.g.toInternal(z.command,ae),Re={x:Q,a:z.label,b:z.kind!==void 0?g.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(g.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:g.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(g.TextEdit.from),n:le?.$ident,o:le?.id,p:le?.$ident?void 0:le?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=z.textEdit.newText):typeof z.insertText=="string"?Re.h=z.insertText:z.insertText instanceof I.$fL&&(Re.h=z.insertText.value,Re.i|=4);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),I.$9K.isRange(je)?Re.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!V?.isEqual(je.replacing))&&(Re.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Re}}class oe{async provideInlineCompletions(z,Q,ee,V){}disposeCompletions(z){}handleDidShowCompletionItem(z,Q,ee){}handlePartialAccept(z,Q,ee){}}class K extends oe{constructor(z,Q,ee,V){super(),this.f=z,this.g=Q,this.h=ee,this.j=V,this.d=new W,this.e=(0,t.$AF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$AF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,Q,ee,V){const ae=this.g.getDocument(z),le=g.Position.to(Q),Re=await this.h.provideInlineCompletionItems(ae,le,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},V);if(!Re||V.isCancellationRequested)return;const je=Array.isArray(Re)?Re:Re.items,He=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Je=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((ot,rt)=>{let Ae;ot.command&&(_e||(_e=new h.$Sc),Ae=this.j.toInternal(ot.command,_e));const Ue=ot.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:ot.filterText,range:ot.range?g.Range.from(ot.range):void 0,command:Ae,idx:rt,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:He.map(ot=>(_e||(_e=new h.$Sc),this.j.toInternal(ot,_e))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,Q,ee){const V=this.d.get(z)?.items[Q];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,ee)}handlePartialAccept(z,Q,ee){const V=this.d.get(z)?.items[Q];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,ee)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const Q=this.e++;return this.d.set(Q,z),Q}disposeReferenceId(z){const Q=this.d.get(z);return this.d.delete(z),Q}get(z){return this.d.get(z)}}class re{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$Sfc("SignatureHelp")}async provideSignatureHelp(z,Q,ee,V){const ae=this.e.getDocument(z),le=g.Position.to(Q),Re=this.g(ee),je=await this.f.provideSignatureHelp(ae,le,V,Re);if(je){const He=this.d.add([je]);return{...g.SignatureHelp.from(je),id:He}}}g(z){let Q;if(z.activeSignatureHelp){const ee=g.SignatureHelp.to(z.activeSignatureHelp),V=this.d.get(z.activeSignatureHelp.id,0);V?(Q=V,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...z,activeSignatureHelp:Q}}releaseSignatureHelp(z){this.d.delete(z)}}class ye{constructor(z,Q,ee,V,ae){this.f=z,this.g=Q,this.h=ee,this.j=V,this.k=ae,this.d=new i.$Sfc("InlayHints"),this.e=new Map}async provideInlayHints(z,Q,ee){const V=this.f.getDocument(z),ae=g.Range.to(Q),le=await this.h.provideInlayHints(V,ae,ee);if(!Array.isArray(le)||le.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Re=this.d.add(le);this.e.set(Re,new h.$Sc);const je={hints:[],cacheId:Re};for(let He=0;He<le.length;He++)this.l(le[He],ae)&&je.hints.push(this.m(le[He],[Re,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(z,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=await this.h.resolveInlayHint(ee,Q);if(V&&this.l(V))return this.m(V,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,Q){return z.label.length===0||Array.isArray(z.label)&&z.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(Q&&!Q.contains(z.position))}m(z,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const V={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(z.tooltip),position:g.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(g.TextEdit.from),kind:z.kind&&g.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")V.label=z.label;else{const ae=[];V.label=ae;for(const le of z.label){if(!le.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:le.value,tooltip:g.MarkdownString.fromStrict(le.tooltip)};I.$gL.isLocation(le.location)&&(Re.location=g.location.from(le.location)),le.command&&(Re.command=this.g.toInternal(le.command,ee)),ae.push(Re)}}return V}}class de{constructor(z,Q){this.e=z,this.f=Q,this.d=new i.$Sfc("DocumentLink")}async provideLinks(z,Q){const ee=this.e.getDocument(z),V=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(V)||V.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(de.g).map(g.DocumentLink.from)};{const ae=this.d.add(V),le={links:[],cacheId:ae};for(let Re=0;Re<V.length;Re++){if(!de.g(V[Re]))continue;const je=g.DocumentLink.from(V[Re]);je.cacheId=[ae,Re],le.links.push(je)}return le}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...z);if(!ee)return;const V=await this.f.resolveDocumentLink(ee,Q);if(!(!V||!de.g(V)))return g.DocumentLink.from(V)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,Q){this.d=z,this.e=Q}async provideColors(z,Q){const ee=this.d.getDocument(z),V=await this.e.provideDocumentColors(ee,Q);return Array.isArray(V)?V.map(le=>({color:g.Color.from(le.color),range:g.Range.from(le.range)})):[]}async provideColorPresentations(z,Q,ee){const V=this.d.getDocument(z),ae=g.Range.to(Q.range),le=g.Color.to(Q.color),Re=await this.e.provideColorPresentations(le,{document:V,range:ae},ee);if(Array.isArray(Re))return Re.map(g.ColorPresentation.from)}}class x{constructor(z,Q){this.d=z,this.e=Q}async provideFoldingRanges(z,Q,ee){const V=this.d.getDocument(z),ae=await this.e.provideFoldingRanges(V,Q,ee);if(Array.isArray(ae))return ae.map(g.FoldingRange.from)}}class te{constructor(z,Q,ee){this.d=z,this.e=Q,this.f=ee}async provideSelectionRanges(z,Q,ee){const V=this.d.getDocument(z),ae=Q.map(g.Position.to),le=await this.e.provideSelectionRanges(V,ae,ee);if(!(0,R.$Lb)(le))return[];if(le.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let je=0;je<ae.length;je++){const He=[];Re.push(He);let Je=ae[je],_e=le[je];for(;;){if(!_e.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(He.push(g.SelectionRange.from(_e)),!_e.parent)break;Je=_e.range,_e=_e.parent}}return Re}}class G{constructor(z,Q){this.f=z,this.g=Q,this.d=new o.$bN(""),this.e=new Map}async prepareSession(z,Q,ee){const V=this.f.getDocument(z),ae=g.Position.to(Q),le=await this.g.prepareCallHierarchy(V,ae,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideCallsTo(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(V,ee);if(ae)return ae.map(le=>({from:this.h(z,le.from),fromRanges:le.fromRanges.map(Re=>g.Range.from(Re))}))}async provideCallsFrom(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(V,ee);if(ae)return ae.map(le=>({to:this.h(z,le.to),fromRanges:le.fromRanges.map(Re=>g.Range.from(Re))}))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),V=g.CallHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(z,Q){return this.e.get(z)?.get(Q)}}class ie{constructor(z,Q){this.f=z,this.g=Q,this.d=new o.$bN(""),this.e=new Map}async prepareSession(z,Q,ee){const V=this.f.getDocument(z),ae=g.Position.to(Q),le=await this.g.prepareTypeHierarchy(V,ae,ee);if(!le)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(le)?le.map(je=>this.h(Re,je)):[this.h(Re,le)]}async provideSupertypes(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(V,ee);if(ae)return ae.map(le=>this.h(z,le))}async provideSubtypes(z,Q,ee){const V=this.j(z,Q);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(V,ee);if(ae)return ae.map(le=>this.h(z,le))}releaseSession(z){this.e.delete(z)}h(z,Q){const ee=this.e.get(z),V=g.TypeHierarchyItem.from(Q,z,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(z,Q){return this.e.get(z)?.get(Q)}}class fe{static toInternalProviderId(z,Q){return z+"."+Q}constructor(z,Q,ee,V,ae){this.d=z,this.e=Q,this.f=ee,this.g=V,this.h=ae}async provideDocumentOnDropEdits(z,Q,ee,V,ae){const le=this.e.getDocument(Q),Re=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(V,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Je)).buffer),He=await this.f.provideDocumentDropEdits(le,Re,je,ae);if(He)return{label:He.label??(0,u.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:fe.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?g.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class ve{constructor(z,Q){this.d=z,this.e=Q}async provideMappedEdits(z,Q,ee,V){const ae=D.URI.revive(z),le=this.d.getDocument(ae),Re=ee.documents.map(Je=>Je.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(ct=>g.Range.to(ct))}))),je={documents:Re,selections:Re[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(le,Q,je,V);return He?g.WorkspaceEdit.from(He):null}}class Pe{constructor(z,Q){this.adapter=z,this.extension=Q}}class be{static{this.d=0}constructor(z,Q,ee,V,ae,le,Re,je){this.g=Q,this.h=ee,this.j=V,this.k=ae,this.l=le,this.m=Re,this.n=je,this.f=new Map,this.e=z.getProxy(b.$5K.MainThreadLanguageFeatures)}o(z,Q){return g.DocumentSelector.from(z,this.g,Q)}p(z){return new I.$7K(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return be.d++}async s(z,Q,ee,V,ae,le=!1){const Re=this.f.get(z);if(!Re||!(Re.adapter instanceof Q))return V;const je=Date.now();le||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const He=ee(Re.adapter,Re.extension);return Promise.resolve(He).catch(Je=>{(0,n.$4)(Je)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(Re.extension.identifier,Je))}).finally(()=>{le||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),v.CancellationToken.isCancellationToken(ae)?(0,c.$Ug)(He,ae):He}t(z,Q){const ee=this.q();return this.f.set(ee,new Pe(z,Q)),ee}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Q,ee,V){const ae=this.t(new s(this.h,ee),z),le=V&&V.label||be.u(z);return this.e.$registerDocumentSymbolProvider(ae,this.o(Q,z),le),this.p(ae)}$provideDocumentSymbols(z,Q,ee){return this.s(z,s,V=>V.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(z,Q,ee){const V=this.q(),ae=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Pe(new l(this.h,this.j.converter,ee,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(V,this.o(Q,z),ae);let le=this.p(V);if(ae!==void 0){const Re=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ae));le=I.$7K.from(le,Re)}return le}$provideCodeLenses(z,Q,ee){return this.s(z,l,V=>V.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(z,Q,ee){return this.s(z,l,V=>V.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(z,Q){this.s(z,l,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(z,Q,ee){const V=this.t(new d(this.h,ee),z);return this.e.$registerDefinitionSupport(V,this.o(Q,z)),this.p(V)}$provideDefinition(z,Q,ee,V){return this.s(z,d,ae=>ae.provideDefinition(D.URI.revive(Q),ee,V),[],V)}registerDeclarationProvider(z,Q,ee){const V=this.t(new k(this.h,ee),z);return this.e.$registerDeclarationSupport(V,this.o(Q,z)),this.p(V)}$provideDeclaration(z,Q,ee,V){return this.s(z,k,ae=>ae.provideDeclaration(D.URI.revive(Q),ee,V),[],V)}registerImplementationProvider(z,Q,ee){const V=this.t(new P(this.h,ee),z);return this.e.$registerImplementationSupport(V,this.o(Q,z)),this.p(V)}$provideImplementation(z,Q,ee,V){return this.s(z,P,ae=>ae.provideImplementation(D.URI.revive(Q),ee,V),[],V)}registerTypeDefinitionProvider(z,Q,ee){const V=this.t(new p(this.h,ee),z);return this.e.$registerTypeDefinitionSupport(V,this.o(Q,z)),this.p(V)}$provideTypeDefinition(z,Q,ee,V){return this.s(z,p,ae=>ae.provideTypeDefinition(D.URI.revive(Q),ee,V),[],V)}registerHoverProvider(z,Q,ee,V){const ae=this.t(new w(this.h,ee),z);return this.e.$registerHoverProvider(ae,this.o(Q,z)),this.p(ae)}$provideHover(z,Q,ee,V){return this.s(z,w,ae=>ae.provideHover(D.URI.revive(Q),ee,V),void 0,V)}registerEvaluatableExpressionProvider(z,Q,ee,V){const ae=this.t(new E(this.h,ee),z);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(Q,z)),this.p(ae)}$provideEvaluatableExpression(z,Q,ee,V){return this.s(z,E,ae=>ae.provideEvaluatableExpression(D.URI.revive(Q),ee,V),void 0,V)}registerInlineValuesProvider(z,Q,ee,V){const ae=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,le=this.t(new A(this.h,ee),z);this.e.$registerInlineValuesProvider(le,this.o(Q,z),ae);let Re=this.p(le);if(ae!==void 0){const je=ee.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ae));Re=I.$7K.from(Re,je)}return Re}$provideInlineValues(z,Q,ee,V,ae){return this.s(z,A,le=>le.provideInlineValues(D.URI.revive(Q),ee,V,ae),void 0,ae)}registerDocumentHighlightProvider(z,Q,ee){const V=this.t(new T(this.h,ee),z);return this.e.$registerDocumentHighlightProvider(V,this.o(Q,z)),this.p(V)}registerMultiDocumentHighlightProvider(z,Q,ee){const V=this.t(new U(this.h,ee),z);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(Q,z)),this.p(V)}$provideDocumentHighlights(z,Q,ee,V){return this.s(z,T,ae=>ae.provideDocumentHighlights(D.URI.revive(Q),ee,V),void 0,V)}$provideMultiDocumentHighlights(z,Q,ee,V,ae){return this.s(z,U,le=>le.provideMultiDocumentHighlights(D.URI.revive(Q),ee,V.map(Re=>D.URI.revive(Re)),ae),void 0,ae)}registerLinkedEditingRangeProvider(z,Q,ee){const V=this.t(new N(this.h,ee),z);return this.e.$registerLinkedEditingRangeProvider(V,this.o(Q,z)),this.p(V)}$provideLinkedEditingRanges(z,Q,ee,V){return this.s(z,N,async ae=>{const le=await ae.provideLinkedEditingRanges(D.URI.revive(Q),ee,V);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?be.w(le.wordPattern):void 0}},void 0,V)}registerReferenceProvider(z,Q,ee){const V=this.t(new j(this.h,ee),z);return this.e.$registerReferenceSupport(V,this.o(Q,z)),this.p(V)}$provideReferences(z,Q,ee,V,ae){return this.s(z,j,le=>le.provideReferences(D.URI.revive(Q),ee,V,ae),void 0,ae)}registerCodeActionProvider(z,Q,ee,V){const ae=new h.$Sc,le=this.t(new F(this.h,this.j.converter,this.k,ee,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(le,this.o(Q,z),{providedKinds:V?.providedCodeActionKinds?.map(Re=>Re.value),documentation:V?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ae)}))},be.u(z),!!ee.resolveCodeAction),ae.add(this.p(le)),ae}$provideCodeActions(z,Q,ee,V,ae){return this.s(z,F,le=>le.provideCodeActions(D.URI.revive(Q),ee,V,ae),void 0,ae)}$resolveCodeAction(z,Q,ee){return this.s(z,F,V=>V.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(z,Q){this.s(z,F,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(z,Q,ee){const V=this.t(new B(this.h,ee),z);return this.e.$registerDocumentFormattingSupport(V,this.o(Q,z),z.identifier,z.displayName||z.name),this.p(V)}$provideDocumentFormattingEdits(z,Q,ee,V){return this.s(z,B,ae=>ae.provideDocumentFormattingEdits(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentRangeFormattingEditProvider(z,Q,ee){const V=typeof ee.provideDocumentRangesFormattingEdits=="function",ae=this.t(new X(this.h,ee),z);return this.e.$registerRangeFormattingSupport(ae,this.o(Q,z),z.identifier,z.displayName||z.name,V),this.p(ae)}$provideDocumentRangeFormattingEdits(z,Q,ee,V,ae){return this.s(z,X,le=>le.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,V,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(z,Q,ee,V,ae){return this.s(z,X,le=>le.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,V,ae),void 0,ae)}registerOnTypeFormattingEditProvider(z,Q,ee,V){const ae=this.t(new ue(this.h,ee),z);return this.e.$registerOnTypeFormattingSupport(ae,this.o(Q,z),V,z.identifier),this.p(ae)}$provideOnTypeFormattingEdits(z,Q,ee,V,ae,le){return this.s(z,ue,Re=>Re.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,V,ae,le),void 0,le)}registerWorkspaceSymbolProvider(z,Q){const ee=this.t(new Z(Q,this.l),z);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(z,Q,ee){return this.s(z,Z,V=>V.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(z,Q,ee){return this.s(z,Z,V=>V.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(z,Q){this.s(z,Z,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(z,Q,ee){const V=this.t(new J(this.h,ee,this.l),z);return this.e.$registerRenameSupport(V,this.o(Q,z),J.supportsResolving(ee)),this.p(V)}$provideRenameEdits(z,Q,ee,V,ae){return this.s(z,J,le=>le.provideRenameEdits(D.URI.revive(Q),ee,V,ae),void 0,ae)}$resolveRenameLocation(z,Q,ee,V){return this.s(z,J,ae=>ae.resolveRenameLocation(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentSemanticTokensProvider(z,Q,ee,V){const ae=this.t(new he(this.h,ee),z),le=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(Q,z),V,le);let Re=this.p(ae);if(le){const je=ee.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(le));Re=I.$7K.from(Re,je)}return Re}$provideDocumentSemanticTokens(z,Q,ee,V){return this.s(z,he,ae=>ae.provideDocumentSemanticTokens(D.URI.revive(Q),ee,V),null,V)}$releaseDocumentSemanticTokens(z,Q){this.s(z,he,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,Q,ee,V){const ae=this.t(new _(this.h,ee),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(Q,z),V),this.p(ae)}$provideDocumentRangeSemanticTokens(z,Q,ee,V){return this.s(z,_,ae=>ae.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,V),null,V)}registerCompletionItemProvider(z,Q,ee,V){const ae=this.t(new we(this.h,this.j.converter,ee,this.m,z),z);return this.e.$registerCompletionsProvider(ae,this.o(Q,z),V,we.supportsResolving(ee),z.identifier),this.p(ae)}$provideCompletionItems(z,Q,ee,V,ae){return this.s(z,we,le=>le.provideCompletionItems(D.URI.revive(Q),ee,V,ae),void 0,ae)}$resolveCompletionItem(z,Q,ee){return this.s(z,we,V=>V.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(z,Q){this.s(z,we,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(z,Q,ee,V){const ae=new K(z,this.h,ee,this.j.converter),le=this.t(ae,z);return this.e.$registerInlineCompletionsSupport(le,this.o(Q,z),ae.supportsHandleEvents,S.$km.toKey(z.identifier.value),V?.yieldTo?.map(Re=>S.$km.toKey(Re))||[]),this.p(le)}$provideInlineCompletions(z,Q,ee,V,ae){return this.s(z,oe,le=>le.provideInlineCompletions(D.URI.revive(Q),ee,V,ae),void 0,ae)}$handleInlineCompletionDidShow(z,Q,ee,V){this.s(z,oe,async ae=>{ae.handleDidShowCompletionItem(Q,ee,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,Q,ee,V){this.s(z,oe,async ae=>{ae.handlePartialAccept(Q,ee,V)},void 0,void 0)}$freeInlineCompletionsList(z,Q){this.s(z,oe,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(z,Q,ee,V){const ae=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,le=this.t(new re(this.h,ee),z);return this.e.$registerSignatureHelpProvider(le,this.o(Q,z),ae),this.p(le)}$provideSignatureHelp(z,Q,ee,V,ae){return this.s(z,re,le=>le.provideSignatureHelp(D.URI.revive(Q),ee,V,ae),void 0,ae)}$releaseSignatureHelp(z,Q){this.s(z,re,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(z,Q,ee){const V=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,ee,this.l,z),z);this.e.$registerInlayHintsProvider(ae,this.o(Q,z),typeof ee.resolveInlayHint=="function",V,be.u(z));let le=this.p(ae);if(V!==void 0){const Re=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(V));le=I.$7K.from(le,Re)}return le}$provideInlayHints(z,Q,ee,V){return this.s(z,ye,ae=>ae.provideInlayHints(D.URI.revive(Q),ee,V),void 0,V)}$resolveInlayHint(z,Q,ee){return this.s(z,ye,V=>V.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(z,Q){this.s(z,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(z,Q,ee){const V=this.t(new de(this.h,ee),z);return this.e.$registerDocumentLinkProvider(V,this.o(Q,z),typeof ee.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(z,Q,ee){return this.s(z,de,V=>V.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(z,Q,ee){return this.s(z,de,V=>V.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(z,Q){this.s(z,de,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(z,Q,ee){const V=this.t(new ge(this.h,ee),z);return this.e.$registerDocumentColorProvider(V,this.o(Q,z)),this.p(V)}$provideDocumentColors(z,Q,ee){return this.s(z,ge,V=>V.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(z,Q,ee,V){return this.s(z,ge,ae=>ae.provideColorPresentations(D.URI.revive(Q),ee,V),void 0,V)}registerFoldingRangeProvider(z,Q,ee){const V=this.q(),ae=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Pe(new x(this.h,ee),z)),this.e.$registerFoldingRangeProvider(V,this.o(Q,z),z.identifier,ae);let le=this.p(V);if(ae!==void 0){const Re=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));le=I.$7K.from(le,Re)}return le}$provideFoldingRanges(z,Q,ee,V){return this.s(z,x,ae=>ae.provideFoldingRanges(D.URI.revive(Q),ee,V),void 0,V)}registerSelectionRangeProvider(z,Q,ee){const V=this.t(new te(this.h,ee,this.l),z);return this.e.$registerSelectionRangeProvider(V,this.o(Q,z)),this.p(V)}$provideSelectionRanges(z,Q,ee,V){return this.s(z,te,ae=>ae.provideSelectionRanges(D.URI.revive(Q),ee,V),[],V)}registerCallHierarchyProvider(z,Q,ee){const V=this.t(new G(this.h,ee),z);return this.e.$registerCallHierarchyProvider(V,this.o(Q,z)),this.p(V)}$prepareCallHierarchy(z,Q,ee,V){return this.s(z,G,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideCallHierarchyIncomingCalls(z,Q,ee,V){return this.s(z,G,ae=>ae.provideCallsTo(Q,ee,V),void 0,V)}$provideCallHierarchyOutgoingCalls(z,Q,ee,V){return this.s(z,G,ae=>ae.provideCallsFrom(Q,ee,V),void 0,V)}$releaseCallHierarchy(z,Q){this.s(z,G,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(z,Q,ee){const V=this.t(new ie(this.h,ee),z);return this.e.$registerTypeHierarchyProvider(V,this.o(Q,z)),this.p(V)}$prepareTypeHierarchy(z,Q,ee,V){return this.s(z,ie,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideTypeHierarchySupertypes(z,Q,ee,V){return this.s(z,ie,ae=>ae.provideSupertypes(Q,ee,V),void 0,V)}$provideTypeHierarchySubtypes(z,Q,ee,V){return this.s(z,ie,ae=>ae.provideSubtypes(Q,ee,V),void 0,V)}$releaseTypeHierarchy(z,Q){this.s(z,ie,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(z,Q,ee,V){const ae=this.q();this.f.set(ae,new Pe(new fe(this.e,this.h,ee,ae,z),z));const le=(0,t.$AF)(z,"dropMetadata")&&V?fe.toInternalProviderId(z.identifier.value,V.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(Q,z),le,(0,t.$AF)(z,"dropMetadata")?V:void 0),this.p(ae)}$provideDocumentOnDropEdits(z,Q,ee,V,ae,le){return this.s(z,fe,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(Q,D.URI.revive(ee),V,ae,le)),void 0,void 0)}registerMappedEditsProvider(z,Q,ee){const V=this.t(new ve(this.h,ee),z);return this.e.$registerMappedEditsProvider(V,this.o(Q,z)),this.p(V)}$provideMappedEdits(z,Q,ee,V,ae){return this.s(z,ve,le=>Promise.resolve(le.provideMappedEdits(Q,ee,V,ae)),null,ae)}registerDocumentPasteEditProvider(z,Q,ee,V){const ae=this.q();this.f.set(ae,new Pe(new M(this.e,this.h,ee,ae,z),z));const le=M.toInternalProviderId(z.identifier.value,V.id);return this.e.$registerPasteEditProvider(ae,this.o(Q,z),le,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(z,Q,ee,V,ae){return this.s(z,M,le=>le.prepareDocumentPaste(D.URI.revive(Q),ee,V,ae),void 0,ae)}$providePasteEdits(z,Q,ee,V,ae,le){return this.s(z,M,Re=>Re.providePasteEdits(Q,D.URI.revive(ee),V,ae,le),void 0,le)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:be.w(z.decreaseIndentPattern),increaseIndentPattern:be.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:be.w(z.beforeText),afterText:z.afterText?be.w(z.afterText):void 0,previousLineText:z.previousLineText?be.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(be.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(Q=>I.SyntaxTokenType.toString(Q)):void 0}}static D(z){return z.map(be.C)}setLanguageConfiguration(z,Q,ee){const{wordPattern:V}=ee;if(V&&(0,$.$Xe)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(Q,V):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ae=this.q(),le={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?be.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?be.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?be.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?be.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,Q,le),this.p(ae)}$setWordDefinitions(z){for(const Q of z)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$3fc=be}),define(ke[327],Se([1,0,6,15,7,39,11,3,25]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class y{constructor(C,m,v,S){this.c=m,this.d=v,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$5K.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,m){const v=C.version,S=O.Position.from(m),h=await this.a.$tokensAtPosition(C.uri,S),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$9K(m.line,m.character,m.line,m.character)};if(!h)return f;const o={range:O.Range.to(h.range),type:O.TokenType.to(h.type)};return!o.range.contains(m)||v!==C.version?f:o}createLanguageStatusItem(C,m,v){const S=this.f++,h=this.a,f=this.g,o=`${C.identifier.value}/${m}`;if(f.has(o))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(o);const i={selector:v,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new b.$Sc,c=()=>{if(r?.dispose(),!f.has(o)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,L.$7g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),h.$removeLanguageStatus(S),f.delete(o)},get id(){return i.id},get name(){return i.name},set name(u){i.name=u,c()},get selector(){return i.selector},set selector(u){i.selector=u,c()},get text(){return i.text},set text(u){i.text=u,c()},set text2(u){(0,$.$BF)(C,"languageStatusText"),i.text=u,c()},get text2(){return(0,$.$BF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(u){i.detail=u,c()},get severity(){return i.severity},set severity(u){i.severity=u,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(u){i.accessibilityInformation=u,c()},get command(){return i.command},set command(u){i.command=u,c()},get busy(){return i.busy},set busy(u){i.busy=u,c()}};return c(),t}}e.$phc=y}),define(ke[115],Se([1,0,10,12,2,5,13,6,27,20]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;let R=class{constructor(m,v,S){this.f=S,this.d=new Map,this.a=v.getProxy(b.$5K.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,v){const{message:S,args:h,comment:f}=v;if(this.c)return(0,O.$Ke)(S,h??{});let o=S;f&&f.length>0&&(o+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$Ke)(i??S,h??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const S=await this.g(m);if(!S){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(S),f=JSON.parse(h);v=m.isBuiltin?f.contents?.bundle:f}catch(h){this.f.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${h.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:S})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(v)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ngc=R,e.$Ngc=R=Ge([We(0,$.$mN),We(1,y.$9M),We(2,L.$mj)],R),e.$Ogc=(0,I.$5h)("IExtHostLocalizationService")}),define(ke[150],Se([1,0,13,6,27,20,2,55]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;let $=class extends D.$xj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(v=>(0,b.$Bh)(v))),this.r=C.getProxy(O.$5K.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(L.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,v){return new y(this.r,C,m,v)}};e.$1hc=$,e.$1hc=$=Ge([We(0,I.$9M),We(1,g.$mN)],$);class y extends D.$sj{constructor(C,m,v,S){super(S?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(m,S).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const v=[[C,m]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0,e.$Pgc=(0,O.$5h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$5K.MainThreadManagedSockets)}setFactory(C,m){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,v=await this.c.makeConnection(),S=new g.$Sc;return this.d.set(m,new y(m,v,S)),S.add((0,g.$Rc)(()=>this.d.delete(m))),S.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),S.dispose()})),S.add(v.onDidClose(h=>{this.a.$onDidManagedSocketClose(m,h?.stack??h?.message),S.dispose()})),S.add(v.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(m,L.$ie.wrap(h)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Qgc=b,e.$Qgc=b=Ge([We(0,I.$9M)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Tc{constructor(C,m,v){super(),this.socketId=C,this.actual=m,this.B(v)}}}),define(ke[328],Se([1,0,6,13,25]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;function I(b){return b&&b.title}let L=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$5K.MainThreadMessageService)}showMessage($,y,R,C,m){const v={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||I(C)?S=[C,...m]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,S=m),v.useCustom&&(0,g.$BF)($,"resolvers");const h=[];let f=!1;for(let o=0;o<S.length;o++){const i=S[o];if(typeof i=="string")h.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;h.push({title:r,isCloseAffordance:!!n,handle:o}),n&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,R,v,h).then(o=>{if(typeof o=="number")return S[o]})}};e.$qhc=L,e.$qhc=L=Ge([We(1,O.$mj)],L)}),define(ke[329],Se([1,0,19,11,21,4,3,28,2,26,13,6,35,15,7,113,285,25,68]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0;let r=class{constructor(d,k,P,p,w){this.m=k,this.n=P,this.o=p,this.q=w,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Ud,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=d.getProxy(C.$5K.MainThreadNotebookKernels);const E=new m.$wN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$uN("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const T=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:T}}else if(A&&"notebookEditor"in A){const T=this.n.getIdByEditor(A.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return A})],m.$vN.Void);this.o.registerApiCommand(E)}createNotebookController(d,k,P,p,w,E){for(const _ of this.j.values())if(_.controller.id===k&&y.$km.equals(d.identifier,_.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const A=this.k++,T=this;this.q.trace(`NotebookController[${A}], CREATED by ${d.identifier.value}, ${k}`);const U=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${d.identifier}'`);let N=!1;const j=new I.$Ud,F=new I.$Ud,M={id:l(d.identifier,k),notebookType:P,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:p||d.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let B=w??U,X,ue;this.a.$addKernel(A,M).catch(_=>{console.log(_),N=!0});let Z=0;const J=()=>{if(N)return;const _=++Z;Promise.resolve().then(()=>{_===Z&&this.a.$updateKernel(A,M)})},Y=new b.$Ac,he={get id(){return k},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return M.label},set label(_){M.label=_??d.displayName??d.name,J()},get detail(){return M.detail??""},set detail(_){M.detail=_,J()},get description(){return M.description??""},set description(_){M.description=_,J()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(_){M.supportedLanguages=_,J()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(_){M.supportsExecutionOrder=_,J()},get rendererScripts(){return M.preloads?M.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(_){B=_??U},get interruptHandler(){return X},set interruptHandler(_){X=_,M.supportsInterrupt=!!_,J()},set variableProvider(_){(0,o.$BF)(d,"notebookVariableProvider"),ue=_,M.hasVariableProvider=!!_,_?.onDidChangeVariables(we=>T.a.$variablesUpdated(we.uri)),J()},get variableProvider(){return ue},createNotebookCellExecution(_){if(N)throw new Error("notebook controller is DISPOSED");if(!Y.has(_.notebook.uri))throw T.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.notebook.uri.toString()}`);return T._createNotebookCellExecution(_,l(d.identifier,this.id))},createNotebookExecution(_){if((0,o.$BF)(d,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!Y.has(_.uri))throw T.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.uri.toString()}`);return T._createNotebookExecution(_,l(d.identifier,this.id))},dispose:()=>{N||(this.q.trace(`NotebookController[${A}], DISPOSED`),N=!0,this.j.delete(A),j.dispose(),F.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(_,we){we===S.NotebookControllerAffinity2.Hidden&&(0,o.$BF)(d,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(A,_.uri,we)},onDidReceiveMessage:F.event,postMessage(_,we){return(0,o.$BF)(d,"notebookMessaging"),T.a.$postMessage(A,we&&T.n.getIdByEditor(we),_)},asWebviewUri(_){return(0,o.$BF)(d,"notebookMessaging"),(0,h.$svb)(_,T.m.remote)}};return this.j.set(A,{extensionId:d.identifier,controller:he,onDidReceiveMessage:F,onDidChangeSelection:j,associatedNotebooks:Y}),he}getIdByController(d){for(const[k,P]of this.j)if(P.controller===d)return l(P.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,k){const P=this.g++,p=this;this.q.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(P,k);const w={dispose:()=>{this.f.delete(P),p.a.$removeKernelDetectionTask(P)}};return this.f.set(P,w),w}registerKernelSourceActionProvider(d,k,P){const p=this.i++,w=typeof P.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,E=this;this.h.set(p,P),this.q.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(p,p,k);let A;return w!==void 0&&(A=P.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(p),E.a.$removeKernelSourceActionProvider(p,p),A?.dispose()}}}async $provideKernelSourceActions(d,k){const P=this.h.get(d);if(P){const p=new L.$Sc;return(await P.provideNotebookKernelSourceActions(k)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.o.converter,p))}return[]}$acceptNotebookAssociation(d,k,P){const p=this.j.get(d);if(p){const w=this.n.getNotebookDocument($.URI.revive(k));P?p.associatedNotebooks.set(w.uri,!0):p.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${d}] ASSOCIATE notebook`,w.uri.toString(),P),p.onDidChangeSelection.fire({selected:P,notebook:w.apiNotebook})}}async $executeCells(d,k,P){const p=this.j.get(d);if(!p)return;const w=this.n.getNotebookDocument($.URI.revive(k)),E=[];for(const A of P){const T=w.getCell(A);T&&E.push(T.apiCell)}try{this.q.trace(`NotebookController[${d}] EXECUTE cells`,w.uri.toString(),E.length),await p.controller.executeHandler.call(p.controller,E,w.apiNotebook,p.controller)}catch(A){this.q.error(`NotebookController[${d}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(d,k,P){const p=this.j.get(d);if(!p)return;const w=this.n.getNotebookDocument($.URI.revive(k));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,w.apiNotebook);else for(const E of P){const A=w.getCell(E);A&&this.b.get(A.uri)?.cancel()}if(p.controller.interruptHandler){const E=this.c.get(w.uri);P.length&&Array.isArray(E)&&E.length&&E.forEach(A=>A.dispose())}}async $provideVariables(d,k,P,p,w,E,A){const T=this.j.get(d);if(!T)return;const U=this.n.getNotebookDocument($.URI.revive(P)),N=T.controller.variableProvider;if(!N)return;let j;if(p){if(j=this.s[p],!j)return}else this.s={};const F=w==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,M=N.provideVariables(U.apiNotebook,j,F,E,A);for await(const B of M){if(A.isCancellationRequested)return;const X={id:this.r++,name:B.variable.name,value:B.variable.value,hasNamedChildren:B.hasNamedChildren,indexedChildrenCount:B.indexedChildrenCount};this.s[X.id]=B.variable,this.a.$receiveVariable(k,X)}}$acceptKernelMessageFromRenderer(d,k,P){const p=this.j.get(d);if(!p)return;const w=this.n.getEditorById(k);p.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:P}))}$cellExecutionChanged(d,k,P){const w=this.n.getNotebookDocument($.URI.revive(d)).getCell(k);if(w){const E=P?v.NotebookCellExecutionState.to(P):S.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:w.apiCell,state:E})}}_createNotebookCellExecution(d,k){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this.n.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!p)throw new Error("invalid cell");if(this.b.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const w=new c(k,p,this.a);this.b.set(p.uri,w);const E=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),E.dispose(),this.b.delete(p.uri))});return w.asApiObject()}_createNotebookExecution(d,k){const P=this.n.getNotebookDocument(d.uri),p=d.getCells().find(A=>{const T=P.getCellFromApiCell(A);return T&&this.b.has(T.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this.c.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const w=new u(k,P,this.a),E=w.onDidChangeState(()=>{w.state===t.Resolved&&(w.dispose(),E.dispose(),this.c.delete(P.uri))});return this.c.set(P.uri,[w,E]),w.asApiObject()}};e.$uhc=r,e.$uhc=r=Ge([We(4,R.$mj)],r);var n;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(n||(n={}));class c extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(d,k,P){super(),this.m=k,this.n=P,this.b=c.a++,this.c=new I.$Ud,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new g.$5d),this.h=new s(10,p=>this.s(p)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const k=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new i.$Sv(k))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let k=this.m;if(d&&(k=this.m.notebook.getCellFromApiCell(d)),!k)throw new Error("INVALID cell");return k.handle}y(d){return d.map(k=>{const P=S.$wM.ensureUniqueMimeTypes(k.items,!0);return P===k.items?v.NotebookCellOutput.from(k):v.NotebookCellOutput.from({items:P,id:k.id,metadata:k.metadata})})}async z(d,k,P){const p=this.w(k),w=this.y((0,D.$3b)(d));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:p,append:P,outputs:w})}async C(d,k,P){return d=S.$wM.ensureUniqueMimeTypes((0,D.$3b)(d),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:d.map(v.NotebookCellOutputItem.from),outputId:k.id,append:P})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(P){d.j=P,d.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(P){if(d.f===n.Resolved||d.f===n.Started)throw new Error("Cannot call start again");d.f=n.Started,d.c.fire(),d.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,p){if(d.f===n.Resolved)throw new Error("Cannot call resolve twice");d.f=n.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new i.$Sv({runEndTime:p,lastRunSuccess:P}))},clearOutput(P){return d.t(),d.z([],P,!1)},appendOutput(P,p){return d.t(),d.z(P,p,!0)},replaceOutput(P,p){return d.t(),d.z(P,p,!1)},appendOutputItems(P,p){return d.t(),d.C(P,p,!0)},replaceOutputItems(P,p){return d.t(),d.C(P,p,!1)}})}}var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class u extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(d,k,P){super(),this.h=k,this.j=P,this.b=u.a++,this.c=new I.$Ud,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$5d),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(d,k){this.f=d,this.g=k,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new O.$ph,this.b=Date.now(),(0,O.$6g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>d.complete())}}function l(a,d){return`${a.value}/${d}`}e.$vhc=l}),define(ke[330],Se([1,0,4,6,146]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class I{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(O.$5K.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const R=this.c.getEditorById(b);this.a.get($)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,C,m)=>this.d($).event(R,C,m),postMessage:(R,C)=>{g.$chc.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const m=C&&g.$chc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,R)}}}d(b){let $=this.a.get(b);return $||($=new D.$Ud({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$whc=I}),define(ke[331],Se([1,0,3,18,2,25,6]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(L.$5K.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,R,C){if((0,I.$BF)(y,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,C),this.a.$registerProfileContentHandler(R,C.name,C.description,y.identifier.value),(0,D.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(y,R,C,m){const v=this.b.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.saveProfile(R,C,m)}async $readProfile(y,R,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,O.$Hf)(R)?R:g.URI.revive(R),C)}}e.$zhc=b}),define(ke[332],Se([1,0,2,6,11,15]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class L{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(O.$5K.MainThreadQuickDiff)}$provideOriginalResource($,y,R){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Xg)(()=>m.provideOriginalResource(C,R)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider($,y,R,C){const m=L.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),R,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Bhc=L}),define(ke[333],Se([1,0,21,4,3,6,2,7,14,19,39,61,25,15]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;function S(h,f,o){const i=h.getProxy(I.$5K.MainThreadQuickOpen);class r{constructor(k,P){this.e=new Map,this.f=0,this.a=k,this.b=P}showQuickPick(k,P,p,w=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(P),A=++this.f,T=i.$show(A,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},w),U={},N=T.then(()=>U);return Promise.race([N,E]).then(j=>{if(j===U)return;const F=(0,m.$AF)(k,"quickPickItemTooltip");return E.then(M=>{const B=[];for(let X=0;X<M.length;X++){const ue=M[X];if(typeof ue=="string")B.push({label:ue,handle:X});else if(ue.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:ue.label});else{ue.tooltip&&!F&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const Z=ue.iconPath?s(ue.iconPath):void 0;B.push({label:ue.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:F?v.MarkdownString.fromStrict(ue.tooltip):void 0,handle:X})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=X=>{p.onDidSelectItem(M[X])}),i.$setItems(A,B),T.then(X=>{if(typeof X=="number")return M[X];if(Array.isArray(X))return X.map(ue=>M[ue])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(A,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,P=D.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",P).then(void 0,p=>{if(!(0,$.$4)(p))return Promise.reject(p)})}async $validateInput(k){if(!this.d)return;const P=await this.d(k);if(!P||typeof P=="string")return P;let p;switch(P.severity){case b.InputBoxValidationSeverity.Info:p=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:p=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:p=R.default.Error;break;default:p=P.message?R.default.Error:R.default.Ignore;break}return{content:P.message,severity:p}}async showWorkspaceFolderPick(k,P=D.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!p)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(E=>E.uri.toString()===p.uri.toString())}createQuickPick(k){const P=new l(k,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(k){const P=new a(k,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(k,P){this.e.get(k)?._fireDidChangeValue(P)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,P){const p=this.e.get(k);p instanceof l&&p._fireDidChangeActive(P)}$onDidChangeSelection(k,P){const p=this.e.get(k);p instanceof l&&p._fireDidChangeSelection(P)}$onDidTriggerButton(k,P){this.e.get(k)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(k,P,p){const w=this.e.get(k);w instanceof l&&w._fireDidTriggerItemButton(P,p)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class n{static{this.a=1}constructor(k,P){this.x=k,this.y=P,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$Ud,this.q=new O.$Ud,this.r=new O.$Ud,this.s=new O.$Ud,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((P,p)=>{const w=P===b.$pM.Back?-1:p;this.o.set(w,P)}),this.z({buttons:k.map((P,p)=>({...s(P.iconPath),tooltip:P.tooltip,handle:P===b.$pM.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const P=this.o.get(k);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const P of Object.keys(k)){const p=k[P];this.u[P]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(d){if(d instanceof b.$2L)return{id:d.id};const k=u(d),P=t(d);return{dark:typeof k=="string"?L.URI.file(k):k,light:typeof P=="string"?L.URI.file(P):P}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function u(d){return typeof d=="object"&&"dark"in d?d.dark:d}function s(d){const k=c(d);let P,p;return"id"in k?p=C.ThemeIcon.asClassName(k):P=k,{iconPath:P,iconClass:p}}class l extends n{constructor(k,P){super(k.identifier,P),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$Ud,this.L=[],this.M=new O.$Ud,this.N=new O.$Ud,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((w,E)=>{this.C.set(E,w),this.D.set(w,E)});const P=(0,m.$AF)(this.O,"quickPickItemTooltip"),p=[];for(let w=0;w<k.length;w++){const E=k[w];if(E.kind===b.QuickPickItemKind.Separator)p.push({type:"separator",label:E.label});else{E.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=E.iconPath?s(E.iconPath):void 0;p.push({handle:w,label:E.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:P?v.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((T,U)=>({...s(T.iconPath),tooltip:T.tooltip,handle:U}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(k){const P=(0,y.$Hb)(k.map(p=>this.C.get(p)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(k){const P=(0,y.$Hb)(k.map(p=>this.C.get(p)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(k,P){const p=this.C.get(k);if(!p||!p.buttons||!p.buttons.length)return;const w=p.buttons[P];w&&this.N.fire({button:w,item:p})}}class a extends n{constructor(k,P){super(k.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:R.default.Error}):this.z({validationMessage:k.message,severity:k.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new r(f,o)}e.$Chc=S}),define(ke[334],Se([1,0,2,4,52,3,11,6,19,128,13,26,61,15,25,17,10]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=void 0;function i(A){return A instanceof D.URI}function r(A,T){return A.scheme===h.Schemas.file&&T.scheme===h.Schemas.file&&f.$k?A.toString()===T.toString():A.toString().toLowerCase()===T.toString().toLowerCase()}function n(A){if(A)return typeof A.iconPath=="string"?D.URI.file(A.iconPath):D.URI.isUri(A.iconPath)||m.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function c(A){if(A.icon){if(D.URI.isUri(A.icon))return A.icon;if(m.ThemeIcon.isThemeIcon(A.icon))return A.icon;{const T=A.icon;return{light:T.light,dark:T.dark}}}else return}function t(A,T){if(!A.iconPath&&!T.iconPath)return 0;if(A.iconPath){if(!T.iconPath)return 1}else return-1;const U=typeof A.iconPath=="string"?A.iconPath:D.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,N=typeof T.iconPath=="string"?T.iconPath:D.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,y.$Rq)(U,N)}function u(A,T){let U=0;if(A.strikeThrough!==T.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==T.faded)return A.faded?1:-1;if(A.tooltip!==T.tooltip)return(A.tooltip||"").localeCompare(T.tooltip||"");if(U=t(A,T),U!==0)return U;if(A.light&&T.light)U=t(A.light,T.light);else{if(A.light)return 1;if(T.light)return-1}if(U!==0)return U;if(A.dark&&T.dark)U=t(A.dark,T.dark);else{if(A.dark)return 1;if(T.dark)return-1}return U}function s(A,T){if(A.command!==T.command)return A.command<T.command?-1:1;if(A.title!==T.title)return A.title<T.title?-1:1;if(A.tooltip!==T.tooltip){if(A.tooltip!==void 0&&T.tooltip!==void 0)return A.tooltip<T.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(A.arguments===T.arguments)return 0;if(A.arguments)if(T.arguments){if(A.arguments.length!==T.arguments.length)return A.arguments.length-T.arguments.length}else return 1;else return-1;for(let U=0;U<A.arguments.length;U++){const N=A.arguments[U],j=T.arguments[U];if(N!==j&&!(i(N)&&i(j)&&r(N,j)))return N<j?-1:1}return 0}function l(A,T){let U=(0,y.$Rq)(A.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(U!==0)return U;if(A.command&&T.command)U=s(A.command,T.command);else{if(A.command)return 1;if(T.command)return-1}if(U!==0)return U;if(A.decorations&&T.decorations)U=u(A.decorations,T.decorations);else{if(A.decorations)return 1;if(T.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)U=(0,y.$Rq)(A.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)U=(0,y.$Rq)(A.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return U}function a(A,T){for(let U=0;U<A.length;U++)if(A[U]!==T[U])return!1;return!0}function d(A,T){return A.command===T.command&&A.title===T.title&&A.tooltip===T.tooltip&&(A.arguments&&T.arguments?a(A.arguments,T.arguments):A.arguments===T.arguments)}function k(A,T){return(0,$.$ub)(A,T,d)}class P{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,S.$BF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,S.$BF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,S.$BF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,U,N,j,F){this.k=T,this.l=j,this.m=F,this.d="",this.e=new O.$Ud,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=N}showValidationMessage(T,U){(0,S.$BF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,U)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Dhc=P;class p{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,U,N,j,F,M,B){this.q=T,this.s=U,this.t=N,this.u=j,this.v=F,this.multiDiffEditorEnableViewChanges=M,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$Ud,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$Ud,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=p.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,U){const N=this.h.get(T);return N?(0,L.$Xg)(()=>this.s.executeCommand(N.command,...N.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(l),N=(0,$.$Db)(this.o,T,l).map(M=>{const B=M.toInsert.map(X=>{const ue=this.e++;this.g.set(ue,X);const Z=X.resourceUri;let J;if(X.command)if(X.command.command==="vscode.open"||X.command.command==="vscode.diff"||X.command.command==="vscode.changes"){const te=new I.$Sc;J=this.s.converter.toInternal(X.command,te),this.j.set(ue,te)}else this.h.set(ue,X.command);const Y=(0,S.$AF)(this.w,"scmMultiDiffEditor"),he=Y?X.multiDiffEditorOriginalUri:void 0,_=Y?X.multiFileDiffEditorModifiedUri:void 0,we=n(X.decorations),oe=X.decorations&&n(X.decorations.light)||we,K=X.decorations&&n(X.decorations.dark)||we,W=[oe,K],re=X.decorations&&X.decorations.tooltip||"",ye=X.decorations&&!!X.decorations.strikeThrough,de=X.decorations&&!!X.decorations.faded,ge=X.contextValue||"";return{rawResource:[ue,Z,W,re,ye,de,ge,J,he,_],handle:ue}});return{start:M.start,deleteCount:M.deleteCount,toInsert:B}}),j=N.map(({start:M,deleteCount:B,toInsert:X})=>[M,B,X.map(ue=>ue.rawResource)]),F=N.reverse();for(const{start:M,deleteCount:B,toInsert:X}of F){const ue=X.map(J=>J.handle),Z=this.n.splice(M,B,...ue);for(const J of Z)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=T,j}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let U;(0,S.$AF)(this.x,"quickDiffProvider")&&(U=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:U})}get historyProvider(){return(0,S.$BF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,S.$BF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new I.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new I.$Sc,this.o=T;const U=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,S.$BF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,S.$BF)(this.x,"scmActionButton"),this.p.value=new I.$Sc,this.q=T;const U=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(N=>N.map(j=>this.y.converter.toInternal(j,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&k(this.t,T))return;this.s.value=new I.$Sc,this.t=T;const U=(T||[]).map(N=>this.y.converter.toInternal(N,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(T,U,N,j,F,M,B){this.x=T,this.y=j,this.z=F,this.A=M,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Uc,this.m=void 0,this.n=new I.$Uc,this.o=void 0,this.p=new I.$Uc,this.s=new I.$Uc,this.t=void 0,this.u=!1,this.v=new O.$Ud,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=N;const X=D.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${F}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new P(T,U,this.#e,this.w,X),this.#e.$registerSourceControl(this.w,F,M,B,X)}createResourceGroup(T,U,N){const j=(0,S.$AF)(this.x,"scmMultiDiffEditor")&&N?.multiDiffEditorEnableViewChanges===!0,F=new p(this.#e,this.y,this.w,T,U,j,this.x),M=O.Event.once(F.onDidDispose)(()=>this.C.delete(F));return this.C.set(F,M),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const T=[],U=[];for(const[N,j]of this.C){j.dispose();const F=N.onDidUpdateResourceStates(()=>{this.D.add(N),this.eventuallyUpdateResourceStates()});O.Event.once(N.onDidDispose)(()=>{this.D.delete(N),F.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.w,N.handle)}),T.push([N.handle,N.id,N.label,N.features,N.multiDiffEditorEnableViewChanges]);const M=N._takeResourceStateSnapshot();M.length>0&&U.push([N.handle,M]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.w,T,U),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(U=>{const N=U._takeResourceStateSnapshot();N.length!==0&&T.push([U.handle,N])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,g.$xh)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ge([(0,g.$xh)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,U,N,j){this.l=U,this.m=N,this.n=j,this.g=new Map,this.h=new C.$mm,this.j=new O.$Ud,this.e=T.getProxy(b.$5K.MainThreadSCM),this.f=T.getProxy(b.$5K.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const M=this.g.get(F.sourceControlHandle);if(!M)return F;const B=M.getResourceGroup(F.groupHandle);return B?B.getResourceState(F.handle):F}else if(F&&F.$mid===4){const M=this.g.get(F.sourceControlHandle);return M?M.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const M=this.g.get(F.handle);return M||F}return F}})}createSourceControl(T,U,N,j){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,U,N,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const F=o.d++,M=new w(T,this.m,this.e,this.l,U,N,j);this.g.set(F,M);const B=this.h.get(T.identifier)||[];return B.push(M),this.h.set(T.identifier,B),M}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const U=this.h.get(T.identifier),N=U&&U[U.length-1];return N&&N.inputBox}$provideOriginalResource(T,U,N){const j=D.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",T,j.toString());const F=this.g.get(T);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Xg)(()=>F.quickDiffProvider.provideOriginalResource(j,N)).then(M=>M||null)}$onInputBoxValueChange(T,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const N=this.g.get(T);return N&&N.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(T,U,N,j){this.n.trace("ExtHostSCM#$executeResourceCommand",T,U,N);const F=this.g.get(T);if(!F)return Promise.resolve(void 0);const M=F.getResourceGroup(U);return M?M.$executeResourceCommand(N,j):Promise.resolve(void 0)}$validateInput(T,U,N){this.n.trace("ExtHostSCM#$validateInput",T);const j=this.g.get(T);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Xg)(()=>j.inputBox.validateInput(U,N)).then(F=>{if(!F)return Promise.resolve(void 0);const M=v.MarkdownString.fromStrict(F.message);return M?Promise.resolve([M,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(T,U,N){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupBase(U,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(T,U,N,j){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,N,j)??void 0}async $provideHistoryItems(T,U,N,j){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(U,N,j))?.map(B=>({...B,icon:c(B)}))??void 0}async $provideHistoryItemSummary(T,U,N,j){const F=this.g.get(T)?.historyProvider;if(typeof F?.provideHistoryItemSummary!="function")return;const M=await F.provideHistoryItemSummary(U,N,j);return M?{...M,icon:c(M)}:void 0}async $provideHistoryItemChanges(T,U,N,j){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(U,N,j)??void 0}};e.$Ehc=E,e.$Ehc=E=o=Ge([We(3,R.$mj)],E)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=void 0;class I{constructor(b){this.b=new O.$Ud,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$5K.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$Kgc=I,e.$Lgc=(0,g.$5h)("IExtHostSecretState")}),define(ke[335],Se([1,0,6,15,2]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class I{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$5K.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:O.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,O.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Fhc=I}),define(ke[336],Se([1,0,21,3,6]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class I{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$5K.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const R=new O.$Sc,C=new D.$5d;this.d.set($,C);const m=R.add(y.provideSpeechToTextSession(C.token));R.add(m.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const R=I.a++;return this.c.set(R,y),this.b.$registerProvider(R,$,{extension:b,displayName:b.value}),(0,O.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Ghc=I}),define(ke[337],Se([1,0,7,6,216,3,15,18]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=e.$Hhc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$3L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$3L("statusBarItem.warningForeground")]])}#e;#t;constructor(m,v,S,h,f,o=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Sc,this.#e=m,this.#t=v,f&&h){this.c=(0,D.$FL)(h.identifier,f);const r=S.get(this.c);r&&(o=r.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String($.a++);this.e=h,this.f=f,this.g=o,this.h=this.u(i)}u(m){if((0,b.$Lf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Sc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let v;this.m?v=this.m:v=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const h=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,v,this.k,h,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Hhc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const v={message:m};return this.b.unshift(v),this.c(),new D.$7K(()=>{const S=this.b.indexOf(v);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(m,v){this.e=new Map,this.a=m.getProxy(O.$5K.MainThreadStatusBar),this.b=v,this.c=new y(this)}$acceptStaticEntries(m){for(const v of m)this.e.set(v.entryId,v)}createStatusBarEntry(m,v,S,h){return new $(this.a,this.b,this.e,m,v,S,h)}setStatusBarMessage(m,v){const S=this.c.setMessage(m);let h;return typeof v=="number"?h=setTimeout(()=>S.dispose(),v):typeof v<"u"&&v.then(()=>S.dispose(),()=>S.dispose()),new D.$7K(()=>{S.dispose(),clearTimeout(h)})}}e.$Ihc=R}),define(ke[118],Se([1,0,6,4,5]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=void 0;class I{constructor(b,$){this.c=$,this.b=new O.$Ud,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$5K.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const R=await this.a.$initializeExtensionStorage(b,$);let C;return R&&(C=this.d(b,$,R)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const R=this.d(b,$,y);R&&this.b.fire({shared:b,key:$,value:R})}d(b,$,y){try{return JSON.parse(y)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${R}`)}}}e.$Cgc=I,e.$Dgc=(0,g.$5h)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,13,71,2]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=e.$lgc=void 0,e.$lgc=(0,D.$5h)("IExtensionStoragePaths");let b=class{constructor(y,R,C){this.d=R,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return L.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,R=await this.g(y);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(L.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return L.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return L.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$mgc=b,e.$mgc=b=Ge([We(0,O.$mN),We(1,g.$mj),We(2,I.$kgc)],b)}),define(ke[47],Se([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,61,11,15,35]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=e.$Igc=e.$Hgc=e.$Ggc=void 0,e.$Ggc=(0,g.$5h)("IExtHostTerminalService");class r{constructor(p,w,E,A){this.l=p,this._id=w,this.m=E,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(U,N=!0){T.q(),T.l.$sendText(T._id,U,N)},show(U){T.q(),T.l.$show(T._id,U)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(p,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??w?.cwd??void 0,env:p.env??void 0,icon:a(p.iconPath)??void 0,color:h.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(p.location,w?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,w,E,A,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:A,color:h.ThemeColor.isThemeColor(T)?T.id:void 0,location:w?.location||this.o(p,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(p,w){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in p?{viewColumn:o.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.n=p}setExitStatus(p,w){this.h=Object.freeze({code:p,reason:w})}setDimensions(p,w){return p===this.d&&w===this.g||p===0||w===0?!1:(this.d=p,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(p){this.k=p}_setProcessId(p){this.f?(this.f(p),this.f=void 0):this.b.then(w=>{w!==p&&(this.b=Promise.resolve(p))})}}e.$Hgc=r;class n{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new D.$Ud,this.onProcessData=this.a.event,this.b=new D.$Ud,this.d=new D.$Ud,this.onDidChangeProperty=this.d.event,this.f=new D.$Ud,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,w){this.g.setDimensions?.({columns:p,rows:w})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends b.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,w,E){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Ud,this.onDidCloseTerminal=this.H.event,this.I=new D.$Ud,this.onDidOpenTerminal=this.I.event,this.J=new D.$Ud,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Ud,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Ud,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Ud,this.onDidChangeShell=this.N.event,this.O=new D.$Ud({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Ud({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(O.$5K.MainThreadTerminalService),this.y=new S.$Grb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:A=>{const T=U=>{const N=U;return this.W(N.instanceId)?.value};switch(A?.$mid){case 15:return T(A);default:{if(Array.isArray(A))for(let U=0;U<A.length&&A[U].$mid===15;U++)A[U]=T(A[U]);return A}}}}),this.B({dispose:()=>{for(const[A,T]of this.g)T.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,w){const E=new r(this.a,(0,v.$pg)(),p,p.name),A=new n(p.pty);return E.createExtensionTerminal(p.location,w,this.R(p,w).resolvedExtHostIdentifier,a(p.iconPath),d(p.color)).then(T=>{const U=this.S(T,A);this.h[T]=U}),this.f.push(E),E.value}R(p,w){if(w=w||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const E=p.location.parentTerminal;if(E){const A=this.f.find(T=>T.value===E);A&&(w.resolvedExtHostIdentifier=A._id)}}else p.location&&typeof p.location!="object"?w.location=p.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(p,w){if(!this.W(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const A=new n(w),T=this.S(p,A);this.h[p]=T}async $acceptActiveTerminalChanged(p){const w=this.b;if(p===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const E=this.W(p);E&&(this.b=E,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,w){const E=this.W(p);E&&this.O.fire({terminal:E.value,data:w})}async $acceptTerminalDimensions(p,w,E){const A=this.W(p);A&&A.setDimensions(w,E)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(p,w){const E=this.W(p);E&&this.P.fire({terminal:E.value,...w})}async $acceptTerminalMaximumDimensions(p,w,E){this.g.get(p)?.resize(w,E)}async $acceptTerminalTitleChange(p,w){const E=this.W(p);E&&(E.name=w)}async $acceptTerminalClosed(p,w,E){const A=this.Y(this.f,p);if(A!==null){const T=this.f.splice(A,1)[0];T.setExitStatus(w,E),this.H.fire(T.value)}}$acceptTerminalOpened(p,w,E,A){if(w){const N=this.Y(this.f,w);if(N!==null){this.f[N]._id=p,this.I.fire(this.terminals[N]),this.f[N].isOpen=!0;return}}const T={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:I.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},U=new r(this.a,p,T,E);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(p,w){this.W(p)?._setProcessId(w)}async $startExtensionTerminal(p,w){const E=this.W(p);if(!E)return{message:(0,y.localize)(0,null,p)};E.isOpen||await new Promise(T=>{const U=this.onDidOpenTerminal(async N=>{N===E.value&&(U.dispose(),T())})});const A=this.g.get(p);A?A.startSendingEvents(w):this.j[p]={initialDimensions:w}}S(p,w){const E=new b.$Sc;E.add(w.onProcessReady(T=>this.a.$sendProcessReady(p,T.pid,T.cwd,T.windowsPty))),E.add(w.onDidChangeProperty(T=>this.a.$sendProcessProperty(p,T))),this.y.startBuffering(p,w.onProcessData),E.add(w.onProcessExit(T=>this.U(p,T))),this.g.set(p,w);const A=this.j[p];return A&&w instanceof n&&(w.startSendingEvents(A.initialDimensions),delete this.j[p]),E}$acceptProcessAckDataEvent(p,w){this.g.get(p)?.acknowledgeDataEvent(w)}$acceptProcessInput(p,w){this.g.get(p)?.input(w)}$acceptTerminalInteraction(p){const w=this.W(p);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(p,w){this.W(p)?.setSelection(w)}$acceptProcessResize(p,w,E){try{this.g.get(p)?.resize(w,E)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(p,w){this.g.get(p)?.shutdown(w)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(w=>this.a.$sendProcessProperty(p,{type:"cwd",value:w}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$7K(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,w,E){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,E),this.a.$registerProfileProvider(w,p.identifier.value),new $.$7K(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(p,w,E){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,E),this.a.$registerQuickFixProvider(p,w),new $.$7K(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,w){const E=new m.$5d().token;if(E.isCancellationRequested)return;const A=this.D.get(p);if(!A)return;const T=await A.provideTerminalQuickFixes(w,E);if(T===null||Array.isArray(T)&&T.length===0)return;const U=new b.$Sc;if(this.w.value=U,!Array.isArray(T))return T?o.TerminalQuickFix.from(T,this.Q.converter,U):void 0;const N=[];for(const j of T){const F=o.TerminalQuickFix.from(j,this.Q.converter,U);F&&N.push(F)}return N}async $createContributedProfileTerminal(p,w){const E=new m.$5d().token;let A=await this.C.get(p)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,w);return}this.createTerminalFromOptions(A.options,w)}}async $provideLinks(p,w){const E=this.W(p);if(!E)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const T=new m.$5d;this.G.set(p,T);const U=[],N={terminal:E.value,line:w},j=[];for(const B of this.z)j.push(f.Promises.withAsyncBody(async X=>{T.token.onCancellationRequested(()=>X({provider:B,links:[]}));const ue=await B.provideTerminalLinks(N,T.token)||[];T.token.isCancellationRequested||X({provider:B,links:ue})}));const F=await Promise.all(j);if(T.token.isCancellationRequested)return[];const M=new Map;for(const B of F)B&&B.links.length>0&&U.push(...B.links.map(X=>{const ue={id:c++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return M.set(ue.id,{provider:B.provider,link:X}),ue}));return this.F.set(p,M),U}$activateLink(p,w){const E=this.F.get(p)?.get(w);E&&E.provider.handleTerminalLink(E.link)}U(p,w){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const E=this.h[p];E&&(E.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,w)}W(p){return this.X(this.f,p)}X(p,w){const E=this.Y(p,w);return E!==null?p[E]:null}Y(p,w){const E=p.findIndex(A=>A._id===w);return E===-1?null:E}getEnvironmentVariableCollection(p){let w=this.n.get(p.identifier.value);return w||(w=new u,this.$(p.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(p,w){const E=(0,C.$Lr)(w.map),A=(0,C.$Mr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(p,w.persistent,E.length===0?void 0:E,A)}$initEnvironmentVariableCollections(p){p.forEach(w=>{const E=w[0],A=new u(w[1]);this.$(E,A)})}$acceptDefaultProfile(p,w){const E=this.s;this.s=p,this.u=w,E?.path!==p.path&&this.N.fire(p.path)}$(p,w){this.n.set(p,w),w.onDidChangeCollection(()=>{this.Z(p,w)})}};e.$Igc=t,e.$Igc=t=Ge([We(1,i.$sN),We(2,L.$9M)],t);class u{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Ud,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const w=this.h(p);let E=this.a.get(w);return E||(E=new s(this,p),this.a.set(w,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(p,w,E,A){this.f(p,{value:w,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:A})}append(p,w,E,A){this.f(p,{value:w,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:A})}prepend(p,w,E,A){this.f(p,{value:w,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:A})}f(p,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(p,w.scope),A=this.map.get(E),T=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==w.value||A.type!==w.type||A.options?.applyAtProcessCreation!==T.applyAtProcessCreation||A.options?.applyAtShellIntegration!==T.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const U=this.g(p,w.scope),N={variable:p,...w,options:T};this.map.set(U,N),this.d.fire()}}get(p,w){const E=this.g(p,w),A=this.map.get(E);return A?k(A):void 0}g(p,w){const E=this.h(w);return E.length?`${p}:::${E}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const w=new Map;for(const[E,A]of this.map)this.h(A.scope)===this.h(p)&&w.set(A.variable,k(A));return w}delete(p,w){const E=this.g(p,w);this.map.delete(E),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[w,E]of this.map)E.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(w);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,w){const E=this.h(w),A=this.descriptionMap.get(E);if(!A||A.description!==p){let T;typeof p=="string"?T=p:T=p?.value.split(`

`)[0];const U={description:T,scope:w};this.descriptionMap.set(E,U),this.d.fire()}}getDescription(p){const w=this.h(p);return this.descriptionMap.get(w)?.description}k(p){const w=this.h(p);this.descriptionMap.delete(w)}}class s{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,w){this.b=p,this.d=w,this.a=new D.$Ud}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,w,E){this.b.replace(p,w,E,this.d)}append(p,w,E){this.b.append(p,w,E,this.d)}prepend(p,w,E){this.b.prepend(p,w,E,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,w){this.b.getVariableMap(this.d).forEach((E,A)=>p.call(w,A,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(p,w){super(!1,p,w)}createTerminal(p,w,E){throw new R.$_}createTerminalFromOptions(p,w){throw new R.$_}};e.$Jgc=l,e.$Jgc=l=Ge([We(0,i.$sN),We(1,L.$9M)],l);function a(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function d(P){return h.ThemeColor.isThemeColor(P)?P:void 0}function k(P){const p={...P};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[338],Se([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,147,15,7,67,112,89,25]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=e.$Nhc=e.$Mhc=void 0;let t=class extends $.$Tc{constructor(j,F,M,B){super(),this.w=B,this.f=this.B(new I.$Ud),this.g=new Map,this.s=this.B(new I.$Ud),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(v.$5K.MainThreadTesting),this.m=new E(this.h),this.j=new a(this.h,F),M.registerArgumentProcessor({processArgument:X=>{switch(X?.$mid){case 16:{const ue=X,Z=ue.tests[ue.tests.length-1].item.extId;return this.g.get(i.$WJ.root(Z))?.collection.tree.get(Z)?.actual??(0,h.$iN)(X)}case 18:{const{extId:ue,message:Z}=X;return{test:this.g.get(i.$WJ.root(ue))?.collection.tree.get(ue)?.actual,message:f.TestMessage.to(Z)}}default:return X}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const X=await M.executeCommand("_testing.getExplorerSelection"),ue=Z=>{const J=this.g.get(i.$WJ.root(Z));if(J)return i.$WJ.isRoot(Z)?J.controller:J.collection.tree.get(Z)?.actual};return{include:X?.include.map(ue).filter(R.$Pf)||[],exclude:X?.exclude.map(ue).filter(R.$Pf)||[]}})}createTestController(j,F,M,B){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const X=new $.$Sc,ue=X.add(new h.$lN(F,M,this.w));ue.root.label=M;const Z=new Map,J=new Set,Y=this.h,he={items:ue.root.children,get label(){return M},set label(we){M=we,ue.root.label=we,Y.$updateController(F,{label:M})},get refreshHandler(){return B},set refreshHandler(we){B=we,Y.$updateController(F,{canRefresh:!!we})},get id(){return F},createRunProfile:(we,oe,K,W,re,ye)=>{let de=(0,b.$Si)(we);for(;Z.has(de);)de++;return new T(this.h,Z,j,J,this.s.event,F,de,we,oe,K,W,re,ye)},createTestItem(we,oe,K){return new h.$jN(F,we,oe,K)},createTestRun:(we,oe,K=!0)=>this.j.createTestRun(j,F,ue,we,oe,K),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const oe=we instanceof Array?we:[we];this.h.$markTestRetired(oe.map(K=>i.$WJ.fromExtHostTestItem(K,F).toString()))}},set resolveHandler(we){ue.resolveHandler=we},get resolveHandler(){return ue.resolveHandler},dispose:()=>{X.dispose()}};Y.$registerTestController(F,M,!!B),X.add((0,$.$Rc)(()=>Y.$unregisterTestController(F)));const _={controller:he,collection:ue,profiles:Z,extension:j,activeProfiles:J};return this.g.set(F,_),X.add((0,$.$Rc)(()=>this.g.delete(F))),X.add(ue.onDidGenerateDiff(we=>Y.$publishDiff(F,we.map(n.TestsDiffOp.serialize)))),he}createTestObserver(){return this.m.checkout()}async runTests(j,F=g.CancellationToken.None){const M=d(j);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.g.get(M.controllerId);if(!B)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(X=>i.$WJ.fromExtHostTestItem(X,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:U[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:j.exclude?.map(X=>X.id)},F)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,F,M){return await this.j.getCoverageReport(j,F)?.provideFileCoverage(M)??[]}async $resolveFileCoverage(j,F,M,B){return await this.j.getCoverageReport(j,F)?.resolveFileCoverage(M,B)??[]}$configureRunProfile(j,F){this.g.get(j)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(j){const F=new Map;for(const[M,B]of Object.entries(j)){const X=this.g.get(M);if(!X)continue;const ue=new Map,Z=B.filter(Y=>!X.activeProfiles.has(Y)),J=[...X.activeProfiles].filter(Y=>!B.includes(Y));for(const Y of Z)ue.set(Y,!0),X.activeProfiles.add(Y);for(const Y of J)ue.set(Y,!1),X.activeProfiles.delete(Y);ue.size&&F.set(M,ue)}this.s.fire(F)}async $refreshTests(j,F){await this.g.get(j)?.controller.refreshHandler?.(F)}$publishTestResults(j){this.results=Object.freeze(j.map(F=>(0,y.$vn)(f.TestResults.to(F))).concat(this.results).sort((F,M)=>M.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,F){const M=this.g.get(i.$WJ.fromString(j).controllerId)?.collection;M&&(await M.expand(j,F<0?1/0:F),M.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(F=>n.TestsDiffOp.deserialize({asCanonicalUri:M=>M},F)))}async $runControllerTests(j,F){return Promise.all(j.map(M=>this.y(M,!1,F)))}async $startContinuousRun(j,F){const M=new g.$5d(F),B=await Promise.all(j.map(X=>this.y(X,!0,M.token)));return!F.isCancellationRequested&&!B.some(X=>X.error)&&await new Promise(X=>F.onCancellationRequested(X)),M.dispose(!0),B}async y(j,F,M){const B=this.g.get(j.controllerId);if(!B)return{};const{collection:X,profiles:ue,extension:Z}=B,J=ue.get(j.profileId);if(!J)return{};const Y=j.testIds.map(oe=>X.tree.get(oe)).filter(R.$Pf),he=j.excludeExtIds.map(oe=>B.collection.tree.get(oe)).filter(R.$Pf).filter(oe=>Y.some(K=>K.fullId.compare(oe.fullId)===2));if(!Y.length)return{};const _=new o.$DM(Y.some(oe=>oe.actual instanceof h.$kN)?void 0:Y.map(oe=>oe.actual),he.map(oe=>oe.actual),J,F),we=(0,n.$YJ)(j)&&this.j.prepareForMainThreadTestRun(_,k.fromInternal(j,B.collection),Z,M);try{return await J.runHandler(_,M),{}}catch(oe){return{error:String(oe)}}finally{we&&(we.hasRunningTasks&&!M.isCancellationRequested&&await I.Event.toPromise(we.onEnd),we.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$Mhc=t,e.$Mhc=t=Ge([We(0,S.$9M),We(1,m.$mj)],t);const u=1e4;var s;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(s||(s={}));class l extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,F,M,B,X){super(),this.s=j,this.w=F,this.y=M,this.z=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Ud),this.m=this.B(new I.$Ud),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$5d(X));const ue=this.B(new D.$eh(()=>this.C(),u));this.B(this.h.token.onCancellationRequested(()=>ue.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(j){const F=this.s.id,M=this.s.controllerId,B=(0,C.$pg)(),X=this.y,ue=this.m;let Z;const J=we=>(oe,...K)=>{if(he){this.z.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(oe)&&(this.F(oe),we(oe,...K))},Y=(we,oe)=>{const K=oe instanceof Array?oe.map(f.TestMessage.from):[f.TestMessage.from(oe)];if(we.uri&&we.range){const W={range:f.Range.from(we.range),uri:we.uri};for(const re of K)re.location=re.location||W}this.w.$appendTestMessagesInRun(F,B,i.$WJ.fromExtHostTestItem(we,M).toString(),K)};let he=!1;const _={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return Z?.provider},set coverageProvider(we){(0,c.$BF)(X,"testCoverage"),Z=we&&new P(we),ue.fire({taskId:B,runId:F,coverage:Z})},enqueued:J(we=>{this.w.$updateTestStateInRun(F,B,i.$WJ.fromExtHostTestItem(we,M).toString(),1)}),skipped:J(we=>{this.w.$updateTestStateInRun(F,B,i.$WJ.fromExtHostTestItem(we,M).toString(),5)}),started:J(we=>{this.w.$updateTestStateInRun(F,B,i.$WJ.fromExtHostTestItem(we,M).toString(),2)}),errored:J((we,oe,K)=>{Y(we,oe),this.w.$updateTestStateInRun(F,B,i.$WJ.fromExtHostTestItem(we,M).toString(),6,K)}),failed:J((we,oe,K)=>{Y(we,oe),this.w.$updateTestStateInRun(F,B,i.$WJ.fromExtHostTestItem(we,M).toString(),4,K)}),passed:J((we,oe)=>{this.w.$updateTestStateInRun(F,B,i.$WJ.fromExtHostTestItem(we,this.s.controllerId).toString(),3,oe)}),appendOutput:(we,oe,K)=>{he||(K&&(this.s.isIncluded(K)?this.F(K):K=void 0),this.w.$appendOutputToRun(F,B,O.$ie.fromString(we),oe&&f.location.from(oe),K&&i.$WJ.fromExtHostTestItem(K,M).toString()))},end:()=>{he||(he=!0,this.w.$finishedTestRunTask(F,B),this.f.delete(B),this.f.size||this.D())}};return this.f.set(B,{run:_}),this.w.$startedTestRunTask(F,{id:B,name:j,running:!0}),_}C(){for(const{run:j}of this.f.values())j.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(j){if(!(j instanceof h.$jN))throw new r.$1M(j.id);if(this.g.has(i.$WJ.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const F=[],M=this.s.colllection.root;for(;;){const B=f.TestItem.from(j);if(F.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),j===M))break;j=j.parent||M}this.w.$addTestsToRun(this.s.controllerId,this.s.id,F)}dispose(){this.D(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(j,F){this.g=j,this.h=F,this.c=new Map,this.f=[]}getCoverageReport(j,F){return this.f.find(M=>M.runId===j)?.coverage.get(F)}prepareForMainThreadTestRun(j,F,M,B){return this.j(j,F,M,B)}cancelRunById(j){for(const F of this.c.values())if(F.id===j){F.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,F,M,B,X,ue){const Z=this.c.get(B);if(Z)return Z.createRun(X);const J=k.fromPublic(F,M,B,ue),Y=d(B);this.g.$startedExtensionTestRun({controllerId:F,continuous:!!B.continuous,profile:Y&&{group:U[Y.kind],id:Y.profileId},exclude:B.exclude?.map(_=>i.$WJ.fromExtHostTestItem(_,M.root.id).toString())??[],id:J.id,include:B.include?.map(_=>i.$WJ.fromExtHostTestItem(_,M.root.id).toString())??[M.root.id],persist:ue});const he=this.j(B,J,j);return I.Event.once(he.onEnd)(()=>{this.g.$finishedExtensionTestRun(J.id),he.dispose()}),he.createRun(X)}j(j,F,M,B){const X=new l(F,this.g,M,this.h,B);this.c.set(j,X);let ue;const Z=X.onDidCoverage(({runId:J,taskId:Y,coverage:he})=>{ue||(ue={runId:J,coverage:new Map},this.f.unshift(ue),this.f.length>n.$4J&&this.f.pop()),ue.coverage.set(Y,he),this.g.$signalCoverageAvailable(J,Y,!!he)});return I.Event.once(X.onEnd)(()=>{this.c.delete(j),Z.dispose()}),X}}e.$Nhc=a;const d=N=>{if(N.profile){if(!(N.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class k{static fromPublic(j,F,M,B){return new k(j,(0,C.$pg)(),M.include?.map(X=>i.$WJ.fromExtHostTestItem(X,j).toString())??[j],M.exclude?.map(X=>i.$WJ.fromExtHostTestItem(X,j).toString())??[],B,F)}static fromInternal(j,F){return new k(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,F)}constructor(j,F,M,B,X,ue){this.controllerId=j,this.id=F,this.isPersisted=X,this.colllection=ue,this.c=M.map(Z=>Z+"\0"),this.f=B.map(Z=>Z+"\0")}isIncluded(j){const F=i.$WJ.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const M of this.f)if(F===M||F.startsWith(M))return!1;for(const M of this.c)if(F===M||F.startsWith(M))return!0;return!1}}e.$Ohc=k;class P{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(f.TestCoverage.fromFile)??[]}catch(F){throw this.c=void 0,F}}async resolveFileCoverage(j,F){const M=await this.c;let B=M?.[j];return!this.provider||!M||!B?[]:(B.detailedCoverage||(B=M[j]=await this.provider.resolveFileCoverage?.(B,F)??B),B.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class p{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,f.TestItem.toPlain(j.item)),this.c.has(j)||this.f.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.f.delete(j);const F=i.$WJ.parentId(j.item.extId);if(F&&this.h.has(F.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{c:j,f:F,g:M}=this;return{get added(){return[...j].map(B=>B.revived)},get updated(){return[...F].map(B=>B.revived)},get removed(){return[...M].map(B=>B.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends n.$5J{constructor(){super(...arguments),this.s=new I.$Ud,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}w(j,F){return{...j,revived:f.TestItem.toPlain(j.item),depth:F?F.depth+1:0,children:new Set}}v(){return new p(this.s)}}class E{constructor(j){this.f=j}checkout(){this.c||(this.c=this.g());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(F=>F.revived)},dispose:(0,L.$db)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}g(){const j=new w({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}const A=(N,j,F,M)=>{F?Object.assign(F,M):j.$updateTestRunConfig(N.controllerId,N.profileId,M)};class T{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,A(this,this.#e,this.#n,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,A(this,this.#e,this.#n,{supportsContinuousRun:j}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(j){j!==this.isDefault&&(j?this.#i.add(this.profileId):this.#i.delete(this.profileId),A(this,this.#e,this.#n,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,A(this,this.#e,this.#n,{tag:j?f.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,A(this,this.#e,this.#n,{hasConfigurationHandler:!!j}))}get onDidChangeDefault(){return(0,c.$BF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,j=>j.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(R.$Pf))}constructor(j,F,M,B,X,ue,Z,J,Y,he,_=!1,we=void 0,oe=!1){this.controllerId=ue,this.profileId=Z,this.f=J,this.kind=Y,this.runHandler=he,this._tag=we,this.g=oe,this.#e=j,this.#r=F,this.#t=M,this.#i=B,this.#o=X,F.set(Z,this);const K=U[Y];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);_&&B.add(Z),this.#n={profileId:Z,controllerId:ue,tag:we?f.TestTag.namespace(this.controllerId,we.id):null,label:J,group:K,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Phc=T;const U={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[339],Se([1,0,19,4,6,148,15,7]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class ${constructor(R,C){this.i=C,this.a=new O.$Ud,this.b=new O.$Ud,this.c=new O.$Ud,this.d=new O.$Ud,this.f=new O.$Ud,this.g=new O.$Ud,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(g.$5K.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const C=this.i.allEditors();return R?C:C.map(m=>m.value)}async showTextDocument(R,C,m){let v;typeof C=="number"?v={position:L.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?v={position:L.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?L.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:v={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(R.uri,v),h=S&&this.i.getEditor(S);if(h)return h.value;throw S?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new I.$dN(this.h,R,C).value}$acceptEditorPropertiesChanged(R,C){const m=this.i.getEditor(R);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const v=C.selections.selections.map(L.Selection.to);m._acceptSelections(v)}if(C.visibleRanges){const v=D.$Hb(C.visibleRanges.map(L.Range.to));m._acceptVisibleRanges(v)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:L.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const v=b.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(L.Selection.to);this.a.fire({textEditor:m.value,selections:S,kind:v})}if(C.visibleRanges){const v=D.$Hb(C.visibleRanges.map(L.Range.to));this.c.fire({textEditor:m.value,visibleRanges:v})}}$acceptEditorPositionData(R){for(const C in R){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const v=L.ViewColumn.to(R[C]);m.value.viewColumn!==v&&(m._acceptViewColumn(v),this.d.fire({textEditor:m.value,viewColumn:v}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$_fc=$}),define(ke[340],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,O.$5h)("IExtHostTimeline");class R{constructor(v,S){this.b=new Map,this.c=new Map,this.a=v.getProxy(g.$5K.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(h,f)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&$.$km.equals(f,this.b.get(h.source)?.extension)){const o=h.uri===void 0?void 0:D.URI.revive(h.uri);return this.c.get(h.source)?.get(C(o))?.get(h.handle)}else return;return h}})}async $getTimeline(v,S,h,f){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(S),h,f)}registerTimelineProvider(v,S,h,f){const o=new I.$Sc,i=this.d(S.id,f,o).bind(this);let r;S.onDidChange&&(r=S.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:S.id}),this));const n=this.c;return this.f({...S,scheme:v,onDidChange:void 0,async provideTimeline(c,t,u){t?.resetCache&&(o.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(c,t,u);if(s==null)return;const l=i(c,t);return{...s,source:S.id,items:s.items.map(l)}},dispose(){for(const c of n.values())c.get(S.id)?.clear();r?.dispose(),o.dispose()}},h)}d(v,S,h){return(f,o)=>{let i;if(o?.cacheResults){let r=this.c.get(v);r===void 0&&(r=new Map,this.c.set(v,r));const n=C(f);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...c}=r,t=`${v}|${r.id??r.timestamp}`;i?.set(t,r);let u,s,l;r.iconPath&&(n instanceof L.$2L?l={id:n.id,color:n.color}:D.URI.isUri(n)?(u=n,s=n):{light:u,dark:s}=n);let a;return L.$vL.isMarkdownString(c.tooltip)?a=b.MarkdownString.from(c.tooltip):(0,y.$Hf)(c.tooltip)?a=c.tooltip:L.$vL.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=b.MarkdownString.from(c.detail)):(0,y.$Hf)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=c.detail),{...c,id:c.id??void 0,handle:t,source:v,command:r.command?S.toInternal(r.command,h):void 0,icon:u,iconDark:s,themeIcon:l,tooltip:a,accessibilityInformation:r.accessibilityInformation}}}}f(v,S){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:S}),(0,I.$Rc)(()=>{for(const f of this.c.values())f.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Shc=R;function C(m){return m?.toString()}}),define(ke[72],Se([1,0,21,4,3,220,5,13,88,6,27,20,7]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lyb=e.$kyb=e.TunnelDtoConverter=void 0;class v extends $.$Iv{}var S;(function(f){function o(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:r.protocol}}f.fromApiTunnel=o;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==$.TunnelPrivacyId.ConstantPrivate&&r.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}f.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$kyb=(0,L.$5h)("IExtHostTunnelService");let h=class extends g.$Tc{constructor(o,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$Ud,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(y.$5K.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,o.displayName);if(r){const n=new v(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const r=this.u();return this.r.set(r,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,r),new m.$7K(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(o,i,r,n,c){const t=[];for(const s of o){const l=this.r.get(s);if(!l)return[];t.push(...await Promise.all(i.map(async a=>{let d;try{d=await l.provider.providePortAttributes({port:a,pid:r,commandLine:n},c)}catch{d=await l.provider.providePortAttributes(a,r,n,c)}return{providedAttributes:d,port:a}})))}const u=t.filter(s=>!!s.providedAttributes);return u.length>0?u.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,c)=>await o.provideTunnel(n,c,new D.$5d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,g.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const r=o.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const c=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,g.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const r=this.g.get(o.host);r.has(o.port)&&(i&&r.get(o.port).disposeListener.dispose(),await r.get(o.port).tunnel.dispose(),r.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const c=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:n,disposeListener:c}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(n=>this.f(n.host,n.port,n.detail??""))),r=o.filter((n,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$lyb=h,e.$lyb=h=Ge([We(0,C.$9M),We(1,R.$mN),We(2,b.$mj)],h)}),define(ke[341],Se([1,0,3,17,2,6]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class L{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$5K.MainThreadUriOpeners)}registerExternalUriOpener($,y,R,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(v=>!L.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,R),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Rc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,R)}async $openUri($,y,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},R)}}e.$Uhc=L}),define(ke[342],Se([1,0,6,2,3,14,26]),function(me,e,D,O,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class b{static{this.a=0}constructor(y){this.c=new L.$lm,this.d=new Map,this.b=y.getProxy(D.$5K.MainThreadUrls)}registerUriHandler(y,R){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,R),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Rc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,R){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(O.URI.revive(R))}catch(m){(0,I.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return O.URI.revive(await this.b.$createAppUri(y))}}e.$Vhc=b}),define(ke[93],Se([1,0,4,3,17,24,2,237,274,113,6]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=e.$qgc=e.$pgc=e.$ogc=e.$ngc=void 0;class C{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(n,c,t,u,s,l,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Ud,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Ud,this._onDidDispose=this.#h.event,this.#e=n,this.#t=c,this.#s=t,this.#o=u,this.#n=s,this.#r=l,this.#l=m(l),this.#d=v(l),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#u=!0,(0,y.$svb)(n,this.#o)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===g.Schemas.https||n.scheme===g.Schemas.http){let c=n.toString();return c.endsWith("/")||(c+="/"),c+" "+y.$rvb}return y.$rvb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#s}set options(n){this.a(),I.$yn(this.#s,n)||this.#t.$setOptions(this.#e,f(this.#r,this.#n,n)),this.#s=n}async postMessage(n){if(this.#c)return!1;const c=(0,$.$$kb)(n,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const c=this.#r.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,l,a,d,k)=>{const P=L.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),p=(0,y.$svb)(P,{isRemote:c,authority:t}).toString();return`${s}${p}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,l,a,d,k)=>{const P=L.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),p=(0,y.$svb)(P,{isRemote:c,authority:t}).toString();return`${s}${p}${k}`})}}e.$ngc=C;function m(r){try{const n=(0,b.$bp)((0,b.$ap)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$ogc=m;function v(r){try{const n=(0,b.$bp)((0,b.$ap)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends O.$Tc{constructor(n,c,t,u,s){super(),this.c=c,this.f=t,this.g=u,this.h=s,this.b=new Map,this.a=n.getProxy(R.$5K.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,c,t){const u=this.j(n);if(u){const{message:s}=(0,$.$_kb)(c,t.value);u._onMessageEmitter.fire(s)}}$onMissingCsp(n,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,c,t){const u=new C(n,this.a,o(c),this.c,this.f,t,this.h);this.b.set(n,u);const s=u._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$pgc=S;function h(r){return{id:r.identifier,location:r.extensionLocation}}e.$qgc=h;function f(r,n,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(r,n)}}e.$rgc=f;function o(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>L.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(c=>c.uri),r.extensionLocation]}}),define(ke[343],Se([1,0,21,54,3,17,23,2,15,93,110,6,7]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class v{constructor(u,s){this.document=u,this.b=s,this.a=1,this.c=new R.$Sfc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,s){await this.f(u).undo(),s||this.disposeBackup()}async redo(u,s){await this.f(u).redo(),s||this.disposeBackup()}disposeEdits(u){for(const s of u)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=c(this.document.uri)+this.a++;return(0,L.$Gg)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const s=this.c.get(u,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(u,s){return this.a.get(this.b(u,s))}add(u,s,l){const a=this.b(u,s.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${u} resource:${s.uri}`);const d=new v(s,l);return this.a.set(a,d),d}delete(u,s){const l=this.b(u,s.uri);this.a.delete(l)}b(u,s){return`${u}@@@${s}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class f{constructor(){this.a=new Map}addTextProvider(u,s,l){return this.b(0,u,s,l)}addCustomProvider(u,s,l){return this.b(1,u,s,l)}get(u){return this.a.get(u)}b(u,s,l,a){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:u,extension:l,provider:a}),new m.$7K(()=>this.a.delete(s))}}class o{constructor(u,s,l,a,d){this.d=s,this.f=l,this.g=a,this.h=d,this.b=new f,this.c=new S,this.a=u.getProxy(C.$5K.MainThreadCustomEditors)}registerCustomEditorProvider(u,s,l,a){const d=new g.$Sc;return r(l)?(d.add(this.b.addTextProvider(s,u,l)),this.a.$registerTextEditorProvider((0,y.$qgc)(u),s,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,y.$ogc)(u))):(d.add(this.b.addCustomProvider(s,u,l)),i(l)&&d.add(l.onDidChangeCustomDocument(k=>{const P=this.i(s,k.document.uri);if(n(k)){const p=P.addEdit(k);this.a.$onDidEdit(k.document.uri,s,p,k.label)}else this.a.$onContentChange(k.document.uri,s)})),this.a.$registerCustomEditorProvider((0,y.$qgc)(u),s,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,y.$ogc)(u))),m.$7K.from(d,new m.$7K(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(u,s,l,a,d){const k=this.b.get(s);if(!k)throw new Error(`No provider found for '${s}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${s}'`);const P=b.URI.revive(u),p=await k.provider.openCustomDocument(P,{backupId:l,untitledDocumentData:a?.buffer},d);let w;return i(k.provider)&&this.f&&(w=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(s,p,w),{editable:i(k.provider)}}async $disposeCustomDocument(u,s){const l=this.b.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const a=b.URI.revive(u),{document:d}=this.i(s,a);this.c.delete(s,d),d.dispose()}async $resolveCustomEditor(u,s,l,a,d,k){const P=this.b.get(l);if(!P)throw new Error(`No provider found for '${l}'`);const p=$.ViewColumn.to(d),w=this.g.createNewWebview(s,a.contentOptions,P.extension),E=this.h.createNewWebviewPanel(s,l,a.title,p,a.options,w,a.active),A=b.URI.revive(u);switch(P.type){case 1:{const{document:T}=this.i(l,A);return P.provider.resolveCustomEditor(T,E,k)}case 0:{const T=this.d.getDocument(A);return P.provider.resolveCustomTextEditor(T,E,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,s,l){this.i(s,u).disposeEdits(l)}async $onMoveCustomEditor(u,s,l){const a=this.b.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const d=this.h.getWebviewPanel(u);if(!d)throw new Error("No webview found");const k=b.URI.revive(s),P=this.d.getDocument(k);await a.provider.moveCustomTextEditor(P,d,D.CancellationToken.None)}async $undo(u,s,l,a){return this.i(s,u).undo(l,a)}async $redo(u,s,l,a){return this.i(s,u).redo(l,a)}async $revert(u,s,l){const a=this.i(s,u);await this.j(s).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(u,s,l){const a=this.i(s,u);await this.j(s).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(u,s,l,a){const d=this.i(s,u);return this.j(s).saveCustomDocumentAs(d.document,b.URI.revive(l),a)}async $backup(u,s,l){const a=this.i(s,u),k=await this.j(s).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(k),k.id}i(u,s){const l=this.c.get(u,b.URI.revive(s));if(!l)throw new Error("No custom document found");return l}j(u){const l=this.b.get(u)?.provider;if(!l||!i(l))throw new Error("Custom document is not editable");return l}}e.$tgc=o;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const u=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,O.$Si)(u)+""}}),define(ke[344],Se([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class R extends O.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(S,h,f,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Ud),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Ud),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=h,this.#o=f,this.#i=o.viewType,this.#n=o.panelOptions,this.#s=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:L.ViewColumn.from(S),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends O.$Tc{static c(){return(0,I.$pg)()}constructor(S,h,f){super(),this.j=h,this.m=f,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$5K.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,h,f,o,i={}){const r=typeof o=="object"?o.viewColumn:o,n={viewColumn:L.ViewColumn.from(r),preserveFocus:typeof o=="object"&&!!o.preserveFocus},c=(0,b.$ogc)(S),t=C.c();this.f.$createWebviewPanel((0,b.$qgc)(S),t,h,{title:f,panelOptions:m(i),webviewOptions:(0,b.$rgc)(S,this.m,i),serializeBuffersForPostMessage:c},n);const u=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,h,f,r,i,u,!0)}$onDidChangeWebviewPanelViewStates(S){const h=Object.keys(S);h.sort((f,o)=>{const i=S[f],r=S[o];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const f of h){const o=this.getWebviewPanel(f);if(!o)continue;const i=S[f];o._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,h,f){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:f,extension:S}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,b.$ogc)(S)}),new y.$7K(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(S,h,f,o){const i=this.h.get(h);if(!i)throw new Error(`No serializer found for '${h}'`);const{serializer:r,extension:n}=i,c=this.j.createNewWebview(S,f.webviewOptions,n),t=this.createNewWebviewPanel(S,h,f.title,o,f.panelOptions,c,f.active);await r.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(S,h,f,o,i,r,n){const c=new R(S,this.f,r,{viewType:h,title:f,viewColumn:o,panelOptions:i,active:n});return this.g.set(S,c),c}getWebviewPanel(S){return this.g.get(S)}}e.$sgc=C;function m(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(ke[345],Se([1,0,4,3,93,15,6,7]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class $ extends O.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(C,m,v,S,h,f){super(),this.#n=!1,this.#u=this.B(new D.$Ud),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Ud),this.onDidDispose=this.#l.event,this.#i=v,this.#a=S,this.#e=C,this.#t=m,this.#o=h,this.#r=f}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#n||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#n)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(L.$5K.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,v,S){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,g.$qgc)(C),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$ogc)(C)}),new b.$7K(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,v,S,h){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:o,extension:i}=f,r=this.d.createNewWebview(C,{},i),n=new $(C,this.a,m,v,r,!0);this.c.set(C,n),await o.resolveWebviewView(n,{state:S},h)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$Whc=y}),define(ke[151],Se([1,0,4,6,2,17,12,5,20,25]),function(me,e,D,O,g,I,L,b,$,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=void 0;let C=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(v){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$BF)(v,"windowActivity"),S.active}}}constructor(v){this.c=new D.$Ud,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=v.getProxy(O.$5K.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:h})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,S){S!==this.d[v]&&(this.d={...this.d,[v]:S},this.c.fire(this.d))}openUri(v,S){let h;if(typeof v=="string"){h=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,L.$Ie)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,h,S)}async asExternalUri(v,S){if((0,L.$Ie)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this.b.$asExternalUri(v,S);return g.URI.from(h)}};e.$Xhc=C,e.$Xhc=C=R=Ge([We(0,$.$9M)],C),e.$Yhc=(0,b.$5h)("IExtHostWindow")}),define(ke[346],Se([1,0,314,27,20]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;const I=1024*1024;let L=class extends D.$2hc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,R){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,R),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const R=process[$],C=R.write;let m="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(v,S,h)=>{if(!this.g){m+=v.toString(S);const f=m.length>I?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(R,v,S,h)}})}};e.$Aic=L,e.$Aic=L=Ge([We(0,g.$9M),We(1,O.$mN)],L)}),define(ke[347],Se([1,0,71,17,13,249,32,10]),function(me,e,D,O,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(O.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$Bic=$,e.$Bic=$=Ge([We(0,D.$kgc),We(1,g.$mj)],$);class y{constructor(C){this.b=C,this.a=new I.$Aq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,v){return this.a.writeFile(C,m,{...v,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,v){return this.a.rename(C,m,v)}copy(C,m,v){return this.a.copy(C,m,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[348],Se([1,0,16,63,30,35,3,6,2,20]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;let R=class extends L.$Tc{constructor(m,v){super();const S=m.getProxy(b.$5K.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async h=>{const f=$.URI.file((0,D.$jc)((0,O.tmpdir)(),(0,g.$pg)()));return await S.$download(h,f),f})}};e.$zic=R,e.$zic=R=Ge([We(0,y.$9M),We(1,I.$sN)],R)}),define(ke[349],Se([1,0,150,17,251,30]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;class L extends D.$1hc{s($,y,R){return $.scheme===O.Schemas.file?new g.$iO(R?.name||(0,I.$pg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,y):super.s($,y,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Mic=L}),define(ke[350],Se([1,0,56,16,2,92,3,17,11,31]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;class R extends I.$mgc{constructor(){super(...arguments),this.i=null}async g(t){const u=await super.g(t);if(u.scheme!==b.Schemas.file)return u;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const s=u.fsPath;let l=0;do{let a;l===0?a=s:a=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${l}`:`${s}-${l}`,await C(a);const d=O.$jc(a,"vscode.lock"),k=await h(this.d,d,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),g.URI.file(a);l++}while(l<10);return u}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Lic=R;async function C(c){try{await y.Promises.stat(c);return}catch{}try{await y.Promises.mkdir(c,{recursive:!0})}catch{}}const m=1e3,v=10*60*1e3;class S extends L.$Tc{constructor(t,u){super(),this.b=t,this.c=u,this.a=this.B(new $.$dh),this.a.cancelAndSet(async()=>{const s=await f(t,u);(!s||s.pid!==process.pid)&&(t.info(`Lock '${u}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(u,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${u}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(u),{flag:"w"})}catch(u){this.b.error(u)}}}async function h(c,t,u){try{const l={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){c.error(l)}const s=await f(c,t);return!s||s.pid!==process.pid?u?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new S(c,t))}async function f(c,t){let u;try{u=await y.Promises.readFile(t)}catch(s){return c.error(s),null}try{return JSON.parse(String(u))}catch(s){return c.error(s),null}}async function o(c,t){let u;try{u=await y.Promises.stat(t)}catch(s){return c.error(s),0}return u.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function r(c,t){const u=await f(c,t);if(!u)return c.info(`Lock '${t}': Could not read pid of lock holder.`),n(c,t);if(u.willReleaseAt){let k=u.willReleaseAt-Date.now();if(k<5e3){for(k>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,$.$6g)(Math.min(100,k)),await o(c,t)===0)return n(c,t);k=u.willReleaseAt-Date.now()}return n(c,t)}}if(!i(u.pid))return c.info(`Lock '${t}': The pid ${u.pid} appears to be gone.`),n(c,t);const s=await o(c,t),l=Date.now()-s;if(l<=v)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$6g)(2e3);const a=await o(c,t),d=Date.now()-a;return d<=v?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(c,t))}async function n(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return h(c,t,!0)}}),define(ke[351],Se([1,0,30,20,47,35]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;let L=class extends g.$Igc{constructor($,y){super(!0,$,y)}createTerminal($,y,R){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:R})}createTerminalFromOptions($,y){const R=new g.$Hgc(this.a,(0,D.$pg)(),$,$.name);return this.f.push(R),R.create($,this.R($,y)),R.value}};e.$7hc=L,e.$7hc=L=Ge([We(0,I.$sN),We(1,O.$9M)],L)}),define(ke[352],Se([1,0,11,22,21,14,4,3,130,303,68]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=e.ResponsiveState=e.RequestInitiator=e.$d8b=e.$c8b=void 0;function m(E,A){try{return JSON.stringify(E,A)}catch{return"null"}}const v="$$ref$$",S={[v]:-1};class h{constructor(A,T){this.jsonString=A,this.referencedBuffers=T}}function f(E,A=null,T=!1){const U=[];return{jsonString:(T?m:JSON.stringify)(E,(j,F)=>{if(typeof F>"u")return S;if(typeof F=="object"){if(F instanceof O.$ie){const M=U.push(F)-1;return{[v]:M}}if(A)return A(j,F)}return F}),referencedBuffers:U}}e.$c8b=f;function o(E,A,T){return JSON.parse(E,(U,N)=>{if(N){const j=N[v];if(typeof j=="number")return A[j];if(T&&N.$mid===1)return T.transformIncoming(N)}return N})}e.$d8b=o;function i(E,A){return JSON.stringify(E,A)}function r(E){return E?(A,T)=>T&&T.$mid===1?E.transformOutgoing(T):T:null}var n;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var c;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},u=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class l extends b.$Tc{static{C=u}static{this.a=3*1e3}constructor(A,T=null,U=null){super(),this[C]=!0,this.b=this.B(new L.$Ud),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=T,this.g=U,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let N=0,j=R.$Pv.count;N<j;N++)this.m[N]=null,this.s[N]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$eh(()=>this.H(),1e3)),this.c.onMessage(N=>this.L(N))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const T=this.w[A];delete this.w[A],T.resolveErr(I.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,$.$6m)(A,this.g):A}getProxy(A){const{nid:T,sid:U}=A;return this.s[T]||(this.s[T]=this.J(T,U)),this.s[T]}J(A,T){const U={get:(N,j)=>(typeof j=="string"&&!N[j]&&j.charCodeAt(0)===36&&(N[j]=(...F)=>this.U(A,j,F)),j===s?T:N[j])};return new Proxy(Object.create(null),U)}set(A,T){return this.m[A.nid]=T,T}assertRegistered(A){for(let T=0,U=A.length;T<U;T++){const N=A[T];if(!this.m[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}L(A){if(this.j)return;const T=A.byteLength,U=d.read(A,0),N=U.readUInt8(),j=U.readUInt32();switch(N){case 1:case 2:{let{rpcId:F,method:M,args:B}=P.deserializeRequestJSONArgs(U);this.g&&(B=(0,$.$6m)(B,this.g)),this.M(T,j,F,M,B,N===2);break}case 3:case 4:{let{rpcId:F,method:M,args:B}=P.deserializeRequestMixedArgs(U);this.g&&(B=(0,$.$6m)(B,this.g)),this.M(T,j,F,M,B,N===4);break}case 5:{this.f?.logIncoming(T,j,0,"ack"),this.G(j);break}case 6:{this.N(T,j);break}case 7:{this.O(T,j,void 0);break}case 9:{let F=P.deserializeReplyOKJSON(U);this.g&&(F=(0,$.$6m)(F,this.g)),this.O(T,j,F);break}case 10:{const F=P.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(T,j,F);break}case 8:{const F=P.deserializeReplyOKVSBuffer(U);this.O(T,j,F);break}case 11:{let F=P.deserializeReplyErrError(U);this.g&&(F=(0,$.$6m)(F,this.g)),this.P(T,j,F);break}case 12:{this.P(T,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,T,U,N,j,F){this.f?.logIncoming(A,T,1,`receiveRequest ${(0,R.$Rv)(U)}.${N}(`,j);const M=String(T);let B,X;if(F){const Z=new g.$5d;j.push(Z.token),B=this.Q(U,N,j),X=()=>Z.cancel()}else B=this.Q(U,N,j),X=t;this.u[M]=X;const ue=P.serializeAcknowledged(T);this.f?.logOutgoing(ue.byteLength,T,1,"ack"),this.c.send(ue),B.then(Z=>{delete this.u[M];const J=P.serializeReplyOK(T,Z,this.h);this.f?.logOutgoing(J.byteLength,T,1,"reply:",Z),this.c.send(J)},Z=>{delete this.u[M];const J=P.serializeReplyErr(T,Z);this.f?.logOutgoing(J.byteLength,T,1,"replyErr:",Z),this.c.send(J)})}N(A,T){this.f?.logIncoming(A,T,1,"receiveCancel");const U=String(T);this.u[U]?.()}O(A,T,U){this.f?.logIncoming(A,T,0,"receiveReply:",U);const N=String(T);if(!this.w.hasOwnProperty(N))return;const j=this.w[N];delete this.w[N],j.resolveOk(U)}P(A,T,U){this.f?.logIncoming(A,T,0,"receiveReplyErr:",U);const N=String(T);if(!this.w.hasOwnProperty(N))return;const j=this.w[N];delete this.w[N];let F;U&&(U.$isError?(F=new Error,F.name=U.name,F.message=U.message,F.stack=U.stack):F=U),j.resolveErr(F)}Q(A,T,U){try{return Promise.resolve(this.S(A,T,U))}catch(N){return Promise.reject(N)}}S(A,T,U){const N=this.m[A];if(!N)throw new Error("Unknown actor "+(0,R.$Rv)(A));const j=N[T];if(typeof j!="function")throw new Error("Unknown method "+T+" on actor "+(0,R.$Rv)(A));return j.apply(N,U)}U(A,T,U){if(this.j)return new y.$b8b;let N=null;if(U.length>0&&g.CancellationToken.isCancellationToken(U[U.length-1])&&(N=U.pop()),N&&N.isCancellationRequested)return Promise.reject(I.$6());const j=P.serializeRequestArguments(U,this.h),F=++this.t,M=String(F),B=new y.$a8b,X=new b.$Sc;N&&X.add(N.onCancellationRequested(()=>{const Z=P.serializeCancel(F);this.f?.logOutgoing(Z.byteLength,F,0,"cancel"),this.c.send(P.serializeCancel(F))})),this.w[M]=new a(B,X),this.F(F);const ue=P.serializeRequest(F,A,T,j,!!N);return this.f?.logOutgoing(ue.byteLength,F,0,`request: ${(0,R.$Rv)(A)}.${T}(`,U),this.c.send(ue),B}}e.$e8b=l;class a{constructor(A,T){this.a=A,this.b=T}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class d{static alloc(A,T,U){const N=new d(O.$ie.alloc(U+1+4),0);return N.writeUInt8(A),N.writeUInt32(T),N}static read(A,T){return new d(A,T)}get buffer(){return this.a}constructor(A,T){this.a=A,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+A).toString();return this.b+=A,U}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+A).toString();return this.b+=A,U}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+A);return this.b+=A,T}static sizeMixedArray(A){let T=0;T+=1;for(let U=0,N=A.length;U<N;U++){const j=A[U];switch(T+=1,j.type){case 1:T+=this.sizeLongString(j.value);break;case 2:T+=this.sizeVSBuffer(j.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(j.value);for(let F=0;F<j.buffers.length;++F)T+=this.sizeVSBuffer(j.buffers[F]);break;case 4:break}}return T}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let T=0,U=A.length;T<U;T++){const N=A[T];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let j=0;j<N.buffers.length;++j)this.writeBuffer(N.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const T=new Array(A);for(let U=0;U<A;U++)switch(this.readUInt8()){case 1:T[U]=this.readLongString();break;case 2:T[U]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),F=this.readLongString(),M=[];for(let B=0;B<j;++B)M.push(this.readVSBuffer());T[U]=new R.$Sv(o(F,M,null));break}case 4:T[U]=void 0;break}return T}}var k;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(k||(k={}));class P{static a(A){for(let T=0,U=A.length;T<U;T++)if(A[T]instanceof O.$ie||A[T]instanceof R.$Sv||typeof A[T]>"u")return!0;return!1}static serializeRequestArguments(A,T){if(this.a(A)){const U=[];for(let N=0,j=A.length;N<j;N++){const F=A[N];if(F instanceof O.$ie)U[N]={type:2,value:F};else if(typeof F>"u")U[N]={type:4};else if(F instanceof R.$Sv){const{jsonString:M,referencedBuffers:B}=f(F.value,T);U[N]={type:3,value:O.$ie.fromString(M),buffers:B}}else U[N]={type:1,value:O.$ie.fromString(i(F,T))}}return{type:1,args:U}}return{type:0,args:i(A,T)}}static serializeRequest(A,T,U,N,j){switch(N.type){case 0:return this.b(A,T,U,N.args,j);case 1:return this.c(A,T,U,N.args,j)}}static b(A,T,U,N,j){const F=O.$ie.fromString(U),M=O.$ie.fromString(N);let B=0;B+=d.sizeUInt8(),B+=d.sizeShortString(F),B+=d.sizeLongString(M);const X=d.alloc(j?2:1,A,B);return X.writeUInt8(T),X.writeShortString(F),X.writeLongString(M),X.buffer}static deserializeRequestJSONArgs(A){const T=A.readUInt8(),U=A.readShortString(),N=A.readLongString();return{rpcId:T,method:U,args:JSON.parse(N)}}static c(A,T,U,N,j){const F=O.$ie.fromString(U);let M=0;M+=d.sizeUInt8(),M+=d.sizeShortString(F),M+=d.sizeMixedArray(N);const B=d.alloc(j?4:3,A,M);return B.writeUInt8(T),B.writeShortString(F),B.writeMixedArray(N),B.buffer}static deserializeRequestMixedArgs(A){const T=A.readUInt8(),U=A.readShortString(),N=A.readMixedArray(),j=new Array(N.length);for(let F=0,M=N.length;F<M;F++){const B=N[F];typeof B=="string"?j[F]=JSON.parse(B):j[F]=B}return{rpcId:T,method:U,args:j}}static serializeAcknowledged(A){return d.alloc(5,A,0).buffer}static serializeCancel(A){return d.alloc(6,A,0).buffer}static serializeReplyOK(A,T,U){if(typeof T>"u")return this.d(A);if(T instanceof O.$ie)return this.e(A,T);if(T instanceof R.$Sv){const{jsonString:N,referencedBuffers:j}=f(T.value,U,!0);return this.g(A,N,j)}else return this.f(A,m(T,U))}static d(A){return d.alloc(7,A,0).buffer}static e(A,T){let U=0;U+=d.sizeVSBuffer(T);const N=d.alloc(8,A,U);return N.writeVSBuffer(T),N.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,T){const U=O.$ie.fromString(T);let N=0;N+=d.sizeLongString(U);const j=d.alloc(9,A,N);return j.writeLongString(U),j.buffer}static g(A,T,U){const N=O.$ie.fromString(T);let j=0;j+=d.sizeUInt32,j+=d.sizeLongString(N);for(const M of U)j+=d.sizeVSBuffer(M);const F=d.alloc(10,A,j);F.writeUInt32(U.length),F.writeLongString(N);for(const M of U)F.writeBuffer(M);return F.buffer}static deserializeReplyOKJSON(A){const T=A.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(A,T){const U=A.readUInt32(),N=A.readLongString(),j=[];for(let F=0;F<U;++F)j.push(A.readVSBuffer());return new R.$Sv(o(N,j,T))}static serializeReplyErr(A,T){const U=T?m(I.$3(T),null):void 0;if(typeof U!="string")return this.h(A);const N=O.$ie.fromString(U);let j=0;j+=d.sizeLongString(N);const F=d.alloc(11,A,j);return F.writeLongString(N),F.buffer}static deserializeReplyErrError(A){const T=A.readLongString();return JSON.parse(T)}static h(A){return d.alloc(12,A,0).buffer}}var p;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var w;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(w||(w={}))}),define(ke[353],Se([1,0,4,37,46,5]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oK=e.$nK=e.OutputChannelUpdateMode=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=void 0,e.$dK="text/x-code-output",e.$eK="output",e.$fK="Log",e.$gK="text/x-code-log-output",e.$hK="log",e.$iK="workbench.panel.output",e.$jK=new g.$jj("inOutput",!1),e.$kK=new g.$jj("activeLogOutput",!1),e.$lK=new g.$jj("outputView.scrollLock",!1),e.$mK=(0,I.$5h)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$nK={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Ud,this.onDidRegisterChannel=this.b.event,this.c=new D.$Ud,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(R=>y.push(R)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}O.$Gn.add(e.$nK.OutputChannels,new b),e.$oK=new g.$jj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,26,13,353,71,27,58,182,22,18,32,4,3]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=void 0;class o extends L.$sj{get disposed(){return this.n}constructor(c,t,u,s,l){super(),this.id=c,this.name=t,this.r=u,this.s=s,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=m.$ie.fromString(t).byteLength,(0,L.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(c){this.append(c)}}let r=class{constructor(c,t,u,s,l,a){this.i=t,this.j=u,this.k=s,this.l=l,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(D.$5K.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$vm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(c,t,u){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,l=(0,v.$Hf)(t)?t:void 0;if((0,v.$Hf)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const d=this.i.environment.extensionLogLevel?.find(([P])=>I.$km.equals(u.identifier,P))?.[1];d&&(a=(0,L.$Cj)(d));const k=s?this.o(c,a,u):this.n(c,l,u);return k.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),s?this.r(c,a??this.m.getLevel(),k):this.q(c,k)}async n(c,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,l=this.k.extUri.joinPath(s,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(c,l,t,u.identifier.value);return new o(d,c,a,this.a,u)}async o(c,t,u){const s=await this.p(u),l=c.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(s,`${l}.log`),d=`${u.identifier.value}.${l}`,k=this.l.createLogger(a,{id:d,name:c,logLevel:t,extensionId:u.identifier.value});return new i(d,c,k,this.a,u)}p(c){let t=this.d.get(c.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(s){if((0,S.$Fk)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return u})())}return t}q(c,t){let u=!1;const s=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return c},append(l){s(),t.then(a=>a.append(l))},appendLine(l){s(),t.then(a=>a.appendLine(l))},clear(){s(),t.then(l=>l.clear())},replace(l){s(),t.then(a=>a.replace(l))},show(l,a){s(),t.then(d=>d.show(l,a))},hide(){s(),t.then(l=>l.hide())},dispose(){u=!0,t.then(l=>l.dispose())}}}r(c,t,u){const s=new f.$Sc,l=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},a=s.add(new h.$Ud);function d(k){t=k,a.fire(k)}return u.then(k=>{s.add(k),k.logLevel!==t&&d(k.logLevel),s.add(k.onDidChangeLogLevel(P=>d(P)))}),{...this.q(c,u),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(k,...P){l(),u.then(p=>p.trace(k,...P))},debug(k,...P){l(),u.then(p=>p.debug(k,...P))},info(k,...P){l(),u.then(p=>p.info(k,...P))},warn(k,...P){l(),u.then(p=>p.warn(k,...P))},error(k,...P){l(),u.then(p=>p.error(k,...P))},dispose(){s.dispose()}}}};e.$xhc=r,e.$xhc=r=Ge([We(0,g.$9M),We(1,y.$mN),We(2,$.$kgc),We(3,R.$Wfc),We(4,L.$nj),We(5,L.$mj)],r),e.$yhc=(0,O.$5h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,11]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=void 0,e.$Km=(0,D.$5h)("remoteAgentService"),e.$Lm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,O.$6g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(I):L=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:I,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof L>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>L*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[354],Se([1,0,223,86,37,40,45,3,4,153,10,24]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=void 0,e.$QH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$RH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$SH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$TH=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$UH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Ud,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const v=new m;g.$Gn.add(e.$UH.ConfigurationMigration,v);let S=class extends b.$Tc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.f(n,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(r=>this.g(r,o?.uri))])}async g(o,i){const r=this.a.inspect(o.key,{resource:i}),n=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[c,t]of n){const u=[];for(const l of r.overrideIdentifiers??[]){const a=await this.h(o,{resource:i,overrideIdentifier:l},c);for(const d of a??[]){let k=u.find(([[P,p]])=>P===d[0]&&(0,C.$yn)(p.value,d[1].value));k||u.push(k=[d,[]]),k[1].push(l)}}const s=await this.h(o,{resource:i},c,r);for(const l of s??[])u.push([l,[]]);u.length&&await Promise.allSettled(u.map(async([[l,a],d])=>this.a.updateValue(l,a.value,{resource:i,overrideIdentifiers:d},t)))}}async h(o,i,r,n){const c=l=>t(this.a.inspect(l,i)),t=l=>{const a=l[r];return i.overrideIdentifier?a?.override:a?.value},u=n?t(n):c(o.key);if(u===void 0)return;const s=await o.migrateFn(u,c);return Array.isArray(s)?s:[[o.key,s]]}};e.$VH=S,e.$VH=S=Ge([We(0,L.$yi),We(1,I.$bi)],S);let h=class extends b.$Tc{constructor(o){super(),(async()=>{if(!R.$i&&(await o.getEnvironment())?.os!==1)return;g.$Gn.as(O.$Ln.Configuration).registerConfiguration({...e.$SH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})})()}};e.$WH=h,e.$WH=h=Ge([We(0,y.$Km)],h)}),define(ke[355],Se([1,0,34,17,16,23,232,354,86,5,37]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddb=e.$cdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$bdb=e.$adb=void 0,e.$adb=(0,y.$5h)("editorResolverService"),e.$bdb="workbench.editorAssociations";const C=R.$Gn.as($.$Ln.Configuration),m={...b.$RH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var v;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(v||(e.RegisteredEditorPriority=v={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function h(o){switch(o){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$cdb=h;function f(o,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof o=="string"&&o.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$Dg)(i);return D.$Kj(typeof o=="string"?o.toLowerCase():o,c.toLowerCase())}e.$ddb=f}),define(ke[356],Se([1,0,33,17,16,10,23,2,5,267,40,144,153]),function(me,e,D,O,g,I,L,b,$,y,R,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$GK=void 0,e.$GK=(0,$.$5h)("pathService");let S=v=class{constructor(f,o,i,r){this.d=f,this.e=o,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??f})()}hasValidBasename(f,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(r=>this.h(f,r,o)):this.h(f,o,i)}h(f,o,i){return f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote?(0,D.$5f)(i??(0,L.$Dg)(f),o===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,y.$DK)(o.getWorkspace());if(i)return i;const r=o.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=o.getWorkspace().configuration;return n?n.scheme:O.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let o="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const r=f.indexOf("/",2);r===-1?(o=f.substring(2),f="/"):(o=f.substring(2,r),f=f.substring(r)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:o,path:f,query:"",fragment:""})}};e.$HK=S,e.$HK=S=v=Ge([We(1,m.$Km),We(2,C.$pK),We(3,R.$bi)],S)}),define(ke[357],Se([1,0,234,19,52,4,54,3,2,45,239,13,64,269,88,40,144,25,21,18,24,46]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.$zK=e.$yK=e.OnPortForward=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.TunnelSource=e.TunnelCloseReason=e.$sK=e.$rK=e.$qK=void 0;const t=10*1e3,u="remote.tunnels.toRestore";e.$qK="onTunnel",e.$rK=new c.$jj("forwardedPortsViewEnabled",!1,D.localize(0,null));function s(T){const U=T.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(U)return{host:U[1]?.substring(0,U[1].length-1)||"localhost",port:Number(U[2])}}e.$sK=s;var l;(function(T){T.Other="Other",T.User="User",T.AutoForwardEnd="AutoForwardEnd"})(l||(e.TunnelCloseReason=l={}));var a;(function(T){T[T.User=0]="User",T[T.Auto=1]="Auto",T[T.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$tK={source:a.User,description:D.localize(1,null)},e.$uK={source:a.Auto,description:D.localize(2,null)};function d(T,U,N){const j=T.get(P(U,N));if(j)return j;if((0,S.$Ev)(U))for(const F of S.$Dv){const M=P(F,N);if(T.has(M))return T.get(M)}else if((0,S.$Gv)(U))for(const F of S.$Fv){const M=P(F,N);if(T.has(M))return T.get(M)}}e.$vK=d;function k(T,U,N){const j=d(T,U,N);if(j)return j;const F=(0,S.$Gv)(U)?"localhost":(0,S.$Ev)(U)?"0.0.0.0":void 0;if(F)return d(T,F,N)}e.$wK=k;function P(T,U){return T+":"+U}e.$xK=P;var p;(function(T){T.Notify="notify",T.OpenBrowser="openBrowser",T.OpenBrowserOnce="openBrowserOnce",T.OpenPreview="openPreview",T.Silent="silent",T.Ignore="ignore"})(p||(e.OnPortForward=p={}));function w(T){return T&&"host"in T&&typeof T.host=="string"&&"port"in T&&typeof T.port=="number"&&(!("detail"in T)||typeof T.detail=="string")&&(!("pid"in T)||typeof T.pid=="string")}e.$yK=w;class E extends b.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(U){super(),this.r=U,this.j=[],this.n=new I.$Ud,this.onDidChangeAttributes=this.n.event,this.B(U.onDidChangeConfiguration(N=>{(N.affectsConfiguration(E.c)||N.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(U,N,j){let F=this.w(U,N,j,this.j,0);const M={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const B=this.j[F];B.key===U?(M.onAutoForward=B.onAutoForward??M.onAutoForward,M.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:M.elevateIfNeeded,M.label=B.label??M.label,M.requireLocalPort=B.requireLocalPort,M.protocol=B.protocol):(M.onAutoForward=M.onAutoForward??B.onAutoForward,M.elevateIfNeeded=M.elevateIfNeeded!==void 0?M.elevateIfNeeded:B.elevateIfNeeded,M.label=M.label??B.label,M.requireLocalPort=M.requireLocalPort!==void 0?M.requireLocalPort:void 0,M.protocol=M.protocol??B.protocol),F=this.w(U,N,j,this.j,F+1)}return M.onAutoForward!==void 0||M.elevateIfNeeded!==void 0||M.label!==void 0||M.requireLocalPort!==void 0||M.protocol!==void 0?M:this.C()}t(U){return U.start!==void 0&&U.end!==void 0}u(U){return U.host!==void 0&&U.port!==void 0&&(0,r.$Hf)(U.host)&&(0,r.$Lf)(U.port)}w(U,N,j,F,M){if(M>=F.length)return-1;const B=!(0,S.$Ev)(N)&&!(0,S.$Gv)(N),ue=F.slice(M).findIndex(Z=>(0,r.$Lf)(Z.key)?B?!1:Z.key===U:this.t(Z.key)?B?!1:U>=Z.key.start&&U<=Z.key.end:this.u(Z.key)?U===Z.key.port&&N===Z.key.host:j?Z.key.test(j):!1);return ue>=0?ue+M:-1}y(){const U=this.r.getValue(E.c);if(!U||!(0,r.$Jf)(U))return[];const N=[];for(const F in U){if(F===void 0)continue;const M=U[F];let B;if(Number(F))B=Number(F);else if((0,r.$Hf)(F))if(E.g.test(F)){const X=F.match(E.g);B={start:Number(X[1]),end:Number(X[2])}}else if(E.h.test(F)){const X=F.match(E.h);B={host:X[1],port:Number(X[2])}}else{let X;try{X=RegExp(F)}catch{}X&&(B=X)}B&&N.push({key:B,elevateIfNeeded:M.elevateIfNeeded,onAutoForward:M.onAutoForward,label:M.label,requireLocalPort:M.requireLocalPort,protocol:M.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(N)}z(U){function N(j,F){return(0,r.$Lf)(j.key)?j.key:F.t(j.key)?j.key.start:F.u(j.key)?j.key.port:Number.MAX_VALUE}return U.sort((j,F)=>N(j,this)-N(F,this))}C(){return this.m}static providedActionToAction(U){switch(U){case S.ProvidedOnAutoForward.Notify:return p.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return p.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return p.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return p.OpenPreview;case S.ProvidedOnAutoForward.Silent:return p.Silent;case S.ProvidedOnAutoForward.Ignore:return p.Ignore;default:return}}async addAttributes(U,N,j){const M=this.r.inspect(E.c).userRemoteValue;let B;!M||!(0,r.$Jf)(M)?B={}:B=(0,n.$un)(M),B[`${U}`]||(B[`${U}`]={});for(const X in N)B[`${U}`][X]=N[X];return this.r.updateValue(E.c,B,j)}}e.$zK=E;let A=class extends b.$Tc{constructor(U,N,j,F,M,B,X,ue,Z,J){super(),this.H=U,this.I=N,this.J=j,this.L=F,this.M=M,this.N=B,this.O=X,this.P=ue,this.Q=Z,this.R=J,this.c=new Map,this.g=new I.$Ud,this.onForwardPort=this.g.event,this.h=new I.$Ud,this.onClosePort=this.h.event,this.j=new I.$Ud,this.onPortName=this.j.event,this.n=new I.$Ud,this.onCandidatesChanged=this.n.event,this.t=new I.$Ud,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Ud,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Y=>{const he=await this.getAttributes(Y.map(_=>({port:_.tunnelRemotePort,host:_.tunnelRemoteHost})));for(const _ of Y)if(_.localAddress){const we=P(_.tunnelRemoteHost,_.tunnelRemotePort),oe=k(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort);this.forwarded.set(we,{remotePort:_.tunnelRemotePort,remoteHost:_.tunnelRemoteHost,localAddress:_.localAddress,protocol:he?.get(_.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(_.localAddress,he?.get(_.tunnelRemotePort)),localPort:_.tunnelLocalPort,runningProcess:oe?.detail,hasRunningProcess:!!oe,pid:oe?.pid,privacy:_.privacy,source:e.$tK}),this.f.set(we,_)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Y=>{const he=P(Y.tunnelRemoteHost,Y.tunnelRemotePort);if(!k(this.forwarded,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&!k(this.detected,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&!k(this.c,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&Y.localAddress){const _=k(this.m??new Map,Y.tunnelRemoteHost,Y.tunnelRemotePort),we=(await this.getAttributes([{port:Y.tunnelRemotePort,host:Y.tunnelRemoteHost}]))?.get(Y.tunnelRemotePort);this.forwarded.set(he,{remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localAddress:Y.localAddress,protocol:we?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Y.localAddress,we),localPort:Y.tunnelLocalPort,closeable:!0,runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,privacy:Y.privacy,source:e.$tK})}await this.$(),this.f.set(he,Y),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(Y=>this.W(Y,l.Other))),this.U()}S(){return this.Q.extensions.find(U=>U.activationEvents?.includes(e.$qK))?(this.R.createKey(e.$rK.key,!0),!0):!1}U(){if(this.S())return;const U=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&U.dispose()}))}async W(U,N){const j=P(U.host,U.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(U))}X(U,N){if(U.startsWith("http"))return $.URI.parse(U);const j=N?.protocol??"http";return $.URI.parse(`${j}://${U}`)}async Y(){const U=this.N.getWorkspace(),N=U.configuration?(0,L.$Si)(U.configuration.path):U.folders.length>0?(0,L.$Si)(U.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${u}.${this.L.remoteAuthority}.${N}`}async Z(){const U=this.I.get(u,1);if(U)return this.I.remove(u,1),await this.$(),U;const N=await this.Y();if(N)return this.I.get(N,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=await this.s;if(U&&U!==this.y){const N=JSON.parse(U)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(j=>j.remotePort).join(", ")}`);for(const j of N){const F=k(this.detected,j.remoteHost,j.remotePort);j.source.source!==a.Extension&&!F||j.source.source===a.Extension&&F?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===a.Extension&&!F&&this.D.set(P(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const U=await this.Y();this.w=this.B(new b.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async N=>{N.key===U&&(this.s=Promise.resolve(this.I.get(U,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=JSON.stringify(Array.from(this.forwarded.values()));if(U!==this.y){this.y=U;const N=await this.Y();N&&this.I.store(N,this.y,0,0)}}}async bb(U,N,j){if(!U.tunnelLocalPort||!j?.requireLocalPort||U.tunnelLocalPort===N)return;const F=new Date;if(this.ab.getTime()+t>F.getTime())return;this.ab=F;const M=D.localize(3,null,N,U.tunnelRemotePort,U.tunnelLocalPort);return this.P.info(M)}async forward(U,N){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(U,N)}async cb(U,N){await this.Q.activateByEvent(e.$qK);const j=k(this.forwarded,U.remote.host,U.remote.port);N=N??(N!==null?(await this.getAttributes([U.remote]))?.get(U.remote.port):void 0);const F=U.local!==void 0?U.local:U.remote.port;let M;if(j)return this.eb(j,U,N);{const B=this.L.remoteAuthority,X=B?{getAddress:async()=>(await this.M.resolveAuthority(B)).authority}:void 0,ue=P(U.remote.host,U.remote.port);this.c.set(ue,!0),U=this.db(ue,U);const Z=await this.H.openTunnel(X,U.remote.host,U.remote.port,void 0,F,U.elevateIfNeeded?U.elevateIfNeeded:N?.elevateIfNeeded,U.privacy,N?.protocol);if(typeof Z=="string")M=Z;else if(Z&&Z.localAddress){const J=k(this.m??new Map,U.remote.host,U.remote.port),Y=Z.protocol?Z.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:N?.protocol??S.TunnelProtocol.Http,he={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:N?.label??U.name,closeable:!0,localAddress:Z.localAddress,protocol:Y,localUri:await this.X(Z.localAddress,N),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:U.source??e.$tK,privacy:Z.privacy};return this.forwarded.set(ue,he),this.f.set(ue,Z),this.c.delete(ue),await this.$(),await this.bb(Z,F,N),this.g.fire(he),Z}this.c.delete(ue)}return M}db(U,N){const j=this.D.has(U)?this.D:this.F.has(U)?this.F:void 0;if(j){const F=j.get(U);j.delete(U),F&&(N.name=F.name??N.name,N.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??N.local,N.privacy=F.privacy??N.privacy)}return N}async eb(U,N,j){const F=j?.label??N.name;let M;(function(X){X[X.None=0]="None",X[X.Fire=1]="Fire",X[X.Reopen=2]="Reopen"})(M||(M={}));let B=M.None;switch(F!==U.name&&(U.name=F,B=M.Fire),(j?.protocol||U.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==U.protocol&&(N.source=U.source,B=M.Reopen),N.privacy&&U.privacy!==N.privacy&&(B=M.Reopen),B){case M.Fire:{this.g.fire();break}case M.Reopen:await this.close(U.remoteHost,U.remotePort,l.User),await this.cb(N,j)}return k(this.f,N.remote.host,N.remote.port)}async name(U,N,j){const F=k(this.forwarded,U,N),M=P(U,N);if(F){F.name=j,await this.$(),this.j.fire({host:U,port:N});return}else this.detected.has(M)&&(this.detected.get(M).name=j,this.j.fire({host:U,port:N}))}async close(U,N,j){const F=P(U,N),M=this.forwarded.get(F);return j===l.AutoForwardEnd&&M&&M.source.source===a.Auto&&this.F.set(F,{local:M.localPort,name:M.name,privacy:M.privacy}),await this.H.closeTunnel(U,N),this.W({host:U,port:N},j)}address(U,N){const j=P(U,N);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(U){if(U)for(const N of U){const j=k(this.m??new Map,N.remoteAddress.host,N.remoteAddress.port),F=typeof N.localAddress=="string"?N.localAddress:P(N.localAddress.host,N.localAddress.port);this.detected.set(P(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:F,protocol:S.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,F,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(U){this.r=U}async setCandidates(U){let N=U;this.r&&(N=await this.r(U));const j=this.fb(N);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(F=>F.port).join(", ")}`),this.n.fire(j)}fb(U){const N=this.m??new Map,j=new Map;return this.m=j,U.forEach(F=>{const M=P(F.host,F.port);j.set(M,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),N.has(M)&&N.delete(M);const B=k(this.forwarded,F.host,F.port);B&&(B.runningProcess=F.detail,B.hasRunningProcess=!0,B.pid=F.pid)}),N.forEach((F,M)=>{const B=s(M);if(!B)return;const X=k(this.forwarded,B.host,B.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0);const ue=k(this.detected,B.host,B.port);ue&&(ue.runningProcess=void 0,ue.hasRunningProcess=!1,ue.pid=void 0)}),N}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const U=Array.from(this.forwarded.values()),N=await this.getAttributes(U.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(N)for(const j of U){const F=N.get(j.remotePort);(F?.protocol||j.protocol!==S.TunnelProtocol.Http)&&F?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},F),F&&F.label&&F.label!==j.name&&await this.name(j.remoteHost,j.remotePort,F.label)}}async getAttributes(U,N=!0){const j=new Map,F=new Map;U.forEach(Z=>{const J=k(this.m??new Map,S.$Dv[0],Z.port)??Z;if(J){j.set(Z.port,J);const Y=w(J)?J.pid:void 0;F.has(Y)||F.set(Y,[]),F.get(Y)?.push(Z.port)}});const M=new Map;if(U.forEach(Z=>{const J=this.configPortsAttributes.getAttributes(Z.port,Z.host,j.get(Z.port)?.detail);J&&M.set(Z.port,J)}),this.G.length===0||!N)return M.size>0?M:void 0;const B=await Promise.all((0,O.$Rb)(this.G.map(Z=>Array.from(F.entries()).map(J=>{const Y=J[1],he=j.get(Y[0]);return Z.providePortAttributes(Y,he?.pid,he?.detail,new i.$5d().token)})))),X=new Map;if(B.forEach(Z=>Z.forEach(J=>{J&&X.set(J.port,J)})),!M&&!X)return;const ue=new Map;return U.forEach(Z=>{const J=M.get(Z.port),Y=X.get(Z.port);ue.set(Z.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??E.providedActionToAction(Y?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),ue}addAttributesProvider(U){this.G.push(U)}};e.$AK=A,Ge([(0,g.$xh)(1e3)],A.prototype,"$",null),e.$AK=A=Ge([We(0,S.$zv),We(1,v.$tp),We(2,y.$yi),We(3,f.$pK),We(4,m.$7k),We(5,h.$bi),We(6,C.$mj),We(7,R.$5v),We(8,o.$xF),We(9,c.$kj)],A)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$jJ=e.$iJ=void 0;class D{constructor(L,b){this.line=L,this.character=b}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,b){return new D(0,0)}with(L){return new D(0,0)}}e.$iJ=D;class O{constructor(L,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(L,b),this.end=new D($,y)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new O(0,0,0,0)}with(L){return new O(0,0,0,0)}}e.$jJ=O;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(ke[36],Se([1,0,19,34,24,33,12,5,16,14,94,11]),function(me,e,D,O,g,I,L,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.SearchErrorCode=e.$yJ=e.$xJ=e.SearchSortOrder=e.ViewMode=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.SearchCompletionExitCode=e.$sJ=e.$rJ=e.$qJ=e.QueryType=e.SearchProviderType=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$kJ="workbench.view.search",e.$lJ="workbench.panel.search",e.$mJ="workbench.view.search",e.$nJ="search-result",e.$oJ="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",S=(m.length+v.length+5)*2;e.$pJ=(0,b.$5h)("searchService");var h;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(h||(e.SearchProviderType=h={}));var f;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(f||(e.QueryType=f={}));function o(Y){return!!Y.preview}e.$qJ=o;function i(Y){return!!Y.resource}e.$rJ=i;function r(Y){return!!Y.message}e.$sJ=r;var n;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class c{constructor(he){this.resource=he,this.results=[]}}e.$tJ=c;class t{constructor(he,_,we,oe){this.ranges=_,this.webviewIndex=oe;const K=Array.isArray(_)?_:[_];if(we&&we.matchLines===1&&u(K)){he=(0,L.$Af)(he,we.matchLines);let W="",re=0,ye=0;const de=Math.floor(we.charsPerLine/5),ge=[];for(const x of K){const te=Math.max(x.startColumn-de,0),G=x.startColumn+we.charsPerLine;if(te>ye+de+S){const ie=m+(te-ye)+v;W+=ie+he.slice(te,G),re+=te-(ye+ie.length)}else W+=he.slice(ye,G);ge.push(new l(0,x.startColumn-re,x.endColumn-re)),ye=G}this.preview={text:W,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const W=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:he,matches:(0,D.$2b)(_,re=>new s(re.startLineNumber-W,re.startColumn,re.endLineNumber-W,re.endColumn))}}}}e.$uJ=t;function u(Y){const he=Y[0].startLineNumber;for(const _ of Y)if(_.startLineNumber!==he||_.endLineNumber!==he)return!1;return!0}class s{constructor(he,_,we,oe){this.startLineNumber=he,this.startColumn=_,this.endLineNumber=we,this.endColumn=oe}}e.$vJ=s;class l extends s{constructor(he,_,we){super(he,_,he,we)}}e.$wJ=l;var a;(function(Y){Y.List="list",Y.Tree="tree"})(a||(e.ViewMode=a={}));var d;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function k(Y,he=!0){const _=Y&&Y.files&&Y.files.exclude,we=he&&Y&&Y.search&&Y.search.exclude;if(!_&&!we)return;if(!_||!we)return _||we;let oe=Object.create(null);return oe=g.$xn(oe,g.$un(_)),oe=g.$xn(oe,g.$un(we),!0),oe}e.$xJ=k;function P(Y,he){return Y.excludePattern&&O.$Kj(Y.excludePattern,he)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&O.$Kj(Y.includePattern,he)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(_=>{const we=_.folder.fsPath;if(I.$7f(he,we)){const oe=$.$lc(we,he);return!_.includePattern||!!O.$Kj(_.includePattern,oe)}else return!1}):!1:!0}e.$yJ=P;var p;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class w extends Error{constructor(he,_){super(he),this.code=_}}e.$zJ=w;function E(Y){const he=Y.message;if((0,y.$4)(Y))return new w(he,p.canceled);try{const _=JSON.parse(he);return new w(_.message,_.code)}catch{return new w(he,p.other)}}e.$AJ=E;function A(Y){const he={message:Y.message,code:Y.code};return new Error(JSON.stringify(he))}e.$BJ=A;function T(Y){return Y.type==="error"?!0:Y.type==="success"}e.$CJ=T;function U(Y){return Y.type==="success"}e.$DJ=U;function N(Y){return!!Y.path}e.$EJ=N;function j(Y,he){const _=Y.searchPath?Y.searchPath:Y.relativePath;return(0,L.$xf)(_,he)}e.$FJ=j;class F{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$GJ=F;function M(Y,he){const _={...Y||{},...he||{}};return Object.keys(_).filter(we=>{const oe=_[we];return typeof oe=="boolean"&&oe})}e.$HJ=M;class B{constructor(he,_){this.c=null,this.a={...he.excludePattern||{},..._.excludePattern||{}},this.b=O.$Lj(this.a);let we=he.includePattern;_.includePattern&&(we?we={...we,..._.includePattern}:we=_.includePattern),we&&(this.c=O.$Lj(we))}matchesExcludesSync(he,_,we){return!!(this.b&&this.b(he,_,we))}includedInQuerySync(he,_,we){return!(this.b&&this.b(he,_,we)||this.c&&!this.c(he,_,we))}includedInQuery(he,_,we){const oe=this.b(he,_,we),K=()=>this.c?!!this.c(he,_,we):!0;return(0,C.$Rg)(oe)?oe.then(W=>W?!1:K()):K()}hasSiblingExcludeClauses(){return X(this.a)}}e.$IJ=B;function X(Y){for(const he in Y)if(typeof Y[he]!="boolean")return!0;return!1}function ue(Y){if(!Y)return;let he;return _=>(he||(he=(Y()||Promise.resolve([])).then(we=>we?J(we):{})),he.then(we=>!!we[_]))}e.$JJ=ue;function Z(Y){if(!Y)return;let he;return _=>{if(!he){const we=Y();he=we?J(we):{}}return!!he[_]}}e.$KJ=Z;function J(Y){const he={};for(const _ of Y)he[_]=!0;return he}}),define(ke[41],Se([1,0,19,11,21,4,3,77,17,122,23,12,2,221,5,13,252,40,58,27,20,15,7,66,36,6,55]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u,s,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0;function d(U,N,j){return new R.$vg(F=>w(F,j)).isEqual(U,N)}function k(U,N,j){return d(U.uri,N.uri,j)?0:(0,C.$4e)(U.uri.toString(),N.uri.toString())}function P(U,N,j){return U.index!==N.index?U.index<N.index?-1:1:d(U.uri,N.uri,j)?(0,C.$4e)(U.name,N.name):(0,C.$4e)(U.uri.toString(),N.uri.toString())}function p(U,N,j,F){const M=U.slice(0).sort((X,ue)=>j(X,ue,F)),B=N.slice(0).sort((X,ue)=>j(X,ue,F));return(0,D.$Eb)(M,B,(X,ue)=>j(X,ue,F))}function w(U,N){const j=N.getCapabilities(U.scheme);return!(j&&j&1024)}class E extends o.$li{static toExtHostWorkspace(N,j,F,M){if(!N)return{workspace:null,added:[],removed:[]};const{id:B,name:X,folders:ue,configuration:Z,transient:J,isUntitled:Y}=N,he=[],_=j;j?ue.forEach((W,re)=>{const ye=m.URI.revive(W.uri),de=E.o(F||j,ye,M);de?(de.name=W.name,de.index=W.index,he.push(de)):he.push({uri:ye,name:W.name,index:re})}):he.push(...ue.map(({uri:W,name:re,index:ye})=>({uri:m.URI.revive(W),name:re,index:ye}))),he.sort((W,re)=>W.index<re.index?-1:1);const we=new E(B,X,he,!!J,Z?m.URI.revive(Z):null,!!Y,W=>w(W,M)),{added:oe,removed:K}=p(_?_.workspaceFolders:[],we.workspaceFolders,k,M);return{workspace:we,added:oe,removed:K}}static o(N,j,F){for(let M=0;M<N.folders.length;M++){const B=N.workspaceFolders[M];if(d(B.uri,j,F))return B}}constructor(N,j,F,M,B,X,ue){super(N,F.map(Z=>new o.$mi(Z)),M,B,ue),this.t=j,this.u=X,this.q=[],this.s=b.$$h.forUris(ue),F.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,j){return j&&this.s.get(N)&&(N=(0,R.$Fg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let A=class{constructor(N,j,F,M,B){this.c=new I.$Ud,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Ud,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Wd,this.B=new Map,this.h=M,this.s=F,this.t=B,this.j=new y.$8l,this.k=new O.$4g,this.o=N.getProxy(l.$5K.MainThreadWorkspace),this.q=N.getProxy(l.$5K.MainThreadMessageService);const X=j.workspace;this.l=X?new E(X.id,X.name,[],!!X.transient,X.configuration?m.URI.revive(X.configuration):null,!!X.isUntitled,ue=>w(ue,F)):void 0}$initializeWorkspace(N,j){this.v=j,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,R.$Dg)((0,R.$Fg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,j,F,...M){const B=[];if(Array.isArray(M)&&M.forEach(Y=>{m.URI.isUri(Y.uri)&&!B.some(he=>d(he.uri,Y.uri,this.s))&&B.push({uri:Y.uri,name:Y.name||(0,R.$Cg)(Y.uri)})}),this.n||[j,F].some(Y=>typeof Y!="number"||Y<0)||F===0&&B.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(j+F>X.length)return!1;const ue=X.slice(0);ue.splice(j,F,...B.map(Y=>({uri:Y.uri,name:Y.name||(0,R.$Cg)(Y.uri),index:void 0})));for(let Y=0;Y<ue.length;Y++){const he=ue[Y];if(ue.some((_,we)=>we!==Y&&d(he.uri,_.uri,this.s)))return!1}ue.forEach((Y,he)=>Y.index=he);const{added:Z,removed:J}=p(X,ue,P,this.s);if(Z.length===0&&J.length===0)return!1;if(this.o){const Y=N.displayName||N.name;this.o.$updateWorkspaceFolders(Y,j,F,B).then(void 0,he=>{this.n=void 0;const _={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(f.Severity.Error,(0,v.localize)(0,null,Y,he.toString()),_,[])})}return this.y(ue),!0}getWorkspaceFolder(N,j){if(this.x)return this.x.getWorkspaceFolder(N,j)}async getWorkspaceFolder2(N,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,j)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,j){let F,M="";if(typeof N=="string"?(F=m.URI.file(N),M=N):typeof N<"u"&&(F=N,M=N.fsPath),!F)return M;const B=this.getWorkspaceFolder(F,!0);if(!B)return M;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let X=(0,R.$Ig)(B.uri,F);return j&&B.name&&(X=`${B.name}/${X}`),X}y(N){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:j,added:F,removed:M}=E.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:M}))}findFiles(N,j,F,M,B=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let X;if(j===null?X=!1:j&&(typeof j=="string"?X=j:X=j.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:Z}=T(c.GlobPattern.from(N));return this.o.$startFileSearch(ue??null,Z??null,X??null,F??null,B).then(J=>Array.isArray(J)?J.map(Y=>m.URI.revive(Y)):[])}async findTextInFiles(N,j,F,M,B=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),ue=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Z,folder:J}=T(c.GlobPattern.from(j.include)),Y=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,he={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:ue,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Z,excludePattern:Y},_=!1;if(this.u[X]=we=>{if(_)return;const oe=m.URI.revive(we.resource);we.results.forEach(K=>{const W=(0,a.$Bh)(K);(0,s.$qJ)(W)?F({uri:oe,preview:{text:W.preview.text,matches:(0,D.$2b)(W.preview.matches,re=>new t.$9K(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,D.$2b)(W.ranges,re=>new t.$9K(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):F({uri:oe,text:W.text,lineNumber:W.lineNumber})})},B.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(N,J??null,he,X,B);return delete this.u[X],we||{}}catch(we){throw delete this.u[X],we}}$handleTextSearchResult(N,j){this.u[j]?.(N)}async save(N){const j=await this.o.$save(N,{saveAs:!1});return m.URI.revive(j)}async saveAs(N){const j=await this.o.$save(N,{saveAs:!0});return m.URI.revive(j)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,j){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,j);const F=this.t.transformOutgoingScheme(N),M=this.z++;return this.o.$registerEditSessionIdentityProvider(M,F),(0,L.$Rc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(N,j){this.h.info("Getting edit session identifier for workspaceFolder",N);const F=await this.resolveWorkspaceFolder(m.URI.revive(N));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const M=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!M),!M)return;const B=await M.provideEditSessionIdentity(F,j);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(N,j,F,M){this.h.info("Getting edit session identifier for workspaceFolder",N);const B=await this.resolveWorkspaceFolder(m.URI.revive(N));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const X=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!X),!X)return;const ue=await X.provideEditSessionIdentityMatch?.(j,F,M);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(N){return(j,F,M)=>{const B=function(ue){j.call(F,ue)};return B.extension=N,this.A.event(B,void 0,M)}}async $onWillCreateEditSessionIdentity(N,j,F){const M=await this.resolveWorkspaceFolder(m.URI.revive(N));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:M},j,async(B,X)=>{const ue=Date.now();await Promise.resolve(B),Date.now()-ue>F&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(N,j){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,j);const F=this.t.transformOutgoingScheme(N),M=this.z++;return this.o.$registerCanonicalUriProvider(M,F),(0,L.$Rc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(N,j,F){const M=this.B.get(N.scheme);if(!M)return;const B=await M.provideCanonicalUri?.(m.URI.revive(N),j,F);if(B)return B}async $provideCanonicalUri(N,j,F){return this.provideCanonicalUri(m.URI.revive(N),{targetScheme:j},F)}};e.$egc=A,e.$egc=A=Ge([We(0,n.$9M),We(1,r.$mN),We(2,i.$Wfc),We(3,h.$mj),We(4,u.$cgc)],A),e.$fgc=(0,S.$5h)("IExtHostWorkspace");function T(U){let N,j;return U&&(typeof U=="string"?N=U:(N=U.pattern,j=m.URI.revive(U.baseUri))),{includePattern:N,folder:j}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,86,18,11,5,20,13,2]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=e.$ggc=void 0;function h(u,s){if(s){const l=s.split(".");let a=u;for(let d=0;a&&d<l.length;d++)a=a[l[d]];return a}}function f(u){return u instanceof S.URI}function o(u){return u&&u.uri instanceof S.URI&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function r(u){return u&&u.uri instanceof S.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function n(u){if(f(u))return{resource:u};if(o(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(i(u))return{overrideIdentifier:u.languageId};if(r(u))return{resource:u.uri};if(u===null)return{resource:null}}let c=class{constructor(s,l,a){this.a=s.getProxy(I.$5K.MainThreadConfiguration),this.c=l,this.b=a,this.d=new R.$4g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,l){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,l))}};e.$ggc=c,e.$ggc=c=Ge([We(0,m.$9M),We(1,g.$fgc),We(2,v.$mj)],c);class t{constructor(s,l,a,d){this.a=new O.$Ud,this.b=s,this.f=d,this.c=l,this.e=b.$5n.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,l){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$5n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(l,a))}getConfiguration(s,l,a){const d=n(l)||{},k=this.g(s?h(this.e.getValue(void 0,d,this.c.workspace),s):this.e.getValue(void 0,d,this.c.workspace));s&&this.h(s,d,a?.identifier);function P(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(w){return typeof h(k,w)<"u"},get:(w,E)=>{this.h(s?`${s}.${w}`:w,d,a?.identifier);let A=h(k,w);if(typeof A>"u")A=E;else{let T;const U=(N,j)=>{if((0,y.$Jf)(N)){let F;const M=()=>{T=T||(0,D.$un)(k),F=F||h(T,j)};return new Proxy(N,{get:(B,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return M(),()=>F;if(T)return F=F||h(T,j),F[X];const ue=B[X];return typeof X=="string"?U(ue,`${j}.${X}`):ue},set:(B,X,ue)=>(M(),F&&(F[X]=ue),!0),deleteProperty:(B,X)=>(M(),F&&delete F[X],!0),defineProperty:(B,X,ue)=>(M(),F&&Object.defineProperty(F,X,ue),!0)})}return Array.isArray(N)?(0,D.$un)(N):N};A=U(A,w)}return A},update:(w,E,A,T)=>{w=s?`${s}.${w}`:w;const U=P(A);return E!==void 0?this.b.$updateConfigurationOption(U,w,E,d,T):this.b.$removeConfigurationOption(U,w,d,T)},inspect:w=>{w=s?`${s}.${w}`:w;const E=this.e.inspect(w,d,this.c.workspace);if(E)return{key:w,defaultValue:(0,D.$un)(E.policy?.value??E.default?.value),globalValue:(0,D.$un)(E.user?.value??E.application?.value),workspaceValue:(0,D.$un)(E.workspace?.value),workspaceFolderValue:(0,D.$un)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$un)(E.default?.override),globalLanguageValue:(0,D.$un)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$un)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$un)(E.workspaceFolder?.override),languageIds:(0,D.$un)(E.overrideIdentifiers)}}};return typeof k=="object"&&(0,D.$xn)(p,k,!1),Object.freeze(p)}g(s){const l=a=>(0,y.$Jf)(a)?new Proxy(a,{get:(d,k)=>l(d[k]),set:(d,k,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(d,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(d,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return l(s)}h(s,l,a){const d=$.$Vn.test(s)?4:this.d.get(s),k=a?`[${a.value}] `:"";if(d===4){typeof l?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){l?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,l){const a=new b.$7n(s,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,k)=>a.affectsConfiguration(d,n(k))})}k(s){return s.reduce((l,a)=>(l.set(a[0],a[1]),l),new Map)}}e.$hgc=t,e.$igc=(0,C.$5h)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,11,4,6,7,41,69,42,21,47,20,27,5,17,10,13,91,302,14]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=e.$Jhc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(U){function N(F){if(F!=null)return F}U.from=N;function j(F){if(F!=null)return F}U.to=j})(c||(c={}));var t;(function(U){function N(F){if(F!=null)return F}U.from=N;function j(F){if(F!=null)return F}U.to=j})(t||(t={}));var u;(function(U){function N(F){if(F!=null)return F}U.from=N;function j(F){if(F!=null)return F}U.to=j})(u||(u={}));var s;(function(U){function N(M){if(M){const B=M;return B&&!!B.process}else return!1}U.is=N;function j(M){if(M==null)return;const B={process:M.process,args:M.args};return M.options&&(B.options=u.from(M.options)),B}U.from=j;function F(M){if(M!=null)return new L.$PL(M.process,M.args,M.options)}U.to=F})(s||(s={}));var l;(function(U){function N(F){if(F!=null)return F}U.from=N;function j(F){if(F!=null)return F}U.to=j})(l||(l={}));var a;(function(U){function N(M){if(M){const B=M;return B&&(!!B.commandLine||!!B.command)}else return!1}U.is=N;function j(M){if(M==null)return;const B={};return M.commandLine!==void 0?B.commandLine=M.commandLine:(B.command=M.command,B.args=M.args),M.options&&(B.options=l.from(M.options)),B}U.from=j;function F(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$QL(M.commandLine,M.options):new L.$QL(M.command,M.args?M.args:[],M.options)}U.to=F})(a||(a={}));var d;(function(U){function N(M){if(M){const B=M;return B&&B.customExecution==="customExecution"}else return!1}U.is=N;function j(M){return{customExecution:"customExecution"}}U.from=j;function F(M,B){return B.get(M)}U.to=F})(d||(e.CustomExecutionDTO=d={}));var k;(function(U){function N(j,F){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&F&&F.workspaceFile?M=F.workspaceFile:M=r.$xG),{id:j._id,workspaceFolder:M}}U.from=N})(k||(e.TaskHandleDTO=k={}));var P;(function(U){function N(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}U.from=N})(P||(P={}));var p;(function(U){function N(M,B){if(M==null)return[];const X=[];for(const ue of M){const Z=j(ue,B);Z&&X.push(Z)}return X}U.fromMany=N;function j(M,B){if(M==null)return;let X;M.execution instanceof L.$PL?X=s.from(M.execution):M.execution instanceof L.$QL?X=a.from(M.execution):M.execution&&M.execution instanceof L.$RL&&(X=d.from(M.execution));const ue=c.from(M.definition);let Z;return M.scope?typeof M.scope=="number"?Z=M.scope:Z=M.scope.uri:Z=L.TaskScope.Workspace,!ue||!Z?void 0:{_id:M._id,definition:ue,name:M.name,source:{extensionId:B.identifier.value,label:M.source,scope:Z},execution:X,isBackground:M.isBackground,group:P.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}U.from=j;async function F(M,B,X){if(M==null)return;let ue;s.is(M.execution)?ue=s.to(M.execution):a.is(M.execution)?ue=a.to(M.execution):d.is(M.execution)&&(ue=d.to(M._id,X));const Z=c.to(M.definition);let J;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?J=M.source.scope:J=await B.resolveWorkspaceFolder(D.URI.revive(M.source.scope)):J=L.TaskScope.Workspace),!Z||!J)return;const Y=new L.$SL(Z,J,M.name,M.source.label,ue,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=L.$OL.from(M.group._id),Y.group&&M.group.isDefault&&(Y.group=new L.$OL(Y.group.id,Y.group.label),M.group.isDefault===!0&&(Y.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Y.presentationOptions=t.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}U.to=F})(p||(e.TaskDTO=p={}));var w;(function(U){function N(F){return F}U.from=N;function j(F){if(F)return Object.assign(Object.create(null),F)}U.to=j})(w||(w={}));class E{#e;constructor(N,j,F){this._id=j,this.a=F,this.#e=N}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let A=class{constructor(N,j,F,M,B,X,ue,Z){this.q=new g.$Ud,this.r=new g.$Ud,this.s=new g.$Ud,this.u=new g.$Ud,this.a=N.getProxy(I.$5K.MainThreadTask),this.b=F,this.c=M,this.d=B,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,j,F){if(!F)return new L.$7K(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:F,extension:N}),this.a.$registerTaskProvider(M,j),new L.$7K(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(N,j){this.a.$registerTaskSystem(N,j)}fetchTasks(N){return this.a.$fetchTasks(w.from(N)).then(async j=>{const F=[];for(const M of j){const B=await p.to(M,this.b,this.m);B&&F.push(B)}return F})}get taskExecutions(){const N=[];return this.k.forEach(j=>N.push(j)),N}terminateTask(N){if(!(N instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,j,F){const M=this.m.get(N.id);M&&(this.o.set(N.id,M),this.e.attachPtyToTerminal(j,await M.callback(F))),this.p=N.id,this.q.fire({execution:await this.z(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){if(!this.l.has(N.id))return;const j=await this.z(N);this.l.delete(N.id),this.k.delete(N.id),this.B(N),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const j=await this.z(N.id);this.s.fire({execution:j,processId:N.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(N){const j=await this.z(N.id);this.u.fire({execution:j,exitCode:N.exitCode})}$provideTasks(N,j){const F=this.j.get(N);if(!F)return Promise.reject(new Error("no handler found"));const M=[],B=(0,O.$Xg)(()=>F.provider.provideTasks(R.CancellationToken.None)).then(X=>this.v(j,M,F,X));return new Promise(X=>{B.then(ue=>{Promise.all(M).then(()=>{X(ue)})})})}async $resolveTask(N,j){const F=this.j.get(N);if(!F)return Promise.reject(new Error("no handler found"));if(j.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${F.type}].`);const M=await p.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const B=await F.provider.resolveTask(M,R.CancellationToken.None);if(!B)return;this.A(B,F);const X=p.from(B,F.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(X.execution)&&await this.y(X,B,!0),await this.w(X)}x(){return this.h++}async y(N,j,F){const M=await this.a.$createTaskId(N);!F&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(N,j){if(typeof N=="string"){const B=this.l.get(N);if(!B)throw new n.$bb("Unexpected: The specified task is missing an execution");return B}const F=this.l.get(N.id);if(F)return F;let M;return j?M=Promise.resolve(new E(this,N.id,j)):M=p.to(N.task,this.b,this.m).then(B=>{if(!B)throw new n.$bb("Unexpected: Task does not exist.");return new E(this,N.id,B)}),this.l.set(N.id,M),M.then(B=>(this.k.set(N.id,B),B))}A(N,j){N._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const F=this.n.values();let M=F.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=F.next()}};e.$Jhc=A,e.$Jhc=A=Ge([We(0,m.$9M),We(1,v.$mN),We(2,b.$fgc),We(3,$.$hN),We(4,y.$igc),We(5,C.$Ggc),We(6,o.$mj),We(7,i.$Zfc)],A);let T=class extends A{constructor(N,j,F,M,B,X,ue,Z){super(N,j,F,M,B,X,ue,Z),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(N,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const F=p.from(j,N);if(F===void 0)throw new Error("Task is not valid");if(d.is(F.execution))await this.y(F,j,!1);else throw new n.$_;const M=await this.z(await this.a.$getTaskExecution(F),j);return this.a.$executeTask(F).catch(B=>{throw new Error(B)}),M}v(N,j,F,M){const B=[];if(M)for(const X of M){if(this.A(X,F),!X.definition||!N[X.definition.type]){const Z=X.source?X.source:"No task source";this.f.warn(`The task [${Z}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=p.from(X,F.extension);ue&&d.is(ue.execution)?(B.push(ue),j.push(this.y(ue,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:F.extension}}async w(N){if(d.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,j,F){}};e.$Khc=T,e.$Khc=T=Ge([We(0,m.$9M),We(1,v.$mN),We(2,b.$fgc),We(3,$.$hN),We(4,y.$igc),We(5,C.$Ggc),We(6,o.$mj),We(7,i.$Zfc)],T),e.$Lhc=(0,S.$5h)("IExtHostTask")}),define(ke[358],Se([1,0,36,29]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.$QJ=void 0;function g(L){return"cellResults"in L}e.$QJ=g,e.$RJ="rawCell#";function I(L,b){let $=-1;const y=[];let R=[];return L.forEach(m=>{m.range.startLineNumber!==$&&R.length>0&&(y.push([...R]),R=[]),R.push(m),$=m.range.endLineNumber}),R.length>0&&y.push([...R]),y.map(m=>{const v=[],S=m[0].range.startLineNumber,h=m[m.length-1].range.endLineNumber;for(let f=S;f<=h;f++)v.push(b.getLineContent(f));return new D.$uJ(v.join(`
`)+`
`,m.map(f=>new O.$Ts(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$SJ=I}),define(ke[359],Se([1,0,215,22,4,3,28,12,18,2,32,110,6,35,15,7,68,294,146,24,17,286,358,355]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,d,k,P,p,w){this.q=k,this.r=P,this.s=p,this.t=w,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new g.$Ud,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Ud,this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Ud,this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Ud,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$Sfc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(m.$5K.MainThreadNotebook),this.c=a.getProxy(m.$5K.MainThreadNotebookDocuments),this.d=a.getProxy(m.$5K.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const A=E.notebookEditor?.notebookUri,T=E.cell.handle,N=this.g.get(A)?.getCell(T);if(N)return N.apiCell}if(E&&E.$mid===14){const A=E.uri,T=this.g.get(A);if(T)return T.apiNotebook}return E}}),s.B(d)}getEditorById(a){const d=this.h.get(a);if(!d)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(a){for(const[d,k]of this.h)if(k.apiEditor===a)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,d){const k=this.g.get(a);if(!k&&!d)throw new Error(`NO notebook document for '${a}'`);return k}static u(a,d){if(!d)return;const k=d.filenamePattern.map(P=>S.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(d.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:d.displayName,filenamePattern:k,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,d,k){const P=s.a++,p=typeof k.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(P,k),this.b.$registerNotebookCellStatusBarItemProvider(P,p,d);let w;return p!==void 0&&(w=k.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(p))),new h.$7K(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,p),w?.dispose()})}async createNotebookDocument(a){const d=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&S.NotebookData.from(a.content)});return y.URI.revive(d)}async openNotebookDocument(a){const d=this.g.get(a);if(d)return d.apiNotebook;const k=await this.c.$tryOpenNotebook(a),P=this.g.get(y.URI.revive(k));return(0,$.$Sf)(P?.apiNotebook)}async showNotebookDocument(a,d){y.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let k;typeof d=="object"?k={position:S.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(S.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:k={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,k),p=P&&this.h.get(P)?.apiEditor;if(p)return p;throw P?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,d,k,P){const p=this.f.get(a),w=y.URI.revive(d),E=this.g.get(w);if(!E||!p)return;const A=E.getCellFromIndex(k);if(!A)return;const T=await p.provideCellStatusBarItems(A.apiCell,P);if(!T)return;const U=new I.$Sc,N=this.p.add([U]),F=(Array.isArray(T)?T:[T]).map(M=>S.NotebookStatusBarItem.from(M,this.i,U));return{cacheId:N,items:F}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,d,k,P,p){if((0,b.$Ie)(d))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:d,serializer:k,options:P}),this.b.$registerNotebookSerializer(w,{id:a.identifier,location:a.extensionLocation},d,S.NotebookDocumentContentOptions.from(P),s.u(a,p)),(0,I.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(a,d,k){const P=this.x.get(a);if(!P)throw new Error("NO serializer found");const p=await P.serializer.deserializeNotebook(d.buffer,k);return new f.$Sv(S.NotebookData.from(p))}async $notebookToData(a,d,k){const P=this.x.get(a);if(!P)throw new Error("NO serializer found");const p=await P.serializer.serializeNotebook(S.NotebookData.to(d.value),k);return O.$ie.wrap(p)}async $saveNotebook(a,d,k,P,p){const w=y.URI.revive(d),E=this.x.get(a);if(!E)throw new Error("NO serializer found");const A=this.g.get(w);if(!A)throw new Error("Document NOT found");if(A.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new R.$Kk((0,D.localize)(0,null,this.z(w)),6);await this.y(w,P);const T={metadata:(0,r.$Cn)(A.apiNotebook.metadata,M=>!(E.options?.transientDocumentMetadata??{})[M]),cells:[]};for(const M of A.apiNotebook.getCells()){const B=new h.$tM(M.kind,M.document.getText(),M.document.languageId,M.mime,E.options?.transientOutputs?[]:[...M.outputs],M.metadata,M.executionSummary);B.metadata=(0,r.$Cn)(M.metadata,X=>!(E.options?.transientCellMetadata??{})[X]),T.cells.push(B)}const U=await E.serializer.serializeNotebook(T,p);await this.s.value.writeFile(w,U);const N=this.s.getFileSystemProviderExtUri(w.scheme),j=await this.s.value.stat(w);return{name:N.basename(w),isFile:(j.type&R.FileType.File)!==0,isDirectory:(j.type&R.FileType.Directory)!==0,isSymbolicLink:(j.type&R.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((j.permissions??0)&R.FilePermission.Locked),etag:R.$Vk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(a,d,k,P,p){const w=this.x.get(a)?.serializer;if(!w)return{limitHit:!1,results:[]};const E=new L.$Bc;await(async(j,F,M)=>{await Promise.all(j.map(async B=>await Promise.all(B.filenamePatterns.map(X=>{const ue={_reason:M._reason,folderQueries:M.folderQueries,includePattern:M.includePattern,excludePattern:M.excludePattern,maxResults:M.maxResults,type:1,filePattern:X};return this.t.doInternalFileSearchWithCustomCallback(ue,F,Z=>{Z.forEach(J=>{E.has(J)||P.some(he=>B.isFromSettings&&!he.isFromSettings?!1:he.filenamePatterns.some(_=>(0,u.$ddb)(_,J)))||E.add(J)})})}))))})(k,p,d);const T=new L.$Ac;let U=!1;const N=Array.from(E).map(async j=>{const F=[];try{if(p.isCancellationRequested)return;if(d.maxResults&&[...T.values()].reduce((ue,Z)=>ue+Z.cellResults.length,0)>d.maxResults){U=!0;return}const M=[],B=this.g.get(j);if(B)B.apiNotebook.getCells().forEach(Z=>M.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(J=>J.items.map(Y=>Y.data.toString()))}));else{const ue=await this.s.value.readFile(j),Z=O.$ie.fromString(ue.toString()),J=await w.deserializeNotebook(Z.buffer,p);if(p.isCancellationRequested)return;S.NotebookData.from(J).cells.forEach(he=>M.push({input:he.source,outputs:he.outputs.flatMap(_=>_.items.map(we=>we.valueBytes.toString()))}))}if(p.isCancellationRequested)return;M.forEach((ue,Z)=>{const J=d.contentPattern.pattern,Y=new c.$DQb(ue.input,void 0,ue.outputs),he=Y.findInInputs(J),_=Y.findInOutputs(J),we=_.flatMap(oe=>(0,t.$SJ)(oe.matches,oe.textBuffer)).map((oe,K)=>(oe.webviewIndex=K,oe));if(he.length>0||_.length>0){const oe={index:Z,contentResults:(0,t.$SJ)(he,Y.inputTextBuffer),webviewResults:we};F.push(oe)}});const X={resource:j,cellResults:F};T.set(j,X);return}catch{return}});return await Promise.all(N),{limitHit:U,results:[...T.values()]}}async y(a,d){const k=await this.s.value.stat(a);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==R.$Uk&&typeof k.mtime=="number"&&typeof k.size=="number"&&d.mtime<k.mtime&&d.etag!==R.$Vk({mtime:d.mtime,size:k.size}))throw new R.$Kk((0,D.localize)(1,null),3,d)}z(a){return a.scheme===n.Schemas.file?a.fsPath:a.toString()}A(a,d,k){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const P=new i.$chc(d,this.d,a,k.visibleRanges.map(S.NotebookRange.to),k.selections.map(S.NotebookRange.to),typeof k.viewColumn=="number"?S.ViewColumn.to(k.viewColumn):void 0);this.h.set(d,P)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const k of a.value.removedDocuments){const P=y.URI.revive(k),p=this.g.get(P);p&&(p.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(p.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===P.toString()&&this.h.delete(w.id)}if(a.value.addedDocuments){const k=[];for(const P of a.value.addedDocuments){const p=y.URI.revive(P.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const w=new o.$bhc(this.c,this.q,this.r,p,P);k.push(...P.cells.map(E=>o.$ahc.asModelAddData(w.apiNotebook,E))),this.g.get(p)?.dispose(),this.g.set(p,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(w.apiNotebook)}}if(a.value.addedEditors)for(const k of a.value.addedEditors){if(this.h.has(k.id))return;const P=y.URI.revive(k.documentUri),p=this.g.get(P);p&&this.A(p,k.id,k)}const d=[];if(a.value.removedEditors)for(const k of a.value.removedEditors){const P=this.h.get(k);P&&(this.h.delete(k),this.k?.id===P.id&&(this.k=void 0),d.push(P))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const k=new Set;this.l.forEach(P=>k.add(P.id));for(const P of this.h.values()){const p=k.has(P.id);P._acceptVisibility(p)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const d=v.$uN.String.with("notebookType","A notebook type"),k=new v.$wN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new v.$uN("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>O.$ie.wrap(p))],new v.$vN("Notebook Data",p=>S.NotebookData.to(p.value))),P=new v.$wN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new v.$uN("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new f.$Sv(S.NotebookData.from(p)))],new v.$vN("Bytes",p=>p.buffer));a.registerApiCommand(k),a.registerApiCommand(P)}}e.$lhc=s}),define(ke[360],Se([1,0,16,21,44,34,23,38,36]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class y{constructor(m,v,S){this.k=m,this.l=v,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Lj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Lj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((S,h)=>{const f=o=>{this.f++,m(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),r=D.$nc(i);this.j&&this.j(i,r)||this.v(f,{base:o,basename:r})}),Promise.all(v.map(o=>this.p(o,f))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{h(new Error((0,g.$Pi)(o)))})})}async p(m,v){const S=new O.$5d,h=this.q(m),f=this.r(),o=new $.$IJ(this.k,m),i=!o.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=b.$Qd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,S.token),c=r.elapsed(),t=b.$Qd.create();return this.g&&!this.e||(n&&n.forEach(u=>{const s=D.$gc.relative(m.folder.path,u.path);if(i){const l=D.$nc(u.path);this.v(v,{base:m.folder,relativePath:s,basename:l});return}this.s(f,m.folder,s,v)}),this.g&&!this.e)?null:(this.u(f,o,v),{providerTime:c,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(m){const v=(0,$.$HJ)(this.k.includePattern,m.includePattern),S=(0,$.$HJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,S,h){if(S===this.a){const o=D.$nc(this.a);this.v(h,{base:v,relativePath:this.a,basename:o})}function f(o){const i=D.$nc(o),r=D.$mc(o);let n=m[r];n||(n=m[r]=[],f(r)),n.push({base:v,relativePath:o,basename:i})}f(S)}u({rootEntries:m,pathToEntries:v},S,h){const f=this,o=this.a;function i(r){const n=(0,$.$KJ)(()=>r.map(c=>c.basename));for(let c=0,t=r.length;c<t;c++){const u=r[c],{relativePath:s,basename:l}=u;if(S.matchesExcludesSync(s,l,o!==l?n:void 0))continue;const a=v[s];if(a)i(a);else{if(s===o)continue;f.v(h,u)}if(f.e)break}}i(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,v,S,h){const f=this.c(m.cacheKey),o=new y(m,v,f&&f.token);let i=0;const r=n=>{i+=n.length,S(n.map(c=>this.d(c)))};return this.e(o,R.a,r,h).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new O.$5d),this.b.get(m)}d(m){return m.relativePath?{resource:L.$Gg(m.base,m.relativePath)}:{resource:m.base}}e(m,v,S,h){const f=h.onCancellationRequested(()=>{m.cancel()}),o=r=>{r&&(i.push(r),v>0&&i.length>=v&&(S(i),i=[]))};let i=[];return m.search(o).then(r=>(i.length&&S(i),f.dispose(),r),r=>(i.length&&S(i),f.dispose(),Promise.reject(r)))}}e.$dhc=R}),define(ke[361],Se([1,0,19,73,34,102,28,17,16,23,12,18,2,99,235,45,13,40,143,356,36]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JK=e.$IK=void 0;let c=class{constructor(w,E,A,T,U){this.a=w,this.b=E,this.c=A,this.d=T,this.e=U}text(w,E,A={}){w=this.f(w,A);const T=this.a.getValue(),U=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(o.$ni),A),type:2,contentPattern:w,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:T.search.usePCRE2||U||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(w,E){const A=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const T={...w,wordSeparators:A.editor.wordSeparators};return this.j(w,E)&&(T.isCaseSensitive=!0),this.k(w)&&(T.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),T}file(w,E={}){return{...this.h(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(w,E){return w?(w=Array.isArray(w)?w.map(a):a(w),E?this.parseSearchPaths(w):{pattern:u(...Array.isArray(w)?w:[w])}):{}}h(w=[],E={}){const A=this.g(E.includePattern,E.expandPatterns),T=this.g(E.excludePattern,E.expandPatterns),U=w.length>1,N=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(M=>this.q(M,E,T)):w.map(M=>this.r(M,E,T,U))).filter(M=>!!M),j={_reason:E._reason,folderQueries:N,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:T.pattern,includePattern:A.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const M=D.$Hb(D.$Rb(this.c.groups.map(ue=>ue.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const B=M.filter(ue=>(0,n.$yJ)(j,ue.fsPath)),X=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...j,...X}}const F=E.extraFileResources&&E.extraFileResources.filter(M=>(0,n.$yJ)(j,M.fsPath));return j.extraFileResources=F&&F.length?F:void 0,j}i(w){const E=[],A=new L.$Ac,T={};let U=!1;return w.forEach(N=>{if(N.scheme===b.Schemas.walkThrough)return;if((0,y.$Kg)(N)){const F=this.b.getWorkspaceFolder(N)?.uri??N.with({path:$.$mc(N.fsPath)});let M=A.get(F);M||(U=!0,M={folder:F,includePattern:{}},E.push(M),A.set(F,M));const B=$.$lc(F.fsPath,N.fsPath);(0,C.$Sf)(M.includePattern)[B.replace(/\\/g,"/")]=!0}else N.fsPath&&(U=!0,T[N.fsPath]=!0)}),{folderQueries:E,includePattern:T,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(w,E){if(E.isSmartCase){if(w.isRegExp){if(R.$yf(w.pattern,!0))return!0}else if(R.$yf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,v.$3B)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=X=>$.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),T=(Array.isArray(w)?w:s(w)).map(X=>{const ue=this.e.resolvedUserHome;return ue?(0,I.$Xv)(X,ue.scheme===b.Schemas.file?ue.fsPath:ue.path):X}),U=O.$K(T,X=>E(X)?"searchPaths":"exprSegments"),N=(U.exprSegments||[]).map(X=>R.$Te(X,"/")).map(X=>R.$Te(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),l(X))),j={},F=this.m(U.searchPaths||[]);F&&F.length&&(j.searchPaths=F);const M=D.$Rb(N),B=u(...M);return B&&(j.pattern=B),j}l(w,E){return E.disregardExcludeSettings?void 0:(0,n.$xJ)(w,!E.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const E=w.flatMap(T=>{let{pathPortion:U,globPortion:N}=t(T);return N&&(N=d(N)),this.n(U).flatMap(F=>this.o(F,N))}),A=new Map;return E.forEach(T=>{const U=T.searchPath.toString(),N=A.get(U);N?T.pattern&&(N.pattern=N.pattern||{},N.pattern[T.pattern]=!0):A.set(U,{searchPath:T.searchPath,pattern:T.pattern?u(T.pattern):void 0})}),Array.from(A.values())}n(w){if($.$ic(w)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:m.URI.file($.$hc(w))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(w=a(w),w.startsWith("../")||w===".."){const T=$.$gc.resolve(E.path,w);return[{searchPath:E.with({path:T})}]}const A=d(w);return[{searchPath:E,pattern:A}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(U=>{const N=E.match(new RegExp(`^${R.$Ne(U.name)}(?:/(.*)|$)`));return N?{match:N,folder:U}:null}).filter(C.$Pf);if(T.length)return T.map(U=>{const N=U.match[1];return{searchPath:U.folder.uri,pattern:N&&d(N)}});{const U=w.match(/\.[\/\\](.+)[\/\\]?/),N=U?U[1]:w,j=S.localize(0,null,N);throw new Error(j)}}}}o(w,E){const A=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,T=[{searchPath:w.searchPath,pattern:A}];return A&&!A.endsWith("**")&&T.push({searchPath:w.searchPath,pattern:A+"/**"}),T}q(w,E,A){const T=this.r((0,o.$ni)(w.searchPath),E,A,!1);return T?{...T,includePattern:w.pattern}:null}r(w,E,A,T){let U;const N=m.URI.isUri(w)?w:w.uri;if(A.searchPaths){const X=A.searchPaths.filter(ue=>(0,y.$zg)(ue.searchPath,N))[0];if(X&&!X.pattern)return null;X&&(U=X.pattern)}const j=this.a.getValue({resource:N}),M={...this.l(j,E)||{},...U||{}},B=m.URI.isUri(w)?(0,y.$Dg)(w):w.name;return{folder:N,folderName:T?B:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$IK=c,e.$IK=c=Ge([We(0,h.$yi),We(1,o.$bi),We(2,i.$8C),We(3,f.$mj),We(4,r.$GK)],c);function t(p){const w=p.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,A=p.substr(0,E).match(/[/|\\][^/\\]*$/);if(A){let T=p.substr(0,A.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:p.substr((A.index||0)+1)}}}return{pathPortion:p}}function u(...p){return p.length?p.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function s(p){return g.$Jj(p,",").map(w=>w.trim()).filter(w=>!!w.length)}function l(p){return[`**/${p}/**`,`**/${p}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function a(p){return p.replace(/\\/g,"/")}function d(p){return a(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(p){return p.replace(/([?*[\]])/g,"[$1]")}function P(p,w){p=D.$Mb(p,T=>T.toString());const E=[],A=w.getWorkspace();return p&&p.forEach(T=>{let U;if(w.getWorkbenchState()===2)U=(0,y.$Ig)(A.folders[0].uri,T),U&&U!=="."&&(U="./"+U);else{const N=w.getWorkspaceFolder(T);if(N){const j=N.name;if(A.folders.filter(M=>M.name===j).length===1){const M=(0,y.$Ig)(N.uri,T);M===""?U=`./${N.name}`:U=`./${N.name}/${M}`}else U=T.fsPath}}U&&E.push(k(U))}),E}e.$JK=P}),define(ke[362],Se([1,0,23,2,21,14,5,361,36,40]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsb=e.$msb=void 0;const R=7e3;function C(h,f){const o=f.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],r=[];for(const l of o)if(/^workspaceContains:/.test(l)){const a=l.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||h.forceUsingSearch?r.push(a):i.push(a)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);let n;const c=new Promise((l,a)=>{n=l}),t=l=>n({activationEvent:l}),u=Promise.all(i.map(l=>m(h,l,t))).then(()=>{}),s=v(h,f.identifier,r,t);return Promise.all([u,s]).then(()=>{n(void 0)}),c}e.$msb=C;async function m(h,f,o){for(const i of h.folders)if(await h.exists(D.$Gg(O.URI.revive(i),f))){o(`workspaceContains:${f}`);return}}async function v(h,f,o,i){if(o.length===0)return Promise.resolve(void 0);const r=new g.$5d,n=h.checkExists(h.folders,o,r.token),c=setTimeout(async()=>{r.cancel(),h.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let t=!1;try{t=await n}catch(u){I.$4(u)||I.$1(u)}r.dispose(),clearTimeout(c),t&&i(`workspaceContains:${o.join(",")}`)}function S(h,f,o,i){const r=h.get(L.$4h),n=h.get($.$pJ),t=r.createInstance(b.$IK).file(f.map(u=>(0,y.$ni)(O.URI.revive(u))),{_reason:"checkExists",includePattern:o,exists:!0});return n.fileSearch(t,i).then(u=>!!u.limitHit,u=>I.$4(u)?!1:Promise.reject(u))}e.$nsb=S}),define(ke[48],Se([1,0,212,16,57,23,11,3,77,2,13,6,42,292,118,41,25,145,14,26,22,271,7,64,5,27,92,20,107,72,47,4,362,117,273,17,115,38,10,116]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u,s,l,a,d,k,P,p,w,E,A,T,U,N,j,F,M){"use strict";var B;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=void 0,e.$Rgc=(0,s.$5h)("IHostUtils");let X=B=class extends b.$Tc{constructor(K,W,re,ye,de,ge,x,te,G,ie,fe,ve){super(),this.X=ve,this.a=this.B(new w.$Ud),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=re,this.f=x,this.j=ye,this.m=de,this.s=ge,this.t=G,this.u=ie,this.w=fe,this.y=this.g.getProxy(C.$5K.MainThreadWorkspace),this.z=this.g.getProxy(C.$5K.MainThreadTelemetry),this.C=this.g.getProxy(C.$5K.MainThreadExtensionService),this.D=new L.$4g,this.F=new L.$4g,this.G=new L.$4g,this.H=new L.$4g,this.I=new we(this.f.extensions.activationEvents),this.L=new o.$97b(this.I,this.f.extensions.allExtensions);const Pe=new r.$lm(this.f.extensions.myExtensions);this.J=new o.$97b(this.I,he(this.L,Pe)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new S.$Cgc(this.g,this.s),this.N=new A.$Kgc(this.g),this.O=te,this.h=K.createChild(new k.$3h([S.$Dgc,this.M],[A.$Lgc,this.N])),this.P=this.B(new v.$Bgc(this.J,this.L,{onExtensionActivationError:(be,De,z)=>{this.C.$onExtensionActivationError(be,i.$3(De),z)},actualActivateExtension:async(be,De)=>{if(o.$97b.isHostExtension(be,this.J,this.L))return await this.C.$activateExtension(be,De),new v.$Agc;const z=this.J.getExtensionDescription(be);return this.db(z,De)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(K)}terminate(K,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const re=this.Y();Promise.race([(0,L.$6g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const W=await this.C.$getExtension(K);return W&&{...W,identifier:new r.$km(W.identifier.value),extensionLocation:y.URI.revive(W.extensionLocation)}}Z(K,W){return this.P.activateByEvent(K,W)}$(K,W){return this.P.activateById(K,W)}activateByIdWithErrors(K,W){return this.$(K,W).then(()=>{const re=this.P.getActivatedExtension(K);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===U.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(K.fsPath);return y.URI.file(W)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new _(K))),this.Q}async bb(K){const W=$.$$h.forUris(re=>I.$xg.ignorePathCasing(re));return await Promise.all(K.map(async re=>{if(this.ub(re)){const ye=await this.ab(re.extensionLocation);W.set(ye,re)}})),W}cb(K){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return W;const re=this.P.getActivatedExtension(K);if(!re)return W;try{typeof re.module.deactivate=="function"&&(W=Promise.resolve(re.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,b.$Oc)(re.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return W}async db(K,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,W).then(re=>{const ye=re.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,W),this.eb(K,W,"success",ye),re},re=>{throw this.eb(K,W,"failure"),re})}eb(K,W,re,ye){const de=Z(K,W);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:re})}fb(K,W){const re=Z(K,W);this.z.$publicLog2("activatePlugin",re);const ye=this.ub(K);if(!ye)return Promise.resolve(new v.$zgc(v.$wgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${K.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const de=new v.$xgc(W.startup);return Promise.all([this.vb(K,(0,I.$Gg)(K.extensionLocation,ye),de),this.gb(K)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),B.hb(this.s,K.identifier,ge[0],ge[1],de))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),ge))}gb(K){const W=new c.$Fgc(K,this.M),re=new c.$Egc(K.identifier.value,!1,this.M),ye=new T.$Mgc(K,this.N),de=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([W.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const x=this;let te,G;const ie=(0,f.$AF)(K,"ipc")?this.f.messagePorts?.get(r.$km.toKey(K.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:re,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(fe){return O.$jc(K.extensionLocation.fsPath,fe)},get storagePath(){return x.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return x.O.globalValue(K).fsPath},get logPath(){return O.$jc(x.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return y.URI.joinPath(x.f.logsLocation,K.identifier.value)},get storageUri(){return x.O.workspaceValue(K)},get globalStorageUri(){return x.O.globalValue(K)},get extensionMode(){return de},get extension(){return te===void 0&&(te=new Y(x,K.identifier,K,ge,!1)),te},get extensionRuntime(){return(0,f.$BF)(K,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!G){if(!ie)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(ie,"message",ve=>ve.data));ie.start(),G={onDidReceiveMessage:fe,postMessage:ie.postMessage.bind(ie)}}return G}})})}static hb(K,W,re,ye,de){return re=re||{activate:void 0,deactivate:void 0},this.ib(K,W,re,ye,de).then(ge=>new v.$ygc(!1,null,de.build(),re,ge,ye.subscriptions))}static ib(K,W,re,ye,de){if(typeof re.activate=="function")try{de.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ge=typeof global=="object"?global:self,x=re.activate.apply(ge,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(x).then(te=>(de.activateResolveStop(),te))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(re)}jb(K,W){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:W}).then(void 0,re=>{this.s.error(re)})}kb(K,W=0){const ye=Date.now();(0,F.$B)(()=>{for(let de=W;de<K.length;de+=1){const ge=K[de];for(const x of ge.activationEvents??[])if(x==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,de);break}else this.jb(ge,x)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(K=>{const W=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(W)this.kb(re);else for(const ye of re)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const K=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const W=this.j.workspace?this.j.workspace.folders:[],re=this.nb(W),ye=this.pb(),de=Promise.all([ye,K,re]).then(()=>{});return Promise.race([de,(0,L.$6g)(1e4)]).then(()=>{this.lb()}),de}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(K,W))).then(()=>{})}async ob(K,W){if(this.isActivated(W.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(ge=>ge.uri),forceUsingSearch:re||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,x,te)=>this.y.$checkExists(ge,x,te)},de=await(0,E.$msb)(ye,W);if(de)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:de.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:W}=this.f.environment;if(!K||!W)throw new Error(D.localize(0,null));const re=await this.vb(null,W,new v.$xgc(!1));if(!re||typeof re.run!="function")throw new Error(D.localize(1,null,W.toString()));return new Promise((ye,de)=>{const ge=(G,ie)=>{G?(F.$t&&this.s.error("Test runner called back with error",G),de(G)):(F.$t&&(ie?this.s.info(`Test runner called back with ${ie} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof ie=="number"&&ie>0?1:0))},x=(0,I.$ug)(W),te=re.run(x,ge);te&&te.then&&te.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{F.$t&&this.s.error("Test runner finished with error",G),de(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$6g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,W){return this.R[K]=W,(0,b.$Rc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:W}=await this.sb(K);return W?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const W=K.indexOf("+");if(W===-1)throw new t.$aL("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=K.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(K,W){const re=j.$Qd.create(!1),ye=()=>`[resolveAuthority(${(0,u.$$k)(K)},${W})][${re.elapsed()}ms] `,de=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),x=(ee,V=void 0)=>this.s.error(`${ye()}${ee}`,V),te=ee=>{if(ee instanceof t.$aL)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},G=async ee=>{de(`activating resolver for ${ee}...`);const{resolver:V,authorityPrefix:ae}=await this.sb(ee);if(!V)throw x(`no resolver for ${ae}`),new t.$aL(`No remote extension installed to resolve ${ae}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:V,authorityPrefix:ae,remoteAuthority:ee}},ie=K.split(/@|%40/g).reverse();de(`activating remote resolvers ${ie.join(" -> ")}`);let fe;try{fe=await Promise.all(ie.map(G)).catch(async ee=>{if(!(ee instanceof t.$aL)||ee._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await G(K)]})}catch(ee){return te(ee)}const ve=new L.$dh;ve.cancelAndSet(()=>de("waiting..."),1e3);let Pe,be;for(const[ee,{authorityPrefix:V,resolver:ae,remoteAuthority:le}]of fe.entries())try{if(ee===fe.length-1)de("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${V}`),Pe=await ae.resolve(le,{resolveAttempt:W,execServer:be}),g.mark(`code/extHost/didResolveAuthorityOK/${V}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$_K.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(de(`invoking resolveExecServer() for ${le}`),g.mark(`code/extHost/willResolveExecServer/${V}`),be=await ae.resolveExecServer?.(le,{resolveAttempt:W,execServer:be}),!be)throw new t.$aL(`Exec server was not available for ${le}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${V}`)}}catch(Re){return g.mark(`code/extHost/didResolveAuthorityError/${V}`),x("returned an error",Re),ve.dispose(),te(Re)}ve.dispose();const De={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},z={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$_K.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let Q;if(t.$_K.isManagedResolvedAuthority(Pe)){const ee=W;this.X.setFactory(ee,Pe.makeConnection),Q={authority:K,connectTo:new u.$8k(ee),connectionToken:Pe.connectionToken}}else Q={authority:K,connectTo:new u.$9k(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:Q,options:z,tunnelInformation:De}}}async $getCanonicalURI(K,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$$k)(K)})`);const{resolver:re}=await this.sb(K);if(!re)return null;const ye=y.URI.revive(W);if(typeof re.getCanonicalURI>"u")return ye;const de=await(0,L.$Xg)(()=>re.getCanonicalURI(ye));return de||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:W,myExtensions:re}=ue(this.I,this.L,this.J,K);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.rb()}$activateByEvent(K,W){return W===1?this.D.wait().then(re=>this.Z(K,!1)):this.G.wait().then(re=>this.Z(K,!1))}async $activate(K,W){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,W),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:W,myExtensions:re}=ue(this.I,this.L,this.J,K),ye=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const W=n.$ie.alloc(K),re=Math.random()%256;for(let ye=0;ye<K;ye++)W.writeUInt8(re,ye);return W}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$Sgc=X,e.$Sgc=X=B=Ge([We(0,s.$4h),We(1,e.$Rgc),We(2,d.$9M),We(3,h.$fgc),We(4,m.$igc),We(5,R.$mj),We(6,l.$mN),We(7,a.$lgc),We(8,P.$kyb),We(9,p.$Ggc),We(10,N.$Ogc),We(11,M.$Pgc)],X);function ue(oe,K,W,re){oe.addActivationEvents(re.addActivationEvents);const ye=new o.$97b(oe,K.getAllExtensionDescriptions());ye.deltaExtensions(re.toAdd,re.toRemove);const de=new r.$lm(W.getAllExtensionDescriptions().map(x=>x.identifier));for(const x of re.myToRemove)de.delete(x);for(const x of re.myToAdd)de.add(x);const ge=he(ye,de);return{globalRegistry:ye,myExtensions:ge}}function Z(oe,K){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function J(oe){return oe.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$Tgc=(0,s.$5h)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(K,W,re,ye,de){this.#e=K,this.#t=W,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=O.$hc((0,I.$ug)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ugc=Y;function he(oe,K){return oe.getAllExtensionDescriptions().filter(W=>K.has(W.identifier))}class _{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$Vgc=_;class we{constructor(K){this.a=new r.$mm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const W of Object.keys(K))this.a.set(W,K[W])}}}),define(ke[363],Se([1,0,57,2,6,42,25,26,20,27,5,48,13,12]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;let h=class{constructor(n,c,t,u,s,l,a){this.c=n,this.d=c,this.e=t,this.f=u,this.g=s,this.h=l,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new o(this.c,c,this.d,n,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const c of n.nodeModuleName)this.a.set(c,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(c=>n.alternativeModuleName(c))}};e.$4hc=h,e.$4hc=h=Ge([We(2,R.$4h),We(3,I.$igc),We(4,C.$Tgc),We(5,y.$mN),We(6,m.$mj)],h);let f=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const c=(0,v.$Ne)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${s}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const c=this.b.exec(this.c(n));if(!c)return;const[,t,u,s]=c,l=S.a.get(u);if(l!==void 0)return console.warn(`${u} as been renamed to ${l}, please update your imports`),t+l+s}c(n){return n.replace(/\\/g,"/")}};f=S=Ge([We(0,y.$mN)],f);class o{constructor(n,c,t,u,s){this.c=n,this.d=c,this.e=t,this.f=u,this.g=s,this.nodeModuleName="vscode",this.a=new b.$mm}load(n,c){const t=this.d.findSubstr(c);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((s,l)=>u+=`	${l} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${u}`),this.b=this.c(L.$vF,this.e,this.f)}return this.b}}let i=class{constructor(n,c,t){this.e=n,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$5K.MainThreadTelemetry);const u=t.getProxy(g.$5K.MainThreadWindow);this.c=(s,l)=>{const a=O.URI.parse(s);return l?this.g(s,l):a.scheme==="http"||a.scheme==="https"?u.$openUri(a,s,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?u.$openUri(a,s,{}):this.g(s,l)}}load(n,c,t){const u=this.e.findSubstr(c);return u&&(this.a=u.identifier.value,this.h()),this.b=t(n),this.c}g(n,c){return this.i(),this.b(n,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([We(2,$.$9M)],i)}),define(ke[59],Se([1,0,43,3,16,50,5,69,70,48,7,41,289,42]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0,e.$Wgc=(0,L.$5h)("IExtHostVariableResolverProvider");class S extends m.$0N{constructor(o,i,r,n,c,t,u){function s(){if(r){const l=r.activeEditor();if(l)return l.document.uri;const a=n.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof R.$NM||a.input instanceof R.$SM)return a.input.modified;if(a.input instanceof R.$MM||a.input instanceof R.$RM||a.input instanceof R.$PM)return a.input.uri}}}super({getFolderUri:l=>{const a=t.folders.filter(d=>d.name===l);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,a)=>c.getConfiguration(void 0,l).get(a),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=s();if(l)return g.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const l=s();if(l){const a=i.getWorkspaceFolder(l);if(a)return g.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(r){const l=r.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(r){const l=r.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(I.env))}}let h=class extends O.$Tc{constructor(o,i,r,n,c){super(),this.b=o,this.c=i,this.g=r,this.h=n,this.j=c,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xgc=h,e.$Xgc=h=Ge([We(0,y.$Tgc),We(1,C.$fgc),We(2,b.$hN),We(3,v.$igc),We(4,$.$ugc)],h)}),define(ke[96],Se([1,0,11,4,2,5,6,70,48,20,7,41,140,281,42,59]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=e.$2gc=e.$1gc=e.$Zgc=e.$Ygc=void 0,e.$Ygc=(0,I.$5h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(u,s,l,a,d,k){this.E=s,this.F=l,this.G=a,this.H=d,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new O.$Ud,this.n=new O.$Ud,this.o=new O.$Ud,this.u=new O.$Ud,this.k=u.getProxy(L.$5K.MainThreadDebugService),this.y=new O.$Ud,this.A=new O.$Ud,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(P=>{P.onDidChange(p=>{this.J(P)}),this.J(P)})}asDebugSourceUri(u,s){const l=u;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let a=`debug:${encodeURIComponent(l.path||"")}`,d="?";return s&&(a+=`${d}session=${encodeURIComponent(s.id)}`,d="&"),a+=`${d}ref=${l.sourceReference}`,g.URI.parse(a)}else{if(l.path)return g.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(u){const s=[];for(const l of u.getAllExtensionDescriptions())if(l.contributes){const a=l.contributes.debuggers;if(a&&a.length>0)for(const d of a)(0,v.$aG)(d)&&s.push(d.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const u=[];return this.w.forEach(s=>u.push(s)),u}addBreakpoints(u){const s=u.filter(d=>{const k=d.id;return this.w.has(k)?!1:(this.w.set(k,d),!0)});this.U(s,[],[]);const l=[],a=new Map;for(const d of s)if(d instanceof R.$7L){let k=a.get(d.location.uri.toString());k||(k={type:"sourceMulti",uri:d.location.uri,lines:[]},a.set(d.location.uri.toString(),k),l.push(k)),k.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof R.$8L&&l.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(u){const s=u.filter(k=>this.w.delete(k.id));this.U([],s,[]);const l=s.filter(k=>k instanceof R.$7L).map(k=>k.id),a=s.filter(k=>k instanceof R.$8L).map(k=>k.id),d=s.filter(k=>k instanceof R.$9L).map(k=>k.id);return this.k.$unregisterBreakpoints(l,a,d)}startDebugging(u,s,l){return this.k.$startDebugging(u?u.uri:void 0,s,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(u){return this.k.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,s,l){if(!s)return new R.$7K(()=>{});const a=this.d++;return this.f.push({type:u,handle:a,provider:s}),this.k.$registerDebugConfigurationProvider(u,l,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,a),new R.$7K(()=>{this.f=this.f.filter(d=>d.provider!==s),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(u,s,l){if(!l)return new R.$7K(()=>{});if(!this.Q(u,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:s,handle:a,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(s,a),new R.$7K(()=>{this.h=this.h.filter(d=>d.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(u,s){if(!s)return new R.$7K(()=>{});const l=this.i++;return this.j.push({type:u,handle:l,factory:s}),new R.$7K(()=>{this.j=this.j.filter(a=>a.factory!==s)})}async $runInTerminal(u,s){return Promise.resolve(void 0)}async $substituteVariables(u,s){let l;const a=await this.W(u);return a&&(l={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(l,s)}K(u,s){if(u.type==="implementation")return new n(u.implementation)}L(){}async $startDASession(u,s){const l=this,a=await this.V(s);return this.S(this.N(a.type),a).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const k=this.M(d),P=this.K(k,a);if(!P)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const p=P;return this.B.set(u,p),this.R(a).then(w=>(w&&this.C.set(u,w),p.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const A=E,T={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const U=await this.D.sign(A.arguments.value);T.body={signature:U},p.sendResponse(T)}else throw new Error("no signer")}catch(U){T.success=!1,T.message=U.message,p.sendResponse(T)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(E),E=(0,v.$fG)(E,!0),l.k.$acceptDAMessage(u,E)}),p.onError(E=>{w&&w.onError&&w.onError(E),this.k.$acceptDAError(u,E.name,E.message,E.stack)}),p.onExit(E=>{w&&w.onExit&&w.onExit(E??void 0,void 0),this.k.$acceptDAExit(u,E??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),p.startSession()))})}$sendDAMessage(u,s){s=(0,v.$eG)(s,!1);const l=this.C.get(u);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(s),this.B.get(u)?.sendMessage(s)}$stopDASession(u){const s=this.C.get(u);this.C.delete(u),s&&s.onWillStopSession&&s.onWillStopSession();const l=this.B.get(u);return this.B.delete(u),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const s=[],l=[],a=[];if(u.added)for(const d of u.added){const k=d.id;if(k&&!this.w.has(k)){let P;if(d.type==="function")P=new R.$8L(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")P=new R.$9L(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const p=g.URI.revive(d.uri);P=new R.$7L(new R.$gL(p,new R.$8K(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,R.$5L)(P,k),this.w.set(k,P),s.push(P)}}if(u.removed)for(const d of u.removed){const k=this.w.get(d);k&&(this.w.delete(d),l.push(k))}if(u.changed){for(const d of u.changed)if(d.id){const k=this.w.get(d.id);if(k){if(k instanceof R.$8L&&d.type==="function"){const P=k;P.enabled=d.enabled,P.condition=d.condition,P.hitCondition=d.hitCondition,P.logMessage=d.logMessage,P.functionName=d.functionName}else if(k instanceof R.$7L&&d.type==="source"){const P=k;P.enabled=d.enabled,P.condition=d.condition,P.hitCondition=d.hitCondition,P.logMessage=d.logMessage,P.location=new R.$gL(g.URI.revive(d.uri),new R.$8K(d.line,d.character))}a.push(k)}}}this.U(s,l,a)}async $acceptStackFrameFocus(u){let s;const l=u.sessionId?await this.V(u.sessionId):void 0;if(!l)throw new Error("no DebugSession found for debug focus context");u.kind==="thread"?s=new R.$cM(l,u.threadId):s=new R.$bM(l,u.threadId,u.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(u,s,l){return(0,D.$Xg)(async()=>{const a=this.P(u);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(s);return a.provideDebugConfigurations(d,l)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(u,s,l,a){return(0,D.$Xg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(s);return d.resolveDebugConfiguration(k,l,a)})}$resolveDebugConfigurationWithSubstitutedVariables(u,s,l,a){return(0,D.$Xg)(async()=>{const d=this.P(u);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(s);return d.resolveDebugConfigurationWithSubstitutedVariables(k,l,a)})}async $provideDebugAdapter(u,s){const l=this.O(u);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(s);return this.S(l,a).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(u){const s=await this.V(u);this.m.fire(s)}async $acceptDebugSessionTerminated(u){const s=await this.V(u);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(u){this.q=u?await this.V(u):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(u,s){(await this.V(u))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(u,s){const a={session:await this.V(u),event:s.event,body:s.body};this.u.fire(a)}M(u){if(u instanceof R.$0L)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof R.$$L)return{type:"server",port:u.port,host:u.host};if(u instanceof R.$_L)return{type:"pipeServer",path:u.path};if(u instanceof R.$aM)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}N(u){const s=this.h.filter(l=>l.type===u);if(s.length>0)return s[0].factory}O(u){const s=this.h.filter(l=>l.handle===u);if(s.length>0)return s[0].factory}P(u){const s=this.f.filter(l=>l.handle===u);if(s.length>0)return s[0].provider}Q(u,s){if(u.contributes){const l=u.contributes.debuggers;if(l&&l.length>0){for(const a of l)if(a.label&&a.type&&a.type===s)return!0}}return!1}R(u){const l=u.configuration.type,a=this.j.filter(d=>d.type===l||d.type==="*").map(d=>(0,D.$Xg)(()=>d.factory.createDebugAdapterTracker(u)).then(k=>k,k=>null));return Promise.race([Promise.all(a).then(d=>{const k=d.filter(P=>!!P);if(k.length>0)return new r(k)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(u,s){const l=s.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new R.$$L(l));if(u){const d=await this.F.getExtensionRegistry();return(0,D.$Xg)(()=>u.createDebugAdapterDescriptor(s,this.T(s,d))).then(k=>{if(k)return k})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,a))}T(u,s){}U(u,s,l){(u.length>0||s.length>0||l.length>0)&&this.y.fire(Object.freeze({added:u,removed:s,changed:l}))}async V(u){if(u)if(typeof u=="string"){const s=this.l.get(u);if(s)return s}else{let s=this.l.get(u.id);if(!s){const l=await this.W(u.folderUri),a=u.parent?this.l.get(u.parent):void 0;s=new o(this.k,u.id,u.type,u.name,l,u.configuration,a),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(u){if(u){const s=g.URI.revive(u);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$Zgc=f,e.$Zgc=f=Ge([We(0,y.$9M),We(1,C.$fgc),We(2,$.$Tgc),We(3,S.$igc),We(4,b.$ugc),We(5,h.$Wgc)],f);class o{constructor(u,s,l,a,d,k,P){this.d=u,this.f=s,this.g=l,this.h=a,this.i=d,this.j=k,this.k=P}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(u){this.h=u,this.d.$setDebugSessionName(this.f,u)}get parentSession(){return this.k}_acceptNameChanged(u){this.h=u}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(u,s){return this.d.$customDebugAdapterRequest(this.f,u,s)}getDebugProtocolBreakpoint(u){return this.d.$getDebugProtocolBreakpoint(this.f,u.id)}}e.$1gc=o;class i{constructor(u){this.value=Object.freeze({append(s){u.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$2gc=i;class r{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(s=>s.onError?s.onError(u):void 0)}onExit(u,s){this.d.forEach(l=>l.onExit?l.onExit(u,s):void 0)}}class n extends m.$Elb{constructor(u){super(),this.h=u,u.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends f{constructor(u,s,l,a,d,k){super(u,s,l,a,d,k)}};e.$3gc=c,e.$3gc=c=Ge([We(0,y.$9M),We(1,C.$fgc),We(2,$.$Tgc),We(3,S.$igc),We(4,b.$ugc),We(5,h.$Wgc)],c)}),define(ke[364],Se([1,0,14,57,2,6,352,13,106,107,27,247,20,66,48,90]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=void 0;class f{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(b.$mj),t=r.get(m.$9M).getProxy(I.$5K.MainThreadErrors);D.setUnexpectedErrorHandler(u=>{n.error(u);const s=D.$3(u);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(b.$mj),c=r.get(m.$9M),t=r.get(S.$Tgc),u=r.get(h.$qN),s=c.getProxy(I.$5K.MainThreadExtensionService),l=c.getProxy(I.$5K.MainThreadErrors),a=await t.getExtensionPathIndex(),d=new WeakMap;function k(w,E){if(d.has(w))return d.get(w).stack;let A="",T,U;for(const j of E)A+=`
	at ${j.toString()}`,U=j.getFileName(),!T&&U&&(T=a.findSubstr(g.URI.file(U)));const N=`${w.name||"Error"}: ${w.message||""}${A}`;return d.set(w,{extensionIdentifier:T?.identifier,stack:N}),N}const P=Symbol("prepareStackTrace wrapped");let p=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(w){if(w===k||!w||w[P]){p=w||k;return}p=function(E,A){return k(E,A),w.call(Error,E,A)},Object.assign(p,{[P]:!0})}}),D.setUnexpectedErrorHandler(w=>{n.error(w);const E=D.$3(w),A=d.get(w);if(!A?.extensionIdentifier){l.$onUnexpectedError(E);return}s.$onExtensionRuntimeError(A.extensionIdentifier,E);const T=u.onExtensionError(A.extensionIdentifier,w);n.trace("forwarded error to extension?",T,A)})}}e.$5hc=f;class o{constructor(r,n,c,t,u){this.a=c,this.b=new L.$e8b(r,null,t),n=o.e(n,this.b);const s=new y.$3h(...(0,$.$Yr)());s.set(R.$mN,{_serviceBrand:void 0,...n,messagePorts:u}),s.set(m.$9M,new m.$0M(this.b)),s.set(v.$cgc,new v.$dgc(t)),s.set(S.$Rgc,c);const l=new C.$Dq(s,!0);l.invokeFunction(f.installEarlyHandler),this.d=l.invokeFunction(a=>a.get(b.$mj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=l.invokeFunction(a=>a.get(S.$Tgc)),this.c.initialize(),l.invokeFunction(f.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(I.$5K.MainThreadExtensionService);return g.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=g.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const c=r.environment.extensionDevelopmentLocationURI;return c&&(r.environment.extensionDevelopmentLocationURI=c.map(t=>g.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=g.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=g.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=g.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=g.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=g.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=g.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$6hc=o}),define(ke[365],Se([1,0,11,10,222,241,138,96,70,48,20,47,7,59,41,282,283,42]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;let i=class extends b.$Zgc{constructor(u,s,l,a,d,k,P){super(u,s,l,a,k,P),this.Z=d,this.X=new c}K(u,s){switch(u.type){case"server":return new h.$$hc(u);case"pipeServer":return new h.$_hc(u);case"executable":return new h.$aic(u,s.type)}return super.K(u,s)}T(u,s){const l=h.$aic.platformAdapterExecutable(s.getAllExtensionDescriptions(),u.type);if(l)return new m.$0L(l.command,l.args,l.options)}L(){return new L.$4$b}async $runInTerminal(u,s){if(u.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(N=>{this.X.onTerminalClosed(N)}));const l=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),d=this.Z.getDefaultShellArgs(!0),k=u.title||g.localize(0,null),P=JSON.stringify({shell:a,shellArgs:d});let p=await this.X.checkout(P,k),w,E=!1;if(p)w=u.cwd;else{const N={shellPath:a,shellArgs:d,cwd:u.cwd,name:k,iconPath:new m.$2L("debug")};E=!0,p=this.Z.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(p,P)}p.show(!0);const A=await p.processId;E?await new Promise(N=>setTimeout(N,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?p.sendText("cls"):a.indexOf("bash")>=0?p.sendText("clear"):O.$i?p.sendText("cls"):p.sendText("clear"));const T=(0,f.$cic)(a,u.args,!!u.argsCanBeInterpretedByShell,w,u.env);p.sendText(T);const U=this.onDidTerminateDebugSession(N=>{N.id===s&&(this.X.free(p),U.dispose())});return A}else if(u.kind==="external")return n(u,await this.G.getConfigProvider());return super.$runInTerminal(u,s)}};e.$dic=i,e.$dic=i=Ge([We(0,R.$9M),We(1,S.$fgc),We(2,y.$Tgc),We(3,o.$igc),We(4,C.$Ggc),We(5,$.$ugc),We(6,v.$Wgc)],i);let r;function n(t,u){if(!r)if(O.$i)r=new I.$P0b;else if(O.$j)r=new I.$Q0b;else if(O.$k)r=new I.$R0b;else throw new Error("external terminals not supported on this platform");const s=u.getConfiguration("terminal");return r.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class c{constructor(){this.b=new Map}static{this.a=1e3}async checkout(u,s){const a=[...this.b.entries()].map(([d,k])=>(0,D.$Sg)(async P=>{if(d.name!==s||k.lastUsedAt!==-1&&await(0,f.$bic)(await d.processId))return null;const p=Date.now();return k.lastUsedAt+c.a>p||P.isCancellationRequested||k.config!==u?null:(k.lastUsedAt=p,d)}));return await(0,D.$0g)(a,d=>!!d)}insert(u,s){this.b.set(u,{lastUsedAt:Date.now(),config:s})}free(u){const s=this.b.get(u);s&&(s.lastUsedAt=-1)}onTerminalClosed(u){this.b.delete(u)}}}),define(ke[366],Se([1,0,16,2,104,41,69,42,40,47,20,27,95,17,13,91,23,63,59]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;let r=class extends m.$Jhc{constructor(c,t,u,s,l,a,d,k,P){super(c,t,u,s,l,a,d,k),this.C=u,this.D=P,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const u=t;if(!t.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=m.TaskHandleDTO.from(u,this.C),l=await this.a.$getTaskExecution(s);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(l,t);return this.a.$executeTask(s).catch(()=>{}),a}else{const s=m.TaskDTO.from(t,c);if(s===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const l=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),l}}v(c,t,u,s){const l=[];if(s)for(const a of s){this.A(a,u),(!a.definition||!c[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=m.TaskDTO.from(a,u.extension);d&&(l.push(d),m.CustomExecutionDTO.is(d.execution)&&t.push(this.y(d,a,!0)))}return{tasks:l,extension:u.extension}}async w(c){return c}async G(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const u=O.URI.file((0,o.homedir)());t=new $.$mi({uri:u,name:f.$Dg(u),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const u=O.URI.revive(c),s={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(u),a=await this.b.getWorkspaceFolders2()??[],d=await this.D.getResolver(),k=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const P of t.variables)s.variables[P]=await d.resolveAsync(k,P);if(t.process!==void 0){let P;if(t.process.path!==void 0){P=t.process.path.split(D.$tc);for(let p=0;p<P.length;p++)P[p]=await d.resolveAsync(k,P[p])}s.process=await g.win32.findExecutable(await d.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(k,t.process.cwd):void 0,P)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,u){return g.win32.findExecutable(c,t,u)}};e.$8hc=r,e.$8hc=r=Ge([We(0,R.$9M),We(1,C.$mN),We(2,I.$fgc),We(3,L.$hN),We(4,b.$igc),We(5,y.$Ggc),We(6,S.$mj),We(7,h.$Zfc),We(8,i.$Wgc)],r)}),define(ke[367],Se([1,0,63,59]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;class g extends O.$Xgc{m(){return(0,D.homedir)()}}e.$Nic=g}),define(ke[154],Se([1,0,19,11,21,44,17,16,23,2,36]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=e.$fhc=e.$ehc=void 0;class C{constructor(i,r,n,c){this.d=i,this.e=r,this.f=n,this.g=c,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],c=new g.$5d(r);return new Promise((t,u)=>{this.a=new v(i);let s=!1;const l=(a,d)=>{if(!s&&!this.b){const k=this.h(a);h(a)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,s=!0,c.cancel(),a=this.j(a,this.d.maxResults-this.c));const P=this.h(a);this.c+=P,(P>0||!h(a))&&this.a.add(a,d)}};Promise.all(n.map((a,d)=>this.k(a,k=>l(k,d),c.token))).then(a=>{c.dispose(),this.a.flush();const d=a.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||d,messages:(0,D.$Rb)(a.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},a=>{c.dispose();const d=(0,I.$Pi)(a);u(new Error(d))})})}h(i){return h(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:c.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const c=new R.$IJ(this.d,i),t=[],u={report:a=>{if(!this.l(a))return;const d=i.folder.scheme===L.Schemas.file?(0,R.$JJ)(()=>this.f.readdir($.$Fg(a.uri))):void 0,k=$.$Ig(i.folder,a.uri);if(k){const P=c.includedInQuery(k,b.$nc(k),d);(0,O.$Rg)(P)?t.push(P.then(p=>{p&&r(a)})):P&&r(a)}}},s=this.n(i),l=await this.e.provideTextSearchResults(m(this.d.contentPattern),s,u,n);return t.length&&await Promise.all(t),l}l(i){if(h(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,R.$HJ)(this.d.includePattern,i.includePattern),n=(0,R.$HJ)(this.d.excludePattern,i.excludePattern),c={folder:y.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return c.usePCRE2=this.d.usePCRE2,c}}e.$ehc=C;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!$.$zg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$fhc=v;function S(o){return h(o)?{preview:{matches:(0,D.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,D.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function h(o){return!!o.preview}e.$ghc=h;class f{static{this.a=4e3}static{this.b=50}constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$hhc=f}),define(ke[97],Se([1,0,3,6,5,360,20,66,13,2,154]),function(me,e,D,O,g,I,L,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=void 0,e.$ihc=(0,g.$5h)("IExtHostSearch");let C=class{constructor(h,f,o){this.k=h,this.l=f,this.n=o,this.c=this.k.getProxy(O.$5K.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$dhc}o(h){return this.l.transformOutgoingScheme(h)}registerTextSearchProvider(h,f){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const o=this.d++;return this.e.set(o,f),this.c.$registerTextSearchProvider(o,this.o(h)),(0,D.$Rc)(()=>{this.g.delete(h),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(h,f){if(this.i.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.i.add(h);const o=this.d++;return this.h.set(o,f),this.c.$registerFileSearchProvider(o,this.o(h)),(0,D.$Rc)(()=>{this.i.delete(h),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(h,f,o,i){const r=m(o),n=this.h.get(h);if(n)return this.j.fileSearch(r,n,c=>{this.c.$handleFileMatch(h,f,c.map(t=>t.resource))},i);throw new Error("unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,f,o){return{messages:[]}}$clearCache(h){return this.j.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,f,o,i){const r=this.e.get(h);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const n=m(o);return this.q(n,r).search(t=>this.c.$handleTextMatch(h,f,t),i)}$enableExtensionHostSearch(){}q(h,f){return new R.$ehc(h,f,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$jhc=C,e.$jhc=C=Ge([We(0,L.$9M),We(1,b.$cgc),We(2,$.$mj)],C);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(v),extraFileResources:S.extraFileResources&&S.extraFileResources.map(h=>y.URI.revive(h))}}e.$khc=m;function v(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(ke[368],Se([1,0,21,14,4,3,17,39,2,132,191,172,79,26,32,13,65,87,266,6,304,312,91,305,306,307,308,309,310,311,287,35,313,42,343,96,149,315,316,317,293,318,69,70,319,48,320,71,321,58,27,322,323,324,325,326,327,115,116,328,359,295,272,296,329,330,152,331,297,332,333,20,334,97,117,335,336,337,118,92,95,90,47,338,339,284,340,298,72,15,7,341,66,342,93,344,345,151,41,280,114,25,94]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u,s,l,a,d,k,P,p,w,E,A,T,U,N,j,F,M,B,X,ue,Z,J,Y,he,_,we,oe,K,W,re,ye,de,ge,x,te,G,ie,fe,ve,Pe,be,De,z,Q,ee,V,ae,le,Re,je,He,Je,_e,ct,ot,rt,Ae,Ue,Le,Ye,ne,ce,Ie,Ve,Xe,nt,it,Oe,pt,St,Nt,Wt,Et,Kt,Ot,Xt,Ut,Lt,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;function Jt(ht){const bt=ht.get(K.$mN),zt=ht.get(oe.$Wfc),qt=ht.get(_.$kgc),Dt=ht.get(Y.$Tgc),ft=ht.get(Xt.$fgc),At=ht.get(Le.$qN),xt=ht.get(A.$igc),Ct=ht.get(St.$cgc),Qe=ht.get(Re.$9M),Ft=ht.get(rt.$Dgc),Vt=ht.get(Ae.$lgc),Qt=ht.get(h.$nj),gt=ht.get(h.$mj),Tt=ht.get(nt.$kyb),Fe=ht.get(t.$Zfc),Ne=ht.get(Ot.$Yhc),Ce=ht.get(Je.$Lgc),se=ht.get(Z.$ugc),Te=ht.get(G.$Pgc);Qe.set(r.$6K.ExtHostFileSystemInfo,zt),Qe.set(r.$6K.ExtHostLogLevelServiceShape,Qt),Qe.set(r.$6K.ExtHostWorkspace,ft),Qe.set(r.$6K.ExtHostConfiguration,xt),Qe.set(r.$6K.ExtHostExtensionService,Dt),Qe.set(r.$6K.ExtHostStorage,Ft),Qe.set(r.$6K.ExtHostTunnelService,Tt),Qe.set(r.$6K.ExtHostWindow,Ne),Qe.set(r.$6K.ExtHostSecretState,Ce),Qe.set(r.$6K.ExtHostTelemetry,At),Qe.set(r.$6K.ExtHostEditorTabs,se),Qe.set(r.$6K.ExtHostManagedSockets,Te);const qe=Qe.set(r.$6K.ExtHostDecorations,ht.get(N.$5gc)),xe=Qe.set(r.$6K.ExtHostDocumentsAndEditors,ht.get(ue.$hN)),Ke=Qe.set(r.$6K.ExtHostCommands,ht.get(w.$sN)),st=Qe.set(r.$6K.ExtHostTerminalService,ht.get(Ye.$Ggc)),$t=Qe.set(r.$6K.ExtHostDebugService,ht.get(U.$Ygc)),Bt=Qe.set(r.$6K.ExtHostSearch,ht.get(He.$ihc)),kt=Qe.set(r.$6K.ExtHostTask,ht.get(Ue.$Lhc)),It=Qe.set(r.$6K.ExtHostOutputService,ht.get(Q.$yhc)),yt=Qe.set(r.$6K.ExtHostLocalization,ht.get(te.$Ogc)),gi=Qe.set(r.$6K.ExtHostUrls,new Nt.$Vhc(Qe)),Rt=Qe.set(r.$6K.ExtHostDocuments,new X.$Ufc(Qe,xe)),Di=Qe.set(r.$6K.ExtHostDocumentContentProviders,new M.$7gc(Qe,xe,gt)),Gi=Qe.set(r.$6K.ExtHostDocumentSaveParticipant,new B.$8gc(gt,Rt,Qe.getProxy(r.$5K.MainThreadBulkEdits))),Pt=Qe.set(r.$6K.ExtHostNotebook,new fe.$lhc(Qe,Ke,xe,Rt,qt,Bt)),ri=Qe.set(r.$6K.ExtHostNotebookDocuments,new Pe.$shc(Pt)),mi=Qe.set(r.$6K.ExtHostNotebookEditors,new be.$thc(gt,Pt)),ci=Qe.set(r.$6K.ExtHostNotebookKernels,new De.$uhc(Qe,bt,Pt,Ke,gt)),Ci=Qe.set(r.$6K.ExtHostNotebookRenderers,new z.$whc(Qe,Pt)),Ii=Qe.set(r.$6K.ExtHostNotebookDocumentSaveParticipant,new ve.$rhc(gt,Pt,Qe.getProxy(r.$5K.MainThreadBulkEdits))),jt=Qe.set(r.$6K.ExtHostEditors,new ce.$_fc(Qe,xe)),$i=Qe.set(r.$6K.ExtHostTreeViews,new Xe.$Thc(Qe.getProxy(r.$5K.MainThreadTreeViews),Ke,gt)),Pi=Qe.set(r.$6K.ExtHostEditorInsets,new p.$agc(Qe.getProxy(r.$5K.MainThreadEditorInsets),jt,bt.remote)),ui=Qe.set(r.$6K.ExtHostDiagnostics,new j.$Yfc(Qe,gt,zt,xe)),li=Qe.set(r.$6K.ExtHostLanguages,new x.$phc(Qe,Rt,Ke.converter,Ct)),dt=Qe.set(r.$6K.ExtHostLanguageFeatures,new ge.$3fc(Qe,Ct,Rt,Ke,ui,gt,Fe,At)),Ji=Qe.set(r.$6K.ExtHostFileSystem,new he.$0gc(Qe,dt)),_t=Qe.set(r.$6K.ExtHostFileSystemEventService,new we.$$gc(Qe,gt,xe)),si=Qe.set(r.$6K.ExtHostQuickOpen,(0,le.$Chc)(Qe,ft,Ke)),bi=Qe.set(r.$6K.ExtHostSCM,new je.$Ehc(Qe,Ke,Rt,gt)),Ai=Qe.set(r.$6K.ExtHostQuickDiff,new ae.$Bhc(Qe,Ct)),Qi=Qe.set(r.$6K.ExtHostShare,new _e.$Fhc(Qe,Ct)),Li=Qe.set(r.$6K.ExtHostComments,(0,E.$bgc)(Qe,Ke,Rt)),wi=Qe.set(r.$6K.ExtHostProgress,new V.$Ahc(Qe.getProxy(r.$5K.MainThreadProgress))),Xi=Qe.set(r.$6K.ExtHostLabelService,new de.$ohc(Qe)),Ri=Qe.set(r.$6K.ExtHostTheming,new Ie.$Qhc(Qe)),hi=Qe.set(r.$6K.ExtHostAuthentication,new u.$5fc(Qe)),Yi=Qe.set(r.$6K.ExtHostTimeline,new Ve.$Shc(Qe,Ke)),pi=Qe.set(r.$6K.ExtHostWebviews,new Wt.$pgc(Qe,bt.remote,ft,gt,Fe)),Mi=Qe.set(r.$6K.ExtHostWebviewPanels,new Et.$sgc(Qe,pi,ft)),un=Qe.set(r.$6K.ExtHostCustomEditors,new T.$tgc(Qe,Rt,Vt,pi,Mi)),Fi=Qe.set(r.$6K.ExtHostWebviewViews,new Kt.$Whc(Qe,pi)),oi=Qe.set(r.$6K.ExtHostTesting,new ne.$Mhc(Qe,gt,Ke,xe)),ln=Qe.set(r.$6K.ExtHostUriOpeners,new pt.$Uhc(Qe)),hn=Qe.set(r.$6K.ExtHostProfileContentHandlers,new ee.$zhc(Qe));Qe.set(r.$6K.ExtHostInteractive,new re.$mhc(Qe,Pt,xe,Ke,gt));const Zi=Qe.set(r.$6K.ExtHostInlineChat,new W.$_gc(Qe,Ke,Rt,gt)),di=Qe.set(r.$6K.ExtHostChatProvider,new d.$8fc(Qe,gt)),xi=Qe.set(r.$6K.ExtHostChatAgents2,new a.$9fc(Qe,di,gt)),_i=Qe.set(r.$6K.ExtHostChatVariables,new k.$0fc(Qe)),vi=Qe.set(r.$6K.ExtHostChat,new l.$7fc(Qe)),en=Qe.set(r.$6K.ExtHostAiRelatedInformation,new n.$Tfc(Qe)),Ti=Qe.set(r.$6K.ExtHostAiEmbeddingVector,new J.$9gc(Qe)),Ni=Qe.set(r.$6K.ExtHostIssueReporter,new ye.$nhc(Qe)),ei=Qe.set(r.$6K.ExtHostStatusBar,new ot.$Ihc(Qe,Ke.converter)),yi=Qe.set(r.$6K.ExtHostSpeech,new ct.$Ghc(Qe)),dn=Object.values(r.$6K);Qe.assertRegistered(dn);const Yt=new s.$6fc(Qe,xe),Ei=new P.$$fc(Qe),ki=new ie.$qhc(Qe,gt),Oi=new F.$6gc(Qe);return c.$4fc.register(Ke),function(Be,ti,tn){function at($e){return(Ee,ze,ut)=>{const vt=$e(Mt=>{try{Ee.call(ze,Mt)}catch(cn){O.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event`,{cause:cn})),At.onExtensionError(Be.identifier,cn)}});return ut?.push(vt),vt}}const wt=function(){let $e=!Be.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function ze(ut){if(Array.isArray(ut))ut.forEach(ze);else if(typeof ut=="string")Ee();else{const vt=ut;typeof vt.scheme>"u"&&Ee(),typeof vt.exclusive=="boolean"&&(0,et.$BF)(Be,"documentFiltersExclusive")}return ut}}(),fn={getSession($e,Ee,ze){return hi.getSession(Be,$e,Ee,ze)},getSessions($e,Ee){return(0,et.$BF)(Be,"authGetSessions"),hi.getSessions(Be,$e,Ee)},async hasSession($e,Ee){return(0,et.$BF)(Be,"authSession"),!!await hi.getSession(Be,$e,Ee,{silent:!0})},get onDidChangeSessions(){return at(hi.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,ze,ut){return hi.registerAuthenticationProvider($e,Ee,ze,ut)}},gn={registerCommand($e,Ee,ze){return Ke.registerCommand(!0,$e,Ee,ze,void 0,Be)},registerTextEditorCommand($e,Ee,ze){return Ke.registerCommand(!0,$e,(...ut)=>{const vt=jt.getActiveTextEditor();if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return vt.edit(Mt=>{Ee.apply(ze,[vt,Mt,...ut])}).then(Mt=>{Mt||gt.warn("Edits from command "+$e+" were not applied.")},Mt=>{gt.warn("An error occurred while running command "+$e,Mt)})},void 0,void 0,Be)},registerDiffInformationCommand:($e,Ee,ze)=>((0,et.$BF)(Be,"diffCommand"),Ke.registerCommand(!0,$e,async(...ut)=>{const vt=xe.activeEditor(!0);if(!vt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Mt=await jt.getDiffInformation(vt.id);Ee.apply(ze,[Mt,...ut])},void 0,void 0,Be)),executeCommand($e,...Ee){return Ke.executeCommand($e,...Ee)},getCommands($e=!1){return Ke.getCommands($e)}},ji={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return Ei.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return at(st.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$BF)(Be,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$BF)(Be,"telemetry"),at(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Le.$pN)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Le.$oN.validateSender($e),At.instantiateLogger(Be,$e,Ee)},openExternal($e,Ee){return Ne.openUri($e,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===bt.environment.appUriScheme)return gi.createAppUri($e);try{return await Ne.asExternalUri($e,{allowTunneling:!!bt.remote.authority})}catch(Ee){if((0,L.$dg)($e,L.Schemas.http)||(0,L.$dg)($e,L.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$al)(bt.remote.authority)},get remoteAuthority(){return(0,et.$BF)(Be,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return at(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,et.$BF)(Be,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Be,$e)},registerIssueDataProvider($e){return(0,et.$BF)(Be,"handleIssueUri"),Ni.registerIssueDataProvider(Be,$e)},get appQuality(){return(0,et.$BF)(Be,"resolvers"),bt.quality},get appCommit(){return(0,et.$BF)(Be,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ji);const Ui={createTestController($e,Ee,ze){return oi.createTestController(Be,$e,Ee,ze)},createTestObserver(){return(0,et.$BF)(Be,"testObserver"),oi.createTestObserver()},runTests($e){return(0,et.$BF)(Be,"testObserver"),oi.runTests($e)},get onDidChangeTestResults(){return(0,et.$BF)(Be,"testObserver"),at(oi.onResultsChanged)},get testResults(){return(0,et.$BF)(Be,"testObserver"),oi.results}},fi=bt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension($e,Ee){(0,et.$AF)(Be,"extensionsAny")||(Ee=!1);const ze=ti.mine.getExtensionDescription($e);if(ze)return new Y.$Ugc(Dt,Be.identifier,ze,fi,!1);if(Ee){const ut=ti.all.getExtensionDescription($e);if(ut)return new Y.$Ugc(Dt,Be.identifier,ut,fi,!0)}},get all(){const $e=[];for(const Ee of ti.mine.getAllExtensionDescriptions())$e.push(new Y.$Ugc(Dt,Be.identifier,Ee,fi,!1));return $e},get allAcrossExtensionHosts(){(0,et.$BF)(Be,"extensionsAny");const $e=new v.$lm(ti.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of ti.all.getAllExtensionDescriptions()){const ut=!$e.has(ze.identifier);Ee.push(new Y.$Ugc(Dt,Be.identifier,ze,fi,ut))}return Ee},get onDidChange(){return(0,et.$AF)(Be,"extensionsAny")?at(g.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):at(ti.mine.onDidChange)}},rn={createDiagnosticCollection($e){return ui.createDiagnosticCollection(Be.identifier,$e)},get onDidChangeDiagnostics(){return at(ui.onDidChangeDiagnostics)},getDiagnostics:$e=>ui.getDiagnostics($e),getLanguages(){return li.getLanguages()},setTextDocumentLanguage($e,Ee){return li.changeLanguage($e.uri,Ee)},match($e,Ee){const ze=Rt.getDocumentData(Ee.uri)?.notebook;return(0,R.$At)(it.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider($e,Ee,ze){return dt.registerCodeActionProvider(Be,wt($e),Ee,ze)},registerDocumentPasteEditProvider($e,Ee,ze){return(0,et.$BF)(Be,"documentPaste"),dt.registerDocumentPasteEditProvider(Be,wt($e),Ee,ze)},registerCodeLensProvider($e,Ee){return dt.registerCodeLensProvider(Be,wt($e),Ee)},registerDefinitionProvider($e,Ee){return dt.registerDefinitionProvider(Be,wt($e),Ee)},registerDeclarationProvider($e,Ee){return dt.registerDeclarationProvider(Be,wt($e),Ee)},registerImplementationProvider($e,Ee){return dt.registerImplementationProvider(Be,wt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return dt.registerTypeDefinitionProvider(Be,wt($e),Ee)},registerHoverProvider($e,Ee){return dt.registerHoverProvider(Be,wt($e),Ee,Be.identifier)},registerEvaluatableExpressionProvider($e,Ee){return dt.registerEvaluatableExpressionProvider(Be,wt($e),Ee,Be.identifier)},registerInlineValuesProvider($e,Ee){return dt.registerInlineValuesProvider(Be,wt($e),Ee,Be.identifier)},registerDocumentHighlightProvider($e,Ee){return dt.registerDocumentHighlightProvider(Be,wt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return dt.registerMultiDocumentHighlightProvider(Be,wt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return dt.registerLinkedEditingRangeProvider(Be,wt($e),Ee)},registerReferenceProvider($e,Ee){return dt.registerReferenceProvider(Be,wt($e),Ee)},registerRenameProvider($e,Ee){return dt.registerRenameProvider(Be,wt($e),Ee)},registerDocumentSymbolProvider($e,Ee,ze){return dt.registerDocumentSymbolProvider(Be,wt($e),Ee,ze)},registerWorkspaceSymbolProvider($e){return dt.registerWorkspaceSymbolProvider(Be,$e)},registerDocumentFormattingEditProvider($e,Ee){return dt.registerDocumentFormattingEditProvider(Be,wt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return dt.registerDocumentRangeFormattingEditProvider(Be,wt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,ze,...ut){return dt.registerOnTypeFormattingEditProvider(Be,wt($e),Ee,[ze].concat(ut))},registerDocumentSemanticTokensProvider($e,Ee,ze){return dt.registerDocumentSemanticTokensProvider(Be,wt($e),Ee,ze)},registerDocumentRangeSemanticTokensProvider($e,Ee,ze){return dt.registerDocumentRangeSemanticTokensProvider(Be,wt($e),Ee,ze)},registerSignatureHelpProvider($e,Ee,ze,...ut){return typeof ze=="object"?dt.registerSignatureHelpProvider(Be,wt($e),Ee,ze):dt.registerSignatureHelpProvider(Be,wt($e),Ee,typeof ze>"u"?[]:[ze,...ut])},registerCompletionItemProvider($e,Ee,...ze){return dt.registerCompletionItemProvider(Be,wt($e),Ee,ze)},registerInlineCompletionItemProvider($e,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,et.$BF)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$BF)(Be,"inlineCompletionsAdditions"),ze&&(0,et.$BF)(Be,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Be,wt($e),Ee,ze)},registerDocumentLinkProvider($e,Ee){return dt.registerDocumentLinkProvider(Be,wt($e),Ee)},registerColorProvider($e,Ee){return dt.registerColorProvider(Be,wt($e),Ee)},registerFoldingRangeProvider($e,Ee){return dt.registerFoldingRangeProvider(Be,wt($e),Ee)},registerSelectionRangeProvider($e,Ee){return dt.registerSelectionRangeProvider(Be,$e,Ee)},registerCallHierarchyProvider($e,Ee){return dt.registerCallHierarchyProvider(Be,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return dt.registerTypeHierarchyProvider(Be,$e,Ee)},setLanguageConfiguration:($e,Ee)=>dt.setLanguageConfiguration(Be,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,et.$BF)(Be,"tokenInformation"),li.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return dt.registerInlayHintsProvider(Be,$e,Ee)},createLanguageStatusItem($e,Ee){return li.createLanguageStatusItem(Be,$e,Ee)},registerDocumentDropEditProvider($e,Ee,ze){return dt.registerDocumentOnDropEditProvider(Be,$e,Ee,(0,et.$AF)(Be,"dropMetadata")?ze:void 0)}},mn={get activeTextEditor(){return jt.getActiveTextEditor()},get visibleTextEditors(){return jt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument($e,Ee,ze){const ut=await($.URI.isUri($e)?Promise.resolve(sn.openTextDocument($e)):Promise.resolve($e));return jt.showTextDocument(ut,Ee,ze)},createTextEditorDecorationType($e){return jt.createTextEditorDecorationType(Be,$e)},onDidChangeActiveTextEditor($e,Ee,ze){return at(jt.onDidChangeActiveTextEditor)($e,Ee,ze)},onDidChangeVisibleTextEditors($e,Ee,ze){return at(jt.onDidChangeVisibleTextEditors)($e,Ee,ze)},onDidChangeTextEditorSelection($e,Ee,ze){return at(jt.onDidChangeTextEditorSelection)($e,Ee,ze)},onDidChangeTextEditorOptions($e,Ee,ze){return at(jt.onDidChangeTextEditorOptions)($e,Ee,ze)},onDidChangeTextEditorVisibleRanges($e,Ee,ze){return at(jt.onDidChangeTextEditorVisibleRanges)($e,Ee,ze)},onDidChangeTextEditorViewColumn($e,Ee,ze){return at(jt.onDidChangeTextEditorViewColumn)($e,Ee,ze)},onDidCloseTerminal($e,Ee,ze){return at(st.onDidCloseTerminal)($e,Ee,ze)},onDidOpenTerminal($e,Ee,ze){return at(st.onDidOpenTerminal)($e,Ee,ze)},onDidChangeActiveTerminal($e,Ee,ze){return at(st.onDidChangeActiveTerminal)($e,Ee,ze)},onDidChangeTerminalDimensions($e,Ee,ze){return(0,et.$BF)(Be,"terminalDimensions"),at(st.onDidChangeTerminalDimensions)($e,Ee,ze)},onDidChangeTerminalState($e,Ee,ze){return at(st.onDidChangeTerminalState)($e,Ee,ze)},onDidWriteTerminalData($e,Ee,ze){return(0,et.$BF)(Be,"terminalDataWriteEvent"),at(st.onDidWriteTerminalData)($e,Ee,ze)},onDidExecuteTerminalCommand($e,Ee,ze){return(0,et.$BF)(Be,"terminalExecuteCommandEvent"),at(st.onDidExecuteTerminalCommand)($e,Ee,ze)},get state(){return Ne.getState(Be)},onDidChangeWindowState($e,Ee,ze){return at(Ne.onDidChangeWindowState)($e,Ee,ze)},showInformationMessage($e,...Ee){return ki.showMessage(Be,b.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return ki.showMessage(Be,b.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return ki.showMessage(Be,b.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,ze){return si.showQuickPick(Be,$e,Ee,ze)},showWorkspaceFolderPick($e){return si.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return si.showInput($e,Ee)},showOpenDialog($e){return Oi.showOpenDialog(Be,$e)},showSaveDialog($e){return Oi.showSaveDialog($e)},createStatusBarItem($e,Ee,ze){let ut,vt,Mt;return typeof $e=="string"?(ut=$e,vt=Ee,Mt=ze):(vt=$e,Mt=Ee),ei.createStatusBarEntry(Be,ut,vt,Mt)},setStatusBarMessage($e,Ee){return ei.setStatusBarMessage($e,Ee)},withScmProgress($e){return Fe.report("window.withScmProgress",Be,"Use 'withProgress' instead."),wi.withProgress(Be,{location:Oe.ProgressLocation.SourceControl},(Ee,ze)=>$e({report(ut){}}))},withProgress($e,Ee){return wi.withProgress(Be,$e,Ee)},createOutputChannel($e,Ee){return It.createOutputChannel($e,Ee,Be)},createWebviewPanel($e,Ee,ze,ut){return Mi.createWebviewPanel(Be,$e,Ee,ze,ut)},createWebviewTextEditorInset($e,Ee,ze,ut){return(0,et.$BF)(Be,"editorInsets"),Pi.createWebviewEditorInset($e,Ee,ze,ut,Be)},createTerminal($e,Ee,ze){return typeof $e=="object"?"pty"in $e?st.createExtensionTerminal($e):st.createTerminalFromOptions($e):st.createTerminal($e,Ee,ze)},registerTerminalLinkProvider($e){return st.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return st.registerProfileProvider(Be,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,et.$BF)(Be,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider($e,Be.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return $i.registerTreeDataProvider($e,Ee,Be)},createTreeView($e,Ee){return $i.createTreeView($e,Ee,Be)},registerWebviewPanelSerializer:($e,Ee)=>Mi.registerWebviewPanelSerializer(Be,$e,Ee),registerCustomEditorProvider:($e,Ee,ze={})=>un.registerCustomEditorProvider(Be,$e,Ee,ze),registerFileDecorationProvider($e){return qe.registerFileDecorationProvider($e,Be)},registerUriHandler($e){return gi.registerUriHandler(Be,$e)},createQuickPick(){return si.createQuickPick(Be)},createInputBox(){return si.createInputBox(Be)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,ze){return at(Ri.onDidChangeActiveColorTheme)($e,Ee,ze)},registerWebviewViewProvider($e,Ee,ze){return Fi.registerWebviewViewProvider(Be,$e,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,ze){return at(Pt.onDidChangeActiveNotebookEditor)($e,Ee,ze)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,ze){return at(mi.onDidChangeNotebookEditorSelection)($e,Ee,ze)},onDidChangeNotebookEditorVisibleRanges($e,Ee,ze){return at(mi.onDidChangeNotebookEditorVisibleRanges)($e,Ee,ze)},showNotebookDocument($e,Ee){return Pt.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,ze){return(0,et.$BF)(Be,"externalUriOpener"),ln.registerExternalUriOpener(Be.identifier,$e,Ee,ze)},registerProfileContentHandler($e,Ee){return(0,et.$BF)(Be,"profileContentHandlers"),hn.registerProfileContentHandler(Be,$e,Ee)},registerQuickDiffProvider($e,Ee,ze,ut){return(0,et.$BF)(Be,"quickDiffProvider"),Ai.registerQuickDiffProvider(wt($e),Ee,ze,ut)},get tabGroups(){return se.tabGroups},registerShareProvider($e,Ee){return(0,et.$BF)(Be,"shareProvider"),Qi.registerShareProvider(wt($e),Ee)}},sn={get rootPath(){return Fe.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new O.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new O.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...ze)=>ft.updateWorkspaceFolders(Be,$e,Ee||0,...ze),onDidChangeWorkspaceFolders:function($e,Ee,ze){return at(ft.onDidChangeWorkspace)($e,Ee,ze)},asRelativePath:($e,Ee)=>ft.getRelativePath($e,Ee),findFiles:($e,Ee,ze,ut)=>ft.findFiles($e,Ee,ze,Be.identifier,ut),findTextInFiles:($e,Ee,ze,ut)=>{(0,et.$BF)(Be,"findTextInFiles");let vt,Mt;return typeof Ee=="object"?(vt=Ee,Mt=ze):(vt={},Mt=Ee,ut=ze),ft.findTextInFiles($e,vt||{},Mt,Be.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Ee){return Yt.applyWorkspaceEdit($e,Be,Ee)},createFileSystemWatcher:($e,Ee,ze,ut)=>{let vt;return typeof Ee=="boolean"?vt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,et.$BF)(Be,"createFileSystemWatcher"),vt={...Ee,correlate:!0}),_t.createFileSystemWatcher(ft,Be,$e,vt)},get textDocuments(){return Rt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new O.$9("textDocuments")},openTextDocument($e){let Ee;const ze=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!ze||typeof ze=="object")Ee=Rt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>Rt.ensureDocumentData(ut).then(vt=>vt.document))},onDidOpenTextDocument:($e,Ee,ze)=>at(Rt.onDidAddDocument)($e,Ee,ze),onDidCloseTextDocument:($e,Ee,ze)=>at(Rt.onDidRemoveDocument)($e,Ee,ze),onDidChangeTextDocument:($e,Ee,ze)=>at(Rt.onDidChangeDocument)($e,Ee,ze),onDidSaveTextDocument:($e,Ee,ze)=>at(Rt.onDidSaveDocument)($e,Ee,ze),onWillSaveTextDocument:($e,Ee,ze)=>at(Gi.getOnWillSaveTextDocumentEvent(Be))($e,Ee,ze),get notebookDocuments(){return Pt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let ze;if($.URI.isUri($e))ze=$e,await Pt.openNotebookDocument($e);else if(typeof $e=="string")ze=$.URI.revive(await Pt.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument($e,Ee,ze){return at(ri.onDidSaveNotebookDocument)($e,Ee,ze)},onDidChangeNotebookDocument($e,Ee,ze){return at(ri.onDidChangeNotebookDocument)($e,Ee,ze)},onWillSaveNotebookDocument($e,Ee,ze){return at(Ii.getOnWillSaveNotebookDocumentEvent(Be))($e,Ee,ze)},get onDidOpenNotebookDocument(){return at(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,ze,ut){return Pt.registerNotebookSerializer(Be,$e,Ee,ze,(0,et.$AF)(Be,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,Ee,ze)=>at(tn.onDidChangeConfiguration)($e,Ee,ze),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,tn.getConfiguration($e,Ee,Be)},registerTextDocumentContentProvider($e,Ee){return Di.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Fe.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Be,$e,Ee)),registerFileSystemProvider($e,Ee,ze){return(0,I.$Qc)(Ji.registerFileSystemProvider(Be,$e,Ee,ze),qt.addFileSystemProvider($e,Ee,ze))},get fs(){return qt.value},registerFileSearchProvider:($e,Ee)=>((0,et.$BF)(Be,"fileSearchProvider"),Bt.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,et.$BF)(Be,"textSearchProvider"),Bt.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,et.$BF)(Be,"resolvers"),Dt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,et.$BF)(Be,"resolvers"),Xi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,et.$BF)(Be,"resolvers"),Dt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,ze)=>at(_t.onDidCreateFile)($e,Ee,ze),onDidDeleteFiles:($e,Ee,ze)=>at(_t.onDidDeleteFile)($e,Ee,ze),onDidRenameFiles:($e,Ee,ze)=>at(_t.onDidRenameFile)($e,Ee,ze),onWillCreateFiles:($e,Ee,ze)=>at(_t.getOnWillCreateFileEvent(Be))($e,Ee,ze),onWillDeleteFiles:($e,Ee,ze)=>at(_t.getOnWillDeleteFileEvent(Be))($e,Ee,ze),onWillRenameFiles:($e,Ee,ze)=>at(_t.getOnWillRenameFileEvent(Be))($e,Ee,ze),openTunnel:$e=>((0,et.$BF)(Be,"tunnels"),Tt.openTunnel(Be,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$BF)(Be,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:($e,Ee,ze)=>((0,et.$BF)(Be,"tunnels"),at(Tt.onDidChangeTunnels)($e,Ee,ze)),registerPortAttributesProvider:($e,Ee)=>((0,et.$BF)(Be,"portsAttributes"),Tt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,et.$BF)(Be,"tunnelFactory"),Tt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,et.$BF)(Be,"timeline"),Yi.registerTimelineProvider($e,Ee,Be.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,et.$BF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,ze)=>at(ft.onDidGrantWorkspaceTrust)($e,Ee,ze),registerEditSessionIdentityProvider:($e,Ee)=>((0,et.$BF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,ze)=>((0,et.$BF)(Be,"editSessionIdentityProvider"),at(ft.getOnWillCreateEditSessionIdentityEvent(Be))($e,Ee,ze)),registerCanonicalUriProvider:($e,Ee)=>((0,et.$BF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,ze)=>((0,et.$BF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri($e,Ee,ze))},on={get inputBox(){return Fe.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Be)},createSourceControl($e,Ee,ze){return bi.createSourceControl(Be,$e,Ee,ze)}},an={createCommentController($e,Ee){return Li.createCommentController(Be,$e,Ee)}},zi={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession($e,Ee,ze){return at($t.onDidStartDebugSession)($e,Ee,ze)},onDidTerminateDebugSession($e,Ee,ze){return at($t.onDidTerminateDebugSession)($e,Ee,ze)},onDidChangeActiveDebugSession($e,Ee,ze){return at($t.onDidChangeActiveDebugSession)($e,Ee,ze)},onDidReceiveDebugSessionCustomEvent($e,Ee,ze){return at($t.onDidReceiveDebugSessionCustomEvent)($e,Ee,ze)},onDidChangeBreakpoints($e,Ee,ze){return at($t.onDidChangeBreakpoints)($e,Ee,ze)},onDidChangeStackFrameFocus($e,Ee,ze){return(0,et.$BF)(Be,"debugFocus"),at($t.onDidChangeStackFrameFocus)($e,Ee,ze)},registerDebugConfigurationProvider($e,Ee,ze){return $t.registerDebugConfigurationProvider($e,Ee,ze||Ut.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return $t.registerDebugAdapterDescriptorFactory(Be,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return $t.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?$t.startDebugging($e,Ee,{parentSession:ze}):$t.startDebugging($e,Ee,ze||{})},stopDebugging($e){return $t.stopDebugging($e)},addBreakpoints($e){return $t.addBreakpoints($e)},removeBreakpoints($e){return $t.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return $t.asDebugSourceUri($e,Ee)}},Bi={registerTaskProvider:($e,Ee)=>kt.registerTaskProvider(Be,$e,Ee),fetchTasks:$e=>kt.fetchTasks($e),executeTask:$e=>kt.executeTask(Be,$e),get taskExecutions(){return kt.taskExecutions},onDidStartTask:($e,Ee,ze)=>at(kt.onDidStartTask)($e,Ee,ze),onDidEndTask:($e,Ee,ze)=>at(kt.onDidEndTask)($e,Ee,ze),onDidStartTaskProcess:($e,Ee,ze)=>at(kt.onDidStartTaskProcess)($e,Ee,ze),onDidEndTaskProcess:($e,Ee,ze)=>at(kt.onDidEndTaskProcess)($e,Ee,ze)},Wi={createNotebookController($e,Ee,ze,ut,vt){return ci.createNotebookController(Be,$e,Ee,ze,ut,(0,et.$AF)(Be,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(Be,$e,Ee),createRendererMessaging($e){return Ci.createRendererMessaging(Be,$e)},createNotebookControllerDetectionTask($e){return(0,et.$BF)(Be,"notebookKernelSource"),ci.createNotebookControllerDetectionTask(Be,$e)},registerKernelSourceActionProvider($e,Ee){return(0,et.$BF)(Be,"notebookKernelSource"),ci.registerKernelSourceActionProvider(Be,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,ze){return(0,et.$BF)(Be,"notebookCellExecutionState"),at(ci.onDidChangeNotebookCellExecutionState)($e,Ee,ze)}},Si={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),ze=!$e||typeof $e[0]!="object"?$e:$e[0];return yt.getMessage(Be.identifier.value,{message:Ee,args:ze})}return yt.getMessage(Be.identifier.value,$e[0])},get bundle(){return yt.getBundle(Be.identifier.value)},get uri(){return yt.getBundleUri(Be.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,et.$BF)(Be,"interactive"),Zi.registerProvider(Be,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,et.$BF)(Be,"interactive"),vi.registerChatProvider(Be,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,et.$BF)(Be,"interactive"),vi.sendInteractiveRequestToProvider($e,Ee)},transferChatSession($e,Ee){return(0,et.$BF)(Be,"interactive"),vi.transferChatSession($e,Ee)}},Vi={getRelatedInformation($e,Ee){return(0,et.$BF)(Be,"aiRelatedInformation"),en.getRelatedInformation(Be,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,et.$BF)(Be,"aiRelatedInformation"),en.registerRelatedInformationProvider(Be,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,et.$BF)(Be,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Be,$e,Ee)}},$n={registerChatResponseProvider($e,Ee,ze){return(0,et.$BF)(Be,"chatProvider"),di.registerProvider(Be.identifier,$e,Ee,ze)},requestChatAccess($e){return(0,et.$BF)(Be,"chatRequestAccess"),di.requestChatResponseProvider(Be.identifier,$e)},registerVariable($e,Ee,ze){return(0,et.$BF)(Be,"chatAgents2"),_i.registerVariableResolver(Be,$e,Ee,ze)},registerMappedEditsProvider($e,Ee){return(0,et.$BF)(Be,"mappedEditsProvider"),dt.registerMappedEditsProvider(Be,$e,Ee)},createChatAgent($e,Ee){return(0,et.$BF)(Be,"chatAgents2"),xi.createChatAgent(Be,$e,Ee)}},bn={registerSpeechProvider($e,Ee){return(0,et.$BF)(Be,"speech"),yi.registerProvider(Be.identifier,$e,Ee)}};return{version:bt.version,ai:Vi,authentication:fn,commands:gn,comments:an,chat:$n,debug:zi,env:ji,extensions:nn,interactive:qi,l10n:Si,languages:rn,notebooks:Wi,scm:on,speech:bn,tasks:Bi,tests:Ui,window:mn,workspace:sn,Breakpoint:Oe.$6L,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$XM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$WM,CallHierarchyIncomingCall:Oe.$sL,CallHierarchyItem:Oe.$rL,CallHierarchyOutgoingCall:Oe.$tL,CancellationError:O.$5,CancellationTokenSource:D.$5d,CandidatePortSource:r.CandidatePortSource,CodeAction:Oe.$oL,CodeActionKind:Oe.$pL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$uL,Color:Oe.$HL,ColorInformation:Oe.$IL,ColorPresentation:Oe.$JL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$BL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$CL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$RL,DebugAdapterExecutable:Oe.$0L,DebugAdapterInlineImplementation:Oe.$aM,DebugAdapterNamedPipeServer:Oe.$_L,DebugAdapterServer:Oe.$$L,DebugConfigurationProviderTriggerKind:Ut.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$iL,DiagnosticRelatedInformation:Oe.$hL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$7K,DocumentHighlight:Oe.$kL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$lL,DocumentLink:Oe.$GL,DocumentSymbol:Oe.$nL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$dM,InlineValueText:Oe.$eM,InlineValueVariableLookup:Oe.$fM,InlineValueEvaluatableExpression:Oe.$gM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:g.$Ud,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$qM,FileDecoration2:Oe.$qM,FileSystemError:Oe.$iM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$jM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$8L,InlineCompletionItem:Oe.$DL,InlineCompletionList:Oe.$EL,Hover:Oe.$jL,IndentAction:C.IndentAction,Location:Oe.$gL,MarkdownString:Oe.$vL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Oe.$wL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$8K,ProcessExecution:Oe.$PL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$pM,Range:Oe.$9K,RelativePattern:Oe.$4L,Selection:Oe.$0K,SelectionRange:Oe.$qL,SemanticTokens:Oe.$mM,SemanticTokensBuilder:Oe.$lM,SemanticTokensEdit:Oe.$nM,SemanticTokensEdits:Oe.$oM,SemanticTokensLegend:Oe.$kM,ShellExecution:Oe.$QL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$yL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$xL,SnippetString:Oe.$fL,SourceBreakpoint:Oe.$7L,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$mL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$SL,TaskGroup:Oe.$OL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$KL,TerminalQuickFixTerminalCommand:Oe.$ML,TerminalQuickFixOpener:Oe.$LL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$NL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$bL,SnippetTextEdit:Oe.$dL,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$3L,ThemeIcon:Oe.$2L,TreeItem:Oe.$TL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$LM,UIKind:Lt.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$eL,DocumentDropEdit:Oe.$ZL,DocumentPasteEdit:Oe.$1L,InlayHint:Oe.$AL,InlayHintLabelPart:Oe.$zL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$aL,ResolvedAuthority:Oe.$$K,ManagedResolvedAuthority:Oe.$_K,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$AM,NotebookRange:Oe.$sM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$tM,NotebookData:Oe.$uM,NotebookRendererScript:Oe.$yM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$wM,NotebookCellOutputItem:Oe.$vM,NotebookCellStatusBarItem:Oe.$xM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$cL,NotebookKernelSourceAction:Oe.$zM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$CM,LinkedEditingRanges:Oe.$BM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$DM,TestMessage:Oe.$EM,TestMessage2:Oe.$EM,TestTag:Oe.$FM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$YL,DataTransferItem:Oe.$UL,CoveredCount:Oe.$GM,FileCoverage:Oe.$HM,StatementCoverage:Oe.$IM,BranchCoverage:Oe.$JM,FunctionCoverage:Oe.$KM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$MM,TabInputTextDiff:Oe.$NM,TabInputTextMerge:Oe.$OM,TabInputCustom:Oe.$PM,TabInputNotebook:Oe.$RM,TabInputNotebookDiff:Oe.$SM,TabInputWebview:Oe.$QM,TabInputTerminal:Oe.$TM,TabInputInteractiveWindow:Oe.$UM,TabInputChat:Oe.$VM,TelemetryTrustedValue:o.$Jo,LogLevel:h.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$bM,ThreadFocus:Oe.$cM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$Zhc=Jt}),define(ke[369],Se([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,58,117,90,70,150,13,59,115,116]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u,s,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Xr)(l.$Ogc,l.$Ngc,1),(0,D.$Xr)(u.$nj,t.$1hc,1),(0,D.$Xr)(h.$Zfc,h.$1fc,1),(0,D.$Xr)(b.$sN,b.$rN,0),(0,D.$Xr)(L.$igc,L.$ggc,0),(0,D.$Xr)(o.$kgc,o.$jgc,0),(0,D.$Xr)(C.$Ygc,C.$3gc,0),(0,D.$Xr)(I.$5gc,I.$4gc,0),(0,D.$Xr)($.$hN,$.$gN,0),(0,D.$Xr)(a.$Pgc,a.$Qgc,0),(0,D.$Xr)(i.$Wfc,i.$Vfc,0),(0,D.$Xr)(O.$yhc,O.$xhc,1),(0,D.$Xr)(m.$ihc,m.$jhc,0),(0,D.$Xr)(v.$Dgc,v.$Cgc,0),(0,D.$Xr)(R.$Lhc,R.$Khc,0),(0,D.$Xr)(y.$Ggc,y.$Jgc,0),(0,D.$Xr)(S.$kyb,S.$lyb,0),(0,D.$Xr)(f.$Yhc,f.$Xhc,0),(0,D.$Xr)(g.$fgc,g.$egc,0),(0,D.$Xr)(r.$Lgc,r.$Kgc,0),(0,D.$Xr)(n.$qN,n.$nN,0),(0,D.$Xr)(c.$ugc,c.$vgc,0),(0,D.$Xr)(s.$Wgc,s.$Xgc,0)}),define(ke[119],Se([1,0,19,13,36,94]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=e.$eic=void 0;function L(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$eic=L;function b(C,m,v,S){const h=(0,D.$2b)(v,$),f=new g.$uJ(m,h,S),o=f.preview.matches;return{ranges:(0,D.$2b)(h,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(o,y)}}}e.$fic=b;function $(C){return new g.$vJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$jJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(m,v){this.a=m,this.b=v}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$gic=R,e.$gic=R=Ge([We(1,O.$mj)],R)}),define(ke[370],Se([1,0,51,16,76,33,10,12,119,371]),function(me,e,D,O,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=e.$hic=void 0;const R=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(r,n,c,t){const u=m(r,n,c,t),s=n.folder.fsPath;return{cmd:D.spawn(R,u.args,{cwd:s}),rgDiskPath:R,siblingClauses:u.siblingClauses,rgArgs:u,cwd:s}}e.$hic=C;function m(r,n,c,t){const u=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],c,!1).forEach(l=>{const a=(0,$.$eic)(l);if(u.push("-g",a),L.$j){const d=(0,g.$Gl)(a);d!==a&&u.push("-g",d)}});const s=v([n],t,void 0,!1);return s.globArgs.forEach(l=>{const a=`!${(0,$.$eic)(l)}`;if(u.push("-g",a),L.$j){const d=(0,g.$Gl)(a);d!==a&&u.push("-g",d)}}),n.disregardIgnoreFiles!==!1?u.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),n.ignoreSymlinks||u.push("--follow"),r.exists&&u.push("--quiet"),u.push("--no-config"),n.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:s.siblingClauses}}function v(r,n,c,t=!0){const u=[];let s={};return r.forEach(l=>{const a=Object.assign({},l.excludePattern||{},n||{}),d=h(a,t?l.folder.fsPath:void 0,c);u.push(...d.globArgs),d.siblingClauses&&(s=Object.assign(s,d.siblingClauses))}),{globArgs:u,siblingClauses:s}}function S(r,n,c=!0){const t=[];return r.forEach(u=>{const s=Object.assign({},n||{},u.includePattern||{}),l=h(s,c?u.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function h(r,n,c){const t=[],u={};return Object.keys(r).forEach(s=>{if(c&&c.has(s)||!s)return;const l=r[s];s=o(n?f(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof l=="boolean"&&l?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):l&&l.when&&(u[s]=l)}),{globArgs:t,siblingClauses:u}}function f(r,n){return O.$ic(n)?n:O.$jc(r,n)}e.$iic=f;function o(r){return r=b.$Te(r,"\\"),b.$Te(r,"/")}function i(r){return I.$3f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$jic=i}),define(ke[372],Se([1,0,51,56,16,373,19,44,34,76,33,10,38,12,18,31,36,370,129]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=e.$kic=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$Lj(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Yq)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$Lj(l.excludePattern),this.t=new Map,l.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),k=a.folder.fsPath;l.folderQueries.map(P=>P.folder.fsPath).filter(P=>P!==k).forEach(P=>{(0,R.$7f)(P,k)&&(d[g.$lc(k,P)]=!0)}),this.t.set(k,new t(d,k))})}cancel(){this.l=!0,r.forEach(l=>l())}walk(l,a,d,k,P){if(this.m=m.$Qd.create(!1),this.l)return P(null,this.j);a.forEach(p=>{const w=g.$nc(p.fsPath);this.u&&this.u(p.fsPath,w)||this.J(d,{relativePath:p.fsPath,searchPath:void 0})}),this.r=m.$Qd.create(!1),this.w(l,(p,w)=>{this.x(this.y,this,p,d,k,E=>{if(E){const A=(0,b.$Pi)(E);console.error(A),this.q.push(A),w(E,void 0)}else w(null,void 0)})},(p,w)=>{this.m.stop();const E=p?L.$Hb(p)[0]:null;P(E,this.j)})}w(l,a,d){const k=new Array(l.length),P=new Array(l.length);let p=!1,w=0;if(l.length===0)return d(null,[]);l.forEach((E,A)=>{a(E,(T,U)=>{if(T?(p=!0,k[A]=null,P[A]=T):(k[A]=U,P[A]=null),++w===l.length)return d(p?P:null,k)})})}x(l,a,...d){try{l.apply(a,d)}catch(k){d[d.length-1](k)}}y(l,a,d,k){const P=l.folder.fsPath,p=C.$j,w=()=>N&&N.kill();r.add(w);let E=B=>{r.delete(w),E=()=>{},k(B)},A="";const T=this.D(),U=(0,o.$hic)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),N=U.cmd,j=!Object.keys(U.siblingClauses).length,F=U.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let M=`${U.rgDiskPath} ${F}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),d({message:M}),this.s=0,this.z(N,"utf8",d,(B,X,ue)=>{if(B){E(B);return}if(this.j){E();return}const J=(A+(p?y.$Fl(X||""):X)).split(`
`);if(ue){const Y=J.length;J[Y-1]=J[Y-1].trim(),J[Y-1]||J.pop()}else A=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=J.length,j){for(const Y of J)if(this.J(a,{base:P,relativePath:Y,searchPath:this.N(l,Y)}),this.j){w();break}(ue||this.j)&&E();return}this.G(l,T,P,J,a),ue&&(this.H(T,P,a),E())})}spawnFindCmd(l){const a=this.t.get(l.folder.fsPath),d=a.getBasenameTerms(),k=a.getPathTerms(),P=["-L","."];if(d.length||k.length){P.push("-not","(","(");for(const p of d)P.push("-name",p),P.push("-o");for(const p of k)P.push("-path",p),P.push("-o");P.pop(),P.push(")","-prune",")")}return P.push("-type","f"),D.spawn("find",P,{cwd:l.folder.fsPath})}readStdout(l,a,d){let k="";this.z(l,a,()=>{},(P,p,w)=>{if(P){d(P);return}k+=p,w&&d(null,k)})}z(l,a,d,k){let P=(E,A,T)=>{(E||T)&&(P=()=>{},this.r?.stop()),k(E,A,T)},p=!1;l.stdout?(this.A(l.stdout,a,P),l.stdout.once("data",()=>p=!0)):d({message:"stdout is null"});let w;l.stderr?w=this.B(l.stderr):d({message:"stderr is null"}),l.on("error",E=>{P(E)}),l.on("close",E=>{let A;!p&&(A=this.C(w,a))&&u(A)?P(new Error(`command failed with error code ${E}: ${this.C(w,a)}`)):(this.g&&E===0&&(this.j=!0),P(null,"",!0))})}A(l,a,d){const k=new I.StringDecoder(a);return l.on("data",P=>{d(null,k.write(P))}),k}B(l){const a=[];return l.on("data",d=>{a.push(d)}),a}C(l,a){const d=new I.StringDecoder(a);return l.map(k=>d.write(k)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:a},d,k,P){k.indexOf(this.b)!==-1&&this.J(P,{base:d,relativePath:this.b,searchPath:this.N(l,this.b)});const p=w=>{const E=g.$nc(w),A=g.$mc(w);let T=a[A];T||(T=a[A]=[],p(A)),T.push({base:d,relativePath:w,basename:E,searchPath:this.N(l,w)})};k.forEach(p)}H({rootEntries:l,pathToEntries:a},d,k){const P=this,p=this.t.get(d),w=this.b;function E(A){P.o++;const T=(0,f.$KJ)(()=>A.map(U=>U.basename));for(let U=0,N=A.length;U<N;U++){const j=A[U],{relativePath:F,basename:M}=j;if(p.test(F,M,w!==M?T:void 0))continue;const B=a[F];if(B)E(B);else{if(P.p++,F===w)continue;P.J(k,j)}if(P.j)break}}E(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,a,d,k,P){const p=l.folder,w=(0,f.$KJ)(()=>d);this.w(d,(E,A)=>{if(this.l||this.j)return A(null);const T=a?[a,E].join(g.sep):E;if(this.t.get(l.folder.fsPath).test(T,E,this.a.filePattern!==E?w:void 0))return A(null);const U=[p.fsPath,T].join(g.sep);O.lstat(U,(N,j)=>{if(N||this.l||this.j)return A(null);this.L(U,j,(F,M)=>F||this.l||this.j?A(null):M.isDirectory()?(this.o++,this.M(U,j,(B,X)=>B||this.l||this.j||(X=X||"",this.v[X])?A(null):(this.v[X]=!0,h.Promises.readdir(U).then(ue=>{if(this.l||this.j)return A(null);this.I(l,T,ue,k,Z=>A(Z||null))},ue=>{A(null)})))):(this.p++,T===this.b||this.h&&S.$Lf(M.size)&&M.size>this.h||this.J(k,{base:p.fsPath,relativePath:T,searchPath:this.N(l,T)}),A(null,void 0)))})},E=>{const A=E&&L.$Hb(E);return P(A&&A.length>0?A[0]:void 0)})}J(l,a){this.K(a)&&(!this.d||this.d(a.relativePath,g.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(a))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$FJ)(l,this.c)}return!0}L(l,a,d){return a.isSymbolicLink()?O.stat(l,d):d(null,a)}M(l,a,d){return a.isSymbolicLink()?O.realpath(l,(k,P)=>k?d(k):d(null,P)):d(null,l)}N(l,a){return l.folderName?g.$jc(l.folderName,a):a}}e.$kic=n;class c{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new n(l)}search(l,a,d){this.c.walk(this.a,this.b,l,a,(k,P)=>{d(k,{limitHit:P,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$lic=c;class t{constructor(l,a){this.expression=l,this.c=a,this.d(l)}d(l){let a,d;Object.keys(l).filter(k=>l[k]).forEach(k=>{g.$ic(k)?(a=a||$.$Gj(),a[k]=l[k]):(d=d||$.$Gj(),d[k]=l[k])}),this.a=a&&$.$Lj(a,{trimForExclusions:!0}),this.b=d&&$.$Lj(d,{trimForExclusions:!0})}test(l,a,d){return this.b&&this.b(l,a,d)||this.a&&this.a(g.$jc(this.c,l),a,d)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$Nj(this.a)),this.b&&l.push(...$.$Nj(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$Oj(this.a)),this.b&&l.push(...$.$Oj(this.b)),l}}function u(s){const l=s.trim().split(`
`),a=l[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return v.$zf(l[l.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(ke[374],Se([1,0,98,22,186,21]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.DecodeStreamErrorKind=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=e.$fD=void 0,e.$fD="utf8",e.$gD="utf8bom",e.$hD="utf16be",e.$iD="utf16le";function L(a){return[e.$fD,e.$gD,e.$hD,e.$iD].some(d=>d===a)}e.$jD=L,e.$kD=[254,255],e.$lD=[255,254],e.$mD=[239,187,191];const b=512,$=512,y=512*8,R=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(d,k){super(d),this.decodeStreamErrorKind=k}}e.$nD=m;class v{static async create(d){let k;if(d!==e.$fD)k=(await(0,g.$eD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const P=new TextDecoder;k={write(p){return P.decode(p,{stream:!0})},end(){return P.decode()}}}return new v(k)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function S(a,d){const k=d.minBytesRequiredForDetection??d.guessEncoding?y:$;return new Promise((P,p)=>{const w=(0,D.$9d)(j=>j.join("")),E=[];let A=0,T;const U=new I.$5d,N=async()=>{try{const j=await l({buffer:O.$ie.concat(E),bytesRead:A},d.guessEncoding);if(j.seemsBinary&&d.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await d.overwriteEncoding(j.encoding),T=await v.create(j.encoding);const F=T.write(O.$ie.concat(E).buffer);w.write(F),E.length=0,A=0,P({stream:w,detected:j})}catch(j){U.cancel(),w.destroy(),p(j)}};(0,D.$ae)(a,{onData:async j=>{T?w.write(T.write(j.buffer)):(E.push(j),A+=j.byteLength,A>=k&&(a.pause(),await N(),setTimeout(()=>a.resume())))},onError:j=>w.error(j),onEnd:async()=>{T||await N(),w.end(T?.end())}},U.token)})}e.$oD=S;async function h(a,d,k){const p=(await(0,g.$eD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),k);let w=!1,E=!1;return{read(){if(E)return null;const A=a.read();if(typeof A!="string"){if(E=!0,!w&&k?.addBOM)switch(d){case e.$fD:case e.$gD:return O.$ie.wrap(Uint8Array.from(e.$mD));case e.$hD:return O.$ie.wrap(Uint8Array.from(e.$kD));case e.$iD:return O.$ie.wrap(Uint8Array.from(e.$lD))}const T=p.end();return T&&T.length>0?(w=!0,O.$ie.wrap(T)):null}return w=!0,O.$ie.wrap(p.write(A))}}}e.$pD=h;async function f(a){return(await(0,g.$eD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}e.$qD=f;function o(a){return a===e.$gD||a===null?e.$fD:a}e.$rD=o;function i(a,d){if(!a||d<e.$kD.length)return null;const k=a.readUInt8(0),P=a.readUInt8(1);if(k===e.$kD[0]&&P===e.$kD[1])return e.$hD;if(k===e.$lD[0]&&P===e.$lD[1])return e.$iD;if(d<e.$mD.length)return null;const p=a.readUInt8(2);return k===e.$mD[0]&&P===e.$mD[1]&&p===e.$mD[2]?e.$gD:null}e.$sD=i;const r=["ascii","utf-16","utf-32"];async function n(a){const d=await(0,g.$eD)("jschardet","dist/jschardet.min.js"),k=a.slice(0,R),P=u(k.buffer),p=d.detect(P);if(!p||!p.encoding)return null;const w=p.encoding.toLowerCase();return 0<=r.indexOf(w)?null:t(p.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(a){const d=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[d]||d}function u(a){let d="";for(let k=0;k<a.length;k++)d+=String.fromCharCode(a[k]);return d}function s(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=a.match(/windows(\d+)/);return d?"windows-"+d[1]:a}}}e.$tD=s;function l({buffer:a,bytesRead:d},k){let P=i(a,d),p=!1;if(P!==e.$hD&&P!==e.$iD&&a){let w=!0,E=!0,A=!1;for(let T=0;T<d&&T<b;T++){const U=T%2===1,N=a.readUInt8(T)===0;if(N&&(A=!0),w&&(U&&!N||!U&&N)&&(w=!1),E&&(U&&N||!U&&!N)&&(E=!1),N&&!w&&!E)break}A&&(w?P=e.$iD:E?P=e.$hD:p=!0)}return k&&!p&&!P&&a?n(a.slice(0,d)).then(w=>({seemsBinary:!1,encoding:w})):{seemsBinary:p,encoding:P}}e.$uD=l,e.$vD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,374,31,154]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;class I extends g.$ehc{constructor(b,$,y=O,R="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$tD)(C)},R)}}e.$tic=I}),define(ke[156],Se([1,0,51,390,373,19,73,34,12,2,36,94,391,371,119]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=e.$pic=e.$oic=e.$nic=e.$mic=void 0;const h=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(w){this.a=w}provideTextSearchResults(w,E,A,T){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((U,N)=>{T.onCancellationRequested(()=>J());const j=t(w,E),F=E.folder.fsPath,M=j.map(oe=>oe.match(/^-/)?oe:`'${oe}'`).join(" ");this.a.appendLine(`${h} ${M}
 - cwd: ${F}`);let B=D.spawn(h,j,{cwd:F});B.on("error",oe=>{console.error(oe),this.a.appendLine("Error: "+(oe&&oe.message)),N((0,R.$BJ)(new R.$zJ(oe&&oe.message,R.SearchErrorCode.rgProcessError)))});let X=!1;const ue=new r(E.maxResults,E.folder,E.previewOptions);ue.on("result",oe=>{X=!0,he="",A.report(oe)});let Z=!1;const J=()=>{Z=!0,B?.kill(),ue?.cancel()};let Y=!1;ue.on("hitLimit",()=>{Y=!0,J()});let he="";B.stdout.on("data",oe=>{ue.handleData(oe),X||(he+=oe)});let _=!1;B.stdout.once("data",()=>_=!0);let we="";B.stderr.on("data",oe=>{const K=oe.toString();this.a.appendLine(K),we.length+K.length<1e6&&(we+=K)}),B.on("close",()=>{if(this.a.appendLine(_?"Got data from stdout":"No data from stdout"),this.a.appendLine(X?"Got result from parser":"No result from parser"),he&&this.a.appendLine(`Got data without result: ${he}`),this.a.appendLine(""),Z)U({limitHit:Y});else{ue.flush(),B=null;let oe;we&&!_&&(oe=o(we))?N((0,R.$BJ)(new R.$zJ(oe.message,oe.code))):U({limitHit:Y})}})})}}e.$mic=f;function o(p){const w=p.split(`
`),E=w[0].trim();if(w.some(T=>T.startsWith("regex parse error")))return new R.$zJ(i(w),R.SearchErrorCode.regexParseError);const A=E.match(/grep config error: unknown encoding: (.*)/);if(A)return new R.$zJ(`Unknown encoding: ${A[1]}`,R.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new R.$zJ(E.charAt(0).toUpperCase()+E.substr(1),R.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new R.$zJ(E.charAt(0).toUpperCase()+E.substr(1),R.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new R.$zJ(E,R.SearchErrorCode.regexParseError)}function i(p){const w=["Regex parse error"],E=p.filter(A=>A.startsWith("PCRE2:"));if(E.length>=1){const A=E[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const T=A.split(":")[1];w.push(":"+T)}}return w.join("")}class r extends O.EventEmitter{constructor(w,E,A){super(),this.g=w,this.h=E,this.j=A,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,E){return super.on(w,E),this}handleData(w){if(this.b)return;const E=typeof w=="string"?w:this.d.write(w);this.k(E)}k(w){let E=w.indexOf(`
`);const A=this.a+w;if(E>=0)E+=this.a.length;else{this.a=A;return}let T=0;for(;E>=0;)this.m(A.substring(T,E).trim()),T=E+1,E=A.indexOf(`
`,T);this.a=A.substring(T)}m(w){if(this.b||!w)return;let E;try{E=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(E.type==="match"){const A=n(E.data.path),T=y.URI.joinPath(this.h,A),U=this.n(E.data,T);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const A=n(E.data.path),T=y.URI.joinPath(this.h,A);this.o(E.data,T).forEach(N=>this.p(N))}}n(w,E){const A=w.line_number-1,T=n(w.lines),U=Buffer.from(T);let N=0,j=0,F=A;w.submatches.length===0&&w.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const M=(0,I.$Hb)(w.submatches.map((B,X)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ue=n(B.match),Z=U.slice(N,B.start).toString(),J=c(Z),Y=J.numLines>0?J.lastLineLength:J.lastLineLength+j,he=c(ue),_=J.numLines+F,we=he.numLines+_,oe=he.numLines>0?he.lastLineLength:he.lastLineLength+Y;return N=B.end,j=oe,F=we,new C.$jJ(_,Y,we,oe)}));return(0,S.$fic)(E,T,M,this.j)}o(w,E){const A=n(w.lines),T=w.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((U,N)=>({text:U,uri:E,lineNumber:T+N}))}p(w){this.emit("result",w)}}e.$nic=r;function n(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function c(p){const w=/\n/g;let E=0,A=-1,T;for(;T=w.exec(p);)E++,A=T.index;const U=A>=0?p.length-A-1:p.length;return{numLines:E,lastLineLength:U}}function t(p,w){const E=["--hidden","--no-require-git"];E.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:T}=(0,L.$K)(w.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const N=new Set;T.forEach(j=>{N.add(j)}),E.push("-g","!*"),N.forEach(j=>{u(j).map(S.$eic).forEach(F=>{E.push("-g",F)})})}A&&A.length&&A.forEach(N=>{E.push("-g",N)}),w.excludes.map(S.$eic).forEach(N=>E.push("-g",`!${N}`)),w.maxFileSize&&E.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),w.followSymlinks&&E.push("--follow"),w.encoding&&w.encoding!=="utf8"&&E.push("--encoding",w.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,$.$Ne)(p.pattern),p.isRegExp=!0),w.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),p.isRegExp&&(p.pattern=s(p.pattern),E.push("--engine","auto"));let U;if(p.isWordMatch){const j=(0,$.$We)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",j)}else if(p.isRegExp){let N=a(p.pattern);N=d(N),E.push("--regexp",N)}else U=p.pattern,E.push("--fixed-strings");return E.push("--no-config"),w.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),p.isMultiline&&E.push("--multiline"),w.beforeContext&&E.push("--before-context",w.beforeContext+""),w.afterContext&&E.push("--after-context",w.afterContext+""),E.push("--"),U&&E.push(U),E.push("."),E}e.$oic=t;function u(p){return P(p).flatMap(E=>{const A=(0,b.$Jj)(E,"/");return A.map((T,U)=>A.slice(0,U+1).join("/"))})}function s(p){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(w);)p=p.replace(w,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");return p}e.$pic=s;const l=p=>p.type==="Assertion"&&p.kind==="lookbehind";function a(p){let w;try{w=new m.RegExpParser().parsePattern(p)}catch{return p}let E="",A=0;const T=(j,F,M)=>{E+=p.slice(A,j)+M,A=F},U=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const F=U[0];if(!F)T(j.start,j.end,"\\r?\\n");else if(!U.some(l))if(F.type==="CharacterClass")if(F.negate){const M=p.slice(F.start+2,j.start)+p.slice(j.end,F.end-1);F.parent?.type==="Quantifier"?T(F.start,F.end,M?`[^${M}]`:"."):T(F.start,F.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=p.slice(F.start+1,j.start)+p.slice(j.end,F.end-1);T(F.start,F.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else F.type==="Quantifier"&&T(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){U.unshift(j)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(j){U.unshift(j)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(j){U.unshift(j)},onCharacterClassLeave(){U.shift()},onAssertionEnter(j){l(j)&&U.push(j)},onAssertionLeave(j){U[0]===j&&U.shift()}}).visit(w),E+=p.slice(A),E}e.$qic=a;function d(p){return p.replace(/\n/g,"\\r?\\n")}e.$ric=d;function k(p){let w=!1,E=!1,A="",T="";for(let U=0;U<p.length;U++){const N=p[U];switch(N){case"\\":E?(w?T+="\\"+N:A+="\\"+N,E=!1):E=!0;break;case"{":if(E)w?T+=N:A+=N,E=!1;else{if(w)return{strInBraces:A+"{"+T+"{"+p.substring(U+1)};w=!0}break;case"}":if(E)w?T+=N:A+=N,E=!1;else{if(w)return{fixedStart:A,strInBraces:T,fixedEnd:p.substring(U+1)};A+=N}break;default:w?T+=(E?"\\":"")+N:A+=(E?"\\":"")+N,E=!1;break}}return{strInBraces:A+(w?"{"+T:"")}}function P(p){const{fixedStart:w,strInBraces:E,fixedEnd:A}=k(p);if(w===void 0||A===void 0)return[E];let T=(0,b.$Jj)(E,",");T.length||(T=[""]);const U=P(A);return T.flatMap(N=>{const j=w+N;return U.map(F=>j+F)})}e.$sic=P}),define(ke[375],Se([1,0,21,156,85,17]),function(me,e,D,O,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class L{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,R,C,m){const v=new O.$mic(this.b);if(R.folder.scheme===I.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:I.Schemas.file})},h=new g.$uv(f=>C.report({...f,uri:f.uri.with({scheme:R.folder.scheme})}));return this.c(m,f=>v.provideTextSearchResults(y,S,h,f))}else return this.c(m,S=>v.provideTextSearchResults(y,R,C,S))}async c(y,R){const C=b(y);this.a.add(C);const m=await R(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$wic=L;function b($){const y=new D.$5d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(ke[376],Se([1,0,31,156,155]),function(me,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class I{constructor($){this.a=$}search($,y,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){R({message:v})}},m=new g.$tic(this.a,new O.$mic(C),D);return new Promise((v,S)=>m.search(h=>{y(h.map(L))},$).then(h=>v({limitHit:h.limitHit,type:"success",stats:h.stats}),S))}}e.$uic=I;function L(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const R=y;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(ke[377],Se([1,0,19,11,14,4,129,16,38,2,32,36,372,376]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let c;const t=o(n),u=new I.$Ud({onDidAddFirstListener:()=>{c=(0,O.$Sg)(s=>this.doFileSearchWithEngine(m.$lic,t,l=>u.fire(l),s)),c.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return u.event}textSearch(n){let c;const t=o(n),u=new I.$Ud({onDidAddFirstListener:()=>{c=(0,O.$Sg)(s=>this.f(t,l=>u.fire(l),s)),c.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return u.event}f(n,c,t){return n.maxFileSize=this.g().maxFileSize,new v.$uic(n).search(t,c,c)}g(){return{maxFileSize:16*R.$Xk.GB}}doFileSearch(n,c,t){return this.doFileSearchWithEngine(m.$lic,n,c,t)}doFileSearchWithEngine(n,c,t,u,s=S.a){let l=0;const a=k=>{Array.isArray(k)?(l+=k.length,t(k.map(P=>this.h(P)))):k.relativePath?(l++,t(this.h(k))):t(k)};if(c.sortByScore){let k=this.l(c,a,u);if(!k){const P=c.maxResults?Object.assign({},c,{maxResults:null}):c,p=new n(P);k=this.j(p,c,t,a,u)}return new Promise((P,p)=>{k.then(([w,E])=>{const A=E.map(T=>this.h(T));this.o(A,t,s),P(w)},p)})}const d=new n(c);return this.r(d,a,s,u).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(n){return{path:n.base?(0,b.$jc)(n.base,n.relativePath):n.relativePath}}j(n,c,t,u,s){const l=new I.$Ud;let a=(0,O.$Sg)(k=>{let P=[];const p=w=>{Array.isArray(w)?P=w:(u(w),l.fire(w))};return this.r(n,p,-1,k).then(w=>[w,P])}),d;if(c.cacheKey){d=this.k(c.cacheKey);const k={promise:a,event:l.event,resolved:!1};d.resultsToSearchCache[c.filePattern||""]=k,a.then(()=>{k.resolved=!0},P=>{delete d.resultsToSearchCache[c.filePattern||""]}),a=this.s(a)}return a.then(([k,P])=>{const p=d?d.scorerCache:Object.create(null),w=(typeof c.maxResults!="number"||c.maxResults>0)&&$.$Qd.create(!1);return this.n(c,P,p,s).then(E=>{const A=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:A,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:E.length},messages:k.messages,limitHit:k.limitHit||typeof c.maxResults=="number"&&P.length>c.maxResults},E]})})}k(n){const c=this.b[n];return c||(this.b[n]=new h)}l(n,c,t){const u=n.cacheKey&&this.b[n.cacheKey];if(!u)return;const s=this.q(u,n.filePattern||"",c,t);if(s)return s.then(([l,a,d])=>{const k=$.$Qd.create(!1);return this.n(n,a,u.scorerCache,t).then(P=>{const p=k.elapsed(),w={fromCache:!0,detailStats:d,type:this.d,resultCount:a.length,sortingTime:p};return[{type:"success",limitHit:l.limitHit||typeof n.maxResults=="number"&&a.length>n.maxResults,stats:w},P]})})}n(n,c,t,u){const s=(0,L.$Yq)(n.filePattern||""),l=(d,k)=>(0,L.$Xq)(d,k,s,!0,f,t),a=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.$Gb(c,l,a,1e4,u)}o(n,c,t){if(t&&t>0)for(let u=0;u<n.length;u+=t)c(n.slice(u,u+t));else c(n)}q(n,c,t,u){const s=$.$Qd.create(!1),l=c.indexOf(b.sep)>=0;let a;for(const p in n.resultsToSearchCache)if(c.startsWith(p)){if(l&&p.indexOf(b.sep)<0&&p!=="")continue;const w=n.resultsToSearchCache[p];a={promise:this.s(w.promise),event:w.event,resolved:w.resolved};break}if(!a)return null;const d=s.elapsed(),k=$.$Qd.create(!1),P=a.event(t);return u&&u.onCancellationRequested(()=>{P.dispose()}),a.promise.then(([p,w])=>{if(u&&u.isCancellationRequested)throw(0,g.$6)();const E=[],A=(0,L.$Yq)(c).normalizedLowercase;for(const T of w)(0,C.$FJ)(T,A)&&E.push(T);return[p,E,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:k.elapsed(),cacheEntryCount:w.length}]})}r(n,c,t,u){return new Promise((s,l)=>{let a=[];u?.onCancellationRequested(()=>n.cancel()),n.search(d=>{d&&(t?(a.push(d),t>0&&a.length>=t&&(c(a),a=[])):c(d))},d=>{c(d)},(d,k)=>{a.length&&c(a),d?(c({message:"Search finished. Error: "+d.message}),l(d)):(c({message:"Search finished. Stats: "+JSON.stringify(k.stats)}),s(k))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return n.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return n.finally(c)}}}}e.$vic=S;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(r){return(0,b.$nc)(r.relativePath)}getItemDescription(r){return(0,b.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function o(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>y.URI.revive(n))}}function i(r){return{...r,folder:y.URI.revive(r.folder)}}}),define(ke[378],Se([1,0,3,17,2,31,13,27,20,97,66,36,377,375,119,155]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;let f=class extends y.$jhc{constructor(i,r,n,c){super(i,n,c),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$gic("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new v.$wic(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$gic("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.file,new v.$wic(i))),this.x.add(this.z(O.Schemas.file,new m.$vic("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,c){const t=(0,y.$khc)(n);if(i===this.t){const u=Date.now();return this.A(i,r,t,c).then(s=>{const l=Date.now()-u;return this.n.debug(`Ext host file search time: ${l}ms`),s})}return super.$provideFileSearchResults(i,r,n,c)}doInternalFileSearchWithCustomCallback(i,r,n){const c=t=>{if((0,C.$EJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(u=>g.URI.file(u.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,c,r)}async A(i,r,n,c){return this.doInternalFileSearchWithCustomCallback(n,c,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new h.$tic(i,r,void 0,"textSearchProvider")}};e.$xic=f,e.$xic=f=Ge([We(0,$.$9M),We(1,b.$mN),We(2,R.$cgc),We(3,L.$mj)],f)}),define(ke[120],Se([1,0,392,62,63,393,22,14,4,3,16,10,30,81,82]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=void 0;class h{traceSocketEvent(w,E){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,E)}constructor(w,E=""){this.f=!0,this.debugLabel=E,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,b.$1)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(w){const E=A=>{this.traceSocketEvent("read",A),w(L.$ie.wrap(A))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(w){const E=A=>{w({type:0,hadError:A,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(w){const E=()=>{w()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(w){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$Th=h;var f;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var o;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(o||(o={}));class i extends y.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(w,E){this.socket.traceSocketEvent(w,E)}constructor(w,E,A,T){super(),this.f=this.B(new $.$Ud),this.g=this.B(new $.$Ud),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:A?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new r(this,E,A,T,this.f,(U,N)=>this.m(U,N))),this.B(this.a.onError(U=>{console.error(U),(0,b.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new S.$Oh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this.f.event(w)}onClose(w){return this.g.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let E=0;for(;E<w.byteLength;)this.a.writeMessage(w.slice(E,Math.min(E+262144,w.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(w,{compressed:E,opcode:A}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let T=2;w.byteLength<126?T+=0:w.byteLength<2**16?T+=2:T+=8;const U=L.$ie.alloc(T),N=E?64:0,j=A&15;if(U.writeUInt8(128|N|j,0),w.byteLength<126)U.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){U.writeUInt8(126,1);let F=1;U.writeUInt8(w.byteLength>>>8&255,++F),U.writeUInt8(w.byteLength>>>0&255,++F)}else{U.writeUInt8(127,1);let F=1;U.writeUInt8(0,++F),U.writeUInt8(0,++F),U.writeUInt8(0,++F),U.writeUInt8(0,++F),U.writeUInt8(w.byteLength>>>24&255,++F),U.writeUInt8(w.byteLength>>>16&255,++F),U.writeUInt8(w.byteLength>>>8&255,++F),U.writeUInt8(w.byteLength>>>0&255,++F)}this.socket.write(L.$ie.concat([U,w]))}end(){this.h=!0,this.socket.end()}n(w){if(w.byteLength!==0){for(this.b.acceptChunk(w);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),A=E.readUInt8(0),T=(A&128)>>>7,U=(A&64)>>>6,N=A&15,j=E.readUInt8(1),F=(j&128)>>>7,M=j&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),A=E.readUInt8(1),T=(A&128)>>>7;let U=A&127,N=1;U===126?U=E.readUInt8(++N)*2**8+E.readUInt8(++N):U===127&&(U=E.readUInt8(++N)*0+E.readUInt8(++N)*0+E.readUInt8(++N)*0+E.readUInt8(++N)*0+E.readUInt8(++N)*2**24+E.readUInt8(++N)*2**16+E.readUInt8(++N)*2**8+E.readUInt8(++N));let j=0;T&&(j=E.readUInt8(++N)*2**24+E.readUInt8(++N)*2**16+E.readUInt8(++N)*2**8+E.readUInt8(++N)),this.j.state=3,this.j.readLen=U,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Uh=i;class r extends y.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$ie.alloc(0)}constructor(w,E,A,T,U,N){super(),this.n=w,this.r=U,this.s=N,this.a=this.B(new $.$Ud),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Ud),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Ud),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new n(this.n,T,A,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(w,E){this.g.push({data:w,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:w,options:E}=this.g.shift();if(this.f&&E.compressed){const A=await this.w(this.f,w);this.s(A,E)}else this.s(w,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(w,E){return new Promise((A,T)=>{w.write(E),w.flush(U=>A(U))})}acceptFrame(w,E,A){this.h.push({data:w,isCompressed:E,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const w=this.h.shift();if(this.b&&w.isCompressed){const E=await this.C(this.b,w.data,w.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(w.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(w,E,A){return new Promise((T,U)=>{w.write(E),A&&w.write(L.$ie.fromByteArray([0,0,255,255])),w.flush(N=>T(N))})}}class n extends y.$Tc{get recordedInflateBytes(){return this.j?L.$ie.concat(this.f):L.$ie.alloc(0)}constructor(w,E,A,T){super(),this.h=w,this.j=E,this.a=this.B(new $.$Ud),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(T),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(L.$ie.wrap(U))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(w){this.j&&this.f.push(w.clone()),this.h.traceSocketEvent("zlibInflateWrite",w),this.b.write(w.buffer)}flush(w){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=L.$ie.concat(this.g);this.g.length=0,w(E)})}}class c extends y.$Tc{constructor(w,E){super(),this.g=w,this.a=this.B(new $.$Ud),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(L.$ie.wrap(A))})}write(w){this.g.traceSocketEvent("zlibDeflateWrite",w.buffer),this.b.write(w.buffer)}flush(w){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=L.$ie.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),w(E)})}}function t(p,w){if(w===0)return;const E=p.byteLength>>>2;for(let F=0;F<E;F++){const M=p.readUInt32BE(F*4);p.writeUInt32BE(M^w,F*4)}const A=E*4,T=p.byteLength-A,U=w>>>24&255,N=w>>>16&255,j=w>>>8&255;T>=1&&p.writeUInt8(p.readUInt8(A)^U,A),T>=2&&p.writeUInt8(p.readUInt8(A+1)^N,A+1),T>=3&&p.writeUInt8(p.readUInt8(A+2)^j,A+2)}e.$Vh=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function s(){const p=(0,m.$pg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const w=process.platform!=="darwin"&&e.$Vh?e.$Vh:(0,g.tmpdir)(),E=(0,R.$jc)(w,`vscode-ipc-${p}.sock`);return a(E),E}e.$Wh=s;function l(p,w,E){const T=(0,D.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${E}-${w}-sock`;const U=E.substr(0,4),N=w.substr(0,6);let j;return process.platform!=="darwin"&&e.$Vh&&!process.env.VSCODE_PORTABLE?j=(0,R.$jc)(e.$Vh,`vscode-${T}-${U}-${N}.sock`):j=(0,R.$jc)(p,`${U}-${N}.sock`),a(j),j}e.$Xh=l;function a(p){const w=u[C.$u];typeof w=="number"&&p.length>=w&&console.warn(`WARNING: IPC handle "${p}" is longer than ${w} chars, try a shorter --user-data-dir`)}class d extends v.$Ih{static b(w){const E=$.Event.fromNodeEventEmitter(w,"connection");return $.Event.map(E,A=>({protocol:new S.$Ph(new h(A,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(A,"close"))}))}constructor(w){super(d.b(w)),this.d=w}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Yh=d;function k(p){return new Promise((w,E)=>{const A=(0,O.createServer)();A.on("error",E),A.listen(p,()=>{A.removeListener("error",E),w(new d(A))})})}e.$Zh=k;function P(p,w){return new Promise((E,A)=>{const T=(0,O.createConnection)(p,()=>{T.removeListener("error",A),E(S.$Qh.fromSocket(new h(T,`ipc-client${w}`),w))});T.once("error",A)})}e.$1h=P}),define(ke[379],Se([1,0,62,63,166,120,11,3,10,45,13,136,256,257,109,88,22]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=e.$1$b=e.$Z$b=e.$Y$b=void 0;async function o(t,u,s,l,a){let d;for(let k=3;k&&(d?.dispose(),d=await new i(t,u,s,l,a).waitForReady(),!(a&&g.$sg[a]||!g.$sg[d.tunnelLocalPort]));k--);return d}class i extends b.$Tc{constructor(u,s,l,a,d){super(),this.m=s,this.n=d,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=D.createServer(),this.c=new L.$4g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,s=(0,h.$Gv)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,g.$tg)(u,2,1e3,s),a=null;return this.b.listen(l,this.m),await this.c.wait(),a=this.b.address(),a||(l=0,this.b.listen(l,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(u){u.pause();const s=(0,h.$Ev)(this.tunnelRemoteHost)||(0,h.$Gv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,m.$kl)(this.a,s,this.tunnelRemotePort),a=l.getSocket(),d=l.readEntireBuffer();l.dispose(),d.byteLength>0&&u.write(d.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),a.end()}),u.on("close",()=>a.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),a instanceof I.$Th?a.socket.destroy():a.end()}),a instanceof I.$Th?this.t(u,a):this.s(u,a),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),a.end()})}s(u,s){s.onClose(()=>u.destroy()),s.onEnd(()=>u.end()),s.onData(l=>u.write(l.buffer)),u.on("data",l=>s.write(f.$ie.wrap(l))),u.resume()}t(u,s){const l=s.socket;l.on("end",()=>u.end()),l.on("close",()=>u.end()),l.on("error",()=>{u.destroy()}),l.pipe(u),u.pipe(l)}}e.$Y$b=i;let r=class extends h.$Jv{constructor(u,s,l,a,d){super(s,d),this.v=u,this.w=l,this.y=a}isPortPrivileged(u){return(0,h.$Hv)(u,this.m,$.OS,O.release())}t(u,s,l,a,d,k,P,p){const w=this.s(s,l);if(w)return++w.refcount,w.value;if((0,h.$Bv)(u))return this.u(u,s,l,d,k,P,p);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${l} on local port ${d}.`);const E={commit:this.y.commit,quality:this.y.quality,addressProvider:u,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},A=o(E,a,s,l,d);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,l,A),A}}};e.$Z$b=r,e.$Z$b=r=Ge([We(0,v.$el),We(1,R.$mj),We(2,S.$hl),We(3,C.$Ej),We(4,y.$yi)],r);let n=class extends r{constructor(u,s,l,a,d){super(u,s,l,a,d)}};e.$1$b=n,e.$1$b=n=Ge([We(0,v.$el),We(1,R.$mj),We(2,S.$hl),We(3,C.$Ej),We(4,y.$yi)],n);let c=class extends b.$Tc{constructor(u,s,l,a,d){super(),this.b=u,this.c=s,this.f=l,this.g=a,this.h=d,this.a=new Map}async openTunnel(u,s,l,a,d,k,P,p,w){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${a} on local port ${k}.`),!this.a.has(u)){const E=new n(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(u,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(s,l,a,d,k,P,p,w)}};e.$2$b=c,e.$2$b=c=Ge([We(0,v.$el),We(1,R.$mj),We(2,C.$Ej),We(3,S.$hl),We(4,y.$yi)],c)}),define(ke[380],Se([1,0,120,276,56,35,2,13,40]),function(me,e,D,O,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=void 0;class y{constructor(m,v,S){this.b=m,this.c=v,this.f=S,this.a=O.createServer((h,f)=>this.h(h,f)),this.g().catch(h=>(v.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,v){const S=(f,o)=>{v.writeHead(f,{"content-type":"application/json"}),v.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},h=[];m.setEncoding("utf8"),m.on("data",f=>h.push(f)),m.on("end",async()=>{try{const f=JSON.parse(h.join(""));let o;switch(f.type){case"open":o=await this.i(f);break;case"openExternal":o=await this.j(f);break;case"status":o=await this.l(f);break;case"extensionManagement":o=await this.k(f);break;default:S(404,`Unknown message type: ${f.type}`);break}S(200,o)}catch(f){const o=f instanceof Error?f.message:JSON.stringify(f);S(500,o),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:v,folderURIs:S,forceNewWindow:h,diffMode:f,mergeMode:o,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:c,remoteAuthority:t}=m,u=[];if(Array.isArray(S))for(const d of S)try{u.push({folderUri:L.URI.parse(d)})}catch{}if(Array.isArray(v))for(const d of v)try{(0,$.$xi)(d)?u.push({workspaceUri:L.URI.parse(d)}):u.push({fileUri:L.URI.parse(d)})}catch{}const s=c?L.URI.file(c):void 0,a={forceNewWindow:h,diffMode:f,mergeMode:o,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",u,a)}async j(m){for(const v of m.uris){const S=L.URI.parse(v),h=S.scheme==="file"?S:v;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(m){const v=h=>h?.map(f=>/\.vsix$/i.test(f)?L.URI.parse(f):f),S={list:m.list,install:v(m.install),uninstall:v(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$xN=y;let R=class extends y{constructor(m,v){super(m,v,(0,D.$Wh)())}};e.$yN=R,e.$yN=R=Ge([We(0,I.$sN),We(1,b.$mj)],R)}),define(ke[381],Se([1,0,57,368,363,275,48,348,2,17,7,380,103,346,347]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class h extends g.$4hc{j(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,l,a){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,m.$vq)(l.filename)),d=>n.apply(this,[d,l,a])):n.apply(this,arguments)};const c=r._resolveLookupPaths;r._resolveLookupPaths=(u,s)=>c.call(this,t(u),s);const t=u=>{for(const s of i.b){const l=s(u);if(l){u=l;break}}return u}}}class f extends L.$Sgc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$Aic);const i=this.h.invokeFunction(O.$Zhc);if(this.h.createInstance(b.$zic),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$yN);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(S.$Bic),await this.h.createInstance(h,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,I.$yic)(this.j,n,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,r,n){if(r.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let c=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),c=me.__$__nodeRequire(r.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.$Cic=f}),define(ke[382],Se([1,0,51,22,4,3,122,10,23,2,31,13,255,64,109,88,379,27,20,72,357]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=e.$Jic=e.$Iic=e.$Hic=e.$Gic=e.$Fic=e.$Eic=e.$Dic=void 0;function c(w){const E=w.trim().split(`
`),A=[];return E.forEach(U=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);N&&N.length>=3&&A.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),A.reduce((U,N)=>(U[N.socket]=N,U),{})}e.$Dic=c;function t(...w){const E=[].concat(...w.map(s));return[...new Map(E.filter(A=>A.st==="0A").map(A=>{const T=A.local_address.split(":");return{socket:parseInt(A.inode,10),ip:u(T[0]),port:parseInt(T[1],16)}}).map(A=>[A.ip+":"+A.port,A])).values()]}e.$Eic=t;function u(w){let E="";if(w.length===8)for(let A=w.length-2;A>=0;A-=2)E+=parseInt(w.substr(A,2),16),A!==0&&(E+=".");else for(let A=0;A<w.length;A+=8){const T=w.substring(A,A+8);let U="";for(let N=8;N>=2;N-=2)U+=T.substring(N-2,N),(N===6||N===2)&&(U=parseInt(U,16).toString(16),E+=`${U}`,U="",A+N!==w.length-6&&(E+=":"))}return E}e.$Fic=u;function s(w){const E=w.trim().split(`
`),A=E.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return E.map(U=>U.trim().split(/\s+/).reduce((N,j,F)=>(N[A[F]||F]=j,N),{}))}e.$Gic=s;function l(w){return!!w.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||w.indexOf("out/server-main.js")!==-1||w.indexOf("_productName=VSCode")!==-1}function a(w){const E=w.trim().split(`
`),A=[];return E.forEach(T=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(T);U&&U.length>=4&&A.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),A}e.$Hic=a;async function d(w,E,A){const T=A.reduce((N,j)=>(N[j.pid]=j,N),{}),U=[];return w.forEach(({socket:N,ip:j,port:F})=>{const M=E[N]?E[N].pid:void 0,B=M?T[M]?.cmd:void 0;M&&B&&!l(B)&&U.push({host:j,port:F,detail:B,pid:M})}),U}e.$Iic=d;function k(w,E,A){const T=new Map,U=a(E);for(const N of w){const j=A.get(N.port);if(j){T.set(N.port,j);continue}const F=U.find(M=>M.cmd.includes(`${N.port}`));if(F){let M=F,B;do B=U.find(X=>X.ppid===M.pid),B&&(M=B);while(B);T.set(N.port,{host:N.ip,port:N.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else T.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return T}e.$Jic=k;let P=class extends r.$lyb{constructor(E,A,T,U){super(E,A,T),this.D=A,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&A.remote.isRemote&&A.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let A;this.y&&(A=this.y,await this.a.$onFoundNewCandidates(this.y));const T=new L.$9l;let U=0;for(;this.C;){const N=new Date().getTime(),j=(await this.I()).filter(B=>(0,h.$Ev)(B.host)||(0,h.$Gv)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(B=>B.port).join(", ")}`);const F=new Date().getTime()-N;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),U++>3&&T.update(F),(!A||JSON.stringify(A)!==JSON.stringify(j))&&(A=j,await this.a.$onFoundNewCandidates(A));const M=this.G(T.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(B=>setTimeout(()=>B(),M))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",A="";try{E=await R.Promises.readFile("/proc/net/tcp","utf8"),A=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const T=t(E,A),U=await new Promise(Z=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,Y,he)=>{Z(Y)})}),N=c(U),j=await R.Promises.readdir("/proc"),F=[];for(const Z of j)try{const J=Number(Z),Y=$.$Gg(y.URI.file("/proc"),Z);if((await R.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(J)){const _=await R.Promises.readlink($.$Gg(Y,"cwd").fsPath),we=await R.Promises.readFile($.$Gg(Y,"cmdline").fsPath,"utf8");F.push({pid:J,cwd:_,cmd:we})}}catch{}const M=[],B=T.filter(Z=>{const J=N[Z.socket];return J||M.push(Z),J}),X=d(B,N,F);let ue;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const Z=await new Promise(J=>{(0,D.exec)("ps -F -A -l | grep root",(Y,he,_)=>{J(he)})});this.z=k(M,Z,this.z),ue=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ue.map(J=>J.port).join(", ")}`)}return X.then(Z=>ue?Z.concat(ue):Z)}w(E){return async A=>{const T=new f.$Y$b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(N,j,F,M){const B=await E.makeConnection();return p.connect(B,j,F,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$8k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",A.remoteAddress.host||"localhost",A.remoteAddress.port,A.localAddressPort);await T.waitForReady();const U=new g.$Ud;return{localAddress:(0,n.$sK)(T.localAddress)??T.localAddress,remoteAddress:{port:T.tunnelRemotePort,host:T.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{T.dispose(),U.fire(),U.dispose()}}}}};e.$Kic=P,e.$Kic=P=Ge([We(0,i.$9M),We(1,o.$mN),We(2,C.$mj),We(3,S.$hl)],P);class p extends m.$prb{static connect(E,A,T,U){const N=new I.$Sc,j={onClose:N.add(new g.$Ud),onData:N.add(new g.$Ud),onEnd:N.add(new g.$Ud)};N.add(E.onDidReceiveMessage(M=>j.onData.fire(O.$ie.wrap(M)))),N.add(E.onDidEnd(()=>j.onEnd.fire())),N.add(E.onDidClose(M=>j.onClose.fire({type:0,error:M,hadError:!!M})));const F=new p(E,U,j);return F.B(N),(0,m.$orb)(F,A,T,U,j)}constructor(E,A,T){super(A,T),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[383],Se([1,0,106,351,366,365,378,381,382,96,48,97,95,47,72,92,350,349,13,367,59,270,105,109,138]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o,i,r,n,c,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Xr)(R.$Tgc,b.$Cic,0),(0,D.$Xr)(i.$nj,o.$Mic,1),(0,D.$Xr)(i.$mj,new t.$2h(c.$3hc,[!1],!0)),(0,D.$Xr)(u.$hl,s.$4$b,1),(0,D.$Xr)(h.$lgc,f.$Lic,0),(0,D.$Xr)(y.$Ygc,I.$dic,0),(0,D.$Xr)(C.$ihc,L.$xic,0),(0,D.$Xr)(m.$Lhc,g.$8hc,0),(0,D.$Xr)(v.$Ggc,O.$7hc,0),(0,D.$Xr)(S.$kyb,$.$Kic,0),(0,D.$Xr)(n.$Wgc,r.$Nic,0)}),define(ke[394],Se([1,0,62,395,57,14,82,120,253,114,364,22,31,103,11,132,277,291,369,383]),function(me,e,D,O,g,I,L,b,$,y,R,C,m,v,S,h,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let k=0;k<process.execArgv.length;k++)process.execArgv[k]==="--inspect-port=0"&&(process.execArgv.splice(k,1),k--)}();const i=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,k=d._load;d._load=function(P){if(P==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return k.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function c(d){process.exit=function(k){if(d)r(k);else{const P=new Error("An extension called process.exit() and this was prevented.");console.warn(P.stack)}},process.crash=function(){const k=new Error("An extension called process.crash() and this was prevented.");console.warn(k.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(k,P){k==="uncaughtException"&&(P=function(){try{return P.call(void 0,arguments)}catch{}}),n(k,P)}}let t=function(d){r()};function u(){const d=(0,o.$Sm)(process.env);if(d.type===3)return new Promise((k,P)=>{const p=w=>{const E=w[0],A=new L.$Rh;E.on("message",T=>A.fire(C.$ie.wrap(T.data))),E.on("close",()=>{t("renderer closed the MessagePort")}),E.start(),k({onMessage:A.event,send:T=>E.postMessage(T.buffer)})};process.parentPort.on("message",w=>p(w.ports))});if(d.type===2)return new Promise((k,P)=>{let p=null;const w=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,A=3e5,T=new S.$fh(()=>t("renderer disconnected for too long (1)"),E),U=new S.$fh(()=>t("renderer disconnected for too long (2)"),A);process.on("message",(j,F)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){F.setNoDelay(!0);const M=C.$ie.wrap(Buffer.from(j.initialDataChunk,"base64"));let B;if(j.skipWebSocketFrames)B=new b.$Th(F,"extHost-socket");else{const X=C.$ie.wrap(Buffer.from(j.inflateBytes,"base64"));B=new b.$Uh(new b.$Th(F,"extHost-socket"),j.permessageDeflate,X,!1)}p?(T.cancel(),U.cancel(),p.beginAcceptReconnection(B,M),p.endAcceptReconnection(),p.sendResume()):(clearTimeout(w),p=new L.$Sh({socket:B,initialChunk:M}),p.sendResume(),p.onDidDispose(()=>t("renderer disconnected")),k(p),p.onSocketClose(()=>{T.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;T.isScheduled()&&U.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const k=d.pipeName;return new Promise((P,p)=>{const w=D.createConnection(k,()=>{w.removeListener("error",p);const E=new L.$Sh({socket:new b.$Th(w,"extHost-renderer")});E.sendResume(),P(E)});w.once("error",p),w.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const d=await u();return new class{constructor(){this.a=new L.$Rh,this.onMessage=this.a.event,this.b=!1,d.onMessage(k=>{(0,y.$tm)(k,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(k)})}send(k){this.b||d.send(k)}async drain(){if(d.drain)return d.drain()}}}function l(d){return new Promise(k=>{const P=d.onMessage(p=>{P.dispose();const w=JSON.parse(p.toString()),E=w.commit,A=$.default.commit;if(E&&A&&E!==A&&r(55),w.parentPid){let T=0;setInterval(function(){try{process.kill(w.parentPid,0),T=0}catch(N){N&&N.code==="EPERM"?(T++,T>=3&&t(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):t(`parent process ${w.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(w.parentPid)}catch(N){(0,I.$1)(N)}}d.send((0,y.$sm)(0)),k({protocol:d,initData:w})});d.send((0,y.$sm)(1))})}async function a(){const d=[];process.on("unhandledRejection",(T,U)=>{d.push(U),setTimeout(()=>{const N=d.indexOf(U);N>=0&&U.catch(j=>{d.splice(N,1),(0,I.$4)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),T&&(0,I.$1)(T))})},1e3)}),process.on("rejectionHandled",T=>{const U=d.indexOf(T);U>=0&&d.splice(U,1)}),process.on("uncaughtException",function(T){(0,I.$Z)(T)||(0,I.$1)(T)}),g.mark("code/extHost/willConnectToRenderer");const k=await s();g.mark("code/extHost/didConnectToRenderer");const P=await l(k);g.mark("code/extHost/didWaitForInitData");const{initData:p}=P;c(!!p.environment.extensionTestsLocationURI),p.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,p.environment.skipWorkspaceStorageLock=(0,h.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(U){r(U)}fsExists(U){return m.Promises.exists(U)}fsRealpath(U){return(0,v.$uq)(U)}};let E=null;p.remote.authority&&i.transformURIs&&(E=(0,f.$2r)(p.remote.authority));const A=new R.$6hc(P.protocol,p,w,E);t=T=>A.terminate(T)}a().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/29bef5673ebb1fc3a59b90c9d8bfd2bc61c3f011/core/vs/workbench/api/node/extensionHostProcess.js.map
