/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],p=function(G){for(var e=[],P=0,S=G.length;P<S;P++)e[P]=K[G[P]];return e};define(K[22],p([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class P{static get(){const E=new Map,L=new Map,s=new Map,f=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function c(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let $=[];typeof G=="function"&&typeof G.getStats=="function"&&($=G.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of $)switch(a.type){case 10:t(E,a);break;case 11:case 12:c(E,a);break;case 21:t(L,a);break;case 22:c(L,a);break;case 33:t(s,a);break;case 34:c(s,a);break;case 31:t(f,a);break;case 32:c(f,a);break}let l=0;s.forEach(a=>l+=a);function h(a){const i=[];return a.forEach((n,r)=>i.push([r,n])),i}return{amdLoad:h(E),amdInvoke:h(L),nodeRequire:h(s),nodeEval:h(f),nodeRequireTotal:l}}static toMarkdownTable(E,L){let s="";const f=[];return E.forEach((t,c)=>{f[c]=t.length}),L.forEach(t=>{t.forEach((c,$)=>{typeof c>"u"&&(c=t[$]="-");const l=c.toString().length;f[$]=Math.max(l,f[$])})}),E.forEach((t,c)=>{s+=`| ${t+" ".repeat(f[c]-t.toString().length)} `}),s+=`|
`,E.forEach((t,c)=>{s+=`| ${"-".repeat(f[c])} `}),s+=`|
`,L.forEach(t=>{t.forEach((c,$)=>{typeof c<"u"&&(s+=`| ${c+" ".repeat(f[$]-c.toString().length)} `)}),s+=`|
`}),s}}e.$U=P}),define(K[4],p([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ud=e.$td=e.$sd=void 0;let P;function S(n){P=n}e.$sd=S;function E(){return P}e.$td=E;class L{constructor(){this.a=0,this.d=new WeakMap}b(r){return s([f(a("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[f(" "),c($(r.oldValue,70),{color:"red",strikeThrough:!0}),f(" "),c($(r.newValue,60),{color:"green"})]:[f(" (unchanged)")]:[f(" "),c($(r.newValue,60),{color:"green"}),f(" (initial)")]}handleObservableChanged(r,b){console.log(...this.b([t("observable value changed"),c(r.debugName,{color:"BlueViolet"}),...this.c(b)]))}formatChanges(r){if(r.size!==0)return c(" (changed deps: "+[...r].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const b=r.handleChange;this.d.set(r,new Set),r.handleChange=(T,j)=>(this.d.get(r).add(T),b.apply(r,[T,j]))}handleDerivedRecomputed(r,b){const T=this.d.get(r);console.log(...this.b([t("derived recomputed"),c(r.debugName,{color:"BlueViolet"}),...this.c(b),this.formatChanges(T),{data:[{fn:r._computeFn}]}])),T.clear()}handleFromEventObservableTriggered(r,b){console.log(...this.b([t("observable from event triggered"),c(r.debugName,{color:"BlueViolet"}),...this.c(b),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const b=r.handleChange;this.d.set(r,new Set),r.handleChange=(T,j)=>(this.d.get(r).add(T),b.apply(r,[T,j]))}handleAutorunTriggered(r){const b=this.d.get(r);console.log(...this.b([t("autorun"),c(r.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:r._runFn}]}])),b.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let b=r.getDebugName();b===void 0&&(b=""),console.log(...this.b([t("transaction"),c(b,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$ud=L;function s(n){const r=new Array,b=[];let T="";function j(O){if("length"in O)for(const g of O)g&&j(g);else"text"in O?(T+=`%c${O.text}`,r.push(O.style),O.data&&b.push(...O.data)):"data"in O&&b.push(...O.data)}j(n);const M=[T,...r];return M.push(...b),M}function f(n){return c(n,{color:"black"})}function t(n){return c(i(`${n}: `,10),{color:"black",bold:!0})}function c(n,r={color:"black"}){function b(j){return Object.entries(j).reduce((M,[O,g])=>`${M}${O}:${g};`,"")}const T={color:r.color};return r.strikeThrough&&(T["text-decoration"]="line-through"),r.bold&&(T["font-weight"]="bold"),{text:n,style:b(T)}}function $(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?l(n,r):h(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function l(n,r){let b="[ ",T=!0;for(const j of n){if(T||(b+=", "),b.length-5>r){b+="...";break}T=!1,b+=`${$(j,r-b.length)}`}return b+=" ]",b}function h(n,r){let b="{ ",T=!0;for(const[j,M]of Object.entries(n)){if(T||(b+=", "),b.length-5>r){b+="...";break}T=!1,b+=`${j}: ${$(M,r-b.length)}`}return b+=" }",b}function a(n,r){let b="";for(let T=1;T<=r;T++)b+=n;return b}function i(n,r){for(;n.length<r;)n+=" ";return n}}),define(K[5],p([0,1,4]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=void 0;let S;function E(m){S=m}e.$Bd=E;let L;function s(m){L=m}e.$Cd=s;class f{get TChange(){return null}reportChanges(){this.get()}read(w){return w?w.readObservable(this):this.get()}map(w,I){const y=I===void 0?void 0:w,d=I===void 0?w:I;return L({owner:y,debugName:()=>{const N=k(d);if(N!==void 0)return N;const q=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(d.toString());if(q)return`${this.debugName}.${q[2]}`;if(!y)return`${this.debugName} (mapped)`}},N=>d(this.read(N),N))}recomputeInitiallyAndOnChange(w,I){return w.add(S(this,I)),this}}e.$Dd=f;class t extends f{constructor(){super(...arguments),this.c=new Set}addObserver(w){const I=this.c.size;this.c.add(w),I===0&&this.f()}removeObserver(w){this.c.delete(w)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Ed=t;function c(m,w){const I=new i(m,w);try{m(I)}finally{I.finish()}}e.$Fd=c;let $;function l(m){if($)m($);else{const w=new i(m,void 0);$=w;try{m(w)}finally{w.finish(),$=void 0}}}e.$Gd=l;async function h(m,w){const I=new i(m,w);try{await m(I)}finally{I.finish()}}e.$Hd=h;function a(m,w,I){m?w(m):c(w,I)}e.$Id=a;class i{constructor(w,I){this._fn=w,this.b=I,this.a=[],(0,P.$td)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():k(this._fn)}updateObserver(w,I){this.a.push({observer:w,observable:I}),w.beginUpdate(I)}finish(){const w=this.a;for(let I=0;I<w.length;I++){const{observer:y,observable:d}=w[I];y.endUpdate(d)}this.a=null,(0,P.$td)()?.handleEndTransaction()}}e.$Jd=i;const n=new Map,r=new WeakMap;function b(m,w,I,y,d){const N=r.get(m);if(N)return N;const z=T(m,w,I,y,d);if(z){let q=n.get(z)??0;q++,n.set(z,q);const V=q===1?z:`${z}#${q}`;return r.set(m,V),V}}e.$Kd=b;function T(m,w,I,y,d){const N=r.get(m);if(N)return N;const z=y?O(y)+".":"";let q;if(w!==void 0)if(typeof w=="function"){if(q=w(),q!==void 0)return z+q}else return z+w;if(I!==void 0&&(q=k(I),q!==void 0))return z+q;if(y!==void 0){for(const V in y)if(y[V]===d)return z+V}}const j=new Map,M=new WeakMap;function O(m){const w=M.get(m);if(w)return w;const I=g(m);let y=j.get(I)??0;y++,j.set(I,y);const d=y===1?I:`${I}#${y}`;return M.set(m,d),d}function g(m){const w=m.constructor;return w?w.name:"Object"}function k(m){const w=m.toString(),y=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(y?y[1]:void 0)?.trim()}e.$Ld=k;function C(m,w){return typeof m=="string"?new F(void 0,m,w):new F(m,void 0,w)}e.$Md=C;class F extends t{get debugName(){return b(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(w,I,y){super(),this.b=w,this.d=I,this.a=y}get(){return this.a}set(w,I,y){if(this.a===w)return;let d;I||(I=d=new i(()=>{},()=>`Setting ${this.debugName}`));try{const N=this.a;this.e(w),(0,P.$td)()?.handleObservableChanged(this,{oldValue:N,newValue:w,change:y,didChange:!0,hadValue:!0});for(const z of this.c)I.updateObserver(z,this),z.handleChange(this,y)}finally{d&&d.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(w){this.a=w}}e.$Nd=F;function D(m,w){return typeof m=="string"?new u(void 0,m,w):new u(m,void 0,w)}e.$Od=D;class u extends F{e(w){this.a!==w&&(this.a&&this.a.dispose(),this.a=w)}dispose(){this.a?.dispose()}}e.$Pd=u}),define(K[9],p([0,1,43,2,5,4]),function(G,e,P,S,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=void 0;function s(i){return new h(void 0,i,void 0,void 0)}e.$0c=s;function f(i,n){return new h(i.debugName,n,void 0,void 0)}e.$$c=f;function t(i,n){return new h(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$_c=t;function c(i,n){const r=new S.$Sc,b=t({debugName:i.debugName??(()=>(0,E.$Ld)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(T,j)=>{r.clear(),n(T,j,r)});return(0,S.$Rc)(()=>{b.dispose(),r.dispose()})}e.$ad=c;function $(i){const n=new S.$Sc,r=f({debugName:()=>(0,E.$Ld)(i)||"(anonymous)"},b=>{n.clear(),i(b,n)});return(0,S.$Rc)(()=>{r.dispose(),n.dispose()})}e.$bd=$;var l;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(l||(l={}));class h{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const r=this.h();if(r!==void 0)return r}const n=(0,E.$Ld)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,r,b,T){this.h=n,this._runFn=r,this.i=b,this.j=T,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,L.$td)()?.handleAutorunCreated(this),this.k(),(0,S.$Kc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,S.$Lc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,L.$td)()?.handleAutorunTriggered(this);const b=this.g;this.g=this.i?.(),this._runFn(this,b)}}finally{r||(0,L.$td)()?.handleAutorunFinished(this);for(const b of this.f)b.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$8c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:T=>T===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}e.$cd=h,function(i){i.Observer=h}(s||(e.$0c=s={}));function a(i,n){let r;return f({debugName:()=>(0,E.$Ld)(n)},b=>{const T=i.read(b),j=r;r=T,n({lastValue:j,newValue:T})})}e.$dd=a}),define(K[10],p([0,1,6,2,5,4]),function(G,e,P,S,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=void 0;const s=(i,n)=>i===n;function f(i,n){return n!==void 0?new a(i,void 0,n,void 0,void 0,void 0,s):new a(void 0,void 0,i,void 0,void 0,void 0,s)}e.$vd=f;function t(i,n){return new a(i.owner,i.debugName,n,void 0,void 0,i.onLastObserverRemoved,i.equalityComparer??s)}e.$wd=t;function c(i,n){return new a(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$xd=c;function $(i,n){let r,b;n===void 0?(r=i,b=void 0):(b=i,r=n);const T=new S.$Sc;return new a(b,()=>(0,E.$Ld)(r)??"(anonymous)",j=>(T.clear(),r(j,T)),void 0,void 0,()=>T.dispose(),s)}e.$yd=$;function l(i,n){let r,b;n===void 0?(r=i,b=void 0):(b=i,r=n);const T=new S.$Sc;return new a(b,()=>(0,E.$Ld)(r)??"(anonymous)",j=>{T.clear();const M=r(j);return M&&T.add(M),M},void 0,void 0,()=>T.dispose(),s)}e.$zd=l,(0,E.$Cd)(t);var h;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class a extends E.$Ed{get debugName(){return(0,E.$Kd)(this,this.p,this._computeFn,this.n,this)??"(anonymous)"}constructor(n,r,b,T,j,M=void 0,O){super(),this.n=n,this.p=r,this._computeFn=b,this.q=T,this.s=j,this.t=M,this.u=O,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,L.$td)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const r=this.e!==0,b=this.h;this.e=3;const T=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,T)}finally{for(const M of this.l)M.removeObserver(this);this.l.clear()}const j=r&&!this.u(b,this.h);if((0,L.$td)()?.handleDerivedRecomputed(this,{oldValue:b,newValue:this.h,change:void 0,didChange:j,hadValue:r}),j)for(const M of this.c)M.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const r=this.j===1;if(this.e===3&&(this.e=1,!r))for(const b of this.c)b.handlePossibleChange(this);if(r)for(const b of this.c)b.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const r=[...this.c];for(const b of r)b.endUpdate(this)}if(this.j<0)throw new P.$cb}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const r of this.c)r.handlePossibleChange(this)}}handleChange(n,r){if(this.k.has(n)&&!this.l.has(n)){const b=this.s?this.s({changedObservable:n,change:r,didChange:j=>j===n},this.m):!0,T=this.e===3;if(b&&(this.e===1||T)&&(this.e=2,T))for(const j of this.c)j.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const r=n.get();return this.k.add(n),this.l.delete(n),r}addObserver(n){const r=!this.c.has(n)&&this.j>0;super.addObserver(n),r&&n.beginUpdate(this)}removeObserver(n){const r=this.c.has(n)&&this.j>0;super.removeObserver(n),r&&n.endUpdate(this)}}e.$Ad=a}),define(K[23],p([0,1,2,9,5,10,4]),function(G,e,P,S,E,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=void 0;function f(D){return new t(D)}e.$ed=f;class t extends E.$Dd{constructor(u){super(),this.a=u}get debugName(){return this.toString()}get(){return this.a}addObserver(u){}removeObserver(u){}toString(){return`Const: ${this.a}`}}function c(D){const u=(0,E.$Md)("promiseValue",{});return D.then(m=>{u.set({value:m},void 0)}),u}e.$fd=c;function $(D,u){return new Promise(m=>{let w=!1,I=!1;const y=D.map(N=>({isFinished:u(N),state:N})),d=(0,S.$0c)(N=>{const{isFinished:z,state:q}=y.read(N);z&&(w?d.dispose():I=!0,m(q))});w=!0,I&&d.dispose()})}e.$gd=$;function l(D,u){return new h(D,u)}e.$hd=l;class h extends E.$Ed{constructor(u,m){super(),this.h=u,this._getValue=m,this.b=!1,this.l=w=>{const I=this._getValue(w),y=this.a,d=!this.b||y!==I;let N=!1;d&&(this.a=I,this.b&&(N=!0,(0,E.$Id)(h.globalTransaction,z=>{(0,s.$td)()?.handleFromEventObservableTriggered(this,{oldValue:y,newValue:I,change:void 0,didChange:d,hadValue:this.b});for(const q of this.c)z.updateObserver(q,this),q.handleChange(this,void 0)},()=>{const z=this.j();return"Event fired"+(z?`: ${z}`:"")})),this.b=!0),N||(0,s.$td)()?.handleFromEventObservableTriggered(this,{oldValue:y,newValue:I,change:void 0,didChange:d,hadValue:this.b})}}j(){return(0,E.$Ld)(this._getValue)}get debugName(){const u=this.j();return"From Event"+(u?`: ${u}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$id=h,function(D){D.Observer=h;function u(m,w){let I=!1;h.globalTransaction===void 0&&(h.globalTransaction=m,I=!0);try{w()}finally{I&&(h.globalTransaction=void 0)}}D.batchEventsGlobally=u}(l||(e.$hd=l={}));function a(D,u){return new i(D,u)}e.$jd=a;class i extends E.$Ed{constructor(u,m){super(),this.debugName=u,this.b=m,this.h=()=>{(0,E.$Fd)(w=>{for(const I of this.c)w.updateObserver(I,this),I.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(D){return typeof D=="string"?new r(D):new r(void 0,D)}e.$kd=n;class r extends E.$Ed{get debugName(){return(0,E.$Kd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(u,m){super(),this.a=u,this.b=m}trigger(u,m){if(!u){(0,E.$Fd)(w=>{this.trigger(w,m)},()=>`Trigger signal ${this.debugName}`);return}for(const w of this.c)u.updateObserver(w,this),w.handleChange(this,m)}get(){}}function b(D,u,m){const w=(0,E.$Md)("debounced",void 0);let I;return m.add((0,S.$0c)(y=>{const d=D.read(y);I&&clearTimeout(I),I=setTimeout(()=>{(0,E.$Fd)(N=>{w.set(d,N)})},u)})),w}e.$ld=b;function T(D,u,m){const w=(0,E.$Md)("triggeredRecently",!1);let I;return m.add(D(()=>{w.set(!0,void 0),I&&clearTimeout(I),I=setTimeout(()=>{w.set(!1,void 0)},u)})),w}e.$md=T;function j(D){const u=new O(!1,void 0);return D.addObserver(u),(0,P.$Rc)(()=>{D.removeObserver(u)})}e.$nd=j;function M(D,u){const m=new O(!0,u);return D.addObserver(m),u?u(D.get()):D.reportChanges(),(0,P.$Rc)(()=>{D.removeObserver(m)})}e.$od=M,(0,E.$Bd)(M);class O{constructor(u,m){this.b=u,this.c=m,this.a=0}beginUpdate(u){this.a++}endUpdate(u){this.a--,this.a===0&&this.b&&(this.c?this.c(u.get()):u.reportChanges())}handlePossibleChange(u){}handleChange(u,m){}}function g(D){let u;return(0,L.$vd)(w=>(u=D(w,u),u))}e.$pd=g;function k(D,u){let m;const w=(0,E.$Md)("derivedObservableWithWritableCache.counter",0),I=(0,L.$vd)(D,y=>(w.read(y),m=u(y,m),m));return Object.assign(I,{clearCache:y=>{m=void 0,w.set(w.get()+1,y)}})}e.$qd=k;function C(D,u,m,w){let I=new F(m,w);return(0,L.$wd)({debugName:typeof u=="string"?u:void 0,owner:typeof u=="string"?void 0:u,onLastObserverRemoved:()=>{I.dispose(),I=new F(m)}},y=>(I.setItems(D.read(y)),I.getItems()))}e.$rd=C;class F{constructor(u,m){this.c=u,this.e=m,this.a=new Map,this.b=[]}dispose(){this.a.forEach(u=>u.store.dispose()),this.a.clear()}setItems(u){const m=[],w=new Set(this.a.keys());for(const I of u){const y=this.e?this.e(I):I;let d=this.a.get(y);if(d)w.delete(y);else{const N=new P.$Sc;d={out:this.c(I,N),store:N},this.a.set(y,d)}m.push(d.out)}for(const I of w)this.a.get(I).store.dispose(),this.a.delete(I);this.b=m}getItems(){return this.b}}}),define(K[11],p([0,1,5,10,9,23,4]),function(G,e,P,S,E,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Md}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Od}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$Fd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Id}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$vd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$wd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$xd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$yd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return E.$0c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return E.$dd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return E.$_c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return E.$bd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return E.$$c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return E.$ad}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return L.$ed}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return L.$ld}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return L.$pd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return L.$qd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return L.$nd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return L.$od}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return L.$hd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return L.$fd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return L.$kd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return L.$jd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return L.$gd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return L.$md}}),!1&&(0,s.$sd)(new s.$ud)}),define(K[24],p([0,1,6,2]),function(G,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=void 0;function E(M){const O=M;return O?typeof O.read=="function":!1}e.$6d=E;function L(M){const O=M;return O?[O.on,O.pause,O.resume,O.destroy].every(g=>typeof g=="function"):!1}e.$7d=L;function s(M){const O=M;return O?L(O.stream)&&Array.isArray(O.buffer)&&typeof O.ended=="boolean":!1}e.$8d=s;function f(M,O){return new t(M,O)}e.$9d=f;class t{constructor(O,g){this.e=O,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(O){if(!this.a.destroyed){if(this.a.flowing)this.g(O);else if(this.b.data.push(O),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(O){this.a.destroyed||(this.a.flowing?this.h(O):this.b.error.push(O))}end(O){this.a.destroyed||(typeof O<"u"&&this.write(O),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(O){this.c.data.slice(0).forEach(g=>g(O))}h(O){this.c.error.length===0?(0,P.$1)(O):this.c.error.slice(0).forEach(g=>g(O))}i(){this.c.end.slice(0).forEach(O=>O())}on(O,g){if(!this.a.destroyed)switch(O){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(O,g){if(this.a.destroyed)return;let k;switch(O){case"data":k=this.c.data;break;case"end":k=this.c.end;break;case"error":k=this.c.error;break}if(k){const C=k.indexOf(g);C>=0&&k.splice(C,1)}}j(){if(this.b.data.length>0){const O=this.e(this.b.data);this.g(O),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(k=>k())}}k(){if(this.c.error.length>0){for(const O of this.b.error)this.h(O);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(M,O){const g=[];let k;for(;(k=M.read())!==null;)g.push(k);return O(g)}e.$0d=c;function $(M,O,g){const k=[];let C;for(;(C=M.read())!==null&&k.length<g;)k.push(C);return C===null&&k.length>0?O(k):{read:()=>{if(k.length>0)return k.shift();if(typeof C<"u"){const F=C;return C=void 0,F}return M.read()}}}e.$$d=$;function l(M,O){return new Promise((g,k)=>{const C=[];h(M,{onData:F=>{O&&C.push(F)},onError:F=>{O?k(F):g(void 0)},onEnd:()=>{g(O?O(C):void 0)}})})}e.$_d=l;function h(M,O,g){M.on("error",k=>{g?.isCancellationRequested||O.onError(k)}),M.on("end",()=>{g?.isCancellationRequested||O.onEnd()}),M.on("data",k=>{g?.isCancellationRequested||O.onData(k)})}e.$ae=h;function a(M,O){return new Promise((g,k)=>{const C=new S.$Sc,F=[],D=w=>{if(F.push(w),F.length>O)return C.dispose(),M.pause(),g({stream:M,buffer:F,ended:!1})},u=w=>(C.dispose(),k(w)),m=()=>(C.dispose(),g({stream:M,buffer:F,ended:!0}));C.add((0,S.$Rc)(()=>M.removeListener("error",u))),M.on("error",u),C.add((0,S.$Rc)(()=>M.removeListener("end",m))),M.on("end",m),C.add((0,S.$Rc)(()=>M.removeListener("data",D))),M.on("data",D)})}e.$be=a;function i(M,O){const g=f(O);return g.end(M),g}e.$ce=i;function n(){const M=f(()=>{throw new Error("not supported")});return M.end(),M}e.$de=n;function r(M){let O=!1;return{read:()=>O?null:(O=!0,M)}}e.$ee=r;function b(M,O,g){const k=f(g);return h(M,{onData:C=>k.write(O.data(C)),onError:C=>k.error(O.error?O.error(C):C),onEnd:()=>k.end()}),k}e.$fe=b;function T(M,O,g){let k=!1;return{read:()=>{const C=O.read();return k?C:(k=!0,C!==null?g([M,C]):M)}}}e.$ge=T;function j(M,O,g){let k=!1;const C=f(g);return h(O,{onData:F=>k?C.write(F):(k=!0,C.write(g([M,F]))),onError:F=>C.error(F),onEnd:()=>{k||(k=!0,C.write(M)),C.end()}}),C}e.$he=j}),define(K[12],p([0,1,25,24]),function(G,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;const E=typeof Buffer<"u",L=new P.$V(()=>new Uint8Array(256));let s,f;class t{static alloc(d){return E?new t(Buffer.allocUnsafe(d)):new t(new Uint8Array(d))}static wrap(d){return E&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new t(d)}static fromString(d,N){return!(N?.dontUseNodeBuffer||!1)&&E?new t(Buffer.from(d)):(s||(s=new TextEncoder),new t(s.encode(d)))}static fromByteArray(d){const N=t.alloc(d.length);for(let z=0,q=d.length;z<q;z++)N.buffer[z]=d[z];return N}static concat(d,N){if(typeof N>"u"){N=0;for(let V=0,_=d.length;V<_;V++)N+=d[V].byteLength}const z=t.alloc(N);let q=0;for(let V=0,_=d.length;V<_;V++){const W=d[V];z.set(W,q),q+=W.byteLength}return z}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=t.alloc(this.byteLength);return d.set(this),d}toString(){return E?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(d,N){return new t(this.buffer.subarray(d,N))}set(d,N){if(d instanceof t)this.buffer.set(d.buffer,N);else if(d instanceof Uint8Array)this.buffer.set(d,N);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),N);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return h(this.buffer,d)}writeUInt32BE(d,N){a(this.buffer,d,N)}readUInt32LE(d){return i(this.buffer,d)}writeUInt32LE(d,N){n(this.buffer,d,N)}readUInt8(d){return r(this.buffer,d)}writeUInt8(d,N){b(this.buffer,d,N)}indexOf(d,N=0){return c(this.buffer,d instanceof t?d.buffer:d,N)}}e.$ie=t;function c(y,d,N=0){const z=d.byteLength,q=y.byteLength;if(z===0)return 0;if(z===1)return y.indexOf(d[0]);if(z>q-N)return-1;const V=L.value;V.fill(d.length);for(let J=0;J<d.length;J++)V[d[J]]=d.length-J-1;let _=N+d.length-1,W=_,H=-1;for(;_<q;)if(y[_]===d[W]){if(W===0){H=_;break}_--,W--}else _+=Math.max(d.length-W,V[y[_]]),W=d.length-1;return H}e.$je=c;function $(y,d){return y[d+0]<<0>>>0|y[d+1]<<8>>>0}e.$ke=$;function l(y,d,N){y[N+0]=d&255,d=d>>>8,y[N+1]=d&255}e.$le=l;function h(y,d){return y[d]*2**24+y[d+1]*2**16+y[d+2]*2**8+y[d+3]}e.$me=h;function a(y,d,N){y[N+3]=d,d=d>>>8,y[N+2]=d,d=d>>>8,y[N+1]=d,d=d>>>8,y[N]=d}e.$ne=a;function i(y,d){return y[d+0]<<0>>>0|y[d+1]<<8>>>0|y[d+2]<<16>>>0|y[d+3]<<24>>>0}e.$oe=i;function n(y,d,N){y[N+0]=d&255,d=d>>>8,y[N+1]=d&255,d=d>>>8,y[N+2]=d&255,d=d>>>8,y[N+3]=d&255}e.$pe=n;function r(y,d){return y[d]}e.$qe=r;function b(y,d,N){y[N]=d}e.$re=b;function T(y){return S.$0d(y,d=>t.concat(d))}e.$se=T;function j(y){return S.$ee(y)}e.$te=j;function M(y){return S.$_d(y,d=>t.concat(d))}e.$ue=M;async function O(y){return y.ended?t.concat(y.buffer):t.concat([...y.buffer,await M(y.stream)])}e.$ve=O;function g(y){return S.$ce(y,d=>t.concat(d))}e.$we=g;function k(y){return S.$fe(y,{data:d=>typeof d=="string"?t.fromString(d):t.wrap(d)},d=>t.concat(d))}e.$xe=k;function C(y){return S.$9d(d=>t.concat(d),y)}e.$ye=C;function F(y,d){return S.$ge(y,d,N=>t.concat(N))}e.$ze=F;function D(y,d){return S.$he(y,d,N=>t.concat(N))}e.$Ae=D;function u(y){let d=0,N=0,z=0;const q=new Uint8Array(Math.floor(y.length/4*3)),V=W=>{switch(N){case 3:q[z++]=d|W,N=0;break;case 2:q[z++]=d|W>>>2,d=W<<6,N=3;break;case 1:q[z++]=d|W>>>4,d=W<<4,N=2;break;default:d=W<<2,N=1}};for(let W=0;W<y.length;W++){const H=y.charCodeAt(W);if(H>=65&&H<=90)V(H-65);else if(H>=97&&H<=122)V(H-97+26);else if(H>=48&&H<=57)V(H-48+52);else if(H===43||H===45)V(62);else if(H===47||H===95)V(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${y[W]}`)}}const _=z;for(;N>0;)V(0);return t.wrap(q).slice(0,_)}e.$Be=u;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:y},d=!0,N=!1){const z=N?w:m;let q="";const V=y.byteLength%3;let _=0;for(;_<y.byteLength-V;_+=3){const W=y[_+0],H=y[_+1],J=y[_+2];q+=z[W>>>2],q+=z[(W<<4|H>>>4)&63],q+=z[(H<<2|J>>>6)&63],q+=z[J&63]}if(V===1){const W=y[_+0];q+=z[W>>>2],q+=z[W<<4&63],d&&(q+="==")}else if(V===2){const W=y[_+0],H=y[_+1];q+=z[W>>>2],q+=z[(W<<4|H>>>4)&63],q+=z[H<<2&63],d&&(q+="=")}return q}e.$Ce=I}),define(K[26],p([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Rd=Symbol("MicrotaskDelay")}),define(K[13],p([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.StringEOL=void 0;var P;(function(E){E[E.Unknown=0]="Unknown",E[E.Invalid=3]="Invalid",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function S(E){let L=0,s=0,f=0,t=0;for(let c=0,$=E.length;c<$;c++){const l=E.charCodeAt(c);l===13?(L===0&&(s=c),L++,c+1<$&&E.charCodeAt(c+1)===10?(t|=2,c++):t|=3,f=c+1):l===10&&(t|=1,L===0&&(s=c),L++,f=c+1)}return L===0&&(s=E.length),[L,s,E.length-f,t]}e.$tt=S}),define(K[14],p([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var E;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var L;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(L||(e.StandardTokenType=L={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class f{static getLanguageId(c){return(c&255)>>>0}static getTokenType(c){return(c&768)>>>8}static containsBalancedBrackets(c){return(c&1024)!==0}static getFontStyle(c){return(c&30720)>>>11}static getForeground(c){return(c&16744448)>>>15}static getBackground(c){return(c&4278190080)>>>24}static getClassNameFromMetadata(c){let l="mtk"+this.getForeground(c);const h=this.getFontStyle(c);return h&1&&(l+=" mtki"),h&2&&(l+=" mtkb"),h&4&&(l+=" mtku"),h&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(c,$){const l=this.getForeground(c),h=this.getFontStyle(c);let a=`color: ${$[l]};`;h&1&&(a+="font-style: italic;"),h&2&&(a+="font-weight: bold;");let i="";return h&4&&(i+=" underline"),h&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(c){const $=this.getForeground(c),l=this.getFontStyle(c);return{foreground:$,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$rt=f}),define(K[27],p([0,1,28]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=void 0;class S{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,f){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=f}replace(s,f,t){if(s>=this.a.length)return;if(f===0){this.insert(s,t);return}else if(t===0){this.delete(s,f);return}const c=this.a.slice(0,s),$=this.a.slice(s+f),l=E(t,this.b);this.a=c.concat(l,$)}delete(s,f){f===0||s>=this.a.length||this.a.splice(s,f)}insert(s,f){if(f===0||s>=this.a.length)return;const t=[];for(let c=0;c<f;c++)t[c]=this.b;this.a=(0,P.$Wb)(this.a,s,t)}}e.$fC=S;function E(L,s){const f=[];for(let t=0;t<L;t++)f[t]=s;return f}}),define(K[7],p([0,1,14]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,f){const t=S.defaultTokenMetadata,c=new Uint32Array(2);return c[0]=s.length,c[1]=t,new S(c,s,f)}constructor(s,f,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=f,this.d=t}equals(s){return s instanceof S?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,f,t){if(this.c!==s.c||this.b!==s.b)return!1;const c=f<<1,$=c+(t<<1);for(let l=c;l<$;l++)if(this.a[l]!==s.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const f=this.a[(s<<1)+1],t=P.$rt.getLanguageId(f);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const f=this.a[(s<<1)+1];return P.$rt.getTokenType(f)}getForeground(s){const f=this.a[(s<<1)+1];return P.$rt.getForeground(f)}getClassName(s){const f=this.a[(s<<1)+1];return P.$rt.getClassNameFromMetadata(f)}getInlineStyle(s,f){const t=this.a[(s<<1)+1];return P.$rt.getInlineStyleFromMetadata(t,f)}getPresentation(s){const f=this.a[(s<<1)+1];return P.$rt.getPresentationFromMetadata(f)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return S.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,f,t){return new E(this,s,f,t)}static convertToEndOffset(s,f){const c=(s.length>>>1)-1;for(let $=0;$<c;$++)s[$<<1]=s[$+1<<1];s[c<<1]=f}static findIndexInTokensArray(s,f){if(s.length<=2)return 0;let t=0,c=(s.length>>>1)-1;for(;t<c;){const $=t+Math.floor((c-t)/2),l=s[$<<1];if(l===f)return $+1;l<f?t=$+1:l>f&&(c=$)}return t}withInserted(s){if(s.length===0)return this;let f=0,t=0,c="";const $=new Array;let l=0;for(;;){const h=f<this.b?this.a[f<<1]:-1,a=t<s.length?s[t]:null;if(h!==-1&&(a===null||h<=a.offset)){c+=this.c.substring(l,h);const i=this.a[(f<<1)+1];$.push(c.length,i),f++,l=h}else if(a){if(a.offset>l){c+=this.c.substring(l,a.offset);const i=this.a[(f<<1)+1];$.push(c.length,i),l=a.offset}c+=a.text,$.push(c.length,a.tokenMetadata),t++}else break}return new S(new Uint32Array($),c,this.d)}}e.$ut=S;class E{constructor(s,f,t,c){this.a=s,this.b=f,this.c=t,this.d=c,this.e=s.findTokenIndexAtOffset(f),this.f=0;for(let $=this.e,l=s.getCount();$<l&&!(s.getStartOffset($)>=t);$++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof E?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const f=this.a.getEndOffset(this.e+s);return Math.min(this.c,f)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,f){return this.a.getInlineStyle(this.e+s,f)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(K[29],p([0,1,7]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=e.$vt=void 0,e.$vt=new Uint32Array(0).buffer;class S{static deleteBeginning(s,f){return s===null||s===e.$vt?s:S.delete(s,0,f)}static deleteEnding(s,f){if(s===null||s===e.$vt)return s;const t=E(s),c=t[t.length-2];return S.delete(s,f,c)}static delete(s,f,t){if(s===null||s===e.$vt||f===t)return s;const c=E(s),$=c.length>>>1;if(f===0&&c[c.length-2]===t)return e.$vt;const l=P.$ut.findIndexInTokensArray(c,f),h=l>0?c[l-1<<1]:0,a=c[l<<1];if(t<a){const T=t-f;for(let j=l;j<$;j++)c[j<<1]-=T;return s}let i,n;h!==f?(c[l<<1]=f,i=l+1<<1,n=f):(i=l<<1,n=h);const r=t-f;for(let T=l+1;T<$;T++){const j=c[T<<1]-r;j>n&&(c[i++]=j,c[i++]=c[(T<<1)+1],n=j)}if(i===c.length)return s;const b=new Uint32Array(i);return b.set(c.subarray(0,i),0),b.buffer}static append(s,f){if(f===e.$vt)return s;if(s===e.$vt)return f;if(s===null)return s;if(f===null)return null;const t=E(s),c=E(f),$=c.length>>>1,l=new Uint32Array(t.length+c.length);l.set(t,0);let h=t.length;const a=t[t.length-2];for(let i=0;i<$;i++)l[h++]=c[i<<1]+a,l[h++]=c[(i<<1)+1];return l.buffer}static insert(s,f,t){if(s===null||s===e.$vt)return s;const c=E(s),$=c.length>>>1;let l=P.$ut.findIndexInTokensArray(c,f);l>0&&c[l-1<<1]===f&&l--;for(let h=l;h<$;h++)c[h<<1]+=t;return s}}e.$wt=S;function E(L){return L instanceof Uint32Array?L:new Uint32Array(L)}e.$xt=E}),define(K[30],p([0,1,28,12,44,13,29,15]),function(G,e,P,S,E,L,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0;class t{static deserialize($,l,h){const a=new Uint32Array($.buffer),i=(0,S.$me)($,l);l+=4;const n=(0,S.$me)($,l);l+=4;const r=[];for(let b=0;b<n;b++){const T=(0,S.$me)($,l);l+=4,r.push(a.subarray(l/4,l/4+T/4)),l+=T}return h.push(new t(i,r)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor($,l){this.a=$,this.b=l}getLineRange(){return new f.$3s(this.a,this.a+this.b.length)}getLineTokens($){return this.b[$-this.a]}appendLineTokens($){this.b.push($)}serializeSize(){let $=0;$+=4,$+=4;for(let l=0;l<this.b.length;l++){const h=this.b[l];if(!(h instanceof Uint32Array))throw new Error("Not supported!");$+=4,$+=h.byteLength}return $}serialize($,l){(0,S.$ne)($,this.a,l),l+=4,(0,S.$ne)($,this.b.length,l),l+=4;for(let h=0;h<this.b.length;h++){const a=this.b[h];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,S.$ne)($,a.byteLength,l),l+=4,$.set(new Uint8Array(a.buffer),l),l+=a.byteLength}return l}applyEdit($,l){const[h,a]=(0,L.$tt)(l);this.c($),this.d(new E.$Ss($.startLineNumber,$.startColumn),h,a)}c($){if($.startLineNumber===$.endLineNumber&&$.startColumn===$.endColumn)return;const l=$.startLineNumber-this.a,h=$.endLineNumber-this.a;if(h<0){const a=h-l;this.a-=a;return}if(!(l>=this.b.length)){if(l<0&&h>=this.b.length){this.a=0,this.b=[];return}if(l===h){this.b[l]=s.$wt.delete(this.b[l],$.startColumn-1,$.endColumn-1);return}if(l>=0)if(this.b[l]=s.$wt.deleteEnding(this.b[l],$.startColumn-1),h<this.b.length){const a=s.$wt.deleteBeginning(this.b[h],$.endColumn-1);this.b[l]=s.$wt.append(this.b[l],a),this.b.splice(l+1,h-l)}else this.b[l]=s.$wt.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const a=-l;this.a-=a,this.b[h]=s.$wt.deleteBeginning(this.b[h],$.endColumn-1),this.b=this.b.slice(h)}}}d($,l,h){if(l===0&&h===0)return;const a=$.lineNumber-this.a;if(a<0){this.a+=l;return}if(!(a>=this.b.length)){if(l===0){this.b[a]=s.$wt.insert(this.b[a],$.column-1,h);return}this.b[a]=s.$wt.deleteEnding(this.b[a],$.column-1),this.b[a]=s.$wt.insert(this.b[a],$.column-1,h),this.e($.lineNumber,l)}}e($,l){if(l===0)return;const h=[];for(let a=0;a<l;a++)h[a]=null;this.b=P.$Wb(this.b,$,h)}}e.$yt=t}),define(K[16],p([0,1,12,30]),function(G,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class E{static deserialize(s){let f=0;const t=(0,P.$me)(s,f);f+=4;const c=[];for(let $=0;$<t;$++)f=S.$yt.deserialize(s,f,c);return c}constructor(){this.a=[]}add(s,f){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(f);return}}this.a.push(new S.$yt(s,[f]))}finalize(){return this.a}serialize(){const s=this.b(),f=new Uint8Array(s);return this.c(f),f}b(){let s=0;s+=4;for(let f=0;f<this.a.length;f++)s+=this.a[f].serializeSize();return s}c(s){let f=0;(0,P.$ne)(s,this.a.length,f),f+=4;for(let t=0;t<this.a.length;t++)f=this.a[t].serialize(s,f)}}e.$gC=E}),define(K[31],p([0,1,32,3,17,45]),function(G,e,P,S,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=void 0;function s(u){return u===47||u===92}e.$Zf=s;function f(u){return u.replace(/[\\/]/g,P.$gc.sep)}e.$1f=f;function t(u){return u.indexOf("/")===-1&&(u=f(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$2f=t;function c(u,m=P.$gc.sep){if(!u)return"";const w=u.length,I=u.charCodeAt(0);if(s(I)){if(s(u.charCodeAt(1))&&!s(u.charCodeAt(2))){let d=3;const N=d;for(;d<w&&!s(u.charCodeAt(d));d++);if(N!==d&&!s(u.charCodeAt(d+1))){for(d+=1;d<w;d++)if(s(u.charCodeAt(d)))return u.slice(0,d+1).replace(/[\\/]/g,m)}}return m}else if(b(I)&&u.charCodeAt(1)===58)return s(u.charCodeAt(2))?u.slice(0,2)+m:u.slice(0,2);let y=u.indexOf("://");if(y!==-1){for(y+=3;y<w;y++)if(s(u.charCodeAt(y)))return u.slice(0,y+1)}return""}e.$3f=c;function $(u){if(!S.$i||!u||u.length<5)return!1;let m=u.charCodeAt(0);if(m!==92||(m=u.charCodeAt(1),m!==92))return!1;let w=2;const I=w;for(;w<u.length&&(m=u.charCodeAt(w),m!==92);w++);return!(I===w||(m=u.charCodeAt(w+1),isNaN(m)||m===92))}e.$4f=$;const l=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(u,m=S.$i){const w=m?l:h;return!(!u||u.length===0||/^\s+$/.test(u)||(w.lastIndex=0,w.test(u))||m&&a.test(u)||u==="."||u===".."||m&&u[u.length-1]==="."||m&&u.length!==u.trim().length||u.length>255)}e.$5f=i;function n(u,m,w){const I=u===m;return!w||I?I:!u||!m?!1:(0,E.$$e)(u,m)}e.$6f=n;function r(u,m,w,I=P.sep){if(u===m)return!0;if(!u||!m||m.length>u.length)return!1;if(w){if(!(0,E.$_e)(u,m))return!1;if(m.length===u.length)return!0;let d=m.length;return m.charAt(m.length-1)===I&&d--,u.charAt(d)===I}return m.charAt(m.length-1)!==I&&(m+=I),u.indexOf(m)===0}e.$7f=r;function b(u){return u>=65&&u<=90||u>=97&&u<=122}e.$8f=b;function T(u,m){return S.$i&&u.endsWith(":")&&(u+=P.sep),(0,P.$ic)(u)||(u=(0,P.$jc)(m,u)),u=(0,P.$hc)(u),S.$i?(u=(0,E.$Te)(u,P.sep),u.endsWith(":")&&(u+=P.sep)):(u=(0,E.$Te)(u,P.sep),u||(u=P.sep)),u}e.$9f=T;function j(u){const m=(0,P.$hc)(u);return S.$i?u.length>3?!1:M(m)&&(u.length===2||m.charCodeAt(2)===92):m===P.$gc.sep}e.$0f=j;function M(u,m=S.$i){return m?b(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$$f=M;function O(u,m=S.$i){return M(u,m)?u[0]:void 0}e.$_f=O;function g(u,m,w){return m.length>u.length?-1:u===m?0:(w&&(u=u.toLowerCase(),m=m.toLowerCase()),u.indexOf(m))}e.$ag=g;function k(u){const m=u.split(":");let w,I,y;for(const d of m){const N=Number(d);(0,L.$Lf)(N)?I===void 0?I=N:y===void 0&&(y=N):w=w?[w,d].join(":"):d}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:I!==void 0?I:void 0,column:y!==void 0?y:I!==void 0?1:void 0}}e.$bg=k;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",F="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(u,m,w=8){let I="";for(let d=0;d<w;d++){let N;d===0&&S.$i&&!m&&(w===3||w===4)?N=F:N=C,I+=N.charAt(Math.floor(Math.random()*N.length))}let y;return m?y=`${m}-${I}`:y=I,u?(0,P.$jc)(u,y):y}e.$cg=D}),define(K[18],p([0,1,6,3,17,8]),function(G,e,P,S,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.Schemas=void 0;var s;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(s||(e.Schemas=s={}));function f(h,a){return L.URI.isUri(h)?(0,E.$$e)(h.scheme,a):(0,E.$_e)(h,a+":")}e.$dg=f;function t(h,...a){return a.some(i=>f(h,i))}e.$eg=t,e.$fg="vscode-tkn",e.$gg="tkn";class c{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${s.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${s.vscodeRemoteResource}`}set(a,i,n){this.a[a]=i,this.b[a]=n}setConnectionToken(a,i){this.c[a]=i}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(j){return P.$1(j),a}const i=a.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[i],b=this.c[i];let T=`path=${encodeURIComponent(a.path)}`;return typeof b=="string"&&(T+=`&${e.$gg}=${encodeURIComponent(b)}`),L.URI.from({scheme:S.$o?this.d:s.vscodeRemoteResource,authority:`${n}:${r}`,path:this.f,query:T})}}e.$hg=new c,e.$ig="vs/../../extensions",e.$jg="vs/../../node_modules",e.$kg="vs/../../node_modules.asar",e.$lg="vs/../../node_modules.asar.unpacked",e.$mg="vscode-app";class ${static{this.a=e.$mg}asBrowserUri(a){const i=this.b(a,G);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===s.vscodeRemote?e.$hg.rewrite(a):a.scheme===s.file&&(S.$m||S.$q===`${s.vscodeFileResource}://${$.a}`)?a.with({scheme:s.vscodeFileResource,authority:a.authority||$.a,query:null,fragment:null}):a}asFileUri(a){const i=this.b(a,G);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===s.vscodeFileResource?a.with({scheme:s.file,authority:a.authority!==$.a?a.authority:null,query:null,fragment:null}):a}b(a,i){return L.URI.isUri(a)?a:L.URI.parse(i.toUrl(a))}}e.$ng=new $;var l;(function(h){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(b){let T;typeof b=="string"?T=new URL(b).searchParams:b instanceof URL?T=b.searchParams:L.URI.isUri(b)&&(T=new URL(b.toString(!0)).searchParams);const j=T?.get(i);if(j)return a.get(j)}h.getHeadersFromQuery=n;function r(b,T,j){if(!globalThis.crossOriginIsolated)return;const M=T&&j?"3":j?"2":"1";b instanceof URLSearchParams?b.set(i,M):b[i]=M}h.addSearchParam=r})(l||(e.COI=l={}))}),define(K[33],p([0,1,22,18,3,8]),function(G,e,P,S,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=void 0;class s{constructor(h,a,i){this.id=h,this.dependencies=a,this.callback=i}}class f{static{this.INSTANCE=new f}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,a,i)=>{typeof h!="string"&&(i=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this.c.push(new s(h,a,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const a=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!a)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(h){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const r=()=>{n.removeEventListener("load",b),n.removeEventListener("error",T)},b=j=>{r(),a(this.c.pop())},T=j=>{r(),i(j)};n.addEventListener("load",b),n.addEventListener("error",T),this.f&&(h=this.f.createScriptURL(h)),n.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(h){return new Promise((a,i)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),a(this.c.pop())}catch(n){i(n)}})}async j(h){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,r=L.URI.parse(h).fsPath,b=a.readFileSync(r).toString(),T=n.wrap(b.replace(/^#!.*/,""));return new i.Script(T).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const t=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function $(l,h,a){if(P.$T){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[l]&&(l=c[l]);const i=`${l}/${h}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const j=`${a&&!E.$o?S.$kg:S.$jg}/${i}`;n=S.$ng.asBrowserUri(j).toString(!0)}const r=f.INSTANCE.load(n);return t.set(i,r),r}else return await new Promise((i,n)=>{G([l],i,n)})}e.$eD=$}),define(K[19],p([0,1,31,18,32,3,17,8]),function(G,e,P,S,E,L,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.DataUri=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=void 0;function t(a){return(0,f.$wc)(a,!0)}e.$ug=t;class c{constructor(i){this.a=i}compare(i,n,r=!1){return i===n?0:(0,s.$4e)(this.getComparisonKey(i,r),this.getComparisonKey(n,r))}isEqual(i,n,r=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,r)===this.getComparisonKey(n,r)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,r=!1){if(i.scheme===n.scheme){if(i.scheme===S.Schemas.file)return P.$7f(t(i),t(n),this.a(i))&&i.query===n.query&&(r||i.fragment===n.fragment);if((0,e.$Lg)(i.authority,n.authority))return P.$7f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(r||i.fragment===n.fragment)}return!1}joinPath(i,...n){return f.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$Dg)(i)||i.authority}basename(i){return E.$gc.basename(i.path)}extname(i){return E.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===S.Schemas.file?n=f.URI.file(E.$mc(t(i))).path:(n=E.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===S.Schemas.file?n=f.URI.file(E.$hc(t(i))).path:n=E.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Lg)(i.authority,n.authority))return;if(i.scheme===S.Schemas.file){const T=E.$lc(t(i),t(n));return L.$i?P.$1f(T):T}let r=i.path||"/";const b=n.path||"/";if(this.a(i)){let T=0;for(const j=Math.min(r.length,b.length);T<j&&!(r.charCodeAt(T)!==b.charCodeAt(T)&&r.charAt(T).toLowerCase()!==b.charAt(T).toLowerCase());T++);r=b.substr(0,T)+r.substr(T)}return E.$gc.relative(r,b)}resolvePath(i,n){if(i.scheme===S.Schemas.file){const r=f.URI.file(E.$kc(t(i),n));return i.with({authority:r.authority,path:r.path})}return n=P.$2f(n),i.with({path:E.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$$e)(i,n)}hasTrailingPathSeparator(i,n=E.sep){if(i.scheme===S.Schemas.file){const r=t(i);return r.length>P.$3f(r).length&&r[r.length-1]===n}else{const r=i.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=E.sep){return(0,e.$Mg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=E.sep){let r=!1;if(i.scheme===S.Schemas.file){const b=t(i);r=b!==void 0&&b.length===P.$3f(b).length&&b[b.length-1]===n}else{n="/";const b=i.path;r=b.length===1&&b.charCodeAt(b.length-1)===47}return!r&&!(0,e.$Mg)(i,n)?i.with({path:i.path+"/"}):i}}e.$vg=c,e.$wg=new c(()=>!1),e.$xg=new c(a=>a.scheme===S.Schemas.file?!L.$k:!0),e.$yg=new c(a=>!0),e.$zg=e.$wg.isEqual.bind(e.$wg),e.$Ag=e.$wg.isEqualOrParent.bind(e.$wg),e.$Bg=e.$wg.getComparisonKey.bind(e.$wg),e.$Cg=e.$wg.basenameOrAuthority.bind(e.$wg),e.$Dg=e.$wg.basename.bind(e.$wg),e.$Eg=e.$wg.extname.bind(e.$wg),e.$Fg=e.$wg.dirname.bind(e.$wg),e.$Gg=e.$wg.joinPath.bind(e.$wg),e.$Hg=e.$wg.normalizePath.bind(e.$wg),e.$Ig=e.$wg.relativePath.bind(e.$wg),e.$Jg=e.$wg.resolvePath.bind(e.$wg),e.$Kg=e.$wg.isAbsolutePath.bind(e.$wg),e.$Lg=e.$wg.isEqualAuthority.bind(e.$wg),e.$Mg=e.$wg.hasTrailingPathSeparator.bind(e.$wg),e.$Ng=e.$wg.removeTrailingPathSeparator.bind(e.$wg),e.$Og=e.$wg.addTrailingPathSeparator.bind(e.$wg);function $(a,i){const n=[];for(let r=0;r<a.length;r++){const b=i(a[r]);a.some((T,j)=>j===r?!1:(0,e.$Ag)(b,i(T)))||n.push(a[r])}return n}e.$Pg=$;var l;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(j=>{const[M,O]=j.split(":");M&&O&&r.set(M,O)});const T=n.path.substring(0,n.path.indexOf(";"));return T&&r.set(a.META_DATA_MIME,T),r}a.parseMetaData=i})(l||(e.DataUri=l={}));function h(a,i,n){if(i){let r=a.path;return r&&r[0]!==E.$gc.sep&&(r=E.$gc.sep+r),a.with({scheme:n,authority:i,path:r})}return a.with({scheme:n})}e.$Qg=h}),define(K[20],p([0,1,46,6,34,2,19,3,26,25]),function(G,e,P,S,E,L,s,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.Promises=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=void 0;function $(R){return!!R&&typeof R.then=="function"}e.$Rg=$;function l(R){const o=new P.$5d,v=R(o.token),A=new Promise((U,B)=>{const Z=o.token.onCancellationRequested(()=>{Z.dispose(),B(new S.$5)});Promise.resolve(v).then(Y=>{Z.dispose(),o.dispose(),U(Y)},Y=>{Z.dispose(),o.dispose(),B(Y)})});return new class{cancel(){o.cancel(),o.dispose()}then(U,B){return A.then(U,B)}catch(U){return this.then(void 0,U)}finally(U){return A.finally(U)}}}e.$Sg=l;function h(R,o,v){return new Promise((A,U)=>{const B=o.onCancellationRequested(()=>{B.dispose(),A(v)});R.then(A,U).finally(()=>B.dispose())})}e.$Tg=h;function a(R,o){return new Promise((v,A)=>{const U=o.onCancellationRequested(()=>{U.dispose(),A(new S.$5)});R.then(v,A).finally(()=>U.dispose())})}e.$Ug=a;async function i(R){let o=-1;const v=R.map((A,U)=>A.then(B=>(o=U,B)));try{return await Promise.race(v)}finally{R.forEach((A,U)=>{U!==o&&A.cancel()})}}e.$Vg=i;function n(R,o,v){let A;const U=setTimeout(()=>{A?.(void 0),v?.()},o);return Promise.race([R.finally(()=>clearTimeout(U)),new Promise(B=>A=B)])}e.$Wg=n;function r(R){return new Promise((o,v)=>{const A=R();$(A)?A.then(o,v):o(A)})}e.$Xg=r;class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const v=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(v,v).then(A)})}return new Promise((v,A)=>{this.b.then(v,A)})}return this.a=o(),new Promise((v,A)=>{this.a.then(U=>{this.a=null,v(U)},U=>{this.a=null,A(U)})})}dispose(){this.f=!0}}e.$Yg=b;class T{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$Zg=T;class j{constructor(){this.a=new Map}queue(o,v){const U=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(o)===U&&this.a.delete(o)});return this.a.set(o,U),U}}e.$1g=j;const M=(R,o)=>{let v=!0;const A=setTimeout(()=>{v=!1,o()},R);return{isTriggered:()=>v,dispose:()=>{clearTimeout(A),v=!1}}},O=R=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,R())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class g{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,v=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((U,B)=>{this.d=U,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=v===t.$Rd?O(A):M(v,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$2g=g;class k{constructor(o){this.a=new g(o),this.b=new b}trigger(o,v){return this.a.trigger(()=>this.b.queue(o),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$3g=k;class C{constructor(){this.a=!1,this.b=new Promise((o,v)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$4g=C;class F extends C{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$5g=F;function D(R,o){return o?new Promise((v,A)=>{const U=setTimeout(()=>{B.dispose(),v()},R),B=o.onCancellationRequested(()=>{clearTimeout(U),B.dispose(),A(new S.$5)})}):l(v=>D(R,v))}e.$6g=D;function u(R,o=0,v){const A=setTimeout(()=>{R(),v&&U.dispose()},o),U=(0,L.$Rc)(()=>{clearTimeout(A),v?.deleteAndLeak(U)});return v?.add(U),U}e.$7g=u;function m(R){const o=[];let v=0;const A=R.length;function U(){return v<A?R[v++]():null}function B(Z){Z!=null&&o.push(Z);const Y=U();return Y?Y.then(B):Promise.resolve(o)}return Promise.resolve(null).then(B)}e.$8g=m;function w(R,o=A=>!!A,v=null){let A=0;const U=R.length,B=()=>{if(A>=U)return Promise.resolve(v);const Z=R[A++];return Promise.resolve(Z()).then(X=>o(X)?Promise.resolve(X):B())};return B()}e.$9g=w;function I(R,o=A=>!!A,v=null){if(R.length===0)return Promise.resolve(v);let A=R.length;const U=()=>{A=-1;for(const B of R)B.cancel?.()};return new Promise((B,Z)=>{for(const Y of R)Y.then(X=>{--A>=0&&o(X)?(U(),B(X)):A===0&&B(v)}).catch(X=>{--A>=0&&(U(),Z(X))})})}e.$0g=I;class y{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new E.$Ud}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,A)=>{this.g.push({factory:o,c:v,e:A}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const v=o.factory();v.then(o.c,o.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$$g=y;class d extends y{constructor(){super(1)}}e.$_g=d;class N{constructor(){this.a=new te,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$ah=N;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new x;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,v=s.$wg){const A=v.getComparisonKey(o);return this.a.get(A)?.size??0}queueFor(o,v,A=s.$wg){const U=A.getComparisonKey(o);let B=this.a.get(U);if(!B){B=new d;const Z=this.f++,Y=E.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(U),this.h(),this.d?.deleteAndDispose(Z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(Z,Y),this.a.set(U,B)}return B.queue(v)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$bh=z;class q{constructor(o,v){this.a=-1,typeof o=="function"&&typeof v=="number"&&this.setIfNotSet(o,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},v)}setIfNotSet(o,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},v))}}e.$ch=q;class V{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,v,A=globalThis){this.cancel();const U=A.setInterval(()=>{o()},v);this.d=(0,L.$Rc)(()=>{A.clearInterval(U),this.d=void 0})}dispose(){this.cancel()}}e.$dh=V;class _{constructor(o,v){this.b=-1,this.a=o,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$eh=_;class W{constructor(o,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=o,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$fh=W;class H extends _{constructor(o,v){super(o,v),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$gh=H;class J extends L.$Tc{constructor(o,v){super(),this.g=o,this.h=v,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of o)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$hh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$jh=(R,o)=>{(0,f.$B)(()=>{if(v)return;const A=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$jh=(R,o,v)=>{const A=R.requestIdleCallback(o,typeof v=="number"?{timeout:v}:void 0);let U=!1;return{dispose(){U||(U=!0,R.cancelIdleCallback(A))}}},e.$ih=R=>(0,e.$jh)(globalThis,R)}();class ee{constructor(o,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(A){this.l=A}finally{this.g=!0}},this.f=(0,e.$jh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$kh=ee;class he extends ee{constructor(o){super(globalThis,o)}}e.$lh=he;async function ue(R,o,v){let A;for(let U=0;U<v;U++)try{return await R()}catch(B){A=B,await D(o)}throw A}e.$mh=ue;class te{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,v,A){return this.a={taskId:o,cancel:()=>A?.(),promise:v},v.then(()=>this.d(o),()=>this.d(o)),v}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{let v,A;const U=new Promise((B,Z)=>{v=B,A=Z});this.b={run:o,promise:U,promiseResolve:v,promiseReject:A}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$nh=te;class oe{constructor(o,v=()=>Date.now()){this.d=o,this.f=v,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$oh=oe;var ne;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,v)=>{this.a=o,this.b=v})}complete(o){return new Promise(v=>{this.a(o),this.d={outcome:0,value:o},v()})}error(o){return new Promise(v=>{this.b(o),this.d={outcome:1,value:o},v()})}cancel(){return this.error(new S.$5)}}e.$ph=x;var ie;(function(R){async function o(A){let U;const B=await Promise.all(A.map(Z=>Z.then(Y=>Y,Y=>{U||(U=Y)})));if(typeof U<"u")throw U;return B}R.settled=o;function v(A){return new Promise(async(U,B)=>{try{await A(U,B)}catch(Z){B(Z)}})}R.withAsyncBody=v})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$qh=se;class ce{constructor(o){this.b=o,this.a=new c.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$rh=ce;var re;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(re||(re={}));class Q{static fromArray(o){return new Q(v=>{v.emitMany(o)})}static fromPromise(o){return new Q(async v=>{v.emitMany(await o)})}static fromPromises(o){return new Q(async v=>{await Promise.all(o.map(async A=>v.emitOne(await A)))})}static merge(o){return new Q(async v=>{await Promise.all(o.map(async A=>{for await(const U of A)v.emitOne(U)}))})}static{this.EMPTY=Q.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new E.$Ud,queueMicrotask(async()=>{const v={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(o(v)),this.j()}catch(A){this.k(A)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await E.Event.toPromise(this.f.event)}while(!0)}}}static map(o,v){return new Q(async A=>{for await(const U of o)A.emitOne(v(U))})}map(o){return Q.map(this,o)}static filter(o,v){return new Q(async A=>{for await(const U of o)v(U)&&A.emitOne(U)})}filter(o){return Q.filter(this,o)}static coalesce(o){return Q.filter(o,v=>!!v)}coalesce(){return Q.coalesce(this)}static async toPromise(o){const v=[];for await(const A of o)v.push(A);return v}toPromise(){return Q.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$sh=Q;class ae extends Q{constructor(o,v){super(v),this.l=o}cancel(){this.l.cancel()}}e.$th=ae;function de(R){const o=new P.$5d,v=R(o.token);return new ae(o,async A=>{const U=o.token.onCancellationRequested(()=>{U.dispose(),o.dispose(),A.reject(new S.$5)});try{for await(const B of v){if(o.token.isCancellationRequested)return;A.emitOne(B)}U.dispose(),o.dispose()}catch(B){U.dispose(),o.dispose(),A.reject(B)}})}e.$uh=de;class le{constructor(){this.a=new x,this.b=new Q(A=>{if(o){A.reject(o);return}return v&&A.emitMany(v),this.d=U=>A.reject(U),this.f=U=>A.emitOne(U),this.a.p});let o,v;this.f=A=>{v||(v=[]),v.push(A)},this.d=A=>{o||(o=A)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}e.$vh=le}),define(K[21],p([0,1,35]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=e.$dC=e.$cC=void 0,e.$cC=new class{clone(){return this}equals(L){return this===L}};function S(L,s){return new P.$Ct([new P.$Bt(0,"",L)],s)}e.$dC=S;function E(L,s){const f=new Uint32Array(2);return f[0]=0,f[1]=(L<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new P.$Dt(f,s===null?e.$cC:s)}e.$eC=E}),define(K[36],p([0,1,20,6,3,37,13,15,47,21,27,16,7]),function(G,e,P,S,E,L,s,f,t,c,$,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=void 0;var a;(function(O){O[O.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(g,k){this.tokenizationSupport=k,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(g)}getStartState(g){return this.store.getStartState(g,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$hC=i;class n extends i{constructor(g,k,C,F){super(g,k),this._textModel=C,this._languageIdCodec=F}updateTokensUntilLine(g,k){const C=this._textModel.getLanguageId();for(;;){const F=this.getFirstInvalidLine();if(!F||F.lineNumber>k)break;const D=this._textModel.getLineContent(F.lineNumber),u=j(this._languageIdCodec,C,this.tokenizationSupport,D,!0,F.startState);g.add(F.lineNumber,u.tokens),this.store.setEndState(F.lineNumber,u.endState)}}getTokenTypeIfInsertingCharacter(g,k){const C=this.getStartState(g.lineNumber);if(!C)return 0;const F=this._textModel.getLanguageId(),D=this._textModel.getLineContent(g.lineNumber),u=D.substring(0,g.column-1)+k+D.substring(g.column-1),m=j(this._languageIdCodec,F,this.tokenizationSupport,u,!0,C),w=new h.$ut(m.tokens,u,this._languageIdCodec);if(w.getCount()===0)return 0;const I=w.findTokenIndexAtOffset(g.column-1);return w.getStandardTokenType(I)}tokenizeLineWithEdit(g,k,C){const F=g.lineNumber,D=g.column,u=this.getStartState(F);if(!u)return null;const m=this._textModel.getLineContent(F),w=m.substring(0,D-1)+C+m.substring(D-1+k),I=this._textModel.getLanguageIdAtPosition(F,0),y=j(this._languageIdCodec,I,this.tokenizationSupport,w,!0,u);return new h.$ut(y.tokens,w,this._languageIdCodec)}isCheapToTokenize(g){const k=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<k||g===k&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,k,C){if(C<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(k<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,C),{heuristicTokens:!1};let F=this.b(k);const D=this._textModel.getLanguageId();for(let u=k;u<=C;u++){const m=this._textModel.getLineContent(u),w=j(this._languageIdCodec,D,this.tokenizationSupport,m,!0,F);g.add(u,w.tokens),F=w.endState}return{heuristicTokens:!0}}b(g){let k=this._textModel.getLineFirstNonWhitespaceColumn(g);const C=[];let F=null;for(let m=g-1;k>1&&m>=1;m--){const w=this._textModel.getLineFirstNonWhitespaceColumn(m);if(w!==0&&w<k&&(C.push(this._textModel.getLineContent(m)),k=w,F=this.getStartState(m),F))break}F||(F=this.tokenizationSupport.getInitialState()),C.reverse();const D=this._textModel.getLanguageId();let u=F;for(const m of C)u=j(this._languageIdCodec,D,this.tokenizationSupport,m,!1,u).endState;return u}}e.$iC=n;class r{constructor(g){this.d=g,this.a=new b,this.b=new T,this.b.addRange(new t.$1s(1,g+1))}getEndState(g){return this.a.getEndState(g)}setEndState(g,k){if(!k)throw new S.$cb("Cannot set null/undefined state");this.b.delete(g);const C=this.a.setEndState(g,k);return C&&g<this.d&&this.b.addRange(new t.$1s(g+1,g+2)),C}acceptChange(g,k){this.d+=k-g.length,this.a.acceptChange(g,k),this.b.addRangeAndResize(new t.$1s(g.startLineNumber,g.endLineNumberExclusive),k)}acceptChanges(g){for(const k of g){const[C]=(0,s.$tt)(k.text);this.acceptChange(new f.$3s(k.range.startLineNumber,k.range.endLineNumber+1),C+1)}}invalidateEndStateRange(g){this.b.addRange(new t.$1s(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(g,k){return g===1?k:this.getEndState(g-1)}getFirstInvalidLine(g){const k=this.getFirstInvalidEndStateLineNumber();if(k===null)return null;const C=this.getStartState(k,g);if(!C)throw new S.$cb("Start state must be defined");return{lineNumber:k,startState:C}}}e.$jC=r;class b{constructor(){this.a=new $.$fC(null)}getEndState(g){return this.a.get(g)}setEndState(g,k){const C=this.a.get(g);return C&&C.equals(k)?!1:(this.a.set(g,k),!0)}acceptChange(g,k){let C=g.length;k>0&&C>0&&(C--,k--),this.a.replace(g.startLineNumber,C,k)}acceptChanges(g){for(const k of g){const[C]=(0,s.$tt)(k.text);this.acceptChange(new f.$3s(k.range.startLineNumber,k.range.endLineNumber+1),C+1)}}}e.$kC=b;class T{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const g=this.a[0];return g.start+1===g.endExclusive?this.a.shift():this.a[0]=new t.$1s(g.start+1,g.endExclusive),g.start}delete(g){const k=this.a.findIndex(C=>C.contains(g));if(k!==-1){const C=this.a[k];C.start===g?C.endExclusive===g+1?this.a.splice(k,1):this.a[k]=new t.$1s(g+1,C.endExclusive):C.endExclusive===g+1?this.a[k]=new t.$1s(C.start,g):this.a.splice(k,1,new t.$1s(C.start,g),new t.$1s(g+1,C.endExclusive))}}addRange(g){t.$1s.addRange(g,this.a)}addRangeAndResize(g,k){let C=0;for(;!(C>=this.a.length||g.start<=this.a[C].endExclusive);)C++;let F=C;for(;!(F>=this.a.length||g.endExclusive<this.a[F].start);)F++;const D=k-g.length;for(let u=F;u<this.a.length;u++)this.a[u]=this.a[u].delta(D);if(C===F){const u=new t.$1s(g.start,g.start+k);u.isEmpty||this.a.splice(C,0,u)}else{const u=Math.min(g.start,this.a[C].start),m=Math.max(g.endExclusive,this.a[F-1].endExclusive),w=new t.$1s(u,m+D);w.isEmpty?this.a.splice(C,F-C):this.a.splice(C,F-C,w)}}toString(){return this.a.map(g=>g.toString()).join(" + ")}}e.$lC=T;function j(O,g,k,C,F,D){let u=null;if(k)try{u=k.tokenizeEncoded(C,F,D.clone())}catch(m){(0,S.$1)(m)}return u||(u=(0,c.$eC)(O.encodeLanguageId(g),D)),h.$ut.convertToEndOffset(u.tokens,C.length),u}class M{constructor(g,k){this.b=g,this.d=k,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$ih)(g=>{this.f=!1,this.h(g)}))}h(g){const k=Date.now()+g.timeRemaining(),C=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<k?(0,E.$B)(C):this.g())};C()}j(){const g=this.b._textModel.getLineCount(),k=new l.$gC,C=L.$Qd.create(!1);do if(C.elapsed()>1||this.l(k)>=g)break;while(this.k());this.d.setTokens(k.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(g){const k=this.b?.getFirstInvalidLine();return k?(this.b.updateTokensUntilLine(g,k.lineNumber),k.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(g,k){this.b.store.invalidateEndStateRange(new f.$3s(g,k))}}e.$mC=M}),define(K[38],p([0,1,34,2,37,14,35]),function(G,e,P,S,E,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MGb=void 0;class f extends S.$Tc{constructor(c,$,l,h,a,i,n){super(),this.c=c,this.f=$,this.g=l,this.h=h,this.j=a,this.m=i,this.n=n,this.a=[],this.b=this.B(new P.$Ud),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(c,$,l){throw new Error("Not supported!")}createBackgroundTokenizer(c,$){if(this.h)return this.h(c,$)}tokenizeEncoded(c,$,l){const h=Math.random()*1e4<1,a=this.n||h,i=a?new E.$Qd(!0):void 0,n=this.c.tokenizeLine2(c,l,500);if(a){const b=i.elapsed();(h||b>32)&&this.m(b,c.length,h)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${c.substring(0,100)}`),new s.$Dt(n.tokens,l);if(this.g){const b=this.a,T=n.tokens;for(let j=0,M=T.length>>>1;j<M;j++){const O=T[(j<<1)+1],g=L.$rt.getLanguageId(O);b[g]||(b[g]=!0,this.b.fire(g))}}let r;return l.equals(n.ruleStack)?r=l:r=n.ruleStack,new s.$Dt(n.tokens,r)}}e.$MGb=f}),define(K[39],p([0,1,21,2,11]),function(G,e,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NGb=void 0;class L extends S.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(f,t,c){super(),this.a=f,this.b=t,this.c=c,this.B((0,E.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(f,t,c){throw new Error("Not supported!")}tokenizeEncoded(f,t,c){return f.length>=this.c.get()?(0,P.$eC)(this.a,c):this.b.tokenizeEncoded(f,t,c)}createBackgroundTokenizer(f,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(f,t)}}e.$NGb=L}),define(K[40],p([0,1,33,20,11,3,15,48,36,16,7,38,39]),function(G,e,P,S,E,L,s,f,t,c,$,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SGb=void 0;class a extends f.$kv{constructor(r,b,T,j,M,O,g,k){super(r,b,T,j),this.s=M,this.t=O,this.u=g,this.a=null,this.b=!1,this.c=(0,E.observableValue)(this,-1),this.q=new S.$eh(()=>this.w(),10),this.c.set(k,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,b){this.t=r,this.u=b,this.v()}onEvents(r){super.onEvents(r),this.a?.store.acceptChanges(r.changes),this.q.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,b){this.a&&(this.a.store.invalidateEndStateRange(new s.$3s(r,b)),this.q.schedule())}async v(){this.a=null;const r=this.t,b=this.u,T=await this.s.getOrCreateGrammar(r,b);if(!(this.b||r!==this.t||b!==this.u||!T)){if(T.grammar){const j=new h.$NGb(this.u,new l.$MGb(T.grammar,T.initialState,!1,void 0,()=>!1,(M,O,g)=>{this.s.reportTokenizationTime(M,r,T.sourceExtensionId,O,g)},!1),this.c);this.a=new t.$hC(this.f.length,j)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:b}=await(0,P.$eD)("vscode-textmate","release/main.js");this.m=b}const r=new Date().getTime();for(;;){let b=0;const T=new c.$gC,j=new i;for(;;){const g=this.a.getFirstInvalidLine();if(g===null||b>200)break;b++;const k=this.f[g.lineNumber-1],C=this.a.tokenizationSupport.tokenizeEncoded(k,!0,g.startState);if(this.a.store.setEndState(g.lineNumber,C.endState)){const D=this.m(g.startState,C.endState);j.setState(g.lineNumber,D)}else j.setState(g.lineNumber,null);if($.$ut.convertToEndOffset(C.tokens,k.length),T.add(g.lineNumber,C.tokens),new Date().getTime()-r>20)break}if(b===0)break;const M=j.getStateDeltas();if(this.s.setTokensAndStates(this.h,T.serialize(),M),new Date().getTime()-r>20){(0,L.$B)(()=>this.w());return}}}}e.$SGb=a;class i{constructor(){this.a=-1,this.b=[]}setState(r,b){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(b):this.b.push({startLineNumber:r,stateDeltas:[b]}),this.a=r}getStateDeltas(){return this.b}}}),define(K[41],p([0,1,19]),function(G,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PGb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(L){if(this.a[L.scopeName]){const s=this.a[L.scopeName];P.$zg(s.location,L.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${L.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${L.location.toString()}`)}this.a[L.scopeName]=L}getGrammarDefinition(L){return this.a[L]||null}}e.$PGb=S}),define(K[42],p([0,1,2,41]),function(G,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RGb=e.$QGb=void 0,e.$QGb="No TM Grammar registered for this language.";class E extends P.$Tc{constructor(s,f,t,c){super(),this.a=s,this.b=t.INITIAL,this.c=new S.$PGb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:c,loadGrammar:async $=>{const l=this.c.getGrammarDefinition($);if(!l)return this.a.logTrace(`No grammar found for scope ${$}`),null;const h=l.location;try{const a=await this.a.readFile(h);return t.parseRawGrammar(a,h.path)}catch(a){return this.a.logError(`Unable to load and parse grammar for scope ${$} from ${h}`,a),null}},getInjections:$=>{const l=$.split(".");let h=[];for(let a=1;a<=l.length;a++){const i=l.slice(0,a).join(".");h=[...h,...this.f[i]||[]]}return h}}));for(const $ of f){if(this.c.register($),$.injectTo){for(const l of $.injectTo){let h=this.f[l];h||(this.f[l]=h=[]),h.push($.scopeName)}if($.embeddedLanguages)for(const l of $.injectTo){let h=this.g[l];h||(this.g[l]=h=[]),h.push($.embeddedLanguages)}}$.language&&this.h.set($.language,$.scopeName)}}has(s){return this.h.has(s)}setTheme(s,f){this.j.setTheme(s,f)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,f){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$QGb);const c=this.c.getGrammarDefinition(t);if(!c)throw new Error(e.$QGb);const $=c.embeddedLanguages;if(this.g[t]){const a=this.g[t];for(const i of a)for(const n of Object.keys(i))$[n]=i[n]}const l=Object.keys($).length>0;let h;try{h=await this.j.loadGrammarWithConfiguration(t,f,{embeddedLanguages:$,tokenTypes:c.tokenTypes,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.$QGb):a}return{languageId:s,grammar:h,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:c.sourceExtensionId}}}e.$RGb=E}),define(K[49],p([0,1,8,42,40]),function(G,e,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function L(f,t){return new s(f,t)}e.create=L;class s{constructor(t,c){this.f=c,this.b=new Map,this.c=[],this.a=t.host;const $=c.grammarDefinitions.map(l=>({location:P.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g($)}async g(t){const c=this.f.textmateMainUri,$=await new Promise((n,r)=>{G([c],n,r)}),l=await new Promise((n,r)=>{G([this.f.onigurumaMainUri],n,r)}),a=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>l.createOnigScanner(n),createOnigString:n=>l.createOnigString(n)});return new S.$RGb({logTrace:n=>{},logError:(n,r)=>console.error(n,r),readFile:n=>this.a.readFile(n)},t,$,i)}acceptNewModel(t){const c=P.URI.revive(t.uri),$=this;this.b.set(t.controllerId,new E.$SGb(c,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(l,h){const a=await $.d;return a?($.c[h]||($.c[h]=a.createGrammar(l,h)),$.c[h]):Promise.resolve(null)},setTokensAndStates(l,h,a){$.a.setTokensAndStates(t.controllerId,l,h,a)},reportTokenizationTime(l,h,a,i,n){$.a.reportTokenizationTime(l,h,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,c){this.b.get(t).onEvents(c)}retokenize(t,c,$){this.b.get(t).retokenize(c,$)}acceptModelLanguageChanged(t,c,$){this.b.get(t).onLanguageId(c,$)}acceptRemovedModel(t){const c=this.b.get(t);c&&(c.dispose(),this.b.delete(t))}async acceptTheme(t,c){(await this.d)?.setTheme(t,c)}acceptMaxTokenizationLineLength(t,c){this.b.get(t).acceptMaxTokenizationLineLength(c)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/29bef5673ebb1fc3a59b90c9d8bfd2bc61c3f011/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
